# Cuba

from ai import *
from cshelper import *
from js import *
from random import randint
from ffx import *

trainers = [2,3,6,22,7,4,23]


def OnPrecacheObjects():
	print "Cuba/precache"
	Mission_PrecacheTemplateObj('red_oktober', 1, 0)

def OnPostInit():
	print 'Cuba OnPostInit()'

	setMission(2)

	Mission_SetSunlight(-40,30,1.2,1.0,(0.8,0.5,0.2))
	Mission_SetShadows(-40,30,(0.2,0.3,0.3))
	Mission_SetProjShadowBackground((1,1,1))
	Mission_SetProjShadowColor((.8,.7,.7,1))

	Mission_SetAttr('total_troopers', 6)
	Mission_SetAttr('total_snowmen', 6)
	Mission_SetAttr('troopers_dead', 0)
	Mission_SetAttr('infs_dead', 0)
	Mission_SetAttr('snowmen_down',0)
	Mission_SetAttr('freeze_gun_dead', 0)
	Mission_SetAttr('soldiers_dead', 0)
	Mission_SetAttr('heroesdown', 0)

	Mission_SetAttr('base_cleared', 0)
	Mission_SetAttr('left_base', 0)
	Mission_SetAttr('speak_bomb_line', 0)
	Mission_SetAttr('planes_frozen', 0)
	Mission_SetAttr('freeze_ray_destroyed', 0)
	Mission_SetAttr('bomb_ok', 0)
	Mission_SetAttr('plane_ok', 0)
	Mission_SetAttr('plane_cs_done', 0)
	Mission_SetAttr('current_plane', 0)
	Mission_SetAttr('plane_1_done', 0)
	Mission_SetAttr('plane_2_done', 0)
	Mission_SetAttr('plane_3_done', 0)
	Mission_SetAttr('plane_4_done', 0)
	Mission_SetAttr('plane_5_done', 0)
	Mission_SetAttr('plane_6_done', 0)

	regHeroMarkerEnter('drop_bomb_trigger_1','MaybeDropBomb1',persistent=1)
	regHeroMarkerEnter('drop_bomb_trigger_2','MaybeDropBomb2',persistent=1)
	regHeroMarkerEnter('drop_bomb_trigger_3','MaybeDropBomb3',persistent=1)
	regHeroMarkerEnter('drop_bomb_trigger_4','MaybeDropBomb4',persistent=1)
	regHeroMarkerEnter('drop_bomb_trigger_5','MaybeDropBomb5',persistent=1)
	regHeroMarkerEnter('drop_bomb_trigger_6','MaybeDropBomb6',persistent=1)
	regHeroMarkerEnter('drop_bomb_trigger_7','MaybeDropBomb7',persistent=1)
	regHeroMarkerEnter('drop_bomb_trigger_8','MaybeDropBomb8',persistent=1)
	regHeroMarkerEnter('drop_bomb_trigger_9','MaybeDropBomb9',persistent=1)
	regHeroMarkerEnter('drop_bomb_trigger_10','MaybeDropBomb10',persistent=1)
	regHeroMarkerEnter('drop_bomb_trigger_11','MaybeDropBomb11',persistent=1)
	regHeroMarkerEnter('drop_bomb_trigger_12','MaybeDropBomb12',persistent=1)
	regHeroMarkerEnter('drop_bomb_trigger_13','MaybeDropBomb13',persistent=1)
	spawn('bomb_object1','invisible_object','drop_bomb_trigger_1')
	spawn('bomb_object2','invisible_object','drop_bomb_trigger_2')
	spawn('bomb_object3','invisible_object','drop_bomb_trigger_3')
	spawn('bomb_object4','invisible_object','drop_bomb_trigger_4')
	spawn('bomb_object5','invisible_object','drop_bomb_trigger_5')
	spawn('bomb_object6','invisible_object','drop_bomb_trigger_6')
	spawn('bomb_object7','invisible_object','drop_bomb_trigger_7')
	spawn('bomb_object8','invisible_object','drop_bomb_trigger_8')
	spawn('bomb_object9','invisible_object','drop_bomb_trigger_9')
	spawn('bomb_object10','invisible_object','drop_bomb_trigger_10')
	spawn('bomb_object11','invisible_object','drop_bomb_trigger_11')
	spawn('bomb_object12','invisible_object','drop_bomb_trigger_12')
	spawn('bomb_object13','invisible_object','drop_bomb_trigger_13')
	regHeroMarkerEnter('drop_plane_1','MaybeDropPlane1',persistent=1)
	regHeroMarkerEnter('drop_plane_2','MaybeDropPlane2',persistent=1)
	regHeroMarkerEnter('drop_plane_3','MaybeDropPlane3',persistent=1)
	regHeroMarkerEnter('drop_plane_4','MaybeDropPlane4',persistent=1)
	regHeroMarkerEnter('drop_plane_5','MaybeDropPlane5',persistent=1)
	regHeroMarkerEnter('drop_plane_6','MaybeDropPlane6',persistent=1)
	regHeroMarkerEnter('freezeray_fx1','FreezerayFX',persistent=1)
	regHeroMarkerEnter('freezeray_fx2','FreezerayFX',persistent=1)
	regHeroMarkerEnter('freezeray_fx3','FreezerayFX',persistent=1)
	regHeroMarkerEnter('freezeray_fx4','FreezerayFX',persistent=1)
	regHeroMarkerEnter('freezeray_fx5','FreezerayFX',persistent=1)

	regDeath('_impobj_freezeray','FreezeRayDestroyed')

	Event_RegisterSink(EVENT_TEMPLATE_OBJ_DIED, 'SoldierDead', 'us_soldier', '', 0, 0, 1)
	Event_RegisterSink(EVENT_TEMPLATE_OBJ_DIED, 'TrooperDead', 'ice_trooper', '', 0, 0, 1)
	Event_RegisterSink(EVENT_TEMPLATE_OBJ_DIED, 'SnowmanDead', 'snow_man', '', 0, 0, 1)

	makeInterrogationFn('ice_sergeant1',oneshot=0)

	regHeroMarkerEnter('snow_man_intro_marker', 'SnowManIntro')
	regHeroMarkerEnter('side1', 'SnowManIntro')
	regHeroMarkerEnter('side2', 'SnowManIntro')
	regHeroMarkerEnter('attack_cliff_marker', 'AttackCliff')
	regHeroMarkerEnter('attack_square_marker', 'AttackSquare')

	regDeath('inf1','InfiltratorDown')
	regDeath('inf2','InfiltratorDown')
	regDeath('inf3','InfiltratorDown')
	regDeath('inf4','InfiltratorDown')
	regDeath('inf5','InfiltratorDown')
	regDeath('inf6','InfiltratorDown')
	regDeath('inf7','InfiltratorDown')
	regDeath('inf8','InfiltratorDown')
	regDeath('inf9','InfiltratorDown')
	regDeath('inf10','InfiltratorDown')
	Mission_SetAttr('total_infs',10)
	Mission_SetAttr('total_snowmen',8)
	if RPG_GAME_DIFFICULTY < 4:
		Object_Destroy('inf2')
		Object_Destroy('ice_trooper2')
		Mission_SetAttr('total_infs',9)
	if RPG_GAME_DIFFICULTY < 3:
		Object_Destroy('inf9')
		Object_Destroy('snow_man1')
		Mission_SetAttr('total_infs',8)
		Mission_SetAttr('total_snowmen',7)
	if RPG_GAME_DIFFICULTY < 2:
		Object_Destroy('inf6')
		Object_Destroy('inf10')
		Object_Destroy('ice_trooper10')
		Object_Destroy('snow_man3')
		Mission_SetAttr('total_infs',6)
		Mission_SetAttr('total_snowmen',6)

	Mission_SetAttr('mission_won',0)
	regDialog('DLG_DEBRIEF', 'OnDebrief')

	regDeath('alchemiss','HeroDown')
	regDeath('el_diablo','HeroDown')
	regDeath('mentor','HeroDown')

#	TestSetup()
	RealSetup()
	play(start_cs,'start_cs')
	FFX_InitMission()
	print ff.trainers
	addTrainerAttention(ff.trainers)
	ff.CAM_MIN_ZOOM = -100
	FFX_InitMission()

#----------
# Callbacks
#----------

def StartBattle():
	Sound_PlaySound('battle')
def EndBattle():
	print "battle sounds should end here, but I don't know how..."


def HeroDown(event):
	hero = event.object
	print hero
	if Object_GetAttr(hero,'heroPoints')>0:
		speakNoCB('narrator','MISSPCH_2_NR_21')
		regDeath(hero,'HeroDown')


def InfiltratorDown(event):
	numdead = Mission_GetAttr('infs_dead') + 1
	total = Mission_GetAttr('total_infs')
	print numdead
	Mission_SetAttr('infs_dead',numdead)
	if numdead == total:
		Objective_Complete('infiltrators')
		GetRay()
	elif numdead == total - 2:
		ArrowInfs()
def GetRay():
	Mission_SetAttr('base_cleared',1)
	play(get_ray_ss,'get_ray_ss')
def ArrowInfs():
	if Object_IsAlive('inf1'):
		addArrow('infarrow1','inf1',js.ARROW_YELLOW,1)
	if Object_IsAlive('inf2'):
		addArrow('infarrow2','inf2',js.ARROW_YELLOW,1)
	if Object_IsAlive('inf3'):
		addArrow('infarrow3','inf3',js.ARROW_YELLOW,1)
	if Object_IsAlive('inf4'):
		addArrow('infarrow4','inf4',js.ARROW_YELLOW,1)
	if Object_IsAlive('inf5'):
		addArrow('infarrow5','inf5',js.ARROW_YELLOW,1)
	if Object_IsAlive('inf6'):
		addArrow('infarrow6','inf6',js.ARROW_YELLOW,1)
	if Object_IsAlive('inf7'):
		addArrow('infarrow7','inf7',js.ARROW_YELLOW,1)
	if Object_IsAlive('inf8'):
		addArrow('infarrow8','inf8',js.ARROW_YELLOW,1)
	if Object_IsAlive('inf9'):
		addArrow('infarrow9','inf9',js.ARROW_YELLOW,1)
	if Object_IsAlive('inf10'):
		addArrow('infarrow10','inf10',js.ARROW_YELLOW,1)


def RealSetup():
	regTimer('FirstBomb',30)
	Mission_SetAttr('bomb_interval', 40)
	Mission_SetAttr('plane_bomb_increment', 5)
	Mission_SetAttr('freeze_ray_plane_interval', 60)
	Mission_SetAttr('freeze_ray_bomb_increment', 15)
def TestSetup():
	regTimer('FirstBomb',5)
	Mission_SetAttr('bomb_interval', 4)
	Mission_SetAttr('plane_bomb_increment', 0)
	Mission_SetAttr('freeze_ray_plane_interval', 5)
	Mission_SetAttr('freeze_ray_bomb_increment', 0)
#	regHeroMarkerEnter('trigger_drop_test', 'DropTest')
def DropTest(event):
	playEffectMarker('cub_bomb_effect', 'trigger_drop_test', orientation = 0)
	print 'dropping now'
#	Trigger_Force('dropper1',0,0,270,500,0)
#	Object_SetAttr('dropper1','health',1)

def DropInit(event):
	Mission_SetAttr('bomb_ok', 1)
#	Mission_SetAttr('plane_ok', 1)
#	regTimer('DropABomb',Mission_GetAttr('bomb_interval'))
	MaybeDropBomb11(event)

def MaybeDropBomb1(event):
	if Mission_GetAttr('bomb_ok') == 1:
		DropABomb(1)
	else:
		print "too soon to drop another bomb"
def MaybeDropBomb2(event):
	if Mission_GetAttr('bomb_ok') == 1:
		DropABomb(2)
	else:
		print "too soon to drop another bomb"
def MaybeDropBomb3(event):
	if Mission_GetAttr('bomb_ok') == 1:
		DropABomb(3)
	else:
		print "too soon to drop another bomb"
def MaybeDropBomb4(event):
	if Mission_GetAttr('bomb_ok') == 1:
		DropABomb(4)
	else:
		print "too soon to drop another bomb"
def MaybeDropBomb5(event):
	if Mission_GetAttr('bomb_ok') == 1:
		DropABomb(5)
	else:
		print "too soon to drop another bomb"
def MaybeDropBomb6(event):
	if Mission_GetAttr('bomb_ok') == 1:
		DropABomb(6)
	else:
		print "too soon to drop another bomb"
def MaybeDropBomb7(event):
	if Mission_GetAttr('bomb_ok') == 1:
		DropABomb(7)
	else:
		print "too soon to drop another bomb"
def MaybeDropBomb8(event):
	if Mission_GetAttr('bomb_ok') == 1:
		DropABomb(8)
	else:
		print "too soon to drop another bomb"
def MaybeDropBomb9(event):
	if Mission_GetAttr('bomb_ok') == 1:
		DropABomb(9)
	else:
		print "too soon to drop another bomb"
def MaybeDropBomb10(event):
	if Mission_GetAttr('bomb_ok') == 1:
		DropABomb(10)
	else:
		print "too soon to drop another bomb"
def MaybeDropBomb11(event):
	if Mission_GetAttr('bomb_ok') == 1:
		DropABomb(11)
	else:
		print "too soon to drop another bomb"
def MaybeDropBomb12(event):
	if Mission_GetAttr('bomb_ok') == 1:
		DropABomb(12)
	else:
		print "too soon to drop another bomb"
def MaybeDropBomb13(event):
	if Mission_GetAttr('bomb_ok') == 1:
		DropABomb(13)
	else:
		print "too soon to drop another bomb"

def DropABomb(bomb):
	Mission_SetAttr('bomb_ok',0)
	Mission_SetAttr('bomb_pending',bomb)
	timevariant = randint(0,7) - 3
	regTimer('BombsOK',Mission_GetAttr('bomb_interval') + timevariant)
	playEffectMarker('cub_bomb_effect','drop_bomb_trigger_' + str(bomb),orientation=0,key='damage',keyFn='DropABomb2')
def DropABomb2(event):
	bomb = Mission_GetAttr('bomb_pending')
	print 'dropping bomb from spot '
	print bomb
#	spawn('dropper_' + str(int(bomb)), 'cub_bomb', 'drop_bomb_' + str(int(bomb)))
#	xdelta = randint(0,40) - 20
#	print xdelta
#	ydelta = randint(0,40) - 20
#	print ydelta
#	Trigger_Force('dropper_' + str(int(bomb)),xdelta,ydelta,270,500,0)
#	Object_SetAttr('dropper_' + str(int(bomb)),'health',1)
	Trigger_Explosion('bomb_object' + str(int(bomb)),'cuban bomb explosion')
	if Mission_GetAttr('speak_bomb_line') == 1:
		Mission_SetAttr('speak_bomb_line',0)
		regTimer('FirstBombLine',3)
def BombsOK(event):
	Mission_SetAttr('bomb_ok',1)


def MaybeDropPlane1(event):
	if (Mission_GetAttr('plane_ok') == 1) and (Mission_GetAttr('plane_1_done') == 0):
		FreezeAPlane(1)
		Mission_SetAttr('plane_1_done',1)
	else:
		print "too soon to drop another plane"
def MaybeDropPlane2(event):
	if (Mission_GetAttr('plane_ok') == 1) and (Mission_GetAttr('plane_2_done') == 0):
		FreezeAPlane(2)
		Mission_SetAttr('plane_2_done',1)
	else:
		print "too soon to drop another plane"
def MaybeDropPlane3(event):
	if (Mission_GetAttr('plane_ok') == 1) and (Mission_GetAttr('plane_3_done') == 0):
		FreezeAPlane(3)
		Mission_SetAttr('plane_3_done',1)
	else:
		print "too soon to drop another plane"
def MaybeDropPlane4(event):
	if (Mission_GetAttr('plane_ok') == 1) and (Mission_GetAttr('plane_4_done') == 0):
		FreezeAPlane(4)
		Mission_SetAttr('plane_4_done',1)
	else:
		print "too soon to drop another plane"
def MaybeDropPlane5(event):
	if (Mission_GetAttr('plane_ok') == 1) and (Mission_GetAttr('plane_5_done') == 0):
		FreezeAPlane(5)
		Mission_SetAttr('plane_5_done',1)
	else:
		print "too soon to drop another plane"
def MaybeDropPlane6(event):
	if (Mission_GetAttr('plane_ok') == 1) and (Mission_GetAttr('plane_6_done') == 0):
		FreezeAPlane(6)
		Mission_SetAttr('plane_6_done',1)
	else:
		print "too soon to drop another plane"

def FreezeAPlane(plane):
	Mission_SetAttr('current_plane',plane)
	if (Mission_GetAttr('plane_cs_done') == 0) and (Mission_GetAttr('plane_ok') == 1) and (Mission_GetAttr('freeze_ray_destroyed') == 0):
		Mission_SetAttr('plane_cs_done',1)
		play(plane_start_ss,'plane_start_ss')
		#go to FreezeAPlane2 from here
	else:
		FreezeAPlane2(plane)
def FreezeAPlane2(event):
	plane = Mission_GetAttr('current_plane')
	if (Mission_GetAttr('freeze_ray_destroyed') == 0):
		if Mission_GetAttr('plane_ok') == 1:
			Object_PlayEffect('_impobj_freezeray','effect_freezeray_blast','DropAPlane',FX_TRACK_OBJECT_FULL,0,'effect_attach_point')
		Mission_SetAttr('plane_ok',0)
		regTimer('PlanesOK',Mission_GetAttr('freeze_ray_plane_interval'))
		if (Mission_GetAttr('planes_frozen') == 6) or (plane > 6):
			print "FX only"
		else:
			current_bomb_time = Mission_GetAttr('bomb_interval')
			new_bomb_time = current_bomb_time - Mission_GetAttr('plane_bomb_increment')
			Mission_SetAttr('bomb_interval', new_bomb_time)
			print 'bomb interval now'
			print new_bomb_time
	else:
		print "not freezing plane; Ray destroyed"
def DropAPlane(event):
	plane_index = Mission_GetAttr('current_plane')
	plane_num = Mission_GetAttr('planes_frozen') + 1
	Mission_SetAttr('planes_frozen',plane_num)
	print 'dropping plane number '
	print int(plane_index)
	Object_PlayEffect('sc_cub_bomber_frozen'+str(int(plane_index)), 'effect_bomber_crash', 'ExplodePlane', FX_TRACK_OBJECT_ROT)
	if plane_num == 2:
		#this is really second plane line now
		regTimer('FirstPlaneLine',5)
	elif plane_num == 4:
		regTimer('FourthPlaneLine',5)
	elif plane_num == 6:
		regTimer('LastPlaneLine',5)
def ExplodePlane(event):
	plane_index = Mission_GetAttr('current_plane')
	kill('sc_cub_bomber_frozen'+str(int(plane_index)))
def PlanesOK(event):
	Mission_SetAttr('plane_ok',1)

def FreezerayFX(event):
	FreezeAPlane(99)

def FreezeRayDestroyed(event):
	print "Freeze Ray destroyed!"
	Mission_SetAttr('freeze_ray_destroyed',1)
	current_bomb_time = Mission_GetAttr('bomb_interval')
	new_bomb_time = current_bomb_time + Mission_GetAttr('freeze_ray_bomb_increment')
	Mission_SetAttr('bomb_interval', new_bomb_time)
	print 'bomb interval now'
	print new_bomb_time
	Objective_Complete('freeze_ray')
	newObjective('primary', 2, name='interrogate')
	addArrow('interr_arrow', 'ice_sergeant1', js.ARROW_RED, delete=1)
	print Mission_GetAttr('planes_frozen')
	if (Mission_GetAttr('planes_frozen') < 6):
		print 'here we are'
		Objective_Complete('save_planes')
	play(freeze_ray_killed_ss,'freeze_ray_killed_ss')



def OnTrainer(object, hero, train_number):
	print "Player clicked on trainer " + str(train_number)
	for trainer in ff.trainers:
		removeArrow('trainer_' + str(trainer) + '_arrow')
	for trainer in ff.trainers:
		next_trainer = 'trainer_' + str(trainer)
		if Object_Exists(next_trainer) and hasAttention(next_trainer):
			js.Mission_AddArrowObject('trainer_' + str(trainer) + '_arrow', next_trainer, ARROW_YELLOW)
			return


def TroopersAlive():
	count = 0
	for trooper in getAll('ice_trooper'):      # looks through each ice trooper
		if Object_IsAlive(trooper):     # each time it finds a living trooper,
			count = count + 1           # it increments "count" by 1.  This function returns
			print 'found a live one'
	return count                        # a number that is the number of living troopers

def TrooperDead(event):
	addAttr('troopers_dead', 1)             # each time a trooper dies, increment troopers_dead by 1
#	print TroopersAlive()
#	print 'Troopers alive'
#	if (TroopersAlive() == 1):              # if the number of living troopers == 1
#		print 'Only one Trooper left!'
#		troopers = getAll('ice_trooper')        # set "troopers" to be a list of all objects of type 'ice_trooper'
#		for trooper in troopers:            # looks through each trooper in the list
#			if Object_IsAlive(trooper):     # when it finds what should be the only living one,
#				Object_SetAttr(trooper, 'minHealth', 1)  # make sure that trooper can't be killed
#				regAlmostDead(trooper, 'SetUpInterrogateTrooper')  # make that one Interrogatable
#				addArrow('TestArrow', trooper, colour = js.ARROW_RED)   # adds a red arrow called "Test Arrow"
#				break                                                   # to the remaining trooper
#
#def SetUpInterrogateTrooper(event):
#	char = event.object                     # get name of person to be interrogated
#	setInterrogateState(char)               # put the interrogate marker/state on him
#	AI_SetEnabled(char, 0)
#	addInterrogation(char, 'InterrogateTrooper')        # set up the callback when he is clicked on
#
#def InterrogateTrooper(object, char):
#	print 'Help, I am being questioned!'
#	interrogate(object, char)


def SoldierDead(event):                            # This function causes secondary mission failure if 6 soldiers are killed
	addAttr('soldiers_dead', 1)
#	if Mission_GetAttr('soldiers_dead') == 6:
#		play(soldiers_dead_ss,'soldiers_dead_ss')
#		Objective_Fail('save_navy')
#	elif Mission_GetAttr('soldiers_dead') == 1:
#		play(keep_navy_alive_ss,'keep_navy_alive_ss')
#		Objective_Activate('save_navy')


def SnowManIntro(event):
	if Mission_GetAttr('left_base') == 0:
		Mission_SetAttr('left_base',1)
		addMoveGoal('snow_man7', 'snow_man_intro_marker', priority = ai.goal.PRI_LOW)
		play (snow_man_intro_ss,'snow_man_intro_ss')
		regTimer('PlanesOK',5)
def SnowManIntroLine():
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_2_AL_08')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_2_ED_07')
	elif a_hero == 'mentor':
		speak('mentor', 'MISSPCH_2_ME_13')
	else:
		print "Custom character?  Shouldn't be allowed yet..."
		wait(.1)
def SnowmanDead(event):
	addAttr('snowmen_down',1)
	if Mission_GetAttr('snowmen_down') == Mission_GetAttr('total_snowmen'):
		Objective_Complete('snowmen')

def FirstBomb(event):
	play(bomb_start_ss,'bomb_start_ss')
def FirstBombLine(event):
	if (Mission_GetAttr('freeze_ray_destroyed') == 0):
		a_hero = getRandomLiveHeroName()
		print a_hero
		if a_hero == 'alchemiss':
			speakNoCB('alchemiss', 'MISSPCH_2_AL_02')
		elif a_hero == 'el_diablo':
			speakNoCB('el_diablo', 'MISSPCH_2_ED_01')
		elif a_hero == 'mentor':
			speakNoCB('mentor', 'MISSPCH_2_ME_05')
		else:
			print "Custom character?  Shouldn't be allowed yet..."
	else:
		print "not speaking; freeze ray destroyed."
def FirstPlaneLine(event):
	if (Mission_GetAttr('freeze_ray_destroyed') == 0):
		a_hero = getRandomLiveHeroName()
		print a_hero
		if a_hero == 'alchemiss':
			speakNoCB('alchemiss', 'MISSPCH_2_AL_03')
		elif a_hero == 'el_diablo':
			speakNoCB('el_diablo', 'MISSPCH_2_ED_02')
		elif a_hero == 'mentor':
			speakNoCB('mentor', 'MISSPCH_2_ME_06')
		else:
			print "Custom character?  Shouldn't be allowed yet..."
	else:
		print "not speaking; freeze ray destroyed."
def FourthPlaneLine(event):
	if (Mission_GetAttr('freeze_ray_destroyed') == 0):
		a_hero = getRandomLiveHeroName()
		print a_hero
		if a_hero == 'alchemiss':
			speakNoCB('alchemiss', 'MISSPCH_2_AL_04')
		elif a_hero == 'el_diablo':
			speakNoCB('el_diablo', 'MISSPCH_2_ED_03')
		elif a_hero == 'mentor':
			speakNoCB('mentor', 'MISSPCH_2_ME_07')
		else:
			print "Custom character?  Shouldn't be allowed yet..."
	else:
		print "not speaking; freeze ray destroyed."
def LastPlaneLine(event):
	if (Mission_GetAttr('freeze_ray_destroyed') == 0):
		a_hero = getRandomLiveHeroName()
		print a_hero
		if a_hero == 'alchemiss':
			speakNoCB('alchemiss', 'MISSPCH_2_AL_05')
		elif a_hero == 'el_diablo':
			speakNoCB('el_diablo', 'MISSPCH_2_ED_04')
		elif a_hero == 'mentor':
			speakNoCB('mentor', 'MISSPCH_2_ME_08')
		else:
			print "Custom character?  Shouldn't be allowed yet..."
	else:
		print "not speaking; freeze ray destroyed."


def AttackSquare(event):
	if RPG_GAME_DIFFICULTY < 6:
		spawn('square3','us_soldier','soldier_spawn_3')
	if RPG_GAME_DIFFICULTY < 4:
		spawn('square4','us_soldier','soldier_spawn_4')
	if Mission_GetAttr('base_cleared') == 1:
		spawn('square5','us_soldier','soldier_spawn_5')
	if (Mission_GetAttr('base_cleared') == 1) or (RPG_GAME_DIFFICULTY < 6):
		forceSpeakNoCB('us_soldier','MISSPCH_2_NS_05',telepathy=0)
#Add logic for soldiers to follow FF


def AttackCliff(event):
	if RPG_GAME_DIFFICULTY < 5:
		spawn('cliff1','us_soldier','soldier_spawn_1')
	if Mission_GetAttr('base_cleared') == 1:
		spawn('cliff2','us_soldier','soldier_spawn_2')
	if (Mission_GetAttr('base_cleared') == 1) or (RPG_GAME_DIFFICULTY < 5):
		forceSpeakNoCB('us_soldier','MISSPCH_2_NS_06',telepathy=0)
#Add logic for soldiers to follow FF




def InterrogateLine(event):
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_2_AL_06')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_2_ED_05')
	elif a_hero == 'mentor':
		speak('mentor', 'MISSPCH_2_ME_09')
	else:
		wait(.1)
		print "Custom character?  Shouldn't be allowed yet..."

def interrogate_ice_sergeant1_fn(interrogator):
	if Objective_IsComplete('freeze_ray'):
		ff.CAM_MIN_ZOOM = -200
		play(final_cs,'final_cs')
	else:
		if interrogator == "alchemiss":
			speakNoCB('alchemiss', 'MISSPCH_2_AL_07')
		elif interrogator == "mentor":
			speakNoCB('mentor', 'MISSPCH_2_ME_12')
		if interrogator == "el_diablo":
			speakNoCB('el_diablo', 'MISSPCH_2_ED_06')


def OnMissionWon():
#	if not Objective_IsFailed('save_navy'):
#		Objective_Complete('save_navy')
	Objective_Complete('interrogate')
	Mission_SetAttr('mission_won',1)
	print "cuba won"

def OnDebrief(event):
	print "Debriefing screen reached with script"
	if Mission_GetAttr('mission_won'):
		print "debrief training here"
		play(debrief_dialog_ss,'debrief_dialog_ss',interrupt=1)
	else:
		print "loser training here"
		play(lose_dialog_ss,'lose_dialog_ss',interrupt=1)

#										 #
# cutscenes and scripted sequences below  #
#										 #



start_cs = [
(
	"peace()",
	"startCS()",
	"#audio goes here",
	"move('us_soldier1','start_us_marker')",
	"look('start_cam_2', zoom = -250, heading = 110, time = 0)",
	"wait(.1)",
),
(
	"speak('minute_man', 'MISSPCH_2_MM_14')",
),
(
	"turnTo('alchemiss','us_soldier1')",
	"turnTo('el_diablo','us_soldier1')",
	"turnTo('mentor','us_soldier1')",
	"turnTo('us_soldier1','el_diablo')",
	"forceSpeakNoCB('us_soldier', 'MISSPCH_2_NS_04',telepathy=0)",
	"wait(.5)",
),
(
	"speak('minute_man', 'MISSPCH_2_MM_15')",
),
(
	"#Add logic for soldiers to follow FF",
	"endCS()",
	"war()",
	"Sound_PlayMusic('music_02cuba1')",
	"newObjective('primary', 1, name='freeze_ray')",
	"newObjective('secondary', 1, name='infiltrators')",
	"registerObjective('secondary', 2, name='save_planes')",
	"registerObjective('secondary', 3, name='snowmen')",
	"addArrow('freeze_arrow','_impobj_freezeray',ARROW_RED,1)",
),
]


get_ray_ss = [
(
	"forceSpeak('us_soldier', 'MISSPCH_2_NS_07',telepathy=0)",
),
(
	"blank",
),
]

snow_man_intro_ss = [
(
	"ff.SnowManIntroLine()",
),
(
	"Objective_Activate('snowmen')",
	"addArrow('intro_snow_arrow','snow_man7',ARROW_YELLOW,1)",
	"forceSpeak('minute_man', 'MISSPCH_2_MM_20')",
),
(
	"blank",
),
]


bomb_start_ss = [
(
	"speak('minute_man', 'MISSPCH_2_MM_16')",
),
(
	"wait(3)",
),
(
	"ff.DropInit(event)",
	"speak('minute_man', 'MISSPCH_2_MM_17')",
),
(
	"blank",
),
]

plane_start_ss = [
(
	"speak('minute_man', 'MISSPCH_2_MM_18')",
),
(
	"ff.StartBattle()",
	"wait(1.5)",
),
(
	"ff.FreezeAPlane2(event)",
	"wait(1.5)",
),
(
	"Mission_SetAttr('speak_bomb_line',1)",
	"speak('minute_man', 'MISSPCH_2_MM_19')",
),
(
	"blank",
),
]


keep_navy_alive_ss = [
(
	"forceSpeak('us_soldier', 'MISSPCH_2_NS_03',telepathy=0)",
),
(
	"speak('minute_man', 'MISSPCH_2_MM_11')",
),
(
	"blank",
),
]

freeze_ray_killed_ss = [
(
	"speak('minute_man', 'MISSPCH_2_MM_13')",
),
(
	"ff.EndBattle()",
	"ff.InterrogateLine(event)",
),
(
	"blank",
),
]

soldiers_dead_ss = [
(
	"forceSpeak('us_soldier', 'MISSPCH_2_NS_02',telepathy=0)",
),
(
	"speak('minute_man', 'MISSPCH_2_MM_07')",
),
(
	"blank",
),
]



final_cs = [
(
	"peace()",
	"startCS()",
	"reviveHeroes()",
	"normalize('ice_sergeant1')",
	"teleport('ice_sergeant1','it_marker1')",
	"teleport('alchemiss','al_marker1')",
	"teleport('el_diablo','ed_marker1')",
	"teleport('mentor','me_marker1')",
	"playTransition()",
),
(
	"look('ice_sergeant1', zoom = 0, heading = 0, time = 0)",
	"Sound_PlayMusic('music_02cuba_end')",
	"wait(.2)",
),
(
	"speak('ice_sergeant1', 'MISSPCH_2_IT_01')",
),
(
	"speak('mentor', 'MISSPCH_2_ME_10')",
),
(
	"speak('alchemiss', 'MISSPCH_2_AL_09')",
),
(
	"speak('mentor', 'MISSPCH_2_ME_14')",
),
(
	"speak('mentor', 'MISSPCH_2_ME_15')",
),
(
	"speak('el_diablo', 'MISSPCH_2_ED_08')",
),
(
	"speak('mentor', 'MISSPCH_2_ME_16')",
),
(
	"look('mentor', zoom = -100, heading = 120, time = 0)",
	"AI_Animate('mentor','fall','',0,1)",
	"Sound_PlayMusic('music_02cuba_enda',1)",
	"kill('ice_sergeant1')",
	"speak('mentor', 'MISSPCH_2_ME_11')",
),
(
	"look('mentor', zoom = -125, heading = 0, time = 6)",
	"forceSpeak('red_oktober', 'MISSPCH_2_RO_01')",
),
(
	"look('mentor', zoom = -150, heading = -120, time = 4)",
	"Camera_Fade(2)",
	"speak('minute_man', 'MISSPCH_2_MM_12')",
),
(
	"endCS()",
	"Mission_Win()",
),
]


debrief_dialog_ss = [
(
	"AI_CancelAllSpeech()",
	"speak('narrator', 'MISSPCH_2_NR_20', forceNonMission = 1)",
),
(
	"blank",
),
]

lose_dialog_ss = [
(
	"AI_CancelAllSpeech()",
	"speak('narrator', 'MISSPCH_2_NR_19', forceNonMission = 1)",
),
(
	"blank",
),
]

