# inside 1

from cshelper import *
from js import *
import event
import ai
import goal
from ffx import *

def OnPrecacheObjects():
	print "inside1/precache"
	Mission_PrecacheTemplateObj('mentor',1,0)

def OnPostInit():
	print "inside1/start"
	setMission(4)

	Mission_SetSunlight(-80,75,0.8,0.4,(0.6,0.3,0.6))
	Mission_SetShadows(-80,75,(0.4,0.2,0.4))
	Mission_SetProjShadowBackground((1,1,1))
	Mission_SetProjShadowColor((.6,.6,.6,1))

	Mission_SetAttr('cauldron_b_arrow_hack', 0)
	Mission_SetAttr('generator_c1_dead', 0)	   #The first two doors only have one generator, so don't need to be kept track of.
	Mission_SetAttr('generator_c2_dead', 0)
	Mission_SetAttr('total_cgens_dead', 0)

	Mission_SetAttr('played_cauldron_respawn_ss', 0)
	Mission_SetAttr('cauldron_b_dead', 0)
	Mission_SetAttr('cauldron_c_dead', 0)
	regDeath('_impobj_cauldron_b', 'OnCauldronBDestroyed')
	regDeath('_impobj_cauldron_c', 'OnCauldronCDestroyed')

	Mission_SetAttr('played_prisoner_ss',0)
	regHeroMarkerEnter('trigger_cs_prisoner', 'PrisonerCS')
	regDamage('ice_trooper_guard1','PrisonerCS')
	regDamage('ice_trooper_guard2','PrisonerCS')
	regDetectHero('ice_trooper_guard1', 'PrisonerCS')
	regDetectHero('ice_trooper_guard2', 'PrisonerCS')
	regDamage('_impobj_cage_a','PrisonerCS')

	regDeath('civilian1', 'OnCiv1KO')
	staygoal=Null()
	addGoalToAI('civilian1',staygoal,ai.goal.PRI_HI)
	regDeath('civilian2', 'OnCivilianKO')
	regHeroMarkerEnter('trigger_help_b_ss','HelpB')
	addGoalToAI('civilian2',staygoal,ai.goal.PRI_HI)
	regDeath('civilian3', 'OnCivilianKO')
	regHeroMarkerEnter('trigger_help_c_ss','HelpC')
	addGoalToAI('civilian3',staygoal,ai.goal.PRI_HI)
	regDeath('civilian_toad_b1', 'OnCivilianKO')
	regDeath('civilian_toad_b2', 'OnCivilianKO')
	regDeath('civilian_toad_b2', 'OnCivilianKO')
	regDeath('civilian_toad_c1', 'OnCivilianKO')

	regDeath('_impobj_cage_a', 'CageAOpen')
	regDeath('_impobj_cage_b', 'CageBOpen')
	regDeath('_impobj_cage_c', 'CageCOpen')
	Object_Spawn('exit_point', 'ro_generator_standin', 'exit_marker')
	Object_Spawn('waypoint1', 'ro_generator_standin', 'waypoint_marker1')
	Object_Spawn('waypoint2', 'ro_generator_standin', 'waypoint_marker2')
	Object_Spawn('waypoint3', 'ro_generator_standin', 'waypoint_marker3')

	Mission_SetAttr('total_civs_freed', 0)

	Mission_CustomAction('enter', '', '_impobj_pumpkin_a', 'OnKnockPumpkinA', 10, 1)
	Mission_CustomAction('enter', '', '_impobj_pumpkin_b', 'OnKnockPumpkinB', 10, 1)
	Mission_CustomAction('enter', '', '_impobj_pumpkin_c', 'OnKnockPumpkinC', 10, 1)

	regDeath('generator_a1', 'AllAGensGone')	  #The first two doors only have one generator, so don't need the more complicated functions.
	regDeath('generator_b1', 'AllBGensGone')
	Object_Spawn('generator_standin_a1', 'ro_generator_standin', 'gen_a1_marker')
	Object_Spawn('generator_standin_b1', 'ro_generator_standin', 'gen_b1_marker')
	Object_Spawn('generator_standin_c1', 'ro_generator_standin', 'gen_c1_marker')
	Object_Spawn('generator_standin_c2', 'ro_generator_standin', 'gen_c2_marker')

	regHeroMarkerEnter('trigger_cs_shaman_intro', 'PlayShamanIntroCS')
	regHeroMarkerEnter('trigger_detoad_toads_b', 'DetoadToadsB')
	regHeroMarkerEnter('trigger_ss_more_toads', 'PlayMoreToadsSS')
	regHeroMarkerEnter('trigger_detoad_toads_c', 'DetoadToadsC')

	regHeroMarkerEnter('trigger_cauldron_b_setup', 'CauldronBSetup')
	regHeroMarkerEnter('trigger_cauldron_c_setup', 'CauldronCSetup')

	AI_SetEnabled('ice_trooper_guard3',0)
	AI_SetEnabled('intro_shaman',0)
	AI_SetEnabled('dark_shaman2',0)
	AI_SetEnabled('shurale2',0)
	AI_SetEnabled('shurale3',0)

	Mission_SetAttr('multiple_guards', 1)
	Mission_SetAttr('multiple_cauldrons', 1)

	Mission_SetAttr('mission_won',0)
	regDialog('DLG_DEBRIEF', 'OnDebrief')

	play(start_cs, "start_cs")
	FFX_InitMission()

def PrisonerCS(event):
	if Mission_GetAttr('played_prisoner_ss') == 0:
		Mission_SetAttr('played_prisoner_ss',1)
		play(prisoner_cs, "prisoner_cs")
def GuardsAttack():
	hero_list = getAllHeroes()
	liveheroes = ['nullhero']
	for one_hero in hero_list:
		if Object_IsAlive(one_hero):
			liveheroes.append(one_hero)
	temp = randint(1,len(liveheroes)-1)
	a_hero = liveheroes[temp]
	print a_hero
	targetspot = Get_ObjectPos(a_hero)
	print targetspot
	Trigger_Move('ice_trooper_guard1',"move",targetspot,'',75,0)
	Trigger_Move('ice_trooper_guard2',"move",targetspot,'',75,0)

def OnCivilianKO(event):
	if Objective_IsFailed('live_civs') != 1:
		Objective_Fail('live_civs')
def OnCiv1KO(event):
	if Objective_IsComplete('free_civ1') != 1:
		Objective_Fail('free_civ1')
	OnCivilianKO(event)

def CageAOpen(event):
	addAttr('total_civs_freed', 1)
	print Mission_GetAttr('total_civs_freed')
	if Objective_IsFailed('free_civ1') != 1:
		play(free_civs_ss,"free_civs_ss")
		Objective_Complete('free_civ1')
#		Objective_Activate('free_civs')
		clearGoals('civilian1')
		exitpos=Get_MarkerPos('exit_marker')
		newgoal=Move(exitpos)
		ai.addGoalToAI('civilian1',newgoal,ai.goal.PRI_MED)
		Object_SetAttr('civilian1','pathBudget',1500)
		regProximityEnter('civilian1','exit_point',5,'RemoveCiv')
	if (Mission_GetAttr('total_civs_freed') == 7) and (Objective_IsFailed('free_civs') != 1):
		Objective_Complete('free_civs')

def RemoveCiv(event):
	print event.object
	Object_Destroy(event.object)
def WaypointCiv1(event):
	clearGoals(event.object)
	exitpos=Get_MarkerPos('exit_marker')
	newgoal=Move(exitpos)
	ai.addGoalToAI(event.object,newgoal,ai.goal.PRI_MED)
	regProximityEnter(event.object,'exit_point',5,'RemoveCiv')
def WaypointCiv2(event):
	clearGoals(event.object)
	exitpos=Get_MarkerPos('waypoint_marker1')
	newgoal=Move(exitpos)
	ai.addGoalToAI(event.object,newgoal,ai.goal.PRI_MED)
	regProximityEnter(event.object,'waypoint1',3,'WaypointCiv1')
def WaypointCiv3(event):
	clearGoals(event.object)
	exitpos=Get_MarkerPos('waypoint_marker2')
	newgoal=Move(exitpos)
	ai.addGoalToAI(event.object,newgoal,ai.goal.PRI_MED)
	regProximityEnter(event.object,'waypoint2',35,'WaypointCiv2')

def HelpB(event):
	HelpSpeech(event)
	addArrow('cage_b_arrow', '_impobj_cage_b', js.ARROW_YELLOW, delete=1)

def HelpC(event):
	HelpSpeech(event)
	addArrow('cage_c_arrow', '_impobj_cage_c', js.ARROW_YELLOW, delete=1)

def HelpSpeech(event):
	print "HelpSpeech"
	temp = randint(0,2)
	if temp == 0:
		play(civ_help_ss_1,'civ_help_ss_1')
	elif temp == 1:
		play(civ_help_ss_2,'civ_help_ss_2')
	elif temp == 2:
		play(civ_help_ss_3,'civ_help_ss_3')
	else:
		print "bad random number in Helppeech???"

def CageBOpen(event):
	addAttr('total_civs_freed', 1)
	print Mission_GetAttr('total_civs_freed')
	clearGoals('civilian2')
	exitpos=Get_MarkerPos('waypoint_marker1')
	newgoal=Move(exitpos)
	ai.addGoalToAI('civilian2',newgoal,ai.goal.PRI_MED)
	Object_SetAttr('civilian2','pathBudget',1500)
	regProximityEnter('civilian2','waypoint1',5,'WaypointCiv1')
	FreeSpeech(event)
	if (Mission_GetAttr('total_civs_freed') == 7) and (Objective_IsFailed('free_civs') != 1):
		Objective_Complete('free_civs')

def CageCOpen(event):
	addAttr('total_civs_freed', 1)
	print Mission_GetAttr('total_civs_freed')
	clearGoals('civilian3')
	exitpos=Get_MarkerPos('waypoint_marker3')
	newgoal=Move(exitpos)
	ai.addGoalToAI('civilian3',newgoal,ai.goal.PRI_MED)
	Object_SetAttr('civilian3','pathBudget',1500)
	regProximityEnter('civilian3','waypoint3',5,'WaypointCiv3')
	FreeSpeech(event)
	if (Mission_GetAttr('total_civs_freed') == 7) and (Objective_IsFailed('free_civs') != 1):
		Objective_Complete('free_civs')

def FreeSpeech(event):
	temp = randint(0,2)
	if temp == 0:
		play(civ_thank_ss_1,'civ_thank_ss_1')
	elif temp == 1:
		play(civ_thank_ss_2,'civ_thank_ss_2')
	elif temp == 2:
		play(civ_thank_ss_3,'civ_thank_ss_3')
	else:
		print "bad random number in FreeSpeech???"


def PlayShamanIntroCS(event):
	play(shaman_intro_cs, "shaman_intro_cs")


def DetoadToadsB(event):
	kill("toad_b1")
	kill("toad_b2")
	kill("toad_b3")
	### play detoading FX?
	playEffectMarker('effect_frog_transition','toad_b1_spawn_point')
	playEffectMarker('effect_frog_transition','toad_b2_spawn_point')
	playEffectMarker('effect_frog_transition','toad_b3_spawn_point')
	removeArrow('toads_b_arrow')
	spawn('civilian_toad_b1', 'cuban_male', 'toad_b1_spawn_point')
	spawn('civilian_toad_b2', 'cuban_male', 'toad_b2_spawn_point')
	spawn('civilian_toad_b3', 'cuban_male', 'toad_b3_spawn_point')
	addAttr('total_civs_freed', 3)
	print Mission_GetAttr('total_civs_freed')
	play(cubans_detoad_ss, "cubans_detoad_ss")
	if (Mission_GetAttr('total_civs_freed') == 7) and (Objective_IsFailed('free_civs') != 1):
		Objective_Complete('free_civs')
	exitpos=Get_MarkerPos('exit_marker')
	newgoal=Move(exitpos)
	ai.addGoalToAI('civilian_toad_b1',newgoal,ai.goal.PRI_MED)
	ai.addGoalToAI('civilian_toad_b2',newgoal,ai.goal.PRI_MED)
	ai.addGoalToAI('civilian_toad_b3',newgoal,ai.goal.PRI_MED)
	Object_SetAttr('civilian_toad_b1','pathBudget',1500)
	regProximityEnter('civilian_toad_b1','exit_point',5,'RemoveCiv')
	Object_SetAttr('civilian_toad_b2','pathBudget',1500)
	regProximityEnter('civilian_toad_b2','exit_point',5,'RemoveCiv')
	Object_SetAttr('civilian_toad_b3','pathBudget',1500)
	regProximityEnter('civilian_toad_b3','exit_point',5,'RemoveCiv')



def PlayMoreToadsSS(event):
	addArrow('toads_c_arrow', 'trigger_detoad_toads_c', js.ARROW_YELLOW, delete=1)
	play(more_toads_ss, "more_toads_ss")

def DetoadToadsC(event):
	kill("toad_c1")
	kill("toad_c2")
	kill("toad_c3")
	### play detoading FX?
	playEffectMarker('effect_frog_transition','toad_c1_spawn_point')
	playEffectMarker('effect_frog_transition','toad_c2_spawn_point')
	playEffectMarker('effect_frog_transition','toad_c3_spawn_point')
	removeArrow('toads_c_arrow')
	spawn('ice_trooper_toad_c1', 'ice_trooper_guard', 'toad_c1_spawn_point')
	spawn('ice_trooper_toad_c2', 'ice_trooper_guard', 'toad_c2_spawn_point')
	spawn('civilian_toad_c1', 'cuban_male', 'toad_c3_spawn_point')
	addAttr('total_civs_freed', 1)
	print Mission_GetAttr('total_civs_freed')
	play(enemy_toads_ss, "enemy_toads_ss")
	if (Mission_GetAttr('total_civs_freed') == 7) and (Objective_IsFailed('free_civs') != 1):
		Objective_Complete('free_civs')
	exitpos=Get_MarkerPos('waypoint_marker2')
	newgoal=Move(exitpos)
	ai.addGoalToAI('civilian_toad_c1',newgoal,ai.goal.PRI_MED)
	Object_SetAttr('civilian_toad_c1','pathBudget',1500)
	regProximityEnter('civilian_toad_c1','waypoint2',5,'WaypointCiv2')


def OnKnockPumpkinA(event, char):
	play(first_pumpkin_ss, "first_pumpkin_ss")
	Object_PlayEffect('generator_standin_a1', 'effect_generator_spawn', 'OnSpawnEffectFinishedA1',FX_TRACK_OBJECT_ROT)
	addArrow('gen_a1_arrow', 'gen_a1_marker', js.ARROW_RED, delete=1)
	if RPG_GAME_DIFFICULTY > 2:
		playEffectMarker('effect_redtree_spawn','gen_a1_guard_point1',key='spawn',keyFn='GenAGuard1Spawn')
	if RPG_GAME_DIFFICULTY > 4:
		playEffectMarker('effect_redtree_spawn','gen_a1_guard_point2',key='spawn',keyFn='GenAGuard2Spawn')
def GenAGuard1Spawn(event):
	spawn('hand_guard_a1', 'ice_trooper_guard', 'gen_a1_guard_point1')
def GenAGuard2Spawn(event):
	spawn('hand_guard_a2', 'ice_trooper_guard', 'gen_a1_guard_point2')

def OnSpawnEffectFinishedA1(event):
	spawn("generator_a1", "ro_generator", "gen_a1_marker")


def PickSpeechGensUp(event):
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_4_MM_21')
	elif a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_4_AL_07')
	elif a_hero == 'bullet':
		speak('bullet', 'MISSPCH_4_BL_06')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_4_ED_07')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_4_GG_07')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_4_LL_07')
	elif a_hero == 'tombstone':
		speak('tombstone', 'MISSPCH_4_TS_07')
	else:
		print "custom?!?"
		speak('mentor', 'MISSPCH_4_ME_22')


def OnKnockPumpkinB(event, char):
	Object_PlayEffect('generator_standin_b1', 'effect_generator_spawn', 'OnSpawnEffectFinishedB1',FX_TRACK_OBJECT_ROT)
	addArrow('gen_b1_arrow', 'gen_b1_marker', js.ARROW_RED, delete=1)
	removeArrow('pumpkin_b_arrow')
	Mission_RemoveCustomAction('enter', '', '_impobj_pumpkin_b')
	if RPG_GAME_DIFFICULTY > 1:
		playEffectMarker('effect_redtree_spawn','gen_b1_guard_point1',key='spawn',keyFn='GenBGuard1Spawn')
	if RPG_GAME_DIFFICULTY > 3:
		playEffectMarker('effect_redtree_spawn','gen_b1_guard_point1',key='spawn',keyFn='GenBGuard2Spawn')
	PickSpeechGensUp(event)
def GenBGuard1Spawn(event):
	spawn('hand_guard_b1', 'ice_trooper_guard', 'gen_b1_guard_point1')
def GenBGuard2Spawn(event):
	spawn('hand_guard_b2', 'ice_trooper_guard', 'gen_b1_guard_point2')

def OnSpawnEffectFinishedB1(event):
	spawn("generator_b1", "ro_generator", "gen_b1_marker")

def OnKnockPumpkinC(event, char):
	Object_PlayEffect('generator_standin_c1', 'effect_generator_spawn', 'OnSpawnEffectFinishedC1',FX_TRACK_OBJECT_ROT)
	Object_PlayEffect('generator_standin_c2', 'effect_generator_spawn', 'OnSpawnEffectFinishedC2',FX_TRACK_OBJECT_ROT)
	removeArrow('pumpkin_c_arrow')
	addArrow('gen_c1_arrow', 'gen_c1_marker', js.ARROW_RED, delete=1)
	addArrow('gen_c2_arrow', 'gen_c2_marker', js.ARROW_RED, delete=1)
	Mission_RemoveCustomAction('enter', '', '_impobj_pumpkin_c')
	if RPG_GAME_DIFFICULTY > 1:
		playEffectMarker('effect_redtree_spawn','gen_c1_guard_point1',key='spawn',keyFn='GenC1Guard1Spawn')
	if RPG_GAME_DIFFICULTY > 2:
		playEffectMarker('effect_redtree_spawn','gen_c2_guard_point1',key='spawn',keyFn='GenC2Guard1Spawn')
	if RPG_GAME_DIFFICULTY > 3:
		playEffectMarker('effect_redtree_spawn','gen_c1_guard_point2',key='spawn',keyFn='GenC1Guard2Spawn')
	if RPG_GAME_DIFFICULTY > 4:
		playEffectMarker('effect_redtree_spawn','gen_c2_guard_point2',key='spawn',keyFn='GenC2Guard2Spawn')
	PickSpeechGensUp(event)
def GenC1Guard1Spawn(event):
	spawn('hand_guard_c1_1', 'ice_trooper_guard', 'gen_c1_guard_point1')
def GenC2Guard1Spawn(event):
	spawn('hand_guard_c2_1', 'ice_trooper_guard', 'gen_c2_guard_point1')
def GenC1Guard2Spawn(event):
	spawn('hand_guard_c1_2', 'ice_trooper_guard', 'gen_c1_guard_point2')
def GenC2Guard2Spawn(event):
	spawn('hand_guard_c2_2', 'ice_trooper_guard', 'gen_c2_guard_point2')

def OnSpawnEffectFinishedC1(event):
	spawn("generator_c1", "ro_generator", "gen_c1_marker")
	regDeath('generator_c1', 'OnGenC1Destroyed')

def OnSpawnEffectFinishedC2(event):
	spawn("generator_c2", "ro_generator", "gen_c2_marker")
	regDeath('generator_c2', 'OnGenC2Destroyed')



# These functions do things when one of a set of Generators is destroyed

def OnGenC1Destroyed(event):
	Object_PlayEffect('generator_standin_c1', 'effect_generator_destroy','',FX_TRACK_OBJECT_ROT)
	removeArrow('gen_c1_arrow')
	print "Generator C1 Destroyed"
	addAttr('total_cgens_dead', 1)				   # increment the count of how many Generators are currently dead
	print Mission_GetAttr('total_cgens_dead')
	if Mission_GetAttr('total_cgens_dead') == 2:	 # if all Generators of the set are currently dead...
		AllCGensGone(event)							   # ...open the matching Pumpkin Gate.  Otherwise...
	else:
		regTimer('RespawnGenC1', (37 - 3*RPG_GAME_DIFFICULTY))			   # 10 seconds from now, the appropriate RespawnGenXX function will get called

def OnGenC2Destroyed(event):
	Object_PlayEffect('generator_standin_c2', 'effect_generator_destroy','',FX_TRACK_OBJECT_ROT)
	removeArrow('gen_c2_arrow')
	print "Generator C2 Destroyed"
	addAttr('total_cgens_dead', 1)				   # increment the count of how many Generators are currently dead
	print Mission_GetAttr('total_cgens_dead')
	if Mission_GetAttr('total_cgens_dead') == 2:	 # if all Generators of the set are currently dead...
		AllCGensGone(event)							   # ...open the matching Pumpkin Gate.  Otherwise...
	else:
		regTimer('RespawnGenC2', (37 - 3*RPG_GAME_DIFFICULTY))			   # 10 seconds from now, the appropriate RespawnGenXX function will get called


# These functions are triggered by the regTimers above completing, thus repawning the appropriate generator

def RespawnGenC1(event):
	if Mission_GetAttr('total_cgens_dead') != 2:						 # we only spawn if this objective hasn't been won already
		Object_PlayEffect('generator_standin_c1', 'effect_generator_spawn', 'OnSpawnEffectFinishedC1',FX_TRACK_OBJECT_ROT)
		PickSpeechGenRespawn(event)
		print "We should be spawning a new generator now!"
		addAttr('total_cgens_dead', -1)								  # appropriate name ("generatorXX") of template type 'ro_generator',
		print Mission_GetAttr('total_cgens_dead')
		addArrow('gen_c1_arrow', 'gen_c1_marker', js.ARROW_RED, delete=1)
	if Mission_GetAttr('total_cgens_dead') == 2:
		print "No respawn; they're all dead"

def RespawnGenC2(event):
	if Mission_GetAttr('total_cgens_dead') != 2:						 # we only spawn if this objective hasn't been won already
		Object_PlayEffect('generator_standin_c2', 'effect_generator_spawn', 'OnSpawnEffectFinishedC2',FX_TRACK_OBJECT_ROT)
		PickSpeechGenRespawn(event)
		print "We should be spawning a new generator now!"
		addAttr('total_cgens_dead', -1)								  # appropriate name ("generatorXX") of template type 'ro_generator',
		print Mission_GetAttr('total_cgens_dead')
		addArrow('gen_c2_arrow', 'gen_c2_marker', js.ARROW_RED, delete=1)
	if Mission_GetAttr('total_cgens_dead') == 2:
		print "No respawn; they're all dead"

def PickSpeechGenRespawn(event):
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_4_MM_17')
	elif a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_4_AL_04')
	elif a_hero == 'bullet':
		speak('bullet', 'MISSPCH_4_BL_02')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_4_ED_04')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_4_GG_03')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_4_LL_04')
	elif a_hero == 'tombstone':
		speak('tombstone', 'MISSPCH_4_TS_04')
	else:
		print "custom?!?"
		speak('mentor', 'MISSPCH_4_ME_20')


def AllAGensGone(event):
	Object_PlayEffect('generator_standin_a1', 'effect_generator_destroy','',FX_TRACK_OBJECT_ROT)
	removeArrow('gen_a1_arrow')
	Mission_CustomAction('enter', '', '_impobj_pumpkin_a', 'OpenPumpkinA', 10, 1)
	print "door A unlocked"
	forceSpeakNoCB('mentor','MISSPCH_4_ME_13')
	addArrow('pumpkin_a_arrow', '_impobj_pumpkin_a', js.ARROW_RED, delete=1)
	if RPG_GAME_DIFFICULTY > 2:
		playEffectMarker('effect_redtree_spawn','gate_a_guard_point',key='spawn',keyFn='AGuardSpawn')
def AGuardSpawn(event):
	spawn('door_guard_a', 'shurale', 'gate_a_guard_point')
def OpenPumpkinA(event,heroname):
	print "Open Door A"
	pumpkinAPos = Get_ObjectPos('_impobj_pumpkin_a') #if you play an effect then kill the object the effect dies too!
	pumpkinARot = Object_GetOrientation('_impobj_pumpkin_a')
	kill('_impobj_pumpkin_a')
	kill('_impobj_fog1')
	kill('_impobj_physics_stopper_1')
	playEffect('effect_ro_pumpkin_gate', pumpkinAPos, pumpkinARot[1])
	Sound_PlayMusic('music_03inside1')
	addArrow('pumpkin_b_arrow', '_impobj_pumpkin_b', js.ARROW_RED, delete=1)
	AI_SetEnabled('ice_trooper_guard3',1)
	AI_SetEnabled('intro_shaman',1)
	AI_SetEnabled('dark_shaman2',1)
	AI_SetEnabled('shurale2',1)
	addArrow('toads_b_arrow', 'trigger_detoad_toads_b', js.ARROW_YELLOW, delete=1)
	play(intro_toads_cs, "intro_toads_cs")



def AllBGensGone(event):
	Object_PlayEffect('generator_standin_b1', 'effect_generator_destroy','',FX_TRACK_OBJECT_ROT)
	removeArrow('gen_b1_arrow')
	Mission_CustomAction('enter', '', '_impobj_pumpkin_b', 'OpenPumpkinB', 10, 1)
	print "door B unlocked"
	forceSpeakNoCB('mentor','MISSPCH_4_ME_14')
	addArrow('pumpkin_b_arrow', '_impobj_pumpkin_b', js.ARROW_RED, delete=1)
	if RPG_GAME_DIFFICULTY > 1:
		playEffectMarker('effect_redtree_spawn','gate_b_guard_point1',key='spawn',keyFn='BGuard1Spawn')
	if RPG_GAME_DIFFICULTY > 3:
		playEffectMarker('effect_redtree_spawn','gate_b_guard_point2',key='spawn',keyFn='BGuard2Spawn')
def BGuard1Spawn(event):
	spawn('door_guard_b1', 'shurale', 'gate_b_guard_point1')
def BGuard2Spawn(event):
	spawn('door_guard_b2', 'shurale', 'gate_b_guard_point2')
def OpenPumpkinB(event,heroname):
	print "Open Door B"
#	Object_PlayEffect('_impobj_pumpkin_b','effect_ro_pumpkin_gate')
	pumpkinBPos = Get_ObjectPos('_impobj_pumpkin_b')
	pumpkinBRot = Object_GetOrientation('_impobj_pumpkin_b')
	kill('_impobj_pumpkin_b')
	kill('_impobj_fog2')
	kill('_impobj_physics_stopper_2')
	playEffect('effect_ro_pumpkin_gate', pumpkinBPos, pumpkinBRot[1])
	addArrow('pumpkin_c_arrow', '_impobj_pumpkin_c', js.ARROW_RED, delete=1)
	AI_SetEnabled('shurale3',1)
	Mission_CustomAction('enter', '', '_impobj_pumpkin_c', 'OnKnockPumpkinC', 10, 1)
# This shouldn't be necessary, but for some reason it is.

def AllCGensGone(event):
	print "Open Door C"
	addArrow('end_arrow', '_impobj_pumpkin_c', js.ARROW_RED, delete=1)
	PickSpeechGensDead(event)
	Mission_CustomAction('proceed to next mission', '', '_impobj_pumpkin_c', 'MoveAlong', 10, 1)
	addArrow('pumpkin_c_arrow', '_impobj_pumpkin_c', js.ARROW_RED, delete=1)
	if RPG_GAME_DIFFICULTY > 1:
		playEffectMarker('effect_redtree_spawn','gate_c_guard_point1',key='spawn',keyFn='CGuard1Spawn')
	if RPG_GAME_DIFFICULTY > 3:
		playEffectMarker('effect_redtree_spawn','gate_c_guard_point2',key='spawn',keyFn='CGuard2Spawn')
def CGuard1Spawn(event):
	spawn('door_guard_c1', 'shurale', 'gate_c_guard_point1')
def CGuard2Spawn(event):
	spawn('door_guard_c2', 'shurale', 'gate_c_guard_point2')
def MoveAlong(event,ahero):
	pumpkinCPos = Get_ObjectPos('_impobj_pumpkin_c')
	pumpkinCRot = Object_GetOrientation('_impobj_pumpkin_c')
	playEffect('effect_ro_pumpkin_gate', pumpkinCPos, pumpkinCRot[1])
	kill('_impobj_pumpkin_c')
	play(final_cs,'final_cs')


def PickSpeechGensDead(event):
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_4_MM_18')
	elif a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_4_AL_05')
	elif a_hero == 'bullet':
		speak('bullet', 'MISSPCH_4_BL_03')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_4_ED_05')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_4_GG_04')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_4_LL_05')
	elif a_hero == 'tombstone':
		speak('tombstone', 'MISSPCH_4_TS_05')
	else:
		print "custom?!?"
		speak('mentor', 'MISSPCH_4_ME_21')


# Cauldron functions

def CauldronBSetup(event):
	spawn('cauldron_b_fx1_object','invisible_object','cauldron_b_fx1')
	spawn('cauldron_b_fx2_object','invisible_object','cauldron_b_fx2')
	RespawnCauldronB_1(event)
	if RPG_GAME_DIFFICULTY > 5:
		regTimer('RespawnCauldronB_2',8 - RPG_GAME_DIFFICULTY)

def OnSpawnB_1Destroyed(event):
	regTimer('CleanupCauldronB_1', 7.5 - RPG_GAME_DIFFICULTY)
	regTimer('RespawnCauldronB_1', 8 - RPG_GAME_DIFFICULTY)
def OnSpawnB_2Destroyed(event):
	regTimer('CleanupCauldronB_2', 7.5 - RPG_GAME_DIFFICULTY)
	regTimer('RespawnCauldronB_2', 8 - RPG_GAME_DIFFICULTY)

def CleanupCauldronB_1(event):
	Object_Destroy('it_from_b_1', 0)
def CleanupCauldronB_2(event):
	Object_Destroy('it_from_b_2', 0)

def RespawnCauldronB_1(event):
	if Mission_GetAttr('cauldron_b_dead') == 0:  # check if cauldron is still alive
		Object_PlayEffect('cauldron_b_fx1_object','effect_cauldron_eject','',FX_TRACK_OBJECT_ROT)
#		playEffectMarker('effect_cauldron_eject','cauldron_b_fx1',flags=FX_TRACK_OBJECT_ROT)
		regTimer('ActualSpawnB_1',1.75)
		if Mission_GetAttr('played_cauldron_respawn_ss') == 0:
			PickCauldronSS(event)
			Mission_SetAttr('played_cauldron_respawn_ss', 1)
			if Mission_GetAttr('cauldron_b_arrow_hack') == 0:
			#this is to cover replayers doing stuff out of order
				addArrow('cauldron_b_arrow', '_impobj_cauldron_b', js.ARROW_YELLOW, delete=1)
def RespawnCauldronB_2(event):
	if Mission_GetAttr('cauldron_b_dead') == 0:  # check if cauldron is still alive
		Object_PlayEffect('cauldron_b_fx2_object','effect_cauldron_eject','',FX_TRACK_OBJECT_ROT)
#		playEffectMarker('effect_cauldron_eject','cauldron_b_fx2',flags=FX_TRACK_OBJECT_ROT)
		regTimer('ActualSpawnB_2',1.75)

def PickCauldronSS(event):
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_4_MM_06')
	elif a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_4_AL_02')
	elif a_hero == 'bullet':
		speak('bullet', 'MISSPCH_4_BL_04')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_4_ED_02')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_4_GG_05')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_4_LL_01')
	elif a_hero == 'tombstone':
		speak('tombstone', 'MISSPCH_4_TS_01')
	else:
		print "custom?!?"
		speak('mentor','MISSPCH_4_ME_18')

def ActualSpawnB_1(event):
	spawn('it_from_b_1', 'ice_trooper_guard', 'cauldron_b_spawn_point1')
	regDeath('it_from_b_1', 'OnSpawnB_1Destroyed')
	ITRespawnSpeech()
#	play(it_respawn_ss,'it_respawn_ss')
def ActualSpawnB_2(event):
	spawn('it_from_b_2', 'ice_trooper_guard', 'cauldron_b_spawn_point2')
	regDeath('it_from_b_2', 'OnSpawnB_2Destroyed')
	ITRespawnSpeech()
#	play(it_respawn_ss,'it_respawn_ss')

def ITRespawnSpeech():
	temp = randint(0,2)
	if temp == 0:
		forceSpeakNoCB('ice_trooper', 'MISSPCH_4_IT_03', telepathy=0)
	elif temp == 1:
		forceSpeakNoCB('ice_trooper', 'MISSPCH_4_IT_04', telepathy=0)
	elif temp == 2:
		forceSpeakNoCB('ice_trooper', 'MISSPCH_4_IT_05', telepathy=0)
	else:
		print "bad random number in ITRespawnSpeech???"

def OnCauldronBDestroyed(event):
	PickCauldronDeadLine(event)
	Mission_SetAttr('cauldron_b_dead', 1)
	if Mission_GetAttr('cauldron_c_dead') == 1:
		Objective_Complete('cauldrons')

def PickCauldronDeadLine(event):
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_4_MM_16')
	elif a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_4_AL_03')
	elif a_hero == 'bullet':
		speak('bullet', 'MISSPCH_4_BL_05')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_4_ED_03')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_4_GG_06')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_4_LL_03')
	elif a_hero == 'tombstone':
		speak('tombstone', 'MISSPCH_4_TS_03')
	else:
		print "custom?!?"
		speak('mentor', 'MISSPCH_4_ME_19')



def CauldronCSetup(event):
	spawn('cauldron_c_fx1_object','invisible_object','cauldron_c_fx1')
	spawn('cauldron_c_fx2_object','invisible_object','cauldron_c_fx2')
	addArrow('cauldron_c_arrow', '_impobj_cauldron_c', js.ARROW_YELLOW, delete=1)
	RespawnCauldronC_1(event)
	if RPG_GAME_DIFFICULTY > 4:
		regTimer('RespawnCauldronC_2',8 - RPG_GAME_DIFFICULTY)

def OnSpawnC_1Destroyed(event):
	regTimer('CleanupCauldronC_1', 7.5 - RPG_GAME_DIFFICULTY)
	regTimer('RespawnCauldronC_1', 8 - RPG_GAME_DIFFICULTY)
def OnSpawnC_2Destroyed(event):
	regTimer('CleanupCauldronC_2', 7.5 - RPG_GAME_DIFFICULTY)
	regTimer('RespawnCauldronC_2', 8 - RPG_GAME_DIFFICULTY)

def CleanupCauldronC_1(event):
	Object_Destroy('shurale_from_c_1', 0)
def CleanupCauldronC_2(event):
	Object_Destroy('shurale_from_c_2', 0)

def RespawnCauldronC_1(event):
	if Mission_GetAttr('cauldron_c_dead') == 0:  # check if cauldron is still alive
		Object_PlayEffect('cauldron_c_fx1_object','effect_cauldron_eject','',FX_TRACK_OBJECT_ROT)
#		playEffectMarker('effect_cauldron_eject','cauldron_c_fx1',flags=FX_TRACK_OBJECT_ROT)
		regTimer('ActualSpawnC_1',1.75)
def RespawnCauldronC_2(event):
	if Mission_GetAttr('cauldron_c_dead') == 0:  # check if cauldron is still alive
		Object_PlayEffect('cauldron_c_fx2_object','effect_cauldron_eject','',FX_TRACK_OBJECT_ROT)
#		playEffectMarker('effect_cauldron_eject','cauldron_c_fx2',flags=FX_TRACK_OBJECT_ROT)
		regTimer('ActualSpawnC_2',1.75)

def ActualSpawnC_1(event):
	spawn('shurale_from_c_1', 'shurale', 'cauldron_c_spawn_point1')
	regDeath('shurale_from_c_1', 'OnSpawnC_1Destroyed')
	SRRespawnSpeech()
#	play(sr_respawn_ss,'sr_respawn_ss')
def ActualSpawnC_2(event):
	spawn('shurale_from_c_2', 'shurale', 'cauldron_c_spawn_point2')
	regDeath('shurale_from_c_2', 'OnSpawnC_2Destroyed')
	SRRespawnSpeech()
#	play(sr_respawn_ss,'sr_respawn_ss')

def SRRespawnSpeech():
	temp = randint(0,0)
	if temp == 0:
		forceSpeakNoCB('shurale', 'MISSPCH_4_SR_01',telepathy=0)
	else:
		print "bad random number in SRRespawnSpeech???"

def OnCauldronCDestroyed(event):
	PickCauldronDeadLine(event)
	Mission_SetAttr('cauldron_c_dead', 1)
	if Mission_GetAttr('cauldron_b_dead') == 1:
		Objective_Complete('cauldrons')


def OnMissionWon():
	print "inside1/won"
	Mission_SetAttr('mission_won',1)
	Objective_Complete('follow')
	if not Objective_IsFailed('live_civs'):
		Objective_Complete('live_civs')

def OnMissionLost():
	print "inside1/lost"

def OnDebrief(event):
	print "Debriefing screen reached with script"
	if Mission_GetAttr('mission_won'):
		print "debrief training here"
	else:
		print "loser training here"
		play(lose_dialog_ss,'lose_dialog_ss',interrupt=1)


def DSLine():
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_4_MM_04')
	elif a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_4_AL_08')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_4_ED_08')
	elif a_hero == 'tombstone':
		speak('tombstone', 'MISSPCH_4_TS_08')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_4_LL_08')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_4_GG_09')
	elif a_hero == 'bullet':
		speak('bullet', 'MISSPCH_4_BL_08')
	else:
		print "custom?!?"
		wait(.1)

def ToadLine():
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_4_AL_09')
	elif a_hero == 'bullet':
		speak('bullet', 'MISSPCH_4_BL_09')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_4_ED_09')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_4_GG_10')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_4_LL_09')
	elif a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_4_MM_05')
	elif a_hero == 'tombstone':
		speak('tombstone', 'MISSPCH_4_TS_09')
	else:
		print "custom?!?"
		wait(.2)

def EndLine():
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_4_MM_20')
	elif a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_4_AL_06')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_4_ED_06')
	elif a_hero == 'tombstone':
		speak('tombstone', 'MISSPCH_4_TS_06')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_4_LL_06')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_4_GG_02')
	elif a_hero == 'bullet':
		speak('bullet', 'MISSPCH_4_BL_01')
	else:
		print "custom?!?"
		wait(.1)
def EndLine2():
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_4_MM_24')
	elif a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_4_AL_13')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_4_ED_12')
	elif a_hero == 'tombstone':
		speak('tombstone', 'MISSPCH_4_TS_12')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_4_LL_12')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_4_GG_13')
	elif a_hero == 'bullet':
		speak('bullet', 'MISSPCH_4_BL_12')
	else:
		print "custom?!?"
		wait(.1)


#										 #
# cutscenes and scripted sequences below  #
#										 #



start_cs = [
(
	"peace()",
	"startCS()",
	"look('minute_man', zoom = -250, heading = -20, time = 0)",
	"Sound_PlayMusic('music_03inside1_cs1',1)",
	"wait(.2)",
),
(
	"speak('minute_man', 'MISSPCH_4_MM_01')",
),
(
	"forceSpeak('mentor', 'MISSPCH_4_ME_01')",
),
(
	"endCS()",
	"war()",
	"newObjective('primary', 4, name='follow')",
	"registerObjective('secondary', 1, name='free_civ1')",
	"registerObjective('secondary', 2, name='free_civs')",
	"registerObjective('secondary', 3, name='live_civs')",
	"registerObjective('secondary', 4, name='cauldrons')",
),
]

prisoner_cs = [
(
	"speak('civilian1', 'MISSPCH_4_CC_01')",
),
(
	"forceSpeak('ice_trooper', 'MISSPCH_4_IT_01', telepathy=0)",
),
(
	"optionalSpeak('minute_man', 'MISSPCH_4_MM_02')",
),
(
	"Objective_Activate('free_civ1')",
	"addArrow('cage_arrow', '_impobj_cage_a', js.ARROW_YELLOW, delete=1)",
	"#ff.GuardsAttack()",
	"wait(.01)",
),
(
	"blank",
),
]

free_civs_ss = [
(
	"speak('civilian1', 'MISSPCH_4_CC_02')",
),
(
	"Objective_Activate('free_civs')",
	"Objective_Activate('live_civs')",
	"optionalSpeak('minute_man', 'MISSPCH_4_MM_03')",
),
(
	"blank",
),
]

civ_thank_ss_1 = [
(
	"forceSpeak('cuban_male', 'MISSPCH_4_CC_02', telepathy=0)",
),
(
	"blank",
),
]

civ_thank_ss_2 = [
(
	"forceSpeak('cuban_male', 'MISSPCH_4_CC_05', telepathy=0)",
),
(
	"blank",
),
]

civ_thank_ss_3 = [
(
	"forceSpeak('cuban_male', 'MISSPCH_4_CC_06', telepathy=0)",
),
(
	"blank",
),
]

civ_help_ss_1 = [
(
	"forceSpeak('cuban_male', 'MISSPCH_4_CC_07', telepathy=0)",
),
(
	"blank",
),
]

civ_help_ss_2 = [
(
	"forceSpeak('cuban_male', 'MISSPCH_4_CC_08', telepathy=0)",
),
(
	"blank",
),
]

civ_help_ss_3 = [
(
	"forceSpeak('cuban_male', 'MISSPCH_4_CC_09', telepathy=0)",
),
(
	"blank",
),
]

first_pumpkin_ss = [
(
	"forceSpeak('mentor','MISSPCH_4_ME_02')",
),
(
	"blank",
),
]

shaman_intro_cs = [
(
	"forceSpeak('dark_shaman', 'MISSPCH_4_DS_01',telepathy=0)",
),
(
	"ff.DSLine()",
),
(
	"blank",
),
]

intro_toads_cs = [
(
	"peace()",
	"startCS()",
	"look('trigger_detoad_toads_b', zoom = -150, heading = -20, time = 2)",
	"wait(.2)",
),
(
	"speak('mentor', 'MISSPCH_4_ME_03')",
),
(
	"ff.ToadLine()",
),
(
	"speak('mentor', 'MISSPCH_4_ME_10')",
),
(
	"noLook()",
	"endCS()",
	"war()",
),
]

cubans_detoad_ss = [
(
	"speak('civilian_toad_b1', 'MISSPCH_4_CC_04')",
),
(
	"blank",
),
]


it_respawn_ss = [
(
	"ff.ITRespawnSpeech()",
),
(
	"blank",
),
]

sr_respawn_ss = [
(
	"ff.SRRespawnSpeech()",
),
(
	"blank",
),
]


more_toads_ss = [
(
	"optionalSpeak('minute_man', 'MISSPCH_4_MM_07')",
),
(
	"blank",
),
]

enemy_toads_ss = [
(
	"forceSpeak('ice_trooper', 'MISSPCH_4_IT_02', telepathy=0)",
),
(
	"optionalSpeak('minute_man', 'MISSPCH_4_MM_25')",
),
(
	"blank",
),
]

final_cs = [
(
	"peace()",
	"startCS()",
	"Sound_PlayMusic('music_03inside1_cs1',1)",
	"wait(.2)",
),
(
	"ff.EndLine()",
),
(
	"speak('mentor', 'MISSPCH_4_ME_15')",
),
(
	"ff.EndLine2()",
),
(
	"endCS()",
	"war()",
	"Mission_Win()",
),
]


lose_dialog_ss = [
(
	"AI_CancelAllSpeech()",
	"speak('narrator', 'MISSPCH_4_NR_01', forceNonMission = 1)",
),
(
	"blank",
),
]
