# berlin

from cshelper import *
from js import *
import event
from ffx import *

def OnPrecacheObjects():
	print "berlin/precache"
	Mission_PrecacheTemplateObj("mentor",1,0)
	Mission_PrecacheTemplateObj("black_jack",1,1)

def OnPostInit():
	print "berlin/start"
	setMission(6)

	Mission_SetSunlight(-120,70,1.2,0.6,(0.8,0.7,0.6))
	Mission_SetShadows(-120,70,(0.2,0.2,0.5))
	Mission_SetProjShadowBackground((1,1,1))
	Mission_SetProjShadowColor((.5,.5,.6,1))
	
	Mission_SetAttr('active_hero', 0)
	Mission_SetAttr('h1_health', 0)
	Mission_SetAttr('h2_health', 0)
	Mission_SetAttr('h3_health', 0)
	Mission_SetAttr('bj_interr', 0)
	Mission_SetAttr('time_travel_active', 1)
	Mission_SetAttr('time_travel_now', 0)
	Mission_SetAttr('patrol_down', 0)
	Mission_SetAttr('assault_down', 0)

	makeInterrogationCS('evil_black_jack', oneshot = 1,)
	#regAlmostDead('evil_black_jack','NagSetup')
	#The nagging was more annoying than useful.

	startPatrol('nazi1',4)
	startPatrol('nazi4',3)
	addKillAllGoal('nazi1',OC_CONTROLLABLE,permanent=1)
	addKillAllGoal('nazi2',OC_CONTROLLABLE,permanent=1)
	addKillAllGoal('nazi3',OC_CONTROLLABLE,permanent=1)
	addKillAllGoal('nazi4',OC_CONTROLLABLE,permanent=1)
	addKillAllGoal('evil_black_jack',OC_CONTROLLABLE,permanent=1)
	addKillGoal('nazi1','evil_black_jack',permanent=1)
	addKillGoal('nazi2','evil_black_jack',permanent=1)
	addKillGoal('nazi3','evil_black_jack',permanent=1)
	addKillGoal('nazi4','evil_black_jack',permanent=1)
	addKillGoal('evil_black_jack','nazi1',PRI_LOW,permanent=1)
	addKillGoal('evil_black_jack','nazi2',PRI_LOW,permanent=1)
	addKillGoal('evil_black_jack','nazi3',PRI_LOW,permanent=1)
	addKillGoal('evil_black_jack','nazi4',PRI_LOW,permanent=1)

	regHeroMarkerEnter('bonfire_burn1','EnterBurn1')
	spawn('burn_obj1','fx_standin','bonfire_burn1')

	if RPG_GAME_DIFFICULTY < 5:
		Object_Destroy('nazi2')
	if RPG_GAME_DIFFICULTY < 3:
		Object_Destroy('nazi4')
	if RPG_GAME_DIFFICULTY < 2:
		Mission_SetAttr('total_assault',6)
	elif RPG_GAME_DIFFICULTY < 3:
		Mission_SetAttr('total_assault',7)
	elif RPG_GAME_DIFFICULTY < 4:
		Mission_SetAttr('total_assault',8)
	elif RPG_GAME_DIFFICULTY < 5:
		Mission_SetAttr('total_assault',9)
	else:
		Mission_SetAttr('total_assault',10)

	play(start_cs, "start_cs")
	ff.CAM_MIN_ZOOM = -150
	FFX_InitMission()

def EnterBurn1(event):
	print "setting off bonfire 1"
	Trigger_Explosion('burn_obj1','generic bonfire damage')
	regTimer('ReBurn1',3)
def ReBurn1(event):
	regHeroMarkerEnter('bonfire_burn1','EnterBurn1')


def StandardWarpEffect(pos):
	Mission_SetWaveEnvelope(1, 0.35, 3, 0.35, 3, 1)
	Mission_SetWaveSinParams(1, 4, 0.04, 1)
	Mission_StartWave(1, 3, 1, pos)


#Time Travel
def TimeTravel(event):
	Mission_SetAttr('time_travel_now', 1)
	if Mission_GetAttr('time_travel_active') == 1:
		if Mission_GetAttr('active_hero') == 0: #If First Hero is Active (Spawn H2)
			Mission_SetAttr('h1_health', Object_GetAttr('tombstone', 'health')),
			Object_SpawnAt(Mission_GetSquadList()[1], Get_ObjectPos('tombstone'), 'hero_2', Object_GetOrientation('tombstone')),
			Object_PlayEffect('hero_2', 'effect_portal_mentor_spawn'),
			StandardWarpEffect(Get_ObjectPos('hero_2'))
			if Mission_GetAttr('h2_health') > 0:
				Object_SetAttr('hero_2','health', Mission_GetAttr('h2_health'))
			Object_Destroy('tombstone'),
			Mission_SelectHero('hero_2'),
			Mission_SetAttr('active_hero', 1)
			regTimer('TimeTravel', 45)
			TimeTravelLine('hero_2')
		elif Mission_GetAttr('active_hero') == 1: #If Second Hero is Active (Spawn H3)
			Mission_SetAttr('h2_health', Object_GetAttr('hero_2', 'health')),
			Object_SpawnAt(Mission_GetSquadList()[2], Get_ObjectPos('hero_2'), 'hero_3',Object_GetOrientation('hero_2')),
			Object_PlayEffect('hero_3', 'effect_portal_mentor_spawn'),
			StandardWarpEffect(Get_ObjectPos('hero_3'))
			if Mission_GetAttr('h3_health') > 0:
				Object_SetAttr('hero_3','health', Mission_GetAttr('h3_health')),
			Object_Destroy('hero_2'),
			Mission_SelectHero('hero_3'),
			Mission_SetAttr('active_hero', 2)
			regTimer('TimeTravel', 45)
			TimeTravelLine('hero_3')
		elif Mission_GetAttr('active_hero') == 2: #If Third Hero is Active (Spawn H1)
			Mission_SetAttr('h3_health', Object_GetAttr('hero_3', 'health')),
			Object_SpawnAt(Mission_GetSquadList()[0], Get_ObjectPos('hero_3'), 'tombstone',Object_GetOrientation('hero_3')),
			Object_PlayEffect('tombstone', 'effect_portal_mentor_spawn'),
			StandardWarpEffect(Get_ObjectPos('tombstone'))
			if Mission_GetAttr('h1_health') > 0:
				Object_SetAttr('tombstone','health', Mission_GetAttr('h1_health')),
			Object_Destroy('hero_3'),
			Mission_SelectHero('tombstone'),
			Mission_SetAttr('active_hero', 0)
			regTimer('TimeTravel', 45)
			TimeTravelLine('tombstone')
		else:
			print "problem with TimeTravel"
	else:
		print "time has been stabilized"
	Mission_SetAttr('time_travel_now', 0)

def TimeTravelLine(hero):
	t_hero = Object_GetTemplate(hero)
	if t_hero == 'tombstone':
		speakNoCB('tombstone','MISSPCH_6_TS_08')
	elif t_hero == 'alchemiss':
		speakNoCB('alchemiss','MISSPCH_6_AL_02')
	elif t_hero == 'el_diablo':
		speakNoCB('el_diablo','MISSPCH_6_ED_02')
	elif t_hero == 'eve':
		speakNoCB('eve','MISSPCH_6_EV_01')
	elif t_hero == 'liberty_lad':
		speakNoCB('liberty_lad','MISSPCH_6_LL_02')
	elif t_hero == 'microwave':
		speakNoCB('microwave','MISSPCH_6_MW_02')
	elif t_hero == 'minute_man':
		speakNoCB('minute_man','MISSPCH_6_MM_02')
	elif t_hero == 'supercollider':
		speakNoCB('supercollider','MISSPCH_6_SC_02')
	elif t_hero == 'the_ant':
		speakNoCB('the_ant','MISSPCH_6_AN_01')
	else:
		print "custom hero?!?"
		speak('mentor', 'MISSPCH_6_ME_13')


def NagSetup(event):
	regTimer('InterrogateNag',15)
def InterrogateNag(event):
	if Mission_GetAttr('bj_interr') == 0:
		speakNoCB('tombstone','MISSPCH_6_TS_04')
		regTimer('InterrogateNag2',15)
	else:
		print "no need to nag"
def InterrogateNag2(event):
	if Mission_GetAttr('bj_interr') == 0:
		speakNoCB('tombstone','MISSPCH_6_TS_05')
		regTimer('InterrogateNag',15)
	else:
		print "no need to nag"


def DecoyLine():
	a_hero = Object_GetTemplate('hero_2')
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_6_MM_01')
	elif a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_6_AL_01')
	elif a_hero == 'eve':
		speak('eve', 'MISSPCH_6_EV_01')
	elif a_hero == 'the_ant':
		speak('the_ant', 'MISSPCH_6_AN_02')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_6_ED_01')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_6_LL_01')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_6_GG_01')
	elif a_hero == 'quetzalcoatl':
		speak('quetzalcoatl', 'MISSPCH_6_QZ_01')
	elif a_hero == 'microwave':
		speak('microwave', 'MISSPCH_6_MW_01')
	else:
		print "custom hero???"
		speak('mentor', 'MISSPCH_6_ME_12')


def ReachedCourt(event):
	print "reached courtyard"
	play (reach_courtyard_cs,'reach_courtyard_cs')

def PatrolDown(event):
	print "one of the patrol has gone down"
	addAttr('patrol_down',1)
	if Mission_GetAttr('patrol_down') == 1:
		play (almost_there_ss,'almost_there_ss')
	elif Mission_GetAttr('patrol_down') == 3:
		Mission_SetAttr('time_travel_active',0)
		MaybeHooray(event)
def MaybeHooray(event):
	if Mission_GetAttr('time_travel_now'):
		# we need to delay hooray scene
		regTimer('MaybeHooray',.5)
	else:
		play (hooray_cs,'hooray_cs')


def StableTime():
	Mission_SetAttr('time_travel_active',0)
	print Mission_GetAttr('active_hero')
	if Mission_GetAttr('active_hero') == 0: #If First Hero is Active (Spawn H2, H3)
		teleport('tombstone','hooray1')
		Object_SpawnAt(Mission_GetSquadList()[1], Get_ObjectPos('hpos2'), 'hero_2'),
		Object_PlayEffect('hero_2', 'effect_portal_mentor_spawn'),
		StandardWarpEffect(Get_ObjectPos('hero_2'))
		AI_MakeHeroAI('hero_2')
		if Mission_GetAttr('h2_health') > 0:
			Object_SetAttr('hero_2','health', Mission_GetAttr('h2_health'))
		Object_SpawnAt(Mission_GetSquadList()[2], Get_ObjectPos('hpos3'), 'hero_3'),
		Object_PlayEffect('hero_3', 'effect_portal_mentor_spawn'),
		StandardWarpEffect(Get_ObjectPos('hero_3'))
		AI_MakeHeroAI('hero_3')
		if Mission_GetAttr('h3_health') > 0:
			Object_SetAttr('hero_3','health', Mission_GetAttr('h3_health'))
		spawn('black_jack','black_jack','bj_spawn')
	elif Mission_GetAttr('active_hero') == 1: #If Second Hero is Active (Spawn TS, H3)
		teleport('hero_2','hooray2')
		Object_SpawnAt(Mission_GetSquadList()[0], Get_ObjectPos('hpos1'), 'tombstone'),
		Object_PlayEffect('tombstone', 'effect_portal_mentor_spawn'),
		StandardWarpEffect(Get_ObjectPos('tombstone'))
		AI_MakeHeroAI('tombstone')
		if Mission_GetAttr('h1_health') > 0:
			Object_SetAttr('tombstone','health', Mission_GetAttr('h1_health'))
		Object_SpawnAt(Mission_GetSquadList()[2], Get_ObjectPos('hpos3'), 'hero_3'),
		Object_PlayEffect('hero_3', 'effect_portal_mentor_spawn'),
		StandardWarpEffect(Get_ObjectPos('hero_3'))
		AI_MakeHeroAI('hero_3')
		if Mission_GetAttr('h3_health') > 0:
			Object_SetAttr('hero_3','health', Mission_GetAttr('h3_health'))
		spawn('black_jack','black_jack','bj_spawn')
	elif Mission_GetAttr('active_hero') == 2: #If Third Hero is Active (Spawn TS, H2)
		teleport('hero_3','hooray3')
		Object_SpawnAt(Mission_GetSquadList()[0], Get_ObjectPos('hpos1'), 'tombstone'),
		Object_PlayEffect('tombstone', 'effect_portal_mentor_spawn'),
		StandardWarpEffect(Get_ObjectPos('tombstone'))
		AI_MakeHeroAI('tombstone')
		if Mission_GetAttr('h1_health') > 0:
			Object_SetAttr('tombstone','health', Mission_GetAttr('h1_health'))
		Object_SpawnAt(Mission_GetSquadList()[1], Get_ObjectPos('hpos2'), 'hero_2'),
		Object_PlayEffect('hero_2', 'effect_portal_mentor_spawn'),
		StandardWarpEffect(Get_ObjectPos('hero_2'))
		AI_MakeHeroAI('hero_2')
		if Mission_GetAttr('h2_health') > 0:
			Object_SetAttr('hero_2','health', Mission_GetAttr('h2_health'))
		spawn('black_jack','black_jack','bj_spawn')
	else:
		print "problem with stabletime?"


def AssaultSetup():
	print Mission_GetAttr('total_assault')
	spawnGroup('assault','nazi_rifleman',Mission_GetAttr('total_assault'))
	regDeath('_spwn_assault0','AssaultDown')
	regDeath('_spwn_assault1','AssaultDown')
	regDeath('_spwn_assault2','AssaultDown')
	regDeath('_spwn_assault3','AssaultDown')
	regDeath('_spwn_assault4','AssaultDown')
	regDeath('_spwn_assault5','AssaultDown')
	if Mission_GetAttr('total_assault') > 6:
		move('_spwn_assault6','surround6')
		regDeath('_spwn_assault6','AssaultDown')
	if Mission_GetAttr('total_assault') > 7:
		move('_spwn_assault7','surround7')
		regDeath('_spwn_assault7','AssaultDown')
	if Mission_GetAttr('total_assault') > 8:
		move('_spwn_assault8','surround8')
		regDeath('_spwn_assault8','AssaultDown')
	if Mission_GetAttr('total_assault') > 9:
		move('_spwn_assault9','surround9')
		regDeath('_spwn_assault9','AssaultDown')

def AssaultSurround():
	move('_spwn_assault0','surround0')
	move('_spwn_assault1','surround1')
	move('_spwn_assault2','surround2')
	move('_spwn_assault3','surround3')
	move('_spwn_assault4','surround4')
	move('_spwn_assault5','surround5')
	if Mission_GetAttr('total_assault') > 6:
		move('_spwn_assault6','surround6')
	if Mission_GetAttr('total_assault') > 7:
		move('_spwn_assault7','surround7')
	if Mission_GetAttr('total_assault') > 8:
		move('_spwn_assault8','surround8')
	if Mission_GetAttr('total_assault') > 9:
		move('_spwn_assault9','surround9')

def AssaultBlind():
	Object_SetSecondaryState('_spwn_assault0',SCSTATE_BLIND,18)
	Object_SetSecondaryState('_spwn_assault1',SCSTATE_BLIND,18)
	Object_SetSecondaryState('_spwn_assault2',SCSTATE_BLIND,18)
	Object_SetSecondaryState('_spwn_assault3',SCSTATE_BLIND,18)
	Object_SetSecondaryState('_spwn_assault4',SCSTATE_BLIND,18)
	Object_SetSecondaryState('_spwn_assault5',SCSTATE_BLIND,18)
	if Mission_GetAttr('total_assault') > 6:
		Object_SetSecondaryState('_spwn_assault6',SCSTATE_BLIND,18)
	if Mission_GetAttr('total_assault') > 7:
		Object_SetSecondaryState('_spwn_assault7',SCSTATE_BLIND,18)
	if Mission_GetAttr('total_assault') > 8:
		Object_SetSecondaryState('_spwn_assault8',SCSTATE_BLIND,18)
	if Mission_GetAttr('total_assault') > 9:
		print "did we get here?"
		Object_SetSecondaryState('_spwn_assault9',SCSTATE_BLIND,18)


def AssaultDown(event):
	totass=Mission_GetAttr('total_assault')
	print "one of the assault group has gone down"
	addAttr('assault_down',1)
	if Mission_GetAttr('assault_down') == (totass-3):
		# arrow remaining assault group
		for x in range(10):
			baddie = '_spwn_assault'+str(x)
			if Object_IsAlive(baddie):
				addArrow('baddie'+str(x),baddie,ARROW_RED,1)
	elif Mission_GetAttr('assault_down') == totass:
		regTimer('FinalCS',2.5)
def FinalCS(event):
	play (final_cs,'final_cs')



def OnMissionWon():
	print "berlin/won"
	ff.CAM_MIN_ZOOM = -200
	Campaign_Recruit('black_jack')
	Campaign_UnlockOrigin('black_jack')

def OnMissionLost():
	print "berlin/lost"



start_cs = [
(
	"peace()",
	"see()",
	"startCS()",
	"Camera_SetFade(1)",
	"lookAtPos((-549,-578,0), zoom = -169.3, pitch = 10, heading = -17.2)",
	"Sound_PlayMusic('music_05berlin_cs1',1)",
	"wait(1)",
),
(
	"Camera_UnFade(1)",
	"speak('evil_black_jack', 'MISSPCH_6_BJ_01')",
),
(
	"lookAtPos((-557,-696,0), zoom = -265.6, heading = 112.6)",
	"speak('spy', 'MISSPCH_6_B2_01')",
),
(
	"speak('evil_black_jack', 'MISSPCH_6_BJ_02')",
),
(
	"lookAtPos((-627,-633,0), zoom = -237.1, heading = -175.4)",
	"playEffectMarker('effect_portal_mentor_spawn','ts_teleport')",
	"ff.StandardWarpEffect(Get_ObjectPos('tombstone'))",
	"teleport('tombstone','ts_teleport')",
	"Sound_PlayMusic('music_05berlin_cs1a',1)",
	"turnTo('evil_black_jack','tombstone')",
	"move('spy','spy_moveto')",
	"speak('spy', 'MISSPCH_6_B2_02')",
),
(
	"turnTo('tombstone','evil_black_jack')",
	"speak('tombstone', 'MISSPCH_6_TS_01')",
),
(
	"speak('evil_black_jack', 'MISSPCH_6_BJ_03')",
),
(
	"speak('tombstone', 'MISSPCH_6_TS_02')",
),
(
	"lookAtPos((-549,-578,0), zoom = -169.3, pitch = 10, heading = -17.2)",
	"speak('evil_black_jack', 'MISSPCH_6_BJ_04')",
),
(
	"speak('tombstone', 'MISSPCH_6_TS_03')",
),
(
	"Object_Destroy('spy')",
	"speak('evil_black_jack', 'MISSPCH_6_BJ_05')",
	"AI_Animate('evil_black_jack', 'melee_idle', '', 0, 1)",
),
(
	"addArrow('ebj_arrow', 'evil_black_jack')",
	"newObjective('primary', 1, name='beat_ebj')",
	"noLook()",
	"war()",
	"Sound_PlayMusic('music_05berlin1')",
	"endCS()",
),
]


interrogate_evil_black_jack_cs = [
(
	"startCS()",
	"Mission_SetAttr('bj_interr',1)",
	"removeArrow('ebj_arrow')",
	"Objective_Complete('beat_ebj')",
	"normalize('evil_black_jack')",
	"teleport('evil_black_jack','interr_ebj')",
	"teleport('tombstone','interr_hero')",
	"see()",
	"peace()",
	"look('tombstone', zoom = -175, heading = 180, time = 0)",
	"playTransition()",
),
(
	"Sound_PlayMusic('music_05fort_cs1a',1)",
	"Sound_PlaySound('mission_berlin')",
	"speak('tombstone', 'MISSPCH_6_TS_06')",

),
(
	"look('evil_black_jack', zoom = -175, heading = 0, time = 2)",
	"speak('evil_black_jack', 'MISSPCH_6_BJ_06')",
),
(
	"look('tombstone', zoom = -175, heading = 180, time = 2)",
	"speak('tombstone', 'MISSPCH_6_TS_07')",
),
(
	"Mission_SetAttr('h1_health', Object_GetAttr('tombstone', 'health'))",
	"Object_SpawnAt(Mission_GetSquadList()[1], Get_ObjectPos('tombstone'), 'hero_2',Object_GetOrientation('tombstone'))",
	"Object_PlayEffect('hero_2', 'effect_portal_mentor_spawn')",
	"ff.StandardWarpEffect(Get_ObjectPos('hero_2'))",
	"Object_Destroy('tombstone')",
	"Mission_SelectHero('hero_2')",
	"Mission_SetAttr('active_hero', 1)",
	"Object_SpawnAt('evil_black_jack_image', Get_ObjectPos('evil_black_jack'), 'evil_black_jack_image')",
	"Object_Destroy('evil_black_jack')",
	"normalize('evil_black_jack')",
	"Object_SetAttr('evil_black_jack','health',Object_GetAttr('evil_black_jack','maxHealth'))",
	"speak('mentor', 'MISSPCH_6_ME_01')",
),
(
	"speak('mentor','MISSPCH_6_ME_02')",
),
(
	"look('evil_black_jack_image', zoom = -175, heading = 0, time = 2)",
	"ff.DecoyLine()",
),
(
	"speak('mentor','MISSPCH_6_ME_03')",
),
(
	"kill('evil_black_jack_image')",
	"speak('mentor','MISSPCH_6_ME_04')",
),
(
	"regHeroMarkerEnter('ebj_search','ReachedCourt')",
	"addArrow('ebj_search_arrow', 'ebj_search')",
	"newObjective('primary', 2, name='find_ebj')",
	"regTimer('TimeTravel',45)",
	"war()",
	"blind()",
	"Sound_PlayMusic('music_05berlin1')",
	"endCS()",
),
]

reach_courtyard_cs = [
(
	"spawnGroup('rifle_spawn','nazi_rifleman',3)",
	"startCS()",
	"see()",
	"peace()",
	"removeArrow('ebj_search_arrow')",
	"speak('mentor','MISSPCH_6_ME_06')",
),
(
	"peace()",
	"look('patrol0', zoom = -100, heading = 0, time = 2)",
	"move('_spwn_rifle_spawn0','patrol0')",
	"move('_spwn_rifle_spawn1','patrol1')",
	"move('_spwn_rifle_spawn2','patrol2')",
	"forceSpeak('nazi_rifleman','MISSPCH_6_N1_01',telepathy=0)",
),
(
	"speak('mentor','MISSPCH_6_ME_07')",
),
(
	"regDeath('_spwn_rifle_spawn0','PatrolDown')",
	"regDeath('_spwn_rifle_spawn1','PatrolDown')",
	"regDeath('_spwn_rifle_spawn2','PatrolDown')",
	"addArrow('nazi0_arrow','_spwn_rifle_spawn0',ARROW_RED,1)",
	"addArrow('nazi1_arrow','_spwn_rifle_spawn1',ARROW_RED,1)",
	"addArrow('nazi2_arrow','_spwn_rifle_spawn2',ARROW_RED,1)",
	"newObjective('primary', 3, name='kill_patrol')",
	"war()",
	"blind()",
	"endCS()",
),
]

almost_there_ss = [
(
	"forceSpeak('nazi_rifleman', 'MISSPCH_6_N1_02',telepathy=0)",
),
(
	"speak('mentor','MISSPCH_6_ME_08')",
),
(
	"blank",
),
]

hooray_cs = [
(
	"startCS()",
	"ff.AssaultSetup()",
	"Objective_Complete('kill_patrol')",
	"see()",
	"peace()",
	"look('hooray2', zoom = -100, heading = 0, time = 0)",
	"playTransition()",
),
(
	"ff.StableTime()",
	"Sound_PlaySound('mission_berlin')",
	"speak('mentor','MISSPCH_6_ME_09')",
),
(
	"ff.AssaultSurround()",
	"#look('surround0', zoom = -100, heading = 0, time = 1)",
	"forceSpeak('nazi_rifleman', 'MISSPCH_6_N2_02',telepathy=0)",
),
(
	"look('tombstone', zoom = 0, heading = 0, time = 3.5)",
	"speak('tombstone', 'MISSPCH_6_TS_09')",
),
(
	"forceSpeak('nazi_rifleman', 'MISSPCH_6_N2_03',telepathy=0)",
),
(
	"speak('tombstone', 'MISSPCH_6_TS_10')",
),
(
	"look('black_jack', zoom = -100, heading = 0, time = 1.5)",
	"AI_Animate('black_jack','ranged_2')",
	"speak('black_jack', 'MISSPCH_6_BJ_07')",
),
(
	"Camera_Fade(.25)",
	"ff.AssaultBlind()",
	"forceSpeak('nazi_rifleman', 'MISSPCH_6_N2_01',telepathy=0)",
),
(
	"Camera_UnFade(.25)",
	"speak('black_jack', 'MISSPCH_6_BJ_08')",
),
(
	"Objective_Complete('find_ebj')",
	"newObjective('primary', 4, name='kill_assault')",
	"war()",
	"blind()",
	"endCS()",
),
]


final_cs = [
(
	"peace()",
	"startCS()",
	"Objective_Complete('kill_assault')",
	"reviveHeroes()",
	"playTransition()",
),
(
	"teleport('tombstone','ts_end')",
	"teleport('black_jack','bj_end')",
	"teleport('hero_2','h2_end')",
	"teleport('hero_3','h3_end')",
	"look('tombstone', zoom = -100, heading = 180, time = 2)",
	"Sound_PlayMusic('music_05berlin_cs5',1)",
	"Sound_PlaySound('mission_berlin')",
	"speak('tombstone', 'MISSPCH_6_TS_11')",
),
(
	"speak('black_jack', 'MISSPCH_6_BJ_09')",
),
(
	"speak('mentor','MISSPCH_6_ME_10')",
),
(
	"speak('black_jack', 'MISSPCH_6_BJ_10')",
),
(
	"speak('tombstone', 'MISSPCH_6_TS_12')",
),
(
	"speak('black_jack', 'MISSPCH_6_BJ_11')",
),
(
	"speak('tombstone', 'MISSPCH_6_TS_13')",
),
(
	"speak('black_jack', 'MISSPCH_6_BJ_12')",
),
(
	"spawn('blitzkrieg','blitzkrieg','bz_spawn')",
	"speak('tombstone', 'MISSPCH_6_TS_14')",
),
(
	"speak('black_jack', 'MISSPCH_6_BJ_13')",
),
(
	"speak('tombstone', 'MISSPCH_6_TS_15')",
),
(
	"speak('black_jack', 'MISSPCH_6_BJ_14')",
),
(
	"speak('black_jack', 'MISSPCH_6_BJ_15')",
),
(
	"speak('black_jack', 'MISSPCH_6_BJ_16')",
),
(
	"speak('mentor','MISSPCH_6_ME_11')",
),
(
	"peace()",
	"speak('tombstone', 'MISSPCH_6_TS_16')",
),
(
	"move('black_jack','surround0')",
	"move('tombstone','hooray1')",
	"move('hero_2','hooray2')",
	"move('hero_3','hooray3')",
	"look('bz_walk', zoom = -50, heading = 0, time = 5)",
	"speak('black_jack', 'MISSPCH_6_BJ_17')",
),
(
	"move('blitzkrieg','bz_walk')",
	"Sound_PlayMusic('music_05berlin_cs5a',1)",
	"speak('blitzkrieg', 'MISSPCH_6_BZ_01')",
),
(
	"speak('blitzkrieg', 'MISSPCH_6_BZ_02')",
),
(
	"endCS()",
	"noLook()",
	"Mission_Win()",
),
]
