# fortissimo

from ai import *
from cshelper import *
from js import *
from random import *
import event
from ffx import *

def OnPrecacheObjects():
	print "fortissimo/precache"
	Mission_PrecacheTemplateObj("fortissimo",1,1)
	Mission_PrecacheTemplateObj("black_jack",1,1)
	Mission_PrecacheTemplateObj("tombstone",1,1)
	Mission_PrecacheTemplateObj("schmidt",1,1)
	Mission_PrecacheTemplateObj("tank_ger",1,1)
	Mission_PrecacheTemplateObj("mentor",1,0)

def OnPostInit():
	print "fortissimo/start"

	Mission_SetSunlight(-140,60,1.2,1.0,(0.3,0.2,0.9))
	Mission_SetShadows(-140,60,(0.1,0.1,0.6))
	Mission_SetProjShadowBackground((1,1,1))
	Mission_SetProjShadowColor((.5,.5,.7,1))

# I don't understand the built-in chatter system, so I did my own.
	setMission(7,chatter=0)
	
	Mission_SetAttr('legionnaire_attack1', 0)
	Mission_SetAttr('burner1_trigger', 0)
	Mission_SetAttr('burner2_trigger', 0)
	Mission_SetAttr('nazi_burner1_interrogate', 0)
	Mission_SetAttr('nazi_burner2_interrogate', 0)
	Mission_SetAttr('tank_dead', 0)
	Mission_SetAttr('schmidt_interrogate', 0)

	# Check for Tombstone's death, which loses the mission
	regDeath('tombstone', 'OnTombstoneDeath')

	# When any hero gets close enough to the first ambush, bad guys mouth off
	regDetectHero('legionnaire', 'OnLegionnaireDetectHero1')
	regDetectHero('legionnaire002', 'OnLegionnaireDetectHero1')

	# When Fortissimo is killed
	regDeath('fortissimo', 'OnFortissimoDead')

	# Set up Nazi Burner 1 to move when heroes get close
	regDetectHero('nazi_rifleman_006', 'OnBurner1Trigger')
	regDetectHero('nazi_burner1', 'OnBurner1Trigger')
	regDanger('nazi_rifleman_006', 'OnBurner1Trigger')
	regDanger('nazi_burner1', 'OnBurner1Trigger')

	# setup interrogation
	makeInterrogationFn('nazi_burner1')

	Mission_CustomAction('chat', '', 'berlin_female', 'ChatF', 3, 0)
	Mission_CustomAction('chat', '', 'berlin_female_002', 'ChatF', 3, 0)
	Mission_CustomAction('chat', '', 'berlin_female_003', 'ChatF', 3, 0)
	Mission_CustomAction('chat', '', 'berlin_female_004', 'ChatF', 3, 0)
	Mission_CustomAction('chat', '', 'berlin_male', 'ChatM', 3, 0)
	Mission_CustomAction('chat', '', 'berlin_male_002', 'ChatM', 3, 0)
	Mission_CustomAction('chat', '', 'berlin_male_003', 'ChatM', 3, 0)
	Mission_CustomAction('chat', '', 'berlin_male_004', 'ChatM', 3, 0)
	Mission_CustomAction('chat', '', 'berlin_male_005', 'ChatM', 3, 0)
	Mission_CustomAction('chat', '', 'berlin_male_006', 'ChatM', 3, 0)

	regHeroMarkerEnter('bonfire_burn1','EnterBurn1')
	regHeroMarkerEnter('bonfire_burn2','EnterBurn2')
	regHeroMarkerEnter('bonfire_burn3','EnterBurn3')
	spawn('burn_obj1','fx_standin','bonfire_burn1')
	spawn('burn_obj2','fx_standin','bonfire_burn2')
	spawn('burn_obj3','fx_standin','bonfire_burn3')

	play(start_cs, "start_cs")
	FFX_InitMission()

#----------
# Callbacks
#----------	

def EnterBurn1(event):
	print "setting off bonfire 1"
	Trigger_Explosion('burn_obj1','generic bonfire damage')
	regTimer('ReBurn1',3)
def ReBurn1(event):
	regHeroMarkerEnter('bonfire_burn1','EnterBurn1')
def EnterBurn2(event):
	print "setting off bonfire 2"
	Trigger_Explosion('burn_obj2','generic bonfire damage')
	regTimer('ReBurn2',3)
def ReBurn2(event):
	regHeroMarkerEnter('bonfire_burn2','EnterBurn2')
def EnterBurn3(event):
	print "setting off bonfire 3"
	Trigger_Explosion('burn_obj3','generic bonfire damage')
	regTimer('ReBurn3',3)
def ReBurn3(event):
	regHeroMarkerEnter('bonfire_burn3','EnterBurn3')

def ChatF(event,hero):
	chatline = randint(1,3)
	if chatline == 1:
		forceSpeakNoCB('berlin_female','MISSPCH_7_Z1_01',telepathy=0)
	elif chatline == 2:
		forceSpeakNoCB('berlin_female','MISSPCH_7_Z2_01',telepathy=0)
	elif chatline == 3:
		forceSpeakNoCB('berlin_female','MISSPCH_7_Z2_02',telepathy=0)
def ChatM(event,hero):
	chatline = randint(1,5)
	if chatline == 1:
		forceSpeakNoCB('berlin_male','MISSPCH_7_B1_01',telepathy=0)
	elif chatline == 2:
		forceSpeakNoCB('berlin_male','MISSPCH_7_B2_01',telepathy=0)
	elif chatline == 3:
		forceSpeakNoCB('berlin_male','MISSPCH_7_B2_02',telepathy=0)
	elif chatline == 4:
		forceSpeakNoCB('berlin_male','MISSPCH_7_B2_03',telepathy=0)
	elif chatline == 5:
		forceSpeakNoCB('berlin_male','MISSPCH_7_B1_02',telepathy=0)

# legionnaires attack
def OnLegionnaireDetectHero1(event):
	if Mission_GetAttr('legionnaire_attack1') == 0:
		Mission_SetAttr('legionnaire_attack1', 1)
		play(legionnaire_attack1_ss, "legionnaire_attack1_ss")    

# ---------- First book (bible)

# when burner1 detects heroes
def OnBurner1Trigger(event):
	if Mission_GetAttr('burner1_trigger') == 0:
		Mission_SetAttr('burner1_trigger', 1)
		play(burner1_start_ss, 'burner1_start_ss')

# move burner1 to fire
def StartBurner1():
	print 'StartBurner1'
	addMoveGoal('nazi_burner1', 'bonfire_1', fn = 'OnBurner1Arrived', radius = 7, priority = ai.goal.PRI_HI)

# burner1 proximity to fire
def OnBurner1Close(event):
	if Mission_GetAttr('nazi_burner1_interrogate') == 0:
		play(burner1_close_ss, 'burner1_close_ss')

def interrogate_nazi_burner1_fn(event):
	Mission_SetAttr('nazi_burner1_interrogate', 1)
	Mission_SetAttr('burner1_trigger', 1)
	play(interrogate_nazi_burner1_cs,'interrogate_nazi_burner1_cs',interrupt = 1)

# burner1 arrives at fire - start the book throwing anim
#def OnBurner1Arrived(event):
#	turn('nazi_burner1', 'bonfire_1', 'OnBurner1Turned')

def OnBurner1Arrived(event):
	if (event.data):
		AI_SetEnabled('nazi_burner1', 0)
		AI_Animate('nazi_burner1', 'bookthrowstart', 'OnBurner1AnimEnd', 0, 1)
		play(burner1_start_burn_ss, 'burner1_start_burn_ss')

# burner1 finished initial throw 
def OnBurner1AnimEnd(event):
	status = int(event.data)
	print 'OnBurner1AnimEnd' + ' status = ' + `status`
	if not status:
		# was interruped - re-start the burner
		AI_SetEnabled('nazi_burner1', 1)
		StartBurner1()
		return
	# play the remainder of the animation - you lost
	AI_Animate('nazi_burner1', 'bookthrowend')
	play(burner1_end_burn_ss, 'burner1_end_burn_ss',priority=2)

# ------------ Second book - summa theologica

def SetupBurner2():
	removeArrow('burner_arrow1')
	Objective_Complete('save_bible')
	newObjective('primary', 3, 'save_summa')
	spawnGroup('second_nazi_spawn', 'nazi_rifleman', 3)		# as we send Burner 2, we spawn these three ambushers
	spawn('nazi_burner2', 'nazi_rifleman', 'nazi_burner2_spawn')
	regMarkerEnter('nazi_burner2', 'bonfire_2', 'OnBurner2Close')
	makeInterrogationFn('nazi_burner2', oneshot = 0)
	makePeaceful('nazi_burner2')
	addArrow('fire_arrow2', 'bonfire_2')
	regDetectHero('nazi_burner2', 'OnBurner2Trigger')
	regDanger('nazi_burner2', 'OnBurner2Trigger')
#	regHeroMarkerEnter('nazi_burner2', 'OnBurner2Trigger')

# move burner1 to fire
def StartBurner2():
	addMoveGoal('nazi_burner2', 'bonfire_2', fn = 'OnBurner2Arrived', radius = 7, priority = ai.goal.PRI_HI)

def OnBurner2Trigger(event):
	if Mission_GetAttr('burner2_trigger') == 0:
		Mission_SetAttr('burner2_trigger', 1)
		play(burner2_start_ss, 'burner2_start_ss')
		
def OnBurner2Close(event):
	play(burner2_close_ss, 'burner2_close_ss')

# burner2 arrives at fire - start the book throwing anim	
def OnBurner2Arrived(event):
	if (event.data):
		AI_SetEnabled('nazi_burner2', 0)
		AI_Animate('nazi_burner2', 'bookthrowstart', 'OnBurner2AnimEnd', 0, 1)
		play(burner2_start_burn_ss, 'burner2_start_burn_ss')

# burner1 finished initial throw 
def OnBurner2AnimEnd(event):
	status = int(event.data)
	if not status:
		# was interruped - re-start the burner
		AI_SetEnabled('nazi_burner2', 1)
		StartBurner2()
		return
	# play the remainder of the animation - you lost
	AI_Animate('nazi_burner2', 'bookthrowend')
	play(burner2_end_burn_ss, 'burner2_end_burn_ss',priority=2)

def OnTankDead(event):
	addAttr('tank_dead', 1)
	play(tank_dead_ss, 'tank_dead_ss')

# this is called when interrogate after tank dead
def interrogate_nazi_burner2_fn(char):
	if (Mission_GetAttr('nazi_burner2_interrogate')==0):
		addAttr('nazi_burner2_interrogate', 1)
		play(interrogate_nazi_burner2_cs, 'interrogate_nazi_burner2_cs',interrupt=1)
		Object_SetAttr('nazi_burner2', 'minHealth', 1)
	else:
		if (Mission_GetAttr('tank_dead')>0):
			play(interrogate_nazi_burner2_again_cs, 'interrogate_nazi_burner2_again_cs',interrupt=1)
		else:
			play(kill_tank_ss, 'kill_tank_ss')
	
# ------------  Third book - shakespeare

def SetupSchmidt():
	newObjective('primary', 4, 'save_shakespeare')
	spawn('schmidt', 'schmidt', 'schmidt_spawn')
	addArrow('schmidt_arrow', 'schmidt')
	addStayGoal('schmidt', priority = ai.goal.PRI_MED+1)
	regHeroMarkerEnter('ambush_trigger','AmbushLine')
	Object_SetAttr('schmidt', 'minHealth', 1)
	makeCustomFn('schmidt', oneshot = 1)

def SendSchmidt():
	clearGoals('schmidt')
	addMoveGoal('schmidt', 'bonfire_3', fn = 'OnSchmidtArrived', radius = 7, priority = ai.goal.PRI_ALWAYS-1)
	regMarkerEnter('schmidt', 'bonfire_3', 'OnSchmidtClose')
#	This appears to duplicated in the cutsene, so I'm commenting it out.
#	makeInterrogationFn('schmidt')

def interrogate_schmidt_fn(char):
	if (Mission_GetAttr('schmidt_interrogate')==0):
		play(nazi_ambush_cs, 'nazi_ambush_cs')
		addAttr('schmidt_interrogate', 1)
		Object_SetAttr('schmidt','defaultToAttack',1)
	elif (Mission_GetAttr('schmidt_interrogate')==1):
		addAttr('schmidt_interrogate', 1)
		play(interrogate_schmidt_cs, 'interrogate_schmidt_cs')
	else:
		print "Schmidt has already been interrogated twice."
def OnSchmidtClose(event):
	if Mission_GetAttr('schmidt_interrogate') < 2:
		play(schmidt_close_ss, 'schmidt_close_ss')

# schmidt arrives at fire - start the book throwing anim	
def OnSchmidtArrived(event):
	status = int(event.data)
	if not status:
		# was interruped - re-start the move comand
		AI_SetEnabled('schmidt', 1)
		SendSchmidt()
		return
# we need a book in the fire anim for schmidt
	if Mission_GetAttr('schmidt_interrogate') < 2:
		AI_SetEnabled('schmidt', 0)
		AI_Animate('schmidt', 'throwbookstart', 'OnSchmidtAnimEnd', 0, 1)
		play(schmidt_start_burn_ss, 'schmidt_start_burn_ss')

# schmidt finished initial throw 
def OnSchmidtAnimEnd(event):
	status = int(event.data)
	if not status:
		# was interruped - re-start the burner
		AI_SetEnabled('schmidt', 1)
		SendSchmidt()
		return
	# play the remainder of the animation - you lost
	AI_Animate('schmidt', 'throwbookend')
	play(schmidt_end_burn_cs, 'schmidt_end_burn_cs',priority=2)

# ------------ Fortissimo

def SetupLegionnaireGoals(who):
	addMoveGoal(who, 'bonfire_1', priority = ai.goal.PRI_LOW,radius = 10)
	addKillAllGoal(who, OC_CONTROLLABLE, priority = ai.goal.PRI_MED)

def SetupFortissimo():
	Object_Spawn('fortissimo', 'fortissimo', 'fortissimo_spawn')	# With all the book-burners finished, we spawn Fortissimo and some
	removeArrow('schmidt_arrow')
	spawnGroup('leg_spawn', 'legionnaire', 2)		# attendant Legionnaires
	SetupLegionnaireGoals('_spwn_leg_spawn0')
	SetupLegionnaireGoals('_spwn_leg_spawn1')
	regDamage('fortissimo', 'OnFortDmg', persistent = 1)
	regProximityEnter('black_jack','fortissimo',25,'BJFortSS')
	Mission_SetAttr('fort_burn_pending', 0)
	FortMoveToFire()

def BJFortSS(event):
	play(bj_fort_ss,'bj_fort_ss')

def OnFortissimoDead(event):
	play(fortissimo_dead_cs, 'fortissimo_dead_cs')

def FortissimoWins():
	play(fortissimo_wins_cs, 'fortissimo_wins_cs',priority=2)

def OnFortDmg(event):
	if not Mission_GetAttr('fort_burn_pending'):
		SetupFortBurn()

def SetupFortBurn():
	clearGoals('fortissimo')
	regTimer('RestartFortBurn', 15)
	Mission_SetAttr('fort_burn_pending', 1)
	play(fortissimo_interrupt_ss, 'fortissimo_interrupt_ss')

def RestartFortBurn(event):
	Mission_SetAttr('fort_burn_pending', 0)
	FortMoveToFire()
	play(fortissimo_resume_ss, 'fortissimo_resume_ss')

def FortMoveToFire():
	addMoveGoal('fortissimo', 'bonfire_1', command = 'walk', fn = 'OnFortArrived', speed = 0, radius = 9, priority = ai.goal.PRI_ALWAYS-1)

def OnFortArrived(event):
	status = int(event.data)
	if status:
		turnTo('fortissimo','bonfire_1')
		AI_NullController('fortissimo')
		AI_SetEnabled('fortissimo', 0)
		regTimer('OnFortArrived2', 0.5)
	else:
		if not Mission_GetAttr('fort_burn_pending'):
			SetupFortBurn()

def OnFortArrived2(event):
	AI_Animate('fortissimo', 'ThrowBookStart', 'OnFortAnimEnd', 0, 1)

def OnFortAnimEnd(event):
	status = int(event.data)
	if not status:
		if not Mission_GetAttr('fort_burn_pending'):
			AI_SetEnabled('fortissimo', 1)
			SetupFortBurn()
			return
	AI_Animate('fortissimo', 'ThrowBookEnd')
	FortissimoWins()

# ------------- semi-random Lines

def StartLine1():
	hero_list = getAllHeroes()
	liveheroes = ['nullhero']
	for hero_x in hero_list:
		if (Object_IsAlive(hero_x) and not (Object_GetTemplate(hero_x) == 'tombstone')):
			liveheroes.append(Object_GetTemplate(hero_x))
	print len(liveheroes)
	if len(liveheroes) == 1:
		a_hero = 'nobody'
	else:
		temp = randint(1,len(liveheroes)-1)
		a_hero = liveheroes[temp]
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_7_MM_09')
	elif a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_7_AL_01')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_7_ED_01')
	elif a_hero == 'eve':
		speak('eve', 'MISSPCH_7_EV_01')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_7_GG_01')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_7_LL_01')
	elif a_hero == 'microwave':
		speak('microwave', 'MISSPCH_7_MW_01')
	elif a_hero == 'quetzalcoatl':
		speak('quetzalcoatl', 'MISSPCH_7_QZ_01')
	elif a_hero == 'supercollider':
		speak('supercollider', 'MISSPCH_7_SC_01')
	elif a_hero == 'the_ant':
		speak('the_ant', 'MISSPCH_7_AN_01')
	elif a_hero == 'black_jack':
		speak('black_jack', 'MISSPCH_7_BJ_45')
	else:
		print "Custom character?"
		speak('black_jack', 'MISSPCH_7_BJ_45')
		
def StartLine2():
	hero_list = getAllHeroes()
	liveheroes = ['nullhero']
	for hero_x in hero_list:
		if (Object_IsAlive(hero_x) and not (Object_GetTemplate(hero_x) == 'black_jack') and not (Object_GetTemplate(hero_x) == 'tombstone')):
			liveheroes.append(Object_GetTemplate(hero_x))
	print len(liveheroes)
	if len(liveheroes) == 1:
		a_hero = 'nobody'
	else:
		temp = randint(1,len(liveheroes)-1)
		a_hero = liveheroes[temp]
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_7_MM_17')
	elif a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_7_AL_02')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_7_ED_02')
	elif a_hero == 'eve':
		speak('eve', 'MISSPCH_7_EV_02')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_7_GG_02')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_7_LL_02')
	elif a_hero == 'microwave':
		speak('microwave', 'MISSPCH_7_MW_02')
	elif a_hero == 'quetzalcoatl':
		speak('quetzalcoatl', 'MISSPCH_7_QZ_02')
	elif a_hero == 'supercollider':
		speak('supercollider', 'MISSPCH_7_SC_02')
	elif a_hero == 'the_ant':
		speak('the_ant', 'MISSPCH_7_AN_02')
	else:
		print "Custom character?"
		wait(.1)

def LegionLine():
	hero_list = getAllHeroes()
	liveheroes = ['nullhero']
	for hero_x in hero_list:
		if Object_IsAlive(hero_x):
			liveheroes.append(Object_GetTemplate(hero_x))
	print len(liveheroes)
	if len(liveheroes) == 1:
		a_hero = 'nobody'
	else:
		temp = randint(1,len(liveheroes)-1)
		a_hero = liveheroes[temp]
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_7_MM_11')
	elif a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_7_AL_08')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_7_ED_03')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_7_GG_03')
	elif a_hero == 'quetzalcoatl':
		speak('quetzalcoatl', 'MISSPCH_7_QZ_03')
	elif a_hero == 'the_ant':
		speak('the_ant', 'MISSPCH_7_AN_03')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_7_LL_08')
	elif a_hero == 'microwave':
		speak('microwave', 'MISSPCH_7_MW_03')
	elif a_hero == 'supercollider':
		speak('supercollider', 'MISSPCH_7_SC_03')
	elif a_hero == 'eve':
		speak('eve', 'MISSPCH_7_EV_03')
	elif a_hero == 'black_jack':
		speak('black_jack', 'MISSPCH_7_BJ_46')
	elif a_hero == 'tombstone':
		speak('tombstone', 'MISSPCH_7_TS_11')
	else:
		print "Custom character?"
		wait(.1)

def Tank1Line():
	hero_list = getAllHeroes()
	liveheroes = ['nullhero']
	for hero_x in hero_list:
		if (Object_IsAlive(hero_x) and not (Object_GetTemplate(hero_x) == 'tombstone')):
			liveheroes.append(Object_GetTemplate(hero_x))
	print len(liveheroes)
	if len(liveheroes) == 1:
		a_hero = 'nobody'
	else:
		temp = randint(1,len(liveheroes)-1)
		a_hero = liveheroes[temp]
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_7_MM_12')
	elif a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_7_AL_09')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_7_ED_04')
	elif a_hero == 'eve':
		speak('eve', 'MISSPCH_7_EV_04')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_7_GG_04')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_7_LL_03')
	elif a_hero == 'microwave':
		speak('microwave', 'MISSPCH_7_MW_04')
	elif a_hero == 'quetzalcoatl':
		speak('quetzalcoatl', 'MISSPCH_7_QZ_04')
	elif a_hero == 'supercollider':
		speak('supercollider', 'MISSPCH_7_SC_04')
	elif a_hero == 'the_ant':
		speak('the_ant', 'MISSPCH_7_AN_04')
	elif a_hero == 'black_jack':
		speak('black_jack', 'MISSPCH_7_BJ_47')
	else:
		print "Custom character?"
		speak('tombstone', 'MISSPCH_7_TS_43')
def Tank2Line():
	hero_list = getAllHeroes()
	liveheroes = ['nullhero']
	for hero_x in hero_list:
		if (Object_IsAlive(hero_x) and not (Object_GetTemplate(hero_x) == 'tombstone')):
			liveheroes.append(Object_GetTemplate(hero_x))
	print len(liveheroes)
	if len(liveheroes) == 1:
		a_hero = 'nobody'
	else:
		temp = randint(1,len(liveheroes)-1)
		a_hero = liveheroes[temp]
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_7_MM_13')
	elif a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_7_AL_16')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_7_ED_05')
	elif a_hero == 'eve':
		speak('eve', 'MISSPCH_7_EV_05')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_7_GG_05')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_7_LL_04')
	elif a_hero == 'microwave':
		speak('microwave', 'MISSPCH_7_MW_05')
	elif a_hero == 'quetzalcoatl':
		speak('quetzalcoatl', 'MISSPCH_7_QZ_05')
	elif a_hero == 'supercollider':
		speak('supercollider', 'MISSPCH_7_SC_05')
	elif a_hero == 'the_ant':
		speak('the_ant', 'MISSPCH_7_AN_05')
	elif a_hero == 'black_jack':
		speak('black_jack', 'MISSPCH_7_BJ_09')
	else:
		print "Custom character?"
		speak('tombstone', 'MISSPCH_7_TS_42')

def WhereLine():
	hero_list = getAllHeroes()
	liveheroes = ['nullhero']
	for hero_x in hero_list:
		if (Object_IsAlive(hero_x) and not (Object_GetTemplate(hero_x) == 'tombstone')):
			liveheroes.append(Object_GetTemplate(hero_x))
	print len(liveheroes)
	if len(liveheroes) == 1:
		a_hero = 'nobody'
	else:
		temp = randint(1,len(liveheroes)-1)
		a_hero = liveheroes[temp]
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_7_MM_15')
	elif a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_7_AL_17')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_7_ED_07')
	elif a_hero == 'eve':
		speak('eve', 'MISSPCH_7_EV_07')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_7_GG_07')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_7_LL_06')
	elif a_hero == 'microwave':
		speak('microwave', 'MISSPCH_7_MW_07')
	elif a_hero == 'quetzalcoatl':
		speak('quetzalcoatl', 'MISSPCH_7_QZ_07')
	elif a_hero == 'supercollider':
		speak('supercollider', 'MISSPCH_7_SC_07')
	elif a_hero == 'the_ant':
		speak('the_ant', 'MISSPCH_7_AN_07')
	elif a_hero == 'black_jack':
		speak('black_jack', 'MISSPCH_7_BJ_49')
	else:
		print "Custom character?"
		wait(.1)
def IntermissionLine():
	hero_list = getAllHeroes()
	liveheroes = ['nullhero']
	for hero_x in hero_list:
		if (Object_IsAlive(hero_x) and not (Object_GetTemplate(hero_x) == 'tombstone')):
			liveheroes.append(Object_GetTemplate(hero_x))
	print len(liveheroes)
	if len(liveheroes) == 1:
		a_hero = 'nobody'
	else:
		temp = randint(1,len(liveheroes)-1)
		a_hero = liveheroes[temp]
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_7_MM_19')
	elif a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_7_AL_20')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_7_ED_11')
	elif a_hero == 'eve':
		speak('eve', 'MISSPCH_7_EV_11')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_7_GG_10')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_7_LL_10')
	elif a_hero == 'microwave':
		speak('microwave', 'MISSPCH_7_MW_10')
	elif a_hero == 'quetzalcoatl':
		speak('quetzalcoatl', 'MISSPCH_7_QZ_10')
	elif a_hero == 'supercollider':
		speak('supercollider', 'MISSPCH_7_SC_10')
	elif a_hero == 'the_ant':
		speak('the_ant', 'MISSPCH_7_AN_11')
	elif a_hero == 'black_jack':
		speak('black_jack', 'MISSPCH_7_BJ_53')
	else:
		print "Custom character?"
		speak('tombstone', 'MISSPCH_7_TS_44')

def AmbushLine(event):
	hero_list = getAllHeroes()
	liveheroes = ['nullhero']
	for hero_x in hero_list:
		if (Object_IsAlive(hero_x) and not (Object_GetTemplate(hero_x) == 'tombstone')):
			liveheroes.append(Object_GetTemplate(hero_x))
	print len(liveheroes)
	if len(liveheroes) == 1:
		a_hero = 'nobody'
	else:
		temp = randint(1,len(liveheroes)-1)
		a_hero = liveheroes[temp]
	print a_hero
	if a_hero == 'minute_man':
		speakNoCB('minute_man', 'MISSPCH_7_MM_20')
	elif a_hero == 'alchemiss':
		speakNoCB('alchemiss', 'MISSPCH_7_AL_21')
	elif a_hero == 'el_diablo':
		speakNoCB('el_diablo', 'MISSPCH_7_ED_12')
	elif a_hero == 'eve':
		speakNoCB('eve', 'MISSPCH_7_EV_12')
	elif a_hero == 'green_genie':
		speakNoCB('green_genie', 'MISSPCH_7_GG_11')
	elif a_hero == 'liberty_lad':
		speakNoCB('liberty_lad', 'MISSPCH_7_LL_11')
	elif a_hero == 'microwave':
		speakNoCB('microwave', 'MISSPCH_7_MW_11')
	elif a_hero == 'quetzalcoatl':
		speakNoCB('quetzalcoatl', 'MISSPCH_7_QZ_11')
	elif a_hero == 'supercollider':
		speakNoCB('supercollider', 'MISSPCH_7_SC_11')
	elif a_hero == 'the_ant':
		speakNoCB('the_ant', 'MISSPCH_7_AN_12')
	elif a_hero == 'black_jack':
		speakNoCB('black_jack', 'MISSPCH_7_BJ_52')
	else:
		print "Custom character?"
		#wait(.1)
def AmbushLine2():
	hero_list = getAllHeroes()
	liveheroes = ['nullhero']
	for hero_x in hero_list:
		if (Object_IsAlive(hero_x) and not (Object_GetTemplate(hero_x) == 'tombstone')):
			liveheroes.append(Object_GetTemplate(hero_x))
	print len(liveheroes)
	if len(liveheroes) == 1:
		a_hero = 'nobody'
	else:
		temp = randint(1,len(liveheroes)-1)
		a_hero = liveheroes[temp]
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_7_MM_18')
	elif a_hero == 'alchemiss':
		speak('alchemiss', 'MISSPCH_7_AL_19')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_7_ED_10')
	elif a_hero == 'eve':
		speak('eve', 'MISSPCH_7_EV_10')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_7_GG_09')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_7_LL_09')
	elif a_hero == 'microwave':
		speak('microwave', 'MISSPCH_7_MW_09')
	elif a_hero == 'quetzalcoatl':
		speak('quetzalcoatl', 'MISSPCH_7_QZ_09')
	elif a_hero == 'supercollider':
		speak('supercollider', 'MISSPCH_7_SC_09')
	elif a_hero == 'the_ant':
		speak('the_ant', 'MISSPCH_7_AN_10')
	elif a_hero == 'black_jack':
		speak('black_jack', 'MISSPCH_7_BJ_51')
	else:
		print "Custom character?"
		wait(.1)

def TwoCloseLine():
	temp = randint(0,2)
	if temp == 0:
		speak('tombstone', 'MISSPCH_7_TS_18')
	elif temp == 1:
		speak('tombstone', 'MISSPCH_7_TS_40')
	elif temp == 2:
		speak('tombstone', 'MISSPCH_7_TS_41')
	else:
		print "bad randint?"
		null()

def FortissimoResumeLine():
	temp = randint(0,2)
	if temp == 0:
		speak('fortissimo', 'MISSPCH_7_FT_11')
	elif temp == 1:
		speak('fortissimo', 'MISSPCH_7_FT_12')
	elif temp == 2:
		speak('fortissimo', 'MISSPCH_7_FT_17')
	else:
		print "bad randint?"
		null()



# ------------- Misc

def OnTombstoneDeath(event):
	print "Tombstone has died; you lose the mission!"
	play(tombstone_dead_cs, 'tombstone_dead_cs')

def LiveTeleport(hero,dest):
	if Object_IsAlive(hero):
		teleport (hero,dest)
	else:
		print "not teleporting dead hero"

def OnMissionWon():
	print "fortissimo/won"

def OnMissionLost():
	print "fortissimo/lost"

start_cs = [
(
	"peace()",
	"see()",
	"startCS()",
	"Camera_SetFade(1)",
	"lookAtPos((-495, -722, 80), heading = -55, zoom = -26)",
	"wait(0.5)",
),
(
	"Camera_UnFade(1)",
	"speakNoCB('nazi_rifleman_001', 'MISSPCH_7_N1_13')",
	"wait(0.5)",
),
(
	"lookAtPos((-500, -695, 80), heading = -55, zoom = -26, time = 3.5, fn = 'onStepCB')",
),
(
	"lookAtPos((-500, -695, 80), heading = -55, zoom = -121, time = 7)",
	"speak('nazi_rifleman_002', 'MISSPCH_7_N2_09')",
),
(
	"speak('nazi_rifleman_001', 'MISSPCH_7_N1_11')",
),
(
	"spawn('cs_fort', 'fortissimo', 'fort_cs_spawn')",
	"spawnGroup('leg_cs_spawn', 'legionnaire', 5)",
	"peace()",
	"move('cs_fort', 'fort_cs_move')",
	"move('_spwn_leg_cs_spawn0', 'leg_cs_move0')",
	"move('_spwn_leg_cs_spawn1', 'leg_cs_move1')",
	"move('_spwn_leg_cs_spawn2', 'leg_cs_move2')",
	"move('_spwn_leg_cs_spawn3', 'leg_cs_move3')",
	"move('_spwn_leg_cs_spawn4', 'leg_cs_move4')",
	"lookAtPos((-508, -520, 80), heading = 135, zoom = -160, pitch = -30)",
	"speak('nazi_rifleman_002', 'MISSPCH_7_N2_06')",
	"Sound_PlayMusic('music_05fort_cs1',1)",
),
(
	"turnTo('nazi_rifleman_001', 'cs_fort')",
	"turnTo('nazi_rifleman_002', 'cs_fort')",
	"speak('cs_fort', 'MISSPCH_7_FT_16')",
),
(
	"Trigger_Power('cs_fort', 'cs_guard_post', 'fortissimo Song of Pain', '')",
	"wait(2)",
),
(
	"Trigger_Damage('cs_guard_post',5)",
	"AI_Animate('nazi_rifleman_001', 'dodge_right', '', 0, 0)",
	"AI_Animate('nazi_rifleman_002', 'dodge_left', '', 0, 0)",
	"wait(2)",
),
(
	"speakNoCB('nazi_rifleman_001', 'MISSPCH_7_N1_14')",
	"Camera_Fade(1)",
	"wait(4)",
),
(
	"Object_Destroy('cs_guard_post')",
	"Object_Destroy('cs_fort')",
	"Object_Destroy('_spwn_leg_cs_spawn0')",
	"Object_Destroy('_spwn_leg_cs_spawn1')",
	"Object_Destroy('_spwn_leg_cs_spawn2')",
	"Object_Destroy('_spwn_leg_cs_spawn3')",
	"Object_Destroy('_spwn_leg_cs_spawn4')",
	"turnTo('nazi_rifleman_001', 'nazi_rifleman_002')",
	"turnTo('nazi_rifleman_002', 'nazi_rifleman_001')",
	"Camera_UnFade(1)",
	"lookAtPos((-500, -695, 80), heading = -55, zoom = -121)",
	"speak('nazi_rifleman_002', 'MISSPCH_7_N2_07')",
),
(
	"speak('nazi_rifleman_001', 'MISSPCH_7_N1_12')",
),
(
	"speak('nazi_rifleman_002', 'MISSPCH_7_N2_08')",
),
(
	"lookAtPos((-372, -707, 80), heading = -55, zoom = -121, time = 3)",
	"speak('tombstone', 'MISSPCH_7_TS_01')",
),
(
	"lookAtPos((-500, -695, 80), heading = -55, zoom = -121)",
	"Trigger_Power('nazi_rifleman_001', 'tombstone', 'nazi rifleman Mauser 98K', '')",
	"speakNoCB('nazi_rifleman_001', 'MISSPCH_7_N1_03')",
	"wait(1)",
),
(
	"Trigger_Power('nazi_rifleman_002', 'tombstone', 'nazi rifleman Mauser 98K', '')",
	"wait(2)",
),
(
	"Object_PlayEffect('tombstone_teleport_obj', 'csfx_tombstone_teleport')",
	"lookAtPos((-475, -720, 80), heading = 240, zoom = -205, pitch = -45)",
	"wait(1)",
),
(
	"teleport('tombstone', 'tombstone_cs_teleport')",
	"wait(1)",
),
(
	"walk('tombstone', 'tombstone_cs_move')",
	"wait(1)",
),
(
	"speak('tombstone', 'MISSPCH_7_TS_02')",
	"turnTo('nazi_rifleman_001', 'tombstone')",
	"turnTo('nazi_rifleman_002', 'tombstone')",
),
(
	"speak('nazi_rifleman_002', 'MISSPCH_7_N1_09')",
),
(
	"Camera_Fade(0.2)",
	"wait(0.2)",
),
(
	"Mission_Play2DCutscene('cutscene_krak', 'cutscene_krak_wav', 'onStepCB')",
),
(
	"speak('nazi_rifleman_002', 'SPEECH_N1_INTEROGATEME_05')",
	"Object_SetAttr('nazi_rifleman_001', 'noFade', 1)",
	"Object_SetAttr('nazi_rifleman_002', 'noFade', 1)",
	"kill('nazi_rifleman_001')",
	"kill('nazi_rifleman_002')",
),
(
	"playTransition()",
),
(
	"Camera_UnFade(2.25)",
	"lookAtPos((-506, -714, 79), zoom = -90, heading = -117)",
	"AI_Animate('tombstone', 'idle', '', 0, 0)",
	"Sound_PlayMusic('music_05fort_cs1a',1)",
	"Sound_PlaySound('mission_fortissimo')",
	"wait(1)",
),
(
	"spawn('black_jack', 'black_jack', 'blackjack_cs_spawn')",
	"AI_MakeHeroAI('black_jack')",
	"move('hero_2', 'alchemiss_cs_runtarget')",
	"move('hero_3', 'minuteman_cs_runtarget')",
	"moveCB('black_jack', 'blackjack_cs_runtarget')",
),
(
	"speak('tombstone', 'MISSPCH_7_TS_03')",
),
(
	"lookAtPos((-506, -714, 79), zoom = -75, heading = -117, time = 2)",
	"ff.StartLine1()",
),
(
	"lookAtPos((325,234,80), zoom = 200.0, pitch = -10, heading = 115.2)",
	"speak('tombstone', 'MISSPCH_7_TS_08')",
),
(
	"speak('tombstone', 'MISSPCH_7_TS_05')",
),
(
	"ff.StartLine2()",
),
(
	"endCS()",
	"war()",
	"Sound_PlayMusic('music_05berlin1')",
	"blind()",
	"addArrow('burner_arrow1', 'nazi_burner1')",
	"newObjective('primary', 1, name='tombstone_alive')",
	"newObjective('primary', 2, name='save_bible')",
	"#god()",
),
]

legionnaire_attack1_ss = [
(
	"speak('legionnaire', 'MISSPCH_7_LG_01')",
),
(
	"ff.LegionLine()",
),
(
	"blank",
),
]

# book 1

burner1_start_ss = [
(
	"speak('nazi_rifleman_006', 'MISSPCH_7_N1_07')",
	"wait(0.1)",
),
(
	"speakNoCB('nazi_burner1', 'MISSPCH_7_N2_04')",
),
(
	"speak('tombstone', 'MISSPCH_7_TS_28')",
	"# Check for when Burner 1 either dies or reaches his book pile",
	"regMarkerEnter('nazi_burner1', 'bonfire_1', 'OnBurner1Close')",
	"# Nazi Burner 1 moves toward book pile",
	"ff.StartBurner1()",
),
(
	"blank",
),
]

burner1_close_ss = [
(
	"speak('tombstone', 'MISSPCH_7_TS_12')",
),
(
	"blank",
),
]

burner1_start_burn_ss = [
(
	"speak('nazi_burner1', 'MISSPCH_7_N2_02')",
),
(
	"blank",
),
]

burner1_end_burn_ss = [
(
	"startCS()",
	"peace()",
	"see()",
	"look('nazi_burner1')",
	"speak('tombstone', 'MISSPCH_7_TS_13')",
),
(
	"wait(10)",
),
(
	"Objective_Fail('save_bible')",
	"Mission_Lose()",
	"endCS()",
),
]

interrogate_nazi_burner1_cs = [
(
	"startCS()",
	"peace()",
	"teleport('nazi_burner1','cs1_nb1_marker')",
	"teleport('tombstone','cs1_ts_marker')",
	"ff.LiveTeleport('hero_2','cs1_h2_marker')",
	"ff.LiveTeleport('hero_3','cs1_h3_marker')",
	"ff.LiveTeleport('black_jack','cs1_h4_marker')",
	"look('nazi_burner1')",
	"normalize('nazi_burner1')",
	"turnTo('nazi_burner1', 'tombstone')",
	"turnTo('tombstone','nazi_burner1')",
	"Sound_PlayMusic('music_05fort_book1',1)",
	"speak('tombstone', 'MISSPCH_7_TS_29')",
),
(
	"speak('nazi_burner1', 'MISSPCH_7_N1_17')",
),
(
	"speak('tombstone', 'MISSPCH_7_TS_30')",
),
(
	"speak('nazi_burner1', 'MISSPCH_7_N1_18')",
),
(
	"speakNoCB('tombstone', 'MISSPCH_7_TS_31')",
	"wait(3.5)",
),
(
	"Trigger_Power('tombstone', 'nazi_burner1', 'tombstone Phantom Punch', '')",
	"#AI_Animate('tombstone','melee')",
	"wait(0.5)",
),
(
	"kill('nazi_burner1')",
	"wait(3.5)",
),
(
	"ff.SetupBurner2()",
	"endCS()",
	"war()",
	"Sound_PlayMusic('music_05fort_hear_ft',1)",
	"wait(6)",
),
(
	"speak('tombstone', 'MISSPCH_7_TS_14')",				# These speech lines are in response to the off-stage singing
),
(
	"forceSpeak('fortissimo', 'MISSPCH_7_FT_01', telepathy = 0)",				# of Fortissimo
),
(
	"optionalSpeak('minute_man', 'MISSPCH_7_MM_02')",				# Minuteman only says his line if he's alive
),
(
	"speak('tombstone', 'MISSPCH_7_TS_15')",
),
(
	"blank",
),
]

# book 2

burner2_start_ss = [
(
	"ff.StartBurner2()",
	"removeArrow('fire_arrow2')",
	"addArrow('burner_arrow2', 'nazi_burner2')",
	"speak('tombstone', 'MISSPCH_7_TS_17')",
	"Sound_PlayMusic('music_05berlin1')",
),
(
	"forceSpeak('fortissimo', 'MISSPCH_7_FT_02', telepathy = 0)",
),
(
	"blank",
),
]

burner2_close_ss = [
(
	"ff.TwoCloseLine()",
),
(
	"blank",
),
]

burner2_start_burn_ss = [
(
	"speak('nazi_burner2', 'MISSPCH_7_N1_05')",
),
(
	"blank",
),
]

burner2_end_burn_ss = [
(
	"startCS()",
	"look('nazi_burner2')",
	"peace()",
	"see()",
	"speak('tombstone', 'MISSPCH_7_TS_19')",
),
(
	"wait(10)",
),
(
	"Objective_Fail('save_summa')",
	"Mission_Lose()",
),
]

interrogate_nazi_burner2_cs = [
(
	"startCS()",
	"peace()",
	"teleport('nazi_burner2','cs_nb2_marker')",
	"teleport('tombstone','cs_ts_marker')",
	"ff.LiveTeleport('hero_2','cs_h2_marker')",
	"ff.LiveTeleport('hero_3','cs_h3_marker')",
	"ff.LiveTeleport('black_jack','cs_h4_marker')",
	"look('nazi_burner2', heading = 75)",
	"#normalize('nazi_burner2')",
	"turnTo('tombstone', 'nazi_burner2')",
	"turnTo('nazi_burner2', 'tombstone')",
	"Sound_PlayMusic('music_05fort_book2',1)",
	"speak('tombstone', 'MISSPCH_7_TS_16')",
),
(
	"speak('nazi_burner2', 'MISSPCH_7_N1_09')",
),
(
	"spawn('tank', 'tank_ger', 'tank_spawn')",
	"wait(1)",
),
(
	"look('tank', heading = 200, time = 3)",
	"ff.Tank1Line()",
),
(
	"move('tank', 'tank_move')",
	"see()",
	"regDeath('tank', 'OnTankDead')",
	"Sound_PlayMusic('music_05fort_tank')",
	"ff.Tank2Line()",
),
(
	"addArrow('tank_arrow', 'tank')",
	"endCS()",
	"war()",
	"blind()",
),
]

tank_dead_ss = [
(
	"removeArrow('tank_arrow')",
	"speak('tombstone', 'MISSPCH_7_TS_37')",
	"Sound_PlayMusic('music_05fort_cs1a',1)",
),
(
	"blank",
),
]

kill_tank_ss = [
(
	"speak('tombstone', 'MISSPCH_7_TS_32')",
),
(
	"blank",
),
]

interrogate_nazi_burner2_again_cs = [
(
	"startCS()",
	"peace()",
	"teleport('nazi_burner2','cs_nb2_marker')",
	"teleport('tombstone','cs_ts_marker')",
	"ff.LiveTeleport('hero_2','cs_h2_marker')",
	"ff.LiveTeleport('hero_3','cs_h3_marker')",
	"ff.LiveTeleport('black_jack','cs_h4_marker')",
	"look('nazi_burner2')",
	"normalize('nazi_burner2')",
	"turnTo('nazi_burner2', 'tombstone')",
	"turnTo('tombstone', 'nazi_burner2')",
	"speak('tombstone', 'MISSPCH_7_TS_20')",
),
(
	"speak('nazi_burner2', 'MISSPCH_7_N1_10')",
),
(
	"speak('tombstone', 'MISSPCH_7_TS_38')",
),
(
	"Trigger_Power('tombstone', 'nazi_burner2', 'tombstone Phantom Punch', '')",
	"#AI_Animate('tombstone','melee')",
	"wait(2)",
),
(
	"kill('nazi_burner2')",  # Shouldn't be needed now that Jack punches him out
	"optionalSpeak('alchemiss', 'MISSPCH_7_AL_04')",
),
(
	"speak('tombstone', 'MISSPCH_7_TS_21')",
),
(
	"ff.SetupSchmidt()",
	"Objective_Complete('save_summa')",
	"removeArrow('burner_arrow2')",
	"endCS()",
	"war()",
),
]

# third book

nazi_ambush_cs = [
(
	"look('schmidt', zoom = -100)",
	"normalize('schmidt')",
	"teleport('tombstone','ts_ambush')",
	"ff.LiveTeleport('black_jack','bj_ambush')",
	"ff.LiveTeleport('hero_2','hero2_ambush')",
	"ff.LiveTeleport('hero_3','hero3_ambush')",
	"see()",
	"startCS()",
	"Sound_PlayMusic('music_05berlin1')",
	"spawnGroup('ambush_spawn', 'nazi_rifleman', 4)",
	"spawn('legionnaire_ambush', 'legionnaire', 'legionnaire_spawn')",
	"peace()",
	"move('_spwn_ambush_spawn2', 'ambush_move2')",
	"move('_spwn_ambush_spawn3', 'ambush_move3')",
	"wait(.4)",
),
(
	"look('schmidt', zoom = 100, time = 1)",
	"turnTo('tombstone', '_spwn_ambush_spawn3')",
	"speak('_spwn_ambush_spawn3', 'MISSPCH_7_N2_03')",
),
(
	"#move('schmidt', 'schmidt_move')",  #
	"speak('schmidt', 'MISSPCH_7_B1_04')",
),
(
	"speak('tombstone', 'MISSPCH_7_TS_06')",
),
(
	"forceSpeak('fortissimo', 'MISSPCH_7_FT_05', telepathy = 0)",
),
(
	"speak('tombstone', 'MISSPCH_7_TS_22')",
),
(
	"ff.AmbushLine2()",
),
(
	"blind()",
	"war()",
	"endCS()",
	"ff.SendSchmidt()",
	"makeInterrogationFn('schmidt')",
),
]

interrogate_schmidt_cs = [
(
	"Camera_ForceAutoFade(1)",
	"startCS()",
	"peace()",
	"teleport('schmidt','cs4_s_marker')",
	"teleport('tombstone','cs4_ts_marker')",
	"ff.LiveTeleport('hero_2','cs4_h2_marker')",
	"ff.LiveTeleport('hero_3','cs4_h3_marker')",
	"ff.LiveTeleport('black_jack','cs4_h4_marker')",
	"look('schmidt')",
	"normalize('schmidt')",
	"see()",
	"turnTo('schmidt', 'black_jack')",
	"Sound_PlayMusic('music_05fort_schmidt',1)",
	"speak('schmidt', 'MISSPCH_7_B2_04')",
),
(
	"speak('tombstone', 'MISSPCH_7_TS_23')",
),
(
	"speak('schmidt', 'MISSPCH_7_B2_05')",
),
(
	"speak('tombstone', 'MISSPCH_7_TS_24')",
),
(
	"ff.WhereLine()",
),
(
	"ff.SetupFortissimo()",
	"peace()",
	"lookAtPos(Get_MarkerPos('fortissimo_camera'), heading = 225, zoom = -80, pitch = -17)",
	"move('_spwn_leg_spawn0', 'leg_move0')",
	"move('_spwn_leg_spawn1', 'leg_move1')",
	"Trigger_Move('fortissimo', 'fly', Get_MarkerPos('fortissimo_move'), 'onStepCB')",
),
(
	"speak('fortissimo', 'MISSPCH_7_FT_06')",
),
(
	"ff.IntermissionLine()",
),
(
	"speak('fortissimo', 'MISSPCH_7_FT_07')",
),
(
	"Objective_Complete('save_shakespeare')",
	"newObjective('primary', 5, 'defeat_fortissimo')",
	"addArrow('fortissimo_arrow', 'fortissimo')",
	"endCS()",
	"war()",
	"Sound_PlayMusic('music_05fort_fight_ft')",
	"blind()",
	"Camera_ForceAutoFade(0)",
),
]

schmidt_start_burn_ss = [
(
	"speak('schmidt', 'MISSPCH_7_B1_03')",
),
(
	"blank",
),
]

schmidt_end_burn_cs = [
(
	"startCS()",
	"look('schmidt')",
	"see()",
	"peace()",
	"speak('tombstone', 'MISSPCH_7_TS_19')",
),
(
	"wait(10)",
),
(
	"Objective_Fail('save_shakespeare')",
	"Mission_Lose()",
),
]

schmidt_close_ss = [
(
	"speak('tombstone', 'MISSPCH_7_TS_07')",
),
(
	"blank",
),
]

# fortissimo

bj_fort_ss = [
(
	"speak('black_jack', 'MISSPCH_7_BJ_19')",
),
(
	"speak('fortissimo', 'MISSPCH_7_FT_10')",
),
(
	"speak('black_jack', 'MISSPCH_7_BJ_20')",
),
(
	"blank",
),
]


fortissimo_wins_cs = [
(
	"peace()",
	"see()",
	"startCS()",
	"#ff.teleport('fortissimo', 'fortissimo_fire_marker')",
	"# play an animation of him throwing in the plan book",
	"look('fortissimo', 0, 0, 2)",
	"speak('fortissimo', 'MISSPCH_7_FT_09')",
),
(
	"speak('tombstone', 'MISSPCH_7_TS_27')",
),
(
	"wait(1)",
),
(
	"ff.Objective_Fail('defeat_fortissimo')",
	"ff.Mission_Lose()",
),
]

fortissimo_dead_cs = [
(
	"peace()",
	"see()",
	"startCS()",
	"look('fortissimo', 0, 0, 1)",
	"Sound_PlayMusic('music_05fort_beat_ft',1)",
	"forceSpeak('fortissimo', 'MISSPCH_7_FT_14', telepathy = 0)",
),
(
	"speak('tombstone', 'MISSPCH_7_TS_34')",
),
(
	"wait(2)",
),
(
	"Objective_Complete('defeat_fortissimo')",
	"Objective_Complete('tombstone_alive')",
	"endCS()",
	"Mission_Win()",
),
]

fortissimo_interrupt_ss = [
(
	"speak('fortissimo', 'MISSPCH_7_FT_13')",	# multi-line
),
(
	"blank",
),
]
	
fortissimo_resume_ss = [
(
	"ff.FortissimoResumeLine()",
),
(
	"blank",
),
]

# misc

tombstone_dead_cs = [
(
	"AI_EnableDynamicSpeech('black_jack', 0)",
	"startCS()",
	"look('tombstone')",
	"see()",
	"peace()",
	"forceSpeak('tombstone', 'MISSPCH_7_TS_35', telepathy = 0)",
),
(
	"endCS()",
	"Objective_Fail('tombstone_alive')",
	"Mission_Lose()",
),
]

