# redsun

from cshelper import *
from js import *
import event
from ffx import *

def OnPrecacheObjects():
	Mission_PrecacheTemplateObj('red_sun', 0, 1)
	Mission_PrecacheTemplateObj('nazi_rifleman', 0, 1)
	Mission_PrecacheTemplateObj('bullet', 1, 1)
	print "redsun/precache"
	
def OnPostInit():
	setMission(8)

	Mission_SetSunlight(-120,70,1.2,0.6,(0.8,0.7,0.6))
	Mission_SetShadows(-120,70,(0.2,0.2,0.5))
	Mission_SetProjShadowBackground((1,1,1))
	Mission_SetProjShadowColor((.5,.5,.6,1))

	makeInterrogationCS('red_sun1', oneshot = 1)

	regDeath('truck1', 'OnTruckDead')
	regDeath('truck2', 'OnTruckDead')
	regDeath('truck3', 'OnTruckDead')
	Mission_SetAttr('trucks_dead', 0)
	registerObjective('secondary', 1, 'trucks_destroyed')
	regHeroMarkerEnter('truck1_marker', 'OnTruckProx')
	regHeroMarkerEnter('truck2_marker', 'OnTruckProx')
	regHeroMarkerEnter('truck3_marker', 'OnTruckProx')

	heroPoints = Object_GetAttr('tricolour', 'heroPoints')
	Mission_SetAttr('tricolour_heroPoints', heroPoints)
	Object_SetAttr('tricolour', 'heroPoints', 0)

	play(start_cs, 'start_cs')
	FFX_InitMission()

def OnMissionWon():
	Campaign_Recruit('tricolour')
	Campaign_UnlockOrigin('tricolour')

def OnMissionLost():
	print 'redsun/lost'

# towers
def SetupTowers():
	newObjective('primary', 2, 'destroy_towers')
	Object_Spawn('tower1', 'ger_radio_tower', 'tower1_marker')
	Object_Spawn('tower2', 'ger_radio_tower', 'tower2_marker')
	addArrow('tower1_arrow', 'tower1')
	addArrow('tower2_arrow', 'tower2')
	regDeath('tower1', 'OnTowerDestroyed')
	regDeath('tower2', 'OnTowerDestroyed')
	regHeroMarkerEnter('tower1_marker', 'OnTowerProx')
	regHeroMarkerEnter('tower2_marker', 'OnTowerProx')
	# spawn red suns
	Object_Spawn('red_sun2', 'red_sun', 'red_sun2_marker')
	Object_Spawn('red_sun3', 'red_sun', 'red_sun3_marker')
	regDetectHero('red_sun2', 'OnRedSunDetect')
	regDetectHero('red_sun3', 'OnRedSunDetect')
	regDeath('red_sun2', 'OnRedSunDead')
	regDeath('red_sun3', 'OnRedSunDead')
	Object_Spawn('tank', 'tank_ger', 'tank_marker')

def ReinforceRedsun(index):
	name = 'red_sun' + `index`
	if (Object_IsAlive(name)):
		heal(name)
		Object_PlayEffect(name, 'effect_red_sun_glow')
		# TODO: whatever else we want to do to redsun here

def OnTruckDead(event):
	addAttr('trucks_dead', 1)
	if Mission_GetAttr('trucks_dead')>=3:
		Objective_Complete('trucks_destroyed')
		Mission_SetAttr('truck_objective_active', 1)
		play(trucks_destroyed_ss, 'trucks_destroyed_ss')
		
def OnTruckProx(event):
	print 'OnTruckProx'
	if not Mission_TestAttr('truck_objective_active'):
		play(destroy_trucks_ss, 'destroy_trucks_ss')
		Objective_Activate('trucks_destroyed')
		Mission_SetAttr('truck_objective_active', 1)
	
def OnRedSunDead(event):
	if Mission_TestAttr('red_sun_dead') == 0:
		if event.object == 'red_sun2':
			play(red_sun2_dead_ss, 'red_sun2_dead_ss')
			ReinforceRedsun(3)
		else:
			play(red_sun3_dead_ss, 'red_sun3_dead_ss')
			ReinforceRedsun(2)
		addAttr('red_sun_dead', 1)

def OnRedSunDetect(event):
	if Mission_TestAttr('red_sun_detect') == 0:
		play(red_sun_detect_ss, 'red_sun_detect_ss')
		Mission_SetAttr('red_sun_detect', 1)
		
def SetupTransferCS(where):
	if where == 1:
		teleport('black_jack', 'teleCS_BJ1_Pos1')
		teleport('tricolour', 'teleCS_TC1_Pos1')
		lookAtPos((-453,692,0), zoom = -229.4, heading = -162.1)
		move('black_jack', 'teleCS_BJ1_Pos2')
		move('tricolour', 'teleCS_TC1_Pos2')
	elif where == 2:
		teleport('black_jack', 'teleCS_BJ2_Pos1')
		teleport('tricolour', 'teleCS_TC2_Pos1')
		lookAtPos((699,886,0), zoom = -208.7, heading = -66.8)
		move('black_jack', 'teleCS_BJ2_Pos2')
		move('tricolour', 'teleCS_TC2_Pos2')
	else:
		print 'could not determine correct location for camera ' + `where`

def GetHeroSpawnMarker(where):
	if where == 1:
		return 'spawn_hero1'
	elif where == 2:
		return 'spawn_hero2'
	else:
		print 'error - unknown spawn location for hero ' + `where`
		return 'spawn_hero1'
	
def SpawnHero(where):
	heroes = Mission_GetSquadList()
	if len(heroes)>=3:
		hero = heroes[2]
	else:
		hero = 'minute_man' # for testing
	playEffectMarker('effect_portal_mentor_spawn', GetHeroSpawnMarker(where))
	Object_Spawn(hero, hero, GetHeroSpawnMarker(where))
	AI_MakeHeroAI(hero)
	playEffectMarker('effect_portal_mentor_close', GetHeroSpawnMarker(where), fn = 'onStepCB')
	
def SpawnBullet(where):
	if where == 1:
		playEffectMarker('effect_portal_mentor_spawn', 'spawn_bullet1')
		playEffectMarker('effect_portal_mentor_close', 'spawn_bullet1', fn = 'onStepCB')
		Object_Spawn('bullet', 'bullet', 'spawn_bullet1')
	elif where == 2:
		playEffectMarker('effect_portal_mentor_spawn', 'spawn_bullet2')
		playEffectMarker('effect_portal_mentor_close', 'spawn_bullet2', fn = 'onStepCB')
		Object_Spawn('bullet', 'bullet', 'spawn_bullet2')
	else:
		print 'error - unknown spawn location for bullet ' + `where`
	
def OnTowerProx(event):
	if Mission_TestAttr('towers_destroyed') == 0:
		play(tower1_prox_ss, 'tower1_prox_ss')
	else:
		play(tower2_prox_ss, 'tower2_prox_ss')
	
def OnTowerDestroyed(event):
	tower = event.object
	if tower == 'tower1':
		Mission_SetAttr('last_tower_destroyed', 1)
		removeArrow('tower1_arrow')
	elif tower == 'tower2':
		Mission_SetAttr('last_tower_destroyed', 2)
		removeArrow('tower2_arrow')
	else:
		print 'error - unknown tower ' + tower
	if Mission_TestAttr('towers_destroyed') == 0:
		play(first_transfer_cs, 'first_transfer_cs')
	else:
		play(final_cs, 'final_cs')
	addAttr('towers_destroyed', 1)
		
def WinMission():
	Objective_Complete('destroy_towers')
	Mission_Win()
	
start_cs = [
(
	"startCS()",
	"peace()",
	"RPG_SetActive(0)",
	"lookAtPos((-458,-882,79), zoom = -158.0, pitch = -15, heading = 106.1)",
	"speak('black_jack', 'MISSPCH_8_BJ_01', CAPTION_BOTTOM_LEFT)",
),
(
	"speak('tricolour', 'MISSPCH_8_TC_01', CAPTION_TOP_RIGHT)",
),
(
	"lookAtPos((-459,-925,79), zoom = -161.4, pitch = -20, heading =  50.9)",
	"Trigger_Power('nazi_thug', 'tricolour', 'nazi rifleman Mauser 98K', 'onStepCB', 1)",
),
(
    	"speak('tricolour', 'MISSPCH_8_TC_06', CAPTION_BOTTOM_RIGHT)",
	"Sound_PlayMusic('music_06redsun_cs1nazi',1)",
    	"AI_Animate('nazi_thug', 'melee_idle', '', 0, 0)",
	"kill('tricolour')",
),
(
	"speak('nazi_thug', 'MISSPCH_8_N1_01', CAPTION_TOP_LEFT)",
	"moveTo('black_jack', 'tricolour')",
),
(
	"lookAtPos((-357,-927,80), zoom = -162.8, pitch = -17, heading =  78.9)",
	"Sound_PlayMusic('music_06redsun_cs1meet',1)",
	"Trigger_Power('red_sun1', 'nazi_thug', 'red sun Katana of Fury', 'onStepCB', 1)",
),
(
	"speak('red_sun1', 'MISSPCH_8_RS_06', CAPTION_TOP_RIGHT)",
	"kill('nazi_thug')",
),
(
	"lookAtPos((-459,-925,79), zoom = -161.4, pitch = -20, heading =  50.9)",
	"speak('red_sun1', 'MISSPCH_8_RS_01', CAPTION_TOP_RIGHT)",
	"Sound_PlayMusic('music_06redsun_cs1beat',1)",
	"turnTo('red_sun1', 'black_jack')",
	"turnTo('black_jack', 'red_sun1')",
),
(
	"speak('black_jack', 'MISSPCH_8_BJ_02', CAPTION_BOTTOM_LEFT)",
	"AI_Animate('black_jack', 'melee_idle', '', 0, 1)",
	"AI_Animate('red_sun1', 'melee_idle', '', 0, 1)",
),
(
	"newObjective('primary', 1, 'interrogate_redsun')",
	"addArrow('red_sun1_arrow', 'red_sun1')",
	"RPG_SetActive(1)",
	"endCS()",
	"Sound_PlayMusic('music_06redsun_cs1fight')",
	"war()",
),
]

interrogate_red_sun1_cs = [
(
	"startCS()",
	"lookAtPos((-103,-855,80), zoom = -153.1, pitch = -10, heading = -92.1)",
	"teleport('black_jack', 'intCS_blackjack1')",
	"teleport('red_sun1', 'intCS_redsun1')",
	"removeArrow('red_sun1_arrow')",
	"Sound_PlayMusic('music_06redsun_cs1meet',1)",
	"peace()", #they still seem to stay angry at each other here for some reason?
	"null()",
),
(
	"speak('black_jack', 'MISSPCH_8_BJ_03', CAPTION_TOP_LEFT)",
	"AI_Animate('red_sun1', 'recover_from_stun', '', 0, 0)",
),
(
	"speak('red_sun1', 'MISSPCH_8_RS_02', CAPTION_TOP_RIGHT)",
),
(
	"kill('red_sun1')",
	"Sound_PlayMusic('music_06redsun_cs1beat',1)",
	"Objective_Complete('interrogate_redsun')",
	"revive('tricolour')",
	"teleport('tricolour', 'intCS_tricolour1')",
	"wait(1)",
),
(
	"lookAtPos((-88,-883,80), zoom = -167.4, pitch = -18, heading = -145.4)",
	"move('tricolour', 'intCS_tricolour2')",
	"speak('tricolour', 'MISSPCH_8_TC_07', CAPTION_TOP_LEFT)",
),
(
	"speak('black_jack', 'MISSPCH_8_BJ_15', CAPTION_TOP_RIGHT)",
	"turnTo('black_jack', 'tricolour')",
),
#(
#	"speak('black_jack', 'MISSPCH_8_BJ_16', CAPTION_TOP_RIGHT)",
#),
(
	"speak('tricolour', 'MISSPCH_8_TC_09', CAPTION_TOP_LEFT)",
),
#(
#	"speak('tricolour', 'MISSPCH_8_TC_10', CAPTION_TOP_LEFT)",
#),
(
	"lookAtPos((-128,-854,80), zoom = -129.7, pitch = 10, heading = -115.4)",
	"speak('mentor', 'MISSPCH_8_ME_10', CAPTION_TOP_RIGHT)",
),
(
	"speak('black_jack', 'MISSPCH_8_BJ_17', CAPTION_TOP_LEFT)",
	"turnTo('black_jack', 'red_sun1')",        
),
(
	"lookAtPos((-88,-883,80), zoom = -167.4, pitch = -18, heading = -145.4)",
	"speak('black_jack', 'MISSPCH_8_BJ_24', CAPTION_TOP_RIGHT)",
	"turnTo('black_jack', 'tricolour')",        
),
(
	"speak('tricolour', 'MISSPCH_8_TC_11', CAPTION_TOP_LEFT)",
),
(
	"speak('black_jack', 'MISSPCH_8_BJ_25', CAPTION_TOP_RIGHT)",
	"turnTo('black_jack', 'red_sun1')",        
),
(
	"lookAtPos((-128,-854,80), zoom = -129.7, pitch = 10, heading = -115.4)",
	"speak('mentor', 'MISSPCH_8_ME_11', CAPTION_TOP_RIGHT)",
	"Sound_PlayMusic('music_06redsun_cs1mentor',1)",
),
(
	"lookAtPos((-67,-880,80), zoom = -163.1, pitch = -15, heading = -51.0)",
	"playEffectMarker('effect_portal_mentor_open', 'intCS_portal', fn = 'onStepCB')",
),
(
	"playEffectMarker('effect_portal_mentor_close', 'intCS_portal', fn = 'onStepCB')",
),
(
	"lookAtPos((-128,-854,80), zoom = -129.7, pitch = 10, heading = -115.4)",
	"speak('mentor', 'MISSPCH_8_ME_12', CAPTION_TOP_RIGHT)",
),
(
	"speak('black_jack', 'MISSPCH_8_BJ_18', CAPTION_TOP_LEFT)",
),
(
	"ff.SetupTowers()",
	"speak('mentor', 'MISSPCH_8_ME_13', CAPTION_TOP_RIGHT)",
	"wait(4)",
),
(
	"lookAtPos((-588,556,0), zoom = -27.2, pitch = -5, heading = -118.6)",
	"wait(4)",
),
(
	"lookAtPos((686,989,0), zoom = -51.2, pitch = -5, heading =  -5.9)",
),
(
	"lookAtPos((-128,-854,80), zoom = -129.7, pitch = 10, heading = -115.4)",
	"speak('tricolour', 'MISSPCH_8_TC_12', CAPTION_BOTTOM_LEFT)",
),
(
	"lookAtPos((-88,-883,80), zoom = -167.4, pitch = -18, heading = -145.4)",
	"speak('black_jack', 'MISSPCH_8_BJ_27', CAPTION_TOP_RIGHT)",
	"turnTo('black_jack', 'tricolour')",        
),
(
#	"Camera_ForceAutoFade(1)",
	"Object_SetAttr('tricolour', 'heroPoints', Mission_GetAttr('tricolour_heroPoints'))",
	"war()",
	"Sound_PlayMusic('music_06redsun1')",
	"endCS()",
),
]

tower1_prox_ss = [
(
	"speak('mentor', 'MISSPCH_8_ME_05')",
),
(
	"blank",
),
]

tower2_prox_ss = [
(
	"speak('mentor', 'MISSPCH_8_ME_08')",
),
(
	"blank",
),
]

red_sun_detect_ss = [
(
	"forceSpeak('red_sun', 'MISSPCH_8_RS_03')",
),
(
	"speak('black_jack', 'MISSPCH_8_BJ_14')",
),
(
	"forceSpeak('red_sun', 'MISSPCH_8_RS_09')",
),
(
	"blank",
),
]

red_sun2_dead_ss = [
(
	"speak('red_sun3', 'MISSPCH_8_RS_05')",
),
(
	"speak('tricolour', 'MISSPCH_8_TC_13')",
),
(
	"blank",
),
]

red_sun3_dead_ss = [
(
	"speak('red_sun2', 'MISSPCH_8_RS_05')",
),
(
	"speak('tricolour', 'MISSPCH_8_TC_13')",
),
(
	"blank",
),
]

first_transfer_cs = [
(
	"startCS()",
	"peace()",
	"ff.SetupTransferCS(Mission_GetAttr('last_tower_destroyed'))",
	"Sound_PlayMusic('music_06redsun_cs2',1)",
	"speak('black_jack', 'MISSPCH_8_BJ_09', CAPTION_TOP_LEFT)",
),
(
	"speak('mentor', 'MISSPCH_8_ME_06', CAPTION_TOP_RIGHT)",
),
(
	"playEffectMarker('effect_portal_mentor_open', ff.GetHeroSpawnMarker(Mission_GetAttr('last_tower_destroyed')), fn = 'onStepCB')",
),
(
	"ff.SpawnHero(Mission_GetAttr('last_tower_destroyed'))",
),
(
	"endCS()",
	"Sound_PlayMusic('music_06redsun1')",
	"war()",
),
]

destroy_trucks_ss = [
(
	"speakList([('black_jack', 'MISSPCH_8_BJ_28'), ('tricolor', 'MISSPCH_8_TR_16'), ('mentor', 'MISSPCH_8_ME_17')])",
),
(
	"blank",
),
]

trucks_destroyed_ss = [
(
	"speakList([('black_jack', 'MISSPCH_8_BJ_29'), ('tricolor', 'MISSPCH_8_TR_17'), ('mentor', 'MISSPCH_8_ME_18')])",
),
(
	"blank",
),
]

final_cs = [
(
	"startCS()",
	"peace()",
	"reviveHeroes()",
	"kill('red_sun2')",
	"kill('red_sun3')",
    "null()",
),
(
	"ff.SetupTransferCS(Mission_GetAttr('last_tower_destroyed'))",
	"Sound_PlayMusic('music_06redsun_cs3beg',1)",
	"speak('mentor', 'MISSPCH_8_ME_09', CAPTION_TOP_RIGHT)",
),
(
	"speak('mentor', 'MISSPCH_8_ME_16', CAPTION_TOP_RIGHT)",
),
(
	"playEffectMarker('effect_portal_mentor_open', ff.GetHeroSpawnMarker(Mission_GetAttr('last_tower_destroyed')), orientation = 0, fn = 'onStepCB')",
),
(
	"ff.SpawnBullet(ff.Mission_TestAttr('last_tower_destroyed'))",
),
(
	"speak('bullet', 'MISSPCH_8_BL_01', CAPTION_TOP_RIGHT)",
        "turnTo('bullet', 'tricolour')",
),
(
	"speak('tricolour', 'MISSPCH_8_TC_14', CAPTION_BOTTOM_LEFT)",
	"Sound_PlayMusic('music_06redsun_cs3end',1)",
),
(
	"speak('bullet', 'MISSPCH_8_BL_04', CAPTION_TOP_RIGHT)",
),
(
	"speak('mentor', 'MISSPCH_8_ME_15', CAPTION_BOTTOM_RIGHT)",
),
(
	"speak('bullet', 'MISSPCH_8_BL_02', CAPTION_TOP_RIGHT)",
),
(
	"speak('tricolour', 'MISSPCH_8_TC_15', CAPTION_BOTTOM_LEFT)",
),
(
	"speak('black_jack', 'MISSPCH_8_BJ_19', CAPTION_TOP_LEFT)",
),
(
	"ff.WinMission()",
),
]
