# 06b_codebreak

from cshelper import *
from js import *
import event
from ffx import *

def OnPostInit():
	print "codebreak/start"
	setMission(9)

	Mission_SetSunlight(-140,60,1.2,1.0,(0.3,0.2,0.9))
	Mission_SetShadows(-140,60,(0.1,0.1,0.6))
	Mission_SetProjShadowBackground((1,1,1))
	Mission_SetProjShadowColor((.5,.5,.7,1))

	Object_Spawn('bullet', 'bullet', 'bullet_spawn')
	
	regDeath('_impobj_bunker', 'OnCryptoDestroyed')
	addArrow('arrow_bunker', '_impobj_bunker', delete = 1)
	
	# redsuns
	regDeath('red_sun1', 'OnRedsunDead')
	regDeath('red_sun2', 'OnRedsunDead')
	regDeath('red_sun3', 'OnRedsunDead')
	Mission_SetAttr('redsuns_alive', 3)
	regDetectHero('red_sun1', 'OnRedsunDetect')
	regDetectHero('red_sun2', 'OnRedsunDetect')
	regDetectHero('red_sun3', 'OnRedsunDetect')
#	regMarkerLeave('red_sun1', 'guard1', 'ReturnToGuard', user = 1, persistent = 1)
#	regMarkerLeave('red_sun2', 'guard2', 'ReturnToGuard', user = 2, persistent = 1)
#	regMarkerLeave('red_sun3', 'guard3', 'ReturnToGuard', user = 3, persistent = 1)

	# tank
	regProximityEnter('tank2', 'GAME_OBJ_HERO', 30, 'OnSightTank')
	AI_SetEnabled('tank2', 0)

	# general
#	makeInterrogationCS('nazi_general')
	
	play(start_cs, 'start_cs')
	FFX_InitMission()

def ReturnToGuard(event):
	redsun = event.object
	marker = event.string
	if Mission_TestAttr('redsun_retreat'):
		play(redsun_retreat_ss, 'redsun_retreat_ss')
	else:
		play(redsun_retreat_first_ss, 'redsun_retreat_first_ss')
		Mission_SetAttr('redsun_retreat', 1)
	AI_IssueMove(redsun, marker, "MoveForward", 0, AIM_SPEED_RUN, 0, event.user)
	clearGoals(redsun)
	AI_ClearTargets(redsun)
	AI_SetAlerted(redsun, 0)

def MoveForward(event):
	redsun = event.object
	marker = "guard" + `int(event.user)` + "1"
	AI_IssueMove(redsun, marker)

def ReinforceRedsun(index):
	name = 'red_sun' + `index`
	if (Object_IsAlive(name)):
		heal(name)
		Object_PlayEffect(name, 'effect_red_sun_glow')
		# TODO: whatever else we want to do to redsun here

def OnRedsunDetect(event):
	if Mission_TestAttr('redsun_detected') == 0:
		play(redsun_detects_ss, 'redsun_detects_ss')
		Mission_SetAttr('redsun_detected', 1)
		
def OnRedsunDead(event):
	remaining = int(Mission_GetAttr('redsuns_alive'))
	if (remaining<=0):
		print 'huh? too many redsuns killed'
		return
	remaining = remaining - 1
	Mission_SetAttr('redsuns_alive', remaining)
	
	# if script is killing them, ignore rest of fn
	if Mission_TestAttr('killing_redsuns'):
		return
	
	if (remaining == 2):
		play(redsun_first_dead_ss, 'redsun_first_dead_ss')
	elif (remaining == 1):
		play(redsun_second_dead_ss, 'redsun_second_dead_ss')
	else:
		play(redsun_third_dead_ss, 'redsun_third_dead_ss')
	redsun = event.object
	for i in range(1, 4):
		ReinforceRedsun(i)

def KillRedsuns1():
	if Mission_GetAttr('redsuns_alive') == 0:
		null()
		return
	for redsun in ['red_sun1', 'red_sun2', 'red_sun3']:
		if Object_IsAlive(redsun):
			look(redsun, zoom = -180)
			break
	forceSpeak('red_sun', 'MISSPCH_9_RS_10')

def KillRedsuns2():
	Mission_SetAttr('killing_redsuns', 1)
	for redsun in ['red_sun1', 'red_sun2', 'red_sun3']:
		if Object_IsAlive(redsun):
			kill(redsun)
	
def OnSightTank(event):
	play(detect_tank_ss, 'detect_tank_ss')
	newObjective('secondary', 1, 'tank')
	addArrow('arrow_tank', 'tank2', js.ARROW_YELLOW, delete = 1)
	addCustomCommand('enter', 'tank2', 'OnEnterTank', oneshot = 1, radius = 8)

def OnEnterTank(tank, hero):
	StartTank(hero)
	if not Objective_IsComplete('tank'):
		Objective_Complete('tank')
#	if Mission_TestAttr('hasKey'):
#		StartTank(hero)
#	else:
#		newObjective('secondary', 2, 'key')
#		addArrow('arrow_key', 'nazi_general', js.ARROW_YELLOW)
	

# get into the tank
def StartTank(hero):
	if hero == 'black_jack':
		heroNumber = 1
	elif hero == 'tricolour':
		heroNumber = 2
	elif hero == 'bullet':
		heroNumber = 3
	else:
		heroNumber = 4
	Object_SetAttr('tank2', 'heroNumber', heroNumber)
	Object_Destroy(hero)
	removeAttention('tank2')
#	Mission_RemoveCustomAction('enter', '', 'tank2')
	Event_RegisterSink(EVENT_TIMER, 'StartTank2', 'tank2', '', 0.01, 0, 0)

def StartTank2(event):
	tank = event.object
	AI_MakeIntoHero(tank)
	Object_SetAttr('tank2', 'minHealth', 1)
	Event_RegisterSink(EVENT_OBJ_HEALTHCHANGED, 'OnTankDead', 'tank2', '', 1, 0, 0)
	addCustomCommand('exit', 'tank2', 'OnExitTank', oneshot = 1, hero = tank, attentionMarker = 0)

def OnExitTank(tank, tank):
	AI_DestroyHeroAI(tank)
	heroTemplate = GetHeroInTank('tank2')
	heroNumber = Object_GetAttr(tank, 'heroNumber')
	if heroNumber == 2:
		spawn('hero_2', heroTemplate, Get_ObjectPos('tank2'))
	else:
		spawn(heroTemplate, heroTemplate, Get_ObjectPos('tank2'))
	addCustomCommand('enter', 'tank2', 'OnEnterTank', oneshot = 1, radius = 8)
	Object_SetAttr('tank2', 'minHealth', 0)

def GetHeroInTank(tank):
	heroNumber = Object_GetAttr(tank, 'heroNumber')
	if heroNumber == 1:
		heroTemplate = 'black_jack'
	elif heroNumber == 2:
		heroTemplate = 'tricolour'
	elif heroNumber == 3:
		heroTemplate = 'bullet'
	elif heroNumber == 4:
		heroTemplate = Mission_GetSquadList()[2]
	return heroTemplate

# spawn the hero when the tank dies
def OnTankDead(event):
	heroTemplate = GetHeroInTank('tank2')
	Object_SetAttr('tank2', 'minHealth', 0)
	if not Marker_Exists('marker_hero_spawn'):
		Marker_Spawn('marker_hero_spawn', Get_ObjectPos('tank2'))
#	else:
		# need to move the marker here
	Event_RegisterSink(EVENT_TIMER, 'SpawnHero', '', heroTemplate, 1, 0, 0)
	kill('tank2')

def SpawnHero(event):
	objectTemplate = event.string
	Object_Spawn(objectTemplate, objectTemplate, 'marker_hero_spawn')

def OnCryptoDestroyed(event):
	Objective_Complete('destroy')
	play(crypto_destroyed_cs, 'crypto_destroyed_cs')
	
def SpawnTanks():
	Object_Spawn('tank3', 'tank_ger', 'tank_spawn1')
	regDeath('tank3', 'OnTankKilled')
	addArrow('arrow_tank3', 'tank3', delete = 1)
	Object_Spawn('tank4', 'tank_ger', 'tank_spawn2')
	regDeath('tank4', 'OnTankKilled')
	addArrow('arrow_tank4', 'tank4', delete = 1)

def OnTankKilled(event):
	addAttr('tanks_killed', 1)
	if Mission_GetAttr('tanks_killed') >= 2:
		play(end_cs, 'end_cs')
	
def OnMissionWon():
	print "codebreak/won"

start_cs = [
(
	"startCS()",
	"peace()",
	"lookAtPos((-8,-735,0), zoom = -228.9, heading = -50.3)",
	"Sound_PlayMusic('music_02cuba_end')",
	"speak('tricolour', 'MISSPCH_9_TC_06')",
),
(
	"lookAtPos((-22,-742,0), zoom = -229.1, heading = -138.2)",
	"speak('black_jack', 'MISSPCH_9_BJ_16')",
),
(
	"newObjective('primary', 1, 'destroy')",
	"war()",
	"endCS()",
	"Sound_PlayMusic('music_06code1')",
	"AI_SetEnabled('tank2', 0)",
),
]

detect_tank_ss = [
(
	"speak('black_jack', 'MISSPCH_9_BJ_17')",
),
(
	"speak('mentor', 'MISSPCH_9_ME_10')",
),
(
	"blank",
),
]

redsun_detects_ss = [
(
	"forceSpeak('red_sun', 'MISSPCH_9_RS_06')",
),
(
	"blank",
),
]

redsun_first_dead_ss = [
(
	"forceSpeak('red_sun', 'MISSPCH_9_RS_07')",
),
(
	"blank",
),
]

redsun_second_dead_ss = [
(
	"forceSpeak('red_sun', 'MISSPCH_9_RS_08')",
),
(
	"blank",
),
]

redsun_third_dead_ss = [
(
	"forceSpeak('red_sun', 'MISSPCH_9_RS_09')",
),
(
	"blank",
),
]

redsun_retreat_first_ss = [
(
	"forceSpeak('red_sun', 'MISSPCH_9_RS_10')",
),
(
	"speakList([('bullet', 'MISSPCH_9_BL_04'), ('black_jack', 'MISSPCH_9_BJ_28')])",
),
(
	"speak('mentor', 'MISSPCH_9_ME_17')",
),
(
	"blank",
),
]

redsun_retreat_ss = [
(
	"forceSpeak('red_sun', 'MISSPCH_9_RS_10')",
),
(
	"blank",
),
]

interrogate_nazi_general_cs = [
(
	"speak('black_jack', 'MISSPCH_9_BJ_23')",
),
(
	"speak('nazi_general', 'MISSPCH_9_NG_01')",
),
(
	"kill('nazi_general')",
	"Mission_SetAttr('hasKey', 1)",
),
]

crypto_destroyed_cs = [
(
	"startCS()",
	"peace()",
	"see()",
	"lookAtPos((7,319,0), zoom = -159.9, heading =  -1.5)",
	"teleport('black_jack', 'midcs_hero1')",
	"teleport('tricolour', 'midcs_hero2')",
	"teleport('bullet', 'midcs_hero3')",
	"teleport('hero_3', 'midcs_hero4')",
	"Sound_PlayMusic('music_06redsun_cs1nazi',1)",
	"wait(0.5)",
),
(
	"speakList([('black_jack', 'MISSPCH_9_BJ_34'), ('mentor', 'MISSPCH_9_ME_20')])",
),
(
	"ff.KillRedsuns1()",
),
(
	"ff.KillRedsuns2()",
	"wait(2)",
),
(
	"lookAtPos((15,76,0), zoom = -215.5, pitch = 0, heading = 113.5)",
	"speakList([('black_jack', 'MISSPCH_9_BJ_22'), ('mentor', 'MISSPCH_9_ME_13')])",
),
(
	"lookAtPos((-366,491,0), zoom = -32.9, heading = -80.2)",
	"ff.SpawnTanks()",
	"null()",
),
(
	"moveCB('tank3', 'tank1_pos2')",
),
(
	"lookAtPos((399,497,0), zoom = -34.4, heading = -12.3)",
	"speakList([('black_jack', 'MISSPCH_9_BJ_28'), ('mentor', 'MISSPCH_9_ME_17')])",
	"move('tank4', 'tank2_pos2')",
	"Sound_PlayMusic('music_05fort_tank')",
),
(
	"newObjective('primary', 2, 'tanks')",
	"blind()",
	"war()",
	"AI_SetEnabled('tank2', 0)",
	"endCS()",
),
]

end_cs = [
(
	"startCS()",
	"kill('tank2', force = 0)",
	"peace()",
	"RPG_SetActive(0)",
	"wait(2)",
),
(
	"Sound_PlayMusic('music_06code_end1',1)",
	"reviveHeroes()",
	"normalizeHeroes()",
	"destroyAllByTemplate('tank_damaged')",
	"destroyAllByTemplate('nazi_rifleman')",
	"destroyAllByTemplate('nazi_gunner')",
	"destroyAllByTemplate('nazi_grenadier')",
	"null()",
),
(
	"teleport('tricolour', 'hero1_pos0')",
	"teleport('black_jack', 'hero2_pos0')",
	"teleport('bullet', 'hero3_pos0')",
	"teleport('hero_3', 'hero4_pos0')",
	"null()",
),
(
	"lookAtPos((-419,418,0), zoom = -184.8, heading = -28.3)",
	"move('tricolour', 'hero1_pos1')",
	"moveCB('black_jack', 'hero2_pos1')",
	"move('bullet', 'hero3_pos1')",
	"move('hero_3', 'hero4_pos1')",
),
(
	"speak('bullet', 'MISSPCH_9_BL_02')",
),
(
	"speak('tricolour', 'MISSPCH_9_TC_07')",
),
(
	"lookAtPos((-394,391,0), zoom = -105.5, heading =  74.8)",
	"speak('bullet', 'MISSPCH_9_BL_04')",
	"move('tricolour', 'hero_exit')", # bj & tricolor should walk off here 
	"move('black_jack', 'hero_exit')",
),
(
	"lookAtPos((-394,391,0), zoom = -128.6, heading = -11.2)",
	"speakList([('minute_man', 'MISSPCH_9_MM_01'), ('alchemiss', 'MISSPCH_9_AL_01'), ('el_diablo', 'MISSPCH_9_ED_01'), ('the_ant', 'MISSPCH_9_AN_01'), ('liberty_lad', 'MISSPCH_9_LL_01'), ('green_genie', 'MISSPCH_9_GG_01'), ('quetzalcoatl', 'MISSPCH_9_QZ_01'), ('supercollider', 'MISSPCH_9_SC_01'), ('tombstone', 'MISSPCH_9_TS_01'), ('law', 'MISSPCH_9_LW_01')], optional = 1)",
),
(
	"Object_PlayEffect('bullet', 'effect_portal_mentor_open', 'onStepCB')",
	"playEffectMarker('effect_portal_mentor_open', 'hero4_pos1')",
),
(
	"Object_Destroy('hero_3')",
	"Object_PlayEffect('bullet', 'effect_portal_mentor_close')", # a failed teleport attempt takes place
	"playEffectMarker('effect_portal_mentor_close', 'hero4_pos1')",
	"playEffectMarker('effect_portal_mentor_spawn', 'hero4_pos1', fn = 'onStepCB')",
),
(
	"speak('bullet', 'MISSPCH_9_BL_03')",
	"spawn('truck1', 'nazi_truck', 'truck_pos1')",
),
(
	"lookAtPos((-359,414,0), zoom = -84.2, pitch = -10, heading = 106.8)",
	"AI_Animate('truck1', 'drive_in', 'onStepCB', 0, 1)",
	"Sound_PlayMusic('music_06code_end2',1)",
),
(
	"spawn('blitzkrieg', 'blitzkrieg', 'bk_pos1')", # blitzkrieg and nazis appear and KO bullet
	"spawn('nazi_1', 'nazi_rifleman', 'nazi1_pos1')",
	"spawn('nazi_2', 'nazi_gunner', 'nazi2_pos1')",
	"spawn('nazi_3', 'nazi_rifleman', 'nazi3_pos1')",
	"makePeaceful('blitzkrieg')",
	"makePeaceful('nazi_1')",
	"makePeaceful('nazi_2')",
	"makePeaceful('nazi_3')",
	"null()",
),
(
	"move('nazi_1', 'nazi_intPos1')",
	"move('nazi_2', 'nazi_intPos2')",
	"moveCB('nazi_3', 'nazi_intPos3')",
),
(
	"move('blitzkrieg', 'bk_pos2')",
	"move('nazi_1', 'nazi1_pos2')",
	"move('nazi_2', 'nazi2_pos2')",
	"moveCB('nazi_3', 'nazi3_pos2')",
),
(
	"turnTo('blitzkrieg', 'bullet')",
	"turnTo('nazi_1', 'bullet')",
	"turnTo('nazi_2', 'bullet')",
	"turnTo('nazi_3', 'bullet')",
	"wait(0.5)",
),
(
	"Trigger_Power('blitzkrieg', 'bullet', 'blitzkrieg Hypnotic Glare', 'onStepCB')",
),
(
	"speak('blitzkrieg', 'MISSPCH_9_BZ_01', CAPTION_TOP_RIGHT)",
	"AI_Animate('bullet', 'fall', '', 0, 1)",
	"AI_Animate('nazi_1', 'melee_idle', '', 0, 1)",
	"AI_Animate('nazi_2', 'melee_idle', '', 0, 1)",
	"AI_Animate('nazi_3', 'melee_idle', '', 0, 1)",
),
(
	"Mission_Play2DCutscene('transition_mission_nif', 'transition_mission_wav', 'onStepCB')",
	"Object_Destroy('bullet')",
	"Object_Destroy('blitzkrieg')",
	"Object_Destroy('nazi_1')",
	"Object_Destroy('nazi_2')",
	"Object_Destroy('nazi_3')",
	"Object_Destroy('truck1')",
),
(
	"Sound_PlaySound('mission_codebreak')",
	"move('tricolour', 'hero1_pos1')",
	"moveCB('black_jack', 'hero3_pos1')",
),
(
	"lookAtPos((-419,418,0), zoom = -184.8, heading = -28.3)",
	"speak('black_jack', 'MISSPCH_9_BJ_18', CAPTION_TOP_LEFT)",
),
(
	"Sound_PlayMusic('music_06code_end3',1)",
	"speak('tricolour', 'MISSPCH_9_TC_08', CAPTION_TOP_RIGHT)",
),
(
	"speak('black_jack', 'MISSPCH_9_BJ_30', CAPTION_TOP_LEFT)",
	"Objective_Complete('tanks')",
),
(
	"endCS()",
	"Mission_Win()",
),
]
