# skyking

# To Do:


# - add "random hero" lines to scenes


from cshelper import *
from js import *
import event
from ffx import *

def OnPrecacheObjects():
	print "skyking/precache"
	Mission_PrecacheTemplateObj('el_diablo', 1, 1)
	Mission_PrecacheTemplateObj('tank_ger', 0, 1)
	Mission_PrecacheTemplateObj('eye_minor', 1, 0)

def OnPostInit():
	print "skyking/start"
	setMission(12)

	Mission_SetSunlight(-140,60,1.2,1.0,(0.3,0.2,0.9))
	Mission_SetShadows(-140,60,(0.1,0.1,0.6))
	Mission_SetProjShadowBackground((1,1,1))
	Mission_SetProjShadowColor((.5,.5,.7,1))


	Mission_CustomAction('Adjust_Suit', 'sky_king', 'sky_king', 'OnStartSuitFiddling', 1, 0)
	Mission_SetAttr('testhandle', 0)
	Mission_SetAttr('effect_playing', 0)

	Mission_SetAttr('finished_cycles', 0)
	Mission_SetAttr('number_of_enemies', 3)
	Mission_SetAttr('started_fiddle_cycle', 0)

	Mission_SetAttr('wave_barks_played', 0)	

	Mission_SetAttr('waveA', 1)
	Mission_SetAttr('waveB', 1)

	Mission_SetAttr('mission_over', 0)

	regDeaths('nazi_rifleman', 'OnEnemyDied')
	regDeaths('killarilla_whip', 'OnEnemyDied')
	regDeath('sky_king', 'OnSkyKingDead')

	spawn('ed_standin','fx_standin','el_diablo_spawn_marker')
	spawn('hero_1_standin', 'fx_standin', 'hero_1')
	spawn('hero_2_standin', 'fx_standin', 'hero_2')
	spawn('hero_3_standin', 'fx_standin', 'hero_3')
	spawn('hero_4_standin', 'fx_standin', 'hero_4')

	play(start_cs,'start_cs')
	FFX_InitMission()




def OnMissionWon():
	print "skyking/won"
	
def OnMissionLost():
	print "skyking/lost"

def OnSkyKingDead(event):
	play(sky_king_dead_cs, "sky_king_dead_cs")
#	Mission_Lose()
#	Objective_Fail('protect_sky_king')

def OnStartSuitFiddling(object, heroname):
	print "fiddling!"
	AI_Animate('sky_king', 'fix_suit', 'OnFiddleFinish', 0, 0)
	if Mission_GetAttr('effect_playing') == 0:
		handle = Object_PlayEffect('sky_king', 'effect_skyking_adjustsuit', '', FX_LOOP)
		Mission_SetAttr('testhandle', handle)
		Mission_SetAttr('effect_playing', 1)
	Mission_SetAttr('started_fiddle_cycle', 1)

def SkykingIdle(event):
	if Mission_GetAttr('mission_over') == 0:
		if Mission_GetAttr('started_fiddle_cycle') == 0:
			play(get_to_work_ss, "get_to_work_ss")
			regTimer('SkykingIdle', 45)

def OnFiddleFinish(event):
	print "animation cycle ended"
	status = int(event.data)
	if not status: 
		# fiddling animation was interrupted
		OnFiddleInterrupted()
	else:
		print "cycle complete!"
		addAttr('finished_cycles', 1)
		print Mission_GetAttr('finished_cycles')
		if Mission_GetAttr('finished_cycles') == 6:
			play(one_eighth_done_ss, "one_eighth_done_ss")
		if Mission_GetAttr('finished_cycles') == 12:
			play(two_eighths_done_ss, "two_eighths_done_ss")
		if Mission_GetAttr('finished_cycles') == 18:
			play(three_eighths_done_ss, "three_eighths_done_ss")
		if Mission_GetAttr('finished_cycles') == 24:
			Mission_SetAttr('mission_over', 1)
			play(final_cs, "final_cs")
		OnStartSuitFiddling('sky_king', 'sky_king')

def OnFiddleInterrupted():
	regTimer('SkykingIdle', 20)
	Mission_SetAttr('started_fiddle_cycle', 0)
	Object_StopEffect('sky_king', int(Mission_GetAttr('testhandle')))
	Mission_SetAttr('effect_playing', 0)
	play(interrupted_ss, "interrupted_ss")


def ZeroWaveMoves():
	addMoveGoal('nazi_rifleman1', 'zero_wave_marker', fn = '', radius = 5, priority = ai.goal.PRI_ZERO-1)
	addMoveGoal('nazi_rifleman2', 'zero_wave_marker', fn = '', radius = 5, priority = ai.goal.PRI_ZERO-1)
	addMoveGoal('killarilla_whip1', 'zero_wave_marker', fn = '', radius = 5, priority = ai.goal.PRI_ZERO-1)
#	addKillAllGoal('nazi_rifleman1', OC_CONTROLLABLE, priority = ai.goal.PRI_MED)
#	addKillAllGoal('nazi_rifleman2', OC_CONTROLLABLE, priority = ai.goal.PRI_MED)
#	addKillAllGoal('killarilla_whip1', OC_CONTROLLABLE, priority = ai.goal.PRI_MED)
	regTimer('ZeroWaveBark', 5)
	if RPG_GAME_DIFFICULTY < 3:
		regTimer('EnemyWaveSpawnA', 80)
		regTimer('EnemyWaveSpawnB', 160)
	elif RPG_GAME_DIFFICULTY < 6:
		regTimer('EnemyWaveSpawnA', 60)
		regTimer('EnemyWaveSpawnB', 120)
	else:
		regTimer('EnemyWaveSpawnA', 40)
		regTimer('EnemyWaveSpawnB', 80)
	regTimer('SkykingIdle', 20)
	GoGetKing(event)


# This looping function constantly looks for all bad guys, and sends them to attack Sky King
def GoGetKing(event):
	print "giving all bad guys their orders!"
	baddielist = getAllBaddies(checkLiving=1)
	tempvar = 0
	for baddie in baddielist:
		addMoveGoal(baddie, 'sky_king', fn = '', radius = 5, priority = ai.goal.PRI_ZERO-1)
#		addKillAllGoal(baddie, OC_CONTROLLABLE, priority = ai.goal.PRI_MED)
	regTimer('GoGetKing', 5)

def ZeroWaveBark(event):
	if Mission_GetAttr('mission_over') == 0:
		play(zero_wave_bark_ss, "zero_wave_bark_ss")

def OnEnemyDied(event):
	addAttr('number_of_enemies', -1)
	print "Enemy has died. Number of enemies now: "
	print Mission_GetAttr('number_of_enemies')

def EnemyWaveSpawnA(event):
	if Mission_GetAttr('mission_over') == 0:
		print "Spawning Wave A"
		wave = int(Mission_GetAttr('waveA'))

		if RPG_GAME_DIFFICULTY < 3:
			regTimer('EnemyWaveSpawnA', 160)
		elif RPG_GAME_DIFFICULTY < 6:
			regTimer('EnemyWaveSpawnA', 120)
		else:
			regTimer('EnemyWaveSpawnA', 80)

		addAttr('waveA', 1)

		if Mission_GetAttr('number_of_enemies') < 6:
			if Mission_GetAttr('wave_barks_played') == 0:
				play(wave_a_bark_ss, "wave_a_bark_ss")
			if Mission_GetAttr('wave_barks_played') == 1:
				play(wave_b_bark_ss, "wave_b_bark_ss")
			if Mission_GetAttr('wave_barks_played') == 2:
				play(wave_c_bark_ss, "wave_c_bark_ss")
			if Mission_GetAttr('wave_barks_played') > 2:
				play(wave_d_bark_ss, "wave_d_bark_ss")
			addAttr('wave_barks_played', 1)

		if Mission_GetAttr('number_of_enemies') < 4:
			spawnGroup('an', 'nazi_rifleman', 2, wave)
			spawnGroup('ak', 'killarilla_whip', 1, wave)
			addAttr('number_of_enemies', 3)
			print "3 Enemies spawned. Number of enemies now: "
			print Mission_GetAttr('number_of_enemies')

		elif Mission_GetAttr('number_of_enemies') == 4:
			spawnGroup('an', 'nazi_rifleman', 1, wave)
			spawnGroup('ak', 'killarilla_whip', 1, wave)
			addAttr('number_of_enemies', 2)
			print "2 Enemies spawned. Number of enemies now: "
			print Mission_GetAttr('number_of_enemies')

		elif Mission_GetAttr('number_of_enemies') == 5:
			spawnGroup('ak', 'killarilla_whip', 1, wave)
			addAttr('number_of_enemies', 1)
			print "1 Enemy spawned. Number of enemies now: "
			print Mission_GetAttr('number_of_enemies')



def EnemyWaveSpawnB(event):
	if Mission_GetAttr('mission_over') == 0:
		print "Spawning Wave B"
		wave = int(Mission_GetAttr('waveB'))

		if RPG_GAME_DIFFICULTY < 3:
			regTimer('EnemyWaveSpawnB', 160)
		elif RPG_GAME_DIFFICULTY < 6:
			regTimer('EnemyWaveSpawnB', 120)
		else:
			regTimer('EnemyWaveSpawnB', 80)

		addAttr('waveB', 1)

		if Mission_GetAttr('number_of_enemies') < 6:
			if Mission_GetAttr('wave_barks_played') == 0:
				play(wave_a_bark_ss, "wave_a_bark_ss")
			if Mission_GetAttr('wave_barks_played') == 1:
				play(wave_b_bark_ss, "wave_b_bark_ss")
			if Mission_GetAttr('wave_barks_played') == 2:
				play(wave_c_bark_ss, "wave_c_bark_ss")
			if Mission_GetAttr('wave_barks_played') > 2:
				play(wave_d_bark_ss, "wave_d_bark_ss")
			addAttr('wave_barks_played', 1)

		if Mission_GetAttr('number_of_enemies') < 4:
			spawnGroup('bn', 'nazi_rifleman', 1, wave)
			spawnGroup('bk', 'killarilla_whip', 2, wave)
			addAttr('number_of_enemies', 3)
			print "3 enemies spawned. Number of enemies now: "
			print Mission_GetAttr('number_of_enemies')

		elif Mission_GetAttr('number_of_enemies') == 4:
			spawnGroup('bn', 'nazi_rifleman', 1, wave)
			spawnGroup('bk', 'killarilla_whip', 1, wave)
			addAttr('number_of_enemies', 2)
			print "2 enemies spawned. Number of enemies now: "
			print Mission_GetAttr('number_of_enemies')

		elif Mission_GetAttr('number_of_enemies') == 5:
			spawnGroup('bk', 'killarilla_whip', 1, wave)
			addAttr('number_of_enemies', 1)
			print "1 Enemy spawned. Number of enemies now: "
			print Mission_GetAttr('number_of_enemies')




def YikesTank():
	print "YikesTank getting called"
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'black_jack':
		speak('black_jack', 'MISSPCH_12_BJ_03')
	elif a_hero == 'tricolour':
		speak('tricolour', 'MISSPCH_12_TC_02')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_12_ED_02')
	else:
		print "Custom character?"
		null()


def UhOh():
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'black_jack':
		speak('black_jack', 'MISSPCH_12_BJ_06')
	elif a_hero == 'tricolour':
		speak('tricolour', 'MISSPCH_12_TC_03')
	elif a_hero == 'el_diablo':
		speak('el_diablo', 'MISSPCH_12_ED_07')
	else:
		print "Custom character?"
		null()


########################



start_cs = [
(
	"peace()",
	"startCS()",
	"look('central_marker', zoom = -100, heading = 0, time = 0)",
	"Object_PlayEffect('_impobj_wall_gate', 'effect_blitz_shield', '', FX_LOOP)",
	"Sound_PlayMusic('music_08skyking_cs1',1)",
	"wait(1)",
),
(
	"speak('black_jack', 'MISSPCH_12_BJ_01')",
),
(
	"speak('minute_man', 'MISSPCH_12_MM_03')",
),
(
	"look('barrier_marker', zoom = 0, heading = 0, time = 1)",
	"speak('black_jack', 'MISSPCH_12_BJ_05')",
),
(
	"speak('minute_man', 'MISSPCH_12_MM_01')",
),
(
	"look('central_marker', zoom = 0, heading = 0, time = 1)",
	"speak('sky_king', 'MISSPCH_12_SY_01')",
),
(
	"speak('mentor', 'MISSPCH_12_ME_06')",
),
(
	"speak('minute_man', 'MISSPCH_12_MM_04')",
),
(
	"speak('mentor', 'MISSPCH_12_ME_07')",
),
(
	"speak('sky_king', 'MISSPCH_12_SY_13')",
),
(
	"speak('mentor', 'MISSPCH_12_ME_08')",
),
(
	"speak('minute_man', 'MISSPCH_12_MM_05')",
),
(
	"speak('mentor', 'MISSPCH_12_ME_09')",
),
(
	"speak('alchemiss', 'MISSPCH_12_AL_01')",
),
(
	"speak('mentor', 'MISSPCH_12_ME_10')",
),
(
	"speak('alchemiss', 'MISSPCH_12_AL_02')",
),
(
	"speak('mentor', 'MISSPCH_12_ME_11')",
),
(
	"speak('minute_man', 'MISSPCH_12_MM_06')",
),
(
	"speak('sky_king', 'MISSPCH_12_SY_14')",
),
(
	"speak('minute_man', 'MISSPCH_12_MM_07')",
),
(
	"speak('el_diablo', 'MISSPCH_12_ED_05')",
),
(
	"Object_PlayEffect('hero_1_standin', 'effect_portal_mentor_spawn', '',FX_TRACK_OBJECT_ROT)",
	"Object_PlayEffect('hero_2_standin', 'effect_portal_mentor_spawn', '',FX_TRACK_OBJECT_ROT)",
	"Object_PlayEffect('hero_3_standin', 'effect_portal_mentor_spawn', '',FX_TRACK_OBJECT_ROT)",
	"Object_PlayEffect('hero_4_standin', 'effect_portal_mentor_spawn', '',FX_TRACK_OBJECT_ROT)",
	"Object_Destroy('hero_1')",
	"Object_Destroy('hero_2')",
	"Object_Destroy('hero_3')",
	"Object_Destroy('hero_4')",
	"wait(2.0)",
),
(
	"Object_PlayEffect('ed_standin', 'effect_portal_mentor_spawn', '',FX_TRACK_OBJECT_ROT)",
	"Object_Spawn('el_diablo','el_diablo','el_diablo_spawn_marker')",
	"AI_MakeHeroAI('el_diablo')",
	"wait(1)",
),
(
	"speak('el_diablo', 'MISSPCH_12_ED_04')",
),
(
	"speak('tricolour', 'MISSPCH_12_TC_01')",
),
(
	"speak('sky_king', 'MISSPCH_12_SY_03')",
),
(
	"speak('sky_king', 'MISSPCH_12_SY_15')",
),
(
	"forceSpeak('nazi_rifleman', 'MISSPCH_12_N1_01', telepathy=0)",
	"Sound_PlayMusic('music_06redsun_cs1nazi',1)",
),
(
	"speak('sky_king', 'MISSPCH_12_SY_16')",
),
(
	"endCS()",
	"war()",
	"Sound_PlayMusic('music_08skyking1')",
	"newObjective('primary', 1, name='protect_sky_king')",
	"ff.ZeroWaveMoves()",
),
]

zero_wave_bark_ss = [
(
	"forceSpeak('nazi_rifleman', 'MISSPCH_12_N2_01', telepathy=0)",
),
(
	"speak('sky_king', 'MISSPCH_12_SY_17')",
),
(
	"blank",
),
]


wave_a_bark_ss = [
(
	"forceSpeak('nazi_rifleman', 'MISSPCH_12_N1_02', telepathy=0)",
),
(
	"blank",
),
]

wave_b_bark_ss = [
(
	"speak('sky_king', 'MISSPCH_12_SY_10')",
),
(
	"blank",
),
]

wave_c_bark_ss = [
(
	"speak('sky_king', 'MISSPCH_12_SY_11')",
),
(
	"blank",
),
]

wave_d_bark_ss = [
(
	"forceSpeak('nazi_rifleman', 'MISSPCH_12_N2_02', telepathy=0)",
),
(
	"blank",
),
]

interrupted_ss = [
(
	"speak('sky_king', 'MISSPCH_12_SY_04')",
),
(
	"blank",
),
]

one_eighth_done_ss = [
(
	"speak('sky_king', 'MISSPCH_12_SY_05')",
),
(
	"blank",
),
]

two_eighths_done_ss = [
(
	"spawn('tank', 'tank_ger', 'tank_spawn_marker')",
	"addMoveGoal('tank', 'sky_king', fn = '', radius = 5, priority = ai.goal.PRI_LOW)",
	"addKillAllGoal('tank', OC_CONTROLLABLE, priority = ai.goal.PRI_MED)",
	"speak('sky_king', 'MISSPCH_12_SY_06')",
),
(
	"ff.YikesTank()",
),
(
	"blank",
),
]

three_eighths_done_ss = [
(
	"speak('sky_king', 'MISSPCH_12_SY_07')",
),
(
	"blank",
),
]

final_cs = [
(
	"peace()",
	"see()",
	"startCS()",
	"Sound_PlayMusic('music_04winter_hit1',1)",
	"wait(1.0)",
),
(
	"look('sky_king', zoom = 0, heading = 0, time = 2)",
	"wait(1.0)",
),
(
	"speak('sky_king', 'MISSPCH_12_SY_08')",
),
(
	"forceSpeak('nazi_rifleman', 'MISSPCH_12_N1_03', telepathy=0)",
),
(
	"forceSpeak('nazi_rifleman', 'MISSPCH_12_N2_03', telepathy=0)",
),
(
	"Sound_PlayMusic('music_08skyking_eye',1)",
	"speak('sky_king', 'MISSPCH_12_SY_12')",
),
(
	"spawn('cs_eye_minor', 'eye_minor', 'eye_spawn_marker')",
	"peace()",
	"lookAtPos((37,1335,40), zoom = -180, heading = 0, time = 1)",
	"wait(5.0)",
),
(
	"ff.UhOh()",
),
(
	"forceSpeak('eye_minor', 'MISSPCH_12_E1_01', telepathy=0)",
),
(
	"forceSpeak('narrator', 'MISSPCH_12_NR_01')",
	"blank",
),
(
	"Objective_Complete('protect_sky_king')",
	"endCS()",
	"Mission_Win()",
),
]

get_to_work_ss = [
(
	"speak('sky_king', 'MISSPCH_12_SY_09')",
),
(
	"blank",
),
]

sky_king_dead_cs = [
(
	"peace()",
	"see()",
	"startCS()",
	"look('sky_king', zoom = 0, heading = 0, time = 1)",
	"wait(2.0)",
),
(
	"look('sky_king', zoom = -200, heading = 0, time = 3)",
	"wait(3.0)",
),
(
	"endCS()",
	"Objective_Fail('protect_sky_king')",
	"Mission_Lose()",
),
]






