# explosives

# TO DO:

# - random character lines in scripted scenes (DONE)
# - keep a counter for number of enemies still alive (DONE)
# - always have an arrow on nearest enemy, once you have to kill them all
# - add real objective text

from cshelper import *
from js import *
import event
from ffx import *

def OnPrecacheObjects():
	print "explosives/precache"
	Mission_PrecacheTemplateObj('fortissimo', 1, 0)
	Mission_PrecacheTemplateObj('nazi_rifleman', 1, 0)

def OnPostInit():
	print "explosives/start"
	setMission(13)

	Mission_SetSunlight(-120,70,1.2,0.6,(0.8,0.7,0.6))
	Mission_SetShadows(-120,70,(0.2,0.2,0.5))
	Mission_SetProjShadowBackground((1,1,1))
	Mission_SetProjShadowColor((.5,.5,.6,1))

	Mission_SetAttr('reached_half_way', 0)
	Mission_SetAttr('sent_to_kill', 0)

	regHeroMarkerEnter('half_way_marker', 'OnHalfWay')
#	regHeroMarkerEnter('door_marker', 'OnReachDoor')

	regDeaths('eye_minor', 'OnEnemyDied')
	regDeaths('nazi_gunner', 'OnEnemyDied')
	regDeaths('nazi_general', 'OnEnemyDied')
	regDeaths('tank_ger', 'OnEnemyDied')

	regDeath('hero_1', 'OnAlchemissDead')

	regDetectHero('nazi_general1', 'OnHalfWay', user = 0)
	regDetectHero('nazi_general2', 'OnHalfWay', user = 0)
	regDetectHero('nazi_gunner1', 'OnHalfWay', user = 0)
	regDetectHero('nazi_gunner2', 'OnHalfWay', user = 0)
	regDetectHero('nazi_gunner3', 'OnHalfWay', user = 0)
	regDetectHero('nazi_gunner4', 'OnHalfWay', user = 0)
	regDetectHero('nazi_gunner5', 'OnHalfWay', user = 0)
	regDetectHero('nazi_gunner6', 'OnHalfWay', user = 0)
	regDetectHero('nazi_gunner9', 'OnHalfWay', user = 0)

	startPatrol('nazi_gunner1', 2, priority = ai.goal.PRI_ZERO-1, run = 0)
	startPatrol('nazi_gunner2', 2, priority = ai.goal.PRI_ZERO-1, run = 0)
	startPatrol('nazi_gunner4', 2, priority = ai.goal.PRI_ZERO-1, run = 0)
	startPatrol('nazi_gunner5', 2, priority = ai.goal.PRI_ZERO-1, run = 0)

	Mission_CustomAction('enter', '', '_impobj_wall_gate', 'OnGateExit', 5, 0)

	play(start_cs, "start_cs")
	FFX_InitMission()

def OnMissionWon():
	print "explosives/won"
	
def OnMissionLost():
	print "explosives/lost"


def OnAlchemissDead(event):
	play(alchemiss_dead_cs, "alchemiss_dead_cs")

def GetNumberOfBaddies():
	return len(getAllBaddies(checkLiving=1))
		
#This function seems to be using different units than regProximityEnter
def CheckDistance(thing1,thing2):
#	if (not Object_IsAlive(thing1)) or (not Object_IsAlive(thing2)):
#		print "checking distance on a dead object"
#		return 1000
#	else:
	pos1 = Get_ObjectPos(thing1)
	pos2 = Get_ObjectPos(thing2)
	xdelt = abs(pos1[0] - pos2[0])
	ydelt = abs(pos1[1] - pos2[1])
	zdelt = abs(pos1[2] - pos2[2])
	distance = sqrt(xdelt**2 + ydelt**2 + zdelt**2)
	#print distance
	return distance


def ApplyArrowToClosest():
	if GetNumberOfBaddies()>0:
		arrowlist = getAllBaddies(checkLiving=1)
		tempvar = 0
		tempdist = 500000
		tempstring = 'placeholder'
		for baddie in arrowlist:
			if (CheckDistance(baddie, 'hero_1')) < tempdist:
#				if (Object_GetTemplate(baddie) != 'tank_ger'):
				tempstring = baddie
				tempdist = CheckDistance(baddie, 'hero_1')
				print tempstring
				print tempdist
		if tempstring != 'placeholder':
			ff.addArrow('baddie_' + str(tempstring) + '_arrow', tempstring, js.ARROW_RED, delete=1)
			regDeath(tempstring, 'TempArrowToClosest')

def TempArrowToClosest(event):
	wait(2.0)
	ApplyArrowToClosest()

def OnHalfWay(event):
	if Mission_GetAttr('reached_half_way') == 0:
		Mission_SetAttr('reached_half_way', 1)
		play(ubermensch_ss, "ubermensch_ss")

def OnGateExit(object, char):
	if Mission_GetAttr('sent_to_kill') == 1:
		if GetNumberOfBaddies() == 0:
			play(final_cs, "final_cs")
		else:
			play(kill_more_ss, "kill_more_ss")
	if Mission_GetAttr('sent_to_kill') == 0:
		print "should be playing go-kill-all-nazis-ss"
		play(kill_them_all_ss, "kill_them_all_ss")
		spawn('extra_nazi_1', 'nazi_gunner', 'extra_nazi_marker_1')
		spawn('extra_nazi_2', 'nazi_gunner', 'extra_nazi_marker_2')
		addMoveGoal('extra_nazi_1', 'door_marker', fn = '', radius = 5, priority = ai.goal.PRI_LOW)
		addMoveGoal('extra_nazi_2', 'door_marker', fn = '', radius = 5, priority = ai.goal.PRI_LOW)
		Mission_SetAttr('sent_to_kill', 1)
		baddielist = getAllBaddies(checkLiving=1)
		tempvar = 0
		for baddie in baddielist:
#			if (Object_GetTemplate(baddie) != 'tank_ger'):
			tempvar = tempvar + 1
			print "number of baddies now: "
			print GetNumberOfBaddies()
		ApplyArrowToClosest()
#			ff.addArrow('baddie_' + str(tempvar) + '_arrow', baddie, js.ARROW_RED, delete=1)
			# regDeath(baddie, 'OnEnemyDied')
			# addMoveGoal(baddie, 'door_marker', fn = '', radius = 1, priority = ai.goal.PRI_LOW)

def OnEnemyDied(event):
	if GetNumberOfBaddies() == 0:
		if Mission_GetAttr('sent_to_kill') == 1:
			Objective_Complete('clear_all_nazis')
			play(got_em_all_ss, "got_em_all_ss")
			print "4 complete"
	print "Enemy has died. Number of enemies now: "
	print GetNumberOfBaddies()

def StartGuysMoving():
	addMoveGoal('nazi_gunner_1', 'hero_1', fn = '', radius = 5, priority = ai.goal.PRI_LOW)
	addMoveGoal('nazi_gunner_2', 'hero_1', fn = '', radius = 5, priority = ai.goal.PRI_LOW)
	addKillAllGoal('nazi_gunner_1', OC_CONTROLLABLE, priority = ai.goal.PRI_MED, fn = '', user = 0, permanent = 0, replace = 0)
	addKillAllGoal('nazi_gunner_2', OC_CONTROLLABLE, priority = ai.goal.PRI_MED, fn = '', user = 0, permanent = 0, replace = 0)



def TeleportHeroes():
	print "teleporting"
	reviveHeroes()
	spawn('nazi_gate_guard', 'nazi_rifleman', 'final_cs_nazi_spawn')
	herolist = getAllHeroes()
	temp = 0
	for hero in herolist:
		if temp == 0:
			teleport(hero, 'hero_teleport_marker1')
			temp = 1
		elif temp == 1:
			teleport(hero, 'hero_teleport_marker2')
			temp = 2
		elif temp == 2:
			teleport(hero, 'hero_teleport_marker3')
			temp = 3
		elif temp == 3:
			teleport(hero, 'hero_teleport_marker4')
			temp = 4

# 	"look('hero_1', zoom = -150, heading = 0, time = 0)",
start_cs = [
(
	"peace()",
	"see()",
	"startCS()",
	"lookAtPos((-262, -845, 51), zoom = 28.1, pitch = 0, heading = -135.5, time = 0, fn = 'onStepCB')",
),
(
	"lookAtPos((-262, -845, 51), zoom = -101.2, pitch = 0, heading = -135.5, time = 2, fn = 'onStepCB')",
),
(
	"speak('alchemiss', 'MISSPCH_13_AL_02')",
),
(
	"wait(1.0)",
),
(
	"look('nazi_gunner7', zoom = -100, heading = 180, time = 1)",
	"wait(0.1)",
),
(
	"forceSpeak('nazi_rifleman', 'MISSPCH_13_N1_01', telepathy=0)",
),
(
	"endCS()",
	"war()",
	"Sound_PlayMusic('music_06redsun1')",
	"blind()",
	"newObjective('primary', 1, name='get_inside_compound')",
	"newObjective('primary', 3, name='alchemiss_must_live')",
	"ff.addArrow('door_arrow', 'door_marker', js.ARROW_RED, delete=1)",
	"ff.StartGuysMoving",
),
]

#	commented out of above CS
#	"newObjective('primary', 2, name='plant_explosives')",

ubermensch_ss = [
(
	"forceSpeak('nazi_rifleman', 'MISSPCH_13_N2_01', telepathy=0)",
),
(
	"speak('alchemiss', 'MISSPCH_13_AL_03')",
),
]

kill_them_all_ss = [
(
	"speak('alchemiss', 'MISSPCH_13_AL_06')",
),
(
	"speak('alchemiss', 'MISSPCH_13_AL_07')",
),
(
	"speak('alchemiss', 'MISSPCH_13_AL_08')",
),
(
	"removeArrow('door_arrow')",
	"newObjective('primary', 4, name='clear_all_nazis')",
),
]


kill_more_ss = [
(
	"speak('alchemiss', 'MISSPCH_13_AL_09')",
),
]

got_em_all_ss = [
(
	"speak('alchemiss', 'MISSPCH_13_AL_10')",
	"ff.addArrow('door_arrow', 'door_marker', js.ARROW_RED, delete=1)",
),
]


alchemiss_dead_cs = [
(
	"startCS()",
	"peace()",
	"look('hero_1', zoom = 0, heading = 0, time = 1)",
	"look('hero_1', zoom = -150, heading = 0, time = 4)",
	"wait(5.0)",
),
(
	"endCS()",
	"war()",
	"Objective_Fail('alchemiss_must_live')",
	"Mission_Lose()",
),
]

# instead of a wait in step 1, should be a playTransition
final_cs = [
(
	"Camera_Fade(0)",
	"playTransition()",
),
(
	"startCS()",
	"ff.TeleportHeroes()",
	"lookAtPos((35,1367,-45), zoom = -252.7, pitch = 0, heading = -62.4)",
	"peace()",
	"Sound_PlayMusic('music_04winter_hit1',1)",
	"wait(1.0)",
),
(
	"Camera_UnFade(1)",
	"wait(0.1)",
),
(	
	"forceSpeak('nazi_rifleman', 'MISSPCH_13_N1_04', telepathy=0)",
	"Sound_PlaySound('mission_blitzkrieg')",
),
(
	"speak('alchemiss', 'MISSPCH_13_AL_11')",
),
(
	"forceSpeak('nazi_rifleman', 'MISSPCH_13_N1_05', telepathy=0)",
),
(
	"speak('alchemiss', 'MISSPCH_13_AL_12')",
),
(
	"forceSpeak('nazi_rifleman', 'MISSPCH_13_N1_06', telepathy=0)",
),
(
	"spawn('fortissimo', 'fortissimo', 'fortissimo_spawn_marker')",
	"lookAtPos((-174,1019,-8), zoom = -293.6, pitch = -20, heading = -192.3, time = 1)",
	"peace()",
	"Sound_PlayMusic('music_05fort_cs1',1)",
	"wait(0.1)",
),
(
	"speak('fortissimo', 'MISSPCH_13_FT_02')",
),
(
	"speak('alchemiss', 'MISSPCH_13_AL_13')",
),
(
	"speak('fortissimo', 'MISSPCH_13_FT_03')",
),
(
	"speak('narrator', 'MISSPCH_13_NR_01')",
),
(
	"endCS()",
	"war()",
	"Objective_Complete('get_inside_compound')",
	"Objective_Complete('alchemiss_must_live')",
	"Mission_Win()",
),
]

