# witness

# to do:

# - make generator not pick-up-able
# - Add Fortissimo to Map
# - remove red arrow when bomb planted

from cshelper import *
from js import *
import event
from ffx import *

def OnPrecacheObjects():
	print "witness/precache"
	
def OnPostInit():
	print "witness/start"
	setMission(15)

	Mission_SetSunlight(140,60,1.0,0.8,(0.9,0.8,0.7))
	Mission_SetShadows(140,60,(0.3,0.2,0.6))
	Mission_SetProjShadowBackground((1,1,1))
	Mission_SetProjShadowColor((.7,.6,.7,1))

	Mission_SetAttr('proxguys', 0)
	Mission_SetAttr('witnesses_dead', 0)
	Mission_SetAttr('arrowcount', 0)

	Mission_CustomAction('plant_bomb', '', '_impobj_shield_generator', 'OnBombPlanted', 5, 1)

	startPatrol('nazi1', 2, priority = ai.goal.PRI_ZERO-1, run = 0)
	startPatrol('nazi2', 2, priority = ai.goal.PRI_ZERO-1, run = 0)

	startPatrol('nazi_gunner2', 2, priority = ai.goal.PRI_ZERO-1, run = 0)
	startPatrol('nazi_gunner3', 2, priority = ai.goal.PRI_ZERO-1, run = 0)
	startPatrol('nazi_gunner4', 2, priority = ai.goal.PRI_ZERO-1, run = 0)
	startPatrol('nazi_gunner6', 2, priority = ai.goal.PRI_ZERO-1, run = 0)

	play(start_cs, "start_cs")
	FFX_InitMission()

	regDeath('_impobj_shield_generator', 'OnGenDestroyed')

	Mission_AddSquadExtra('sky_king')
	Mission_AddSquadExtra('black_jack')
	Mission_AddSquadExtra('tricolour')
	Mission_AddSquadExtra('el_diablo')

#	regMarkerEnter(OC_MINION, 'witness_marker', 'OnWitnessApproach')



def OnMissionWon():
	print "witness/won"

def OnMissionLost():
	print "witness/lost"



def OnBombPlanted(Object, Char):
	print "Bomb Planted!"
	spawn('extra_witness_nazi1', 'nazi_gunner', 'extra_witness_marker1')
	spawn('extra_witness_nazi2', 'nazi_gunner', 'extra_witness_marker2')
#	spawn('extra_witness_eye1', 'eye_minor', 'extra_witness_marker3')
#	spawn('extra_witness_eye2', 'eye_minor', 'extra_witness_marker4')
	removeArrow('gen_arrow')
	proxlist = getNearBaddies('_impobj_shield_generator', 1000, checkLiving=1)
	tempvar = 0
	for baddie in proxlist:
		Object_SetAttr(baddie, 'witness', 1)
		regMarkerEnter(baddie, 'witness_marker', 'AddWitnessArrow')
		addAttr('proxguys', 1)
		tempvar = tempvar + 1
		print "added one to proxguys"
		regDeath(baddie, 'OnWitnessDead')
		regDamage(baddie, 'OnWitnessDamaged')
		regMarkerEnter(baddie, 'exit_marker', 'OnWitnessEscape')
		clearGoals(baddie)
		abortPatrol(baddie)
		addMoveGoal(baddie, 'exit_marker', fn = '', radius = 1, priority = ai.goal.PRI_LOW)
	play (stop_witnesses_ss, "stop_witnesses_ss")

def AddWitnessArrow(event):
	tempvar = Mission_GetAttr('arrowcount')
	if Object_GetAttr(event.object, 'witness') == 1:
		addArrow('arrowname_' + str(tempvar) + '_arrow', event.object, colour = js.ARROW_RED, delete = 1)
		addAttr('arrowcount', 1)


def OnWitnessDamaged(event):
	addKillAllGoal(event.object, OC_CONTROLLABLE, priority = ai.goal.PRI_MED)


def CheckDistance(thing1,thing2):
#	if (not Object_IsAlive(thing1)) or (not Object_IsAlive(thing2)):
#		print "checking distance on a dead object"
#		return 1000
#	else:
	pos1 = Get_ObjectPos(thing1)
	pos2 = Get_MarkerPos(thing2)
	xdelt = abs(pos1[0] - pos2[0])
	ydelt = abs(pos1[1] - pos2[1])
	zdelt = abs(pos1[2] - pos2[2])
	distance = sqrt(xdelt**2 + ydelt**2 + zdelt**2)
	#print distance
	return distance


def OnWitnessDead(event):
	addAttr('witnesses_dead', 1)
	print "witness died.  witnesses killed: "
	print Mission_GetAttr('witnesses_dead')
	print "proxguys: "
	print Mission_GetAttr('proxguys')
	if Mission_GetAttr('witnesses_dead') == Mission_GetAttr('proxguys'):
		play(final_cs, "final_cs")

def OnWitnessEscape(event):
	Objective_Fail('stop_witnesses')
	print "A witness got away!  You lose!"
	Mission_Lose()


def SpawnExtraRomans():
	spawn('extra_centurion', 'centurion', 'extra_centurion_marker')
	spawn('extra_legionnaire', 'legionnaire', 'extra_legionnaire_marker')
	addMoveGoal('extra_centurion', 'hero_1', fn = '', radius = 1, priority = ai.goal.PRI_LOW)
	addMoveGoal('extra_legionnaire', 'hero_1', fn = '', radius = 1, priority = ai.goal.PRI_LOW)
	addKillAllGoal('extra_centurion', OC_CONTROLLABLE, priority = ai.goal.PRI_MED)
	addKillAllGoal('extra_legionnaire', OC_CONTROLLABLE, priority = ai.goal.PRI_MED)

def FinalSetup():
	reviveHeroes()
	teleport('hero_1','hero_1')
	teleport('hero_2','hero_2')
	teleport('hero_3','hero_3')
	teleport('hero_4','hero_4')
	peace()

def OnGenDestroyed(event):
	Objective_Fail('no_destroy_gen')
	Mission_Lose()

start_cs = [
(
	"peace()",
	"startCS()",
	"see()",
	"look('hero_1', zoom = 0, heading = 0, time = 0)",
	"wait(1)",
),
(
	"forceSpeak('fortissimo', 'MISSPCH_15_FT_01')",
	"Sound_PlayMusic('music_05fort_cs1',1)",
),
(
	"forceSpeak('alchemiss', 'MISSPCH_15_AL_04')",
),
(
	"forceSpeak('fortissimo', 'MISSPCH_15_FT_02')",
),
(
	"forceSpeak('fortissimo', 'MISSPCH_15_FT_03')",
),
(
	"forceSpeak('bullet', 'MISSPCH_15_BL_01')",
),
(
	"endCS()",
	"war()",
	"blind()",
	"Sound_PlayMusic('music_06redsun1')",
	"newObjective('primary', 1, name='must_plant_bomb')",
	"newObjective('primary', 3, name='no_destroy_gen')",
	"ff.addArrow('gen_arrow', '_impobj_shield_generator', js.ARROW_RED, delete=1)",
),
]


nazi_alert_ss = [
(
	"forceSpeak('nazi_gunner', 'MISSPCH_15_N1_01', telepathy=0)",
),
(
	"forceSpeak('nazi_gunner', 'MISSPCH_15_N2_03', telepathy=0)",
),
]

stop_witnesses_ss = [
(
	"forceSpeak('nazi_gunner', 'MISSPCH_15_N2_01', telepathy=0)",
),
(
	"forceSpeak('nazi_gunner', 'MISSPCH_15_N2_02', telepathy=0)",
),
(
	"speak('bullet', 'MISSPCH_15_BL_02')",
),
(
	"Objective_Complete('must_plant_bomb')",
	"newObjective('primary', 2, name='stop_witnesses')",
	"ff.SpawnExtraRomans()",
),
]


final_cs = [
(
	"peace()",
	"startCS()",
	"ff.FinalSetup()",
	"look('hero_1', zoom = 0, heading = 0, time = 0)",
	"playTransition()",
),
(
	"Sound_PlayMusic('music_08witness_end1',1)",
	"speak('bullet', 'MISSPCH_15_BL_03')",
),
(
	"speak('mentor', 'MISSPCH_15_ME_03')",
),
(
	"Camera_Fade(3)",
	"Sound_PlayMusic('music_08witness_end2',1)",
	"wait(3.0)",
),
(
	"forceSpeak('blitzkrieg', 'MISSPCH_15_BZ_01')",
),
(
	"forceSpeak('blitzkrieg', 'MISSPCH_15_BZ_02')",
),
(
	"wait(1.0)",
),
(
	"Objective_Complete('no_destroy_gen')",
	"Objective_Complete('stop_witnesses')",
	"endCS()",
	"Mission_Win()",
),
]
