# symphony

from cshelper import *
from js import *
import event
from random import randint
from ffx import *

def OnPrecacheObjects():
	print "symphony/precache"
	Mission_PrecacheTemplateObj('entropy', 1, 0)
	Mission_PrecacheTemplateObj('cop_chaos', 1, 1)
	Mission_PrecacheTemplateObj('trex', 1, 1)

def OnPostInit():
	print "symphony/start"
	setMission(18)
	
	Mission_SetSunlight(-140,70,1.0,0.8,(0.7,0.6,0.6))
	Mission_SetShadows(-140,70,(0.2,0.2,0.4))
	Mission_SetProjShadowBackground((1,1,1))
	Mission_SetProjShadowColor((.6,.6,.6,1))

	spawn('fortissimo_target','fx_standin','marker_museum_target')
	dloc = Get_ObjectPos('_impobj_dinosaur_statue')
	drot = Object_GetOrientation('_impobj_dinosaur_statue')
	print drot[1]
	Marker_Spawn('dino_spawn_marker',dloc,drot[1])
	spawn('dino_standin','fx_standin','dino_spawn_marker')
	Object_SetAttr('_impobj_dinosaur_statue','minForce',-1)
	Object_SetAttr('_impobj_dinosaur_statue','minHealth',10)

	Wave1Setup()
	play(start_cs,'start_cs')
	FFX_InitMission()

def TestFortTalk():
	spawn('fortissimo_museum','fortissimo','marker_spawn_fort_mus')
	newObjective('primary', 2, name='kill_fortissimo')
	play(fortissimo_talk_cs,'fortissimo_talk_cs')

def CSTest(event):
	print getRandomLiveHeroName()
	Mission_SetAttr('wave4_killed',3)
	spawn('fortissimo_museum','thug_with_bat','marker_spawn_fort_mus')
	regAlmostDead('fortissimo_museum','FortissimoTest',1)
def FortissimoTest(event):
	peace()
	makeCriticalCustomFn('fortissimo_museum')


def StandardWarpEffect(pos):
	Mission_SetWaveEnvelope(1, 0.35, 3, 0.35, 3, 1)
	Mission_SetWaveSinParams(1, 4, 0.04, 1)
	Mission_StartWave(1, 3, 1, pos)


def Wave1Setup():
	Mission_SetAttr('museum_smashed', 0)
	operagoal = KillObjects('_impobj_opera_centre')
#readd wings?
#	regDeath('museum_right','MuseumSmash')
	regDeath('_impobj_opera_centre','MuseumSmash')
#	regDeath('museum_left','MuseumSmash')
	playEffectMarker('effect_entropy_spawn','spawn_w1l1'),
	StandardWarpEffect(Get_MarkerPos('spawn_w1l1'))
	spawn('wave1_leg1','legionnaire','spawn_w1l1')
#	spawn('wave1_leg2','legionnaire','spawn_w1l2')
	playEffectMarker('effect_entropy_spawn','spawn_w1c1'),
	StandardWarpEffect(Get_MarkerPos('spawn_w1c1'))
	spawn('wave1_cen1','centurion','spawn_w1c1')
#	spawn('wave1_cen2','centurion','spawn_w1c2')
	playEffectMarker('effect_entropy_spawn','spawn_w1w1'),
	StandardWarpEffect(Get_MarkerPos('spawn_w1w1'))
	spawn('wave1_wra1','wraith_warrior','spawn_w1w1')
	addGoalToAI('wave1_leg1',operagoal,PRI_LOW)
#	addGoalToAI('wave1_leg2',operagoal,PRI_LOW)
	addGoalToAI('wave1_cen1',operagoal,PRI_LOW)
#	addGoalToAI('wave1_cen2',operagoal,PRI_LOW)
	addGoalToAI('wave1_wra1',operagoal,PRI_HI)
	addKillAllGoal('wave1_leg1',OC_CONTROLLABLE,ai.goal.PRI_MED)
	addKillAllGoal('wave1_cen1',OC_CONTROLLABLE,ai.goal.PRI_MED)
	addKillAllGoal('wave1_wra1',OC_CONTROLLABLE,ai.goal.PRI_MED)
	Mission_SetAttr('wave1_killed', 0)
	regDeath('wave1_leg1','Wave1Kill')
#	regDeath('wave1_leg2','Wave1Kill')
	regDeath('wave1_cen1','Wave1Kill')
#	regDeath('wave1_cen2','Wave1Kill')
	regDeath('wave1_wra1','Wave1Kill')
def StartCSDone():
	teleport('fortissimo','marker_fort_exit')
	kill('fortissimo')
	Object_Destroy('fortissimo')
def Wave1Kill(event):
	addAttr('wave1_killed',1)
	if Mission_GetAttr('wave1_killed') == 3:
		Wave2Setup()
		play(top_hat_attack_ss,'top_hat_attack_ss')
		if (Objective_IsFailed('save_opera') == 0):
			Objective_Complete('save_opera')
def MuseumSmash(event):
	addAttr('museum_smashed',1)
	if Object_IsAlive('wave1_leg1'):
		addArrow('w1l1','wave1_leg1',ARROW_RED,1)
#	if Object_IsAlive('wave1_leg2'):
#		addArrow('w1l2','wave1_leg2',ARROW_RED,1)
	if Object_IsAlive('wave1_cen1'):
		addArrow('w1c1','wave1_cen1',ARROW_RED,1)
#	if Object_IsAlive('wave1_cen2'):
#		addArrow('w1c2','wave1_cen2',ARROW_RED,1)
	if Object_IsAlive('wave1_wra1'):
		addArrow('w1w1','wave1_wra1',ARROW_RED,1)
#retune number if wings added
	if Mission_GetAttr('museum_smashed') == 1:
		play(opera_down_ss,'opera_down_ss')
		if (Objective_IsComplete('save_opera') == 0):
			Objective_Fail('save_opera')
	

def Wave2Setup():
	removeArrow('opera_arrow')
	regDeath('_impobj_top_hat_nightclub','TopHatSmashed')
	playEffectMarker('effect_entropy_spawn','spawn_w2l1'),
	StandardWarpEffect(Get_MarkerPos('spawn_w2l1'))
	spawn('wave2_leg1','legionnaire','spawn_w2l1')
	playEffectMarker('effect_entropy_spawn','spawn_w2l2'),
	StandardWarpEffect(Get_MarkerPos('spawn_w2l2'))
	spawn('wave2_leg2','legionnaire','spawn_w2l2')
	playEffectMarker('effect_entropy_spawn','spawn_w2c1'),
	StandardWarpEffect(Get_MarkerPos('spawn_w2c1'))
	spawn('wave2_cen1','centurion','spawn_w2c1')
	playEffectMarker('effect_entropy_spawn','spawn_w2c2'),
	StandardWarpEffect(Get_MarkerPos('spawn_w2c2'))
	spawn('wave2_cen2','centurion','spawn_w2c2')
#	spawn('wave2_wra1','wraith_warrior','spawn_w2w1')
	tophatgoal = KillObjects('_impobj_top_hat_nightclub')
	addGoalToAI('wave2_leg1',tophatgoal,PRI_LOW)
	addGoalToAI('wave2_leg2',tophatgoal,PRI_LOW)
	addGoalToAI('wave2_cen1',tophatgoal,PRI_LOW)
	addGoalToAI('wave2_cen2',tophatgoal,PRI_LOW)
#	addGoalToAI('wave2_wra1',tophatgoal,PRI_HI)
	addKillAllGoal('wave2_leg1',OC_CONTROLLABLE,ai.goal.PRI_MED)
	addKillAllGoal('wave2_leg2',OC_CONTROLLABLE,ai.goal.PRI_MED)
	addKillAllGoal('wave2_cen1',OC_CONTROLLABLE,ai.goal.PRI_MED)
	addKillAllGoal('wave2_cen2',OC_CONTROLLABLE,ai.goal.PRI_MED)
	Mission_SetAttr('wave2_killed', 0)
	regDeath('wave2_leg1','Wave2Kill')
	regDeath('wave2_leg2','Wave2Kill')
	regDeath('wave2_cen1','Wave2Kill')
	regDeath('wave2_cen2','Wave2Kill')
#	regDeath('wave2_wra1','Wave2Kill')
def CarBoomSetup():
	regHeroMarkerEnter('marker_car_boom','CarBoom')
def Wave2Kill(event):
	addAttr('wave2_killed',1)
	if Mission_GetAttr('wave2_killed') == 4:
		Wave3Setup()
		play(police_station_attack_ss,'police_station_attack_ss')
		if (Objective_IsFailed('save_hat') == 0):
			Objective_Complete('save_hat')
def TopHatSmashed(event):
	if Object_IsAlive('wave2_leg1'):
		addArrow('w2l1','wave2_leg1',ARROW_RED,1)
	if Object_IsAlive('wave2_leg2'):
		addArrow('w2l2','wave2_leg2',ARROW_RED,1)
	if Object_IsAlive('wave2_cen1'):
		addArrow('w2c1','wave2_cen1',ARROW_RED,1)
	if Object_IsAlive('wave2_cen2'):
		addArrow('w2c2','wave2_cen2',ARROW_RED,1)
#	if Object_IsAlive('wave2_wra1'):
#		addArrow('w2w1','wave2_wra1',ARROW_RED,1)
	if (Objective_IsComplete('save_hat') == 0):
		play(police_station_down_ss,'police_station_down_ss')
		Objective_Fail('save_hat')


def CarBoom(event):
	print "first car booming"
	Object_PlayEffect('car_1', 'effect_car_toss_start','CarBoomDone')
	regHeroMarkerEnter('throw_bench_marker','ThrowBench')
	regHeroMarkerEnter('throw_cart_marker','ThrowCart')
	regHeroMarkerEnter('throw_copcar_marker','ThrowCopCar')
	regHeroMarkerEnter('throw_mail_marker','ThrowMail')
	regHeroMarkerEnter('throw_news_marker','ThrowNews')
	regHeroMarkerEnter('throw_phone_marker','ThrowPhone')
	regHeroMarkerEnter('throw_tree_marker','ThrowTree')
#	Object_PlayEffect(Object_GetTerrain(), 'effect_car_toss_start', 'CarBoomDone', 0,0, "", Get_ObjectPos('car_1'))
def CarBoomDone(event):
	Object_PlayEffect('car_1', 'effect_car_toss_end')
	Trigger_Force('car_1',2,0,90,300000,0)
	regTimer('CarBoom2',2)
def CarBoom2(event):
	Object_PlayEffect('car_2', 'effect_car_toss_start','CarBoom2Done')
def CarBoom2Done(event):
	Object_PlayEffect('car_2', 'effect_car_toss_end')
	Trigger_Force('car_2',0,3,90,300000,0)
	play(car_boom_ss,'car_boom_ss')
	regTimer('CarBoom3',2.5)
def CarBoom3(event):
	Object_PlayEffect('car_3', 'effect_car_toss_start','CarBoom3Done')
def CarBoom3Done(event):
	Object_PlayEffect('car_3', 'effect_car_toss_end')
	Trigger_Force('car_3',-1,2,90,300000,0)
	regTimer('CarBoom4',4)
def CarBoom4(event):
	Object_PlayEffect('car_4', 'effect_car_toss_start','CarBoom4Done')
def CarBoom4Done(event):
	Object_PlayEffect('car_4', 'effect_car_toss_end')
	Trigger_Force('car_4',10,30,90,300000,0)
	regTimer('CarBoom5',1)
def CarBoom5(event):
	Object_PlayEffect('car_5', 'effect_car_toss_start','CarBoom5Done')
def CarBoom5Done(event):
	Object_PlayEffect('car_5', 'effect_car_toss_end')
	Trigger_Force('car_5',22,40,90,300000,0)
	regTimer('CarBoom6',5)
def CarBoom6(event):
	Object_PlayEffect('car_6', 'effect_car_toss_start','CarBoom6Done')
def CarBoom6Done(event):
	Object_PlayEffect('car_6', 'effect_car_toss_end')
	Trigger_Force('car_6',-17,-25,90,300000,0)
	regTimer('CarBoom7',2)
def CarBoom7(event):
	Object_PlayEffect('car_7', 'effect_car_toss_start','CarBoom7Done')
def CarBoom7Done(event):
	Object_PlayEffect('car_7', 'effect_car_toss_end')
	Trigger_Force('car_7',40,35,90,300000,0)
	regTimer('CarBoom8',6)
def CarBoom8(event):
	Object_PlayEffect('car_8', 'effect_car_toss_start','CarBoom8Done')
def CarBoom8Done(event):
	Object_PlayEffect('car_8', 'effect_car_toss_end')
	Trigger_Force('car_8',11,0,90,300000,0)
	regTimer('CarBoom9',4)
def CarBoom9(event):
	Object_PlayEffect('car_9', 'effect_car_toss_start','CarBoom9Done')
def CarBoom9Done(event):
	Object_PlayEffect('car_9', 'effect_car_toss_end')
	Trigger_Force('car_9',25,15,90,300000,0)
	regTimer('CarBoom10',7)
def CarBoom10(event):
	Object_PlayEffect('car_10', 'effect_car_toss_start','CarBoom10Done')
def CarBoom10Done(event):
	Object_PlayEffect('car_10', 'effect_car_toss_end')
	Trigger_Force('car_10',10,-15,90,300000,0)
#	regTimer('ThrowCopCar',1)
def ThrowCopCar(event):
	Object_PlayEffect('throw_copcar', 'effect_car_toss_start','CopCarBoomDone')
def CopCarBoomDone(event):
	Object_PlayEffect('throw_copcar', 'effect_car_toss_end')
	Trigger_Force('throw_copcar',11,10,90,300000,0)
#	regTimer('ThrowTree',5)
def ThrowTree(event):
	Object_PlayEffect('throw_tree', 'effect_car_toss_start','TreeBoomDone')
def TreeBoomDone(event):
	Object_PlayEffect('throw_tree', 'effect_car_toss_end')
	Trigger_Force('throw_tree',-15,-20,90,100000,0)
#	regTimer('ThrowPhone',3)
def ThrowPhone(event):
	Object_PlayEffect('throw_phone', 'effect_car_toss_start','PhoneBoomDone')
def PhoneBoomDone(event):
	Object_PlayEffect('throw_phone', 'effect_car_toss_end')
	Trigger_Force('throw_phone',22,-15,90,120000,0)
#	regTimer('ThrowNews',8)
def ThrowNews(event):
	Object_PlayEffect('throw_news', 'effect_car_toss_start','NewsBoomDone')
def NewsBoomDone(event):
	Object_PlayEffect('throw_news', 'effect_car_toss_end')
	Trigger_Force('throw_news',-23,8,90,50000,0)
#	regTimer('ThrowCart',4)
def ThrowCart(event):
	Object_PlayEffect('throw_cart', 'effect_car_toss_start','CartBoomDone')
def CartBoomDone(event):
	Object_PlayEffect('throw_cart', 'effect_car_toss_end')
	Trigger_Force('throw_cart',7,11,90,100000,0)
#	regTimer('ThrowBench',9)
def ThrowBench(event):
	Object_PlayEffect('throw_bench', 'effect_car_toss_start','BenchBoomDone')
def BenchBoomDone(event):
	Object_PlayEffect('throw_bench', 'effect_car_toss_end')
	Trigger_Force('throw_bench',-12,-10,90,50000,0)
#	regTimer('ThrowMail',5)
def ThrowMail(event):
	Object_PlayEffect('throw_mail', 'effect_car_toss_start','MailBoomDone')
def MailBoomDone(event):
	Object_PlayEffect('throw_mail', 'effect_car_toss_end')
	Trigger_Force('throw_mail',22,-17,90,17000,0)
#	regTimer('Throw',1)



def MovieMonsters(event):
	spawn('movie1','alien_warrior','spawn_movie1')
	spawn('movie2','alien_warrior','spawn_movie2')
	spawn('movie3','alien_warrior','spawn_movie3')



def Wave3Setup():
	removeArrow('top_hat_arrow')
	regTimer('ChaosCops',10)
	regDeath('_impobj_police_station','PoliceStationSmashed')
	spawn('cop1','cop','spawn_cop1')
	spawn('cop2','cop','spawn_cop2')
	spawn('cop3','cop','spawn_cop3')
	spawn('cop4','cop','spawn_cop4')
	spawn('cop5','cop','spawn_cop5')
	playEffectMarker('effect_entropy_spawn','spawn_w3l1'),
	StandardWarpEffect(Get_MarkerPos('spawn_w3l1'))
	spawn('wave3_leg1','legionnaire','spawn_w3l1')
	playEffectMarker('effect_entropy_spawn','spawn_w3c1'),
	StandardWarpEffect(Get_MarkerPos('spawn_w3c1'))
	spawn('wave3_cen1','centurion','spawn_w3c1')
	playEffectMarker('effect_entropy_spawn','spawn_w3w1'),
	StandardWarpEffect(Get_MarkerPos('spawn_w3w1'))
	spawn('wave3_wra1','wraith_warrior','spawn_w3w1')
	playEffectMarker('effect_entropy_spawn','spawn_w3l2'),
	StandardWarpEffect(Get_MarkerPos('spawn_w3l2'))
	spawn('wave3_wra2','wraith_warrior','spawn_w3l2')
	copgoal = KillObjects('_impobj_police_station',)
	addGoalToAI('wave3_leg1',copgoal,PRI_LOW)
	addGoalToAI('wave3_cen1',copgoal,PRI_LOW)
	addGoalToAI('wave3_wra1',copgoal,PRI_HI)
	addGoalToAI('wave3_wra2',copgoal,PRI_HI)
	addKillAllGoal('wave3_leg1',OC_CONTROLLABLE,ai.goal.PRI_MED)
	addKillAllGoal('wave3_cen1',OC_CONTROLLABLE,ai.goal.PRI_MED)
	addKillAllGoal('wave3_wra1',OC_CONTROLLABLE,ai.goal.PRI_MED)
	addKillAllGoal('wave3_wra2',OC_CONTROLLABLE,ai.goal.PRI_MED)
	Mission_SetAttr('wave3_killed', 0)
	regDeath('wave3_leg1','Wave3Kill')
	regDeath('wave3_leg2','Wave3Kill')
	regDeath('wave3_cen1','Wave3Kill')
	regDeath('wave3_cen2','Wave3Kill')
	regDeath('wave3_wra1','Wave3Kill')
	regDeath('wave3_wra2','Wave3Kill')
def Wave3Kill(event):
	addAttr('wave3_killed',1)
	if Mission_GetAttr('wave3_killed') == 4:
		Wave4Setup()
		play(museum_attack_ss,'museum_attack_ss')
		if (Objective_IsFailed('save_cops') == 0):
			Objective_Complete('save_cops')
def PoliceStationSmashed(event):
	if Object_IsAlive('wave3_leg1'):
		addArrow('w3l1','wave3_leg1',ARROW_RED,1)
	if Object_IsAlive('wave3_cen1'):
		addArrow('w3c1','wave3_cen1',ARROW_RED,1)
	if Object_IsAlive('wave3_wra1'):
		addArrow('w3w1','wave3_wra1',ARROW_RED,1)
	if Object_IsAlive('wave3_wra2'):
		addArrow('w3w1','wave3_wra2',ARROW_RED,1)
	if (Objective_IsComplete('save_cops') == 0):
		play(museum_down_ss,'museum_down_ss')
		Objective_Fail('save_cops')


def ChaosCops(event):
	Mission_SetAttr('cops_ss_played', 0)
	if Object_IsAlive('cop1'):
			AI_SetEnabled('cop1',0)
			chaospoint = Get_ObjectPos('cop1')
			chaosheading = Object_GetOrientation('cop1')
			Marker_Spawn('spawn_chaos1',chaospoint,chaosheading[1])
			Object_PlayEffect('cop1', 'effect_entropy_spawn', 'OnChaosFXFinished1', FX_TRACK_OBJECT_ROT)
			StandardWarpEffect(Get_ObjectPos('cop1'))
	if Object_IsAlive('cop2'):
			AI_SetEnabled('cop2',0)
			chaospoint = Get_ObjectPos('cop2')
			chaosheading = Object_GetOrientation('cop2')
			Marker_Spawn('spawn_chaos2',chaospoint,chaosheading[1])
			Object_PlayEffect('cop2', 'effect_entropy_spawn', 'OnChaosFXFinished2', FX_TRACK_OBJECT_ROT)
			StandardWarpEffect(Get_ObjectPos('cop2'))
	if Object_IsAlive('cop3'):
			AI_SetEnabled('cop3',0)
			chaospoint = Get_ObjectPos('cop3')
			chaosheading = Object_GetOrientation('cop3')
			Marker_Spawn('spawn_chaos3',chaospoint,chaosheading[1])
			Object_PlayEffect('cop3', 'effect_entropy_spawn', 'OnChaosFXFinished3', FX_TRACK_OBJECT_ROT)
			StandardWarpEffect(Get_ObjectPos('cop3'))
	if Object_IsAlive('cop4'):
			AI_SetEnabled('cop4',0)
			chaospoint = Get_ObjectPos('cop4')
			chaosheading = Object_GetOrientation('cop4')
			Marker_Spawn('spawn_chaos4',chaospoint,chaosheading[1])
			Object_PlayEffect('cop4', 'effect_entropy_spawn', 'OnChaosFXFinished4', FX_TRACK_OBJECT_ROT)
			StandardWarpEffect(Get_ObjectPos('cop4'))
	if Object_IsAlive('cop5'):
			AI_SetEnabled('cop5',0)
			chaospoint = Get_ObjectPos('cop5')
			chaosheading = Object_GetOrientation('cop5')
			Marker_Spawn('spawn_chaos5',chaospoint,chaosheading[1])
			Object_PlayEffect('cop5', 'effect_entropy_spawn', 'OnChaosFXFinished5', FX_TRACK_OBJECT_ROT)
			StandardWarpEffect(Get_ObjectPos('cop5'))
def OnChaosFXFinished1(event):
	Object_Destroy('cop1')
	spawn('chaos1','cop_chaos','spawn_chaos1')
	if Mission_GetAttr('cops_ss_played') == 0:
		Mission_SetAttr('cops_ss_played',1)
		play(chaos_cops_ss,'chaos_cops_ss')
def OnChaosFXFinished2(event):
	Object_Destroy('cop2')
	spawn('chaos2','cop_chaos','spawn_chaos2')
	if Mission_GetAttr('cops_ss_played') == 0:
		Mission_SetAttr('cops_ss_played',1)
		play(chaos_cops_ss,'chaos_cops_ss')
def OnChaosFXFinished3(event):
	Object_Destroy('cop3')
	spawn('chaos3','cop_chaos','spawn_chaos3')
	if Mission_GetAttr('cops_ss_played') == 0:
		Mission_SetAttr('cops_ss_played',1)
		play(chaos_cops_ss,'chaos_cops_ss')
def OnChaosFXFinished4(event):
	Object_Destroy('cop4')
	spawn('chaos4','cop_chaos','spawn_chaos4')
	if Mission_GetAttr('cops_ss_played') == 0:
		Mission_SetAttr('cops_ss_played',1)
		play(chaos_cops_ss,'chaos_cops_ss')
def OnChaosFXFinished5(event):
	Object_Destroy('cop5')
	spawn('chaos5','cop_chaos','spawn_chaos5')
	if Mission_GetAttr('cops_ss_played') == 0:
		Mission_SetAttr('cops_ss_played',1)
		play(chaos_cops_ss,'chaos_cops_ss')

def CopsLine():
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_18_MM_05')
	elif a_hero == 'black_jack':
		speak('black_jack', 'MISSPCH_18_BJ_03')
	elif a_hero == 'black_bird':
		speak('black_bird', 'MISSPCH_18_BB_04')
	elif a_hero == 'bullet':
		speak('bullet', 'MISSPCH_18_BL_03')
	elif a_hero == 'eve':
		speak('eve', 'MISSPCH_18_EV_04')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_18_GG_04')
	elif a_hero == 'iron_ox':
		speak('iron_ox', 'MISSPCH_18_IO_03')
	elif a_hero == 'law':
		speak('order', 'MISSPCH_18_OR_03')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_18_LL_03')
	elif a_hero == 'man_bot':
		speak('man_bot', 'MISSPCH_18_MB_03')
	elif a_hero == 'man_o_war':
		speak('man_o_war', 'MISSPCH_18_MO_03')
	elif a_hero == 'mentor':
		speak('mentor', 'MISSPCH_18_ME_03')
	elif a_hero == 'microwave':
		speak('microwave', 'MISSPCH_18_MW_03')
	elif a_hero == 'order':
		speak('order', 'MISSPCH_18_OR_03')
	elif a_hero == 'quetzalcoatl':
		speak('quetzalcoatl', 'MISSPCH_18_QZ_03')
	elif a_hero == 'sea_urchin':
		speak('sea_urchin', 'MISSPCH_18_SU_04')
	elif a_hero == 'sky_king':
		speak('sky_king', 'MISSPCH_18_SY_03')
	elif a_hero == 'supercollider':
		speak('supercollider', 'MISSPCH_18_SC_03')
	elif a_hero == 'tombstone':
		speak('tombstone', 'MISSPCH_18_TS_03')
	elif a_hero == 'tricolour':
		speak('tricolour', 'MISSPCH_18_TC_04')
	else:
		print "Custom character?"
		forceSpeak('the_ant','MISSPCH_18_AN_18')


def Wave4Setup():
	removeArrow('police_station_arrow')
	regDeath('_impobj_museum','MuseumSmashed')
	musgoal = KillObjects('_impobj_museum')
	playEffectMarker('effect_entropy_spawn','spawn_w4c1'),
	StandardWarpEffect(Get_MarkerPos('spawn_w4c1'))
	spawn('wave4_cen1','centurion','spawn_w4c1')
	playEffectMarker('effect_entropy_spawn','spawn_w4c2'),
	StandardWarpEffect(Get_MarkerPos('spawn_w4c2'))
	spawn('wave4_cen2','centurion','spawn_w4c2')
	playEffectMarker('effect_entropy_spawn','spawn_w4w1'),
	StandardWarpEffect(Get_MarkerPos('spawn_w4w1'))
	spawn('wave4_wra1','wraith_warrior','spawn_w4w1')
	playEffectMarker('effect_entropy_spawn','marker_spawn_fort_mus'),
	StandardWarpEffect(Get_MarkerPos('marker_spawn_fort_mus'))
	spawn('fortissimo_museum','fortissimo','marker_spawn_fort_mus')
	addGoalToAI('wave4_cen1',musgoal,PRI_LOW)
	addGoalToAI('wave4_cen2',musgoal,PRI_LOW)
	addGoalToAI('fortissimo_museum',musgoal,PRI_MED)
	addGoalToAI('wave4_wra1',musgoal,PRI_HI)
	addKillAllGoal('wave4_cen1',OC_CONTROLLABLE,ai.goal.PRI_MED)
	addKillAllGoal('wave4_cen1',OC_CONTROLLABLE,ai.goal.PRI_MED)
	addKillAllGoal('wave4_wra1',OC_CONTROLLABLE,ai.goal.PRI_MED)
	addKillAllGoal('fortissimo_museum',OC_CONTROLLABLE,ai.goal.PRI_MED)
	Mission_SetAttr('wave4_killed', 0)
	regDeath('wave4_cen1','Wave4Kill')
	regDeath('wave4_cen2','Wave4Kill')
	regDeath('wave4_wra1','Wave4Kill')
	regDeath('fortissimo_museum','Wave4Kill')
	regAlmostDead('fortissimo_museum','FortissimoDown',1)
def Wave4Kill(event):
	addAttr('wave4_killed',1)
	if Mission_GetAttr('wave4_killed') == 3:
		Objective_Complete('kill_minions')
		if (Objective_IsFailed('save_museum') == 0):
			Objective_Complete('save_museum')
def MuseumSmashed(event):
	if Object_IsAlive('wave4_cen1'):
		addArrow('w4c1','wave4_cen1',ARROW_RED,1)
	if Object_IsAlive('wave4_cen2'):
		addArrow('w4c2','wave4_cen2',ARROW_RED,1)
	if Object_IsAlive('wave4_wra1'):
		addArrow('w4w1','wave4_wra1',ARROW_RED,1)
	if (Objective_IsComplete('save_museum') == 0):
		Objective_Fail('save_museum')

def FortissimoDown(event):
	Wave4Kill(event)
	play(fortissimo_down_ss,'fortissimo_down_ss')
	makeCriticalCustomFn('fortissimo_museum')
	AI_SetEnabled('fortissimo_museum',0)
	print 'Fortissimo Down function complete'


def interrogate_fortissimo_museum_fn(a_hero):
	if Mission_GetAttr('wave4_killed') < 3:
		play(clean_up_ss,'clean_up_ss')
	else:
		print "start playing fortissimo talk cs"
		removeArrow('museum_arrow')
		play(fortissimo_talk_cs, 'fortissimo_talk_cs')
def YuckLine():
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_18_MM_06')
	elif a_hero == 'black_jack':
		speak('black_jack', 'MISSPCH_18_BJ_04')
	elif a_hero == 'black_bird':
		speak('black_bird', 'MISSPCH_18_BB_05')
	elif a_hero == 'bullet':
		speak('bullet', 'MISSPCH_18_BL_04')
	elif a_hero == 'eve':
		speak('eve', 'MISSPCH_18_EV_05')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_18_GG_05')
	elif a_hero == 'iron_ox':
		speak('iron_ox', 'MISSPCH_18_IO_04')
	elif a_hero == 'law':
		speak('order', 'MISSPCH_18_OR_04')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_18_LL_04')
	elif a_hero == 'man_bot':
		speak('man_bot', 'MISSPCH_18_MB_05')
	elif a_hero == 'man_o_war':
		speak('man_o_war', 'MISSPCH_18_MO_04')
	elif a_hero == 'mentor':
		speak('mentor', 'MISSPCH_18_ME_04')
	elif a_hero == 'microwave':
		speak('microwave', 'MISSPCH_18_MW_04')
	elif a_hero == 'order':
		speak('order', 'MISSPCH_18_OR_04')
	elif a_hero == 'quetzalcoatl':
		speak('quetzalcoatl', 'MISSPCH_18_QZ_04')
	elif a_hero == 'sea_urchin':
		speak('sea_urchin', 'MISSPCH_18_SU_05')
	elif a_hero == 'sky_king':
		speak('sky_king', 'MISSPCH_18_SY_04')
	elif a_hero == 'supercollider':
		speak('supercollider', 'MISSPCH_18_SC_04')
	elif a_hero == 'tombstone':
		speak('tombstone', 'MISSPCH_18_TS_04')
	elif a_hero == 'tricolour':
		speak('tricolour', 'MISSPCH_18_TC_05')
	else:
		print "Custom character?"
		forceSpeak('the_ant','MISSPCH_18_AN_19')
def DinoHere(event):
	print "spawning T rex"
	kill('_impobj_dinosaur_statue')
	spawn('dino','trex','dino_spawn_marker')
	peace()
	regDeath('dino','DinoDead')
def EntropyGone(event):
	Object_Destroy('entropy')
def DinoDead(event):
	Objective_Complete('kill_dino')
	play(final_cs,'final_cs')


def FinaleSetup():
	reviveHeroes()
	spawn('entropy','entropy', 'entropy_end')
	teleport('hero_1','hero1_end')
	teleport('hero_2','hero2_end')
	teleport('hero_3','hero3_end')
	teleport('hero_4','hero4_end')
	peace()
	if Object_GetTemplate('hero_1') == 'man_bot':
		teleport('hero_1','mb_end')
	elif Object_GetTemplate('hero_2') == 'man_bot':
		teleport('hero_2','mb_end')
	elif Object_GetTemplate('hero_3') == 'man_bot':
		teleport('hero_3','mb_end')
	elif Object_GetTemplate('hero_4') == 'man_bot':
		teleport('hero_4','mb_end')
	else:
		spawn('man_bot','man_bot','mb_end')


def OnMissionWon():
	print "symphony/won"

def OnMissionLost():
	print "symphony/lost"


#										 #
# cutscenes and scripted sequences below  #
#										 #


start_cs = [
(
	"peace()",
	"startCS()",
	"see()",
	"look('fortissimo', zoom = -50, heading = 200, time = 0)",
	"Sound_PlayMusic('music_05fort_cs1',1)",
	"Trigger_Power('fortissimo','fortissimo_target','fortissimo Deadly Chorus','')",
	"wait(2)",
),
(
	"speak('fortissimo', 'MISSPCH_18_FT_01')",
),
(
	"move('fortissimo','marker_fort_exit')",
	"forceSpeak('the_ant', 'MISSPCH_18_AN_01')",
),
(
	"endCS()",
	"blind()",
	"war()",
	"Sound_PlayMusic('music_10sym1')",
	"addArrow('opera_arrow','_impobj_opera_centre',ARROW_YELLOW,1)",
	"newObjective('primary', 1, name='kill_minions')",
	"newObjective('primary', 2, name='kill_fortissimo')",
	"newObjective('secondary', 1, name='save_opera')",
	"registerObjective('secondary', 2, name='save_hat')",
	"registerObjective('secondary', 3, name='save_cops')",
	"registerObjective('secondary', 4, name='save_museum')",
	"ff.StartCSDone()",
),
]

opera_down_ss = [
(
	"forceSpeak('fortissimo', 'MISSPCH_18_FT_02')",
),
(
	"forceSpeak('the_ant', 'MISSPCH_18_AN_02')",
),
(
	"blank",
),
]

top_hat_attack_ss = [
(
	"forceSpeak('fortissimo', 'MISSPCH_18_FT_03')",
),
(
	"forceSpeak('the_ant', 'MISSPCH_18_AN_03')",
),
(
	"Objective_Activate('save_hat')",
	"addArrow('top_hat_arrow','_impobj_top_hat_nightclub',ARROW_YELLOW,1)",
	"ff.CarBoomSetup()",
	"wait(0.05)",
),
(
	"blank",
),
]

car_boom_ss = [
(
	"forceSpeak('the_ant', 'MISSPCH_18_AN_04')",
),
(
	"forceSpeak('the_ant', 'MISSPCH_18_AN_15')",
),
(
	"optionalSpeak('man_bot', 'MISSPCH_18_MB_04')",
),
(
	"blank",
),
]

police_station_attack_ss = [
(
	"forceSpeak('fortissimo', 'MISSPCH_18_FT_04')",
),
(
	"Objective_Activate('save_cops')",
	"addArrow('police_station_arrow','_impobj_police_station',ARROW_YELLOW,1)",
	"forceSpeak('the_ant', 'MISSPCH_18_AN_05')",
),
(
	"blank",
),
]

movie_monsters_ss = [
(
	"forceSpeak('the_ant', 'MISSPCH_18_AN_06')",
),
(
	"forceSpeak('the_ant', 'MISSPCH_18_AN_16')",
),
(
	"blank",
),
]

chaos_cops_ss = [
(
	"forceSpeak('the_ant', 'MISSPCH_18_AN_07')",
),
(
	"ff.CopsLine()",
),
(
	"forceSpeak('the_ant', 'MISSPCH_18_AN_08')",
),
(
	"blank",
),
]

police_station_down_ss = [
(
	"forceSpeak('the_ant', 'MISSPCH_18_AN_09')",
),
(
	"forceSpeak('fortissimo', 'MISSPCH_18_FT_05')",
),
(
	"blank",
),
]

museum_attack_ss = [
(
	"forceSpeak('fortissimo', 'MISSPCH_18_FT_06')",
),
(
	"Objective_Activate('save_museum')",
	"addArrow('museum_arrow','_impobj_museum',ARROW_YELLOW,1)",
	"addArrow('w4fort','fortissimo_museum',ARROW_RED,1)",
	"forceSpeak('the_ant', 'MISSPCH_18_AN_10')",
),
(
	"blank",
),
]

museum_down_ss = [
(
	"forceSpeak('fortissimo', 'MISSPCH_18_FT_07')",
),
(
	"blank",
),
]

fortissimo_down_ss = [
(
	"forceSpeak('fortissimo', 'MISSPCH_18_FT_08')",
),
(
	"blank",
),
]

clean_up_ss = [
(
	"forceSpeak('the_ant', 'MISSPCH_18_AN_11')",
),
(
	"blank",
),
]

fortissimo_talk_cs = [
(
	"playTransition()",
	"look('ft_cam1', zoom = -50, heading = 0, time = 0)",
	"peace()",
	"startCS()",
	"see()",
	"reviveHeroes()",
	"teleport('fortissimo_museum','marker_ft_fort')",
	"teleport('hero_1','marker_ft_hero1')",
	"teleport('hero_2','marker_ft_hero2')",
	"teleport('hero_3','marker_ft_hero3')",
	"teleport('hero_4','marker_ft_hero4')",
),
(
	"speak('fortissimo_museum', 'MISSPCH_18_FT_09')",
),
(
	"Mission_Play2DCutscene('cutscene_fortissimo', 'cutscene_fortissimo_wav', 'onStepCB')",
	"kill('fortissimo_museum')",
	"ff.DinoHere(event)",
	"spawn('entropy','entropy','e_fort_talk')",
	"peace()",
),
(
	"Object_Destroy('fortissimo_museum')",
	"Sound_PlaySound('mission_symphony')",
	"ff.YuckLine()",
),
(
	"Objective_Complete('kill_fortissimo')",
	"forceSpeak('entropy', 'MISSPCH_18_EN_02')",
	"Sound_PlayMusic('music_09entropy_end2',1)",
),
(
	"forceSpeak('entropy', 'MISSPCH_18_EN_05')",
),
(
	"playEffectMarker('effect_entropy_spawn', 'e_fort_talk', key = 'spawn', keyFn = 'EntropyGone')",
	"newObjective('primary', 3, name='kill_dino')",
	"addArrow('dino_arrow','dino',ARROW_RED,1)",
	"endCS()",
	"Sound_PlayMusic('music_10sym')",
	"blind()",
	"war()",
),
]

final_cs = [
(
	"peace()",
	"startCS()",
	"look('dino')",
	"wait(2)",
),
(
	"ff.FinaleSetup()",
	"look('mb_end', zoom = -150, heading = 0)",
	"playTransition()",
),
(
	"forceSpeak('man_bot', 'MISSPCH_18_MB_02')",
	"Sound_PlaySound('mission_entropy')",
),
(
	"#look('entropy', zoom = -200, heading = 300)",
	"forceSpeak('entropy', 'MISSPCH_18_EN_04')",
),
(
	"forceSpeak('man_bot', 'MISSPCH_18_MB_06')",
),
(
	"forceSpeak('entropy', 'MISSPCH_18_EN_06')",
),
(
	"forceSpeak('entropy', 'MISSPCH_18_EN_07')",
),
(
	"forceSpeak('man_bot', 'MISSPCH_18_MB_07')",
),
(
	"forceSpeak('entropy', 'MISSPCH_18_EN_08')",
),
(
	"forceSpeak('entropy', 'MISSPCH_18_EN_09')",
),
(
	"forceSpeak('man_bot', 'MISSPCH_18_MB_08')",
),
(
	"forceSpeak('entropy', 'MISSPCH_18_EN_10')",
),
(
	"endCS()",
	"noLook()",
	"Mission_Win()",
),
]
