# elementals

from cshelper import *
from js import *
import event
	
def OnPostInit():
	print 'elementals base/start'
	#CS setup stuff
	Mission_SetSunlight(0, 60, 0.5, 0, (1,1,1))
	lookAtPos((40,30,4), zoom = -200.0, pitch = 0, heading = 35.0)
	Object_PlayEffect('_impobj_main_screen2', 'cs_screen_scan', '', FX_LOOP|FX_TRACK_OBJECT_ROT)
	Event_RegisterSink(EVENT_TIMER, 'WarpInManbot', '', '', 15)
	spawn('portal_spawn', 'invisible_object', 'idle_pos1')

	Campaign_UnRecruit('alchemiss')
	Campaign_UnlockOrigin('alchemiss')
	Campaign_UnRecruit('el_diablo')
	Campaign_UnlockOrigin('el_diablo')
	Campaign_Recruit('mentor')
	Campaign_UnlockOrigin('mentor')
	Campaign_Recruit('minute_man')
	Campaign_UnlockOrigin('minute_man')
	Campaign_AddHero ('liberty_lad')
	Campaign_UnlockOrigin('liberty_lad')
	Campaign_Recruit('tombstone')
	Campaign_UnlockOrigin('tombstone')
	Campaign_Recruit('bullet')
	Campaign_UnlockOrigin('bullet')
	Campaign_AddHero ('green_genie')
	Campaign_UnlockOrigin('green_genie')
	Campaign_AddHero ('quetzalcoatl')
	Campaign_UnlockOrigin('quetzalcoatl')
	Campaign_Recruit('the_ant')
	Campaign_UnlockOrigin('the_ant')
	Campaign_Recruit('eve')
	Campaign_UnlockOrigin('eve')
	Campaign_AddHero ('microwave')
	Campaign_UnRecruit('supercollider')
	Campaign_Recruit('black_jack')
	Campaign_UnlockOrigin('black_jack')
	Campaign_AddHero ('law')
	Campaign_UnlockOrigin('law')
	Campaign_AddHero ('order')
	Campaign_UnlockOrigin('order')
	Campaign_UnRecruit('ironox')
	Campaign_AddHero ('man_o_war')
	Campaign_UnlockOrigin('man_o_war')
	Campaign_AddHero ('sea_urchin')
	Campaign_UnlockOrigin('sea_urchin')
	Campaign_Recruit('tricolour')
	Campaign_UnlockOrigin('tricolour')
	Campaign_AddHero ('blackbird')
	Campaign_Recruit('sky_king')
	Campaign_UnlockOrigin('sky_king')
	Campaign_Recruit('man_bot')
	Campaign_UnlockOrigin('man_bot')
	Campaign_AddHero ('the_bard')

	Campaign_AddMinion('thug_with_bat')
	Campaign_AddMinion('thug_with_gun')
	Campaign_AddVillain('nuclear_winter')
	Campaign_AddVillain('time_master')
	Campaign_AddMinion('ice_trooper')
	Campaign_AddMinion('ice_sergeant')
	Campaign_AddMinion('snow_man')
	Campaign_AddMinion('shurale')
	Campaign_AddVillain('red_oktober')
	Campaign_AddMinion('dark_shaman')
	Campaign_AddVillain('frozen_giant')
	Campaign_AddMinion('nazi_rifleman')
	Campaign_AddMinion('legionnaire')
	Campaign_AddVillain('fortissimo')
	Campaign_AddVillain('red_sun')
	Campaign_AddMinion('nazi_gunner')
	Campaign_AddMinion('nazi_grenadier')
	Campaign_AddMinion('killarilla_whip')
	Campaign_AddMinion('killarilla_chaingun')
	Campaign_AddMinion('nazi_general')
	Campaign_AddMinion('eye_minor')
	Campaign_AddMinion('centurion')
	Campaign_AddMinion('eye_major')
	Campaign_AddVillain('blitzkrieg')
	Campaign_AddMinion('wraith_warrior')
	Campaign_AddMinion('trex')



#manbot and ironox warping in and out while idle
def WarpInManbot(event):
	if isCSPlaying():
		print "all warped out"
	elif Object_Exists('portal_spawn'):
		Object_PlayEffect('portal_spawn', 'effect_portal_open', 'ManbotAppears', FX_TRACK_OBJECT_ROT)
		
def WarpInIronox(event):
	if isCSPlaying():
		print "all warped out"
	elif Object_Exists('portal_spawn'):
		Object_PlayEffect('portal_spawn', 'effect_portal_open', 'IronoxAppears', FX_TRACK_OBJECT_ROT)
		
def ManbotAppears(event):
	if isCSPlaying():
		print "iron ox has left the building"
	else:
		spawn('manbot_idle', 'man_bot', 'idle_pos1')
		AI_Animate('manbot_idle', 'pain', '', 0, 0)
		Object_PlayEffect('portal_spawn', 'effect_portal_close', '', FX_TRACK_OBJECT_ROT)
		Event_RegisterSink(EVENT_TIMER, 'WarpOut', '', '', 5)
		
def IronoxAppears(event):
	if isCSPlaying():
		print "manbot has left the building"
	else:
		spawn('ironox_idle', 'ironox', 'idle_pos1')
		AI_Animate('ironox_idle', 'pain', '', 0, 0)
		Object_PlayEffect('portal_spawn', 'effect_portal_close', '', FX_TRACK_OBJECT_ROT)
		Event_RegisterSink(EVENT_TIMER, 'WarpOut', '', '', 7)
		
def WarpOut(event):
	if Object_Exists('portal_spawn'):
		Object_PlayEffect('portal_spawn', 'effect_portal_open', 'KillHero', FX_TRACK_OBJECT_ROT)		

def KillHero(event):
	if Object_Exists('manbot_idle'):
		Object_Destroy('manbot_idle')
		Object_PlayEffect('portal_spawn', 'effect_portal_close', '', FX_TRACK_OBJECT_ROT)
		Event_RegisterSink(EVENT_TIMER, 'WarpInIronox', '', '', 16)
	elif Object_Exists('ironox_idle'):
		Object_Destroy('ironox_idle')
		Object_PlayEffect('portal_spawn', 'effect_portal_close', '', FX_TRACK_OBJECT_ROT)
		Event_RegisterSink(EVENT_TIMER, 'WarpInManbot', '', '', 18)

#briefing starts
def OnBriefing():
	KillHero(1)
	Object_Destroy('portal_spawn')
	play(briefing_cs, 'briefing_cs')
	print 'elementals base/briefing'

#-----------
# data
#-----------

briefing_cs = [
(
	"startCS()",
	"lookAtPos((59,-151,0), zoom = -250.8, pitch = -5, heading = -219.3)",
	"speak('liberty_lad', 'BRFSPCH_19_LL_01', CAPTION_TOP_LEFT)", #Liberty Lad so let me see if i get th...
),
(
	"speak('mentor', 'BRFSPCH_19_ME_01', CAPTION_BOTTOM_RIGHT)", #Mentor that is correct.
),
(
	"speak('man_bot', 'BRFSPCH_19_MB_01', CAPTION_TOP_RIGHT)", #Man-Bot in other words, i am both...
	"Object_Spawn('man_o_war', 'man_o_war', 'hero_spawn')",
),
(
	"lookAtPos((118,-55,0), zoom = -261.4, pitch = -5, heading = 12.6)",
	"speak('mentor', 'BRFSPCH_19_ME_02', CAPTION_BOTTOM_LEFT)", #Mentor yes. and though i have se...
	"move('man_o_war', 'manowar_pos1', radius=0)",
),
(
	"speak('man_o_war', 'BRFSPCH_19_MO_01', CAPTION_TOP_LEFT)", #Man O' War what's this all about now...
),
(
	"lookAtPos((71,-11,0), zoom = -265.5, pitch = -5, heading = -32.0)",
	"speak('mentor', 'BRFSPCH_19_ME_03', CAPTION_TOP_LEFT)", #Mentor rings of rexor! can it be...
),
(
	"lookAtPos((118,-55,0), zoom = -261.4, pitch = -5, heading = 12.6)",
	"speak('liberty_lad', 'BRFSPCH_19_LL_02', CAPTION_TOP_RIGHT)", #Liberty Lad iron ox? who's that?
),
(
	"turnTo('man_o_war', 'liberty_lad')",
	"Sound_PlayMusic('music_11elem_base1',1)",
	"speak('man_o_war', 'BRFSPCH_19_MO_02', CAPTION_TOP_LEFT)", #Man O' War do i look like one who's ...
),
(
	"speak('mentor', 'BRFSPCH_19_ME_04', CAPTION_BOTTOM_LEFT)", #Mentor is it possible? can the t...
),
(
	"lookAtPos((59,-151,0), zoom = -250.8, pitch = -5, heading = -219.3)",
	"speak('man_bot', 'BRFSPCH_19_MB_02', CAPTION_TOP_LEFT)", #Man-Bot you mean?
),
(
	"speak('mentor', 'BRFSPCH_19_ME_05', CAPTION_BOTTOM_RIGHT)", #Mentor yes...the universe is str...
),
(
	"speak('liberty_lad', 'BRFSPCH_19_LL_03', CAPTION_TOP_LEFT)", #Liberty Lad memory of who?
	"Object_StopEffect('_impobj_main_screen2', 1)",
	"Object_PlayEffect('_impobj_main_screen2', 'cs_screen_city', '', FX_LOOP|FX_TRACK_OBJECT_ROT)",
),
(
	"lookAtPos((135,-14,0), zoom = -261.8, pitch = -5, heading =  115.7)",
	"Object_Spawn('eve', 'eve', 'hero_spawn')",
	"moveCB('mentor', 'mentor_pos2', radius=0)",
	"move('liberty_lad', 'lad_pos2', radius=0)",
	"move('man_bot', 'manbot_pos2', radius=0)",
),
(
	"lookAtPos((132,7,0), zoom = -200.0, pitch = -13, heading =  47.2)",
	"turnTo('mentor', '_impobj_main_screen2')",
	"turnTo('liberty_lad', '_impobj_main_screen2')",
	"turnTo('man_bot', '_impobj_main_screen2')",
	"move('man_o_war', 'manowar_pos2', radius=0)",
	"wait(3)",
),
(
	"lookAtPos((140,42,0), zoom = -268.8, pitch = -5, heading = 9.3)",
	"moveCB('eve', 'eve_pos1', radius=0)",
),
(
	"Sound_PlayMusic('music_05berlin_cs1',1)",
	"speak('eve', 'BRFSPCH_19_EV_01', CAPTION_TOP_LEFT)", #Eve fires have broken out all...
	"turnTo('mentor', 'eve')",
	"turnTo('liberty_lad', 'eve')",
	"turnTo('man_bot', 'eve')",
),
(
	"speak('mentor', 'BRFSPCH_19_ME_06', CAPTION_TOP_RIGHT)", #Mentor eve, remain here and try ...
),
(
	"endBriefingCS()",
),
]

