# elementals

# 1 - spawn Red Sun
# 2 - regPower for when that Red Sun uses Elemental power
# 3 - Each time that happens, check to see if any civilians of the current wave are left
# 4 - if there are, iterate through all Elementals and give them an Ai Goal to kill civs

from cshelper import *
from js import *
import event
from ffx import *

def OnPrecacheObjects():
	print "elementals/precache"
	Mission_PrecacheTemplateObj('fire_elemental', 0, 1)
	Mission_PrecacheTemplateObj('civilian_male', 1, 0)
	Mission_PrecacheTemplateObj('civilian_female', 1, 0)
	Mission_PrecacheTemplateObj('wraith_warrior', 1, 1)
	Mission_PrecacheTemplateObj('wraith_manta', 1, 1)
	Mission_PrecacheTemplateObj('subterrestrial', 1, 1)
	Mission_PrecacheTemplateObj('eve', 1, 0)
	Mission_PrecacheTemplateObj('man_bot', 1, 0)
	Mission_PrecacheTemplateObj('green_genie', 1, 0)
	Mission_PrecacheTemplateObj('entropy', 1, 1)

def OnPostInit():
	print "elementals/start"
	setMission(19)
	
	Mission_SetSunlight(-140,70,1.0,0.8,(0.7,0.6,0.6))
	Mission_SetShadows(-140,70,(0.2,0.2,0.4))
	Mission_SetProjShadowBackground((1,1,1))
	Mission_SetProjShadowColor((.6,.6,.6,1))

	Mission_SetAttr('civilians_dead', 0)
	Mission_SetAttr('first_civs_dead', 0)
	Mission_SetAttr('second_civs_dead', 0)
	Mission_SetAttr('third_civs_dead', 0)
	Mission_SetAttr('second_wave_launched', 0)
	Mission_SetAttr('third_wave_launched', 0)
	Mission_SetAttr('fourth_wave_launched', 0)
	Mission_SetAttr('elemental_count', 0)
	Mission_SetAttr('two_suns_dead', 0)

	Mission_SetAttr('merge_barks_played', 0)
	Mission_SetAttr('merge_bark_recent', 0)

	Mission_SetAttr('boom_barks_played', 0)
	Mission_SetAttr('boom_bark_recent', 0)

	Mission_SetAttr('uber_spawns', 0)

# used for controlling the waves of wraiths and subs
	Mission_SetAttr('wave_dead', 0)
	Mission_SetAttr('wave_active', 0)
	Mission_SetAttr('first_wave_down', 0)
	Mission_SetAttr('second_wave_up', 0)
	Mission_SetAttr('second_wave_down', 0)
	Mission_SetAttr('third_wave_up', 0)
	Mission_SetAttr('third_wave_down', 0)
	Mission_SetAttr('played_first_retreat', 0)

	Mission_SetAttr('evehandle', 0)

	Mission_SetAttr('wave_id',1)
	Mission_SetAttr('w11s11_anim_count',0)
	Mission_SetAttr('w11s12_anim_count',0)
	Mission_SetAttr('w12s11_anim_count',0)
	Mission_SetAttr('w12s12_anim_count',0)

# This sets how close is "close" for wraith/sub proximity
	Mission_SetAttr('distance_check',250)

# These are used to "lock down" a given pair of wraith/subs, so any given one can only be involved in one interaction at a time.
	Mission_SetAttr('prox_w11_s11', 0)
	Mission_SetAttr('prox_w12_s11', 0)
	Mission_SetAttr('prox_w11_s12', 0)
	Mission_SetAttr('prox_w12_s12', 0)

# The first four fire elementals start out "pre spawned"
	spawn('minion1_1', 'fire_elemental', 'minion_marker1_1')
	spawn('minion1_2', 'fire_elemental', 'minion_marker1_2')
#	spawn('minion1_3', 'fire_elemental', 'minion_marker1_3')

	ff.addArrow('minion1_1_arrow', 'minion1_1', js.ARROW_YELLOW, delete = 1)
	ff.addArrow('minion1_2_arrow', 'minion1_2', js.ARROW_YELLOW, delete = 1)
#	ff.addArrow('minion1_3_arrow', 'minion1_3', js.ARROW_RED, delete = 1)

#	spawn('minion1_4', 'fire_elemental', 'minion_marker1_4')

	addKillAllGoal('minion1_1', OC_CIVILIAN, priority = ai.goal.PRI_LOW, fn = '', user = 0, permanent = 0, replace = 0)
	addKillAllGoal('minion1_2', OC_CIVILIAN, priority = ai.goal.PRI_LOW, fn = '', user = 0, permanent = 0, replace = 0)

	regDeaths('civilian_male', 'OnCivilianDied')
	regDeaths('civilian_female', 'OnCivilianDied')

#	regDeaths('fire_elemental', 'OnElemental1Killed')

	regDeath('civilian_group1_1', 'OnFirstGroupCivDead')
	regDeath('civilian_group1_2', 'OnFirstGroupCivDead')
	regDeath('civilian_group1_3', 'OnFirstGroupCivDead')

	regDeath('red_sun1', 'OnRedSun1Dead')

	regPowerUse('red_sun1', 'red sun Living Fires','OnSunOneSummons')

	spawn('w11_standin','fx_standin','w11_spawn_point')
	spawn('w12_standin','fx_standin','w12_spawn_point')
	spawn('s11_standin','fx_standin','s11_spawn_point')
	spawn('s12_standin','fx_standin','s12_spawn_point')
	spawn('w21_standin','fx_standin','w21_spawn_point')
	spawn('w22_standin','fx_standin','w22_spawn_point')
	spawn('s21_standin','fx_standin','s21_spawn_point')
	spawn('s22_standin','fx_standin','s22_spawn_point')
	spawn('w31_standin','fx_standin','w31_spawn_point')
	spawn('w32_standin','fx_standin','w32_spawn_point')
	spawn('s31_standin','fx_standin','s31_spawn_point')
	spawn('s32_standin','fx_standin','s32_spawn_point')

	spawn('entropy_standin','fx_standin','entropy_spawn_marker')
	spawn('red_sun_standin','fx_standin','red_sun_5_marker')
	spawn('eve_standin','fx_standin','eve_run_target')

	spawn('merge_cs_object1', 'fx_standin', 'merge_cs_marker1')
	spawn('merge_cs_object2', 'fx_standin', 'merge_cs_marker2')

	Mission_SetAttr('cs_playing', 1)

	play(start_cs,'start_cs')
	FFX_InitMission()

def GetThingsStarted():
	regTimer('MarketDay', 5)

def OnCivilianDied(event):
	addAttr('civilians_dead', 1)
	if Mission_GetAttr('civilians_dead') == 3:
		speakNoCB('eve', 'MISSPCH_19_EV_03')
	if Mission_GetAttr('civilians_dead') == 5:
		speakNoCB('eve', 'MISSPCH_19_EV_04')
	if Mission_GetAttr('civilians_dead') == 8:
		speakNoCB('eve', 'MISSPCH_19_EV_05')
		print "Failed to protect Civilians!"
		Objective_Fail('save_civilians')

def OnFirstGroupCivDead(event):
	addAttr('first_civs_dead', 1)
	if Mission_GetAttr('first_civs_dead') == 3:
		if Mission_GetAttr('second_wave_launched') == 0:
			Mission_SetAttr('second_wave_launched', 1)
			play(second_sun_wave_cs, "second_sun_wave_cs")

#this gets triggered each time Red Sun 1 uses the Living Fires power
def OnSunOneSummons(event):
	regTimer('FiresAttackOne', 2)

def FiresAttackOne(event):
	if Mission_GetAttr('second_wave_launched') == 0:
		#if Object_IsAlive('civilian_group1_1'):
		enemylist = getAllBaddies(checkLiving=1)
		for baddie in enemylist:
			if Object_GetClass(baddie) == OC_MINION:
				addKillAllGoal(baddie, OC_CIVILIAN, priority = ai.goal.PRI_LOW, fn = '', user = 0, permanent = 0, replace = 0)

#this gets triggered each time Red Sun 2 uses the Living Fires power
def OnSunTwoSummons(event):
	regTimer('FiresAttackTwo', 2)

def FiresAttackTwo(event):
	if Mission_GetAttr('third_wave_launched') == 0:
		#if Object_IsAlive('civilian_group1_1'):
		enemylist = getAllBaddies(checkLiving=1)
		for baddie in enemylist:
			if Object_GetClass(baddie) == OC_MINION:
				addKillAllGoal(baddie, OC_CIVILIAN, priority = ai.goal.PRI_LOW, fn = '', user = 0, permanent = 0, replace = 0)

#this gets triggered each time Red Sun 3 uses the Living Fires power
def OnSunThreeSummons(event):
	regTimer('FiresAttackThree', 2)

def FiresAttackThree(event):
	if Mission_GetAttr('fourth_wave_launched') == 0:
		#if Object_IsAlive('civilian_group1_1'):
		enemylist = getAllBaddies(checkLiving=1)
		for baddie in enemylist:
			if Object_GetClass(baddie) == OC_MINION:
				addKillAllGoal(baddie, OC_CIVILIAN, priority = ai.goal.PRI_LOW, fn = '', user = 0, permanent = 0, replace = 0)






def OnRedSun1Dead(event):
	if Mission_GetAttr('second_wave_launched') == 0:
		Mission_SetAttr('second_wave_launched', 1)
		play(second_sun_wave_cs, "second__sun_wave_cs")

def SecondSunWave():
	spawn('red_sun2', 'red_sun', 'red_sun_2_marker')
	spawn('civilian_group2_1', 'civilian_male', 'civ_group2_1')
	spawn('civilian_group2_2', 'civilian_female', 'civ_group2_2')
	spawn('civilian_group2_3', 'civilian_male', 'civ_group2_3')
	spawn('civilian_group2_4', 'civilian_female', 'civ_group2_4')
#	spawn('civilian_group2_5', 'civilian_male', 'civ_group2_5')

	Object_SetAttr('red_sun2', 'maxHealth', 80)
	Object_SetAttr('red_sun2', 'health', 80)
	regPowerUse('red_sun2', 'red sun Living Fires','OnSunTwoSummons')

	regDeath('civilian_group2_1', 'OnSecondGroupCivDead')
	regDeath('civilian_group2_2', 'OnSecondGroupCivDead')
	regDeath('civilian_group2_3', 'OnSecondGroupCivDead')
	regDeath('civilian_group2_4', 'OnSecondGroupCivDead')
#	regDeath('civilian_group2_5', 'OnSecondGroupCivDead')

	regDeath('red_sun2', 'OnRedSun2Dead')

#	ff.addArrow('civ2_1_arrow', 'civilian_group2_1', js.ARROW_RED, delete = 1)
#	ff.addArrow('civ2_2_arrow', 'civilian_group2_2', js.ARROW_RED, delete = 1)
#	ff.addArrow('civ2_3_arrow', 'civilian_group2_3', js.ARROW_RED, delete = 1)
#	ff.addArrow('civ2_4_arrow', 'civilian_group2_4', js.ARROW_RED, delete = 1)
#	ff.addArrow('civ2_5_arrow', 'civilian_group2_5', js.ARROW_RED, delete = 1)

	ff.addArrow('redsun2_arrow', 'red_sun2', js.ARROW_RED, delete = 1)


#	ff.removeArrow('civ1_1_arrow')
#	ff.removeArrow('civ1_2_arrow')
#	ff.removeArrow('civ1_3_arrow')
#	ff.removeArrow('civ1_4_arrow')
#	ff.removeArrow('civ1_5_arrow')


	spawn('minion2_1', 'fire_elemental', 'minion_marker2_1')
	spawn('minion2_2', 'fire_elemental', 'minion_marker2_2')
#	spawn('minion2_3', 'fire_elemental', 'minion_marker2_3')
#	spawn('minion2_4', 'fire_elemental', 'minion_marker2_4')

	ff.addArrow('minion2_1_arrow', 'minion2_1', js.ARROW_YELLOW, delete = 1)
	ff.addArrow('minion2_2_arrow', 'minion2_2', js.ARROW_YELLOW, delete = 1)
#	ff.addArrow('minion2_3_arrow', 'minion2_3', js.ARROW_RED, delete = 1)


	spawn('tree1', 'cub_palm1', 'tree_marker1')
	playEffectMarker('effect_spawn_palm_tree', 'tree_marker1')
	playEffectMarker('effect_spawn_power', 'tree_marker1')
	spawn('tree2', 'cub_palm1', 'tree_marker2')
	playEffectMarker('effect_spawn_palm_tree', 'tree_marker2')
	playEffectMarker('effect_spawn_power', 'tree_marker2')
	spawn('tree3', 'cub_palm1', 'tree_marker3')
	playEffectMarker('effect_spawn_palm_tree', 'tree_marker3')
	playEffectMarker('effect_spawn_power', 'tree_marker3')
	spawn('tree4', 'cub_palm1', 'tree_marker4')
	playEffectMarker('effect_spawn_palm_tree', 'tree_marker4')
	playEffectMarker('effect_spawn_power', 'tree_marker4')
	spawn('tree5', 'cub_palm1', 'tree_marker5')
	playEffectMarker('effect_spawn_palm_tree', 'tree_marker5')
	playEffectMarker('effect_spawn_power', 'tree_marker5')
	spawn('tree6', 'cub_palm1', 'tree_marker6')
	playEffectMarker('effect_spawn_palm_tree', 'tree_marker6')
	playEffectMarker('effect_spawn_power', 'tree_marker6')

	regTimer('SpeakOfTrees', 10)

	print "second wave starting"


def OnSecondGroupCivDead(event):
	addAttr('second_civs_dead', 1)
	if Mission_GetAttr('second_civs_dead') == 5:
		if Mission_GetAttr('third_wave_launched') == 0:
			Mission_SetAttr('third_wave_launched', 1)
			play(third_sun_wave_cs, "third_sun_wave_cs")

def OnRedSun2Dead(event):
	if Mission_GetAttr('third_wave_launched') == 0:
		Mission_SetAttr('third_wave_launched', 1)
		play(third_sun_wave_cs, "third_sun_wave_cs")


def ThirdSunWave():
	print "Third Wave Starting"
	spawn('red_sun3', 'red_sun', 'red_sun_3_marker')
	spawn('red_sun4', 'red_sun', 'red_sun_4_marker')
	spawn('civilian_group3_1', 'civilian_male', 'civ_group3_1')
	spawn('civilian_group3_2', 'civilian_female', 'civ_group3_2')
	spawn('civilian_group3_3', 'civilian_male', 'civ_group3_3')
	spawn('civilian_group3_4', 'civilian_female', 'civ_group3_4')
#	spawn('civilian_group3_5', 'civilian_male', 'civ_group3_5')

	Object_SetAttr('red_sun3', 'maxHealth', 90)
	Object_SetAttr('red_sun4', 'maxHealth', 90)
	Object_SetAttr('red_sun3', 'health', 90)
	Object_SetAttr('red_sun4', 'health', 90)

	regDeath('civilian_group3_1', 'OnThirdGroupCivDead')
	regDeath('civilian_group3_2', 'OnThirdGroupCivDead')
	regDeath('civilian_group3_3', 'OnThirdGroupCivDead')
	regDeath('civilian_group3_4', 'OnThirdGroupCivDead')
#	regDeath('civilian_group3_5', 'OnThirdGroupCivDead')

	regDeath('red_sun3', 'OnRedSun3Dead')
	regDeath('red_sun4', 'OnRedSun3Dead')

	regPowerUse('red_sun3', 'red sun Living Fires','OnSunThreeSummons')
	regPowerUse('red_sun4', 'red sun Living Fires','OnSunThreeSummons')

	spawn('minion3_1', 'fire_elemental', 'minion_marker3_1')
	spawn('minion3_2', 'fire_elemental', 'minion_marker3_2')

	ff.addArrow('minion3_1_arrow', 'minion3_1', js.ARROW_YELLOW, delete = 1)
	ff.addArrow('minion3_2_arrow', 'minion3_2', js.ARROW_YELLOW, delete = 1)

	spawn('radio_tower1', 'ger_radio_tower', 'rand_marker2_1')
	playEffectMarker('effect_spawn_radio_tower', 'rand_marker2_1')
	playEffectMarker('effect_spawn_power', 'rand_marker2_1')

	spawn('fountain1', 'park_fountain_berlin', 'rand_marker2_2')
	playEffectMarker('effect_spawn_park_fountain', 'rand_marker2_2')
	playEffectMarker('effect_spawn_power', 'rand_marker2_2')

	spawn('cauldron1', 'red_int_cauldron', 'rand_marker2_3')
	playEffectMarker('effect_spawn_cauldron', 'rand_marker2_3')
	playEffectMarker('effect_spawn_power', 'rand_marker2_3')

	spawn('amp1', 'nazihq_temporal_amplifier', 'rand_marker2_4')
	playEffectMarker('effect_spawn_temporal_amp', 'rand_marker2_4')
	playEffectMarker('effect_spawn_power', 'rand_marker2_4')

	spawn('amp2', 'nazihq_temporal_amplifier', 'rand_marker2_5')
	playEffectMarker('effect_spawn_temporal_amp', 'rand_marker2_5')
	playEffectMarker('effect_spawn_power', 'rand_marker2_5')

	spawn('tree7', 'cub_palm1', 'rand_marker2_6')
	playEffectMarker('effect_spawn_palm_tree', 'rand_marker2_6')
	playEffectMarker('effect_spawn_power', 'rand_marker2_6')

def SpeakOfTrees(event):
	play(trees_ss, 'trees_ss')


def OnThirdGroupCivDead(event):
	addAttr('third_civs_dead', 1)
	if Mission_GetAttr('third_civs_dead') == 5:
		if Mission_GetAttr('fourth_wave_launched') == 0:
			Mission_SetAttr('fourth_wave_launched', 1)
			play(fourth_sun_wave_cs, "fourth_sun_wave_cs")

def OnRedSun3Dead(event):
	if Mission_GetAttr('fourth_wave_launched') == 0:
		addAttr('two_suns_dead', 1)
		if Mission_GetAttr('two_suns_dead') == 2:
			Mission_SetAttr('fourth_wave_launched', 1)
			play(fourth_sun_wave_cs, "fourth_sun_wave_cs")

def FourthSunWave():
	print "Fourth Wave Starting"
	spawn('red_sun5', 'red_sun', 'red_sun_5_marker')
	spawn('minion4_1', 'fire_elemental', 'minion_marker4_1')
	spawn('minion4_2', 'fire_elemental', 'minion_marker4_2')
	spawn('minion4_3', 'fire_elemental', 'minion_marker4_3')

	Object_SetAttr('red_sun5', 'maxHealth', 100)
	Object_SetAttr('red_sun5', 'health', 100)

	regDeath('red_sun5', 'OnSunsDead')

	makeInterrogationFn('red_sun5',oneshot=1)

	ff.addArrow('redsun4_arrow', 'red_sun5', js.ARROW_RED, delete = 1)

	spawn('radio_tower2', 'ger_radio_tower', 'rand_marker3_1')
	playEffectMarker('effect_spawn_radio_tower', 'rand_marker3_1')
	playEffectMarker('effect_spawn_power', 'rand_marker3_1')

	spawn('fountain2', 'park_fountain_berlin', 'rand_marker3_2')
	playEffectMarker('effect_spawn_park_fountain', 'rand_marker3_2')
	playEffectMarker('effect_spawn_power', 'rand_marker3_2')

	spawn('cauldron2', 'red_int_cauldron', 'rand_marker3_3')
	playEffectMarker('effect_spawn_cauldron', 'rand_marker3_3')
	playEffectMarker('effect_spawn_power', 'rand_marker3_3')

	spawn('amp3', 'nazihq_temporal_amplifier', 'rand_marker3_4')
	playEffectMarker('effect_spawn_temporal_amp', 'rand_marker3_4')
	playEffectMarker('effect_spawn_power', 'rand_marker3_4')

	spawn('cauldron3', 'red_int_cauldron', 'rand_marker3_5')
	playEffectMarker('effect_spawn_cauldron', 'rand_marker3_5')
	playEffectMarker('effect_spawn_power', 'rand_marker3_5')



def OnSunsDead(event):
	Objective_Complete('defeat_red_suns')

def interrogate_red_sun5_fn(char):
	play(new_friends_cs, 'new_friends_cs')

def MarketDay(event):
	print "playing markert day ss"
	play(market_day_ss, "market_day_ss")

def TeleportHeroes():
	if Object_IsAlive('red_sun5'):
		teleport('red_sun5', 'red_sun_5_marker')
	herolist = getAllHeroes()
	temp = 0
	for hero in herolist:
		if Object_IsAlive(hero):
			if temp == 0:
				teleport(hero, 'hero_cutscene_marker1')
				temp = 1
			elif temp == 1:
				teleport(hero, 'hero_cutscene_marker2')
				temp = 2
			elif temp == 2:
				teleport(hero, 'hero_cutscene_marker3')
				temp = 3
			elif temp == 3:
				teleport(hero, 'hero_cutscene_marker4')
				temp = 4

# this series of functions gets played in the cutscene where Entropy shows you how merging works
#-----------------------------------------------------------------------------
def SampleMerge():
	print "sample merge"
	Object_PlayEffect('merge_cs_object1', 'effect_portal_open', 'SpawnSamples',FX_TRACK_OBJECT_ROT)
	Object_PlayEffect('merge_cs_object2', 'effect_portal_open', '',FX_TRACK_OBJECT_ROT)

def SpawnSamples(event):
	print "spawning wraith"
	print "spawning sub-t"
	spawn('sample_wraith','wraith_warrior','merge_cs_marker1')
	spawn('sample_sub','subterrestrial','merge_cs_marker2')
	AI_Animate('sample_wraith','absorbing_beam')
	AI_Animate('sample_sub','energy_taken')
	AI_SetEnabled('sample_sub',0)
	AI_SetEnabled('sample_wraith',0)
	# Subterrestrial turns towards Wraith, and plays "preparing to blast" anim
	turnTo('sample_sub','sample_wraith')
	regTimer('SampleZapBoom',2)

def SampleZapBoom(event):
	# trigger a power for the FX -- this is currently placeholder
	print "playing power FX"
	Trigger_Power('sample_sub','sample_wraith','subterrestrial Life Suck','')
	regTimer('SampleFinishBoom',4)

def SampleFinishBoom(event):
	print "kaboom!"
	wraith_loc = Get_ObjectPos('sample_wraith')
	wraith_rot = Object_GetOrientation('sample_wraith')
	Marker_Spawn('sample_uber_point',wraith_loc,wraith_rot[1])
	kill('sample_sub')
	Trigger_Explosion('sample_wraith','wraith warrior Explode')
	kill('sample_wraith')
	# spawn the UberWraith
	regTimer('SpawnSampleUber',1)

def SpawnSampleUber(event):
	print "spawning uber-wraith"
	spawn('sample_uber','wraith_manta','sample_uber_point')
	peace()


def OnMissionWon():
	print "elementals/won"
	#Mission_UnRecruit('eve')  # not yet implemented
	#Mission_UnRecruit('microwave')  # not yet implemented

def OnMissionLost():
	print "elementals/lost"


#-----------------------------------------------------------
# Here's where the UberWraith Madness(tm) starts
#-----------------------------------------------------------

#This function seems to be using different units than regProximityEnter
def CheckDistance(thing1,thing2):
	if (not Object_IsAlive(thing1)) or (not Object_IsAlive(thing2)) or (not normal(thing1)) or (not normal(thing2)) or (isHero(thing1)) or (isHero(thing2)):
		print "checking distance on a dead or warped or possessed object"
		return 1000
	else:
		pos1 = Get_ObjectPos(thing1)
		pos2 = Get_ObjectPos(thing2)
		xdelt = abs(pos1[0] - pos2[0])
		ydelt = abs(pos1[1] - pos2[1])
		zdelt = abs(pos1[2] - pos2[2])
		distance = sqrt(xdelt**2 + ydelt**2 + zdelt**2)
		print distance
		return distance

#This function plays the spawn-in effects, and then calls the funcs that spawn the first wave
def NewFriendsWait():
	print "NewFriendsWait playing: spawning friends in 10 seconds"
	regTimer('NewFriends', 10)

def NewFriends(event):
	print "new friends"
	Object_PlayEffect('w11_standin', 'effect_portal_open', 'W11Spawn',FX_TRACK_OBJECT_ROT)
	Object_PlayEffect('w12_standin', 'effect_portal_open', 'W12Spawn',FX_TRACK_OBJECT_ROT)
	Object_PlayEffect('s11_standin', 'effect_portal_open', 'S11Spawn',FX_TRACK_OBJECT_ROT)
	Object_PlayEffect('s12_standin', 'effect_portal_open', 'S12Spawn',FX_TRACK_OBJECT_ROT)


# This is the first wave, called right after the 'New Friends' cutscene
# The RegDeaths keeps track of how many creatures in Wave 1 have been killed
def W11Spawn(event):
	spawn('wraith_1_1','wraith_warrior','w11_spawn_point')
#	Mission_AddArrowObject('wraith_1_1_arrow', 'wraith_1_1', 'js.ARROW_YELLOW', delete = 1)
	addArrow('wraith_1_1_arrow','wraith_1_1',ARROW_RED,1)
	regDeath('wraith_1_1','AWaveKill')
	Object_PlayEffect('w11_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	if Mission_GetAttr('cs_playing') == 1:
		AI_SetEnabled('wraith_1_1',0)
def W12Spawn(event):
	spawn('wraith_1_2','wraith_warrior','w12_spawn_point')
#	Mission_AddArrowObject('wraith_1_2_arrow', 'wraith_1_2', 'js.ARROW_YELLOW', delete = 1)
	addArrow('wraith_1_2_arrow','wraith_1_2',ARROW_RED,1)
	regDeath('wraith_1_2','AWaveKill')
	Object_PlayEffect('w12_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	if Mission_GetAttr('cs_playing') == 1:
		AI_SetEnabled('wraith_1_2',0)
def S11Spawn(event):
	spawn('sub_1_1','subterrestrial','s11_spawn_point')
#	Mission_AddArrowObject('sub_1_1_arrow', 'sub_1_1', 'js.ARROW_YELLOW', delete = 1)
	addArrow('sub_1_1_arrow','sub_1_1',ARROW_RED,1)
	regDeath('sub_1_1','AWaveKill')
	Object_PlayEffect('s11_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	if Mission_GetAttr('cs_playing') == 1:
		AI_SetEnabled('sub_1_1',0)
def S12Spawn(event):
	spawn('sub_1_2','subterrestrial','s12_spawn_point')
#	Mission_AddArrowObject('sub_1_2_arrow', 'sub_1_2', 'js.ARROW_YELLOW', delete = 1)
	addArrow('sub_1_2_arrow','sub_1_2',ARROW_RED,1)
	regDeath('sub_1_2','AWaveKill')
	Object_PlayEffect('s12_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	if Mission_GetAttr('cs_playing') == 1:
		AI_SetEnabled('sub_1_2',0)
# each wave needs one of these.
	FirstWaveUp(event)


# NOTE: waves 2 and 3 re-use the names from wave 1 to save on code bloat
# These blocks for waves 2 and 3 are called basically from enough counted deaths in previous waves
def W21Spawn(event):
	spawn('wraith_1_1','wraith_warrior','w21_spawn_point')
#	Mission_AddArrowObject('wraith_1_1_arrow', 'wraith_1_1', js.ARROW_YELLOW, delete = 1)
	addArrow('wraith_1_1_arrow','wraith_1_1',ARROW_RED,1)
	regDeath('wraith_1_1','AWaveKill')
	Object_PlayEffect('w21_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
def W22Spawn(event):
	spawn('wraith_1_2','wraith_warrior','w22_spawn_point')
#	Mission_AddArrowObject('wraith_1_2_arrow', 'wraith_1_2', js.ARROW_YELLOW, delete = 1)
	addArrow('wraith_1_2_arrow','wraith_1_2',ARROW_RED,1)
	regDeath('wraith_1_2','AWaveKill')
	Object_PlayEffect('w22_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
def S21Spawn(event):
	spawn('sub_1_1','subterrestrial','s21_spawn_point')
#	Mission_AddArrowObject('sub_1_1_arrow', 'sub_1_1', js.ARROW_YELLOW, delete = 1)
	addArrow('sub_1_1_arrow','sub_1_1',ARROW_RED,1)
	regDeath('sub_1_1','AWaveKill')
	Object_PlayEffect('s21_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
def S22Spawn(event):
	spawn('sub_1_2','subterrestrial','s22_spawn_point')
#	Mission_AddArrowObject('sub_1_2_arrow', 'sub_1_2', js.ARROW_YELLOW, delete = 1)
	addArrow('sub_1_2_arrow','sub_1_2',ARROW_RED,1)
	regDeath('sub_1_2','AWaveKill')
	Object_PlayEffect('s22_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
	WaveProxChecks()


#these lines migrated to a cutscene

#def W31Spawn(event):
#	spawn('wraith_1_1','wraith_warrior','w31_spawn_point')
#	regDeath('wraith_1_1','AWaveKill')
#	Object_PlayEffect('w31_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
#def W32Spawn(event):
#	spawn('wraith_1_2','wraith_warrior','w32_spawn_point')
#	regDeath('wraith_1_2','AWaveKill')
#	Object_PlayEffect('w32_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
#def S31Spawn(event):
#	spawn('sub_1_1','subterrestrial','s31_spawn_point')
#	regDeath('sub_1_1','AWaveKill')
#	Object_PlayEffect('s31_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
#def S32Spawn(event):
#	spawn('sub_1_2','subterrestrial','s32_spawn_point')
#	regDeath('sub_1_2','AWaveKill')
#	Object_PlayEffect('s32_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)
#	WaveProxChecks()



def AWaveKill(event):
	addAttr('wave_dead',1)
	if Mission_GetAttr('wave_dead') == Mission_GetAttr('wave_total'):
		Mission_SetAttr('wave_dead', 0)
		Mission_SetAttr('wave_active', 0)
		CleanWave()
#NEW
		addAttr('wave_id',1)

		if Mission_GetAttr('first_wave_down') == 0:
			FirstWaveDown(event)
		elif Mission_GetAttr('second_wave_down') == 0:
			SecondWaveDown(event)
		elif Mission_GetAttr('third_wave_down') == 0:
			ThirdWaveDown(event)
		else:
			print "problem in AWaveKill?"

def CleanWave():
	print "Cleaning!"
	Object_Destroy('wraith_1_1', 0)
	Object_Destroy('wraith_1_2', 0)
	Object_Destroy('sub_1_1', 0)
	Object_Destroy('sub_1_2', 0)
	Object_Destroy('uber_1_1', 0)
# NEW
#	Object_Destroy('uber_point_1_1')
	Object_Destroy('uber_1_2', 0)
# NEW
#	Object_Destroy('uber_point_1_2')
	Mission_SetAttr('w11s11_anim_count',0)
	Mission_SetAttr('w11s12_anim_count',0)
	Mission_SetAttr('w12s11_anim_count',0)
	Mission_SetAttr('w12s12_anim_count',0)
	Mission_SetAttr('prox_w11_s11', 0)
	Mission_SetAttr('prox_w12_s11', 0)
	Mission_SetAttr('prox_w11_s12', 0)
	Mission_SetAttr('prox_w12_s12', 0)


# WaveProxChecks is called after a waves' worth of spawns has been spawned (and some other times)
def WaveProxChecks():
	regTimer('WaveProxChecks2',1)
# each wave has a different move target for the spawned guys, thus the if/elif/else
def WaveProxChecks2(event):
	# stumpy 2006-10-04: We are getting literally thousands of sinks to this function.  Let's see if we can clean things up.
	Event_CancelSinks('WaveProxChecks2')

	if Object_IsAlive('wraith_1_1') and Object_IsAlive('sub_1_1'):
		regProximityEnter('wraith_1_1','sub_1_1',25,'BoomW11S11',persistent=1)
	if Object_IsAlive('wraith_1_2') and Object_IsAlive('sub_1_1'):
		regProximityEnter('wraith_1_2','sub_1_1',25,'BoomW12S11',persistent=1)
	if Object_IsAlive('wraith_1_1') and Object_IsAlive('sub_1_2'):
		regProximityEnter('wraith_1_1','sub_1_2',25,'BoomW11S12',persistent=1)
	if Object_IsAlive('wraith_1_2') and Object_IsAlive('sub_1_2'):
		regProximityEnter('wraith_1_2','sub_1_2',25,'BoomW12S12',persistent=1)

	if Mission_GetAttr('second_wave_down') == 1:
		targetspot = Get_MarkerPos('third_move_target')
		print "adding move goals.  Move, damn you! (third_move_target)"
		if Object_IsAlive('wraith_1_1'):
			addMoveGoal('wraith_1_1', targetspot, fn = '', radius = 5, priority = ai.goal.PRI_LOW)
			addKillAllGoal('wraith_1_1', OC_CONTROLLABLE, priority = ai.goal.PRI_MED)
			js.Event_RegisterSink(EVENT_CHARACTER_STATE_CHANGED, 'WaveProxChecks2', 'wraith_1_1')
			js.Event_RegisterSink(EVENT_CHARACTER_SEC_STATE_CHANGED, 'WaveProxChecks2', 'wraith_1_1','',0,SCSTATE_POSSESSED)
		if Object_IsAlive('wraith_1_2'):
			addMoveGoal('wraith_1_2', targetspot, fn = '', radius = 5, priority = ai.goal.PRI_LOW)
			addKillAllGoal('wraith_1_2', OC_CONTROLLABLE, priority = ai.goal.PRI_MED)
			js.Event_RegisterSink(EVENT_CHARACTER_STATE_CHANGED, 'WaveProxChecks2', 'wraith_1_2')
			js.Event_RegisterSink(EVENT_CHARACTER_SEC_STATE_CHANGED, 'WaveProxChecks2', 'wraith_1_2','',0,SCSTATE_POSSESSED)
		if Object_IsAlive('sub_1_1'):
			addMoveGoal('sub_1_1', targetspot, fn = '', radius = 5, priority = ai.goal.PRI_LOW)
			addKillAllGoal('sub_1_1', OC_CONTROLLABLE, priority = ai.goal.PRI_MED)
			js.Event_RegisterSink(EVENT_CHARACTER_STATE_CHANGED, 'WaveProxChecks2', 'sub_1_1')
			js.Event_RegisterSink(EVENT_CHARACTER_SEC_STATE_CHANGED, 'WaveProxChecks2', 'sub_1_1','',0,SCSTATE_POSSESSED)
		if Object_IsAlive('sub_1_2'):
			addMoveGoal('sub_1_2', targetspot, fn = '', radius = 5, priority = ai.goal.PRI_LOW)
			addKillAllGoal('sub_1_2', OC_CONTROLLABLE, priority = ai.goal.PRI_MED)
			js.Event_RegisterSink(EVENT_CHARACTER_STATE_CHANGED, 'WaveProxChecks2', 'sub_1_2')
			js.Event_RegisterSink(EVENT_CHARACTER_SEC_STATE_CHANGED, 'WaveProxChecks2', 'sub_1_2','',0,SCSTATE_POSSESSED)
#		Trigger_Move('wraith_1_1',"move",targetspot,'',20,0)
#		Trigger_Move('wraith_1_2',"move",targetspot,'',20,0)
#		Trigger_Move('sub_1_1',"move",targetspot,'',20,0)
#		Trigger_Move('sub_1_2',"move",targetspot,'',20,0)
	elif Mission_GetAttr('first_wave_down') == 1:
		targetspot = Get_MarkerPos('second_move_target')
		print "adding move goals.  Move, damn you! (second_move_target)"
		if Object_IsAlive('wraith_1_1'):
			addMoveGoal('wraith_1_1', targetspot, fn = '', radius = 5, priority = ai.goal.PRI_LOW)
			addKillAllGoal('wraith_1_1', OC_CONTROLLABLE, priority = ai.goal.PRI_MED)
			js.Event_RegisterSink(EVENT_CHARACTER_STATE_CHANGED, 'WaveProxChecks2', 'wraith_1_1')
			js.Event_RegisterSink(EVENT_CHARACTER_SEC_STATE_CHANGED, 'WaveProxChecks2', 'wraith_1_1','',0,SCSTATE_POSSESSED)
		if Object_IsAlive('wraith_1_2'):
			addMoveGoal('wraith_1_2', targetspot, fn = '', radius = 5, priority = ai.goal.PRI_LOW)
			addKillAllGoal('wraith_1_2', OC_CONTROLLABLE, priority = ai.goal.PRI_MED)
			js.Event_RegisterSink(EVENT_CHARACTER_STATE_CHANGED, 'WaveProxChecks2', 'wraith_1_2')
			js.Event_RegisterSink(EVENT_CHARACTER_SEC_STATE_CHANGED, 'WaveProxChecks2', 'wraith_1_2','',0,SCSTATE_POSSESSED)
		if Object_IsAlive('sub_1_1'):
			addMoveGoal('sub_1_1', targetspot, fn = '', radius = 5, priority = ai.goal.PRI_LOW)
			addKillAllGoal('sub_1_1', OC_CONTROLLABLE, priority = ai.goal.PRI_MED)
			js.Event_RegisterSink(EVENT_CHARACTER_STATE_CHANGED, 'WaveProxChecks2', 'sub_1_1')
			js.Event_RegisterSink(EVENT_CHARACTER_SEC_STATE_CHANGED, 'WaveProxChecks2', 'sub_1_1','',0,SCSTATE_POSSESSED)
		if Object_IsAlive('sub_1_2'):
			addMoveGoal('sub_1_2', targetspot, fn = '', radius = 5, priority = ai.goal.PRI_LOW)
			addKillAllGoal('sub_1_2', OC_CONTROLLABLE, priority = ai.goal.PRI_MED)
			js.Event_RegisterSink(EVENT_CHARACTER_STATE_CHANGED, 'WaveProxChecks2', 'sub_1_2')
			js.Event_RegisterSink(EVENT_CHARACTER_SEC_STATE_CHANGED, 'WaveProxChecks2', 'sub_1_2','',0,SCSTATE_POSSESSED)
#		Trigger_Move('wraith_1_1',"move",targetspot,'',20,0)
#		Trigger_Move('wraith_1_2',"move",targetspot,'',20,0)
#		Trigger_Move('sub_1_1',"move",targetspot,'',20,0)
#		Trigger_Move('sub_1_2',"move",targetspot,'',20,0)
	else:
		if Object_IsAlive('wraith_1_1'):
			targetspotw1 = Get_ObjectPos(getNearestHero('wraith_1_1'))
		if Object_IsAlive('wraith_1_2'):
			targetspotw2 = Get_ObjectPos(getNearestHero('wraith_1_2'))
		if Object_IsAlive('sub_1_1'):
			targetspots1 = Get_ObjectPos(getNearestHero('sub_1_1'))
		if Object_IsAlive('sub_1_2'):
			targetspots2 = Get_ObjectPos(getNearestHero('sub_1_2'))

		print "adding move goals.  Move, damn you! ()"
		if Object_IsAlive('wraith_1_1'):
			addMoveGoal('wraith_1_1', targetspotw1, fn = '', radius = 5, priority = ai.goal.PRI_LOW)
			addKillAllGoal('wraith_1_1', OC_CONTROLLABLE, priority = ai.goal.PRI_MED)
			js.Event_RegisterSink(EVENT_CHARACTER_STATE_CHANGED, 'WaveProxChecks2', 'wraith_1_1')
			js.Event_RegisterSink(EVENT_CHARACTER_SEC_STATE_CHANGED, 'WaveProxChecks2', 'wraith_1_1','',0,SCSTATE_POSSESSED)
		if Object_IsAlive('wraith_1_2'):
			addMoveGoal('wraith_1_2', targetspotw2, fn = '', radius = 5, priority = ai.goal.PRI_LOW)
			addKillAllGoal('wraith_1_2', OC_CONTROLLABLE, priority = ai.goal.PRI_MED)
			js.Event_RegisterSink(EVENT_CHARACTER_STATE_CHANGED, 'WaveProxChecks2', 'wraith_1_2')
			js.Event_RegisterSink(EVENT_CHARACTER_SEC_STATE_CHANGED, 'WaveProxChecks2', 'wraith_1_2','',0,SCSTATE_POSSESSED)
		if Object_IsAlive('sub_1_1'):
			addMoveGoal('sub_1_1', targetspots1, fn = '', radius = 5, priority = ai.goal.PRI_LOW)
			addKillAllGoal('sub_1_1', OC_CONTROLLABLE, priority = ai.goal.PRI_MED)
			js.Event_RegisterSink(EVENT_CHARACTER_STATE_CHANGED, 'WaveProxChecks2', 'sub_1_1')
			js.Event_RegisterSink(EVENT_CHARACTER_SEC_STATE_CHANGED, 'WaveProxChecks2', 'sub_1_1','',0,SCSTATE_POSSESSED)
		if Object_IsAlive('sub_1_2'):
			addMoveGoal('sub_1_2', targetspots2, fn = '', radius = 5, priority = ai.goal.PRI_LOW)
			addKillAllGoal('sub_1_2', OC_CONTROLLABLE, priority = ai.goal.PRI_MED)
			js.Event_RegisterSink(EVENT_CHARACTER_STATE_CHANGED, 'WaveProxChecks2', 'sub_1_2')
			js.Event_RegisterSink(EVENT_CHARACTER_SEC_STATE_CHANGED, 'WaveProxChecks2', 'sub_1_2','',0,SCSTATE_POSSESSED)
#		Trigger_Move('wraith_1_1',"move",targetspotw1,'',20,0)
#		Trigger_Move('wraith_1_2',"move",targetspotw2,'',20,0)
#		Trigger_Move('sub_1_1',"move",targetspots1,'',20,0)
#		Trigger_Move('sub_1_2',"move",targetspots2,'',20,0)

#used to make sure 'stop merger' barks don't play too close together
def StartTimer(event):
	Mission_SetAttr('merge_bark_recent', 0)

def StartTimer2(event):
	Mission_SetAttr('boom_bark_recent', 0)

#These are what are called by proximity
def BoomW11S11(event):
	print 'w11 and s11 are close'
	#check to see if either is already doing a boom interaction, and that they're both alive
	if (Mission_GetAttr('prox_w11_s11') == 0) and (Mission_GetAttr('prox_w12_s11') == 0) and (Mission_GetAttr('prox_w11_s12') == 0)and (CheckDistance('wraith_1_1','sub_1_1') < Mission_GetAttr('distance_check')):
		# ensure we don't overlap boom interactions
		Mission_SetAttr('prox_w11_s11',1)
		addArrow('boomer11w','wraith_1_1',js.ARROW_YELLOW,1)
		addArrow('boomer11s','sub_1_1',js.ARROW_YELLOW,1)
		loc = Get_ObjectPos('wraith_1_1')
#		there's a typo in the sound name, so the following is actually correct
		Sound_PlaySound('subt_raith_interaction',loc)
		Mission_RemoveArrow('sub_1_1_arrow')
		Mission_RemoveArrow('wraith_1_1_arrow')
		# the if statements below cause a warning bark, but only if enough time has passed since the last one
		if Mission_GetAttr('merge_barks_played') == 0:
			if Mission_GetAttr('merge_bark_recent') == 0:
				speakNoCB('eve', 'MISSPCH_19_EV_11')
				addAttr('merge_barks_played', 1)
				Mission_SetAttr('merge_bark_recent', 1)
				regTimer('StartTimer', 10)
		elif Mission_GetAttr('merge_barks_played') == 1:
			if Mission_GetAttr('merge_bark_recent') == 0:
				speakNoCB('eve', 'MISSPCH_19_EV_13')
				addAttr('merge_barks_played', 1)
				Mission_SetAttr('merge_bark_recent', 1)
				regTimer('StartTimer', 10)
		elif Mission_GetAttr('merge_barks_played') == 2:
			if Mission_GetAttr('merge_bark_recent') == 0:
				speakNoCB('eve', 'MISSPCH_19_EV_14')
				addAttr('merge_barks_played', 1)
				Mission_SetAttr('merge_bark_recent', 1)
				regTimer('StartTimer', 10)
		elif Mission_GetAttr('merge_barks_played') > 2:
			if Mission_GetAttr('merge_bark_recent') == 0:
				speakNoCB('eve', 'MISSPCH_19_EV_15')
				addAttr('merge_barks_played', 1)
				Mission_SetAttr('merge_bark_recent', 1)
				regTimer('StartTimer', 10)
		# Wraith plays an "awaiting blast" anim
		# Turn off the Wraith AI
		AI_SetEnabled('wraith_1_1',0)
		# Subterrestrial turns towards Wraith, and plays "preparing to blast" anim
		turnTo('sub_1_1','wraith_1_1')
		turnTo('wraith_1_1','sub_1_1')
#NEW
		AnimW11S11(event)
		AI_SetEnabled('sub_1_1',0)
#		regTimer('ZapBoomW11S11',8)

#NEW
def AnimW11S11(event):
	print "starting an animation cycle"
	AI_Animate('wraith_1_1', 'absorbing_beam', 'AnimW11S11Finish', 0, 0)
	AI_Animate('sub_1_1','energy_taken')

def AnimW11S11Finish(event):
	status = int(event.data)
	if not status:
		# draining animation was interrupted
		print "stopped interaction"
		UnBoomW11S11(event)
	else:
		print "cycle complete"
		addAttr('w11s11_anim_count',1)
		# tune number below
		if Mission_GetAttr('w11s11_anim_count') > 8:
			ZapBoomW11S11(event)
		else:
			AnimW11S11(event)



def ZapBoomW11S11(event):
	# First, check if they are still close enough
	if CheckDistance('wraith_1_1','sub_1_1') < Mission_GetAttr('distance_check'):
		print 's11 now blasting w11'
		# if so, trigger a power for the FX -- this is currently placeholder
		Trigger_Power('sub_1_1','wraith_1_1','subterrestrial Life Suck','')
		regTimer('FinishBoomW11S11',4)
	else:
		# if player has successfully separated them, reset their checks (unlock them)
#NEW
		UnBoomW11S11(event)
#NEW
def UnBoomW11S11(event):
		Mission_SetAttr('prox_w11_s11', 0)
		WaveProxChecks()
		# and their AI
		if Object_IsAlive('wraith_1_1'):
			clearGoals('wraith_1_1')
			AI_SetEnabled('wraith_1_1',1)
		if Object_IsAlive('sub_1_1'):
			clearGoals('sub_1_1')
			AI_SetEnabled('sub_1_1',1)
		# and remove arrows
		removeArrow('boomer11w')
		removeArrow('boomer11s')

def FinishBoomW11S11(event):
	print 'ready to spawn uber 1 1'
	# the wave count needs to be icremented for the uber wraith
	addAttr('wave_total',1)
	# prepare marker for UberWraith
	wraith_loc = Get_ObjectPos('wraith_1_1')
	wraith_rot = Object_GetOrientation('wraith_1_1')
#NEW
	wave=Mission_GetAttr('wave_id')
#NEW
	Marker_Spawn('uber_point_1_1_'+str(int(wave)),wraith_loc,wraith_rot[1])
	kill('sub_1_1')
	Trigger_Explosion('wraith_1_1','wraith warrior Explode')
	kill('wraith_1_1')
	# spawn the UberWraith
	regTimer('SpawnUber11',1)

def BoomW11S12(event):
	print 'w11 and s12 are close'
	#check to see if either is already doing a boom interaction, and that they're both alive
	if (Mission_GetAttr('prox_w11_s12') == 0) and (Mission_GetAttr('prox_w11_s11') == 0) and (Mission_GetAttr('prox_w12_s12') == 0) and (CheckDistance('wraith_1_1','sub_1_2') < Mission_GetAttr('distance_check')):
		# ensure we don't overlap boom interactions
		Mission_SetAttr('prox_w11_s12',1)
		addArrow('boomer11w','wraith_1_1',js.ARROW_YELLOW,1)
		addArrow('boomer12s','sub_1_2',js.ARROW_YELLOW,1)
		loc = Get_ObjectPos('wraith_1_1')
#		there's a typo in the sound name, so the following is actually correct
		Sound_PlaySound('subt_raith_interaction',loc)
		Mission_RemoveArrow('sub_1_2_arrow')
		Mission_RemoveArrow('wraith_1_1_arrow')
		# the if statements below cause a warning bark, but only if enough time has passed since the last one
		if Mission_GetAttr('merge_barks_played') == 0:
			if Mission_GetAttr('merge_bark_recent') == 0:
				speakNoCB('eve', 'MISSPCH_19_EV_11')
				addAttr('merge_barks_played', 1)
				Mission_SetAttr('merge_bark_recent', 1)
				regTimer('StartTimer', 10)
		elif Mission_GetAttr('merge_barks_played') == 1:
			if Mission_GetAttr('merge_bark_recent') == 0:
				speakNoCB('eve', 'MISSPCH_19_EV_13')
				addAttr('merge_barks_played', 1)
				Mission_SetAttr('merge_bark_recent', 1)
				regTimer('StartTimer', 10)
		elif Mission_GetAttr('merge_barks_played') == 2:
			if Mission_GetAttr('merge_bark_recent') == 0:
				speakNoCB('eve', 'MISSPCH_19_EV_14')
				addAttr('merge_barks_played', 1)
				Mission_SetAttr('merge_bark_recent', 1)
				regTimer('StartTimer', 10)
		elif Mission_GetAttr('merge_barks_played') > 2:
			if Mission_GetAttr('merge_bark_recent') == 0:
				speakNoCB('eve', 'MISSPCH_19_EV_15')
				addAttr('merge_barks_played', 1)
				Mission_SetAttr('merge_bark_recent', 1)
				regTimer('StartTimer', 10)
		# Wraith plays an "awaiting blast" anim
#NEW
#		AI_Animate('wraith_1_1','stunned')
		AI_SetEnabled('wraith_1_1',0)
		# Subterrestrial turns towards Wraith, and plays "preparing to blast" anim
		turnTo('sub_1_2','wraith_1_1')
		turnTo('wraith_1_1','sub_1_2')
#NEW
#		AI_Animate('sub_1_2','stunned')
#NEW
		AnimW11S12(event)
		AI_SetEnabled('sub_1_2',0)
#NEW
#		regTimer('ZapBoomW11S12',8)
#NEW

def AnimW11S12(event):
	print "starting an animation cycle"
	AI_Animate('wraith_1_1', 'absorbing_beam', 'AnimW11S12Finish', 0, 0)
	AI_Animate('sub_1_2','energy_taken')

def AnimW11S12Finish(event):
	status = int(event.data)
	if not status:
		# draining animation was interrupted
		print "stopped interaction"
		UnBoomW11S12(event)
	else:
		print "cycle complete"
		addAttr('w11s12_anim_count',1)
		# tune number below
		if Mission_GetAttr('w11s12_anim_count') > 8:
			ZapBoomW11S12(event)
		else:
			AnimW11S12(event)

def ZapBoomW11S12(event):
	# First, check if they are still close enough
	if CheckDistance('wraith_1_1','sub_1_2') < Mission_GetAttr('distance_check'):
		print 's12 now blasting w11'
		# if so, trigger a power for the FX
		Trigger_Power('sub_1_2','wraith_1_1','subterrestrial Life Suck','')
		regTimer('FinishBoomW11S12',4)
	else:
		# if player has successfully separated them, reset their checks
#NEW
		UnBoomW11S12(event)

def UnBoomW11S12(event):
		Mission_SetAttr('prox_w11_s12', 0)
		WaveProxChecks()
		# and their AI
		if Object_IsAlive('wraith_1_1'):
			clearGoals('wraith_1_1')
			AI_SetEnabled('wraith_1_1',1)
		if Object_IsAlive('sub_1_2'):
			clearGoals('sub_1_2')
			AI_SetEnabled('sub_1_2',1)
		# and remove arrows
		removeArrow('boomer11w')
		removeArrow('boomer12s')

def FinishBoomW11S12(event):
	print 'ready to spawn uber 1 1'
	# the wave count needs to be icremented for the uber wraith
	addAttr('wave_total',1)
	# prepare marker for UberWraith
	wraith_loc = Get_ObjectPos('wraith_1_1')
	wraith_rot = Object_GetOrientation('wraith_1_1')
#NEW
	wave=Mission_GetAttr('wave_id')
#NEW
	Marker_Spawn('uber_point_1_1_'+str(int(wave)),wraith_loc,wraith_rot[1])
	kill('sub_1_2')
	Trigger_Explosion('wraith_1_1','generic fire explosion large')
	kill('wraith_1_1')
	# spawn the UberWraith
	regTimer('SpawnUber11',1)

def BoomW12S11(event):
	print 'w12 and s11 are close'
	#check to see if either is already doing a boom interaction, and that they're both alive
	if (Mission_GetAttr('prox_w12_s11') == 0) and (Mission_GetAttr('prox_w12_s12') == 0) and (Mission_GetAttr('prox_w11_s11') == 0) and (CheckDistance('wraith_1_2','sub_1_1') < Mission_GetAttr('distance_check')):
		# ensure we don't overlap boom interactions
		Mission_SetAttr('prox_w12_s11',1)
		addArrow('boomer12w','wraith_1_2',js.ARROW_YELLOW,1)
		addArrow('boomer11s','sub_1_1',js.ARROW_YELLOW,1)
		loc = Get_ObjectPos('wraith_1_2')
#		there's a typo in the sound name, so the following is actually correct
		Sound_PlaySound('subt_raith_interaction',loc)
		Mission_RemoveArrow('sub_1_1_arrow')
		Mission_RemoveArrow('wraith_1_2_arrow')
		# the if statements below cause a warning bark, but only if enough time has passed since the last one
		if Mission_GetAttr('merge_barks_played') == 0:
			if Mission_GetAttr('merge_bark_recent') == 0:
				speakNoCB('eve', 'MISSPCH_19_EV_11')
				addAttr('merge_barks_played', 1)
				Mission_SetAttr('merge_bark_recent', 1)
				regTimer('StartTimer', 10)
		elif Mission_GetAttr('merge_barks_played') == 1:
			if Mission_GetAttr('merge_bark_recent') == 0:
				speakNoCB('eve', 'MISSPCH_19_EV_13')
				addAttr('merge_barks_played', 1)
				Mission_SetAttr('merge_bark_recent', 1)
				regTimer('StartTimer', 10)
		elif Mission_GetAttr('merge_barks_played') == 2:
			if Mission_GetAttr('merge_bark_recent') == 0:
				speakNoCB('eve', 'MISSPCH_19_EV_14')
				addAttr('merge_barks_played', 1)
				Mission_SetAttr('merge_bark_recent', 1)
				regTimer('StartTimer', 10)
		elif Mission_GetAttr('merge_barks_played') > 2:
			if Mission_GetAttr('merge_bark_recent') == 0:
				speakNoCB('eve', 'MISSPCH_19_EV_15')
				addAttr('merge_barks_played', 1)
				Mission_SetAttr('merge_bark_recent', 1)
				regTimer('StartTimer', 10)
		# Wraith plays an "awaiting blast" anim
#NEW
#		AI_Animate('wraith_1_2','stunned')
		AI_SetEnabled('wraith_1_2',0)
		# Subterrestrial turns towards Wraith, and plays "preparing to blast" anim
		turnTo('sub_1_1','wraith_1_2')
		turnTo('wraith_1_2','sub_1_1')
#NEW
#		AI_Animate('sub_1_1','stunned')
#NEW
		AnimW12S11(event)
		AI_SetEnabled('sub_1_1',0)
#NEW
#		regTimer('ZapBoomW11S11',8)
#NEW

def AnimW12S11(event):
	print "starting an animation cycle"
	AI_Animate('wraith_1_2', 'absorbing_beam', 'AnimW12S11Finish', 0, 0)
	AI_Animate('sub_1_1','energy_taken')

def AnimW12S11Finish(event):
	status = int(event.data)
	if not status:
		# draining animation was interrupted
		print "stopped interaction"
		UnBoomW12S11(event)
	else:
		print "cycle complete"
		addAttr('w12s11_anim_count',1)
		# tune number below
		if Mission_GetAttr('w12s11_anim_count') > 8:
			ZapBoomW12S11(event)
		else:
			AnimW12S11(event)

def ZapBoomW12S11(event):
	# First, check if they are still close enough
	if CheckDistance('wraith_1_2','sub_1_1') < Mission_GetAttr('distance_check'):
		print 's11 now blasting w12'
		# if so, trigger a power for the FX
		Trigger_Power('sub_1_1','wraith_1_2','subterrestrial Life Suck','')
		regTimer('FinishBoomW12S11',4)
	else:
		# if player has successfully separated them, reset their checks
#NEW
		UnBoomW12S11(event)

def UnBoomW12S11(event):
		Mission_SetAttr('prox_w12_s11', 0)
		WaveProxChecks()
		# and their AI
		if Object_IsAlive('wraith_1_2'):
			clearGoals('wraith_1_2')
			AI_SetEnabled('wraith_1_2',1)
		if Object_IsAlive('sub_1_1'):
			clearGoals('sub_1_1')
			AI_SetEnabled('sub_1_1',1)
		# and remove arrows
		removeArrow('boomer12w')
		removeArrow('boomer11s')

def FinishBoomW12S11(event):
	print 'ready to spawn uber 1 2'
	# the wave count needs to be icremented for the uber wraith
	addAttr('wave_total',1)
	# prepare marker for UberWraith
	wraith_loc = Get_ObjectPos('wraith_1_2')
	wraith_rot = Object_GetOrientation('wraith_1_2')
#NEW
	wave=Mission_GetAttr('wave_id')
#NEW
	Marker_Spawn('uber_point_1_2_'+str(int(wave)),wraith_loc,wraith_rot[1])
	kill('sub_1_1')
	Trigger_Explosion('wraith_1_2','generic fire explosion large')
	kill('wraith_1_2')
	# spawn the UberWraith
	regTimer('SpawnUber12',1)

def BoomW12S12(event):
	print 'w12 and s12 are close'
	#check to see if either is already doing a boom interaction, and that they're both alive
	if (Mission_GetAttr('prox_w12_s12') == 0) and (Mission_GetAttr('prox_w12_s11') == 0) and (Mission_GetAttr('prox_w11_s12') == 0) and (CheckDistance('wraith_1_2','sub_1_2') < Mission_GetAttr('distance_check')):
		# ensure we don't overlap boom interactions
		Mission_SetAttr('prox_w12_s12',1)
		addArrow('boomer12w','wraith_1_2',js.ARROW_YELLOW,1)
		addArrow('boomer12s','sub_1_2',js.ARROW_YELLOW,1)
		loc = Get_ObjectPos('wraith_1_2')
#		there's a typo in the sound name, so the following is actually correct
		Sound_PlaySound('subt_raith_interaction',loc)
		Mission_RemoveArrow('sub_1_2_arrow')
		Mission_RemoveArrow('wraith_1_2_arrow')
		# the if statements below cause a warning bark, but only if enough time has passed since the last one
		if Mission_GetAttr('merge_barks_played') == 0:
			if Mission_GetAttr('merge_bark_recent') == 0:
				speakNoCB('eve', 'MISSPCH_19_EV_11')
				addAttr('merge_barks_played', 1)
				Mission_SetAttr('merge_bark_recent', 1)
				regTimer('StartTimer', 10)
		elif Mission_GetAttr('merge_barks_played') == 1:
			if Mission_GetAttr('merge_bark_recent') == 0:
				speakNoCB('eve', 'MISSPCH_19_EV_13')
				addAttr('merge_barks_played', 1)
				Mission_SetAttr('merge_bark_recent', 1)
				regTimer('StartTimer', 10)
		elif Mission_GetAttr('merge_barks_played') == 2:
			if Mission_GetAttr('merge_bark_recent') == 0:
				speakNoCB('eve', 'MISSPCH_19_EV_14')
				addAttr('merge_barks_played', 1)
				Mission_SetAttr('merge_bark_recent', 1)
				regTimer('StartTimer', 10)
		elif Mission_GetAttr('merge_barks_played') > 2:
			if Mission_GetAttr('merge_bark_recent') == 0:
				speakNoCB('eve', 'MISSPCH_19_EV_15')
				addAttr('merge_barks_played', 1)
				Mission_SetAttr('merge_bark_recent', 1)
				regTimer('StartTimer', 10)
		# Wraith plays an "awaiting blast" anim
#NEW
#		AI_Animate('wraith_1_2','stunned')
		AI_SetEnabled('wraith_1_2',0)
		# Subterrestrial turns towards Wraith, and plays "preparing to blast" anim
		turnTo('sub_1_2','wraith_1_2')
		turnTo('wraith_1_2','sub_1_2')
#NEW
#		AI_Animate('sub_1_2','stunned')
#NEW
		AnimW12S12(event)
		AI_SetEnabled('sub_1_2',0)
#NEW
#		regTimer('ZapBoomW12S12',8)
#NEW

def AnimW12S12(event):
	print "starting an animation cycle"
	AI_Animate('wraith_1_2', 'absorbing_beam', 'AnimW12S12Finish', 0, 0)
	AI_Animate('sub_1_2','energy_taken')

def AnimW12S12Finish(event):
	status = int(event.data)
	if not status:
		# draining animation was interrupted
		print "stopped interaction"
		UnBoomW12S12(event)
	else:
		print "cycle complete"
		addAttr('w12s12_anim_count',1)
		# tune number below
		if Mission_GetAttr('w12s12_anim_count') > 8:
			ZapBoomW12S12(event)
		else:
			AnimW12S12(event)

def ZapBoomW12S12(event):
	# First, check if they are still close enough
	if CheckDistance('wraith_1_2','sub_1_2') < Mission_GetAttr('distance_check'):
		print 's12 now blasting w12'
		# if so, trigger a power for the FX
		Trigger_Power('sub_1_2','wraith_1_2','subterrestrial Life Suck','')
		regTimer('FinishBoomW12S12',4)
	else:
		# if player has successfully separated them, reset their checks
#NEW
		UnBoomW12S12(event)

def UnBoomW12S12(event):
		Mission_SetAttr('prox_w12_s12', 0)
		WaveProxChecks()
		# and their AI
		if Object_IsAlive('wraith_1_2'):
			clearGoals('wraith_1_2')
			AI_SetEnabled('wraith_1_2',1)
		if Object_IsAlive('sub_1_2'):
			clearGoals('sub_1_2')
			AI_SetEnabled('sub_1_2',1)
		# and remove arrows
		removeArrow('boomer12w')
		removeArrow('boomer12s')

def FinishBoomW12S12(event):
	print 'ready to spawn uber 1 2'
	# the wave count needs to be icremented for the uber wraith
	addAttr('wave_total',1)
	# prepare marker for UberWraith
	wraith_loc = Get_ObjectPos('wraith_1_2')
	wraith_rot = Object_GetOrientation('wraith_1_2')
#NEW
	wave=Mission_GetAttr('wave_id')
#NEW
	Marker_Spawn('uber_point_1_2_'+str(int(wave)),wraith_loc,wraith_rot[1])
	kill('sub_1_2')
	Trigger_Explosion('wraith_1_2','generic fire explosion large')
	kill('wraith_1_2')
	# spawn the UberWraith
	regTimer('SpawnUber12',1)

def SpawnUber11(event):
#NEW
	wave=Mission_GetAttr('wave_id')
	spawn('uber_1_1','wraith_manta','uber_point_1_1_'+str(int(wave)))
	regDeath('uber_1_1','AWaveKill')
	addArrow('uber_1_1_arrow', 'uber_1_1', colour = js.ARROW_RED, delete = 1)
	addAttr('uber_spawns', 1)
	if Mission_GetAttr('uber_spawns') == 4:
		Objective_Fail('stop_merging')
#	addAttr('wave_total',1)
	if Mission_GetAttr('boom_bark_recent') == 0:
		speakNoCB('eve', 'MISSPCH_19_EV_16')
		Mission_SetAttr('boom_bark_recent', 1)
		regTimer('StartTimer2', 6)

def SpawnUber12(event):
#NEW
	wave=Mission_GetAttr('wave_id')
	spawn('uber_1_2','wraith_manta','uber_point_1_2_'+str(int(wave)))
	regDeath('uber_1_2','AWaveKill')
	addArrow('uber_1_2_arrow', 'uber_1_2', colour = js.ARROW_RED, delete = 1)
	addAttr('uber_spawns', 1)
	if Mission_GetAttr('uber_spawns') == 4:
		Objective_Fail('stop_merging')
#	addAttr('wave_total',1)
	if Mission_GetAttr('boom_bark_recent') == 0:
		speakNoCB('eve', 'MISSPCH_19_EV_17')
		Mission_SetAttr('boom_bark_recent', 1)
		regTimer('StartTimer2', 6)

def FirstWaveUp(event):
	Mission_SetAttr('wave_total',4)
	WaveProxChecks()

def FirstWaveDown(event):
	play(first_wave_down_ss,'first_wave_down_ss')
	Mission_SetAttr('first_wave_down', 1)

	#Play the effects, and then call the fucntions that spawn the monsters
	Object_PlayEffect('w21_standin', 'effect_portal_open', 'W21Spawn',FX_TRACK_OBJECT_ROT)
	Object_PlayEffect('w22_standin', 'effect_portal_open', 'W22Spawn',FX_TRACK_OBJECT_ROT)
	Object_PlayEffect('s21_standin', 'effect_portal_open', 'S21Spawn',FX_TRACK_OBJECT_ROT)
	Object_PlayEffect('s22_standin', 'effect_portal_open', 'S22Spawn',FX_TRACK_OBJECT_ROT)
	# Reset the number of bad guys to 4
	Mission_SetAttr('wave_total',4)

def SecondWaveDown(event):
	play(second_wave_down_cs,'second_wave_down_cs')

	Mission_SetAttr('second_wave_down', 1)
	Mission_SetAttr('third_wave_up', 1)

#	Object_PlayEffect('w31_standin', 'effect_portal_open', 'W31Spawn',FX_TRACK_OBJECT_ROT)
#	Object_PlayEffect('w32_standin', 'effect_portal_open', 'W32Spawn',FX_TRACK_OBJECT_ROT)
#	Object_PlayEffect('s31_standin', 'effect_portal_open', 'S31Spawn',FX_TRACK_OBJECT_ROT)
#	Object_PlayEffect('s32_standin', 'effect_portal_open', 'S32Spawn',FX_TRACK_OBJECT_ROT)
	# Reset the number of bad guys to 4
	Mission_SetAttr('wave_total',4)

def SecondWaveFollowSpeech():
	play(second_follow_ss, 'second_follow_ss')

def ThirdWaveDown(event):
#	speakNoCB('eve', 'MISSPCH_19_EV_21')
	regTimer('TriggerFinalCS', 1)

def TriggerFinalCS(event):
	if not Objective_IsFailed('save_civilians'):
		Objective_Complete('save_civilians')
	if not Objective_IsFailed('stop_merging'):
		Objective_Complete('stop_merging')
	Objective_Complete('defeat_entropy_minions')
	play(final_cs, "final_cs")

def EvePortalOn():
	print "should be playing portal effect on eve right now!"
	playEffectMarker('effect_portal_open', 'eve_run_target')
	regTimer('EvePortalOn2', 2)

def EvePortalOn2(event):
	handle = Object_PlayEffect('eve_standin', 'effect_portal_steady', '', FX_LOOP)
	Mission_SetAttr('evehandle', handle)


def EvePortalOff():
	playEffectMarker('effect_portal_close', 'eve_run_target')
	Object_StopEffect('eve_standin', int(Mission_GetAttr('evehandle')))


def OnMissionWon():
	print "elementals/won"


def PickTreeSpeaker():
	a_hero = getRandomLiveHeroName()
	print a_hero
	if a_hero == 'minute_man':
		speak('minute_man', 'MISSPCH_19_MM_01')
	elif a_hero == 'black_jack':
		speak('black_jack', 'MISSPCH_19_BJ_01')
	elif a_hero == 'black_bird':
		speak('black_bird', 'MISSPCH_19_BB_01')
	elif a_hero == 'bullet':
		speak('bullet', 'MISSPCH_19_BL_01')
	elif a_hero == 'green_genie':
		speak('green_genie', 'MISSPCH_19_GG_01')
	elif a_hero == 'iron_ox':
		speak('iron_ox', 'MISSPCH_19_IO_01')
	elif a_hero == 'law':
		speak('law', 'MISSPCH_19_LW_01')
	elif a_hero == 'liberty_lad':
		speak('liberty_lad', 'MISSPCH_19_LL_01')
	elif a_hero == 'man_bot':
		speak('man_bot', 'MISSPCH_19_MB_02')
	elif a_hero == 'man_o_war':
		speak('man_o_war', 'MISSPCH_19_MO_01')
	elif a_hero == 'mentor':
		speak('mentor', 'MISSPCH_19_ME_01')
	elif a_hero == 'microwave':
		speak('microwave', 'MISSPCH_19_MW_01')
	elif a_hero == 'order':
		speak('law', 'MISSPCH_19_LW_01')
	elif a_hero == 'quetzalcoatl':
		speak('quetzalcoatl', 'MISSPCH_19_QZ_01')
	elif a_hero == 'sea_urchin':
		speak('sea_urchin', 'MISSPCH_19_SU_01')
	elif a_hero == 'sky_king':
		speak('sky_king', 'MISSPCH_19_SY_01')
	elif a_hero == 'tombstone':
		speak('tombstone', 'MISSPCH_19_TS_01')
	elif a_hero == 'tricolour':
		speak('tricolour', 'MISSPCH_19_TC_01')
	elif a_hero == 'the_ant':
		speak('the_ant', 'MISSPCH_19_AN_01')
	else:
		print "Custom character?"
		forceSpeak('eve','MISSPCH_19_EV_29')

def OnPower(event):
	print "power has struck"
	kill('red_sun5')


#-----------------------------------------------------------
# cutscenes and scripted sequences
#-----------------------------------------------------------


start_cs = [
(
	"startCS()",
	"peace()",
	"see()",
	"wait(0.1)",
),
(
	"look('red_sun1', zoom = 0, heading = 0, time = 1)",
	"wait(0.1)",
),
(
	"forceSpeak('red_sun', 'MISSPCH_19_RS_01', telepathy=0)",
	"Sound_PlayMusic('music_06redsun_cs1meet',1)",
),
(
	"forceSpeak('red_sun', 'MISSPCH_19_RS_02', telepathy=0)",
),
(
	"speak('eve', 'MISSPCH_19_EV_01')",
),
(
	"endCS()",
	"blind()",
	"war()",
	"Sound_PlayMusic('music_06redsun_cs1fight')",
	"newObjective('primary', 1, name='defeat_red_suns')",
	"ff.addArrow('redsun1_arrow', 'red_sun1', js.ARROW_RED, delete=1)",
	"Mission_SetAttr('cs_playing',0)",
	"ff.GetThingsStarted()",
),
]

market_day_ss = [
(
	"speak('eve', 'MISSPCH_19_EV_02')",
	"newObjective('secondary', 1, name='save_civilians')",
#	"ff.addArrow('civ1_1_arrow', 'civilian_group1_1', js.ARROW_RED, delete = 1)",
#	"ff.addArrow('civ1_2_arrow', 'civilian_group1_2', js.ARROW_RED, delete = 1)",
#	"ff.addArrow('civ1_3_arrow', 'civilian_group1_3', js.ARROW_RED, delete = 1)",
#	"ff.addArrow('civ1_4_arrow', 'civilian_group1_4', js.ARROW_RED, delete = 1)",
#	"ff.addArrow('civ1_5_arrow', 'civilian_group1_5', js.ARROW_RED, delete = 1)",
),
(
	"blank",
),
]

second_sun_wave_cs = [
(
	"startCS()",
	"see()",
	"wait(0.1)",
),
(
	"ff.SecondSunWave()",
	"peace()",
	"Sound_PlayMusic('music_06redsun_cs1beat',1)",
	"wait(0.1)",
),
(
	"look('red_sun_2_marker', zoom = 0, heading = 0, time = 2)",
	"wait(0.1)",
),
(
	"Object_PlayEffect('red_sun2', 'effect_red_sun_glow')",
	"forceSpeak('red_sun', 'MISSPCH_19_RS_04', telepathy=0)",
),
(
	"forceSpeak('civilian_male', 'MISSPCH_19_M1_01')",
),
(
	"endCS()",
	"blind()",
	"war()",
	"Sound_PlayMusic('music_06redsun_cs1fight')",
),
]


third_sun_wave_cs = [
(
	"startCS()",
	"see()",
	"wait(0.1)",
),
(
	"ff.ThirdSunWave()",
	"peace()",
	"Sound_PlayMusic('music_06redsun_cs1meet',1)",
	"wait(0.1)",
),
(
	"look('red_sun_3_marker', zoom = 0, heading = 0, time = 2)",
	"Object_PlayEffect('red_sun3', 'effect_red_sun_glow')",
	"wait(2.0)",
),
(
	"forceSpeak('red_sun', 'MISSPCH_19_RS_05', telepathy=0)",
),
(
	"look('red_sun_4_marker', zoom = 0, heading = 0, time = 1)",
	"Sound_PlayMusic('music_06redsun_cs1beat',1)",
	"Object_PlayEffect('red_sun4', 'effect_red_sun_glow')",
	"wait(2.0)",
),
(
	"forceSpeak('red_sun', 'MISSPCH_19_RS_06', telepathy=0)",
),
(
	"forceSpeak('civilian_female', 'MISSPCH_19_F1_01')",
),
(
	"endCS()",
	"blind()",
	"war()",
	"Sound_PlayMusic('music_06redsun_cs1fight')",
	"ff.addArrow('redsun3_arrow', 'red_sun3', js.ARROW_RED, delete = 1)",
	"ff.addArrow('redsun4_arrow', 'red_sun4', js.ARROW_RED, delete = 1)",
	"ff.addArrow('minion3_1_arrow', 'minion3_1', js.ARROW_RED, delete = 1)",
	"ff.addArrow('minion3_2_arrow', 'minion3_2', js.ARROW_RED, delete = 1)",
),
]

fourth_sun_wave_cs = [
(
	"startCS()",
	"see()",
	"wait(0.1)",
),
(
	"ff.FourthSunWave()",
	"Sound_PlayMusic('music_06redsun_cs1beat',1)",
	"peace()",
	"wait(0.1)",
),
(
	"look('red_sun_5_marker', zoom = 0, heading = 0, time = 2)",
	"Object_PlayEffect('red_sun5', 'effect_red_sun_glow')",
	"wait(0.1)",
),
(
	"forceSpeak('red_sun', 'MISSPCH_19_RS_07', telepathy=0)",
),
(
	"endCS()",
	"blind()",
	"war()",
	"Sound_PlayMusic('music_06redsun_cs1fight')",
	"ff.addArrow('redsun5_arrow', 'red_sun5', js.ARROW_RED, delete = 1)",
),
]

new_friends_cs = [
(
	"startCS()",
	"Mission_SetAttr('cs_playing',0)",
	"peace()",
	"see()",
	"wait(0.1)",
),
(
	"normalize('red_sun5')",
	"playTransition()",
),
(
	"ff.TeleportHeroes()",
	"look('red_sun_5_marker', zoom = 0, heading = 0, time = 0)",
	"wait(1.0)",
	"Sound_PlaySound('mission_elementals')",
	"Sound_PlayMusic('music_06redsun_cs1beat',1)",
),
(
	"speak('eve', 'MISSPCH_19_EV_07')",
),
(
	"forceSpeak('red_sun', 'MISSPCH_19_RS_08', telepathy=0)",
),
(
	"Object_PlayEffect('entropy_standin', 'effect_entropy_spawn', '',FX_TRACK_OBJECT_ROT)",
	"spawn('entropy_temp', 'entropy', 'entropy_spawn_marker')",
	"AI_SetEnabled('entropy_temp',0)",
	"peace()",
	"turnTo('entropy_temp','red_sun5')",
	"Sound_PlayMusic('music_09entropy_end1',1)",
	"wait(2.0)",
),
(
	"Trigger_Power('entropy_temp','red_sun5','entropy Potential Transfer','OnPower')",
	"wait(3.0)",
),
(
	"Object_PlayEffect('entropy_standin', 'effect_entropy_spawn', '',FX_TRACK_OBJECT_ROT)",
	"Object_Destroy('entropy_temp')",
	"wait(2.0)",
),
(
	"forceSpeak('entropy', 'MISSPCH_19_EN_01')",
),
(
	"look('sample_camera_point', zoom = 0, heading = 0, time = 1)",
	"see()",
	"wait(1.0)",
),
(
	"ff.SampleMerge()",
	"wait(16)",
),
(
	"forceSpeak('entropy', 'MISSPCH_19_EN_11')",
),
(
	"speak('eve', 'MISSPCH_19_EV_08')",
),
(
	"speak('eve', 'MISSPCH_19_EV_09')",
),
(
	"speak('eve', 'MISSPCH_19_EV_10')",
),
(
	"endCS()",
	"blind()",
	"war()",
	"Sound_PlayMusic('music_11elem1')",
	"newObjective('primary', 2, name='defeat_entropy_minions')",
	"newObjective('secondary', 2, name='stop_merging')",
	"ff.NewFriendsWait()",
),
]

first_wave_down_ss = [
(
	"speak('eve', 'MISSPCH_19_EV_12')",
),
(
	"blank",
),
]

second_wave_down_cs = [
(
	"startCS()",
	"peace()",
	"see()",
	"wait(0.1)",
),
(
	"Sound_PlayMusic('music_04winter_hit1',1)",
	"speak('eve', 'MISSPCH_19_EV_18')",
),
(
	"forceSpeak('entropy', 'MISSPCH_19_EN_03')",
	"Sound_PlayMusic('music_11elem_stdead1',1)",
),
(
	"look('s31_spawn_point', zoom = 0, heading = 0, time = 1)",
	"Object_PlayEffect('s31_standin', 'effect_portal_open', '',FX_TRACK_OBJECT_ROT)",
	"Object_PlayEffect('s32_standin', 'effect_portal_open', '',FX_TRACK_OBJECT_ROT)",
	"spawn('sub_1_1','subterrestrial','s31_spawn_point')",
	"regDeath('sub_1_1','AWaveKill')",
	"Object_PlayEffect('s31_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)",
	"spawn('sub_1_2','subterrestrial','s32_spawn_point')",
	"regDeath('sub_1_2','AWaveKill')",
	"Object_PlayEffect('s32_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)",
	"wait(1)",
),
(
	"wait(2)",
),
(
	"look('w31_spawn_point', zoom = 0, heading = 0, time = 1)",
	"Object_PlayEffect('w31_standin', 'effect_portal_open', '',FX_TRACK_OBJECT_ROT)",
	"Object_PlayEffect('w32_standin', 'effect_portal_open', '',FX_TRACK_OBJECT_ROT)",
	"spawn('wraith_1_1','wraith_warrior','w31_spawn_point')",
	"regDeath('wraith_1_1','AWaveKill')",
	"Object_PlayEffect('w31_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)",
	"spawn('wraith_1_2','wraith_warrior','w32_spawn_point')",
	"regDeath('wraith_1_2','AWaveKill')",
	"Object_PlayEffect('w32_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)",
	"wait(5)",
),
(
	"addArrow('wraith_1_1_arrow','wraith_1_1',ARROW_RED,1)",
	"addArrow('wraith_1_2_arrow','wraith_1_2',ARROW_RED,1)",
	"addArrow('sub_1_1_arrow','sub_1_1',ARROW_RED,1)",
	"addArrow('sub_1_2_arrow','sub_1_2',ARROW_RED,1)",
	"wait(0.1)",
),
(
	"endCS()",
	"blind()",
	"war()",
	"Sound_PlayMusic('music_11elem1')",
	"ff.WaveProxChecks()",
	"ff.SecondWaveFollowSpeech()",
),
]

second_follow_ss = [
(
	"speak('eve', 'MISSPCH_19_EV_20')",
),
(
	"blank",
),
]


#	Mission_SetAttr('second_wave_down', 1)
#	Mission_SetAttr('third_wave_up', 1)
#	# Reset the number of bad guys to 4
#	Mission_SetAttr('wave_total',4)



trees_ss = [
(
	"ff.PickTreeSpeaker()",
),
(
	"speak('eve', 'MISSPCH_19_EV_06')",
),
(
	"blank",
),
]


final_cs = [
(
	"playTransition()",
),
(
	"peace()",
	"see()",
	"startCS()",
	"Sound_PlayMusic('music_04winter_hit2',1)",
	"reviveHeroes()",
	"ff.TeleportHeroes()",
	"wait(0.1)",
),
(
	"look('red_sun_5_marker', zoom = 0, heading = 0, time = 0)",
	"Sound_PlaySound('mission_elementals')",
	"wait(0.2)",
),
(
	"spawn('eve','eve','eve_start_marker')",
	"peace()",
	"moveCB('eve', 'eve_run_target')",
),
(
	"speak('eve', 'MISSPCH_19_EV_21')",
	"Sound_PlayMusic('music_11elem_stdead1')",
),
(
	"look('entropy_spawn_marker', zoom = 0, heading = 0, time = 1)",
	"wait(1)",
),
(
	"Object_PlayEffect('entropy_standin', 'effect_portal_open', '',FX_TRACK_OBJECT_ROT)",
	"wait(1)",
),
(
	"spawn('entropy','entropy','entropy_spawn_marker')",
	"peace()",
	"turnTo('eve', 'entropy')",
	"turnTo('entropy', 'eve')",
	"wait(1)",
),
(
	"look('entropy', zoom = -200, heading = 0, time = 15)",
	"Object_PlayEffect('entropy_standin', 'effect_portal_close', '',FX_TRACK_OBJECT_ROT)",
	"wait(1)",
),
(
	"speak('entropy', 'MISSPCH_19_EN_06')",
),
(
	"speak('entropy', 'MISSPCH_19_EN_07')",
),
(
	"speak('entropy', 'MISSPCH_19_EN_14')",
),
(
	"speak('eve', 'MISSPCH_19_EV_22')",
),
(
	"ff.EvePortalOn()",
	"Object_Destroy('eve')",
	"speak('eve', 'MISSPCH_19_EV_26')",
),
(
	"speak('entropy', 'MISSPCH_19_EN_08')",
),
(
	"speak('entropy', 'MISSPCH_19_EN_09')",
),
(
	"speak('eve', 'MISSPCH_19_EV_27')",
	"Sound_PlayMusic('music_09entropy_end2',1)",
	"playEffectMarker('effect_portal_close', 'eve_run_target')",
	"Object_StopEffect('eve_standin', int(Mission_GetAttr('evehandle')))",
),
(
	"speak('man_bot', 'MISSPCH_19_MB_01')",
),
(
	"speak('entropy', 'MISSPCH_19_EN_15')",
),
(
	"endCS()",
	"blind()",
	"war()",
	"Mission_Win()",
),
]