######################################################################
## 
## debugging and optimizing
##
## stumpy: some help in tuning scripts
######################################################################

import sys
import string

def ShowUntrace(val,str=''):
    dirval = dir(val)
    if string:
        print 'ShowUntrace for %s:' % str
    for item in dirval:
        if item not in ('f_builtins', 'f_globals', 'f_locals', ):
            print '\t%s = %s' % (item,eval('val.%s'%item))

DEBUG_TRACE_CALLS = {}
TRACEBACK_VAL = None
def SimpleTrace(MaxDepth=10,verbose=0):
    global DEBUG_TRACE_CALLS
    global TRACEBACK_VAL
    try:
        raise
    except:
        TRACEBACK_VAL = sys.exc_info()[2]
        try:
            modulename = ('%s' % TRACEBACK_VAL.tb_frame.f_back.f_code)[string.rfind(('%s' % TRACEBACK_VAL.tb_frame.f_back.f_code),'\\')+1:string.rfind(('%s' % TRACEBACK_VAL.tb_frame.f_back.f_code),'.')+1]
            ##print 'SimpleTrace: modulename = <%s>' % modulename
            key = modulename + TRACEBACK_VAL.tb_frame.f_back.f_code.co_name
            rval = []
            depth = 0
            while depth < MaxDepth:
                depth = depth + 1
                namestr = 'TRACEBACK_VAL.tb_frame.f_back' + ('.f_back'*depth) + '.f_code.co_name'
                try:
                    name = eval(namestr)
                    if name != '?':
                        rval.append(name)
                    else:
                        break
                except:
                    break
            if rval == []:
                rval = ['']                                 # likely event
            rval = tuple(rval)
            if DEBUG_TRACE_CALLS.has_key(key):              # already tracing this function
                if DEBUG_TRACE_CALLS[key].has_key(rval):    # called before from this source
                    DEBUG_TRACE_CALLS[key][rval] = DEBUG_TRACE_CALLS[key][rval] + 1
                else:                                       # first call from this source
                    DEBUG_TRACE_CALLS[key][rval] = 1
            else:                                           # first call to traced function
                DEBUG_TRACE_CALLS[key] = {rval : 1}
            return rval
        except AttributeError:
            if verbose:
                print 'SimpleTrace: couldn\'t trace call (couldn\'t get function name).'
                ShowUntrace(TRACEBACK_VAL.tb_frame,'TRACEBACK_VAL.tb_frame')
            return None


def ClearTrace():
    global DEBUG_TRACE_CALLS
    DEBUG_TRACE_CALLS = {}


# Display the trace dictionary.  The default sort is by the alphabetic
# trace tree name (e.g. the dictionary keys).  If sort=='frequency',
# the sort is by descending dictionary values, thus it shows the
# most-called keys at the top.
def DisplayTrace(sort='alphabetic'):
    global DEBUG_TRACE_CALLS
    funckeys = DEBUG_TRACE_CALLS.keys()
    funckeys.sort()
    for func in funckeys:
        print '<---------  Tracing calls to %s  --------->' % func
        if sort == 'alphabetic':
            calltrees = DEBUG_TRACE_CALLS[func].keys()
            calltrees.sort()
            for calltree in calltrees:
                str = '%6d    ' % DEBUG_TRACE_CALLS[func][calltree]
                for caller in calltree:
                    str = str + caller + ' <-- '
                str = str[:-5]
                print str
        elif sort == 'frequency':
            calltrees = DEBUG_TRACE_CALLS[func].keys()
            callvals = DEBUG_TRACE_CALLS[func].values()
            callvals.sort()
            callvals.reverse()
            for callval in callvals:
                for calltree in calltrees:
                  if DEBUG_TRACE_CALLS[func][calltree] == callval:
                    str = '%6d    ' % DEBUG_TRACE_CALLS[func][calltree]
                    for caller in calltree:
                        str = str + caller + ' <-- '
                    str = str[:-5]
                    calltrees.remove(calltree)
                    break
                print str
            