###################################################################################
#
#	A list of all customisable attributes
#	The first entry is the attribute name as appears in FFEdit
#	The second is the name of the array used to customise in ffxcustom.py, in quotes
#   The third is the display name for the attribute, as it will appear in FFX Control Centre
#		and in commands in the FFX Nexus
#
#	To add your own, add the entry here and the customisation array to ffxdefault.py
#   The types list is the second list in the array, and gives types and display names for each slot
#   The first character should be a type code, telling the Control Centre what type it it
#		A - an animation name
#		a - an area power/explosion
#		b - a dependency penalty function, as listed in FFX_PENALTIES in ffxdefault.py
#		C - a custom command name, as listed in FFX_COMMANDS in ffxdefault.py
#		d - a dummy power, ie a ranged power that does nothing 
#		E - a mandatory effect from the Resources Tab in FFEdit (cannot be '')
#		e - a function from the list FFX_FEATSPERSONAL in ffxdefault.py
#		f - a function from the list FFX_TRIGGERS in ffxdefault.py
#		g - a function from the list FFX_ABSORBS in ffxdefault.py
#       G - a gender flag, stored numerically but appears as a string in Control Centre
#		H - the distance flag for HEAVY FOOTED, appears as STANDARD or TELEPORT/SPRINT in Control Centre
#		h - a function from FFX_SIDEEFFECTS in ffxdefault.py
#		i - an intensity, ie an unadulterated numerical value
#		j - a function from FFX_FEATSRANGE in ffxdefaults.py
#       l - a common object from the list in ffxdefaults.py
#		m - a bonus function from FFX_BONUSES
#		O - a resource tab FX, but Optional, ie can be '' for no FX
#               P - uses the FFX_SCHEMES list
#		q - last resort function from FFX_
#	?	R - an optional FX with the Refresh option, used in the nexus to reinstate permanent character FX by respawning
#		r - ranged power (beam or projectile)
#		s - any power from the database
#		t - a template for a TEMPORARY FORM character
#		U - a minion type/charcter template
#		v - a template for an INVOLUNTARY FORM
#		w - a weapon from FFX_WEAPONNAMES in ffxdefault.py
#
#	e.g. "ODamage FX" indicates a parameter to be displayed as 'Damage FX' of type optional FX.
#
#	The arrays mentioned above, eg FFX_COMMANDS, can be added to and the new entries will appear in the lists in Control Centre
#
#   Addendum:
#   - IMPORTANT: Any entry added here must have the corresponding list added in ffxdefault.py;
#     failing to do so may cause the Control Centre to crash (pimthe, 2006-02-18, from a finding by Tommyboy).
###################################################################################

FFX_ATTRIBUTES=[
["volatilestorage","FFX_VOLATILESTORAGE_CUSTOM","Volatile Storage"],
["twister","FFX_TWISTER_CUSTOM","Twister"],
["absorbpower","FFX_ABSORBPOWERS_CUSTOM","Absorb Powers"],
["absorbmat","FFX_ABSORBMATERIAL_CUSTOM","Absorb Material"],
["absorbenergy","FFX_ABSORBENERGY_CUSTOM","Absorb Energy"],
["overheated","FFX_OVERHEATED_CUSTOM","Overheated"],
["envcontrollocal","FFX_ENVCONTROLA_CUSTOM","Env Control (Local)"],
["earthcontrol","FFX_EARTHCONTROL_CUSTOM","Earth Control"],
["shapeshifter","FFX_SHAPESHIFT_CUSTOM","Shapeshifter"],
["livinglaser","FFX_LIVINGLASER_CUSTOM","Living Laser"],
["mimic","FFX_MIMIC_CUSTOM","Mimic"],
["explosive","FFX_EXPLODE_CUSTOM","Explosive"],
["stockpile","FFX_STOCKPILE_CUSTOM","Nuclear Stockpile"],
["dispersed","FFX_DISPERSE_CUSTOM","Dispersed Structure"],
["peacefield","FFX_PEACE_CUSTOM","Anti-War Zone"],
["telepathy","FFX_SCAN_CUSTOM","Enhanced Senses"],
["metashield","FFX_ENERGYSHIELD_CUSTOM","Energy Shield"],
["telekinetic","FFX_TK_CUSTOM","Telekinesis"],
["supertk","FFX_TK_CUSTOM","Super Telekinesis"],
["magnetic","FFX_MAGNETIC_CUSTOM","Magnetic"],
["earthcontrol","FFX_EARTHCONTROL_CUSTOM","Earth Control"],
["degenerative","FFX_DEGENERATIVE_CUSTOM","Degenerative"],
["puppetu","FFX_PUPPETURBAN_CUSTOM","Puppet Master (Urban)"],
["puppetn","FFX_PUPPETNATURE_CUSTOM","Puppet Master (Nature)"],
["tempform","FFX_TEMPFORM_CUSTOM","Temporary Form"],
["grouptp","FFX_GROUPTELEPORT_CUSTOM","Group Teleport"],
["heavyfooted","FFX_HEAVYFOOTED_CUSTOM","Heavy Footed"],
["frostbite","FFX_FROSTBITE_CUSTOM","Frostbite"],
["shortcirc","FFX_SHORTCIRCUITED_CUSTOM","Short-Circuited"],
["biohazard","FFX_BIOHAZARD_CUSTOM","Biohazard"],
["spiny","FFX_SPINY_CUSTOM","Spiny"],
["acidblood","FFX_ACIDBLOOD_CUSTOM","Acid Blood"],
["gaseousform","FFX_GASEOUSFORM_CUSTOM","Gaseous Form"],
["plasmasculptor","FFX_PLASMA_CUSTOM","Plasma Sculptor"],
["privatearmy1","FFX_PRIVATEARMY_CUSTOM","Private Army"],
["privatearmy2","FFX_PRIVATEARMY_CUSTOM","Private Army"],
["privatearmy3","FFX_PRIVATEARMY_CUSTOM","Private Army"],
["firecontrol","FFX_FIRECONTROL_CUSTOM","Flame Control"],
["icecontrol","FFX_ICECONTROL_CUSTOM","Ice Control"],
["accidentalchange","FFX_ACCIDENTALFORM_CUSTOM","Accidental Form"],
["acrobatic","FFX_ACROBATIC_CUSTOM","Acrobatic"],
["weathercontrol","FFX_WEATHERCONTROL_CUSTOM","Weather Control"],
["encontrolglobal","FFX_ENVCONTROLB_CUSTOM","Env Control (Global)"],
["innerbeing","FFX_INNERBEING_CUSTOM","Inner Being"],
["astral","FFX_ASTRALFORM_CUSTOM","Astral Form"],
["blazingglory","FFX_BLAZINGGLORY_CUSTOM","Blazing Glory"],
["kamikaze","FFX_KAMIKAZE_CUSTOM","kamikaze"],
["russiandoll","FFX_RUSSIANDOLL_CUSTOM","Russian Doll"],
["absorption","FFX_ABSORPTION_CUSTOM","Absorption"],
["metaleater","FFX_METALEATER_CUSTOM","Metal Eater"],
["urbandweller","FFX_URBANDWELLER_CUSTOM","Urban Dweller"],
["hatemonger","FFX_HATEMONGER_CUSTOM","Hatemonger"],
["vulnerability","FFX_VULNERABILITY_CUSTOM","Vulnerability"],
["dependency","FFX_DEPENDENCY_CUSTOM","Dependency"],
["transmutator","FFX_TRANSMUTATOR_CUSTOM","Transmutator"],
["weaponmaster","FFX_WEAPONMASTER_CUSTOM","WeaponMaster"],
["lightcontrol","FFX_LIGHTCONTROL_CUSTOM","Light Control"],
["metabolic","FFX_METABOLIC_CUSTOM","Metabolic"],
["solarpowered","FFX_SOLARPOWERED_CUSTOM","Solar Powered"],
["nocturnal","FFX_NOCTURNAL_CUSTOM","Nocturnal"],
["nemesis","FFX_NEMESIS_CUSTOM","Nemesis"],
["lastresort","FFX_LASTRESORT_CUSTOM","Last Resort"],
["painresponse","FFX_PAINRESPONSE_CUSTOM","Defence Mechanism"],
["miracle1","FFX_MIRACLE1_CUSTOM","Megablast"],
["miracle2","FFX_MIRACLE2_CUSTOM","Angelic Ally"],
["boost1","FFX_BOOST3_CUSTOM","Strength Boost"],
["boost2","FFX_BOOST4_CUSTOM","Unstoppable"],
["boost3","FFX_BOOST5_CUSTOM","Thunderclap"],
["pheremones","FFX_PHEREMONE_CUSTOM","Pheremones"],
["cannonball","FFX_C4CANNONBALL_CUSTOM","Human Cannonball"],
["ffqtempinvulnerability","FFQ_TEMPINVULNERABILITY_CUSTOM","Temp. Invulnerability"],
["ffqaura","FFQ_AURAUNTOUCHABLE_CUSTOM","Untouchable Aura"],
["ffqantimissile","FFQ_ANTIMISSILES_CUSTOM","Anti Missile Defence"],
["summoner1","FFX_SUMMONER_CUSTOM","Summoner"],
["summoner2","FFX_SUMMONER_CUSTOM","Summoner"],
["summoner3","FFX_SUMMONER_CUSTOM","Summoner"],
["summoner4","FFX_SUMMONER_CUSTOM","Summoner"],
["ffqbodyaura","FFX_BODYAURA_CUSTOM","Body Aura"],
["ffqupgradeable1","FFQ_UPGRADABLE_CUSTOM","Upgradeable"],
["ffqprecognitive","FFQ_PRECOGNITIVE_CUSTOM","Precognitive"],
["illusionist","FFX_ILLUSIONIST_CUSTOM","Illusionist"],
["ffqdivineintervention","FFQ_DIVINEINTERVENTION_CUSTOM","Divine Intervention"],
["ffqtracking","FFQ_TRACKING_CUSTOM","Tracking"],
["ffqmad","FFQ_MAD_CUSTOM","Mad"],
["terraformer","FFX_TERRAFORMER_CUSTOM","Terraformer"],
["absorptiona","FFX_ABSORPTIONA_CUSTOM","Absorption(Active)"],
["ffqcursed","FFQ_CURSED_CUSTOM","Cursed"],
["ffqblessed","FFQ_BLESSED_CUSTOM","Blessed"],
["ffqrealitymanipchaos","FFQ_REALITYMANIPCHAOS_CUSTOM","Reality Manip. (Chaos)"],
["ffqrealitymaniporder","FFQ_REALITYMANIPORDER_CUSTOM","Reality Manip. (Order)"],
["ffqfieldcommander","FFQ_FIELDCOMMANDER_CUSTOM","Field Commander"],
["symbiote","FFX_SYMBIOTE_CUSTOM","Symbiote"],
["parasite","FFX_PARASITE_CUSTOM","Parasite"],
["teleporter","FFX_C4TELEPORTER_CUSTOM","Natural Teleporter"],
["speedforce","FFX_SPEEDFORCE_CUSTOM","Speed Force"],
["GENERAL","FFX_CRYSTALS",""],
["GENERAL","FFX_TRANSMUTES",""],
["GENERAL","FFX_TELEPORT_FX",""],
["GENERAL","FFX_OBJECT_TEMPLATE",""],
["GENERAL","FFX_OBJECT_FX",""],
["GENERAL","FFX_STROBE",""],
]
##### DO NOT ADD ANY MORE ENTRIES! FFXATTRIBS IS MAXED OUT! #####