###########################################################################
#
# ffxExtras.py
#
# the source of all customised code for character attributes and weapons
#
# note that ffx.py cannot be imported fully here due to a circular dependency,
# so ffx functions need to be appended with ffx. like in the weapon code below
# in order to work correctly.
#
###########################################################################

from cshelper import *
from js import *
import ffx

############################ CONFIGURATION SECTION #######################################

#whether or not to use M25 AI rules as standard in campaign missions
#false for Freedom Force main campaign and the Strangers
FFX_RULES_CAMPAIGN_M25AI=0

#add voice ID's here to allow for gender determination
#templates can go here as well for special case characters, eg a robot with a male voice
#or female with an animal voice or whatever
#templates override voice ID's - they're checked first
girls=('SU','AL','EV','BB','LW','IQ','RB','GB','SB','F1','DF','SH','XV','XS','TC','GG','GF','RO','Z1','EN')
beasts=('SA','WA','RP','TR','ML','SR','KR','FE','SN','ST')
mechs=('MW','MC','FM','EY')
aliens=('AW','PR','ME','WW','WM','AC')
boys=()

#Mimics 
builtinMimics=['']
mimicPrefix=''

#slots are: object name, attachment node, (power, flag) pairs
FFX_Weapons=[
['ffx_flamethrower','Bip01 R Forearm',('ffx_flamethrower',0),],
['ffx_soniccannon','Bip01 R Forearm',('ffx_soniccannon',0),],
['ffx_handgun','Bip01 R Forearm',('ffx_handgun',0),],
['ffx_grenade','Bip01 R Hand',('ffx_grenade',0),],
['ffx_raygun','Bip01 R Forearm',('ffx_raygun',0),],
#['ffx_electronux','Bip01 R Forearm',('ffx_electronux',0),],
['ffx_megarod','Bip01 R Forearm',('ffx_megarodtp',0),('ffx_megarodblast',0),('ffx_megarodshield',1),],
]

#add your character templates which should be considered magical to this list
magicBeings=(
"wraith_warrior_extra",
"wraith_warrior",
"wraith_manta_extra",
"wraith_manta",
"tombstone_extra",
"tombstone",
"subterrestrial_extra",
"subterrestrial",
"shurale_extra",
"shurale",
"quetzalcoatl_extra",
"quetzalcoatl",
"pan",
"manbull_extra",
"manbull",
"fire_elemental_extra",
"fire_elemental",
"ffx_abraxas",
"entropy_extra",
"entropy",
"dark_shaman_friendly",
"dark_shaman_extra",
"dark_shaman",
"bacchite_silver",
"bacchite_red",
"bacchite_green",
"bacchite_extra",
"bacchite_eve",
"alchemiss",
"red_oktober_hero",
"red_oktober_extra",
"red_oktober",
)

#add your pet faschist character templates to this list, so your heroes can sense their evil stench
nazis=(
"nazi_rifleman_extra",
"nazi_rifleman",
"nazi_gunner_extra",
"nazi_gunner",
"nazi_grenadier_extra",
"nazi_grenadier",
"nazi_general_extra",
"nazi_general",
"red_sun_extra",
"red_sun",
"legionnaire_extra",
"legionnaire",
"killarilla_whip_friend",
"killarilla_whip_extra",
"killarilla_whip",
"killarilla_chaingun_extra",
"killarilla_chaingun",
"eye_minor_extra",
"eye_minor",
"eye_major",
"blitzkrieg_extra",
"blitzkrieg",
"fortissimo_extra",
"fortissimo",
)

#add your other electricity-powered physical object templates (generic and vehicles) here; bonus point for renewable sources ;)
electricalSources=(
'blitz_shield_emitter',
'blitz_shield_generator',
'car_1',
'car_2',
'car_3',
'car_3_nostand',
'car_night_1',
'car_night_2',
'car_night_3',
'car_night_ger_civauto1',
'car_night_ger_civauto2',
'car_night_police',
'car_night_taxi',
'car_police',
'car_taxi',
'catsaucer_veh',
'cub_telephone_pole',
'cub_old_car1',
'cub_old_car2',
'cub_old_car3',
'cub_street_lamp',
'cub_truck',
'cub_plane',
'cub_fence_barbed_light',
'cub_fence_barbed_light_on',
'cuban_missile_transmitter',
'ff_car',
'ff_computer',
'ff_objects',
'ff_science_equipment',
'ff_timemachine',
'force_field_projector',
'freezeray',
'ger_prop_poster1',
'ger_prop_poster2',
'ger_prop_poster3',
'ger_prop_poster4',
'ger_fence_barbed_light',
'ger_fence_barbed_light_on',
'ger_radar_large',
'ger_radar_small',
'ger_radio_tower',
'ger_searchlight'
#'ger_streetlamp', #gas-powered
#'ger_streetlamp_night', #gas-powered
'microwave_xray',
'mp_car',
'mp_truck',
'nazihq_cables_wall',
'nazihq_computer_big',
'nazihq_computer_short',
'nazihq_computer_tall',
'nazihq_energy_extractor',
'nazihq_floor_lamp',
'nazihq_hypno_switch',
'nazihq_lab_machine_1',
'nazihq_lab_machine_2',
'nazihq_lab_machine_3',
'nazihq_lab_machine_4',
'nazihq_lab_machine_5',
'nazihq_lab_machine_6',
'nazihq_lab_machine_7',
'nazihq_restraint',
'nazihq_switch',
'nazihq_temporal_amplifier',
'nazihq_temporal_amplifier_mp',
'nazihq_wall_lamp',
'pat_air_conditioner',
'pat_billboard_eldiablo',
'pat_billboard_mentor',
'pat_billboard_minuteman',
'pat_billboard_nobody',
'pat_fusebox',
'pat_neonsign',
'pat_neonsign_anima',
'pat_neonsign_animb',
'pat_neonsign_animc',
'pat_park_lamp',
'pat_phone_booth',
'pat_phone_booth_night',
'pat_streetlight',
'pat_streetlight_night',
'pat_trafficlight',
'pat_TV_aerial',
'screens_base',
'streetlight',
'streetlight_day',
'streetlight_night',
'switch',
'tank_damaged',
'tape_drive',
'truck_ger_ammo',
'truck_ger_cargo',
'truck_ger_military',
'truck_night_ger_cargo',
'truck_night_ger_military',
)

######################################################################
## 
## weapon code - used for adding custom weapon code to a mod
## 
######################################################################

def OnUseffx_flamethrower(target,char):
    ffx.OnUseWeapon(target,char,'ffx_flamethrower')

def OnUseffx_soniccannon(target,char):
    ffx.OnUseWeapon(target,char,'ffx_soniccannon')

def OnUseffx_handgun(target,char):
    ffx.OnUseWeapon(target,char,'ffx_handgun')

def OnUseffx_grenade(target,char):
    ffx.OnUseWeapon(target,char,'ffx_grenade')

def OnUseffx_raygun(target,char):
    ffx.OnUseWeapon(target,char,'ffx_raygun')

def OnUseffx_electronux(target,char):
    ffx.OnUseWeapon(target,char,'ffx_electronux')

def OnUseffx_megarodtp(target,char):
    ffx.OnUseWeapon(target,char,'ffx_megarod','ffx_megarodtp')

def OnUseffx_megarodblast(target,char):
    ffx.OnUseWeapon(target,char,'ffx_megarod','ffx_megarodblast',2)

def OnUseffx_physicalshield(target,char):
    ffx.OnUseWeapon(target,char,'ffx_megarod','ffx_physicalshield',0)

def do_ffx_megarod(event):
    ffx.hextoteleport(event)

def do_ffx_electronux(event):
    char=event.string
    amstat='affx_electronux'
    weapon='ffx_electronux'
    ammo=ffx.FFX_ObjectGetAttr(char,amstat)-1
    ffx.FFX_ObjectSetAttr(char,amstat,ammo)
    Mission_StatusText('ammo=%d'%(ammo))
    if ammo<=0:
        ffx.removeCommand(weapon,char)
        ffx.RegTimer('useupWeapon',2,0,weapon,char)


######################################################################
## 
## trigger actions for objects
## 
######################################################################

#Characters with the following attributes will have custom commands on these special objects
specialAttribs=('scientist','finetk','magnetic','telepathy')

def FFX_Switchffx_teleporter(event):
    obj=event.object
    target='pos_%s'%(obj)
    Object_PlayEffect(obj,'effect_microwave_teleport_out')
    count=0
    for char in Mission_GetDynamicObjects():
        if Object_GetClass(char)&ffx.FFX_CHARACTER:
            if ffx.distanceSq(char,obj)<50*50:
                Object_PlayEffect(obj,'effect_microwave_teleport_in')
                cshelper.teleport(char,target)
                count=count+1
    if count>1:
        name=ffx.getDummyName()
        cshelper.spawn(name,'portal_start_proxy',target)
        Trigger_Explosion(name,'portal_explosion')
        ffx.RegTimer('destroyTemp',3,name)

def FFX_Switchdoor_1(event):
    FFX_Switchdoor(event)
def FFX_Switchdoor_2(event):
    FFX_Switchdoor(event)
def FFX_Switchdoor_3(event):
    FFX_Switchdoor(event)
def FFX_Switch(event):
    FFX_Switchnazihq_wide_door_closed(event)


def FFX_Switchdoor(event):
    obj=event.object
    #open the door
    if Object_Exists(obj):
        cshelper.kill(obj)
    #close the door
    else:
        template=obj[3:-4]
        pos='pos_%s'%(obj)
        cshelper.spawn(obj,template,pos)
