from cshelper import *

import string
from string import *

PCSTATE_EXILED=3
TAGTEAM_FX='effect_portal_start'

def initMPModes():
    if isHost():
        Mission_CustomAction('TAG TEAM ORDERED','','','initTagTeamOrdered',30,0)
        Mission_CustomAction('TAG TEAM CHOICE','','','initTagTeamChoice',30,0)
        Mission_CustomAction('STANDARD','','','initStandard',30,0)

#returns true if you're the host computer
def isHost():
    if Object_Exists('s1:h0')==0:
        return 0
    return (Object_GetClass('s1:h0')&OC_CONTROLLABLE)!=0

def initTagTeamOrdered(dummy1,dummy2):
    initStandard(dummy1,dummy2)
    for team in range(1,5):
        for id in range(1,4):
            char='s%d:h%d'%(team,id)
            if Object_Exists(char):
                previous='s%d:h%d'%(team,id-1)
                archive(char)
                #when the previous character dies, make this one de-exile
                regDeath(previous,'OnDeExileNext')    

def initTagTeamChoice(dummy1,dummy2):
    initStandard(dummy1,dummy2)
    for team in range(1,5):
        for id in range(1,4):
            char='s%d:h%d'%(team,id)
            if Object_Exists(char):
                archive(char)    
                #add an extra hero point to each exiled dude for escaping
                Object_SetAttr(char,'heroPoints',Object_GetAttr(char,'heroPoints')+1)

def makeVisible(event):
    char=event.object
    FFX_ObjectSetAttr(char,'exForMP',0)
    Object_SetSecondaryState(char,SCSTATE_INVISIBLE,0,REMOVE_STATE)
    if TAGTEAM_FX!='':
        Object_PlayEffect(char,TAGTEAM_FX)
    if (Object_GetClass(char)&OC_CONTROLLABLE)!=0:
        Mission_SelectHero(char)

def initStandard(dummy1,dummy2):
    Mission_RemoveCustomAction('TAG TEAM ORDERED','','')
    Mission_RemoveCustomAction('TAG TEAM CHOICE','','')
    Mission_RemoveCustomAction('STANDARD','','')

def archive(char):
    #exile and invisible the character - they just leave a portrait behind now
    FFX_ObjectSetAttr(char,'exForMP',1)
    Object_SetSecondaryState(char,SCSTATE_INVISIBLE,20000,0)
    Object_SetPrimaryState(char,PCSTATE_EXILED,20000,0)
    #make them visible and play an effect when they de-exile
    regCharState(char,PCSTATE_NORMAL,'makeVisible')

def deArchive(char):
    Object_SetPrimaryState(char,PCSTATE_EXILED,0,REMOVE_STATE)

def OnDeExileNext(event):
    deadie=event.object
    print deadie
    id=atoi(deadie[4:])
    next='%s%d'%(deadie[:4],id+1)
    print next
    deArchive(next)
         