
import ff
import js
import m25ai
from m25ai import *
import m25aiconstants
import m25distance
import heightcheck
import skXMapInfo

#------------------------------
# Low Jumper
#------------------------------


def TLowJumper(tid, char, obj, flt, user, pct=100, time=3, energy=0, type=m25aiconstants.TARGET_ENEMY, mindist=0, maxdist=m25distance.DISTANCE_MELEE, subtype=None, situation=None, role=None, priority=m25aiconstants.TACTIC_PRIORITY_LOW):
	target = m25ai.Target_GetCurrentTarget(char,type)
	if not m25ai.AISupport_CheckConditions(char, target, m25ai.Target_GetDistance(char,type), pct, priority, mindist, m25distance.DISTANCE_WHOLEMAP, subtype, situation, role): 
 		return 0
 	object = skXMapInfo.MapInfo_GetObjects(char,tiDistance="nearest",tfFilter=AILowJumperFilter)
 	if object == None: return 0
 	if m25distance.GetDistance(object,char) > maxdist: return 0
 	m25ai.AISupport_DoFunction(char, 'ffx.ffqJumpLow("%s","%s")'%(char,char), target, priority, time, desc='low jump')
 	return 1
 	
def AILowJumperFilter(object):
	height = heightcheck.Template_GetHeight(js.Object_GetTemplate(object))
	if height[0] > 90: return 0
	return 1
ff.AILowJumperFilter = AILowJumperFilter
 	
def AIOpt_TLowJumper(char,tactic):
	return { 
		'mindist': 'Opt_ConvertMinDist(tactic,0)',
		'maxdist': 'Opt_ConvertMaxDist(tactic,m25distance.DISTANCE_MELEE)',
		'energy': 'Opt_Convert(tactic,"energy",0)',
		'pct': 'Opt_Convert(tactic,"pct",PRECALC_PCT_ALWAYS)',
		'time': 'Opt_Convert(tactic,"time",3)',
		'category': 'move',
	}
ff.AIOpt_TLowJumper = AIOpt_TLowJumper
	
def AIGen_ffqlowjumper(char):
	return ["TLowJumper()",1]
ff.AIGen_ffqlowjumper = AIGen_ffqlowjumper
