import ff
import js

from m25aiconstants import *
import m25ai
from m25ai import *
import ffx

#------------------------------
# Reality Manipulation
#------------------------------	
	
def TRealityManipulationChaos(tactic_id, char, object, flt, user, pct=10, time=1, energy=70, mindist=50, maxdist=300, type='enemy', subtype='none', situation='none', role='none', priority=TACTIC_PRIORITY_MEDIUM):
	try:
		if js.Mission_GetAttr('realityManipulation') > 0: return 0
	except: 
		return 0
	target = m25ai.Target_GetCurrentTarget(char,type)
	if not m25ai.AISupport_CheckConditions(char, target, m25ai.Target_GetDistance(char,type), pct, priority, mindist, maxdist, subtype, situation, role): 
		return 0		
	m25ai.AISupport_DoFunction(char, 'ffx.OnFFQRealityChaos("%s","%s")'%(char,char), target, priority, time, desc='temporary invulnerability')
	return 1		

def AIOpt_TRealityManipulationChaos(char,tactic):
	return { 
		'mindist': 'Opt_ConvertMinDist(tactic,0)',
		'maxdist': 'Opt_ConvertMaxDist(tactic,m25distance.DISTANCE_LONG)',
		'energy': 'Opt_Convert(tactic,"energy",66)',
		'pct': 'Opt_Convert(tactic,"pct",PRECALC_PCT_MEDIUM)',
		'time': 'Opt_Convert(tactic,"time",3)',
	}	
	
				
def TRealityManipulationOrderSwarmed(tactic_id, char, object, flt, user, pct=10, time=1, energy=70, mindist=50, maxdist=300, type='enemy', subtype='none', situation='none', role='none', priority=TACTIC_PRIORITY_MEDIUM):
	try:
		if js.Mission_GetAttr('realityManipulation') > 0: return
	except:
		return
	target = m25ai.Target_GetCurrentTarget(char,type)
	if not m25ai.AISupport_CheckConditions(char, target, m25ai.Target_GetDistance(char,type), pct, priority, mindist, maxdist, subtype, situation, role): 
		return 0		
	m25ai.AISupport_DoFunction(char, 'ffx.OnFFQRealityOrder("%s","%s")'%(char,char), target, priority, time, desc='temporary invulnerability')
	return 1		

def AIOpt_TRealityManipulationOrderSwarmed(char,tactic):
	return { 
		'mindist': 'Opt_ConvertMinDist(tactic,0)',
		'maxdist': 'Opt_ConvertMaxDist(tactic,m25distance.DISTANCE_LONG)',
		'energy': 'Opt_Convert(tactic,"energy",66)',
		'pct': 'Opt_Convert(tactic,"pct",PRECALC_PCT_MEDIUM)',
		'time': 'Opt_Convert(tactic,"time",3)',
		'situation': 'Opt_AddSituation(tactic,"swarmed")',
	}			

def TRealityManipulationOrderFriend(tactic_id, char, object, flt, user, pct=10, time=1, energy=70, mindist=50, maxdist=300, type='friend', subtype='none', situation='none', role='none', priority=TACTIC_PRIORITY_MEDIUM):
	try:
		if js.Mission_GetAttr('realityManipulation') > 0: return
	except:
		return
	target = m25ai.Target_GetCurrentTarget(char,type)
	if not m25ai.AISupport_CheckConditions(char, target, m25ai.Target_GetDistance(char,type), pct, priority, mindist, maxdist, subtype, situation, role): 
		return 0		
	m25ai.AISupport_DoFunction(char, 'ffx.OnFFQRealityOrder("%s","%s")'%(char,char), target, priority, time, desc='temporary invulnerability')
	return 1

def AIOpt_TRealityManipulationOrderFriend(char,tactic):
	return { 
		'mindist': 'Opt_ConvertMinDist(tactic,0)',
		'maxdist': 'Opt_ConvertMaxDist(tactic,m25distance.DISTANCE_LONG)',
		'energy': 'Opt_Convert(tactic,"energy",66)',
		'pct': 'Opt_Convert(tactic,"pct",PRECALC_PCT_MEDIUM)',
		'time': 'Opt_Convert(tactic,"time",3)',
		'type': 'Opt_Convert(tactic,"type","friend")',
		'situation': 'Opt_AddSituation(tactic,"lowerhealth 20")',
	}
	
def AIGen_ffqrealitymanipulation(char):
	return [["TRealityManipulationChaos()",1],["TRealityManipulationOrderFriend()",1],["TRealityManipulationOrderSwarmed()",1]]
ff.AIGen_ffqrealitymanipulation = AIGen_ffqrealitymanipulation	
	
def AIGen_ffqrealitymaniporder(char):
	return [["TRealityManipulationOrderFriend()",1],["TRealityManipulationOrderSwarmed()",1]]
ff.AIGen_ffqrealitymaniporder =AIGen_ffqrealitymaniporder	
	
def AIGen_ffqrealitymanipchaos(char):
	return ["TRealityManipulationChaos()",1]
ff.AIGen_ffqrealitymanipchaos = AIGen_ffqrealitymanipchaos