
import ff
import js

import m25event
import m25string
import m25cutscene
from m25cutscene import *


# set up the callback, remembering to make it persistent
m25event.Event_RegisterEvent('pstory_cutsceneline', 'CutscenePower_CheckPower', persistent=1)


# This function recieves a line from the potential cutscene during parsing.
# It checks to see if it contains 'uses power' and if it does
# returns a list consisting of the command to call and any characters
# involved in the command.
def CutscenePower_CheckPower(event):
	line = event.object
	found, user, remainder = m25string.SplitAroundPhrase(line,'uses power')
	if found:
		found, power, target = m25string.SplitAroundPhrase(remainder,' on ')
		if not found:
			power = remainder
			target = user
		command = 'CutscenePower_DoPower("%s","%s","%s")'%(user,power,target)
		actors = [user,target]
		return [command,actors]
	else:
		return None
	
# This function is called when a cutscene is actually being played.
# It triggers the power.
# Remember to use m25cutscene.Cutscene_ResolveObject(char) on any
# characters in the command to get an actual living character.
def CutscenePower_DoPower(cs_num, user, power, target):
	m25event.SetTimer(4, 'PlayCurrentCutscene', user=cs_num)
	user = m25cutscene.Cutscene_ResolveObject(user)
	target = m25cutscene.Cutscene_ResolveObject(target)
	js.Trigger_Power(user,target,power,'')
