#####################################################################################
#
# Module: m25cutscene
# Author: m25
# 
# Description: play pseudo-cutscenes that won't step on each other
#
# Version 3.052
#
#
#####################################################################################

CUTSCENE_WINDOWED = 1


print "Loading m25cutscene.py v.3.3.08 January 18, 2010"

#May 27, 2008: Bug in PlayCutscene function causing infinite recursion (fixed)
#May 7, 2008: Corrected bug in cutscene player - new cutscenes were overriding the return function on just completed cutscenes
#Nov 10, 2008: Cinematic Camera should now resolve objects properly.

#Jan 10, 2009: CS_Kill should now resolve objects properly

#Jan 18, 2010: Templates can be passed in as lower case and will match upper-case.


import types
import m25getset
import js
import ff
import m25event
import m25string
import random
from random import randint
import cshelper
import datfiles
import string
import sys

import m25gametype
import m25report

import m25customheads

from m25config import *
import m25template

if M25_USE_SKXCAMERA:
	import skXCamera2
	from skXCamera2 import *

from ffxtraits import *

import missionobjvar


m25report.Report_SetChannel('CUTSCENE',1)

# def Cutscene_fImportSkXCamera2 (tevent = ""):
# 	from skXCamera2 import *
# 	fSkXCameraInitialise(1)
# cshelper.regTimer ("Cutscene_fImportSkXCamera2", 1)

def onCancelledCS():
	m25report.Report('CUTSCENE', 'm25 cutscene has been cancelled')
	#m25getset.SetMissionVar('__cutscene',[])

def Cutscene_IsPlaying():
	return (m25getset.GetMissionVar('__cutscene', default=[]) != [])
	
def PlayCurrentCutscene(event):
	if type(event) == types.IntType:
		cs_num = event
	else:
		cs_num = event.user
	current_cs_num = m25getset.GetMissionVar('__cutscene_num', default=None)
	if current_cs_num != int(cs_num):
		m25report.Report('CUTSCENE', 'the current cutscene was interrupted... skipping it.')
		return
	cs = m25getset.GetMissionVar('__cutscene', default=[])
	if cs != None and (not type(cs) == types.ListType):
		m25report.Report('ERROR', 'the current cutscene is not a list!')
		return
	if cs not in [[],None]:
		m25getset.SetMissionVar('__cutscene', cs[1:])
		val, funcname, param = m25string.SplitAroundPhrase(cs[0],'(')
		cs_string = 'ff.%s(%i,%s'%(funcname, cs_num, param)
		if param == ')':
			cs_string = 'ff.%s(%i)'%(funcname, cs_num)
		#cs_string = 'ff.' + m25string.GetLeftString(cs[0],'(') + '(' + `cs_num` + ',' + m25string.GetRightString(cs[0],'(')
		m25report.Report('CUTSCENE', 'playing %s'%(cs_string))
		try:
			exec cs_string
		except:
			m25report.Report('ERROR' 'Error in playing cutscene - bad function %s'%(cs_string))
			raise
	else:
		if cs == []:
			m25getset.SetMissionVar('__cutscene', None)
			PlayCutsceneReturnFunction(cs_num)
			#see if there is anything in the queue
			queue = m25getset.GetMissionVar('__cutscene_queue',default=[])
			if queue != []:
				m25report.Report('CUTSCENE', 'retrieving the next cutscene from the queue.')
				m25getset.SetMissionVar('__cutscene_num', current_cs_num + 1)
				m25getset.SetMissionVar('__cutscene', queue[0][0])
				m25getset.SetMissionVar('__cutscene_priority', queue[0][1])
				m25getset.SetMissionVar('__cutscene_enc', queue[0][3])
				Cutscene_SetReturnFunction(queue[0][2])
				queue.remove(queue[0])
				m25getset.SetMissionVar('__cutscene_queue',queue)
				m25event.SetTimer(0.1,'PlayCurrentCutscene',user=current_cs_num+1)
			
	
def PlayCutscene(cutscene,priority=0,return_function=None,enc_id=None):
	m25report.Report('CUTSCENE', 'request to play cutscene.')
	CS_PrintCutscene(cutscene)
	current_cutscene = m25getset.GetMissionVar('__cutscene', default=None)
	current_cutscene_priority = m25getset.GetMissionVar('__cutscene_priority', default=None)
	current_cutscene_number = m25getset.GetMissionVar('__cutscene_num', default=0)
	if (current_cutscene_priority == None) or (priority > current_cutscene_priority) or (current_cutscene == None):
		if current_cutscene != None:
			#if there is an old return function, play it right away
			m25report.Report('CUTSCENE', 'bumping the current cutscene.')
			PlayCutsceneReturnFunction(current_cutscene_number)
		m25getset.SetMissionVar('__cutscene_num', current_cutscene_number + 1)
		m25getset.SetMissionVar('__cutscene', cutscene)
		m25getset.SetMissionVar('__cutscene_priority', priority)
		m25getset.SetMissionVar('__cutscene_enc', enc_id)
		Cutscene_SetReturnFunction(return_function)
		m25report.Report('CUTSCENE', 'calling PlayCurrentCutscene %i'%(current_cutscene_number+1))
		PlayCurrentCutscene(int(current_cutscene_number+1))
		#m25event.SetTimer(0.1,'PlayCurrentCutscene',user=current_cutscene_number+1)
	else:
		#add to queue?
		m25report.Report('CUTSCENE', 'adding cutscene to queue.')
		queue = m25getset.GetMissionVar('__cutscene_queue', default=[])
		queue.append([cutscene,priority,return_function,enc_id])
		m25getset.SetMissionVar('__cutscene_queue',queue)

		
def Cutscene_SetReturnFunction(fn):
	m25getset.SetMissionVar('__cutscene_function', fn)	
	
def Cutscene_GetReturnFunction():
	return m25getset.GetMissionVar('__cutscene_function')
		
def PlayCutsceneReturnFunction(cs_num):
	m25report.Report('CUTSCENE', 'calling cutscene return function.')
	fn = Cutscene_GetReturnFunction()
	current_cs_num = m25getset.GetMissionVar('__cutscene_num', default=0)
	if (current_cs_num == cs_num) and (fn != None):
		try:
			exec 'ff.'+fn
		except:
			m25report.Report('ERROR' 'error in cutscene return function - %s'%(fn))
			raise
	else:
		m25report.Report('CUTSCENE', 'no return function to call.')
	#Cutscene_SetReturnFunction(None)
		
def CS_PrintCutscene(cs):
	for c in cs:
		m25report.Report('CUTSCENE', ' - ' + c)
	
def CS_AddArrow(cs_num, arrow_name, object, arrow_type=js.ARROW_RED, delete=1):
	m25event.SetTimer(0.1, 'PlayCurrentCutscene',user=cs_num)
	cshelper.addArrow(arrow_name,Cutscene_ResolveObject(object),arrow_type,delete=delete)
		
def CS_Animate(cs_num, actor, animation):
	m25event.SetTimer(2.0, 'PlayCurrentCutscene', user=cs_num)
	js.AI_Animate(Cutscene_ResolveObject(actor),animation)	
	
def CS_CinematicCamera(cs_num, location1, location2=''):
	if not M25_USE_SKXCAMERA: 
		CS_Camera(cs_num, location1)
		return
	skXCamera2.fSkXCameraStop(tbRelease = 0)
	if location2 == '':
	#if js.Object_Exists(location1) and js.Object_Exists(location2):
		obj = Cutscene_ResolveObject(location1)
		skXCamera2.fSkXCameraStart(obj)
	else:
		obj = Cutscene_ResolveObject(location1)
		obj2 = Cutscene_ResolveObject(location2)
		skXCamera2.fSkXCameraStart(obj, obj2)
	m25event.SetTimer(1,'PlayCurrentCutscene',user=cs_num)
	
def CS_Camera(cs_num, location, dist=0, pitch=0, yaw=0, speed=1, path=js.CPM_SNAP, action=js.CA_MOVE):
	skXCamera2.fSkXCameraStop(tbRelease = 0)
	if type(location) == types.TupleType:
		js.Camera_LookAtPos(location,dist,pitch,yaw,speed,path,action)
	elif js.Object_Exists(location):
		js.Camera_LookAtObject(location,dist,pitch,yaw,speed,path,action)
	elif js.Marker_Exists(location):
		js.Camera_LookAtMarker(location,dist,pitch,yaw,speed,path,action)
	else:
		#try to find a character with the complex template
		obj = Cutscene_ResolveObject(location)
		if obj != None:
			js.Camera_LookAtObject(obj, dist,pitch,yaw,speed,path,action)
		else:
			m25report.Report('ERROR', 'cannot focus camera on %s - does not exist.'%(repr(location)))
		speed = 0.1
	m25event.SetTimer(speed,'PlayCurrentCutscene',user=cs_num)

def CS_CustomFunction(cs_num, fn, delay):
	m25event.SetTimer(delay,'PlayCurrentCutscene',user=cs_num)
	try:
		eval(fn)
	except:
		m25report.Report('CUTSCENE', 'error in function %s'%fn)
		print sys.exc_type, sys.exc_value
	
def CS_Destroy(cs_num, actor):
	js.Object_Destroy(Cutscene_ResolveObject(actor))
	m25event.SetTimer(0.1,'PlayCurrentCutscene',user=cs_num)
	
def CS_Effect(cs_num, effect, location):
	location = Cutscene_ResolveObject(location)
	try:
		if js.Object_Exists(location):
			js.Object_PlayEffect(location, effect)
		elif js.Marker_Exists(location):
			js.Object_PlayEffect(js.Object_GetTerrain(), effect, '', 0, 0, "", js.Get_MarkerPos(location), 0)
		else:
			js.Object_PlayEffect(js.Object_GetTerrain(), effect, '', 0, 0, "", location, 0)
	except:
		raise
		pass
	m25event.SetTimer(0.1,'PlayCurrentCutscene',user=cs_num)
	
def CS_End(cs_num):
	if CUTSCENE_WINDOWED:
		js.Camera_SetWidescreen(0)
	if CS_GetInBriefing():
		js.UI_Briefing_Done()
		CS_SetInBriefing(0)
	else:
		#check to see if we are in a base mission in a campaign
		if m25gametype.GameType_InBase():
			if CS_GetUIEnable(): js.UI_Base_Enable(1)
		else:	
			if CS_GetUIEnable(): js.UI_Enable(1)
			js.Camera_Release()
			try:
				ff.AIWar()
			except:
				pass
			js.Mission_SetDetectionEnabled(1)
			#stop kuertee's camera
			skXCamera2.fSkXCameraStop()
	m25event.SetTimer(0.1,'PlayCurrentCutscene',user=cs_num)
	
def CS_EndBriefing(cs_num):
	cshelper.endBriefingCS()
	m25event.SetTimer(0.1,'PlayCurrentCutscene',user=cs_num)
	
def CS_Explode(cs_num, actor):
	m25event.SetTimer(0.5,'PlayCurrentCutscene',user=cs_num)
	js.Trigger_Explosion(Cutscene_ResolveObject(actor), 'ffx_ex_fire_large')	
	
def CS_Fade(cs_num, time):
	js.Camera_Fade(time)
	CS_SetUIEnable(0)  #stop the CS_End function from enabling the UI after a cutscene has ended, it just looks bad
	m25event.SetTimer(time,'PlayCurrentCutscene',user=cs_num)
	
def CS_Hurt(cs_num, actor, amount):
	m25event.SetTimer(0.1,'PlayCurrentCutscene',user=cs_num)
	js.Trigger_Damage(Cutscene_ResolveObject(actor), amount)	
	
def CS_Kill(cs_num, actor):
	act = Cutscene_ResolveObject(actor)
	js.Object_SetAttr(act, 'minHealth', 0)
	js.Trigger_Damage(act, js.Object_GetAttr(actor, 'health'))
	m25event.SetTimer(0.1,'PlayCurrentCutscene',user=cs_num)
	
def CS_Lighting(cs_num, lighting):
	#set so ffx doesn't overwrite the user's choice of lighting
	js.Mission_SetAttr('cosmeticSun',1)
	#Mission_SetSunlight(rotation, tilt, brightness, ambient, color tuple)
	if lighting == 'sunrise':
		js.Mission_SetSunlight(170,20,1.2,1.0,(0.8,0.5,0.2))
		js.Mission_SetShadows(170,20,(0.2,0.3,0.3))
		js.Mission_SetProjShadowBackground((1,1,1))
		js.Mission_SetProjShadowColor((.8,.7,.7,1))
		CS_SetLights(0)
	elif lighting == 'midnight':
		js.Mission_SetSunlight(-137,57,1.5,0.2,(0.2,0.2,0.6))
		js.Mission_SetShadows(-137,57,(0.2,0.2,0.4))
		js.Mission_SetProjShadowBackground((1,1,1))
		js.Mission_SetProjShadowColor((.6,.6,.6,1))
		CS_SetLights(1)
	elif lighting == 'sunset':
		js.Mission_SetSunlight(-140,20,1.2,1.0,(0.8,0.5,0.2))
		js.Mission_SetShadows(-140,20,(0.2,0.3,0.3))
		js.Mission_SetProjShadowBackground((1,1,1))
		js.Mission_SetProjShadowColor((.8,.7,.7,1))
		CS_SetLights(0)
	elif lighting == 'red alert':
		js.Mission_SetSunlight(-80,75,0.8,0.4,(1.0,0.5,0.5))
		js.Mission_SetShadows(-80,75,(0.4,0.2,0.4))
		js.Mission_SetProjShadowBackground((1,1,1))
		js.Mission_SetProjShadowColor((.6,.6,.6,1))
	elif lighting == 'afternoon':
		js.Mission_SetSunlight(-120,70,1.2,0.6,(0.8,0.7,0.6))
		js.Mission_SetShadows(-120,70,(0.2,0.2,0.5))
		js.Mission_SetProjShadowBackground((1,1,1))
		js.Mission_SetProjShadowColor((.5,.5,.6,1))
		CS_SetLights(0)
	elif lighting == 'noon':
		js.Mission_SetSunlight(-80,80,1.0,1.0,(1,1,1))
		js.Mission_SetShadows(-80,80,(0.5,0.5,0.5))
		js.Mission_SetProjShadowBackground((1,1,1))
		js.Mission_SetProjShadowColor((.5,.5,.6,1))
		CS_SetLights(0)
	elif lighting == 'twilight':
		js.Mission_SetSunlight(-140,60,1.2,1.0,(0.3,0.2,0.9))
		js.Mission_SetShadows(-140,60,(0.1,0.1,0.6))
		js.Mission_SetProjShadowBackground((1,1,1))
		js.Mission_SetProjShadowColor((.5,.5,.7,1))
		CS_SetLights(1)
	elif lighting == 'day':
		js.Mission_SetSunlight(-45,45,0.8,0.5,(1.0,1.0,1.0))
		js.Mission_SetShadows(-45,45,(0.5,0.5,0.5))
		js.Mission_SetProjShadowBackground((1,1,1))
		js.Mission_SetProjShadowColor((.5,.5,.6,1))
		CS_SetLights(0)
	elif lighting == 'night':
		js.Mission_SetSunlight(-80,80,0.3,0.1,(1.0,1.0,1.0))
		js.Mission_SetShadows(-80,80,(0.5,0.5,0.5))
		js.Mission_SetProjShadowBackground((1,1,1))
		js.Mission_SetProjShadowColor((.5,.5,.6,1))
		CS_SetLights(1)
	else:
		pass
	m25event.SetTimer(0.1,'PlayCurrentCutscene',user=cs_num)	
	
def CS_MoveTo(cs_num, actor, target, time=1.0, command='move'):
	m25event.SetTimer(time, 'PlayCurrentCutscene', user=cs_num)
	cshelper.moveTo(Cutscene_ResolveObject(actor),Cutscene_ResolveObject(target),command=command)
	
def CS_Music(cs_num, music):
	try:
		js.Sound_PlayMusic(music)
	except: pass
	m25event.SetTimer(0.1, 'PlayCurrentCutscene', user=cs_num)	
	
def CS_RemoveArrow(cs_num, arrow_name):
	m25event.SetTimer(0.1, 'PlayCurrentCutscene',user=cs_num)
	cshelper.removeArrow(arrow_name)	
	
def CS_ReturnFunction(cs_num, time, function, string1, string2, user):
	m25event.SetTimer(time, function, string1, string2, user)
	
def CS_Revive(cs_num, actor):
	try:
		char = Cutscene_ResolveObject(actor)
		js.Object_SetAttr(char, 'health', js.Object_GetAttr(char, 'maxHealth'))
		cshelper.normalize(char)
	except:
		print 'Unable to resolve %s'%actor
		pass
	m25event.SetTimer(0.1, 'PlayCurrentCutscene', user=cs_num)	
	
def CS_ReviveAllHeroes(cs_num):
	heroes = cshelper.getAllHeroes()
	for h in heroes:
		js.Object_SetAttr(h, 'health', js.Object_GetAttr(h, 'maxHealth'))
		cshelper.normalize(h)
	m25event.SetTimer(0.1, 'PlayCurrentCutscene', user=cs_num)		
	
def CS_Sound(cs_num, sound, location):
	try:
		if js.Object_Exists(location):
			location = js.Get_ObjectPos(location)
		elif js.Marker_Exists(location):
			location = js.Get_MarkerPos(location)
		else:
			actor = Cutscene_ResolveObject(location)
			if js.Object_Exists(actor):
				location = js.Get_ObjectPos(actor)
		js.Sound_PlaySound(sound, location)
	except: 
		raise
		pass
	m25event.SetTimer(0.1, 'PlayCurrentCutscene', user=cs_num)
	
def CS_Speak(cs_num, char, tag, force=0):
	char = Cutscene_ResolveObject(char)
	truetag = tag
	if type(tag) == types.ListType:
		truetag = findSpeechTag(char,tag[random.randint(0,len(tag)-1)])
	else:
		truetag = findSpeechTag(char,tag)
	# if the speech isn't in captions.txt, use the status line instead
	if not checkCaption(truetag):
		CS_StatusSpeak(cs_num, char, truetag)
		return
	
	if char and (char != 'narrator'):
	#try to force custom templates to speak
		try:
			resolved = Cutscene_ResolveObject(char)
			if resolved != None: char = resolved
			if js.Object_GetAttr(char, 'complex') >= 1000:
			#if js.Object_GetTemplate(char)[0:7] == 'custom_':		
				force = 1
				temp = m25customheads.CustomHeads_GetTemplate(char)
				if temp != None:
					char = temp
				else:
					char = m25template.GetComplexTemplate(char)
		except:
			pass
		
	#otherwise, use the games animated portrait speech mechanism
	if force or (char in ['narrator','none']):
		#cshelper.forceSpeak(char,truetag)
		js.AI_SayPortraitSpeech(char, truetag, 'PlayCurrentCutscene', cs_num, 1, 0.5, -1, 0, 0, 0)
	else:
		js.AI_SayPortraitSpeech(Cutscene_ResolveObject(char), truetag, 'PlayCurrentCutscene', cs_num, 0,0.5, -1, 0, -1, 0)
		#cshelper.speak(char,truetag)
		
def CS_SpeakTo(cs_num, char, target, tag, force=0):
	char = Cutscene_ResolveObject(char)
	target = Cutscene_ResolveObject(char)
	truetag = tag
	if type(tag) == types.ListType:
		truetag = findSpeakToTag(char,target,tag[random.randint(0,len(tag)-1)])
	else:
		truetag = findSpeakToTag(char,target,tag)
	if force or (char in ['narrator','none']):
		js.AI_SayPortraitSpeech(char, truetag, 'PlayCurrentCutscene', cs_num, 1, 0.5, -1, 2, -1, 0)
	else:
		js.AI_SayPortraitSpeech(char, truetag, 'PlayCurrentCutscene', cs_num, 0,0.5, -1, 0, -1, 0)		
		
def CS_StatusSpeak(cs_num, char, tag):
	#status speak does not work with widescreen mode, sadly
	if CUTSCENE_WINDOWED:
		js.Camera_SetWidescreen(0)
	string = UnderscoreToSpace(m25template.GetComplexTemplate(char)) + ': ' + `tag`
	delay = len(tag) * 0.075
	js.Mission_StatusText(string)
	m25event.SetTimer(delay, 'PlayCurrentCutscene', user=cs_num)
		
def UnderscoreToSpace(string):
	newstring = ''
	for s in string:	
		if s == '_': newstring = newstring + ' '
		else: newstring = newstring + s
	return newstring

def CS_Shake(cs_num):
	js.Camera_Shake(1000, (0,0,0))
	m25event.SetTimer(2.0,'PlayCurrentCutscene',user=cs_num)	
		
def CS_Start(cs_num):
	#check to see if we are in a base mission in a campaign
	#if 'base' in sys.modules.keys():  
	if CUTSCENE_WINDOWED:
		js.Camera_SetWidescreen(1)
	if m25gametype.GameType_InBase():
		js.UI_Base_Enable(0)
	else:
		#cshelper.startCS()
		js.UI_Enable(0)
	try:
		ff.AIPeace()
	except:
		pass
	js.Mission_SetDetectionEnabled(0)
	m25event.SetTimer(0.1,'PlayCurrentCutscene',user=cs_num)

def CS_TeleportAllTo(cs_num, t_list, destination):
	m25event.SetTimer(0.2, 'PlayCurrentCutscene', user=cs_num)
	grid = [
			[5,5], [0,-30], [20,-30], [-20,-30], 
			[0,-10], [20,-10], [-20,-10],
			[40,-30], [-40,-30], [40, -10], [-40, -10],
			[0, 10], [20, 10], [-20, 10], [40, 10], [-40, 10],
			[0, 30], [20, 30], [-20, 30], [40, 30], [-40, 30],
			[0, 50], [20, 50], [-20, 50], [40, 50], [-40, 50]
		]
	target = CS_ResolveObject(destination)
	num = 0
	if js.Marker_Exists(target): pos = js.Get_MarkerPos(target)
	else: pos = js.Get_ObjectPos(target)
	if not js.Marker_Exists('cs_teleport_marker'): js.Marker_Spawn('_tpa_marker', (0,0,0), 0)
	for t in t_list:
		target_pos = (pos[0] + grid[num][0], pos[1] + grid[num][1], pos[2])
		js.Marker_SetPos('cs_teleport_marker', target_pos)
		cshelper.teleprot(t, 'cs_teleport_marker')
	
def CS_TeleportTo(cs_num, actor, target):
	m25event.SetTimer(0.2, 'PlayCurrentCutscene', user=cs_num)
	# make sure the actor teleports to a location slightly offset from the target
	# otherwise they will clip each other badly
	pos = None
	try:
		pos = js.Get_ObjectPos(Cutscene_ResolveObject(target))
	except:
		if js.Marker_Exists(target):
			pos = js.Get_MarkerPos(target)
		else:
			return  #nothing to teleport to
	xpos = randint(1,4)*10
	ypos = randint(1,4)*10
	pos = (pos[0]+xpos, pos[1]+ypos, pos[2])
	pos = skXMapInfo.MapInfo_EnsurePointIsOutsideBuilding(pos)
	# find the teleport marker and move it to the appropriate position
	if not js.Marker_Exists('cs_teleport_marker'):
		js.Marker_Spawn('cs_teleport_marker', pos)
	else:
		js.Marker_SetPos('cs_teleport_marker', pos)
	cshelper.teleport(Cutscene_ResolveObject(actor), 'cs_teleport_marker')		

def CS_TraitSpeak(cs_num, char, speechlist, default='', force=0):
	speech = default
	for s in speechlist:
		if Cutscene_HasTrait(Cutscene_ResolveObject(s[0]), s[1]):
			speech = s[2]
			break
	CS_Speak(cs_num, char, speech, force=force)
			
def CS_Transition(cs_num):
	js.Mission_Play2DCutscene("transition_mission_nif", "transition_mission_wav")
	m25event.SetTimer(0.5,'PlayCurrentCutscene',user=cs_num)
		
def CS_TurnTo(cs_num, actor, target):
	m25event.SetTimer(0.5, 'PlayCurrentCutscene', user=cs_num)
	cshelper.turnTo(Cutscene_ResolveObject(actor),Cutscene_ResolveObject(target))
	
def CS_UnFade(cs_num, time):
	js.Camera_UnFade(time)
	CS_SetUIEnable(1)  #allow the CS_End function to enable the UI after a cutscene has ended
	m25event.SetTimer(time,'PlayCurrentCutscene',user=cs_num)	
	
def CS_Wait(cs_num, time, end_time=0):
	delay = time
	if end_time:
		delay = randint(time,end_time)
	m25event.SetTimer(delay, 'PlayCurrentCutscene',user=cs_num)	
	
def CS_WalkTo(cs_num, actor, target, time=1.0):
	m25event.SetTimer(time, 'PlayCurrentCutscene', user=cs_num)
	#moveTo(character, position, command = 'move', fn = '', radius = 30, speed = 0)
	cshelper.moveTo(Cutscene_ResolveObject(actor),Cutscene_ResolveObject(target), command='walk', speed=1)	
		
#-------------------------------------------------------------------------------------
#
# Helper Functions
#
#-------------------------------------------------------------------------------------	
	
def Cutscene_ResolveObject(template):
	if template == 'narrator': return template
	if type(template) != types.StringType:
		return repr(template)
	if js.Object_Exists(template):
		return template
	if js.Marker_Exists(template):
		return template
		
	#try to find a character with the complex template
	objects = js.Mission_GetDynamicObjects()
	done = 0
	for obj in objects:
		if string.lower(m25template.GetComplexTemplate(obj)) == string.lower(template):
			return obj
			
	#try to find a character with that trait
	for traitlist in ffxTraits:
		if template == traitlist[0]:
			for obj in objects:
				if (Object_GetClass(obj) & js.OC_CONTROLLABLE) and js.Template_GetSpeechID(js.Object_GetTemplate(obj)) in traitlist[1:]:
					return obj
	return template
	
		
def Cutscene_HasTrait(char, trait):
	if char == trait: return 1
	if js.Object_Exists(char) and (m25template.GetComplexTemplate(char) == trait): return 1
	if (trait == 'alive') and js.Object_Exists(char) and js.Object_IsAlive(char): return 1
	speechid = ''
	if js.Object_Exists(char): speechid = js.Template_GetSpeechID(js.Object_GetTemplate(char))
	else: speechid = js.Template_GetSpeechID(char)
	for traitlist in ffxTraits:
		if (trait == traitlist[0]) and (speechid in traitlist):
			return 1

	
#-------------------------------------------------------------------------------------
#
# Get appropriate tag from the captions.txt file
#
#-------------------------------------------------------------------------------------		
		
captionList = []
reverseCaptionList = {}

def getCaptions():
	global captionList
	global reverseCaptionList
	modpath = datfiles.GetModPath()
	fname = open(modpath+'\Lang\English\captions.txt','r')
	line = fname.readline()
	while line != '':
		tag = m25string.GetLeftString(line,',')
		if tag != '\n':
			captionList.append(tag)
			rc = string.strip(m25string.GetRightString(m25string.GetRightString(line,','), ','))
			reverseCaptionList[rc] = tag
		line = fname.readline()
	fname.close()

def checkCaption(tag):
	global captionList
	if captionList == []:
		getCaptions()
	if tag in captionList:
		return 1
	return 0

def checkReverseCaption(tag):
	global reverseCaptionList
	if reverseCaptionList == {}:
		getCaptions()
	if reverseCaptionList.has_key(tag):
		return reverseCaptionList[tag]
	return None

def findSpeechTag(char, tag):
	rc = checkReverseCaption(tag)
	if rc != None: return rc
	cpat = GetSpeechPattern(char)
	for c in cpat:
		caption = c + '_' + tag
		if checkCaption(caption): return caption
	return tag

#disabled, pending a better solution	
def GetSpeechPattern(char):
	return [char]
	
	if not type(char) == types.StringType: return char
	template = char
	if js.Object_Exists(char):
		template = m25template.GetComplexTemplate(char)
	if M25SpeechPatterns.has_key(template):
		return CombineLists([template],M25SpeechPatterns[template])
	try:
		t = Object_GetSpeechID(char)
		return CombineLists([tempate],M25SpeechPatterns[t])
	except:
		return [template]
	
	
def findSpeakToTag(char, target, tag):
	rc = checkReverseCaption(tag)
	if rc != None: return rc
	cpat = GetSpeechPattern(char)
	tpat = GetSpeechPattern(target)
	for c in cpat:
		for t in tpat:
			caption = c + '_' + tag + '_' + t
			if checkCaption(caption): return caption
		caption = c + '_' + tag
		if checkCaption(caption): return caption
	return tag


def CombineLists(list1, list2):
	if (list1 == []) or (list1 == None):
		return list2
	if (list2 == []) or (list2 == None):
		return list1
	newlist = list1[0:]
	for t in list2:
		newlist.append(t)
	return newlist
	
	
#-------------------------------------------------------------------------------------
#
# Turn the streetlights on and off (from Dr. Mike's freeroam)
#
#-------------------------------------------------------------------------------------	
	
def CS_SetLights(index):
	pairs=(('pat_streetlight','pat_streetlight_night'),('pat_park_lamp','pat_park_lamp_night'),('pat_hotdog_stand','pat_hotdog_stand_night'),('pat_phonebooth','pat_phonebooth_night'),
		('ger_streetlamp','ger_streetlamp_night'),
	)
	for o in js.Mission_GetObjects():
		if js.Object_GetAttr(o,'health')==js.Object_GetAttr(o,'maxHealth'):
			t=js.Object_GetTemplate(o)
			for pair in pairs:
				if t==pair[0] or t==pair[1]:
					name='o%s'%(o)
					if o[0]=='o':
						name=o[1:]
					cshelper.spawn(name,pair[index],o)
					angle=-(js.Object_GetOrientation(o)[1])*57.3
					try:
						js.Object_SetOrientation(name,angle,(0,0,1))
					except:
						print 'CS_SetLights cannot set orientation of %s'%(name)
						pass
					js.Object_Destroy(o)
					
#-------------------------------------------------------------------------------------
#
# Mark as being in or out of a briefing cutscene
#
#-------------------------------------------------------------------------------------					

def CS_SetInBriefing(val=1):
	m25getset.SetMissionVar('cs_in_briefing', val)
	
def CS_GetInBriefing():
	return m25getset.GetMissionVar('cs_in_briefing', default=0)
	
def CS_InBase():
	return m25gametype.GameType_InBase()
# 	
# 	if 'OnBriefing' in dir(ff):
# 		if not 'FreeRoam_InitMission' in dir(ff):
# 			return 1
# 	return 0


#-------------------------------------------------------------------------------------
#
# Control whether the UI should be enabled, or not
#
#-------------------------------------------------------------------------------------	

def CS_SetUIEnable(enable=1):
	js.Mission_SetAttr('cs_ui_enable', enable)
	
def CS_GetUIEnable():
	try:
		return js.Mission_GetAttr('cs_ui_enable')
	except:
		return 1

