import ff
from ff import *

import cshelper
from cshelper import *
import js
from js import *
import event
import ffx
from ffx import *
from shutil import*
import freeroam_bonus
import freeroam_exit
import freeroam_native
import freeroam_customs
import freeroam_level
import m25freeroam_campaign
import freeroam_campdata

import m25ai

import m25getset
import m25freeroamally
import m25freeroamdata
import m25enc
import m25template

import m25cutscene

import m25event

import os.path
import datfiles

from ffxcustom import *
from ffxcustom2 import *

######################################################################
#
# library code for 'free-roaming' campaign missions
#  by Dr Mike v1.0 28/06/05
# Very heavily modified to work with EZ script by m25
#
######################################################################

######################################################################
#
# Mission-handling functions - loads the next level up, etc.
#
######################################################################

# please update as needed
FREEROAM_VERSION ={
'majorVersion': 3, # official major version, ex.: 3 for 3.0.4
'minorVersion': 2, # official update version, ex.: 0 for 3.0.4
'patchVersion': 0, # official patch version, ex.: 4 for 3.0.4
'buildVersion': 7, # for each new main branch, new build number; for someone's branch, name of the main build from which this was branched
'buildBranch': "m25 branch 1" # either 'main' (followed by some identification for public releases, such as 'beta 1' or 'final') for merged code or name of the author of the branch, optionally followed by the branch's numbering
}
print "Loading m25freeroam.py v. %i.%i.%i build %i; branch = %s" %  (FREEROAM_VERSION['majorVersion'], FREEROAM_VERSION['minorVersion'], FREEROAM_VERSION['patchVersion'], FREEROAM_VERSION['buildVersion'], FREEROAM_VERSION['buildBranch'])


def Freeroam_ArrowCheck(event):
	arrows = m25getset.GetMissionVar('_freeroam_arrows',default=[])
	for a in arrows:
		if m25getset.GetMissionVar('_freeroam_arrows_showall',default=0) or (FreeRoam_HeroDistance(a) < 800):
			if not js.Mission_TestAttr('%s_visible'%(a)):
				cshelper.addArrow('arrow_'+a,a,1)
				js.Mission_SetAttr('%s_visible'%(a),1)
		else:
			if js.Mission_TestAttr('%s_visible'%(a)):
				js.Mission_RemoveArrow('arrow_%s'%(a))
				js.Mission_SetAttr('%s_visible'%(a),0)
	js.Event_RegisterSink(js.EVENT_TIMER, 'Freeroam_ArrowCheck', '', '', 1, 0, 0)

def FreeRoam_HeroDistance(object):
	distance = 100000
	for hero in getAllHeroes():
		if ffx.FFX_HasPortrait(hero):
			newdist = m25distance.GetDistance(hero, object)
			if newdist < distance: distance = newdist
	return distance	
	
def Freeroam_AddArrow(a):
	arrows = m25getset.GetMissionVar('_freeroam_arrows',default=[])
	arrows.append(a)
	m25getset.SetMissionVar('_freeroam_arrows',arrows)

def Freeroam_RemoveArrow(a):
	arrows = m25getset.GetMissionVar('_freeroam_arrows',default=[])
	arrows.remove(a)
	m25getset.SetMissionVar('_freeroam_arrows',arrows)	
	
def FreeRoam_ShowArrows(target=None, char=None):
	m25getset.SetMissionVar('_freeroam_arrows_showall', 1)
	hero = ff.theHero()
	js.Mission_CustomAction('Hide Exits', hero, hero, 'FreeRoam_HideArrows', 5, 1)

def FreeRoam_HideArrows(target=None, char=None):
	m25getset.SetMissionVar('_freeroam_arrows_showall', 0)
	hero = ff.theHero()
	js.Mission_CustomAction('Show Exits', hero, hero, 'FreeRoam_ShowArrows', 5, 1)

#called from the default lose cutscene
def heroesDead():
	m25event.Event_TriggerEvent('freeroam_heroesdead', m25event.UserEvent('freeroam_heroesdead'))
	FreeRoam_PrestigeBonus(-1000)
	#m25freeroamdata.SetFreeRoamBaseEntry(None)
	FreeRoam_NextLevel(m25getset.GetMissionVar('freeroam_startingmap'),0)
	Mission_Lose()
	
def theHero():
    for hero in getAllHeroes():
    	#return hero
        if FFX_HasPortrait(hero):
        	return hero
        #    if FFX_ObjectGetAttr(hero,'originalIndex')==69:
        #        return hero
    return ''
    	

#loads the next level into the next mission folder ready for play
def FreeRoam_NextLevel(levelName, nolose=0):
    print levelName
    #copy the appropriate mission folder into the next slot
    
	#m25 changed to use stumpy's modpath function so it is directory independent
    modpath = datfiles.GetModPath()
    target = os.path.join(os.path.dirname(datfiles.GetMissionDatFile()),'mission.dat')
    target2 = os.path.join(os.path.dirname(datfiles.GetMissionDatFile()),'mission.mg')
    source = os.path.join(modpath,'missions',levelName,'mission.dat')
    source2 = os.path.join(modpath,'missions',levelName,'mission.mg')
    
    try:
        copyfile(source,target)
        print 'mission.dat copied (%s -> %s)'%(source,target)
    except:
    	print 'unable to copy mission.dat!!!!'

    try:
        copyfile(source2, target2)
    except:
        print 'unable to copy mission.mg'

    target = os.path.join(os.path.dirname(datfiles.GetMissionDatFile()),'base.dat')
    try:
        copyfile(source,target)
        print 'mission.dat copied (%s -> %s)'%(source,target)
    except:
        pass

    #write out freeroam_level.py so the game knows what level we're on
    levelfile=open(os.path.join(modpath,'missions','scripts','freeroam_level.py'),'w')
    levelfile.write("currentLevel='%s'\n"%(levelName))
    levelfile.close()
    m25freeroamdata.SetFreeRoamLevel(levelName)
    
    #write out the bonus file and the characters health etc
    FreeRoam_WriteBonusFile()

    #write out campaign variables
    FreeRoam_WriteCampaignData()
    
    #write out dictionary - done inside of WriteCampaignData now
    #m25getset.WriteVarDictionary()
    
    #end this level
    if nolose==0:
        play(exit_cs)

#write out bonus values
def FreeRoam_WriteBonusFile():
    bonusfile=open(os.path.join(datfiles.GetModPath(),'missions','scripts','freeroam_bonus.py'),'w')
    bonusfile.write('prestigeBonus=%d\n'%(Mission_GetAttr('prestigeBonus')))
    bonusfile.write('xpBonus=%d\n'%(Mission_GetAttr('xpBonus')))
    #write out the state of the current hero
    bonusfile.write('\nheroStates=[\n')
    list=[]
#     if not Marker_Exists('base_map'):
#         if ff.theHero()!='':
#             list.append(ff.theHero())
#         for inst in getAllHeroes():
#             if FFX_HasPortrait(inst) and inst!=ff.theHero() and Object_IsAlive(inst):
#                 list.append(inst)
#         for inst in list:
#             hp=Object_GetAttr(inst,'health')
#             mhp=Object_GetAttr(inst,'maxHealth')
#             ep=Object_GetAttr(inst,'energyPoints')
#             rp=Object_GetAttr(inst,'heroPoints')
#             line="['%s',%d,%d,%d,%d],\n"%(Object_GetTemplate(inst),hp,mhp,ep,rp)
#             bonusfile.write(line)
    bonusfile.write(']\n')
    hero=ff.theHero()

    #write out any pending encounters
    bonusfile.write('\nencounters=[\n')
    #print 'saving encounters'
    #print 'hero=%s'%(hero)
#     if hero!='' and Mission_GetAttr('customEncounters')==0 and Object_Exists('i_am_a_base')==0:
#         for o in Mission_GetDynamicObjects():
#             if Object_GetClass(o)&OC_CHARACTER and Object_IsAlive(o):
#                 #print '%s:%d'%(o,FFX_ObjectGetAttr(o,'encounter'))
#                 if FFX_ObjectGetAttr(o,'encounter')!=0:
#                     dist=distanceSq(o,hero)
#                     #print dist
#                     if dist<250000:
#                         hp=Object_GetAttr(o,'health')
#                         ep=Object_GetAttr(o,'energyPoints')
#                         dist=sqrt(dist)/(1+Object_GetAttr(o,'speed'))
#                         line="['%s',%d,%d,%d,%d],\n"%(FFX_GetTemplate(o),hp,ep,FFX_ObjectGetAttr(o,'encounter'),dist)
#                         bonusfile.write(line)
    bonusfile.write(']\n')

    #write out weapon data
    OnSheatheWeapon(hero,hero)
    if Object_Exists('i_am_a_base'):
        bonusfile.write('\nshots=[-1,-1,-1,-1]\n')
    else:
        bonusfile.write('\nshots=[%d,%d,%d,%d]\n'%(FFX_ObjectGetAttr(hero,'shots0'),FFX_ObjectGetAttr(hero,'shots1'),FFX_ObjectGetAttr(hero,'shots2'),FFX_ObjectGetAttr(hero,'shots3')))

    bonusfile.close()

#return to the base screen, where you can train and re-enter the same level next time
def FreeRoam_ReturnToBase():
    FreeRoam_AddBonuses()
    Mission_Lose()

#award bonus xp and/or prestige for completed objectives
def FreeRoam_PrestigeBonus(amount):
    oldtotal=Mission_GetAttr('prestigeTotal')
    total=oldtotal+amount
    Mission_SetAttr('prestigeTotal',total)
    FreeRoam_Print('added %d:total=%d'%(amount,total))
    prestige=Mission_GetAttr('prestigeBonus')+amount
    Mission_SetAttr('prestigeBonus',prestige)
    if amount>0:
        Mission_StatusText('%d prestige bonus: total=%d'%(amount,total))
    else:
        Mission_StatusText('%d spent: total=%d'%(-amount,prestige))

def FreeRoam_XPBonus(amount):
    xp=Mission_GetAttr('xpBonus')+amount
    Mission_SetAttr('xpBonus',xp)
    Mission_StatusText('%d xp bonus: total=%d'%(amount,xp))

#schedule this weapon to get available for recruiting next time you're at the arm's dealers
def FreeRoam_AddWeapon(name):
    Mission_SetAttr('%s_add'%(name),1)

#add accumulated XP/Prestige to your character
def FreeRoam_AddBonuses():
	for hero in m25freeroamally.FreeroamAlly_GetFreeRoamHeroList():
		print 'Adding bonus to %s'%hero
		ff.Campaign_AddCP(hero, Mission_GetAttr('xpBonus'))
	ff.Campaign_AddPrestige(Mission_GetAttr('prestigeBonus'))

# def FreeRoam_AddBonuses():
#     #print 'FreeRoam_AddBonuses'
#     try:
#         #print Mission_GetAttr('xpBonus')
#         #for hero in Mission_GetSquadList():
#         for hero in m25freeroamally.FreeroamAlly_GetFreeRoamHeroList():
#         	print 'Adding bonus to %s'%hero
#             ff.Campaign_AddCP(hero,Mission_GetAttr('xpBonus'))
#         #for set in m25freeroam_campaign.campHeroes:
#         #    hero=set[0]
#             #print hero
#         #    if Mission_TestAttr(hero):
#         #        if Mission_GetAttr(hero):
#                     #print '%s is recruited'%(hero)
#         #            ff.Campaign_AddCP(hero,Mission_GetAttr('xpBonus'))
#         Campaign_AddPrestige(Mission_GetAttr('prestigeBonus'))
#     except:
#         pass

def FreeRoam_InitMission():
    Global_RegisterAttr('enhsenfx',-1)
    Global_RegisterAttr('enhsenfx2',-1)
    Mission_SetAttr('customlight',0)
    Mission_SetAttr('customEncounters',0)
    #FreeRoam_LoadCampaignData()
    
    fn='init_%s'%(freeroam_level.currentLevel)
    if hasattr(m25freeroam_campaign,fn):
        exec('m25freeroam_campaign.%s()'%(fn))
        
        
    FFX_ObjectSetAttr('hero_1','originalIndex',69)
    m25ai.SetTeam('hero_1',1)
    #print 'FreeRoam_InitMission:'
    Mission_SetAttr('prestigeBonus',freeroam_bonus.prestigeBonus)
    #Mission_SetAttr('prestigeTotal', freeroam_bonus.prestigeBonus)
    Mission_SetAttr('xpBonus',freeroam_bonus.xpBonus)
    exit = m25freeroamdata.GetFreeRoamExit()
    try:
        exitPoint='from_%s'%(exit)
        if not Marker_Exists(exitPoint): exitPoint = 'to_%s'%(exit)
        if Marker_Exists(exitPoint): 
            pos_array = [[0,0],[-20, 20],[-20, -20], [0,-20]]
            num = 0
            if not js.Marker_Exists('__freestart'):
                exitpos = js.Get_MarkerPos(exitPoint)
                js.Marker_Spawn('__freestart', exitpos)
            for h in ffx.GetAllHeroes():
                js.Marker_SetPos('__freestart', (exitpos[0]+pos_array[num][0], exitpos[1]+pos_array[num][1], exitpos[2]))
                js.Object_MoveToMarker(h, '__freestart')
                num = num + 1
        else: print 'Freeroam_InitMission markers from_%s or to_%s not found.'%(`exit`,`exit`)
#         if exitPoint=='i_am_a_base':
#             exitPoint='base_entry'
#        if exitPoint!='':
#            FFX_Teleport('hero_1',Get_MarkerPos(exitPoint))
    except:
        pass
    if len(freeroam_bonus.heroStates)>0:
        set=freeroam_bonus.heroStates[0]
        temp=set[0]
        name='hero_1'
        if temp!=Object_GetTemplate('hero_1'):
            name=getFormName()
            morph(name,'hero_1',temp)
        RegTimer('FreeRoam_SetupHero',0.5,0,name)
    #do other heroes
#     for set in freeroam_bonus.heroStates[1:]:
#         pos=Get_MarkerPos(exitPoint)
#         spos=(pos[0]+randint(-50,50),pos[1]+randint(-50,50),pos[2])
#         name=getFormName()
#         FreeRoam_Spawn(name,set[0],spos,1)
#         Object_SetAttr(name,'health',set[1])
#         Object_SetAttr(name,'maxHealth',set[2])
#         Object_SetAttr(name,'energyPoints',set[3])
#         Object_SetAttr(name,'heroPoints',set[4])
#         m25ai.SetTeam(name,1)
    FreeRoam_InitDoors()
    FreeRoam_InitEncounters()
    cshelper.look(ff.theHero())
    cshelper.noLook()
    #m25cutscene.PlayCutscene(["CS_Camera('%s')"%(ff.theHero())])
#     if not isPlaying():
#         if Mission_GetAttr('intro')==0:
#             play(intro_cs)
#             Mission_SetAttr('intro',1)
#         else:
#             play(entry_cs)
    FreeRoam_InitDayLight()
    #set up team up commands
    RegTimer('FreeRoam_InitTeamUp',1)
    
    #trigger the initmission event
    m25event.Event_TriggerEvent('freeroam_initmission', m25event.UserEvent('freeroam_initmission',freeroam_level.currentLevel))
    
    #set up civilians as a 0 team
    for o in Mission_GetDynamicObjects():
        if Object_GetClass(o)&OC_CIVILIAN:
            m25ai.SetTeam(o,0)            
            
    #slot=FreeRoam_SetupWeaponData()
    #print slot

#     if slot>1:
#         h=ff.theHero()
#         FreeRoam_InitWeapons(h)

    #FreeRoam_UpdateArcs()
    #m25 turned off the above so that only story files would be used

def FreeRoam_InitWeapons(h):
    if freeroam_bonus.shots[0]>=0:
        FFX_ObjectSetAttr(h,'shots0',freeroam_bonus.shots[0])
    else:
        FFX_ObjectSetAttr(h,'shots0',5)
    FFX_ObjectSetAttr(Object_GetTemplate(h),'weaponbearer',1)
    initweaponbearer(h)
    FFX_ObjectSetAttr(h,'weapons',1)
    if freeroam_bonus.shots[1]>=0:
        FFX_ObjectSetAttr(h,'shots1',freeroam_bonus.shots[1])
    if freeroam_bonus.shots[1]==0:
        cmd=getByTemplate(h,FFX_WEAPONMASTER_CUSTOM,1)
        Mission_RemoveCustomAction(cmd,h,h)
    if freeroam_bonus.shots[2]>=0:
        FFX_ObjectSetAttr(h,'shots2',freeroam_bonus.shots[2])
    if freeroam_bonus.shots[2]==0:
        cmd=getByTemplate(h,FFX_WEAPONMASTER_CUSTOM,3)
        Mission_RemoveCustomAction(cmd,h,h)
    if freeroam_bonus.shots[3]>=0:
        FFX_ObjectSetAttr(h,'shots3',freeroam_bonus.shots[3])
    if freeroam_bonus.shots[3]==0:
        cmd=getByTemplate(h,FFX_WEAPONMASTER_CUSTOM,5)
        Mission_RemoveCustomAction(cmd,h,h)

def FreeRoam_SetupWeaponData():
    #set up weaponmaster data
    slot=1
    for w in m25freeroam_campaign.campWeapons:
        if Mission_GetAttr(w) and slot<6:
            #print 'adding %s'%(w)
            ffx.FFX_WEAPONMASTER_CUSTOM[0][slot]='CUSTOM_DRAW%s'%(w[4:])
            ffx.FFX_WEAPONMASTER_CUSTOM[0][slot+1]=w
            slot=slot+2
    return slot

def FreeRoam_SetupHero(event):
    name=event.object
    set=freeroam_bonus.heroStates[0]
    Object_SetAttr(name,'health',set[1])
    Object_SetAttr(name,'maxHealth',set[2])
    Object_SetAttr(name,'energyPoints',set[3])
    Object_SetAttr(name,'heroPoints',set[4])

def FreeRoam_PreCreateBase():
    #print 'FreeRoam_PreCreateBase'
    #print 'bonus=%d:%d'%(freeroam_bonus.prestigeBonus,freeroam_bonus.xpBonus)
    #FreeRoam_LoadCampaignData()

    if randint(1,100)<25:
        FreeRoam_Jailbreak()

    #add weapons that are waiting to be added
#     if Object_Exists('arms_dealer'):
#         #print 'checking for new weapons'
#         for v in m25freeroam_campaign.campWeapons:
#             val=0
#             vadd='%s_add'%(v)
#             vchar='%s_char'%(v)
#             try:
#                 #print vadd
#                 val=Mission_GetAttr(vadd)
#             except:
#                 pass
#             #print val
#             if val:
#                 #print 'adding %s_char'%(v)
#                 Campaign_AddHero('%s_char'%(v))
#                 Mission_SetAttr(vadd,0)
#             #if you're equipped with any weapons, buy them back now to allow for a different choice
#             if Campaign_IsRecruited(vchar):
#                 name=getDummyName()
#                 spawn(name,vchar,(6000,6000,0))
#                 payback=Object_CalcPrestige(name)
#                 FreeRoam_Print('%s:payback=%d'%(vchar,payback))
#                 addAttr('prestigeTotal',payback)
#                 Campaign_AddPrestige(payback)
#                 Campaign_UnRecruit(vchar)
#                 Campaign_AddHero(vchar)
#                 Mission_SetAttr(v,0)

    Mission_SetAttr('prestigeBonus',freeroam_bonus.prestigeBonus)
    Mission_SetAttr('xpBonus',freeroam_bonus.xpBonus)
    Mission_SetAttr('startingPrestige',Mission_GetAttr('prestigeBonus'))
    FreeRoam_AddBonuses()
    freeroam_bonus.prestigeBonus=0
    freeroam_bonus.xpBonus=0
    Mission_SetAttr('prestigeBonus',0)
    Mission_SetAttr('xpBonus',0)

def FreeRoam_InitBase():
    #print 'FreeRoam_InitBase'
    Mission_SetAttr('customlight',0)
    FreeRoam_PreCreateBase()
    Camera_UnFade(2)
    FreeRoam_InitDayLight()
    
    #trigger the init base event    
    m25event.Event_TriggerEvent('freeroam_initbase', m25event.UserEvent('freeroam_initbase',freeroam_level.currentLevel))
    
#     fn='init_%s'%(freeroam_level.currentLevel)
#     if hasattr(m25freeroam_campaign,fn):
#         exec('m25freeroam_campaign.%s()'%(fn))
    FreeRoam_WriteBonusFile()

def FreeRoam_ExitBase():
    if Object_Exists('arms_dealer'):
        #print 'arms dealer exiting'
        prestige=Mission_GetAttr('startingPrestige')
        for weapon in m25freeroam_campaign.campWeapons:
            #if we've 'recruited' this weapon
            char='%s_char'%(weapon)
            #print 'weapon=%s char=%s'%(weapon,char)
            #print 'missionVar=%d recruited=%d'%(Mission_GetAttr(weapon),Campaign_IsRecruited(char))
            if Mission_GetAttr(weapon)==0 and Campaign_IsRecruited(char):
                name=getDummyName()
                spawn(name,char,(6000,6000,0))
                cost=Object_CalcPrestige(name)
                prestige=prestige-cost
                FreeRoam_Print('new recruit(%s): cost=%d total=%d'%(char,cost,prestige))
                Mission_SetAttr('prestigeTotal',Mission_GetAttr('prestigeTotal')-cost)
            if Mission_GetAttr(weapon)==1 and Campaign_IsRecruited(char)==0:
                name=getDummyName()
                spawn(name,char,(6000,6000,0))
                cost=Object_CalcPrestige(name)
                prestige=prestige+cost
                FreeRoam_Print('disposal(%s): cost=%d total=%d'%(char,cost,prestige))
                Mission_SetAttr('prestigeTotal',Mission_GetAttr('prestigeTotal')+cost)
            #print 'prestige total=%d'%(prestige)
            Mission_SetAttr(weapon,Campaign_IsRecruited(char))

            

#m25 update to use markers instead of objects and tables
def FreeRoam_InitDoors():
	#m25event.Event_TriggerEvent('freeroam_preinitdoors', m25event.UserEvent('freeroam_preinitdoors',m25freeroamdata.GetFreeRoamLevel()))
	allexits = m25getset.GetMissionVar('freeroam_exit_status', default={})
	map_name = FreeRoam_GetMapName()
	allmarkers = datfiles.Mission_GetStartingPositionals()
	for m in allmarkers:
		if m[:3] == 'to_':
			exit_name = m[3:]
			if Freeroam_Exit_GetStatus(map_name, exit_name, allexits) == 'active':
				if not m25event.Event_TriggerFirst('freeroam_activateexit', m25event.UserEvent('freeroam_activateexit',exit_name,map_name)):
					Freeroam_Exit_MakeExit(exit_name)
					Freeroam_Exit_SetStatus(allexits, map_name, exit_name, 'active')
				else:
					Freeroam_Exit_SetStatus(allexits, map_name, exit_name, 'inactive')			
			#spawn(exit_name,'ffx_tiggot',m)
			#Mission_CustomAction(m,'',exit_name,'FreeRoam_OnExit',5,0)
			#Freeroam_AddArrow(exit_name)
			#addArrow('arrow_'+exit_name,exit_name,1)
	m25getset.SetMissionVar('freeroam_exit_status', allexits, campaign=1)
	FreeRoam_HideArrows()
	#m25event.Event_TriggerEvent('freeroam_postinitdoors', m25event.UserEvent('freeroam_postinitdoors',m25freeroamdata.GetFreeRoamLevel()))
	js.Event_RegisterSink(js.EVENT_TIMER, 'Freeroam_ArrowCheck', '', '', 1, 0, 0)

###########
# 1. get markers
# 2. find stored variable for each marker (create one if it doesn't exist)
# 3. generate made inactive or made active events
###########	

def Freeroam_Exit_GetStatus(map_name, exit_name, allexits):
	if allexits.has_key(map_name):
		if allexits[map_name].has_key(exit_name):
			return allexits[map_name][exit_name]['status']
	return 'active' #default value

def FreeRoam_ActivateExit(exit_name, map_name=None):
	allexits = m25getset.GetMissionVar('freeroam_exit_status', default={})
	if not m25event.Event_TriggerFirst('freeroam_activateexit', m25event.UserEvent('freeroam_activateexit',exit_name,map_name)):
		if FreeRoam_GetMapName() == map_name:
			Freeroam_Exit_MakeExit(exit_name)
		Freeroam_Exit_SetStatus(allexits, map_name, exit_name, 'active')
		m25getset.SetMissionVar('freeroam_exit_status', allexits, campaign=1)
		return 1
	return 0

def FreeRoam_DeactivateExit(exit_name, map_name=None):
	allexits = m25getset.GetMissionVar('freeroam_exit_status', default={})
	if not m25event.Event_TriggerFirst('freeroam_deactivateexit', m25event.UserEvent('freeroam_deactivateexit',exit_name,map_name)):
		if FreeRoam_GetMapName() == map_name:
			Freeroam_Exit_RemoveExit(exit_name)
		Freeroam_Exit_SetStatus(allexits, map_name, exit_name, 'inactive')
		m25getset.SetMissionVar('freeroam_exit_status', allexits, campaign=1)
		return 1
	return 0	
	
def Freeroam_Exit_MakeExit(exit_name):
	spawn(exit_name, 'ffx_tiggot','to_%s'%exit_name)
	Mission_CustomAction('to_%s'%exit_name,'',exit_name,'FreeRoam_OnExit',5,0)
	Freeroam_AddArrow(exit_name)	
	
def Freeroam_Exit_RemoveExit(exit_name):
	print 'removing exit %s'%exit_name
	js.Object_Destroy(exit_name)
	#spawn(exit_name, 'ffx_tiggot','to_%s'%exit_name)
	#Mission_CustomAction('to_%s'%exit_name,'',exit_name,'FreeRoam_OnExit',5,0)
	Freeroam_RemoveArrow(exit_name)	
	
def Freeroam_Exit_SetStatus(allexits, map_name, exit_name, status):
	if allexits.has_key(map_name):
		if allexits[map_name].has_key(exit_name):
			allexits[map_name][exit_name]['status'] = status
		else:
			allexits[map_name][exit_name] = {'status':status, 'tags':{}}
	else:
		allexits[map_name] = {exit_name:{'status':status, 'tags':{}}}


	
#standard door initialisation for each mission
# def FreeRoam_InitDoors():
#     tag=0
#     for pair in m25freeroam_campaign.doorways:
#         #check the condition in the doorway list
#         open=0
#         exec('open=%s'%(pair[2]))
#         if open:
#             Mission_CustomAction('CUSTOM_EXIT','',pair[0],'FreeRoam_OnExit',5,0)
#             for o in Mission_GetObjects():
#                 if Object_GetTemplate(o)==pair[0]:
#                     name='xt%d'%(tag)
#                     tag=tag+1
#                     addArrow(name,o,pair[3])

# #activates a specific set of doors on this level
# def FreeRoam_InitDoorType(name):
#     Mission_CustomAction('CUSTOM_EXIT','',name,'FreeRoam_OnExit',5,0)
#     for o in Mission_GetObjects():
#         if Object_GetTemplate(o)==name:
#             addArrow('a%s'%(o),o,js.ARROW_RED)

def FreeRoam_GetDoorNameAndExtension(name):
	num = 0
	for n in name:
		if n == '-':
			return [name[:num],name[num:]]
		num = num + 1
	return [name,'']

def FreeRoam_GetMapName():
	markers = Mission_GetStartingPositionals()
	for m in markers:
		if m[:8] == 'mapname_': return m[8:]
	return ''
	
def FreeRoam_OnExitBase():
	allmarkers = Mission_GetStartingPositionals()
	nextlevel, extension = '', ''
	mapname = FreeRoam_GetMapName()
	#entry = m25freeroamdata.GetFreeRoamBaseEntry()
	#if entry and (entry != mapname):
	#	nextlevel, extension = FreeRoam_GetDoorNameAndExtension(entry)
    #else:
	for m in allmarkers:
		print m
		if m[:3] == 'to_': 
			nextlevel, extension = FreeRoam_GetDoorNameAndExtension(m[3:])
	#print nextlevel, mapname
	m25event.Event_TriggerEvent('freeroam_exitbase', m25event.UserEvent('freeroam_exitbase',m25freeroamdata.GetFreeRoamLevel(), nextlevel))
	FreeRoam_WriteExitFile(mapname+extension)
	FreeRoam_NextLevel(nextlevel,1)
	#print 'finished on exit base'
	
def FreeRoam_OnExit(target,char):
	#possessed characters cannot exit the current map as the bookkeeping is too tricky
	if Object_Exists(char) and Object_GetSecondaryStates(char)&SCSTATE_POSSESSED: return
	nextlevel, extension = FreeRoam_GetDoorNameAndExtension(target)
	currentlevel = m25freeroamdata.GetFreeRoamLevel()
	m25event.Event_TriggerEvent('freeroam_exitmission', m25event.UserEvent('freeroam_exitmission',currentlevel, nextlevel))
	FreeRoam_WriteExitFile(FreeRoam_GetMapName()+extension)
	FreeRoam_NextLevel(nextlevel,0)
	
#m25: I'm not sure if this is supposed to be here, but it is included just in case
def FreeRoam_WriteExitFile(exit):
	print 'Writing EXIT file'
	modpath = datfiles.GetModPath()
	bonusfile=open(os.path.join(modpath,'missions','scripts','freeroam_exit.py'),'w')
	bonusfile.write("exitPoint='%s'\n"%(exit))
	bonusfile.close()
	m25freeroamdata.SetFreeRoamExit(exit)

# def FreeRoam_OnExit(target,char):
#     #possessed characters cant pass between levels - too tricky
#     if Object_Exists(char):
#         if Object_GetSecondaryStates(char)&SCSTATE_POSSESSED:
#             return
#     #if m25freeroam_campaign.overrideDoor(target):
#     #    return
#     temp=Object_GetTemplate(target)
#     nextlevel=''
#     for pair in m25freeroam_campaign.doorways:
#         if temp==pair[0]:
#             nextlevel=pair[1]
#     if nextlevel!='':
#         nolose=0
#         #char=='' if we're triggered from a base level, so dont call Mission_Lose()
#         if char=='':
#             nolose=1
#         #print nextlevel
#         FreeRoam_NextLevel(nextlevel,nolose)
#     modpath = datfiles.GetModPath()
#     bonusfile=open(os.path.join(modpath,'missions','scripts','freeroam_exit.py'),'w')
#     bonusfile.write("exitPoint='%s'\n"%(target))
#     bonusfile.close()

def FreeRoam_GetCampVariables():
    list=m25freeroam_campaign.campVariables
    for set in freeroam_customs.customVillains:
        list.append('%s_lockup'%(set[0]))
    for set in m25freeroam_campaign.campHeroes:
        list.append(set[0])
    for i in range(0,len(m25freeroam_campaign.arcs)):
        list.append('arc%d'%(i+1))
    return list

def FreeRoam_Jailbreak():
    for set in freeroam_customs.customVillains:
        Mission_SetAttr('%s_lockup'%(set[0]),0)

def FreeRoam_LoadCampaignData():
    #print 'FreeRoam_LoadCampaignData()'
    for v in FreeRoam_GetCampVariables():
        val=0
        try:
            #print 'val=freeroam_campdata.%s'%(v)
            exec('val=freeroam_campdata.%s'%(v))
        except:
            #print 'passing'
            pass
        Mission_SetAttr(v,val)
        Mission_SetAttr('start%s'%(v),val)

    for v in m25freeroam_campaign.campWeapons:
        val=Campaign_IsRecruited('%s_char'%(v))
        Mission_SetAttr(v,val)
        val=0
        try:
            #print 'val=freeroam_campdata.%s_add'%(v)
            exec('val=freeroam_campdata.%s_add'%(v))
        except:
            #print 'passing'
            pass
        Mission_SetAttr('%s_add'%(v),val)
        Mission_SetAttr('start%s_add'%(v),val)

    if hasattr(m25freeroam_campaign,'OnCampVarsLoaded'):
        exec('m25freeroam_campaign.OnCampVarsLoaded()')

def FreeRoam_WriteCampaignData(startingVals=0):
    #print 'FreeRoam_WriteCampaignData()'
    modpath = datfiles.GetModPath()
    file=open(os.path.join(modpath,'missions','scripts','freeroam_campdata.py'),'w')
    for v in FreeRoam_GetCampVariables():
        val=0
        try:
            if startingVals==0:
                val=Mission_GetAttr(v)
            else:
                val=Mission_GetAttr('start%s'%(v))
        except:
            #print 'passing...'
            pass
        file.write("%s=%d\n"%(v,val))
    for v in m25freeroam_campaign.campWeapons:
        val=0
        try:
            #print v
            val=Mission_GetAttr(v)
            #print val
        except:
            #print 'passing...'
            pass
        val=0
        try:
            vadd='%s_add'%(v)
            if startingVals:
                vadd='start%s_add'%(v)
            val=Mission_GetAttr(vadd)
        except:
            #print 'passing...'
            pass
        vadd='%s_add'%(v)
        file.write("%s=%d\n"%(vadd,val))
    file.close()
    
    m25freeroamally.StoreFreeroamAllies()
    m25enc.Enc_StoreEncounters()
    m25getset.WriteVarDictionary(startingVals)
    print 'done writing var dictionary'

    if startingVals==0:
        return

    #extra stuff for save games reloaded - write out freeroam_bonus and freeroam_exit
    #target=Mission_GetVar('start_exitpoint')
    bonusfile=open(os.path.join(modpath,'missions','scripts','freeroam_exit.py'),'w')
    bonusfile.write("exitPoint='%s'\n"%(target))

    bonusfile=open(os.path.join(modpath,'missions','scripts','freeroam_bonus.py'),'w')
    bonusfile.write('prestigeBonus=%d\n\n'%(Mission_GetVar('start_prestigeBonus')))
    bonusfile.write('xpBonus=%d\n\n'%(Mission_GetVar('start_xpBonus')))

    list=Mission_GetVar('start_herostates')
    bonusfile.write('heroStates='+`list`+'\n\n')
    #list=Mission_GetVar('start_encounters')
    #bonusfile.write('encounters='+`list`+'\n\n')
    #list=Mission_GetVar('start_shots')
    #bonusfile.write('shots='+`list`+'\n\n')
    bonusfile.close()

exit_cs=[
(
    "Camera_Fade(1)",
	"wait(1)",
),
(
    "Mission_Lose()",
)
]

entry_cs=[
(
    "Camera_Fade(0)",
	"look('hero_1',-200,0)",
	"wait(1)",
),
(
    "Camera_UnFade(1)",
	"Camera_LookAtObject('hero_1',0,0,0,1,1,0)",
	"wait(1.1)",
),
(
    "noLook()",
),
]

intro_cs=[
(
    "Camera_Fade(0)",
	"look('hero_1',-200,0)",
	"wait(1)",
),
(
    "Camera_UnFade(1)",
	"Camera_LookAtObject('hero_1',0,0,0,1,1,0)",
	"speak('narrator','MISSPCH_1_AA_03')",
),
(
    "noLook()",
),
]


levels=[
0.2,  0.2,  0.2,  0.2,  0.25, 0.5,
0.6,  0.7,  0.8,  0.9,  1.0,  1.0,
1.0,  1.0,  0.9,  0.8,  0.7,  0.6,
0.5,  0.25, 0.2,  0.2,  0.2,  0.2
]

angles1=[
30,30,40,50,60,70,
75,80,85,90,90,90,
90,90,90,95,100,105,
110,120,130,140,150,160
]

angles2=[
90,90,90,90,90,20,
25,40,50,60,65,70,
70,65,60,50,40,25,
20,90,90,90,90,90
]

def FreeRoam_InitDayLight():
    Mission_SetAttr('lightsOn',isNight())
    if Mission_GetAttr('customlight')==0:
        if isNight():
            FreeRoam_LightsOn()
        else:
            FreeRoam_LightsOff()
    RegTimer('FreeRoam_DayLight',0.1)

def FreeRoam_DayLight(event):
    timer=10
    inc=10
    if Marker_Exists('base_map'):
    #if Object_Exists('i_am_a_base'):
        timer=1
        inc=100
    RegTimer('FreeRoam_DayLight',timer)
    Mission_SetAttr('lightStep',0.1)
    t0=int(Mission_GetAttr('timeofday'))+inc
    if t0>=2400:
        t0=0
    Mission_SetAttr('timeofday',t0)
    if Mission_GetAttr('customlight'):
        return
    t=int(t0/100)
    alpha=(t0-t*100)*0.01
    tp1=t+1
    if tp1==24:
        tp1=0
    beta=1.0-alpha
    lvl=levels[t]*beta+levels[tp1]*alpha
    delta=0
    r=1
    g=1
    b=1
    if lvl<0.25:
        r=0.6
        g=0.6
        b=0.8
    elif lvl<0.7:
        delta=(0.7-lvl)/0.45
        r=0.8-delta*0.2
        g=0.6
        b=0.5+delta*0.3
    else:
        delta=(0.8-lvl)*10
        if delta<0:
            delta=0
        r=0.8
        g=0.8-delta*0.2
        b=0.8-delta*0.3
    a1=35+angles1[t]*beta+angles1[tp1]*alpha
    a2=angles2[t]*beta+angles2[tp1]*alpha
    FFX_Sun(a1,a2,lvl,lvl,(r,g,b),1)
    Mission_SetShadows(a1,a2,(0.2,0.2,0.4))
    #do the streetlights
    if isNight() and Mission_GetAttr('lightsOn')==0:
        Mission_SetAttr('lightsOn',1)
        FreeRoam_LightsOn()
    elif isNight()==0 and Mission_GetAttr('lightsOn')!=0:
        Mission_SetAttr('lightsOn',0)
        FreeRoam_LightsOff()

def FreeRoam_LightsOn():
    try: FreeRoam_Lights(1)
    except: pass

def FreeRoam_LightsOff():
    try: FreeRoam_Lights(0)
    except: pass

def FreeRoam_Lights(index):
    pairs=(('pat_streetlight','pat_streetlight_night'),('pat_park_lamp','pat_park_lamp_night'),('pat_hotdog_stand','pat_hotdog_stand_night'),('pat_phonebooth','pat_phonebooth_night'))
    for o in Mission_GetObjects():
        if Object_GetAttr(o,'health')==Object_GetAttr(o,'maxHealth'):
            t=Object_GetTemplate(o)
            for pair in pairs:
                if t==pair[0] or t==pair[1]:
                    name='o%s'%(o)
                    #print 'lighting ' + name
                    if o[0]=='o':
                        name=o[1:]                        
                    spawn(name,pair[index],o)
                    alignWith(name,o)
                    Object_Destroy(o)

######################################################################
#
# Encounter code - generates random encounters in the city or wherever
#
######################################################################

def FreeRoam_InitEncounters():
    newIndex=1
    #continue any pending encounters from last map
    index=0
    for set in freeroam_bonus.encounters:
        RegTimer('FreeRoam_ContinueEncounter',set[4]*0.1,index)
        index=index+1
        encIndex=set[3]
        if newIndex<=encIndex:
            newIndex=encIndex+1
        num=FFX_ObjectGetAttr('encounter','num%d'%(encIndex),0)
        FFX_ObjectSetAttr('encounter','num%d'%(encIndex),num+1)
        
#     if Mission_GetAttr('customEncounters')==0:
#         RegTimer('FreeRoam_GenerateEncounter',randint(5,10))
#         RegTimer('FreeRoam_GenerateEncounter',randint(30,60))
#         
#     see()
    
    Mission_SetAttr('encounterIndex',newIndex)
    Mission_SetAttr('startEncIndex',newIndex)

def FreeRoam_GetEncounterLevel():
    value=0
    mult=1
    for hero in getAllHeroes():
        v=Object_CalcPrestige(hero)
        value=value+v*mult
        mult=mult*0.5
    return value*2

dTooCloseToHero=200
dTooFarFromHeroes=2000
dTooCloseToCamera=300

def TestMarkers():
    list=FreeRoam_GetMarkerList()
    #print list
    for o in list:
        name=getDummyName()
        spawn(name,'portal_start_proxy',o)
        Object_PlayEffect(name,'effect_portal_core','destroyTemp')
        addArrow('a%s'%(name),name,delete=1)

def FreeRoam_GetMarkerList():
    i=1
    marker='encounter%i'%(i)
    list=[]
    #make a list of hero positions
    hpos=[]
    for o in Mission_GetDynamicObjects():
        if FFX_HasPortrait(o):
            hpos.append(Get_ObjectPos(o))
    cpos=Camera_GetLookAtInfo()
    while Marker_Exists(marker):
        reject=0
        pos=Get_MarkerPos(marker)
        minDist=0
        for hp in hpos:
            dx=hp[0]-pos[0]
            dy=hp[1]-pos[1]
            d=sqrt(dx*dx+dy*dy)
            if d<dTooCloseToHero:
                reject=1
                #print 'marker %s too close'%(marker)
            if minDist==0 or minDist>d:
                minDist=d
        if minDist>dTooFarFromHeroes:
            reject=1
            #print 'marker %s too far from all heroes'%(marker)
        dx=cpos[0]-pos[0]
        dy=cpos[1]-pos[1]
        if sqrt(dx*dx+dy*dy)<dTooCloseToCamera:
            reject=1
            #print 'marker %s too close to camera'%(marker)
        if reject==0:
            list.append(marker)
        i=i+1
        marker='encounter%i'%(i)
    return list

def FreeRoam_GetEncounterMarker():
    markers=FreeRoam_GetMarkerList()
    n=len(markers)
    index=int(randint(1,n*100)/100)
    if index>=n:
        index=n-1
    return markers[index]

def FreeRoam_GenerateEncounter(event):
    #dont spawn new encounters in cutscenes
    if isPlaying():
        regTimer('FreeRoam_GenerateEncounter',10)
        return
    if Mission_GetAttr('intro2')==0:
        Mission_SetAttr('intro2',1)
        speak('narrator','MISSPCH_1_AA_04')
    level=FreeRoam_GetEncounterLevel()
    #print 'GENERATING ENCOUNTER: level=%d'%(level)
    list=[]
    for set in freeroam_native.encounterlist:
        list.append(set)
    #add in custom encounters
    for set in freeroam_customs.customVillains:
        if len(set)>0:
            #make sure the character isnt already there!
            if len(getAll(set[0]))==0:
                list.append(set)
    encounterset=list[0]
    sets=[]
    for set in list:
        cost=set[1]
        condition=set[-1]
        valid=1
        try:
            exec('valid=(%s)'%(condition))
        except:
            pass
        if Template_Exists(set[0])==0:
            if len(getAll(set[0]))>0:
                valid=0
        else:
            str=Template_GetClassString(set[0])
            #for heroes and villains, there can only be one at a time!
            if str=='GAME_OBJ_VILLAIN' or str=='GAME_OBJ_HERO':
                if len(getAll(set[0]))>0:
                    valid=0
        if valid and cost<level:
            sets.append(set)
            #print set
    numsets=len(sets)
    if numsets==1:
        encounterset=sets[0]
    elif numsets>1:
        index=int(randint(1,numsets*100)/100)
        if index>=numsets:
            index=numsets-1
        encounterset=sets[index]

    #print encounterset
    #encounterset now contains the kind of villains we'll be spawning
    villain=encounterset[0]
    vcost=encounterset[1]
    minions=[]
    mcosts=[]
    ind=2
    if len(encounterset)>ind+1:
        #print encounterset
        #print 'ind=%d'%(ind)
        #print encounterset[ind]
        minions.append(encounterset[ind])
        mcosts.append(encounterset[ind+1])
    else:
        try:
            if Template_GetClassString(villain)=='GAME_OBJ_MINION':
                minions.append(villain)
                mcosts.append(vcost)
        except:
            pass
    #print villain
    #print vcost
    #print minions
    #print mcosts

    #get the random markers
    markers=FreeRoam_GetMarkerList()
    n=len(markers)
    index=int(randint(1,n*100)/100)
    if index>=n:
        index=n-1
    centre=Get_MarkerPos(markers[index])

    #start spawning around the marker
    totalcost=0
    temp=villain
    unitcost=vcost
    squad=[]
    numMin=len(mcosts)
    fin=0
    leader=''
    #limit number of characters per encounter
    maxtotal=randint(2,5)
    total=0

    while (fin==0 and totalcost<level*randint(1,3)):
        total=total+1
        if total>maxtotal:
            fin=1
        name=getDummyName()
        if leader=='':
            leader=name
        #print temp
        FreeRoam_Spawn(name,temp,(centre[0]+randint(-50,50),centre[1]+randint(-50,50),centre[2]))
        squad.append(name)
        addGoalToAI(name,ai.goal.Wander(),-1)
        totalcost=totalcost+unitcost
        if numMin==0:
           fin=1
        else:
            ind=randint(0,100*numMin)
            if ind>=numMin:
                ind=numMin-1
            unitcost=mcosts[ind]
            temp=minions[ind]
    if ff.APP_DEBUGMODE:
        Mission_CustomAction('KILL GROUP','',leader,'OnKillGroup',50,0)
    bonus=10*int(totalcost/100)
    encIndex=Mission_GetAttr('encounterIndex')
    Mission_SetAttr('encounterIndex',encIndex+1)
    FFX_ObjectSetAttr('encounter','bonus%d'%(encIndex),bonus)
    FFX_ObjectSetAttr('encounter','num%d'%(encIndex),len(squad))

    grp='group%d'%(encIndex)
    for unit in squad:
        FFX_ObjectSetAttr(unit,'encounter',encIndex)
        regDeath(unit,'FreeRoam_OnKO',encIndex)
        AddToGroup(grp,unit)
    Group_SetLeader(grp,squad[0])
    GroupCommand_HuntEnemies(grp)

    #arrow the leader briefly
    arr='arr%s'%(leader)
    addArrow(arr,leader)
    RegTimer('FreeRoam_RemoveArrow',3,0,arr)

    #see if we have a campaign callback function
    fn='%s_start'%(villain)
    if hasattr(m25freeroam_campaign,fn):
        exec('m25freeroam_campaign.%s(leader)'%(fn))

    #print 'ENCOUNTER ENDED!'

def OnKillGroup(target,char):
    index=FFX_ObjectGetAttr(target,'encounter')
    for o in Mission_GetDynamicObjects():
        if FFX_ObjectGetAttr(o,'encounter')==index:
            Trigger_Damage(o,200)

def FreeRoam_RemoveArrow(event):
    Mission_RemoveArrow(event.object)

def FreeRoam_ContinueEncounter(event):
    if Mission_GetAttr('customEncounters'):
        return
    index=int(event.user)
    set=freeroam_bonus.encounters[index]
    name=getDummyName()
    temp=set[0]
    pos=Get_ObjectPos(freeroam_exit.exitPoint)
    pos2=(pos[0]+randint(-50,50),pos[1]+randint(-50,50),pos[2])
    FreeRoam_Spawn(name,temp,pos2)

    #call the callback function for this character to initialise them
    fn='%s_start'%(temp)
    if hasattr(m25freeroam_campaign,fn):
        exec('m25freeroam_campaign.%s(name)'%(fn))

    Object_SetAttr(name,'health',set[1])
    Object_SetAttr(name,'energyPoints',set[2])
    encIndex=set[3]
    ubonus=Object_CalcPrestige(name)
    ubonus=10*int(ubonus/100)
    bonus=FFX_ObjectGetAttr('encounter','bonus%d'%(encIndex),0)
    FFX_ObjectSetAttr('encounter','bonus%d'%(encIndex),bonus+ubonus)
    FFX_ObjectSetAttr(name,'encounter',encIndex)
    regDeath(name,'FreeRoam_OnKO',encIndex)

def FreeRoam_Spawn(name,template,pos,portrait=0):
    #print '%s,%s,(%d,%d)'%(name,template,pos[0],pos[1])
    cshelper.spawn(name,template,pos)
    if Object_GetClass(name)&FFX_CHARACTER:
        aname='a%s'%(name)
        cshelper.spawn(aname,'ffx_tiggot',(-6000,-6000,0))
        AI_Animate(aname,template)
        Object_Destroy(aname)
        FFX_AdjustPortrait(name,portrait)
        SetupOneChar(name)
        SetBrawler(name)
        if portrait:
            m25ai.SetTeam(name,1)
            AIDisableCustom(name)
            SetBrawler(name,0)
        else:
            m25ai.SetTeam(name,2)
        #no prestige bonus for just KO-ing guys as normal
        Object_SetAttr(name,'prestige',0)
        Object_SetAttr(name,'noFade',0)

def FreeRoam_OnKO(event):
    obj=event.object
    print '%s KOd!'%(obj)
    index=FFX_ObjectGetAttr(obj,'encounter')
    num=FFX_ObjectGetAttr('encounter','num%d'%(index))-1
    FFX_ObjectSetAttr('encounter','num%d'%(index),num)
    Mission_SetAttr('%s_lockup'%(Object_GetTemplate(obj)),1)

    #try an end cutscene for this character
    try:
        exec('m25freeroam_campaign.%s_end(obj,num)'%(Object_GetTemplate(obj)))
    except:
        pass

    if num==0:
        bonus=FFX_ObjectGetAttr('encounter','bonus%d'%(index))
        FreeRoam_XPBonus(bonus/100)
        FreeRoam_PrestigeBonus(bonus/10)
        if index>=Mission_GetAttr('startEncIndex'):
            RegTimer('FreeRoam_GenerateEncounter',randint(10,20))

#functions for defining when a villain can appear
def isCity():
    return freeroam_level.currentLevel[:4]=='city'

def isBerlin():
	return 1    
    
def isSewers():
    return freeroam_level.currentLevel[:6]=='sewers'

def isLevel(name):
    return freeroam_level.currentLevel==name

def isNight():
    t=Mission_GetAttr('timeofday')
    return t<600 or t>1800

def isDay():
    t=Mission_GetAttr('timeofday')
    return t>600 and t<1800

def isOutOfJail(template):
    return Mission_GetAttr('%s_lockup'%(template))==0

######################################################################
#
# Custom Encounter code - for special persistent maps
#
######################################################################

def FreeRoam_CustomEncounter(template,markerbase,max):
    down=0
    print 'FreeRoam_Encounter:%s'%(template)
    try:
        var='%s%s'%(freeroam_level.currentLevel,template)
        print var
        down=Mission_GetAttr(var)
    except:
        pass
    if down>0:
        down=down-1
    print down
    num=max-down
    for i in range(1,num+1):
        name='%s%i'%(template,i)
        spawn(name,template,'%s%i'%(markerbase,i))
        m25ai.SetTeam(name,2)
        SetBrawler(name,1)
        RegDeath(name,'FreeRoam_CustomDie')

def FreeRoam_CustomDie(event):
    print 'FreeRoam_CustomDie'
    name=event.object
    var='%s%s'%(freeroam_level.currentLevel,Object_GetTemplate(name))
    try:
        val=Mission_GetAttr(var)+1
        Mission_SetAttr(var,val)
    except:
        pass
    list=[]
    for o in Mission_GetDynamicObjects():
        if Object_GetClass(o)&OC_CHARACTER and o!=name:
            if GetTeam(o)==2 and Object_IsAlive(o):
                list.append(o)
    print list
    if len(list)==0:
        fn='m25freeroam_campaign.end_%s()'%(freeroam_level.currentLevel)
        print 'executing %s'%(fn)
        exec(fn)
    elif len(list)<5:
        addArrow('ce%s'%(list[0]),list[0],delete=1)

######################################################################
#
# Team up code - generates random encounters in the city or wherever
#
######################################################################

def FreeRoam_InitTeamUp(event):
	#continue timer in case the hero switches to an alternate form
	RegTimer('FreeRoam_InitTeamUp',5)
	hero = theHero()
	#check to see if main hero is ko'd
	if Object_IsAlive(hero) == 0 and Object_GetAttr(hero,'heroPoints')==0:
		for h in getAllHeroes():
			kill(h)
			Object_SetAttr(h,'heroPoints',0)
		return
	#is this necessary?
	#m25ai.SetTeam(hero,1)
	#make sure we haven't already set this up
	if FFX_ObjectGetAttr(hero,'teamup')==0:
		print 'FreeRoam_InitTeamUp starting'
		FFX_ObjectSetAttr(hero,'teamup',1)
		print Mission_GetAttr('prestigeTotal'), FFX_ObjectGetAttr(hero,'teamupcmd')
		if Mission_GetAttr('prestigeTotal')>=0 and FFX_ObjectGetAttr(hero,'teamupcmd')==0:
			print 'FreeRoam_InitTeamUp starting passed check'
			FFX_ObjectSetAttr(hero,'teamupcmd',1)
			if not FreeRoam_TeamFull():
				print 'FreeRoam_InitTeamUp no buddy yet.'
				num = 1
				for b in FreeRoam_GetBuddyIndex():
					if num <= 5:
						Mission_CustomAction('TEAMUP:'+b,hero,hero,'FreeRoam_TeamTemp'+`num`,5,0)
						num = num + 1
	
def FreeRoam_GetCustomName(template):
	mapping = {}
	mapping = m25freeroamdata.GetFreeRoamTemplateMap()
	if mapping.has_key(template):
		return mapping[template]
	else:
		#spawn the character, get a proper name for it, then destroy it
		spawn('_templatetest',template,(1000,1000,1000))
		truename = m25template.GetComplexTemplate('_templatetest')
		mapping[template] = truename
		m25freeroamdata.SetFreeRoamTemplateMap(mapping)
		js.Object_Destroy('_templatetest')
		return truename

def FreeRoam_HaveBuddy():
	hero = theHero()
	for h in getAllHeroes():
		if FFX_HasPortrait(h) and h != hero:
			print 'FreeRoam_HaveBuddy - buddy found'
			return 1
	return 0						

def FreeRoam_TeamFull():
	num = 0
	for h in getAllHeroes():
		if FFX_HasPortrait(h): num = num + 1
	if num >= 4: return 1
	return 0	
	
def FreeRoam_HeroExists(char):
	trueform = char
	for row in FFX_SHAPESHIFT_CUSTOM:
		if char in row:
			trueform = row[0]
	for h in ffx.GetAllHeroes():
		if trueform == h: return 1
		if trueform == js.Object_GetTemplate(h): return 1
		if trueform == m25template.GetComplexTemplate(h): return 1
	return 0	
	
def FreeRoam_GetCustomBuddies():
	#hero = theHero()
	hero_list = []
	for index in range(20,1000):
		template='custom_template_%d'%(index)
		if (js.Campaign_IsRecruited(template)!=0) and (not FreeRoam_HeroExists(template)):
			hero_list.append(FreeRoam_GetCustomName(template))
	print 'Freeroam_GetCustomBuddies: ' + `hero_list`
	return hero_list	
	
def FreeRoam_MakeBuddyIndex():
	buddyindex = []
	builtins = datfiles.Campaign_ReadCharacters()
	#herotemplate = js.Object_GetTemplate(theHero())
	for c in builtins.keys(): #m25freeroam_campaign.campHeroes:
		if (not FreeRoam_HeroExists(c)) and Campaign_IsRecruited(c):
			buddyindex.append(c)
	hero_list = FreeRoam_GetCustomBuddies()
	for h in hero_list:
		buddyindex.append(h)
	m25getset.SetMissionVar('buddy_index',buddyindex)
	print 'BuddyIndex ' + `buddyindex`
	return buddyindex

def FreeRoam_GetBuddyIndex():
	buddyindex = m25getset.GetMissionVar('buddy_index',default=None)
	if buddyindex == None:
		return FreeRoam_MakeBuddyIndex()
	return buddyindex	

def FreeRoam_TeamTemp1(char,temp):
	FreeRoam_DoTeamUp(1)
		
def FreeRoam_TeamTemp2(char,temp):
	FreeRoam_DoTeamUp(2)
	
def FreeRoam_TeamTemp3(char,temp):
	FreeRoam_DoTeamUp(3)		

def FreeRoam_TeamTemp4(char,temp):
	FreeRoam_DoTeamUp(4)
	
def FreeRoam_TeamTemp5(char,temp):
	FreeRoam_DoTeamUp(5)		
				
def FreeRoam_DoTeamUp(index):
	hero = theHero()
	print 'doteamup',index
	buddyindex = FreeRoam_GetBuddyIndex()
	print buddyindex[index-1]
	print buddyindex
	if len(buddyindex)>=index-1:
		buddytemplate = m25freeroamdata.GetFreeRoamTemplateSavedName(buddyindex[index-1])
		if not FreeRoam_HeroExists(buddytemplate):
			name = getFormName()
			pos = Get_ObjectPos(hero)
			spawn(name,buddytemplate,(pos[0]+randint(-50,50),pos[1]+randint(-50,50),pos[2]))
			#FreeRoam_PrestigeBonus(-1000)
		#remove all old team up commands
		#num = 0
		Mission_RemoveCustomAction('TEAMUP:'+buddytemplate, hero, hero)
		if FreeRoam_TeamFull():
			for b in buddyindex:
			#for i in range(1,5):
				#if len(buddyindex)>=i-1:
				try:
					Mission_RemoveCustomAction('TEAMUP:'+b,hero,hero)
				except:
					pass
				#Mission_RemoveCustomAction('TEAMUP:'+buddyindex[i-1],hero,hero)

		
	
# #commands for adding teamups and other custom commands to our hero
# def FreeRoam_InitTeamUpold(event):
#     #try again soon for shapeshifters etc
#     RegTimer('FreeRoam_InitTeamUp',5)
#     #print 'FreeRoam_InitTeamUp'

#     hero=ff.theHero()

#     #check if the hero is irrevocably KO'd - if so, force a mission lose
#     if Object_IsAlive(hero)==0 and Object_GetAttr(hero,'heroPoints')==0:
#         #print 'hero is dead'
#         for h in getAllHeroes():
#              kill(h)
#              Object_SetAttr(h,'heroPoints',0)
#         return
#     #print 'hero is dead'

#     if FFX_ObjectGetAttr(hero,'teamup')==0:
#         FFX_ObjectSetAttr(hero,'teamup',1)
#         #campaign specific stuff
#         #exec('m25freeroam_campaign.initthehero(hero)')
#         #buddy teamups
#         if Mission_GetAttr('prestigeTotal')>=2000 and FFX_ObjectGetAttr(hero,'teamupcmd')==0:
#             FFX_ObjectSetAttr(hero,'teamupcmd',1)
#             #abort if we already have a buddy
#             buddy=0
#             for h in getAllHeroes():
#                 if FFX_HasPortrait(h) and h!=hero:
#                     print 'buddy exists:%s'%(h)
#                     buddy=1
#             if buddy==0:
#                 for set in m25freeroam_campaign.campHeroes:
#                     pal=set[0]
#                     print pal
#                     if Campaign_IsRecruited(pal):
#                         fn='teamup_%s'%(pal)
#                         cmd=set[1]
#                         Mission_CustomAction(cmd,hero,hero,fn,5,0)

#     #nasty hack for now
#     m25ai.SetTeam(hero,1)

# def FreeRoam_OnTeamUp(char,pal):
#     pos=Get_ObjectPos(char)
#     if len(getAll(pal))>0:
#         name=getAll(pal)[0]
#     else:
#         name=getFormName()
#         spawn(name,pal,(pos[0]+randint(-50,50),pos[1]+randint(-50,50),pos[2]))
#     tag='%s_01'%(pal)
#     if randint(1,100)<50:
#         tag='%s_02'%(pal)
#     speak(name,tag)
#     m25ai.SetTeam(name,1)
#     hero=ff.theHero()
#     FreeRoam_PrestigeBonus(-2000)
#     for set in m25freeroam_campaign.campHeroes:
#         cmd=set[1]
#         Mission_RemoveCustomAction(cmd,hero,hero)

def FreeRoam_SetArcState(index,state):
    var='arc%i'%(index)
    oldstate=Mission_GetAttr(var)
    #only update if we're advancing the arc here
    if oldstate<state:
        Mission_SetAttr(var,state)
        FreeRoam_UpdateArcs()

def FreeRoam_UpdateArcs():
    arcindex=0
    for arc in m25freeroam_campaign.arcs:
        arcindex=arcindex+1
        state=int(Mission_GetAttr('arc%i'%(arcindex))-1)
        if state>=0 and state<len(arc):
            objname='arc_%i_%i'%(arcindex,state)
            if Objective_Exists(objname)==0:
                nextobj=FFX_ObjectGetAttr('obj','count',0)+1
                FFX_ObjectSetAttr('obj','count',nextobj)
                Objective_Add(objname,arc[state],nextobj>6,0)
        for i in range(0,state):
            objname='arc_%i_%i'%(arcindex,i)
            if Objective_Exists(objname):
                Objective_Complete(objname)

def FreeRoam_Print(var):
    file=open('campaignlog.txt','a')
    str=''+`var`+'\n'
    file.write(str)
    file.close()
   