from cshelper import *
from js import *
import event
import m25freeroam
from ffx import *


######################################################################
#
# freeroam_campaign.py
#  by Dr Mike v1.0 04/07/05
# modified to use ez script by M25
# NOTE: Most of this is no longer used, but exists to prevent the freeroam experience from crashing
# while I continue to convert it over to EZ script.
#
#  this is where campaign-specific data lives, describing the layout of your map,
#   cutscenes, stuff like that
#
######################################################################

#first entry is the object template that takes you to this map
#second entry is the name of the map
#third entry is the condition that must be evaluated for the entry to activate
#fourth entry is the colour of the arrow to use

doorways=[
['ffx_cityblock1','cityblock1','1',js.ARROW_YELLOW],
['ffx_cityblock2','cityblock2','1',js.ARROW_YELLOW],
['ffx_cityblock3','cityblock3','1',js.ARROW_YELLOW],
['ffx_cityblock4','cityblock4','1',js.ARROW_YELLOW],
['ffx_cityblock5','cityblock5',"1",js.ARROW_YELLOW],
['ffx_apartment','apartment','1',js.ARROW_YELLOW],
['ffx_apartment2','apartment2',"1",js.ARROW_YELLOW],
['ffx_sewers','sewers',"1",js.ARROW_YELLOW],
['ffx_sewers2','sewers2',"1",js.ARROW_YELLOW],
['ffx_tophat','tophat',"1",js.ARROW_YELLOW],
['ffx_fortress','fortress',"1",js.ARROW_YELLOW],
['ffx_mechbase','',"1",js.ARROW_YELLOW],
]

#the names of the campaign variables that are stored in your savegames and transmitted between levels when you
#go between maps etc

campVariables=[
'prestigeTotal', #this one must be in the list - its tracks the total value of prestige stored in game memory
'intro', #mandatory - has the intro c/s played yet?
'intro2', #mandatory - has the second intro text played yet?
'timeofday', #mandatory - used by day and night system
]

#weapons that can be bought from the arms dealer
campWeapons=[
'ffx_handgun',
'ffx_grenade',
'ffx_zapgun',
'ffx_lure',
'ffx_scanner',
'ffx_jetpack',
'ffx_fawkes',
]

#recruitable heroes who can team up with your custom hero
campHeroes=[
['blackbird','TEAMUP:BLACKBIRD',],
['bullet','TEAMUP:BULLET',],
['microwave','TEAMUP:MICROWAVE',],
['the_bard','TEAMUP:THEBARD',],
['quetzalcoatl','TEAMUP:QUETZLCOATL',],
]

def teamup_bullet(target,char):
    name=getFormName()
    pos=Get_ObjectPos(char)
    spawn(name,'bullet',(pos[0]+200,pos[1]+200,pos[2]))
    RegTimer('bulletrun',5,0,name,char)
    freeroam.FreeRoam_OnTeamUp(char,'bullet')

def bulletrun(event):
    name=event.object
    char=event.string
    Trigger_Power(name,char,'ffx_sprint','')

def teamup_blackbird(target,char):
    b=getNearestBuilding(ff.theHero())
    if b!='':
        spawn(getFormName(),'blackbird',Get_ObjectPos(b))
    freeroam.FreeRoam_OnTeamUp(char,'blackbird')

def teamup_quetzalcoatl(target,char):
    freeroam.FreeRoam_OnTeamUp(char,'quetzalcoatl')
    Mission_SetSunlight(90,90,2,2,(1,1,1))

def teamup_the_bard(target,char):
    b=getNearestBuilding(ff.theHero())
    if b!='':
        spawn(getFormName(),'the_bard',Get_ObjectPos(b))
    freeroam.FreeRoam_OnTeamUp(char,'the_bard')

def teamup_microwave(target,char):
    freeroam.FreeRoam_OnTeamUp(char,'microwave')
    m=getAll('microwave')[0]
    Object_PlayEffect(m,'effect_microwave_teleport_in')

def getNearestBuilding(char):
    minDist=3000*3000
    target=''
    pos=Get_ObjectPos(char)
    for o in Mission_GetObjects():
        if Object_GetClass(o)&OC_BUILDING:
            bp=Get_ObjectPos(o)
            dx=pos[0]-bp[0]
            dy=pos[1]-bp[1]
            d2=dx*dx+dy*dy
            if d2<minDist:
                minDist=d2
                target=o
    return target


#story arcs - used to generate objectives
ARC_CRIME=1
ARC_MECHS=2
ARC_SHADOW=3
ARC_DEJAVU=4
ARC_QUETZ=5

arcs=[
#organised crime arc
(
"keep the streets safe from organised crime",
"interrogate the gangster",
"find more gangsters to interrogate",
"confront and defeat pin stripe and his goons",
),
#blackjack and the robots
(
"defeat the mech-men and talk to your mysterious ally",
"keep defeating mechs as you find them, and report back to jack",
"confront mr. mechanical in his lair (talk to jack to get the location)",
"defeat mr. mechanical!",
),
#ants, shadow etc
(
"follow the ants down into the sewers",
"defeat the darkmen who live in the sewers",
"defeat and interrogate the bard",
"follow the bard into shadow's inner sanctum",
"defeat shadow and all her minions",
),
#deja vu and clones etc
(
"defeat and interrogate microwave",
"go to the freedom fortress to investigate",
"defeat and interrogate bullet and find the keys to the freedom fortress",
"enter the freedom fortress",
"defeat deja vu and his minions and destroy the cloning machine",
),
#quetz clone
(
"defeat any raptors or legionnaires you find near the museum",
"defeat the quetzalcoatl clone",
),
]

def updateArc(index,state):
    freeroam.FreeRoam_SetArcState(index,state)

#special overrides for junction behaviour - sometimes a junction doesn't lead to another map
def overrideDoor(target):
    t=Object_GetTemplate(target)
    if t=='ffx_mechbase':
        play(mrmech_cs)
        return 1
    if t=='ffx_fortress' and Mission_GetAttr('bulletexplode')==0:
        forceSpeak('microwave','MISSPCH_1_MW_04')
        return 1
    return 0

