#m25freeroamally
#print "Loading m25freeroamally.py v.3.2.0 final; branch = m25 branch 1"
import types
import m25getset
import js
import m25spawn
import m25ai
import m25enc
from m25enc import *
import ffx
import m25gametype
from ffxcustom import *
from ffxcustom2 import *
import m25name

import m25freeroamdata

def AddFreeroamAlly(char):
	allyvar = m25getset.GetMissionVar('freeroam_tempallies',default=[])
	allyvar.append(char)
	m25getset.SetMissionVar('freeroam_tempallies',allyvar)
	
def RemoveFreeroamAlly(char):
	allyvar = m25getset.GetMissionVar('freeroam_tempallies',default=[])
	if char in allyvar: allyvar.remove(char)
	#allyvar.append(char)
	m25getset.SetMissionVar('freeroam_tempallies',allyvar)	
	
def GetFreeroamAllies():
	return m25getset.GetMissionVar('freeroam_tempallies',default=[])	
	
def StoreFreeroamAllies():
	if Marker_Exists('base_map'): return
	allyvar = m25getset.GetMissionVar('freeroam_tempallies',default=[])
	aliveallies = []
	for a in allyvar:
		if js.Object_Exists(a) and js.Object_IsAlive(a):
			aliveallies.append([js.Object_GetTemplate(a),js.Object_GetAttr(a,'health'), js.Object_GetAttr(a,'maxHealth'), js.Object_GetAttr(a,'energyPoints'), js.Object_GetAttr(a,'heroPoints'), m25getset.GetObjectVar(a,'__enc_group_prefix',default=None), m25getset.GetObjectVar(a,'__enc_class_prefix',default=None), js.Object_GetAttr(a,'_enc_id'), a])
	m25getset.SetMissionVar('freeroam_aliveallies',aliveallies,campaign=1)
	try:
		FreeroamAlly_StoreFreeroamHeroes()
	except:
		pass
	
def LoadFreeroamAllies(hero):
	if Marker_Exists('base_map'): return
	allyvar = m25getset.GetMissionVar('freeroam_aliveallies',default=[])
	updatedallies = []
	num = 4  #leave 3 spots open for heroes
	for a in allyvar:
		char = m25spawn.SpawnChar(name=a[8], template=a[0], location=FreeRoamAlly_FindSpawnLocation(hero,num), objclass='ally')
		num = num + 1
		js.Object_SetAttr(char, 'health', a[1])
		js.Object_SetAttr(char, 'maxHealth', a[2])
		js.Object_SetAttr(char, 'energyPoints', a[3])
		js.Object_SetAttr(char, 'heroPoints', a[4])
		m25getset.SetObjectVar(char, '__enc_group_prefix', a[5])
		m25getset.SetObjectVar(char, '__enc_class_prefix', a[6])
		js.Object_SetAttr(char, '_enc_id', a[7])
		m25ai.AddGoal_MoveToHero(char)
		#this is a kludge so that the ko of a buddy will still potentially affect the alliance encounter
		js.Event_RegisterSink(EVENT_OBJ_HEALTHCHANGED, 'EncMinionKO', char, '', 0, int(a[7]), 0)
		m25enc.Enc_SetEncounterIndependent(char)
		m25enc.Enc_SetDoNotStart(char)
		updatedallies.append(char)
	m25getset.SetMissionVar('freeroam_aliveallies',[])
	m25getset.SetMissionVar('freeroam_tempallies', updatedallies)
	FreeroamAlly_LoadFreeroamHeroes(hero)

def FreeRoamAlly_FindSpawnLocation(hero, num):
	grid = [
			[0,0], [0,-30], [20,-30], [-20,-30], 
			[0,-10], [20,-10], [-20,-10],
			[40,-30], [-40,-30], [40, -10], [-40, -10],
			[0, 10], [20, 10], [-20, 10], [40, 10], [-40, 10],
			[0, 30], [20, 30], [-20, 30], [40, 30], [-40, 30],
			[0, 50], [20, 50], [-20, 50], [40, 50], [-40, 50]
		]
	loc = js.Get_ObjectPos(hero)
	return (loc[0]+grid[num][0], loc[1]+grid[num][1], loc[2])
	
def FreeroamAlly_StoreFreeroamHeroes():
	if Marker_Exists('base_map'): 
		m25getset.SetMissionVar('freeroam_aliveheroes',[],campaign=1)
		return
	heroes = ffx.GetAllHeroes()
	aliveheroes = []
	for a in heroes:
		#if a != ff.theHero() and (js.Object_GetTemplate(a) != js.Object_GetTemplate(ff.theHero())):
		print 'storing %s'%(a)
		template = FreeroamAlly_FindTrueForm(a)
		aliveheroes.append([template,js.Object_GetAttr(a,'health'), js.Object_GetAttr(a,'maxHealth'), js.Object_GetAttr(a,'energyPoints'), js.Object_GetAttr(a,'heroPoints')])
	m25getset.SetMissionVar('freeroam_aliveheroes',aliveheroes,campaign=1)
	
def FreeroamAlly_LoadFreeroamHeroes(hero):
	if Marker_Exists('base_map'): return
	allyvar = m25getset.GetMissionVar('freeroam_aliveheroes',default=[])
	updatedallies = []
	num = 0
	for a in allyvar:
		needmorph = 0
		char, template = None, None
		if type(a[0]) == types.ListType:
			needmorph = 1
			char = FreeroamAlly_FindTemplate(a[0][0])
			template = a[0][0]
		else:
			char = FreeroamAlly_FindTemplate(a[0])
			template = a[0]
		if not char:
		#if a != ff.theHero() and (a != js.Object_GetTemplate(ff.theHero())):
			try:
				char = m25spawn.SpawnChar(template=template, location=FreeRoamAlly_FindSpawnLocation(ff.theHero(),num), objclass='hero')
			except:
				print 'SPAWN ERROR %s'%(template)
				continue
		num = num + 1
		js.Object_SetAttr(char, 'health', a[1])
		js.Object_SetAttr(char, 'maxHealth', a[2])
		js.Object_SetAttr(char, 'energyPoints', a[3])
		js.Object_SetAttr(char, 'heroPoints', a[4])
		if type(a[0]) == types.ListType:
			js.Mission_SetAttr('shapeReady',1)
			ffx.initAttribsForChar(char)  #force the initialization of the shapeshifter grid?
			ffx.morph(m25name.GetNextObjectName(), char, a[0][1])

def FreeroamAlly_GetFreeRoamHeroList():
	aliveheroes = m25getset.GetMissionVar('freeroam_aliveheroes',default=[])
	herolist = []
	for a in aliveheroes:
		if type(a[0]) == types.ListType:
			herolist.append(a[0][0])
		else:
			herolist.append(a[0])
	return herolist
					
def FreeroamAlly_ClearFreeroamHeroes():
	m25getset.SetMissionVar('freeroam_aliveheroes', [])

def FreeroamAlly_FindTrueForm(char):
	if ffx.hasAttribute(char,'tempform') or ffx.hasAttribute(char,'involuntaryform'):
		row=int(ffx.FFX_ObjectGetAttr(char,'shapeRow'))
		template=m25freeroamdata.GetFreeRoamTemplateSavedName(FFX_SHAPESHIFT_CUSTOM[row][0])
		if ffx.hasAttribute(char, 'tempform'):
			return [template, js.Object_GetTemplate(char)]
		else:
			return template
	else:
		return js.Object_GetTemplate(char)
	
def FreeroamAlly_HeroExists(char):
	#print 'FreeroamAlly_HeroExits testing %s'%char
	for h in ffx.GetAllHeroes():
		#print '--%s %s'%(h, js.Object_GetTemplate(h))
		if char == h: return 1
		if char == js.Object_GetTemplate(h): return 1
		if char == m25template.GetComplexTemplate(h): return 1
	return 0

def FreeroamAlly_FindTemplate(char):
	for h in ffx.GetAllHeroes():
		if char == h: return h
		if char == js.Object_GetTemplate(h): return h
		if char == m25template.GetComplexTemplate(h): return h
	return None