#####################################################################################
#
# Module: m25gametype
# Author: m25
# 
# Description: functions that detect what type of game is being played
#  skirmish, campaign, freeroam, or base screen
#
# Version 3.053
#
#
#####################################################################################

#print "Loading m25gametype.py v.3.2.0 final; branch = m25 branch 1"

import ff
import string
import m25freeroamdata

from js import *

def GameType_IsCampaign():
	return 'OnGameTypeCheck' not in dir(ff)

def GameType_IsBase():
	return GameType_InBase()	
	
def GameType_InBase():
	try:
		if Mission_GetAttr('gametype_inbase'): return 1
	except:
		pass
	if 'OnBriefing' in dir(ff):
		if not 'FreeRoam_InitMission' in dir(ff):
			return 1
	return 0
	
def GameType_IsFreeRoam():
	return GameType_IsFreeroam()
	
def GameType_IsFreeroam():
	try:
		if Mission_GetAttr('gametype_isfreeroam'): return 1
	except:
		return 'FreeRoam_InitMission' in dir(ff)

	
# functions for determining the type of map we are on

def GameType_CheckMap(prefix):
	return string.find(m25freeroamdata.GetFreeRoamLevel(), prefix) != -1

# def GameType_iscity():
# 	return freeroam_level.currentLevel[:4]=='city'

# def GameType_isberlin():
# 	return 1
#     
# def GameType_issewers():
# 	return freeroam_level.currentLevel[:6]=='sewers'

# def GameType_islevel(name):
# 	return freeroam_level.currentLevel==name

def GameType_isnight():
	t=Mission_GetAttr('timeofday')
	return t<600 or t>1800

def GameType_isday():
	t=Mission_GetAttr('timeofday')
	return t>600 and t<1800	

# 	
# def isCity():
# 	return freeroam_level.currentLevel[:4]=='city'

# def isBerlin():
# 	return 1    
#     
# def isSewers():
# 	return freeroam_level.currentLevel[:6]=='sewers'

# def isLevel(name):
# 	return freeroam_level.currentLevel==name

# def isNight():
# 	t=Mission_GetAttr('timeofday')
# 	return t<600 or t>1800

# def isDay():
# 	t=Mission_GetAttr('timeofday')
# 	return t>600 and t<1800

# def isOutOfJail(template):
# 	return Mission_GetAttr('%s_lockup'%(template))==0
	