#####################################################################################
#
# Module: MiniMod base
# Author: m25
# 
# Description: 
#
#
#
#####################################################################################
#print "Loading m25minimod.py v.3.2.0 final; branch = m25 branch 1"

import js
import cshelper
import sk
import ffx
import m25ai
import m25story
import m25enc
import string

import m25event
import m25report
import m25getset
import m25pstory
import m25missionover
import m25cutscene
from m25cutscene import *

from ff import *
#from cshelper import *
#from js import *
#from sk import *
from ffx import *
from m25ai import *
from m25story import *

from m25skirmish import *

#---------------------------------------------------------------------
#
# Debugging
#
#---------------------------------------------------------------------	

#use this to easily show status reports on your mission
# set the second parameter to 1 to see reports in the log file
# set it to 2 to see reports on the screen
# set it to 0 to turn off reporting
m25report.Report_SetChannel('MISSION',1)


#---------------------------------------------------------------------
#
# Important Callbacks
#
#---------------------------------------------------------------------	


# Set up the XP variables so that XP actually works during a campaign!
RPG_XP_PER_LEVEL=10
RPG_CP_PER_LEVEL=10
RPG_XP_PER_MISSION=50
RPG_XP_PER_TRAINING=0

def OnPrecacheObjects():
	global minimod_storyfile
	m25report.Report('MISSION','EZScript MiniMod/Campaign Precache.')
	MiniMod_AddStories(minimod_storyfile)
	m25pstory.Pstory_DoPrecache()
	m25enc.EncCreateAllMarkers()
	
def OnEnemyKilled(event):
    #sk.OnEnemyKilled(event)
    pass

storedtemplates = []
    
def OnReceiveSelectedEnemies(enemies):
	global storedtemplates
	storedtemplates = []
	sk.PreSetup()
	for enemy in enemies:
		if enemy == '---Buddies---':
			m25getset.SetMissionVar('buddies',1)
		elif enemy == '------------':
			if m25getset.GetMissionVar('buddies',default=0):
				m25getset.SetMissionVar('buddies',0)
			else:  #set up a new group
				enemytemplatelist.append([])
		else:
			if m25getset.GetMissionVar('buddies',default=0):
				name = GenerateName(enemy)
				loc = m25GetSpawnLoc(m25ai.TEAM_GOODGUYS)
				Object_SpawnAt(enemy, loc, name)
				SkirmishSetUpEnemy(name)
				SkirmishSetupAI(name, m25ai.TEAM_GOODGUYS)
			else:
				storedtemplates.append(enemy)
	m25getset.SetMissionVar('story_enemytemplates',storedtemplates)
	

def MiniMod_OnGameTypeCheck(markers):
	num = 0
	rm = ('encounter1','skirmishspawn')
	for r in markers:
		if num == 0:
			rm = (r,)
		else:
			rm.append(r)
		num = num + 1
	print 'OnGameTypecheck ' + `rm`
	return rm
    
def OnPostInit(campaign=0, base=0):
	if not campaign:
		js.Camera_UnFade(1)
	else:
		js.Camera_Fade(0)
		m25cutscene.CS_SetUIEnable(0)
		if base: 
			js.UI_Enable(0)  #this is a hack to ensure that the base cutscene will actually play
			js.UI_Base_Enable(0)
		else: js.UI_Enable(0)
	if not m25cutscene.CS_InBase():
		m25report.Report('MISSION','On Post Init... start.')
		cshelper.setMission(1,1,0)  # start cshelper standard functions
		js.Event_RegisterSink(js.EVENT_MISSIONLOST, "MiniMod_HeroKO", '')
		ffx.FFX_InitMission()  # start FFX
		m25ai.InitScripts()  # start the M25AI
		m25ai.SetSkirmishModeOff()
		#SetupExistingAI()
	m25report.Report('MISSION','On Post Init... complete; starting story.')
	if m25story.GetStoryline() == {}:
		m25report.Report('ERROR', 'Story did not load correctly.  Either it does not exist, or there is a problem in the script.')
		MiniMod_AddStories(storyfile)
	m25story.DoStoryline()
	if not m25cutscene.CS_InBase():
		SetupHeroes()
	
def PlayBriefing():
	m25cutscene.CS_SetInBriefing()
	has_briefing = m25story.Story_DoBriefing()
	if not has_briefing:
		js.UI_Briefing_Done()

def PlayIntermission():
	pass
	#m25story.Story_DoIntermission()	
		

	
			
#---------------------------------------------------------------------
#
# Standard Helper Functions
#
#---------------------------------------------------------------------		
	
def SetSun():
	Mission_SetSunlight(-40,30,1.2,1.0,(0.8,0.5,0.2))
	Mission_SetShadows(-40,30,(0.2,0.3,0.3))
	Mission_SetProjShadowBackground((1,1,1))
	Mission_SetProjShadowColor((.8,.7,.7,1))
		
def SetupExistingAI():
	all = Mission_GetDynamicObjects()
	for a in all:
		if Object_GetClass(a) & OC_CONTROLLABLE:
			m25ai.AIDisableCustom(a)
		m25ai.SetupAI(a)
		
def SetupHeroes():
	all = ffx.GetAllHeroes()
	for a in all:
		#if Object_GetClass(a) & OC_CONTROLLABLE:
		m25ai.AIDisableCustom(a)
		cshelper.regDeath(a,'MiniMod_HeroKO')
		m25ai.SetupAI(a)
		m25ai.AddToGroup('team'+`m25ai.TEAM_GOODGUYS`,a)
	m25ai.Group_PromoteLeader('team'+`m25ai.TEAM_GOODGUYS`)


#---------------------------------------------------------------------
#
# Loading and Restoring Stories
#
#---------------------------------------------------------------------		
	
def MiniMod_AddStories(filename):
	storyset = m25pstory.PStory_MakeStoryFromFile(filename)
	for s in storyset: m25story.Storyline_AddStory(s)


#---------------------------------------------------------------------
#
# Custom Functions
#
#---------------------------------------------------------------------		

def AddHealthCannisters(event):
	m25event.SetTimer(30, 'AddHealthCannisters')
	loc = getMarkerListByName('health')
	for c in loc:
		if not Object_Exists(c+'_can'):
			cshelper.spawn(c+'_can', 'powerup_hp',c)
		
		
def MiniMod_HeroKO(event):
	heroes = ffx.GetAllHeroes()
	for hero in heroes:
		if js.Object_GetAttr(hero, 'heroPoints')>0 or js.Object_IsAlive(hero):
			js.Event_RegisterSink(js.EVENT_MISSIONLOST, "MiniMod_HeroKO", '')
			return
	#call second function to give ffx and others a chance to revive special characters
	m25event.SetTimer(5,'MiniMod_HeroKO2')
	
def MiniMod_HeroKO2(event):
	heroes = ffx.GetAllHeroes()
	for hero in heroes:
		if js.Object_GetAttr(hero, 'heroPoints')>0 or js.Object_IsAlive(hero):
			js.Event_RegisterSink(js.EVENT_MISSIONLOST, "MiniMod_HeroKO", '')
			return
	m25missionover.SetMissionOver()
	lookcmd = "Camera_LookAtObject('" + hero + "', -100, 0, 0, 3, CPM_SCROLLTO, CA_MOVE)"
	cshelper.heroes_dead_cs[0][4] = lookcmd
	cshelper.play(cshelper.heroes_dead_cs, "heroes_dead_cs", 1000)
