#####################################################################
#
# Objectives
# 
# Store a list of objectives that will persist throughout a 
# freeroam style campaign (and also work for normal campaigns).
#
# 
# Version 3.054
#
#
#####################################################################

#print "Loading m25objective.py v.3.2.0 final; branch = m25 branch 1"

import js
import m25getset
import m25report

def Objective_GetObjectives():
	return m25getset.GetMissionVar('_objectivelist',default=[])
	
def Objective_SetObjectives(objectives):
	m25getset.SetMissionVar('_objectivelist', objectives, campaign=1)
	
def Objective_GetNextObjectiveNumber():
	curnum = m25getset.GetMissionVar('_objectivenum', default=0)
	curnum = curnum + 1
	m25getset.SetMissionVar('_objectivenum', curnum, campaign=1)
	return curnum	

def Objective_AddObjective(objective='Have fun', prestige=0, objectivetype=1):
	objectivelist = Objective_GetObjectives()
	#check to see if it is already in the list
	for obj in objectivelist:
		if obj[0] == objective: return
	#add and store the new objective
	name = 'objective' + `Objective_GetNextObjectiveNumber()`
	objectivelist.append([objective,prestige,objectivetype,name])
	Objective_SetObjectives(objectivelist)
	js.Objective_Add(name, objective, objectivetype, prestige)
	
def Objective_RemoveObjective(objective='Have fun'):
	objectivelist = Objective_GetObjectives()
	num = 0
	for obj in objectivelist:
		if obj[0] == objective:
			del objectivelist[num]
		num = num + 1
	Objective_SetObjectives(objectivelist)

def Objective_GetName(objective='Have fun'):
	objectives = Objective_GetObjectives()
	name = None
	for obj in objectives:
		if obj[0] == objective:
			name = obj[3]
	return name	
			
def Objective_CompleteObjective(objective='Have fun'):
	name = Objective_GetName(objective)
	if name:
		js.Objective_Complete(name)
		Objective_RemoveObjective(objective)

def Objective_FailObjective(objective='Have fun'):
	name = Objective_GetName(objective)
	if name:
		js.Objective_Fail(name)
		Objective_RemoveObjective(objective)

def Objective_RestoreObjectives():
	objectivelist = Objective_GetObjectives()
	for obj in objectivelist:
		print obj
		if js.Objective_Exists(obj[3]):
			m25report.Report('ERROR', 'objective %s already exists in the objective manager'%(obj[3]))
		try:
			js.Objective_Add(obj[3],obj[0],obj[2],obj[1])
		except:
			print 'Object_RestoreObjectives cannot restore %s'%(`obj`)
		