#####################################################################################
#
# Module: Report
# Author: m25
# 
# Description: send messages to the screen and/or the console
# 	Multiple channels can be set up and where they send their output can be adjusted.
#
# Version 3.052
#
#####################################################################################

#print "Loading m25report.py v.3.2.0 final; branch = m25 branch 1"

#Use:
# Print an error to the screen:
# 	Report_SetChannel('error', REPORT_SCREEN)
# 	Report('An Error occured!', 'error')

# Print an AI status message to the console
# 	Report_SetChannel('ai', REPORT_CONSOLE)
# 	Report(char + '_' + aitactic, 'ai')

import js
import m25config

REPORT_SCREEN = 2
REPORT_CONSOLE = 1
REPORT_NONE = 0

REPORT_TIME = 0
REPORT_ON = m25config.M25_USE_REPORT

def Report_SetChannel(channel, setting):
	if setting >= REPORT_SCREEN:
		js.Mission_SetAttr('report_' + channel, REPORT_SCREEN)
	elif setting == REPORT_CONSOLE:
		js.Mission_SetAttr('report_' + channel, REPORT_CONSOLE)
	else:
		js.Mission_SetAttr('report_' + channel, REPORT_NONE)
		
def Report_ChannelDebugOn(channel):
	try:
		if js.Mission_GetAttr('report_' + channel) == REPORT_SCREEN:
			return 1
	except:
		return 0

def Report_ChannelPrintOn(channel):
	try:
		c = js.Mission_GetAttr('report_' + channel)
		if (c == REPORT_CONSOLE) or (c == REPORT_SCREEN):
			return 1
	except:
		if channel == 'default':
			js.Mission_SetAttr('report_default',REPORT_CONSOLE)
			return 1
		return 0

def Report_TurnOff():
	global REPORT_ON
	REPORT_ON = 0
	
def Report_TurnOn():
	global REPORT_ON
	REPORT_ON = 1		
		
def Report(text1, text2='default'):
	if not REPORT_ON: return
	if text2 == 'default':
		text = text1
		channel = 'default'
	else:
		text = '%s: %s'%(text1,text2)
		#text = text1 + ': ' + text2
		channel = text1
	if Report_ChannelDebugOn(channel):
		js.Mission_StatusText(text)
	if Report_ChannelPrintOn(channel):
		print text

		
def ReportTime(text, value):
	if not (REPORT_ON and REPORT_TIME): return
	if value < 0.001: return
	if value < 0.01: 
		print 'TIME: %f for %s'%(value, text)
		return
	if value < 0.1: 
		print '---- TIME: %f for %s'%(value, text)
		return
	#js.Mission_StatusText('TIME: %f for %s' %(value, text))
	print '####################### TIME: %f for %s'%(value, text)
	return
