#m25spawn

#print "Loading m25spawn.py v.3.2.0 final; branch = m25 branch 1"

import ff
import js
import cshelper
import m25getset
import m25name
import chardata
import m25report

import m25ai   #bad?

def IsControllableHero(char):
    if js.Object_GetClass(char)&js.OC_CONTROLLABLE:
        try:
            if not js.Mission_GetAttr(char+'_fakehero'):
                return 1
        except:
            return 1
    return 0

	
def SpawnChar(name=None, template='thug_with_bat', location=(0,0,0), objclass=None):
	#generate a new name if none is given
	if name == None: name = m25name.GetNextObjectName()	
	#make sure the character doesn't already exist
	if js.Object_Exists(name): return name
	#spawn the character
	try:
		cshelper.spawn(name,template,location)
	except:
		m25report.Report('ERROR', 'ERROR in m25spawn.SpawnChar: could not spawn ' + `name` + ' of type ' + `template` + ' at ' + `location`)
		return	
	#apply the mass fix
	try:
		Spawn_FixMass(name)		
	except:
		pass
	#remove the portrait if we are not spawning a hero
	if objclass != 'hero':
		Spawn_DestroyPortrait(name)
		Spawn_RemoveNaturalGoal(name)
	#set up the m25 ai
	m25ai.SetupAI(name)
	if objclass != 'hero':
		m25ai.SetBrawler(name)
		m25ai.AIEnableCustom(name)
	else:
		m25ai.AIDisableCustom(name)
	if objclass in ['ally','hero']: m25ai.SetTeam(name,1)
	else: m25ai.SetTeam(name,2)
	return name

	
def Spawn_FixMass(name):
	#array used to fix incorrect mass in spawned characters
	massfactors = [1.0,3.0, 2.5, 1.25, 0.75, 1.0, 0, 1.5, 2.5, 1.5, 1.0]
	#modify the energy and mass attributes as they may not spawn correctly
	chdata = chardata.GetCharacterData(name)
	if chdata.has_key('energy'): js.Object_SetAttr(name, 'energy', chdata['energy'])
	if chdata.has_key('material') and chdata.has_key('mass'): 
		js.Object_SetAttr(name, 'mass', chdata['mass']*massfactors[int(chdata['material'])])	
		
def Spawn_DestroyPortrait(name):
	if IsControllableHero(name):
		#destroy the portait so the player can't control the character
		js.AI_DestroyHeroAI(name)
		js.Mission_SetAttr(name+'_fakehero', 1)
		js.AI_MakeHeroAI(name)
		
def Spawn_RemoveNaturalGoal(name):
	#remove the natural tendencies of the character so the m25 ai can take over
	ai = cshelper.findAI(name)
	ai.removeNaturalKillGoal()