#####################################################################################
#
# Module: m25string
# Author: m25
# 
# Description: some simple string manipulation
#
#
# Version 3.052
#
#####################################################################################

#print "Loading m25string.py v.3.2.0 final; branch = m25 branch 1"

import types
import string

seperator = '_'


def GetLeftString(string,sep=seperator,default=''): 
	if not IsString(string):
		return default
	i = 0
	index = 0
	found = 0
	for s in string:
		if s == sep:
			index = i
			found = 1
			break
		i = i + 1
	if not found:
		return string
	else:
		return string[0:index]
		
def GetRightString(string,sep=seperator,default=''):
	if not IsString(string):
		return default
	i = 0
	found = 0
	index = 0
	for s in string:
		if s == sep:
			index = i
			found = 1
			break
		i = i + 1
	if not found:
		return default
	else:
		return string[index+1:]
		
def SplitAroundOr(param,default=''):
    first = GetLeftString(param,' ')
    remainder = GetRightString(param,' ')
    while (remainder != ''):
        cur = GetLeftString(remainder, ' ')
        rest = GetRightString(remainder, ' ')
        remainder = rest
        if cur == 'or':
           return [1,first,remainder]
        else:
           first = first + ' ' + cur
    return [0,param,default]


def SplitAroundAnd(param,default=''):
    first = GetLeftString(param,' ')
    remainder = GetRightString(param,' ')
    while (remainder != ''):
        cur = GetLeftString(remainder, ' ')
        rest = GetRightString(remainder, ' ')
        remainder = rest
        if cur == 'and':
           return [1,first,remainder]
        else:
           first = first + ' ' + cur
    return [0,param,default]    
    
def SplitAroundPhrase(param,phrase,default=''):
	num = 0
	for p in param:
		if string.lower(param[num:num+len(phrase)]) == string.lower(phrase):
			return [1,string.strip(param[0:num]),string.strip(param[num+len(phrase):])]
		num = num + 1
	return [0,param,default]
    
    
def RemoveSpaces(line):
	whitespace = ['\n',' ','\t']
	newline = ''
	for c in line:
		if not (c in whitespace):
			newline = newline + c
	return newline
	
def String_RemoveSpaces(line):
	return RemoveSpaces(line)	
	
def String_ConvertToTemplate(line):
	newline = string.lower(string.strip(line))
	returnline = ''
	for n in range(0,len(newline)):
		if newline[n] in ['\n',' ','\t']:
			returnline = returnline + '_'
		else:
			returnline = returnline + newline[n]
	return returnline

def IsFunction(string):
	if IsString(string):
		if ('(' in string) and (')' in string):
			return 1
	return 0
	
def IsList(string):
	if type(string) is types.ListType:
		return 1
	return 0
	
def IsString(string):
	if type(string) is types.StringType:
		return 1
	return 0

def TransString(string):
	return string
	
def TransList(string):
	depth = 0
	num = 0
	for s in string:
		if s == '[': 
			depth = depth + 1
		elif s == ']': 
			depth = depth - 1
		elif s in [',',')'] and depth == 0: 
			return eval(TransString('%s'%(string[:num])))
		else: pass
		num = num + 1
	return eval(TransString('%s'%(string)))
	
def CommaToList(line):
	templist = string.split(line,',')
	for index in range(0,len(templist)):
		templist[index] = string.strip(templist[index])
	return templist