#####################################################################################
#
# Module: Timestamp
# Author: m25
# 
# Description: Functions for checking timestamps
# 	used in caching frequently used values
#
# Dependencies: m25getset
#
# Version 3.052
#
#####################################################################################

#print "Loading m25timestamp.py v.3.2.0 final; branch = m25 branch 1"

import js
import m25getset

#---------------------------------------
#
# Functions for checking timestamps
# used in caching frequently used values
#
#---------------------------------------

def Timestamp_Setup(time=0):
	js.Mission_SetAttr('m25_timestamp',time)
	js.Event_CancelSinks('Timestamp_Advance')
	js.Event_RegisterSink(js.EVENT_TIMER, 'Timestamp_Advance', '', '', 1, 0, 0)
	
def Timestamp_Advance(event):
	tick = js.Mission_GetAttr('m25_timestamp')
	js.Mission_SetAttr('m25_timestamp',tick+1)
	js.Event_RegisterSink(js.EVENT_TIMER, 'Timestamp_Advance', '', '', 1, 0, 0)	

def Timestamp_GetTime():
	return js.Mission_GetAttr('m25_timestamp')
	
def Timestamp_ObjectAttrOutdated(object, attr, delta=1):
	value = js.Mission_TestAttr(object+attr+'_timestamp')
	if not value: return 1
	tick = Timestamp_GetTime()
	if (value+delta) <= tick:
		return 1
	return 0

def Timestamp_MissionAttrOutdated(attr, delta=1):
	value = js.Mission_TestAttr(attr+'_timestamp')
	if not value: return 1
	tick = Timestamp_GetTime()
	if (value+delta) <= tick:
		return 1
	return 0

def Timestamp_ObjectAttrSync(object, attr):
	tick = Timestamp_GetTime()
	js.Mission_SetAttr(object+attr+'_timestamp',tick)

def Timestamp_MissionAttrSync(attr):
	tick = Timestamp_GetTime()
	js.Mission_SetAttr(attr+'_timestamp',tick)
	
def Timestamp_GetObjectCachedAttr(object, attr, delta=1, default=None,integer=0):
	if Timestamp_ObjectAttrOutdated(object,attr,delta):
		return default
	return m25getset.GetObjectVar(object,attr,default=default,integer=integer,nosave=1)
	
def Timestamp_SetObjectCachedAttr(object, attr, value):
	m25getset.SetObjectVar(object, attr, value,nosave=1)
	Timestamp_ObjectAttrSync(object, attr)
	
def Timestamp_GetMissionCachedAttr(attr, delta=1, default=None,integer=0):
	if Timestamp_MissionAttrOutdated(attr,delta):
		return default
	return m25getset.GetMissionVar(attr,default=default,integer=integer,nosave=1)
	
def Timestamp_SetMissionCachedAttr(attr, value):
	m25getset.SetMissionVar(attr, value,nosave=1)
	Timestamp_MissionAttrSync(attr)
