######################################################################
##
## Pseudo js module
## By pimthe
## 
######################################################################
print "Starting Pseudo js module 0.2"

# DESCRIPTION
# As it stands currently, the Pseudo js and Pseudo ff modules can be used for auto-completion in
# your Python editor and as a reference. They should list any undocumented function and variable
# in the original modules. The documentation feature is EXTREMELY incomplete at this point, though.

# This project could eventually be extended to allow some basic testing outside the game by defining/
# returning dummy values for each of the functions below (yeah, sure). You could then run your test by doing:
#try:
#    import js
#    from js import *
#except:
#    import pseudojs as js
#    from pseudojs import *

# ...Don't hold your breath.

# Feel free to change or add to the code here. Just make sure you maintain compatibility,
# so external modules which could be using these functions keep working. :)

# INSTALLING THE AUTO-COMPLETION FEATURE FOR PYTHONWIN 2.x
    #1. Copy pseudoff.py and pseudojs.py to your scripts folder. Ex.: "C:\Program Files\Irrational Games\Freedom Force\Data\Missions\Scripts"

    #2. Go to the "Tools" menu and select "Edit Python path".

    #3. In the left pane of the new window, click on the word "PythonPath".

    #4. In the right pane, double-click on the "(Default)" word.

    #5. Append the new path. Ex":
    #C:\Python24\Lib;C:\Python24\DLLs;C:\Python24\Lib\lib-tk;"C:\Program Files\Irrational Games\Freedom Force\Data\Missions\Scripts"

    #6. Save and restart PythonWin.

    #7. Open the PythonWin interactive window. At the prompt type:
    #   >>> import pseudoff as ff
    #   >>> import pseudojs as js

    #8. Open a file, say ffxextras.py, and start writing code. When you type either the "js." or the "ff." prefix, the list of availables
    #   variables and functions with their arguments is available.


# TRIVIA
# "js" stands for "Justice Squad", the development name of Freedom Force.

# DEPENDENCIES
# - Python 2.x (for the import as)
# - Called by Pseudo ff.

# VERSION HISTORY
# 0.1 2006-08-17:
# - Added list of commands and variables.
# - Added pseudoff support
# 0.2 2006-09-01:
# - Completed parameter cleaning for import.

######################################################################
## 
## Pseudo js specific code
## 
######################################################################

import pseudoff as ff
from pseudoff import *


PSEUDOJS_MOBJ_COUNT = 0

def mobjCount_Increment():
    global PSEUDOJS_MOBJ_COUNT
    PSEUDOJS_MOBJ_COUNT = PSEUDOJS_MOBJ_COUNT + 1
    return 'mobj_%i' % PSEUDOJS_MOBJ_COUNT

######################################################################
## 
## Global variables
## 
######################################################################

AIM_EXIT = 1
AIM_SPEED_RUN = 0
AIM_SPEED_WALK = 1
ARROW_RED = 0
ARROW_YELLOW = 1
CA_MOVE = 0
CA_TRACK = 1
CAPTION_AUTO = -1
CAPTION_BOTTOM_LEFT = 2
CAPTION_BOTTOM_RIGHT = 3
CAPTION_TOP_LEFT = 0
CAPTION_TOP_RIGHT = 1
CHANNEL_SCRIPT = 4
CPM_HOMING = 3
CPM_SCROLLTO = 2
CPM_SIMPLEPATH = 4
CPM_SNAP = 1
DEFENCE_POWER = 16
EVENT_AI_COLLECT = 14
EVENT_AI_DANGER = 15
EVENT_BLD_SEGMENT_COLLAPSED = 23
EVENT_CHARACTER_SEC_STATE_CHANGED = 33
EVENT_CHARACTER_STATE_CHANGED = 25
EVENT_DETECT_ENEMY = 19
EVENT_DLG_ONHIDE = 31
EVENT_DLG_ONSHOW = 30
EVENT_MARKER_ENTER = 5
EVENT_MARKER_LEAVE = 4
EVENT_MISSIONLOST = 32
EVENT_OBJ_HEALTHCHANGED = 2
EVENT_OBJ_PROXIMITY_ENTER = 0
EVENT_OBJ_PROXIMITY_LEAVE = 1
EVENT_OBJ_SHIELD_DAMAGED = 3
EVENT_PICKUP = 28
EVENT_TEMPLATE_OBJ_DIED = 20
EVENT_THROW = 29
EVENT_TIMER = 17
FX_LOOP = 8
FX_TRACK_OBJECT_FULL = 3
FX_TRACK_OBJECT_POS = 1
FX_TRACK_OBJECT_ROT = 2
OBJSTATE_ALTERED_STRUCTURE = 8
OBJSTATE_ATTACKBONUS = 2
OBJSTATE_DENSITY_CHANGE = 32
OBJSTATE_ELECTRIFIED = 16
OBJSTATE_MOLECULAR_EXCITE = 1
OC_BUILDING = 524288
OC_CHARACTER = 256000
OC_CIVILIAN = 32768
OC_CONTROLLABLE = 8192
OC_MINION = 65536
OC_POLICE = 16384
OC_POWERUP = 2097152
OC_TERRAIN = 1048576
OC_VEHICLE = 262144
OC_VILLIAN = 131072
OE_FOLLOW = 1
PCSTATE_BLANK = 6
PCSTATE_DIMENSION_SHIFT = 3
PCSTATE_DOPPELGANGER = 13
PCSTATE_ENRAGED = 7
PCSTATE_FLAG_NOMELT = 8
PCSTATE_FROZEN = 4
PCSTATE_HYPNOTISED = 9
PCSTATE_INTEROGATE = 2
PCSTATE_NORMAL = 15
PCSTATE_OBJECT = 11
PCSTATE_PANICKED = 8
PCSTATE_POLYMORPHED = 14
PCSTATE_STATIC = 5
PCSTATE_STUNNED = 10
PCSTATE_TOAD = 12
PERMANENT_STATE = 8
REMOVE_STATE = 2
SCSTATE_ACID_BURNT = 1048576
SCSTATE_AREA_ENERGIZED = 33554432
SCSTATE_BLIND = 262144
SCSTATE_BUOYANT = -2147483648L
SCSTATE_DEEP_SENSORED = 1024
SCSTATE_DISPLACE_IMAGE = 67108864
SCSTATE_EMPATHY = 4194304
SCSTATE_ENERGIZED = 8388608
SCSTATE_HEXED = 524288
SCSTATE_INVISIBLE = 2097152
SCSTATE_IRRADIATED = 131072
SCSTATE_POSSESSED = 134217728
SCSTATE_POWER_NULLIFICATION = 16777216
SCSTATE_SPAWN = 2048
SCSTATE_SPEED_DECREASED = 536870912
SCSTATE_SPEED_INCREASED = 268435456
SCSTATE_WEAKENED = 1073741824
SCSTATE_ZOMBIE = 512
TF_ABSOLUTE = 32
TF_NO_COLLISION = 2
TF_NO_GRAVITY = 8
TF_NO_ROTATION = 4
TRG_MISSIONLOST = 32
TRG_MISSIONWON = 31

error = 'js.error'


######################################################################
## 
## Functions documented in the FF scripting guide and actually existing
## in the game (may or may not work as documented or at all, of course)
## 
######################################################################

######################################################################
## 
## AI
## 
######################################################################

def AI_Animate(character, anim, func='', fUser=0.0, iDontIdle=0):
    """
character::	the name of a character
anim:		the name of an animation
func:		(optional)python function to call on animation completion.
fUser:		float value - user defined data
iDontIdle:	a setting of 1 indicates char should not switch to an idle anim after playing the specified anim (default is 0, ie switch to idle)

Plays the given animation on the character. Note, callback function gets event parameter where object field is character, string field is anim
and data field is a boolean specifying whether or not the animation successfully completed. The latter field will be false if the character was
interrupted (e.g. by being killed) while the animation was still playing.
"""

def AI_CancelAllSpeech(channel=CHANNEL_SCRIPT):
    """
Cancels all speech currently playing in the speech manager. If the optional channel is provided, then only speech in that channel is cancelled.
CHANNEL_SCRIPT is the only one defined currently.
"""
    
def AI_CancelLastOrder(object):
    """
object::	the name of the object being commanded.

This function allows the script to abort a previously issued command.
"""
    
def AI_ClearTargets(AI):
    """
object:		the name of a character
 
Clears target list for the AI (removes knowledge of all current targets).
"""
    
def AI_DestroyHeroAI(hero):
    """
hero:			the object name of the hero to convert into a minion.

Destroys the hero AI for the given character and replaces it with the "generic minion" AI.
"""
    
def AI_Debug(arguments_to_be_determined):
    """Not documented."""
    pass

def AI_NullController(arguments_to_be_determined):
    """
character:	name of a character

Forces the character to stop whatever they're doing and come to a halt.
"""

def AI_EnableDynamicSpeech(on_off):
    """
on_off:		1 or 0 for on or off

Disable or enable dynamic speech.
"""
    
def AI_IsEnabled(character):
    """
Returns true or false indicating whether AI is currently enabled or not. Trivially returns true for vehicles.
Returns false if object is missing or does not have an AI.
"""
    return 1
    
def AI_IssueMove(object, marker, scriptFn='', destRad=1.0, speedFlag=AIM_SPEED_RUN, flags=0, fUserData=0, command=''):
    """
object:		the object's mission name to move
marker:	the marker name to move to.
scriptFn:	(optional)call on move completion.
destRad:	(optional)radius in game units at which to consider move complete, located around destination point
speedFlag:	(optional)AIM_SPEED_WALK or AIM_SPEED_RUN
flags:	(optional)AIM_EXIT to have the character exit the map if he walks out of bounds, otherwise 0.
fUserData:	(optional)user registration data
command:	(optional)movement command


This command instructs the object's AI to suspend normal thought, interupt whatever it's doing, and move.
The named script callback will be triggered by an internal event sink marker registration.

Note: 10 game units = 1 meter.

The movement command is optional, it defaults to "move", the full list of commands is as follows:

"stop"		// stop moving (if walking stand still, if flying then hover...)
"move"		// move to destination (if we are in the air fly there, if we are on the ground, walk there)
"walk"		// walk to destination (if we are flying, land first then walk there...)
"fly"		// fly to destination, if on the ground, first launch into a fly then move there
"hover"		// if flying stop and come to a hover, if on the ground, jump into the air and hover above
where you were standing
"land"		// if flying land gently on the ground, once landed enter walk state but stay still
"jump"		// jump to destination, take a run up if possible... how to handle jumps that are too far, too
high etc?
"fall"		// fall to the ground if flying, do nothing if you are already on the ground
"dodge"		// dodge to the left or right to avoid an attack on the character
"lock"		// lock the movement system (interrupts current state and locks character stationary...)
"unlock" 		// the only way to leave the LOCKED state, ie. when a char is frozen it should be locked then
unlocked when unfrozen
"turn"  		// turn the character to face the target point
"climb"  		// climb up a wall, ladder etc.

NOTE: You should probably use Trigger_Move to move chars if you do not need a callback on completion - its considerably easier to use.
"""
    
def AI_MakeHeroAI(enemy_character):
    """
enemy_character:	the object name of the enemy to convert into a hero.

Changes the AI of the target character into a hero reaction AI. Does not add this character to the squad.
"""
    
def AI_MakeIntoHero(enemy_character):
    """
enemy_character:	the object name of the enemy to convert into a hero.

Makes an AI classed as an enemy into a controllable character for the player.
"""
    
def AI_SayPortraitSpeech(object, speechTag, scriptFn='', fUser=0, iIsTemplate=0, fPan=0.0, iPosition=CAPTION_AUTO, iTelepathy=2, iType=CHANNEL_SCRIPT, iForceNonMission=0):
    """
object:		the object name of the hero speaking.
speechTag:	speech tags are in the format: SPEECH_ID_ACTION_VARIANT
scriptFn:	(optional)call when speech is completed.
fUser:		(optional)user data to pass to callback
iIsTemplate:	(optional)specifies that the object name is not an object, but a template.
fPan:		(optional)panning of the speech - 0.0 = left pan, 0.1 = right pan
iPosition:	(optional)if CAPTION_AUTO, the portrait is automatically placed.  Other possible values are:
            CAPTION_TOP_LEFT, CAPTION_TOP_RIGHT, CAPTION_BOTTOM_LEFT, CAPTION_BOTTOM_RIGHT.
iTelepathy:	(optional)0 = no telepathy effect, 1 = telepathy effect, 2 = auto-decide (default)
iType:		(optional) -1 = none, otherwise speech channel
iForceNonMission:	(optional) 0 = prohibit, 1 = allow

This command tells the object to say the required speech. 

CAPTION_AUTO allows the game to select a position for the character.  If the object has already spoken, then the position used for that occasion is used.
Otherwise the position after the most recent speech position is used.  The order of positions is CAPTION_TOP_LEFT=0, CAPTION_TOP_RIGHT=1, CAPTION_BOTTOM_LEFT=2,
CAPTION_BOTTOM_RIGHT=3. If the camera is not widescreen, then the caption is displayed in the top left.
 
If the iIsTemplate parameter is specified as 1, then the object parameter is taken to be a template name, rather than an object name.
Use this feature to allow characters that are not in the mission to speak, such as Mentor back at the base. Telepathy is used by default in this situation.

If the type is provided, then the speech is spoofed as dynamic speech of that type. Probably best to use 0 to spoof as "alert" speech if desired.

The iForceNonMission parameter allows the script to force the speech to be played in a non-mission situation (e.g. debrief screen). Normally speech
is disabled when not in a mission or base.
"""
    
def AI_SetAlerted(character, alerted):
    """character:	the object name of the character for whom to set alert state.
alerted:	0 (not alerted) or 1 (alerted)

Set an individual AI to be alert or not alert. When a character is alert, line-of-sight checks and detection cones are ignored,
and a simple radius check is used to detect enemies.
"""
    
def AI_SetAllEnabled(enabled):
    """
character:	the object name of the character for whom to enable/disable AI.
enabled:	0 (disabled) or 1 (enabled)

Enable/disable AI for all or individual characters. When AI is disabled characters will not wander, react to threats, etc.
"""
    
def AI_SetEnabled(character, enabled):
    """
character:	the object name of the character for whom to enable/disable AI.
enabled:	0 (disabled) or 1 (enabled)

Enable/disable AI for all or individual characters. When AI is disabled characters will not wander, react to threats, etc.
"""


######################################################################
## 
## Camera
## 
######################################################################

def Camera_Dump():
    """
Show current camera position etc. in the console.
"""
    
def Camera_Fade(time):
    """
time:		time to fade

Start fading the camera to black - full fade completed in time seconds
"""
    
def Camera_ForceAutoFade(forceAutoFade):
    """
forceAutoFade: force auto fade or not

Tell the camera system to force auto fading of objects or not (zero or one). Forcing autofade is useful for cut-scenes where we don't know where the camera will be.
"""
    
def Camera_GetLookAtInfo(comment):
    """
comment:		(Optional) A string comment.
returns:		a tuple

This command returns a tuple of the following format:
((x, y, z), dist, pitch, yaw)
These elements are intended to be passed to the Camera_LookAtPos function.

The 'comment' field is intended to assist designers when this tool is used to gather positions for cutscenes.
If the comment field is specified, the comment is printed to the script log as well as the generated tuple for
easy cut and paste into a script.
"""
    
def Camera_LookAtMarker(markerName, camDist, camPitchRot, camYawRot, camSpeed, movePathMode, camAction, callbackFunc=''):
    """
markerName:		Name of marker object to move to.
camDist:	    The zoom distance in world units, relative to the default zoom. Negative values mean zoom in, positive out.
camPitchRot:	Angle of pitch around object right vector, in degrees.
                (only valid in SNAP mode).
camYawRot:	    Angle of yaw around object up vector, in degrees. Positive angles turn clockwise, negative anticlockwise.
camSpeed:		Time in seconds it will take to complete the move.
movePathMode:	CPM_SNAP: snap straight there.
				CPM_SCROLLTO: spend some time interpolating to new target.
				CPM_HOMING: simple homing path.
				CPM_SIMPLEPATH: use default simple camera path algo.
camAction:		CA_MOVE: move only.
				CA_TRACK: move to object and then track.
				CA_ORBIT: snap to object and then orbit at speed.
callbackFunc:	(optional) python script function to call when movement has finished

Very similar to LookAt(), but it get's the camera target position and orientation from the named marker.
"""
    
def Camera_LookAtObject(objectName, camDist, camPitchRot, camYawRot, camSpeed, movePathMode, camAction, callbackFunc=''):
    """
positionTuple:	Position to look at.
camDist:	    The zoom distance in world units, relative to the default zoom. Negative values mean zoom in, positive out.
camPitchRot:	Angle of pitch around object right vector, in degrees.
                (only valid in SNAP mode).
camYawRot:	    Angle of yaw around object up vector, in degrees. Positive angles turn clockwise, negative anticlockwise.
camSpeed:		Time in seconds it will take to complete the move.
movePathMode:	CPM_SNAP: snap straight there.
				CPM_SCROLLTO: spend some time interpolating to new target.
				CPM_HOMING: simple homing path.
				CPM_SIMPLEPATH: use default simple camera path algo.
camAction:		CA_MOVE: move only.
				CA_TRACK: move to object and then track.
				CA_ORBIT: snap to object and then orbit at speed.
callbackFunc:	(optional) python script function to call when movement has finished

Another camera function, all parameters the same as the others except the position to look at.
"""
    
def Camera_LookAtPos(objectName, camDist, camPitchRot, camYawRot, camSpeed, movePathMode, camAction, callbackFunc='', fUser=0):
    """
objectName:		The object to track.
camDist:		The zoom distance in world units, relative to the default zoom. Negative values mean zoom in, positive out.
camPitchRot:	Angle of pitch around object right vector, in degrees.
                (only valid in SNAP mode).
camYawRot:		Angle of yaw around object up vector, in degrees. Positive angles turn clockwise, negative anticlockwise.
camSpeed:		Time in seconds it will take to complete the move.
movePathMode:	CPM_SNAP: snap straight there.
				CPM_SCROLLTO: spend some time interpolating to new target.
				CPM_HOMING: simple homing path.
				CPM_SIMPLEPATH: use default simple camera path algo.
camAction:		CA_MOVE: move only.
				CA_TRACK: move to object and then track.
				CA_ORBIT: snap to object and then orbit at speed.
callbackFunc:	(optional) python script function to call when movement has finished
fUser:			float value - user defined data

This command moves the camera to focus onto a given mission object. It carries out this move based on the speed and mode parameters.
Once there the camera may optionally carry out further behavior, namely orbit or track. The camera path in the move stage of this
command is a long life process that could in the future be made more complicated. At the moment the camera path must be dynamically constructed.

"""
    
def Camera_Release():
    """
This command releases the camera from any camera command control, and resets it back to the default tactical camera position. (depends on selected hero etc)
"""
    
def Camera_SetFade(fade):
    """
    fade:		fade value

Set camera fade value (0 = no fade, 1 = black screen).
"""
    
def Camera_SetWidescreen(enabled):
    """
enabled:		yes or no?

Enable or disable widescreen mode.
"""
    
def Camera_Shake(intensity, source):
    """
intensity:		Intensity of the shaking.
source:	Tuple specifying the position of the source of the shaking.
"""
    
def Camera_UnFade(time):
    """
time:		time to fade

Start fading the camera back to normal screen - full unfade completed in time seconds.
"""


######################################################################
## 
## Campaign
## 
######################################################################
    
def Campaign_AddCP(hero, XP):
    """

"""
    
def Campaign_AddHero(heroName):
    """

"""
    
def Campaign_AddMinion(minionName):
    """

"""
    
def Campaign_AddPrestige(prestige):
    """

"""
    
def Campaign_AddVillain(villianName):
    """

"""
    
def Campaign_IsRecruited(heroName):
    """

"""
    
def Campaign_Recruit(heroName):
    """

"""
    
def Campaign_Recruit_ClearOverrides():
    """

"""
    
def Campaign_Recruit_Disallow(heroName):
    """

"""
    
def Campaign_Recruit_Require(heroName):
    """

"""
    
def Campaign_Save():
    """

"""
    
def Campaign_UnlockOrigin(heroName):
    """

"""
    
def Campaign_UnRecruit(heroName):
    """

"""
    
def EnableMLOG(state=1):
    """

"""
    
def Event_RegisterMarkerSink(marker, objFilter, function, persist=0, fUserData=0.0):
    """

"""
    
def Event_RegisterPowerUse(object, powerName, func, persist=0, fUserData=0.0):
    """

"""
    
def Event_RegisterSink(event, function, objFilter, strFilter="", fltFilter=0.0, fUserData=0.0, fPersist=0):
    """

"""
    
def Get_MarkerPos(marker):
    """

"""
    
def Get_ObjectPos(object):
    """

"""
    
def Global_RegisterAttr(name, defaultValue):
    """

"""
    
def loadChars():
    """

"""
    
def loadData():
    """

"""
    
def loadPowers ():
    """

"""
    
def Marker_Exists(object):
    """

"""
    
def Marker_SetPos(name, position, heading=0.0):
    """

"""
    
def Marker_Spawn(name, position, heading=0.0):
    """

"""
    
def Mission_AddArrowObject(name, object, type, delete = 1):
    """

"""
    
def Mission_AddArrowPos(name, position, type):
    """

"""
    
def Mission_AddBonus(name, PP):
    """

"""
    
def Mission_AddSquadExtra(heroName):
    """

"""
    
def Mission_ClearCustomActions():
    """

"""
    
def Mission_CustomAction(actionName, heroFilter, objFilter, funcName, radius, oneShot):
    """

"""
    
def Mission_DisplayTimer(name, time):
    """

"""
    
def Mission_FadeDreamSinParams(waveFreq, waveAmplitude, waveSpeed, fadeTime):
    """

"""
    
def Mission_FadeWaveSinParams( waveFrequency, maxWaveFrequency, WaveAmplitude, WaveSpeed, fadeTime):
    """

"""
    
def Mission_GetAttr(name):
    """

"""
    
def Mission_GetDynamicObjects():
    """

"""
    
def Mission_GetHeroList():
    """

"""
    
def Mission_GetObjects():
    """

"""
    
def Mission_GetShadows():
    """

"""
    
def Mission_GetSquadList():
    """

"""
    
def Mission_GetSunlight():
    """

"""
    
def Mission_Lose():
    """

"""
    
def Mission_Play2DCutscene(nifResName, wavResName='', funcName=''):
    """
nifResName:		The resource name of the nif to play.
wavResName:		(optional)The resource name of the accompanying wav file.
funcName:		(optional)Name of a python function.

Plays a 2D cutscene. Calls the python function when the user hits esc or when the cutscene finishes.
"""
    
def Mission_PlayOriginStory(templateName, funcName=''):
    """
templateName:	Template name of a hero.
funcName:		(optional)Name of a python function.

Plays a hero's origin story. Calls the python function when the user hits esc or when the cutscene finishes.
"""
    
def Mission_PrecacheTemplateObj(templateName, talkingHead=0, powers=0):
    """
templateName:	The template name of the object that is to be precached.
talkingHead:		If 1, the talking head is also precached.  Defaults to 0.
Powers:	If 1, the powers associated with the character are also precached.  Defaults to 0.

Precaches data associated with an object so that it can be spawned without the game pausing. This function should only be called from within OnPrecacheObjects
"""
    
def Mission_RemoveArrow(name):
    """
name:		arrow name 

Remove an existing arrow. Error if no such arrow.
"""
    
def Mission_RemoveCustomAction(actionName, heroFilter, objFilter):
    """

"""
    
def Mission_SelectHero(heroName):
    """

"""
    
def Mission_SetAttr(name, value):
    """

"""
    
def Mission_SetBackground(red, green, blue):
    """

"""
    
def Mission_SetDetectionEnabled(enabled):
    """

"""
    
def Mission_SetDreamSinParams(waveFreq, waveAmplitude, waveSpeed):
    """

"""
    
def Mission_SetDreamYScale(yScale):
    """

"""
    
def Mission_SetEffectEdgeFade(bActive, edgeFadeWidth):
    """

"""
    
def Mission_SetPaused(pause):
    """

"""
    
def Mission_SetProjShadowBackground(red, green, blue):
    """

"""
    
def Mission_SetProjShadowColor(red, green, blue):
    """

"""
    
def Mission_SetProjShadowFadeDistance(startDist, EndDist):
    """

"""
    
def Mission_SetProjShadowZOffset(zOffset):
    """

"""
    
def Mission_SetShadows(rotation, tilt, color):
    """

"""
    
def Mission_SetSunlight(rotation, tilt, brightness, ambient, color):
    """

"""
    
def Mission_SetWaveEnvelope(bActive, fadeIn, fullOn, fadeOut, speed, amplitude):
    """

"""
    
def Mission_SetWaveRadiusParams( WorldRadius, MaxOffScreenRadius):
    """

"""
    
def Mission_SetWaveSinParams( waveFrequency, maxWaveFrequency, WaveAmplitude, WaveSpeed):
    """

"""
    
def Mission_StartDreamWave(fadeIn, fullOn, fadeOut):
    """

"""
    
def Mission_StartWave(fadeInDuration, fullOnDuration, fadeOutDuration, centerPoint):
    """

"""
    
def Mission_StatusText(text):
    """

"""
    
def Mission_TestAttr(name):
    """

"""
    
def Mission_Win():
    """

"""
    
def MLOG(moduleName, objectName=''):
    """
ModuleName:	Name of the module to view log messages for.
ObjectName:	Name of the object to filter messages for (default is "" = don't do any filtering)
            *Note: if objectName is enabled, only one single object at a time will be logged. :(

Enables log messages for the specified module.
"""
    
def MLOGKill(moduleName):
    """
Disables log messages for the specified module.
"""
    
def MP_AddScore(object, score):
    """
object:		The object that is to receive points.  The object must be part of a squad for the points to be recorded.  The squad maintains a total of the scores for all 4 heroes.
score:		integer value
"""
    
def MP_AddTeamScore(teamId, score):
    """
Adds the score to the team and not to an individual hero
score:		integer value
"""
    
def MP_DisplayTimer(name, time):
    """

"""
    
def MP_EndGameNow():
    """

"""
    
def MP_GetScore(object):
    """

"""
    
def MP_GetShortDescription():
    """

"""
    
def MP_GetSquadHero(squadId, heroId):
    """
squadId        int
heroId:			0,1,2 or 3
Each squad can only have a maximum of 4 heroes.  This function returns the template that the player
selected for a squad, and the hero/object that is currently in that position.

"""
    
def MP_GetSquadName(squadId):
    """

"""
    
def MP_GetSquads():
    """

"""
    
def MP_GetSquadScore(squadId):
    """

"""
    
def MP_GetSquadSpawnMarker(squadID):
    """
squadID         int

Returns the base name of the spawn marker to use for the squad, e.g. for squad 1 it will return "spawn_1".
To get spawn markers for individual heroes, append their number in the squad (e.g. "spawn_11", etc.).
Note that this does not include any mode specific elements that may be added to the spawn name. The intention
is simply to provide a mapping from the squad ID to the base marker name.
"""
    
def MP_GetSquadTeam(squadId):
    """
squadID         int

Returns the Team Id that the squad belongs to
"""
    
def MP_GetTargetObject():
    """

"""
    
def MP_GetTeamName(teamId):
    """

"""
    
def MP_GetTeams():
    """

"""
    
def MP_GetTeamScore(teamId):
    """

"""
    
def MP_GetTimeLimit():
    """

"""
    
def MP_IsTeamGame():
    """

"""
    
def MP_IsTeamLeader(hero):
    """

"""
    
def MP_Object_GetSquad(object):
    """

"""
    
def MP_PlaySpeech(speechTag, invertSquads = True, squadList = (), invertTeams = True, teamList = ()):
    """

"""
    
def MP_SendMessage(message, params, invertSquads = True, squadList = (), invertTeams = True, teamList = ()):
    """
message:            str
params:     		List of strings that will be substituted in message.
invertSquads:		Determines whether players in squadList should be excluded or included
squadList:  		List of squad ids.  Default values of invertSquads and squadList result in the message being sent to all players.
invertTeams:		Determines whether teams in teamList should be excluded or included.
teamList:	    	List of team ids.  Default values of invertTeams and teamList result in the message being sent to all teams.

This function sends a message to a player.  Tags within the message "\0", "\1", "\2" are replaced with the corresponding element of params.

If both the squad filter and team filter are used, then the message is sent to players that fit both criteria.
"""
    
def Object_CalcPrestige(character):
    """

"""
    
def Object_Destroy(object, updateStats=1):
    """

"""
    
def Object_Drive(vehicle='', enable=True):
    """
object:		(optional) a specific vehicle object, specify empty string for all
enable:		(optional) 1 to start driving, 0 to stop

Starts/stops a vehicle driving along car navigation points. If no vehicle given, start/stops all vehicles.
"""
    
def Object_DumpAttr(object):
    """

"""
    
def Object_Exists(object):
    """

"""
    
def Object_GetAttr(object, attrName):
    """

"""
    
def Object_GetClass(object):
    """

"""
    
def Object_GetOrientation(object):
    """

"""
    
def Object_GetPrimaryState(object):
    """

"""
    
def Object_GetSecondaryStates(object):
    """

"""
    
def Object_GetSpeechID(object):
    """

"""
    
def Object_GetTemplate(object):
    """

"""
    
def Object_GetTerrain():
    """

"""
    
def Object_IsAlive(object):
    """

"""
    
def Object_IsCustomChar(object):
    """

"""
    
def Object_MakeDriver(object):
    """

"""
    
def Object_MoveToMarker(object, marker):
    """

"""
    
def Object_NextVersion(object):
    """

"""
    
def Object_PlayEffect(object, effectname, callbackFunc='', flags=0, fuser=0.0, attachmentPoint='', \
                      offset=(0.0,0.0,0.0), fAngle=0.0, axis=(0.0,0.0,1.0), keyname='', keycallbackfunction=''):
    """
object:          			the object's mission name to play effect on
effect name:        		resource name of effect (must be added to resource DB)
callbackFunc:          		python script function to call when effect has finished playing
flags:
	FX_TRACK_OBJECT_POS 	: effect will follow moving object around
	FX_TRACK_OBJECT_ROT 	: effect will lock onto object rotation
	FX_TRACK_OBJECT_FULL	: combines ROT and POS flags
	FX_LOOP			        : effect should loop continuously
fUser:			            float value - user defined data
attachmentPoint:        	attachment point for effect (default is '', object pivot)
offset			            offset point tuple from the attachment point (defaults to (0.0,0.0,0.0))
fAngle			            angle around the axis to rotate effect (defaults to 0.0)
axis			            angle around the axis to rotate effect  (defaults to (0.0,0.0,1.0))
key name		            name of key to look for in effect
key callback function	function to callback when key encountered

Returns: A handle to the effect. If the effect just has to play, and not be manipulated in any way later on, then this handle can be ignored and the return value not assigned to anything.
This command plays an effect on the specified object. Unless specified as looping, the effect will play though once and then diseapear. Looping effects may be stopped by storing the returned effect handle, and then at any point calling Object_StopEffect.  Orientation parameters (fAngle and axis) have no effect if effect tracks rotation.

You may also specify a note key name and callback function. If these are both specified, then the game will call the function when the key is encountered. If the key is missing, the function will be called immediately.

"""
    
def Object_SetAttr(object, attrName, floatVal):
    """

"""
    
def Object_SetGenericState(object, state, arg, flags=0):
    """
object:			name of the object.
state:
    SCSTATE_IRRADIATED	
    SCSTATE_BLIND
    SCSTATE_HEXED
    SCSTATE_ACID_BURNT
    SCSTATE_INVISIBLE	
    SCSTATE_POWER_NULLIFICATION
    SCSTATE_SPAWN
    SCSTATE_ENERGIZED
    SCSTATE_EMPATHY
    SCSTATE_AREA_ENERGIZED
    SCSTATE_DISPLACE_IMAGE
    SCSTATE_SPEED_INCREASED
    SCSTATE_SPEED_DECREASED
    SCSTATE_WEAKENED
    SCSTATE_BUOYANT
    SCSTATE_ZOMBIE
    SCSTATE_DEEP_SENSORED
arg:			    int argument for the state (usually duration)
flags:
    PERMANENT_STATE If specified, the state will never time out (ie run for infinite time, unless it gets externally interrupted).
    DEFENCE_POWER   For use only with power nullification state. Will cause the state to disable shields only.
    REMOVE_STATE    Removes the state instead of adding it.

*Note: there is no Object_GetGenericStates(object) function. :(
"""
    
def Object_SetOrientation(objectName, angle, axis):
    """

"""
    
def Object_SetPrimaryState(object, state, arg, flags=0):
    """

"""
    
def Object_SetSecondaryState(object, state, arg, flags):
    """

"""
    
def Object_Spawn(objectName, objectTemplate, markerName):
    """

"""


def Object_SpawnAt(objectTemplate, posTuple, name=mobjCount_Increment(), orientationTuple=(0.0,0.0,0.0), squadId=0, heroId=-1):
    """
objectTemplate:		name of the object template used to create object.
posTuple:			tuple specifying object position
name:				(Optional) name to be given the object
orientationTuple:	orientation of the object, using the same format as returned by Object_GetOrientation.
squadId:			spawns the character/object so that it belongs to a squad (only useful for multiplayer scripting)
heroId:				Adds the character/object to the squad for scoring (only useful for multiplayer scripting).  Refer to Multiplayer Game Mode for more details.

This command spawns the given game object at the specified location. Equivalent to js.new(objectTemplate, posTuple).
"""
    
def Object_StopEffect(object, handle):
    """

"""
    
def Objective_Activate(objective):
    """

"""
    
def Objective_Add(objective, description, type, prestigePoints):
    """

"""
    
def Objective_Complete(objective):
    """

"""
    
def Objective_Exists(objective):
    """

"""
    
def Objective_Fail(objective):
    """

"""
    
def Objective_IsComplete(objective):
    """

"""
    
def Objective_IsFailed(objective):
    """

"""
    
def Objective_Register (objective, description, type, prestigePoints):
    """

"""
    
def RPG_SetActive(active):
    """

"""
    
def Skirmish_AddBonus(name, value):
    """

"""
    
def Skirmish_AddMultiplier(name, value):
    """

"""
    
def Sound_PauseMusic():
    """

"""
    
def Sound_PlayAmbient(on):
    """

"""
    
def Sound_PlayMusic(name, loopCount = 0):
    """

"""
    
def Sound_PlaySound(name, position = (0,0,0), gain = 1.0):
    """

"""
    
def Sound_PlayTransition(name, time = 0):
    """

"""
    
def Sound_SetMusicVolume(volume, time = 0):
    """

"""
    
def Sound_StopMusic():
    """

"""
    
def StatMLOG():
    """

"""
    
def Template_Exists(templateName):
    """

"""
    
def Template_GetClassString(templateName):
    """

"""
    
def Template_GetSpeechID(object):
    """

"""
    
def Trigger_Damage(objName, damage):
    """

"""
    
def Trigger_Explosion(objName, powerName, intensity=1):
    """
objName:		object that is source of the explosion
powerName:		name of power to use in the explosion
intensity:		command intensity of the explosion

Trigger an explosion on the designated object. Only area powers and explosive projectile powers may be used.
"""
    
def Trigger_Force(objName, x, y, z, m, flags):
    """

"""
    
def Trigger_Move(objName, commandName, posTuple, funcName, radius, speed):
    """

"""
    
def Trigger_Pickup(objName, targName, funcName='', level=1, fUserData=0.0):
    """
objName:	character to launch pickup
targName:	target of pickup
funcName:	(optional)function to call when the object is picked up (i.e. ready to be thrown)
level:		(optional)intensity level of the pickup
fUserData:	(optional)user registration data.

Tell a character to pick an object up.
The callback struct will contain 1 in the float field if the pickup was successful, or 0 if it failed.
"""
    
def Trigger_Power(objName, targName, powerName, funcName, level, posTuple,fUserData):
    """

"""
    
def Trigger_Throw(objName, targetPoint):
    """

"""
    
def Trigger0(trigger):
    """

"""
    
def UI_Base_Enable(active):
    """

"""
    
def UI_Briefing_Done():
    """

"""
    
def UI_Enable(active):
    """

"""
    
def UI_HideWidget(widget):
    """

"""
    
def UI_ShowWidget(widget):
    """

"""
    
def UI_StartFlashButton(widget):
    """

"""
    
def UI_StopFlashButton(widget):
    """

"""
    
def Vector_Add(v1, v2):
    """

"""
    
def Vector_Sub(v1, v2):
    """

"""
    






######################################################################
## 
## Not documented.
## 
######################################################################




def areaNewHero(arg1, arg2, arg3):
    """Not documented."""
    pass

def Camera_IsWidescreen(arguments_to_be_determined):
    """Not documented."""
    pass

def Command_AddFuture(arguments_to_be_determined):
    """Not documented."""
    pass

def cvarGet(name):
    """Not documented. Apparently broken. Probably allows to read an entry from FF.csv."""
    pass

def cvarSet(name):
    """Not documented. Apparently broken. Probably allows to set an entry in the FF.csv."""
    pass

def Debug_ExportHero(name1, name2):
    """Not documented. Probably related to .ffb hero/mesh/skin bundles."""
    pass

def Debug_ImportHero(name):
    """Not documented. Probably related to .ffb hero/mesh/skin bundles."""
    pass

def Debug_MPCheck(arguments_to_be_determined):
    """Not documented."""
    pass

def Get_MarkerHeading(arguments_to_be_determined):
    """Not documented."""
    pass

def Launch_Power(arguments_to_be_determined):
    """Not documented."""
    pass

def loadPowers(arguments_to_be_determined):
    """Not documented."""
    pass

def log(arguments_to_be_determined):
    """Not documented."""
    pass

def Mission_SetGloss(number):
    """Not documented."""
    pass

def MP_GetScore(arguments_to_be_determined):
    """Not documented."""
    pass

def MP_GetSquadHero(arguments_to_be_determined):
    """Not documented."""
    pass

def MP_GetSquadName(arguments_to_be_determined):
    """Not documented."""
    pass

def MP_GetSquads(arguments_to_be_determined):
    """Not documented."""
    pass

def MP_GetSquadScore(arguments_to_be_determined):
    """Not documented."""
    pass

def MP_GetSquadSpawnMarker(arguments_to_be_determined):
    """Not documented."""
    pass

def MP_GetSquadTeam(arguments_to_be_determined):
    """Not documented."""
    pass

def MP_GetTargetObject(arguments_to_be_determined):
    """Not documented."""
    pass

def MP_GetTeamName(arguments_to_be_determined):
    """Not documented."""
    pass

def MP_GetTeams(arguments_to_be_determined):
    """Not documented."""
    pass

def MP_GetTeamScore(arguments_to_be_determined):
    """Not documented."""
    pass

def MP_GetTimeLimit(arguments_to_be_determined):
    """Not documented."""
    pass

def MP_IsTeamLeader(arguments_to_be_determined):
    """Not documented."""
    pass

def MP_Object_GetSquad(arguments_to_be_determined):
    """Not documented."""
    pass

def new(objectTemplate, posTuple, name=mobjCount_Increment(), orientationTuple=(0.0,0.0,0.0), squadId=0, heroId=-1):
    """
objectTemplate:		name of the object template used to create object.
posTuple:			tuple specifying object position
name:				(Optional) name to be given the object
orientationTuple:	orientation of the object, using the same format as returned by Object_GetOrientation.
squadId:			spawns the character/object so that it belongs to a squad (only useful for multiplayer scripting)
heroId:				Adds the character/object to the squad for scoring (only useful for multiplayer scripting).  Refer to Multiplayer Game Mode for more details.

This command spawns the given game object at the specified location. Equivalent to Object_SpawnAt(objectTemplate, posTuple).
"""

def Object_DriveTo(arguments_to_be_determined):
    """Not documented."""
    pass

def Objective_Register(arguments_to_be_determined):
    """Not documented."""
    pass

def quit():
    """Not documented. Quits the game."""
    pass

def quitApp():
    """Not documented. Quits the game."""
    pass

def Skirmish_AddEnemyMultiplier(arguments_to_be_determined):
    """Not documented."""
    pass

def Sound_AttachSound_HANDLE(arguments_to_be_determined):
    """Not documented."""
    pass

def Sound_CreateSound_HANDLE(arguments_to_be_determined):
    """Not documented."""
    pass

def Sound_EndLoopSound_HANDLE(arguments_to_be_determined):
    """Not documented."""
    pass

def Sound_IsSoundPlaying_HANDLE(arguments_to_be_determined):
    """Not documented."""
    pass

def Sound_LoopSound_HANDLE(arguments_to_be_determined):
    """Not documented."""
    pass

def Sound_PlaySound_HANDLE(arguments_to_be_determined):
    """Not documented."""
    pass

def Sound_ReleaseSound_HANDLE(arguments_to_be_determined):
    """Not documented."""
    pass

def Sound_SetSoundGain_HANDLE(arguments_to_be_determined):
    """Not documented."""
    pass

def Sound_SetSoundPosition_HANDLE(arguments_to_be_determined):
    """Not documented."""
    pass

def Sound_SetSoundVelocity_HANDLE(arguments_to_be_determined):
    """Not documented."""
    pass

def Sound_StopSound_HANDLE(arguments_to_be_determined):
    """Not documented."""
    pass

def Trigger_Emerge(Object):
    """Not documented. Tells a burrowed character (through Trigger_Power() or manually) to emerge."""
    pass

def writeText(arguments_to_be_determined):
    """Not documented."""
    pass


######################################################################
## 
## Default object attributes
## 
######################################################################

# The PSEUDOJS_DEFAULT_OBJECTATTR list below has not been verified for validity and is currently not used.

##alwaysdetect	Only meaningful to characters. If 1, the character is visible even when outside a player's detection radius.
##ambient	Object is marked as ambient and is not shown when the "ambient objects" video option is unchecked.
##animated		If 1, the object receives updates so animations will play
##animRandomOffset	If 1, the animation of each created object is randomly offset so that all objects of the same type do not animate synchronously.  Only affects objects with the "animated" attribute.  Defaults to 1. 
##avoid			If 1, the pathfinder will avoid this object.
##baseForce	The force an object needs to experience in order to become separated from its base.
##canPickUp	If 1, character can pick up or wield objects. Defaults to 1.
##cantIgnite	If 1, object can't be the target of an ignite power. Defaults to 0.
##castShadow	If 1, object casts a shadow. Has no effect if modified in-game, specify in FFEdit.
##complex	If 1, the movement grid will do a more expensive but more accurate ray cast to determine the object's height. This should be set of complex objects with multiple overlapping polygons. For example, it was used for building rubble. Defaults to 0.
##complexFade	If 1, object fades when the camera ray intersects the geometry, not the collision box (e.g. trees). Defaults to 0.
##customRadius	For powerups (GAME_OBJ_POWERUP) - specifies distance at which object will be "used". Defaults to 0.
##damagedOnMove	If set to 1, the object changes to its damaged state if it moves in any way.
##debris	If 1, object will not do damage when colliding with a building (GAME_OBJ_BUILDING). Defaults to 0.
##
##***Dynamic, can be applied to characters
##
##defaultToAttack	only applicable to generic objects, if 1, the context-sensitive cursor will change to attack when this object is moused-over.
##detectangleHeight	The total angle of the vertical arc that is used for the AI's visible calculations.
##detectangleWidth	The total angle of the horizontal arc that is used for the AI's visible calculations.
##detectradius	For villains, the radius in meters at which the AI sees things. For players, the radius in meters at which characters become visible.
##detectradiusMin	The radius in meters at which a character is considered detected even though they may not be within the AI's arc of detection.
##door	If 1, object acts as door (don't path through it). Defaults to 0.
##elasticity	A percentage from 0 to 100, how bouncy the object is
##flyover	Defaults to 1, but if set to 0 an object will report no flyover data, i.e. no healthbar, status bar or highlighting. It will appear similar to terrain.
##health			The current health of a character/object.
##heroPoints	How many Hero Points the character has.
##ignoredByVehicle	If 1, vehicles will drive over/through this object. Defaults to 0.
##ladder	If 1, the objects is special - it's a climbable ladder
##mass			The mass of the object as used in physics calculations.
##material		Type of material the object is made out of
##maxEnergyPoints	The normal amount of full energy points character has.
##minForce		The min force an object needs to move it, lesser forces are ignored.  When set 
##to -1, the object is immovable.
##minHealth	The minimum health level for a character/object. The health attribute can never drop below this value.
##mock	Object (character) is not to be shown in in-game lists (i.e. as custom character mesh or in debrief lists). Defaults to 0.
##mp_targettable	Determines whether object can be a "target" for a destruction mode MP game. Defaults to 0.
##noFade	If 1, the object will not fade out when it blocks the camera.
##notInDB	Like mock but shows character in debrief screens. Defaults to 0.
##pathBudget	How complex paths are for this character. Typically 200-300 is low, 2000 is high. Defaults to 200 for non-heroes, 10,000 for heroes.
##physical	If 1, the object can be affected by events in the sim
##pickupDistance	Controls the distance at which a character picks up an object.
##prestige	For villains and minions, prestige you get for KO-ing them, for civilians and objects, prestige you lose for KO-ing/destroying them.
##	Defaults to 0.
##rangedZOffset	Offset from model center at which shot is fired for LOF checking purposes. Defaults to 0.
##scary	If a civilian sees a villain or minion with the 'scary' attribute, they will run immediately, else they will only run if damaged or if a power is used.
##semiPhysical	Object blocks projectiles (and beams) only if it is the direct target. Use for railings and so on. Defaults to 0.
##shadowType	If 0, character casts a block shadow. If 1, character casts a "blob light". Only applies to characters. Defaults to 0.
##standon		If 1, it is possible to stand on the object.
##throwable		If 1, object can be picked up and thrown.
##turretMaxAngle	The total angle of the arc at which the turret can fire at enemies (relative to it's initial rotation)
##turretUseLOS	only applicable to turrets, if 1, the turret will not fire if it does not have line of sight.
##undetectable	Makes object not detectable by AIs.
##unpassable	Characters cannot fly/walk above/into unpassable objects (default value is 0 = object is passable).
##visibleInEditor	If not set, the object can be toggled in the in-game editor using the J key. (default value, 1 = object is always visible).
##wieldable	If 1, object can be wielded. Defaults to 0.
##
##The following attributes cannot be set in FFEdit. They are used by the game to keep track of data.
## 
##cloneCount	Used internally to keep track of clone numbers 
##crusher		If set, the character will ignore small objects when pathfinding.
##energyPoints		Amount of energy points character has
##EPRechargeRate	No. of EPs that recharge every second
##maxHealth	The normal full health of object 
##speed			Character's RPG speed value 
##strength		Character's RPG strength value 
##zombieState

PSEUDOJS_DEFAULT_OBJECTATTR = ['alwaysdetect', 'ambient', 'animated', 'animRandomOffset', 'avoid', 'baseForce', 'canPickUp', 'cantIgnite',
                               'castShadow', 'complex', 'complexFade', 'customRadius', 'damagedOnMove', 'debris', '***Dynamic,', 'defaultToAttack',
                               'detectangleHeight', 'detectangleWidth', 'detectradius', 'detectradiusMin', 'door', 'elasticity', 'flyover', 'health',
                               'heroPoints', 'ignoredByVehicle', 'ladder', 'mass', 'material', 'maxEnergyPoints', 'minForce', 'to', 'minHealth',
                               'mock', 'mp_targettable', 'noFade', 'notInDB', 'pathBudget', 'physical', 'pickupDistance', 'prestige', 'Defaults',
                               'rangedZOffset', 'scary', 'semiPhysical', 'shadowType', 'standon', 'throwable', 'turretMaxAngle', 'turretUseLOS',
                               'undetectable', 'unpassable', 'visibleInEditor', 'wieldable', 'The', 'cloneCount', 'crusher', 'energyPoints',
                               'EPRechargeRate', 'maxHealth', 'speed', 'strength', 'zombieState']
