from js import *
import sys

Mission_SetAttr('Campaign_Mission',0)
if sys.modules.has_key('missionobjvar'):
    print 'sk: missionobjvar already loaded; resetting mission type to skirmish for mission and object vars'
    import missionobjvar
    missionobjvar.SetFunctionsByMissionType(0)

from cshelper import *
try:
    from ffx import *
    import sysutils
    print "%s\\Missions\\Scripts\\sk.py importing FFX" % sysutils.getModFolder() ###! Ep 2008-04-19: added mod path auto-detection rather than presuming it's "ffx3"
except:
    try:
        import sysutils
        print "FATAL ERROR:"
        print "    %s\\Missions\\Scripts\\sk.py couldn't import FFX" % sysutils.getModFolder()
    except:
        print "FATAL ERROR:"
        print "    (Unknown mod)\\Missions\\Scripts\\sk.py couldn't import FFX or SysUtils"


markers = 6

# Helper funcs

def ArrowBaddie():
    baddies = getAllBaddies(checkLiving = 1)
    if len(baddies)>0:
        addArrow('arrow_'+baddies[0], baddies[0], delete = 1)
    else:
        print 'WARNING: no enemies found to arrow'

def ReviveHeroes():
    print 'revive'
    heroes = getAllHeroes()
    for hero in heroes:
        cure(hero)
        heal(hero)

def GetGroupSpawnPoint(group, count):
    return 'group'+`group`+'marker'+`count`

def GetSpawnPoint(total):
    return GetGroupSpawnPoint(int((total-1)/markers)+1, ((total-1)%markers)+1)
    
def GetEnemyName(type, wave, count):
    return '_sk' + type + `wave` + `count`

def GetStandardMarkerNames():
    return ('group1marker1', 'group1marker2', 'group1marker3', 'group1marker4', 'group1marker5', 'group1marker6','group2marker1', 'group2marker2', 'group2marker3', 'group2marker4', 'group2marker5', 'group2marker6','group3marker1', 'group3marker2', 'group3marker3', 'group3marker4', 'group3marker5', 'group3marker6','group4marker1', 'group4marker2', 'group4marker3', 'group4marker4', 'group4marker5', 'group4marker6',)

def GetTotalHeroCost():
    heroes = getAllHeroes()
    cost = 0
    for hero in heroes:
        cost = cost + Object_CalcPrestige(hero)
    return cost

# *** stumpy: fixing the energy stat and mass bugs
try:
    import sysutils
    print "%s\\Missions\\Scripts\\sk.py loaded" % sysutils.getModFolder()###! Ep 2008-04-19: added mod path auto-detection rather than presuming it's "ffx3"
except:
    print "(Unknown mod)\\Missions\\Scripts\\sk.py loaded"

import chardata
massfactors = [1.0,3.0, 2.5, 1.25, 0.75, 1.0, 0.01, 1.5, 2.5, 1.5, 1.0]
def SpawnEnemy(type, wave, markerNumber = 0, fx = ''):        
    total = int(Mission_GetAttr('total'))
    total = total + 1
    if markerNumber == 0:
        markerNumber = total
    name = GetEnemyName(type, wave, total)
    marker = GetSpawnPoint(markerNumber)
    Object_Spawn(name, type, marker)
    spawnenergy = Object_GetAttr(name,'energy')
    chdata = chardata.GetCharacterData(name)
    if chdata:
        Object_SetAttr(name,'energy',chdata['energy'])
        if chdata.has_key('mass'): # some characters (e.g. ffx_poltergeist) do not
            Object_SetAttr(name,'mass',chdata['mass']*massfactors[int(chdata['material'])])
        else:   # assume game default mass (usually 80 kg)
            Object_SetAttr(name,'mass',RPG_BASE_WEIGHT*massfactors[int(chdata['material'])])
        print 'sk.SpawnEnemy: energy for %s (%s) changed from %d to %d' % (name,chdata.get('name') or chdata.get('templateName'),spawnenergy,Object_GetAttr(name,'energy'))
    if (fx != ''):
        Object_PlayEffect(name, fx)
    regDeath(name, 'OnEnemyKilled')
    Mission_SetAttr('total', total)
    AI_SetAlerted(name, 1)
    heroes = getAllHeroes()
    for hero in heroes:
        addKillGoal(name, hero)
    ###! quick fix for mission script failing due to character having already been destroyed (?)
    #Object_SetAttr(name, 'detectradius', 1000)
    if Object_Exists(name):
        Object_SetAttr(name, 'detectradius', 1000)
    else:
        print "sk.SpawnEnemy() error:"
        print "    character '%s' doesn't exist anymore."%name

def SpawnEnemies(type, total, fx, markerList = []):
    for count in range(1, total+1):
        if markerList == []:
            markerNumber = randint(1, 24)
        else:
            markerNumber = markerList.pop(0)
        SpawnEnemy(type, int(Mission_GetAttr('wave')), markerNumber, fx)

def GenerateMarkerList(number):
    markerList = []
    for marker in range(1,number):
        markerList.insert(randint(1, number), marker)
    return markerList

def SpawnWave(wave_data, fx = 'effect_portal_mentor_spawn'):
    number = int(Mission_GetAttr('wave'))
    Mission_SetAttr('total', 0)
    markerList = GenerateMarkerList(24)
    for group in wave_data:
        type = group[0]
        total = group[1]
        SpawnEnemies(type, total, fx, markerList)
    Mission_StatusText("@DG_WAVE", (`number+1`,))

def SpawnNextWaveDelay():
    regTimer("SpawnNextWave", 3)

def SpawnNextWave(waves_data, fx = 'effect_portal_mentor_spawn'):
    wave = int(Mission_GetAttr('wave'))
    SpawnWave(waves_data[wave], fx)
    arrowNextTarget('_sk')
    Mission_SetAttr('wave', wave+1)
        
# Enemy Killed

def OnEnemyKilled(event):
    total = int(Mission_GetAttr('total'))
    total = total - 1
    Mission_SetAttr('total', total)
    arrowNextTarget('_sk', event.object)

def OnEnemyKilledWave(event, waves_data):
    OnEnemyKilled(event)
    total = int(Mission_GetAttr('total'))
    if (total == 0):
        wave = int(Mission_GetAttr('wave'))
        if (wave == len(waves_data)):
            WinMission()
            return 2
        else:
            SpawnNextWaveDelay()
            return 1
    return 0
    
def OnEnemyKilledInstantAction(event, waves_data):
    retval = OnEnemyKilledWave(event, waves_data)
    if retval:
        ReviveHeroes()

def OnEnemyKilledIronMan(event, waves_data):
    OnEnemyKilledWave(event, waves_data)

def OnEnemyKilledRace(event, waves_data):
    retval = OnEnemyKilledWave(event, waves_data)
    if retval:
        ReviveHeroes()
        AwardBonus()
    if retval == 1:
        StartBonus()

# Setup

def Setup():
    see()
    try:
        ffx.FFX_InitSkirmish()
        print "ffx3\sk.py ffx.FFX_InitSkirmish() done"
    except:
        print "ffx3\sk.py ERROR:"
        print "    cannot run ffx.FFX_InitSkirmish()"
    Event_RegisterSink(js.EVENT_MISSIONLOST, "onHeroesDead", '')
    # this needs to be based on hero prestige
    cost = GetTotalHeroCost()
    if cost < 900:
        Skirmish_AddMultiplier("hero cost", 10)
    elif cost > 90000:
        Skirmish_AddMultiplier("hero cost", 0.1)
    else:
        Skirmish_AddMultiplier("hero cost", 9000.0/cost)
    Skirmish_AddMultiplier("difficulty", 1.0+((ff.RPG_GAME_DIFFICULTY-2)*0.25))
                           
def PreSetup():
    Mission_SetAttr('total', 0)
    Mission_SetAttr('wave', 0)
    return

def SetupInstantAction(waves_data, fx = 'effect_portal_mentor_spawn'):
    PreSetup()
    Setup()
    SpawnNextWave(waves_data, fx)        

def SetupRace(waves_data, bonus_start = 10000, bonus_loss = 2500, bonus_time = 20, fx = 'effect_portal_mentor_spawn'):
    SetupInstantAction(waves_data, fx)
    Mission_SetAttr('bonus_start', bonus_start)
    Mission_SetAttr('bonus_time', bonus_time)
    Mission_SetAttr('bonus_loss', bonus_loss)
    Mission_SetAttr('ignore_bonus_timer', 0)
    StartBonus()

# Race

def StartBonus():
    bonus = int(Mission_GetAttr('bonus_start'))
    Mission_SetAttr('bonus', bonus)
    time = Mission_GetAttr('bonus_time')
    print 'set timer ' + `time`
    regTimer('OnBonusChange', time)
    Mission_StatusText("@DG_BONUS_RESET", (`bonus`,))

def AwardBonus():
    bonus = int(Mission_GetAttr('bonus'))
    if bonus>0:
        Skirmish_AddBonus("bonus", bonus)
        Mission_StatusText("@DG_BONUS_AWARD", (`bonus`,))
        ignore = Mission_GetAttr('ignore_bonus_timer')
        Mission_SetAttr('ignore_bonus_timer', ignore+1)
    
def ShowBonus(bonus):
    Mission_StatusText("@DG_BONUS_SHOW", (`bonus`,))
    
def OnBonusChange(event):
    ignore = Mission_GetAttr('ignore_bonus_timer')
    if ignore:
        Mission_SetAttr('ignore_bonus_timer', ignore-1)
        return
    bonus = int(Mission_GetAttr('bonus'))
    change = int(Mission_GetAttr('bonus_loss'))
    time = Mission_GetAttr('bonus_time')
    bonus = bonus - change
    if bonus<0:
        bonus = 0
    Mission_SetAttr('bonus', bonus)
    if bonus == 0:
        Mission_StatusText("@DG_BONUS_EXPIRED")
    else:
        ShowBonus(bonus)
        regTimer('OnBonusChange', time)
        
# Winning

def WinMission():
    play(win_cs,'Mission Won!')

win_cs = [
(
    "lookAtLastHero()",
    "Mission_StatusText('@DG_WON')",
    "wait(1.5)",
),
(
    "startCS()",
    "wait(2)",
),
(
    "endCS()",
    "Mission_Win()",
)
]
    
