from cshelper import *
from math import *

def fSkXAnglesDebug (ts):
	global gsDebug
	try:
		mbTest = gsDebug
	except:
		gsDebug = ""
	if type (ts) != StringType:
		ts = `ts`
	ts = '----------------------------------------' + ts
	if ts != gsDebug:
		print (ts)
	gsDebug = ts

def fSkXResolveAngle (tiAngle, tiMax = 360):
	miAngle = tiAngle
	while miAngle < 0:
		miAngle = miAngle + 360
	while miAngle > tiMax:
		miAngle = miAngle - tiMax
	return miAngle

def fSkXGetAngle (taPoint1, taPoint2, tsAxis = "heading"):
	if tsAxis == "z" or tsAxis == "heading":
		miX1 = taPoint1 [0]
		miY1 = taPoint1 [1]
		miX2 = taPoint2 [0]
		miY2 = taPoint2 [1]
	elif tsAxis == "x" or tsAxis == "pitch":
		miX1 = taPoint1 [1]
		miY1 = taPoint1 [2]
		miX2 = taPoint1 [1] + fSkXGetDistance (taPoint1, taPoint2, "xy")
		miY2 = taPoint2 [2]
	elif tsAxis == "y" or tsAxis == "yaw":
		miX1 = taPoint1 [0]
		miY1 = taPoint1 [2]
		miX2 = taPoint1 [0] + fSkXGetDistance (taPoint1, taPoint2, "xy")
		miY2 = taPoint2 [2]
	elif tsAxis == "xyz" or tsAxis == "3d":
		maAngles = []
		maAngles.append (fSkXGetAngle (taPoint1, taPoint2, "heading"))
		maAngles.append (fSkXGetAngle (taPoint1, taPoint2, "pitch"))
		maAngles.append (fSkXGetAngle (taPoint1, taPoint2, "yaw"))
		return maAngles
	miDX = abs (miX2 - miX1)
	miDY = abs (miY2 - miY1)
	miDistance = fSkXGetDistance ((miX1, miY1, 0), (miX2, miY2, 0))
	miDegrees = 0
	if miDistance > 0:
		miRadian = acos (miDX / miDistance)
		miDegrees = fSkXGetDegreesFromRadians (miRadian)
		if abs (miY2 - miY1) < 1:
			#fSkXAnglesDebug ('90 or 270:' + `abs (miY2 - miY1)`, 1)
			if miX2 > miX1:
				miDegrees = 90
			elif miX2 < miX1:
				miDegrees = 360 - 90
		elif abs (miX2 - miX1) < 1:
			#fSkXAnglesDebug ('0 or 180:' + `abs (miX2 - miX1)`, 1)
			if miY2 > miY1:
				miDegrees = 0
			elif miY2 < miY1:
				miDegrees = 180
		else:
			if miY2 > miY1 and miX2 > miX1:
				#q1
				#fSkXAnglesDebug ('quadrant1')
				miDegrees = 90 - miDegrees
			elif miY2 < miY1 and miX2 > miX1:
				#q2
				#fSkXAnglesDebug ('quadrant2')
				miDegrees = 90 + miDegrees
			elif miY2 < miY1 and miX2 < miX1:
				#q3
				#fSkXAnglesDebug ('quadrant3')
				miDegrees = 270 - miDegrees
			elif miY2 > miY1 and miX2 < miX1:
				#q4
				#fSkXAnglesDebug ('quadrant4')
				miDegrees = miDegrees + 270
	return miDegrees

def fSkXGetDistance (taPoint1, taPoint2, tsPlane = "heading"):
	if tsPlane == "xy" or tsPlane == "heading":
		miX1 = taPoint1 [0]
		miY1 = taPoint1 [1]
		miX2 = taPoint2 [0]
		miY2 = taPoint2 [1]
	elif tsPlane == "yz" or tsPlane == "pitch":
		miX1 = taPoint1 [1]
		miY1 = taPoint1 [2]
		miX2 = taPoint2 [1]
		miY2 = taPoint2 [2]
	elif tsPlane == "xz" or tsPlane == "yaw":
		miX1 = taPoint1 [0]
		miY1 = taPoint1 [2]
		miX2 = taPoint2 [0]
		miY2 = taPoint2 [2]
	elif tsPlane == "3d":
		maDs = []
		maDs.append (fSkXGetDistance (taPoint1, taPoint2, "xy"))
		maDs.append (fSkXGetDistance (taPoint1, taPoint2, "yz"))
		maDs.append (fSkXGetDistance (taPoint1, taPoint2, "xz"))
		return maDs
	elif tsPlane == "xyz" or tsPlane == "actual":
		miX1 = 0
		miY1 = taPoint1 [2]
		miX2 = fSkXGetDistance (taPoint1, taPoint2)
		miY2 = taPoint2 [2]
	miDX = miX2 - miX1
	miDY = miY2 - miY1
	miDistance = sqrt (miDX * miDX + miDY * miDY)
	return miDistance

def fSkXGetPointInBetween (taPoint1, taPoint2):
	miX1 = taPoint1 [0]
	miY1 = taPoint1 [1]
	miZ1 = taPoint1 [2]
	miX2 = taPoint2 [0]
	miY2 = taPoint2 [1]
	miZ2 = taPoint2 [2]
	miXMid = miX1 + (miX2 - miX1) / 2
	miYMid = miY1 + (miY2 - miY1) / 2
	miZMid = miZ1 + (miZ2 - miZ1) / 2
	mtPoint = (miXMid, miYMid, miZMid)
	return mtPoint

def fSkXGetDegreesFromRadians (tiRadian):
	miDegrees = 180 * tiRadian / pi
	return miDegrees

def fSkXGetRadiansFromDegrees (tiDegrees):
	miRadian = pi * tiDegrees / 180
	return miRadian

def fSkXGetPointFromVector (taPoint, tiAngle, tiDistance, tsAxis = "heading"):
	if tsAxis == "z" or tsAxis == "heading":
		mx = taPoint [0]
		my = taPoint [1]
		miz = taPoint [2]
	elif tsAxis == "x" or tsAxis == "pitch":
		mx = taPoint [1]
		my = taPoint [2]
		miz = taPoint [0]
	elif tsAxis == "y" or tsAxis == "yaw":
		mx = taPoint [0]
		my = taPoint [2]
		miz = taPoint [1]
	elif tsAxis == "xyz" or tsAxis == "3d":
		mt = fSkXGetPointFromVector (taPoint, tiAngle [0], tiDistance [0], "heading")
		mt2 = (mt [0], 0, mt [2])
		mt3 = fSkXGetPointFromVector (mt2, tiAngle [1], tiDistance [1], "pitch")
		mt4 = (mt3 [0], mt [1], mt3 [2])
		return mt4
	while tiAngle < 360:
		tiAngle = tiAngle + 360
	while tiAngle > 360:
		tiAngle = tiAngle - 360
	#SOHCAHTOA
	#cos = adjacent / hypothenuse
	#adjacent = cos * hypothenuse
	#sin = opposite / hypothenuse
	#opposite = sin * hypothenuse
	mA = 0
	mO = 0

	if tiAngle == 0 or tiAngle == 360:
		mx2 = mx
		my2 = my + tiDistance
	elif tiAngle < 90:
		mA = cos (fSkXGetRadiansFromDegrees (90 - tiAngle)) * tiDistance
		mx2 = mx + mA
		mO = sin (fSkXGetRadiansFromDegrees (90 - tiAngle)) * tiDistance
		my2 = my + mO
	elif tiAngle == 90:
		mx2 = mx + tiDistance
		my2 = my
	elif tiAngle > 90 and tiAngle < 180:
		mA = cos (fSkXGetRadiansFromDegrees (tiAngle - 90)) * tiDistance
		mx2 = mx + mA
		mO = sin (fSkXGetRadiansFromDegrees (tiAngle - 90)) * tiDistance
		my2 = my - mO
	elif tiAngle == 180:
		mx2 = mx
		my2 = my - tiDistance
	elif tiAngle > 180 and tiAngle < 270:
		mA = cos (fSkXGetRadiansFromDegrees (270 - tiAngle)) * tiDistance
		mx2 = mx - mA
		mO = sin (fSkXGetRadiansFromDegrees (270 - tiAngle)) * tiDistance
		my2 = my - mO
	elif tiAngle == 270:
		mx2 = mx - tiDistance
		my2 = my
	elif tiAngle > 270 and tiAngle < 360:
		mA = cos (fSkXGetRadiansFromDegrees (tiAngle - 270)) * tiDistance
		mx2 = mx - mA
		mO = sin (fSkXGetRadiansFromDegrees (tiAngle - 270)) * tiDistance
		my2 = my + mO

	if tsAxis == "z" or tsAxis == "heading":
		mtPoint = (mx2, my2, miz)
	elif tsAxis == "x" or tsAxis == "pitch":
		mtPoint = (miz, mx2, my2)
	elif tsAxis == "y" or tsAxis == "yaw":
		mtPoint = (mx2, miz, my2)
	return mtPoint

def fSkXGetIntersectionFromPoints (taPoint1, taPoint2, taPoint3, taPoint4):
	#y1=m1x1+b1 = y2=m2x2+b2
	#m1x + b1 = m2x + b2
	#m1x - m2x = b2 - b1
	#x * (m1 - m2) = b2 - b1
	#x = (b2 - b1) / (m1 - m2)
	#x = (y - b) / m
# 	if taPoint1 [0] == taPoint2 [0]:
# 		taPoint2 = (taPoint2 [0] + 0.1, taPoint2 [1], taPoint2 [2])
	maMB1 = fSkXEmxPbGetMB (taPoint1, taPoint2)
	miM1 = maMB1 [0]
	miB1 = maMB1 [1]
	miX1 = taPoint1 [0]
	maMB2 = fSkXEmxPbGetMB (taPoint3, taPoint4)
	miM2 = maMB2 [0]
	miB2 = maMB2 [1]
	miX2 = taPoint3 [0]
# 	print "x:"+`miX1`+",m:"+`miM1`+",b:"+`miB1`
# 	print "x2:"+`miX2`+",m2:"+`miM2`+",b2:"+`miB2`
	if miM1 == miM2:#parallel
		miX = taPoint1 [0]
		miY = taPoint1 [1]
		miZ = taPoint1 [2]
	elif miM1 != miM2:
		miX = (miB2 - miB1) / float (miM1 - miM2)
		miY = miM1 * miX + miB1
		miZ1 = fSkXGetPointInBetween (taPoint1, taPoint2)
		miZ2 = fSkXGetPointInBetween (taPoint3, taPoint4)
		miZ = fSkXGetPointInBetween (miZ1, miZ2) [2]
	return (miX, miY, miZ)

def fSkXEmxPbGetMB (taPoint1, taPoint2):
	#m = rise over run
	#m = y delta / x delta
	#y = mx + b
	#b = y - mx
	maMB = []
	if taPoint1 [0] == taPoint2 [0]:
		taPoint2 = (taPoint2 [0] + 0.1, taPoint2 [1], taPoint2 [2])
	miM = (taPoint2 [1] - taPoint1 [1]) / float (taPoint2 [0] - taPoint1 [0])
	miB = taPoint1 [1] - miM * taPoint1 [0]
	maMB = [miM, miB]
	return maMB

def fSkXEmxPb (taPoint1, taPoint2, tiX = '', tiY = ''):
	if taPoint1 [0] == taPoint2 [0]:
		taPoint2 = (taPoint2 [0] + 0.1, taPoint2 [1], taPoint2 [2])
	miM = (taPoint2 [1] - taPoint1 [1]) / (taPoint2 [0] - taPoint1 [0])
	#y = mx + b
	#b = y - mx
	miB = taPoint1 [1] - miM * taPoint1 [0]
	miX = tiX
	miY = tiY
	if miX == '':
		#y = mx + b
		#mx = y - b
		#x = (y - b) / m
		miX = (miY - miB) / miM
	elif miY == '':
		miY = (miM * miX) + miB
	miZ = fSkXGetPointInBetween (taPoint1, taPoint2) [2]
	return [miX, miY, miZ]

def fSkXGetAngleOfSegment (tiTotal, tiSegment, tiAngle = 360):
	miAngle = 0
	if tiTotal > 1:
		miAngle = tiAngle / tiTotal * tiSegment
	else:
		miAngle = randint (0, tiAngle - 1)
	return fSkXResolveAngle (miAngle)

def fSkXGetQuadrantOfPointFromPoint (ttPos, ttPos2):
	#	4	|	1
	#	---------
	#	3	|	2
	miA = fSkXGetAngle (ttPos2, ttPos)
	miQuad = 0
	if miA > 0 and miA <= 90: miQuad = 1
	elif miA > 90 and miA <= 180: miQuad = 2
	elif miA > 180 and miA <= 270: miQuad = 3
	elif miA > 270 and miA <= 360: miQuad = 4
	return miQuad

def fSkXGetNearestSideToPoint (ttPos, ttBoundingBox):
	#bounding box = (minx, miny, minz, maxx, maxy, maxz)
	#			1
	#		---------
	#	4	|		|	2
	#		---------
	#			3
	mtNW = (ttBoundingBox [0], ttBoundingBox [1], ttBoundingBox [2])
	mtNE = (ttBoundingBox [3], ttBoundingBox [1], ttBoundingBox [2])
	mtSE = (ttBoundingBox [3], ttBoundingBox [4], ttBoundingBox [2])
	mtSW = (ttBoundingBox [0], ttBoundingBox [4], ttBoundingBox [2])
	mtMid = fSkXGetPointInBetween (mtNW, mtSE)
	miNWA = fSkXGetAngle (mtMid, mtNW)
	miNEA = fSkXGetAngle (mtMid, mtNE)
	miSEA = fSkXGetAngle (mtMid, mtSE)
	miSWA = fSkXGetAngle (mtMid, mtSW)
	miA = fSkXGetAngle (mtMid, ttPos)
	if miA > miNWA or miA <= miNEA: miSide = 1
	elif miA > miNEA and miA <= miSEA: miSide = 2
	elif miA > miSEA and miA <= miSWA: miSide = 3
	elif miA > miSWA and miA <= miNWA: miSide = 4
	return miSide
fSkXGetClosestSideToPoint = fSkXGetNearestSideToPoint

def fSkXSubtractAngles (tiA, tiA2):
	miSub = abs (tiA2 - tiA)
	miA = min (miSub, 360 - miSub)
	return miA
fSkXSubAngles = fSkXSubtractAngles

def fSkXAddAngles (tiA, tiA2):
	return fSkXResolveAngle (tiA + tiA2)
