#####################################################################################
#
# Module: mission.py for freeroam mods
# Author: m25
#
#  IMPORTANT: THE MISSION.PY AND BASE.PY FILES MUST BE THE SAME FOR FREEROAM TO WORK CORRECTLY
#
#####################################################################################

import m25startup
from m25startup import *

# what is the name of the story (the text file) that the mod uses
freeroam_storyfile='freeroam'

# who will the player be able to recruit from at the start of the mod
# built-ins only.  
# the player can still recruit any customs they want
freeroam_addbuiltins=['alchemiss', 'blackbird', 'bullet', 'el_diablo', 'eve', 
	'green_genie', 'ironox', 'man_bot', 'man_o_war', 'microwave', 'minute_man', 
	'liberty_lad', 'order', 'quetzalcoatl', 'sea_urchin', 'tombstone']
	
# How much prestige will the player have to recruit characters
freeroam_startingprestige=11000

# what map does the mod start on
freeroam_startingmap = 'fortressbase'


#------------------------------------------------------------------
#
# Important functions.  Do not modify.
#
#------------------------------------------------------------------


def OnPrecacheObjects():
	m25startup.Startup_Precache(freeroam_storyfile)

def OnPostInit():
	global freeroam_addbuiltins
	global freeroam_startingprestige
	m25startup.Startup_CheckInit(freeroam_addbuiltins, freeroam_startingprestige, freeroam_startingmap)
	
def OnBriefing():
	m25startup.Startup_OnBriefing()
