#####################################################################################
#
# Module: m25skirmishmode
# Author: m25
# 
# Description: Allow for team battles, buddy matches and watch mode within the FFvTTR Rumble Room
#
#
# Version 1
# Date: April 5, 2005
#
#####################################################################################
# Version 1.1   Date: February 7, 2006
#
# Added Stumpy's code to apply fix for area melee powers' range. It Checks all hero files and built-ins
# for any area melee powers that don't have a minRange of 0 and maxRange of 2 and changes them to
# those ranges. You must quit out of the game and reload for the changes to take effect.
#
#####################################################################################

import sk
from sk import *
import m25ai
import m25missionover
import m25distance
import m25getset
import m25report
import cshelper
from m25ai import *
import m25event

import m25generateai
from m25generateai import *
from ChangeAreaMeleeRanges import *

#-------------------------------------------------------------------------------------
#
# Number of characters allowed in the skirmish.
#
#-------------------------------------------------------------------------------------
WATCH_MAXCHARS = 24

occupied = []
for i in range(WATCH_MAXCHARS):
	occupied.append(0)

allchars = []	
	
	
#-------------------------------------------------------------------------------------
#
# Callbacks
#
#-------------------------------------------------------------------------------------
	
def OnPostInit():
	#let the player see the entire level
	cshelper.see()
	
	# initialize the AI
	m25ai.InitScripts()
	m25ai.AIDisableAll()
	m25missionover.SetMissionOver()
	
	heroes = cshelper.getAllHeroes()
	for h in heroes:
		allchars.append(h)
	
	# generate the ai for all heroes and enemies within the rumble room
	m25event.SetTimer(1,'Create_AI')
	#m25generateai.GenerateAIFile(allchars)
	#js.Mission_StatusText('Finished creating custom AIs.  Have fun with them.')
	#m25event.SetTimer(5,'End_Create')
        ChangeAreaMeleeRanges_BuiltIn(minRange=0,maxRange=2)
        ChangeAreaMeleeRanges_AllCustoms(minRange=0,maxRange=2)

def Create_AI(event):
	global allchars
	js.Mission_StatusText('Creating custom AIs...')
	m25generateai.GenerateAIFile(allchars)	
	#js.Mission_StatusText('Finished creating custom AIs.  Have fun with them.')
	#m25event.SetTimer(5,'End_Create')
	
def End_Create(event):
	Mission_Win()
	
def OnReceiveSelectedEnemies(enemies):
	sk.PreSetup()
	for enemy in enemies:
		SkirmishSpawnEnemy(enemy)
                   
def OnSelectionRequiredCheck():
	return 1 #disallows players to choose their opponents

def OnNumEnemiesCheck():
	return WATCH_MAXCHARS

def OnGameTypeCheck():
	#return ('skirmishspawn',)
    return sk.GetStandardMarkerNames()


#-------------------------------------------------------------------------------------
#
# Spawn the characters the player has selected
#
#-------------------------------------------------------------------------------------	
	
def SkirmishSpawnEnemy(template):
	count = m25getset.GetMissionVar('count',integer=1,default=0) + 1
	m25getset.SetMissionVar('count',count)
	name = template + `count`
	marker = GetSpawnPoint(FindLoc())
	pos = Get_MarkerPos(marker)
	Object_SpawnAt(template, pos, name)
	allchars.append(name)

def FindLoc():
	global occupied
	total = len(occupied)-1
	i = randint(0,total)
	if occupied[i] == 1:
		found = 0
		while not (found==1):
			i = i + 1
			if i > total:
				i = 0
			if occupied[i] == 0:
				found = 1
	occupied[i] = 1
	return i+1	