#####################################################################################
#
# Module: Power ID Generator
# Author: Dr Mike
# 
# Description: Generates PowerIDs and writes out ffxpowerids.py
#
# Version 1
# Date: June 20, 2005
#
#####################################################################################

import sk
from sk import *
import m25ai
import m25missionover
import m25distance
import m25getset
import m25report
import cshelper
from m25ai import *
import m25event
from ffx import *

#-------------------------------------------------------------------------------------
#
# Callbacks
#
#-------------------------------------------------------------------------------------
	
def OnPostInit():
	#let the player see the entire level
	cshelper.see()
	FFX_InitSkirmish()

	# initialize the AI
	m25ai.InitScripts()
	m25ai.AIDisableAll()
	m25missionover.SetMissionOver()
	Mission_StatusText("Generating Power IDs for builtin characters");
	RegTimer('Create_PowerIDs',1)

def Create_PowerIDs(event):
	generatePowerIDs()
		
def OnReceiveSelectedEnemies(enemies):
	sk.PreSetup()
	for enemy in enemies:
		SkirmishSpawnEnemy(enemy)

def OnSelectionRequiredCheck():
	return 0 #disallows players to choose their opponents

def OnNumEnemiesCheck():
	return WATCH_MAXCHARS

def OnGameTypeCheck():
    return sk.GetStandardMarkerNames()


#-------------------------------------------------------------------------------------
#
# Spawn the characters the player has selected
#
#-------------------------------------------------------------------------------------	
	
def SkirmishSpawnEnemy(template):
	count = m25getset.GetMissionVar('count',integer=1,default=0) + 1
	m25getset.SetMissionVar('count',count)
	name = template + `count`
	marker = GetSpawnPoint(FindLoc())
	pos = Get_MarkerPos(marker)
	Object_SpawnAt(template, pos, name)
	allchars.append(name)

def FindLoc():
	global occupied
	total = len(occupied)-1
	i = randint(0,total)
	if occupied[i] == 1:
		found = 0
		while not (found==1):
			i = i + 1
			if i > total:
				i = 0
			if occupied[i] == 0:
				found = 1
	occupied[i] = 1
	return i+1	