#####################################################################################
#
# Module: m25skirmishteammode
# Author: m25
# 
# Description: Allow for team battles and buddy matches  within the FFvTTR Rumble Room
#
#
# Version 1
# Date: April 8, 2005
#
#####################################################################################

import sk
from sk import *
import m25ai
import cshelper
from m25ai import *
import m25skirmish
from m25skirmish import *
import ffx
from ffx import *


#-------------------------------------------------------------------------------------
#
# Callbacks
#
#-------------------------------------------------------------------------------------
	
def OnPostInit():
	#let the player see the entire level
	cshelper.see()
	
	# initialize the AI
	m25ai.InitScripts()
	
	#used to start up FFX
	ffx.FFX_InitSkirmish(1)
	
	# check for any characters that already exist on the map (put there by the map-maker)
	m25skirmish.SetupPreexisting()
	
	# put the heroes on the appropriate teams (or set them as neutral if watch mode)
	m25skirmish.SetupHeroTeam()
	
	# give the teams their orders
	m25skirmish.SetupGroups()
	
	# setup hero AI toggles
	#m25skirmish.SetupHeroAIToggles()

	#set up polling loop for the end of the battle
	regTimer('SkirmishModeCheckEnd',1)
	
def OnReceiveSelectedEnemies(enemies):
	sk.PreSetup()
	for enemy in enemies:
		m25skirmish.SkirmishSpawnEnemy(enemy)
                   
def OnSelectionRequiredCheck():
	return 1 #allows players to choose their opponents

def OnNumEnemiesCheck():
	return m25skirmish.WATCH_MAXCHARS

def OnGameTypeCheck():
    return sk.GetStandardMarkerNames()
