#####################################################################################
#
# Module: Mini Mod Caption Generator
# Author: m25
# 
# Description: Generate captions for all stories in the stories directory.
#  Hopefully, this will make it easier for people to see the full 
#  effect of EZ script missions.
#
#
#
#####################################################################################



#Change this to the name of the story file you want to use
minimod_storyfile = 'test'


#---------------------------------------------------------

import m25minimod
from m25minimod import *
import m25pstory
import m25event

import datfiles
import os

import js

gen_storyfiles = []

def OnPrecacheObjects():
	m25pstory.PSTORY_WRITE_CAPTIONS = 1
	
def OnPostInit():
	global gen_storyfiles
	js.Mission_StatusText('Generating captions for:')
	dirname = datfiles.GetModPath()+'\\stories'
	try:
		gen_storyfiles = os.listdir(dirname)
	except:
		js.Mission_StatusText('You do not have a story directory!')
		Mission_Win()
		return
	m25event.SetTimer(0.1,'GenCaptions_GenLoop')
				
				
# I made this into an event loop so that StatusText messages appear on the screen
# and the user can see progress.
def GenCaptions_GenLoop(event):
	global gen_storyfiles
	if gen_storyfiles == []: 
		js.Mission_StatusText('Captions completed.  Please generate your language files using ffedit.')
		m25event.SetTimer(1,'GenCaptions_End')
	else:
		GenCaptions_MakeCaptions(gen_storyfiles.pop())
		m25event.SetTimer(0.5,'GenCaptions_GenLoop')
	
def GenCaptions_MakeCaptions(story):
	if story[-4:] != '.txt': return
	js.Mission_StatusText('- %s'%(story[:-4]))
	m25pstory.PStory_ResetCaptions()
	m25pstory.PStory_MakeStoryFromFile(story[:-4])
	
def GenCaptions_End(event):
	Mission_Win()


def OnSelectionRequiredCheck():	
	#change this to 1 to allow the player to select enemies, 0 (zero) to disallow
	return 0

def OnNumEnemiesCheck():
	#change this number to the number of enemies the player is allowed to select
	return 24

def OnGameTypeCheck():
	#set this list to the markers required for your mini-mod
	#leave it as is for most mods
	return ('encounter1',)


