
import ffx
from ffx import *


FFX_CHARACTER=OC_CHARACTER

#################### explosive tangle swap ##############################################
# Swaps with Primary or Secondary State and places a lock on the target for a few seconds
# and then triggers an explosion at the target.
# -TaskmasterX
#########################################################################################


def stuntoetangle(event):
    eTangleP(event,PCSTATE_STUNNED,1)
def hypnosistoetangle(event):
    eTangleS(event,PCSTATE_HYPNOTISED,ffx.COST_HYPNO)
def ragetoetangle(event):
    eTangleS(event,PCSTATE_ENRAGED,ffx.COST_RAGE)
def exiletoetangle(event):
    eTangleS(event,PCSTATE_EXILE,ffx.COST_EXILE)
def blanktoetangle(event):
    eTangleS(event,PCSTATE_BLANK,ffx.COST_BLANK)
def panictoetangle(event):
    eTangleS(event,PCSTATE_PANICKED,ffx.COST_PANIC)
def stasistoetangle(event):
    eTangleP(event,PCSTATE_STATIC,ffx.COST_STASIS)
def frozentoetangle(event):
    eTangleP(event,PCSTATE_FROZEN,ffx.COST_FROZEN)

def hextoetangle(event):
    eTangleS(event,SCSTATE_HEXED,ffx.COST_HEX)
def blindtoetangle(event):
    eTangleS(event,SCSTATE_BLIND,ffx.COST_BLIND)
def powernulltoetangle(event):
    eTangleS(event,SCSTATE_POWER_NULLIFICATION,ffx.COST_NULL)
def weakentoetangle(event):
    eTangleS(event,SCSTATE_WEAKENED,ffx.COST_WEAKEN)
def speeddecreasetoetangle(event):
    eTangleS(event,SCSTATE_SPEED_DECREASED,ffx.COST_DECREASE)
def speedincreasetoetangle(event):
    eTangleS(event,SCSTATE_SPEED_INCREASED,ffx.COST_INCREASE)

def energisetoetangle(event):
    char=event.object
    source=event.string
    intensity=ffx.COST_ENERGYSURGE
    if Object_GetSecondaryStates(char)&SCSTATE_ENERGIZED:
        Object_SetSecondaryState(char,SCSTATE_ENERGIZED,0,REMOVE_STATE)
        ffx.FFX_ObjectSetAttr(char, 'fx_eTangleWire',0)
        ffx.FFX_UpdateStates(char)
        eTangleStartADCheck(char, source)
    else:
        ffx.RegTimer('energizeSwapCancel',1,0,char,source)

def energysurgetoetangle(event):
    char=event.object
    source=event.string
    intensity=ffx.COST_ENERGYSURGE
    if Object_GetSecondaryStates(char)&SCSTATE_AREA_ENERGIZED:
        Object_SetSecondaryState(char,SCSTATE_AREA_ENERGIZED,0,REMOVE_STATE)
        ffx.FFX_ObjectSetAttr(char, 'fx_eTangleWire',0)
        ffx.FFX_UpdateStates(char)
        eTangleStartADCheck(char, source)
    else:
        ffx.RegTimer('energizeSwapCancel',1,0,char,source)

def densitytoetangle(event):
    char=event.object
    source=event.string
    intensity=ffx.COST_DENSITY
    if ffx.densityaltered(char):
        ffx.FFX_ObjectSetAttr(char, 'fx_eTangleWire',0)
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        ffx.FFX_UpdateStates(char)
        eTangleStartADCheck(char, source)

def eTangleP(event,state,intensity):
    char=event.object
    source=event.string
    if state==PCSTATE_STATIC:
        ffx.FFX_ObjectSetAttr(char,'eTangleMystic',1)
        ffx.FFX_ObjectSetAttr(char,'stasiseTangle',1)
    if state==PCSTATE_DIMENSION_SHIFT:
        ffx.FFX_ObjectSetAttr(char,'eTangleMystic',1)
    if state==PCSTATE_HYPNOTISED:
        ffx.FFX_ObjectSetAttr(char,'eTangleMental',1)
    if state==PCSTATE_ENRAGED:
        ffx.FFX_ObjectSetAttr(char,'eTangleMental',1)
    if state==PCSTATE_BLANK:
        ffx.FFX_ObjectSetAttr(char,'eTangleMental',1)
    if state==PCSTATE_PANICKED:
        ffx.FFX_ObjectSetAttr(char,'eTangleMental',1)
    if state==PCSTATE_FROZEN:
        ffx.FFX_ObjectSetAttr(char,'eTangleCold',1)
    if Object_GetPrimaryState(char)==state:
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        ffx.FFX_UpdateStates(char)
        ffx.FFX_ObjectSetAttr(char,'fx_eTangleWire',0)
        eTangleStartADCheck(char, source)

def eTangleS(event,state,intensity):
    char=event.object
    source=event.string
    if state==SCSTATE_HEXED:
        ffx.FFX_ObjectSetAttr(char,'eTangleMystic',1)
    if state==SCSTATE_BLIND:
        ffx.FFX_ObjectSetAttr(char,'eTangleMystic',1)
    if state==SCSTATE_WEAKENED:
        ffx.FFX_ObjectSetAttr(char,'eTangleMental',1)
    if state==SCSTATE_POWER_NULLIFICATION:
        ffx.FFX_ObjectSetAttr(char,'eTangleMental',1)
    if Object_GetSecondaryStates(char)&state:
        ffx.FFX_ObjectSetAttr(char,'fx_eTangleWire',0)
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        ffx.FFX_UpdateStates(char)
        eTangleStartADCheck(char, source)

def eTangleStartADCheck(char, source):
    if ffx.FFX_ObjectGetAttr(char,'eTangled',0)==1:
        return
    if (ffx.FFX_ObjectGetAttr(char,'eTangleMental')==0) & (ffx.FFX_ObjectGetAttr(char,'eTangleMystic')==0) & (ffx.FFX_ObjectGetAttr(char,'eTangleEnergy')==0):
        ffx.FFX_ObjectSetAttr(char,'eTanglePhysical',1)
        damage_type = m25ai.ai_damage_type['crushing']
        damage_mode = m25ai.ai_damage_mode['ranged']
        if ffx.FFX_ObjectGetAttr(char,'ffactivedefense')==1:
            if ffx.FFX_ObjectGetAttr(char,'ffactivedefenseSelf',0)==0:
                FFX_crushTest1c(char,source)
                return
            power=ffx.getByTemplate(char,FFX_FFACTIVEDEFENSE_CUSTOM,3)
            powdata = datfiles.Campaign_ReadPowers()[power]
            if powdata['PowerType'] == datfiles.PT_ACTIVE_DEFENCE:
                if ( powdata['DamageTypesBlocked'] & damage_type ) and \
                ( powdata['AttackModesBlocked'] & damage_mode ):
                    m25getset.GetObjectVar(char, 'defense ' + `damage_type` + '_' + `damage_mode`, 1,nosave=1)
                    return
        if ffx.FFX_HasPortrait(char):
            if not m25ai.AIInWatch(char):
                FFX_crushTest1c(char,source)
                return
        if m25ai.HasActiveDefenceActive(char,damage_type,damage_mode):
            return
        if ffx.FFX_ObjectGetAttr(char,'phased_out',0)==1:
            return
    eTangleStart(char, source)

def FFX_crushTest1c(char,source):
    name=ffx.getDummyName()
    Object_SpawnAt('ffx_tiggot',Get_ObjectPos(source),name)
    Trigger_Power(name,char,'ffx_ranged_crush_test','',10)
    flying=mlogreader.MLOG_IsFlying(char)
    if flying:
        ffx.FFX_ObjectSetAttr(char, 'eTangle_flier', 1)
    ffx.FFX_ObjectSetAttr(char,'eTangleCrushTest',1)
    ffx.FFX_ObjectSetAttr(char,'crushTestC',1)
    ffx.FFX_ObjectSetAttr(source,'crushTestC',1)
    ffx.RegCharState(char,PCSTATE_STUNNED,'FFX_crushTest2c',0,0,source)
    ffx.RegTimer('FFX_crushTest3c',2,0,char,source)
    ffx.RegTimer('ffx.destroyTemp',3,0,name)

def FFX_crushTest2c(event):
    char=event.object
    source=event.string
    if ffx.FFX_ObjectGetAttr(char,'crushTestC',0)==1:
        if ffx.FFX_ObjectGetAttr(source,'crushTestC',0)==1:
            ffx.FFX_ObjectSetAttr(source,'crushTestC',0)
            Object_SetPrimaryState(char,PCSTATE_STUNNED,0,REMOVE_STATE)
            tangleFX=ffx.getByTemplate(source,FFX_EXPLOSIVETANGLE_CUSTOM,2)
            handle=Object_PlayEffect(char,tangleFX,'',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'centre')
            ffx.FFX_ObjectSetAttr(char,'eTangle_handle',handle)
            if ffx.FFX_ObjectGetAttr(char,'eTangle_flier',0)==1:
                if eTangleBreakCheck(char,source):
                    handle=ffx.FFX_ObjectGetAttr(char,'eTangle_handle')
                    Object_StopEffect(char,handle)
                    ffx.FFX_ObjectSetAttr(char,'eTangleBreak',1)
                    ffx.FFX_ObjectSetAttr(char,'eTangle_flier',0)
                else:
                    Trigger_Force(char,0,0,1,Object_GetAttr(char,'mass')*100,TF_ABSOLUTE)
                    ffx.RegTimer('eTangleStartEvent',0.2,0,char,source)
            else:
                if eTangleBreakCheck(char,source):
                    handle=ffx.FFX_ObjectGetAttr(char,'eTangle_handle')
                    Object_StopEffect(char,handle)
                    ffx.FFX_ObjectSetAttr(char,'eTangleBreak',1)
                else:
                    AI_Animate(char,'pain')
                    ffx.RegTimer('eTangleStartEvent',0.2,0,char,source)
    ffx.FFX_ObjectSetAttr(char,'crushTestC',0)

def FFX_crushTest3c(event):
    char=event.object
    source=event.string
    ffx.FFX_ObjectSetAttr(source,'crushTestC',0)
    if ffx.FFX_ObjectGetAttr(char,'eTangleBreak',0)==1:
        if ffx.FFX_ObjectGetAttr(char,'eTangleMystic',0)==1:
            AI_Animate(char,'recover_from_stun')
        elif ffx.FFX_ObjectGetAttr(char,'eTangleMental',0)==1:
            AI_Animate(char,'recover_from_stun')
        else:
            AI_Animate(char,'swing_pole')
        ffx.FFX_ObjectSetAttr(char,'eTangleBreak',0)
    if ffx.FFX_ObjectGetAttr(char,'eTangled',0)==1:
        flailing=mlogreader.MLOG_IsFlailing(char)
        if not flailing:
            AI_Animate(char,'pain')

def eTangleStartEvent(event):
    char=event.object
    source=event.string
    if Object_IsAlive(char)==0:
        return
    if ffx.FFX_ObjectGetAttr(char,'eTangled',0)==1:
        return
    ffx.FFX_ObjectSetAttr(char,'eTangled',1)
    tangledAgl=Object_GetAttr(char,'agility')-3
    ffx.FFX_ObjectSetAttr(char,'baseAgility',Object_GetAttr(char,'agility'))
    Object_SetAttr(char,'energy',0)
    Object_SetAttr(char,'agility',tangledAgl)
    hasPortrait=ffx.FFX_HasPortrait(char)
    pcAIEnabled=m25ai.AIInWatch(char)
    if pcAIEnabled or not hasPortrait:
        m25ai.AIDisable(char)
    if ffx.FFX_ObjectGetAttr(char, 'stasiseTangle') == 1:
        ffx.RegTimer('makeeTangleFlyer', 0.2, 0, char, source)
        ffx.FFX_ObjectSetAttr(char, 'eTangle_flier', 1)
        return
    ffx.RegTimer('makeeTangled',0.2,0,char,source)
    ffx.RegTimer('eTangleLock',0.1,0,char)

def eTangleStart(char, source):
    if Object_IsAlive(char)==0:
        return
    if ffx.FFX_ObjectGetAttr(char,'eTangled',0)==1:
        return
    flying=mlogreader.MLOG_IsFlying(char)
    if flying:
        ffx.FFX_ObjectSetAttr(char, 'eTangle_flier', 1)
    tangleFX=ffx.getByTemplate(source,FFX_EXPLOSIVETANGLE_CUSTOM,2)
    handle=Object_PlayEffect(char,tangleFX,'',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'centre')
    ffx.FFX_ObjectSetAttr(char,'eTangle_handle',handle)
    if eTangleBreakCheck(char,source):
        handle=ffx.FFX_ObjectGetAttr(char,'eTangle_handle')
        Object_StopEffect(char,handle)
        ffx.FFX_ObjectSetAttr(char,'eTangleBreak',1)
    else:
        ffx.FFX_ObjectSetAttr(char,'eTangled',1)
        hasPortrait=ffx.FFX_HasPortrait(char)
        pcAIEnabled=m25ai.AIInWatch(char)
        if pcAIEnabled or not hasPortrait:
            m25ai.AIDisable(char)
    ffx.RegTimer('eTangleStart2',0.5,0,char,source)

def eTangleStart2(event):
    char=event.object
    source=event.string
    if Object_IsAlive(char)==0:
        ffx.FFX_ObjectSetAttr(char,'eTangled',0)
        ffx.RegTimer('uneTangleBreak',1,0,char)
        return
    flailing=mlogreader.MLOG_IsFlailing(char)
    if ffx.FFX_ObjectGetAttr(char,'eTangle_flier',0)==1:
        if ffx.FFX_ObjectGetAttr(char,'eTangleBreak',0)==0:
            Trigger_Force(char,0,0,1,Object_GetAttr(char,'mass')*100,TF_ABSOLUTE)
            ffx.RegTimer('eTangle',0.7,0,char,source)
            ffx.RegTimer('eTangleLock',0.4,0,char)
            return
        else:
            ffx.FFX_ObjectSetAttr(char, 'eTangle_flier', 0)
    #if target is already flailing from another attack when hit by the tangle...
    elif flailing:
        ffx.RegTimer('makeeTangleFlyer',0.5,0,char,source)
        ffx.FFX_ObjectSetAttr(char,'eTangle_flier',1)
    else:
        if ffx.FFX_ObjectGetAttr(char,'eTangleBreak',0)==0:
            AI_Animate(char,'pain')
    ffx.RegTimer('eTangle',0.4,0,char,source)
    ffx.RegTimer('eTangleLock',0.1,0,char)

def eTangleLock(event):
    char=event.object
    flailing=mlogreader.MLOG_IsFlailing(char)
    flying=mlogreader.MLOG_IsFlying(char)
    if ffx.FFX_ObjectGetAttr(char,'eTangled',0)==0:
        if flailing:
            mlogreader.regGetupStop(char,'eTangleRecover',0,0,0)
        elif ffx.FFX_ObjectGetAttr(char,'eTangleExplode',0)==1:
            ffx.RegTimer('eTangleLock',0.5,0,char)
            ffx.FFX_ObjectSetAttr(char,'eTangleExplode',0)
            return
        elif ffx.FFX_ObjectGetAttr(char,'eTangle_flier',0)==1:
            if ffx.FFX_ObjectGetAttr(char,'eTangleBreak',0)==1:
                ffx.FFX_ObjectSetAttr(char,'eTangle_flier',0)
                AI_Animate(char,'get_up_forward')
                ffx.RegTimer('eTangleLock',0.7,0,char)
                return
            ffx.FFX_ObjectSetAttr(char,'eTangle_flier',0)
            AI_Animate(char,'get_up_forward')
            mlogreader.regGetupStop(char,'eTangleRecover',0,0,0)
        elif ffx.FFX_ObjectGetAttr(char,'eTangleBreak',0)==1:
            ffx.FFX_ObjectSetAttr(char,'eTangleBreak',0)
            if ffx.FFX_ObjectGetAttr(char,'eTangleMystic',0)==1:
                AI_Animate(char,'recover_from_stun')
            elif ffx.FFX_ObjectGetAttr(char,'eTangleMental',0)==1:
                AI_Animate(char,'recover_from_stun')
            else:
                AI_Animate(char,'swing_pole')
            ffx.RegTimer('eTangleRecover',1.5,0,char)
        else:
            Trigger_Force(char,0,0,1,Object_GetAttr(char,'mass')*100,TF_ABSOLUTE)
            if ffx.FFX_ObjectGetAttr(char,'acrobatic',0)!=1:
                mlogreader.regGetupStop(char,'eTangleRecover',0,0,0)
            else:
                ffx.RegTimer('eTangleRecover',1,0,char)
        hasPortrait=ffx.FFX_HasPortrait(char)
        pcAIEnabled=m25ai.AIInWatch(char)
        if pcAIEnabled or not hasPortrait:
            m25ai.ClearAIStandardOnly(char)
            m25ai.AIEnable(char)
            m25ai.AIEnableCustom(char)
            m25ai.SetBrawler(char)
            m25event.SetTimer(1.0, 'm25ai.AIRecoverBroken', char, user=m25ai.GetAITimeStamp(char))
    if ffx.FFX_ObjectGetAttr(char,'eTangled',0)==1:
        if flailing:
            mlogreader.regGetupStart(char,'eTangleLock',0,0,0)
            return
        if ffx.FFX_ObjectGetAttr(char,'eTangle_flier',0)==1:
            AI_Animate(char,'lock')
        else:
            AI_Animate(char,'pain')
        ffx.RegTimer('eTangleLock',0.1,0,char)

def eTangle(event):
    char=event.object
    source=event.string
    if Object_IsAlive(char)==0:
        ffx.FFX_ObjectSetAttr(char,'eTangled',0)
        ffx.RegTimer('uneTangleBreak',1,0,char)
        return
    if ffx.FFX_ObjectGetAttr(char,'eTangled',0)==0:
        return
    tangledAgl=Object_GetAttr(char,'agility')-3
    ffx.FFX_ObjectSetAttr(char,'baseAgility',Object_GetAttr(char,'agility'))
    Object_SetAttr(char,'energy',0)
    Object_SetAttr(char,'agility',tangledAgl)
    if ffx.FFX_ObjectGetAttr(char, 'stasiseTangle') == 1:
        ffx.RegTimer('makeeTangleFlyer', 0.2, 0, char, source)
        ffx.FFX_ObjectSetAttr(char, 'eTangle_flier', 1)
        return
    else:
        ffx.RegTimer('makeeTangled',0.2,0,char,source)

def makeeTangleFlyer(event):
    char = event.object
    source = event.string
    if Object_IsAlive(char)==0:
        ffx.FFX_ObjectSetAttr(char,'eTangled',0)
        ffx.RegTimer('uneTangleBreak',1,0,char)
        return
    flailing=mlogreader.MLOG_IsFlailing(char)
    if flailing:
        ffx.RegTimer('makeeTangleFlyer', 0.2, 0, char, source)
    else:
        ffx.RegTimer('makeeTangled',0.1,0,char,source)

def makeeTangled(event):
    char = event.object
    source = event.string
    if Object_IsAlive(char)==0:
        ffx.FFX_ObjectSetAttr(char,'eTangled',0)
        ffx.RegTimer('uneTangleBreak',1,0,char)
        return
    ffx.RegTimer('eTangleCheck',3,0,char,source)
    ffx.RegTimer('explodeTangle',4,0,char,source)

def eTangleBreakCheck(char,source):
    if ffx.FFX_ObjectGetAttr(char,'eTangleMental')==1:
        targetStr=ffx.getMentalResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    elif ffx.FFX_ObjectGetAttr(char,'eTangleMystic')==1:
        targetStr=ffx.getMysticalResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    elif ffx.FFX_ObjectGetAttr(char,'eTangleEnergy')==1:
        targetStr=ffx.getEnergyResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    else:
        targetStr=Object_GetAttr(char,'strength')+1
    tangleStr=ffx.getByTemplate(source,FFX_EXPLOSIVETANGLE_CUSTOM,3)
    if ffx.FFX_ObjectGetAttr(char,'eTanglePhysical',0)!=1:
        if targetStr==1:
            if tangleStr < 7:
                tangleStr=tangleStr+2
            else:
                tangleStr=tangleStr+1
        if targetStr > 1:
            tangleStr=(tangleStr*0.5)+1.5
        if targetStr < 1:
            tangleStr=tangleStr*1.5
        chance=tangleStr*targetStr
    else:
        if targetStr>tangleStr:
            targetStr=targetStr+1
            strDiff=targetStr-tangleStr
            chance=5-strDiff
        if targetStr==tangleStr:
            chance=6
        if tangleStr>targetStr:
            targetStr=targetStr-1
            strDiff=tangleStr-targetStr
            chance=5+strDiff
    #calculate the chance to break free
    breakFree=randint(1,10)
    if breakFree > chance:
        return 1
    else:
        return 0

def eTangleCheck(event):
    char=event.object
    source=event.string
    if Object_IsAlive(char)==0:
        ffx.FFX_ObjectSetAttr(char,'eTangled',0)
        ffx.RegTimer('uneTangleBreak',1,0,char)
        return
    if ffx.FFX_ObjectGetAttr(char, 'eTangled',0) == 0:
        return
    if eTangleBreakCheck(char,source):
        ffx.FFX_ObjectSetAttr(char,'eTangled',0)
        ffx.FFX_ObjectSetAttr(char,'eTangleBreak',1)
        ffx.RegTimer('uneTangleBreak',1,0,char)
        return

def uneTangleBreak(event):
    char=event.object
    handle=ffx.FFX_ObjectGetAttr(char,'eTangle_handle')
    Object_StopEffect(char, handle)
    ffx.FFX_ObjectSetAttr(char,'eTangleNetMental',0)
    ffx.FFX_ObjectSetAttr(char,'eTangleNetMystic',0)
    ffx.FFX_ObjectSetAttr(char,'eTangleNetCold',0)
    ffx.FFX_ObjectSetAttr(char,'eTangleNetEnergy',0)
    ffx.FFX_ObjectSetAttr(char,'eTangleNetPhysical',0)
    ffx.FFX_ObjectSetAttr(char,'stasiseTangle',0)

def explodeTangle(event):
    char=event.object
    source=event.string
    if ffx.FFX_ObjectGetAttr(char,'eTangled')==0:
        return
    ffx.FFX_ObjectSetAttr(char,'eTangled',0)
    tangleExplode(char,source)

def tangleExplode(char,source):
    name=ffx.getDummyName()
    Object_SpawnAt('ffx_tiggot',Get_ObjectPos(char),name)
    explosion=ffx.getByTemplate(source,FFX_EXPLOSIVETANGLE_CUSTOM,1)
    Trigger_Explosion(name,explosion)
    handle = ffx.FFX_ObjectGetAttr(char, 'eTangle_handle')
    Object_StopEffect(char, handle)
    ffx.RegTimer('ffx.destroyTemp',1,0,name)
    ffx.FFX_ObjectSetAttr(char,'eTangleNetMental',0)
    ffx.FFX_ObjectSetAttr(char,'eTangleNetMystic',0)
    ffx.FFX_ObjectSetAttr(char,'eTangleNetCold',0)
    ffx.FFX_ObjectSetAttr(char,'eTangleNetEnergy',0)
    ffx.FFX_ObjectSetAttr(char,'eTangleNetPhysical',0)
    ffx.FFX_ObjectSetAttr(char,'stasiseTangle',0)
    ffx.FFX_ObjectSetAttr(char,'eTangleExplode',1)
    agility=ffx.FFX_ObjectGetAttr(char,'baseAgility')
    Object_SetAttr(char,'agility',agility)
    energy=ffx.FFX_ObjectGetAttr(char,'baseEnergy')
    Object_SetAttr(char,'energy',energy)

def eTangleRecover(event):
    char=event.object
    if Object_IsAlive(char)==0:
        return
    flailing=mlogreader.MLOG_IsFlailing(char)
    getup=mlogreader.MLOG_IsGettingUp(char)
    if flailing:
        mlogreader.regGetupStop(char,'eTangleRecover',0,0,0)
        return
    if getup:
        mlogreader.regGetupStop(char,'eTangleRecover',0,0,0)
        return
    agility=ffx.FFX_ObjectGetAttr(char,'baseAgility')
    Object_SetAttr(char,'agility',agility)
    energy=ffx.FFX_ObjectGetAttr(char,'baseEnergy')
    Object_SetAttr(char,'energy',energy)
    AI_Animate(char,'unlock')
    hasPortrait=ffx.FFX_HasPortrait(char)
    pcAIEnabled=m25ai.AIInWatch(char)
    if pcAIEnabled or not hasPortrait:
        m25ai.ClearAIStandardOnly(char)
        m25ai.AIEnable(char)
        m25ai.AIEnableCustom(char)
        m25ai.SetBrawler(char)
        m25event.SetTimer(1.0, 'm25ai.AIRecoverBroken', char, user=m25ai.GetAITimeStamp(char))
    if ffx.FFX_ObjectGetAttr(char,'eTangleBreak',0)==1:
        if ffx.FFX_ObjectGetAttr(char,'eTangleMystic',0)==1:
            AI_Animate(char,'recover_from_stun')
        elif ffx.FFX_ObjectGetAttr(char,'eTangleMental',0)==1:
            AI_Animate(char,'recover_from_stun')
        else:
            AI_Animate(char,'swing_pole')
        ffx.FFX_ObjectSetAttr(char,'eTangleBreak',0)
    else:
        flying=mlogreader.MLOG_IsFlying(char)
        if flying:
            AI_Animate(char,'hover')
        else:
            AI_Animate(char,'melee_idle')
    handle=ffx.FFX_ObjectGetAttr(char,'eTangle_handle')
    Object_StopEffect(char,handle)
    ffx.FFX_ObjectSetAttr(char,'eTangleMental',0)
    ffx.FFX_ObjectSetAttr(char,'eTangleMystic',0)
    ffx.FFX_ObjectSetAttr(char,'eTangleCold',0)
    ffx.FFX_ObjectSetAttr(char,'eTangleEnergy',0)
    ffx.FFX_ObjectSetAttr(char,'eTanglePhysical',0)
    if ffx.FFX_ObjectGetAttr(char,'eTangleUnlock',0)==0:
        ffx.FFX_ObjectSetAttr(char,'eTangleUnlock',1)
        ffx.RegTimer('eTangleRecover2a',1,0,char)

def eTangleRecover2a(event):
    char=event.object
    if Object_IsAlive(char)==0:
        return
    pos=Get_ObjectPos(char)
    ffx.FFX_ObjectSetAttr(char,'lastY',pos[1])
    ffx.FFX_ObjectSetAttr(char,'lastX',pos[0])
    ffx.RegTimer('eTangleRecover2b',5,0,char)

def eTangleRecover2b(event):
    char=event.object
    if Object_IsAlive(char)==0:
        return
    flailing=mlogreader.MLOG_IsFlailing(char)
    getup=mlogreader.MLOG_IsGettingUp(char)
    pos=Get_ObjectPos(char)
    dist=(pos[0]-ffx.FFX_ObjectGetAttr(char,'lastX'),pos[1]-ffx.FFX_ObjectGetAttr(char,'lastY'),0)
    ffx.FFX_ObjectSetAttr(char,'lastY',pos[1])
    ffx.FFX_ObjectSetAttr(char,'lastX',pos[0])
    if ffx.FFX_ObjectGetAttr(char,'eTangled',0)==1:
        return
    if flailing:
        mlogreader.regGetupStop(char,'eTangleRecover2b',0,0,0)
        return
    if getup:
        mlogreader.regGetupStop(char,'eTangleRecover2b',0,0,0)
        return
    if (dist[0]*dist[0]+dist[1]*dist[1]) > 10:
        ffx.FFX_ObjectSetAttr(char,'eTangledUnlock',0)
        return
    if not m25ai.IsPerformingTactic(char):
        AI_Animate(char,'unlock')
        hasPortrait=ffx.FFX_HasPortrait(char)
        pcAIEnabled=m25ai.AIInWatch(char)
        if pcAIEnabled or not hasPortrait:
            m25ai.ClearAIStandardOnly(char)
            m25ai.AIEnable(char)
            m25ai.AIEnableCustom(char)
            m25ai.SetBrawler(char)
            m25event.SetTimer(1.0, 'm25ai.AIRecoverBroken', char, user=m25ai.GetAITimeStamp(char))
    ffx.RegTimer('eTangleRecover2b',5,0,char)


######################## Tangle State Swap ########################

def stuntotangle(event):
    tangleP(event,PCSTATE_STUNNED,ffx.COST_STUN)
def hypnosistotangle(event):
    tangleP(event,PCSTATE_HYPNOTISED,ffx.COST_HYPNO)
def ragetotangle(event):
    tangleP(event,PCSTATE_ENRAGED,ffx.COST_RAGE)
def exiletotangle(event):
    tangleP(event,PCSTATE_EXILE,ffx.COST_EXILE)
def blanktotangle(event):
    tangleP(event,PCSTATE_BLANK,ffx.COST_BLANK)
def panictotangle(event):
    tangleP(event,PCSTATE_PANICKED,ffx.COST_PANIC)
def stasistotangle(event):
    tangleP(event,PCSTATE_STATIC,ffx.COST_STASIS)
def frozentotangle(event):
    tangleP(event,PCSTATE_FROZEN,ffx.COST_FROZEN)

def hextotangle(event):
    tangleS(event,SCSTATE_HEXED,ffx.COST_HEX)
def blindtotangle(event):
    tangleS(event,SCSTATE_BLIND,ffx.COST_BLIND)
def powernulltotangle(event):
    tangleS(event,SCSTATE_POWER_NULLIFICATION,ffx.COST_NULL)
def weakentotangle(event):
    tangleS(event,SCSTATE_WEAKENED,ffx.COST_WEAKEN)
def speeddecreasetotangle(event):
    tangleS(event,SCSTATE_SPEED_DECREASED,ffx.COST_DECREASE)

def speedincreasetotangle(event):
    tangleS(event,SCSTATE_SPEED_INCREASED,ffx.COST_INCREASE)

def energisetotangle(event):
    char=event.object
    source=event.string
    if Object_GetSecondaryStates(char)&SCSTATE_ENERGIZED:
        Object_SetSecondaryState(char,SCSTATE_ENERGIZED,0,REMOVE_STATE)
        ffx.FFX_UpdateStates(char)
        tangleNetStartADCheck(char, source, ffx.COST_ENERGYSURGE)
    else:
        ffx.RegTimer('energizeSwapCancel',1,0,char,source)

def energysurgetotangle(event):
    char=event.object
    source=event.string
    if Object_GetSecondaryStates(char)&SCSTATE_AREA_ENERGIZED:
        Object_SetSecondaryState(char,SCSTATE_AREA_ENERGIZED,0,REMOVE_STATE)
        ffx.FFX_UpdateStates(char)
        tangleNetStartADCheck(char, source, ffx.COST_ENERGYSURGE)
    else:
        ffx.RegTimer('energizeSwapCancel',1,0,char,source)

def densitytotangle(event):
    char=event.object
    source=event.string
    if ffx.densityaltered(char):
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        ffx.FFX_UpdateStates(char)
        ffx.FFX_ObjectSetAttr(char,'tangleNetEnergy',1)
        tangleNetStartADCheck(char, source, ffx.COST_DENSITY)

def tangleP(event,state,intensity):
    char=event.object
    source=event.string
    if state==PCSTATE_STATIC:
        ffx.FFX_ObjectSetAttr(char,'tangleNetMystic',1)
        ffx.FFX_ObjectSetAttr(char,'stasisTangle',1)
    if state==PCSTATE_DIMENSION_SHIFT:
        ffx.FFX_ObjectSetAttr(char,'tangleNetMystic',1)
    if state==PCSTATE_HYPNOTISED:
        ffx.FFX_ObjectSetAttr(char,'tangleNetMental',1)
    if state==PCSTATE_ENRAGED:
        ffx.FFX_ObjectSetAttr(char,'tangleNetMental',1)
    if state==PCSTATE_BLANK:
        ffx.FFX_ObjectSetAttr(char,'tangleNetMental',1)
    if state==PCSTATE_PANICKED:
        ffx.FFX_ObjectSetAttr(char,'tangleNetMental',1)
    if state==PCSTATE_FROZEN:
        ffx.FFX_ObjectSetAttr(char,'tangleNetCold',1)
    if Object_GetPrimaryState(char)==state:
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        tangleNetStartADCheck(char, source, intensity)

def tangleS(event,state,intensity):
    char=event.object
    source=event.string
    if state==SCSTATE_HEXED:
        ffx.FFX_ObjectSetAttr(char,'tangleNetMystic',1)
    if state==SCSTATE_BLIND:
        ffx.FFX_ObjectSetAttr(char,'tangleNetMystic',1)
    if state==SCSTATE_WEAKENED:
        ffx.FFX_ObjectSetAttr(char,'tangleNetMental',1)
    if state==SCSTATE_POWER_NULLIFICATION:
        ffx.FFX_ObjectSetAttr(char,'tangleNetMental',1)
    if Object_GetSecondaryStates(char)&state:
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        tangleNetStartADCheck(char, source, intensity)

def tangleNetStartADCheck(char, source, intensity):
    if ffx.FFX_ObjectGetAttr(char,'tangled',0)==1:
        return
    duration=(intensity*4)+4
    ffx.FFX_ObjectSetAttr(char,'tangleNetDuration',duration)
    if (ffx.FFX_ObjectGetAttr(char,'tangleNetMental')==0) & (ffx.FFX_ObjectGetAttr(char,'tangleNetMystic')==0) & (ffx.FFX_ObjectGetAttr(char,'tangleNetEnergy')==0):
        ffx.FFX_ObjectSetAttr(char,'tangleNetPhysical',1)
        damage_type = m25ai.ai_damage_type['crushing']
        damage_mode = m25ai.ai_damage_mode['ranged']
        if ffx.FFX_ObjectGetAttr(char,'ffactivedefense')==1:
            if ffx.FFX_ObjectGetAttr(char,'ffactivedefenseSelf',0)==0:
                FFX_crushTest1b(char,source)
                return
            power=ffx.getByTemplate(char,FFX_FFACTIVEDEFENSE_CUSTOM,3)
            powdata = datfiles.Campaign_ReadPowers()[power]
            if powdata['PowerType'] == datfiles.PT_ACTIVE_DEFENCE:
                if ( powdata['DamageTypesBlocked'] & damage_type ) and \
                ( powdata['AttackModesBlocked'] & damage_mode ):
                    m25getset.GetObjectVar(char, 'defense ' + `damage_type` + '_' + `damage_mode`, 1,nosave=1)
                    return
        if ffx.FFX_HasPortrait(char):
            if not m25ai.AIInWatch(char):
                FFX_crushTest1b(char,source)
                return
        if m25ai.HasActiveDefenceActive(char,damage_type,damage_mode):
            return
        if ffx.FFX_ObjectGetAttr(char,'phased_out',0)==1:
            return
    tangleStart(char, source, duration)

def FFX_crushTest1b(char,source):
    name=ffx.getDummyName()
    Object_SpawnAt('ffx_tiggot',Get_ObjectPos(source),name)
    Trigger_Power(name,char,'ffx_ranged_crush_test','',10)
    flying=mlogreader.MLOG_IsFlying(char)
    if flying:
        ffx.FFX_ObjectSetAttr(char, 'tangle_flier', 1)
    ffx.FFX_ObjectSetAttr(char,'tangleCrushTest',1)
    ffx.FFX_ObjectSetAttr(char,'crushTestB',1)
    ffx.FFX_ObjectSetAttr(source,'crushTestB',1)
    ffx.RegCharState(char,PCSTATE_STUNNED,'FFX_crushTest2b',0,0,source)
    ffx.RegTimer('FFX_crushTest3b',2,0,char,source)
    ffx.RegTimer('ffx.destroyTemp',3,0,name)

def FFX_crushTest2b(event):
    char=event.object
    source=event.string
    if ffx.FFX_ObjectGetAttr(char,'crushTestB',0)==1:
        if ffx.FFX_ObjectGetAttr(source,'crushTestB',0)==1:
            ffx.FFX_ObjectSetAttr(source,'crushTestB',0)
            Object_SetPrimaryState(char,PCSTATE_STUNNED,0,REMOVE_STATE)
            netFX=ffx.getByTemplate(source,FFX_TANGLE_CUSTOM,1)
            if netFX == 'effect_ffx_tree_entangle':
                handle=Object_PlayEffect(char,netFX,'',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'')
            else:
                handle=Object_PlayEffect(char,netFX,'',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'centre')
            ffx.FFX_ObjectSetAttr(char,'tangleNet_handle',handle)
            if ffx.FFX_ObjectGetAttr(char,'tangle_flier',0)==1:
                if tangleBreakCheck(char,source):
                    handle=ffx.FFX_ObjectGetAttr(char,'tangleNet_handle')
                    Object_StopEffect(char,handle)
                    ffx.FFX_ObjectSetAttr(char,'tangleBreak',1)
                    ffx.FFX_ObjectSetAttr(char,'tangle_flier',0)
                else:
                    Trigger_Force(char,0,0,1,Object_GetAttr(char,'mass')*100,TF_ABSOLUTE)
                    ffx.RegTimer('tangleStartEvent',0.2,0,char,source)
            else:
                if tangleBreakCheck(char,source):
                    handle=ffx.FFX_ObjectGetAttr(char,'tangleNet_handle')
                    Object_StopEffect(char,handle)
                    ffx.FFX_ObjectSetAttr(char,'tangleBreak',1)
                else:
                    AI_Animate(char,'pain')
                    ffx.RegTimer('tangleStartEvent',0.2,0,char,source)
    ffx.FFX_ObjectSetAttr(char,'crushTestB',0)

def FFX_crushTest3b(event):
    char=event.object
    source=event.string
    ffx.FFX_ObjectSetAttr(source,'crushTestB',0)
    if ffx.FFX_ObjectGetAttr(char,'tangleBreak',0)==1:
        if ffx.FFX_ObjectGetAttr(char,'tangleNetMystic',0)==1:
            AI_Animate(char,'recover_from_stun')
        elif ffx.FFX_ObjectGetAttr(char,'tangleNetMental',0)==1:
            AI_Animate(char,'recover_from_stun')
        else:
            AI_Animate(char,'swing_pole')
        ffx.FFX_ObjectSetAttr(char,'tangleBreak',0)
    if ffx.FFX_ObjectGetAttr(char,'tangled',0)==1:
        flailing=mlogreader.MLOG_IsFlailing(char)
        if not flailing:
            AI_Animate(char,'pain')

def tangleStartEvent(event):
    char=event.object
    source=event.string
    if Object_IsAlive(char)==0:
        return
    if ffx.FFX_ObjectGetAttr(char,'tangled',0)==1:
        return
    ffx.FFX_ObjectSetAttr(char,'tangled',1)
    tangledAgl=Object_GetAttr(char,'agility')-3
    ffx.FFX_ObjectSetAttr(char,'baseAgility',Object_GetAttr(char,'agility'))
    Object_SetAttr(char,'energy',0)
    Object_SetAttr(char,'agility',tangledAgl)
    hasPortrait=ffx.FFX_HasPortrait(char)
    pcAIEnabled=m25ai.AIInWatch(char)
    if pcAIEnabled or not hasPortrait:
        m25ai.AIDisable(char)
    if ffx.FFX_ObjectGetAttr(char, 'stasisTangle') == 1:
        ffx.RegTimer('maketangleFlyer', 0.2, 0, char, source)
        ffx.FFX_ObjectSetAttr(char, 'tangle_flier', 1)
        return
    ffx.RegTimer('makeTangled',0.2,0,char,source)
    ffx.RegTimer('tangleLock',0.1,0,char)

def tangleStart(char, source, duration):
    if Object_IsAlive(char)==0:
        return
    if ffx.FFX_ObjectGetAttr(char,'tangled',0)==1:
        return
    flying=mlogreader.MLOG_IsFlying(char)
    if flying:
        ffx.FFX_ObjectSetAttr(char, 'tangle_flier', 1)
    netFX=ffx.getByTemplate(source,FFX_TANGLE_CUSTOM,1)
    if netFX == 'effect_ffx_tree_entangle':
        handle=Object_PlayEffect(char,netFX,'',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'')
    else:
        handle=Object_PlayEffect(char,netFX,'',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'centre')
    ffx.FFX_ObjectSetAttr(char,'tangleNet_handle',handle)
    if tangleBreakCheck(char,source):
        handle=ffx.FFX_ObjectGetAttr(char,'tangleNet_handle')
        Object_StopEffect(char,handle)
        ffx.FFX_ObjectSetAttr(char,'tangleBreak',1)
    else:
        ffx.FFX_ObjectSetAttr(char,'tangled',1)
        hasPortrait=ffx.FFX_HasPortrait(char)
        pcAIEnabled=m25ai.AIInWatch(char)
        if pcAIEnabled or not hasPortrait:
            m25ai.AIDisable(char)
        tangleDmg(source,char)
    ffx.RegTimer('tangleStart2',0.5,0,char,source)

def tangleStart2(event):
    char=event.object
    source=event.string
    if Object_IsAlive(char)==0:
        ffx.FFX_ObjectSetAttr(char,'tangled',0)
        ffx.RegTimer('unTangle',1,0,char)
        return
    flailing=mlogreader.MLOG_IsFlailing(char)
    if ffx.FFX_ObjectGetAttr(char,'tangle_flier',0)==1:
        if ffx.FFX_ObjectGetAttr(char,'tangleBreak',0)==0:
            Trigger_Force(char,0,0,1,Object_GetAttr(char,'mass')*100,TF_ABSOLUTE)
            ffx.RegTimer('tangle',0.7,0,char,source)
            ffx.RegTimer('tangleLock',0.4,0,char)
            return
        else:
            ffx.FFX_ObjectSetAttr(char, 'tangle_flier', 0)
    #if target is already flailing from another attack when hit by the tangle...
    elif flailing:
        ffx.RegTimer('maketangleFlyer',0.5,0,char,source)
        ffx.FFX_ObjectSetAttr(char,'tangle_flier',1)
    else:
        if ffx.FFX_ObjectGetAttr(char,'tangleBreak',0)==0:
            AI_Animate(char,'pain')
    ffx.RegTimer('tangle',0.4,0,char,source)
    ffx.RegTimer('tangleLock',0.1,0,char)

def tangleLock(event):
    char=event.object
    flailing=mlogreader.MLOG_IsFlailing(char)
    flying=mlogreader.MLOG_IsFlying(char)
    if ffx.FFX_ObjectGetAttr(char,'tangled',0)==0:
        if flailing:
            mlogreader.regGetupStop(char,'tangleRecover',0,0,0)
        elif ffx.FFX_ObjectGetAttr(char,'tangle_flier',0)==1:
            if ffx.FFX_ObjectGetAttr(char,'tangleBreak',0)==1:
                ffx.FFX_ObjectSetAttr(char,'tangle_flier',0)
                AI_Animate(char,'get_up_forward')
                ffx.RegTimer('tangleLock',0.7,0,char)
                return
            ffx.FFX_ObjectSetAttr(char,'tangle_flier',0)
            AI_Animate(char,'get_up_forward')
            mlogreader.regGetupStop(char,'tangleRecover',0,0,0)
        elif ffx.FFX_ObjectGetAttr(char,'tangleBreak',0)==1:
            ffx.FFX_ObjectSetAttr(char,'tangleBreak',0)
            if ffx.FFX_ObjectGetAttr(char,'tangleNetMystic',0)==1:
                AI_Animate(char,'recover_from_stun')
            elif ffx.FFX_ObjectGetAttr(char,'tangleNetMental',0)==1:
                AI_Animate(char,'recover_from_stun')
            else:
                AI_Animate(char,'swing_pole')
            ffx.RegTimer('tangleRecover',1.5,0,char)
        else:
            Trigger_Force(char,0,0,1,Object_GetAttr(char,'mass')*100,TF_ABSOLUTE)
            if ffx.FFX_ObjectGetAttr(char,'acrobatic',0)!=1:
                mlogreader.regGetupStop(char,'tangleRecover',0,0,0)
            else:
                ffx.RegTimer('tangleRecover',1,0,char)
        hasPortrait=ffx.FFX_HasPortrait(char)
        pcAIEnabled=m25ai.AIInWatch(char)
        if pcAIEnabled or not hasPortrait:
            m25ai.ClearAIStandardOnly(char)
            m25ai.AIEnable(char)
            m25ai.AIEnableCustom(char)
            m25ai.SetBrawler(char)
            m25event.SetTimer(1.0, 'm25ai.AIRecoverBroken', char, user=m25ai.GetAITimeStamp(char))
    if ffx.FFX_ObjectGetAttr(char,'tangled',0)==1:
        if flailing:
            mlogreader.regGetupStart(char,'tangleLock',0,0,0)
            return
        if ffx.FFX_ObjectGetAttr(char,'tangle_flier',0)==1:
            AI_Animate(char,'lock')
        else:
            AI_Animate(char,'pain')
        ffx.RegTimer('tangleLock',0.1,0,char)

def tangle(event):
    char=event.object
    source=event.string
    if Object_IsAlive(char)==0:
        ffx.FFX_ObjectSetAttr(char,'tangled',0)
        ffx.RegTimer('unTangle',1,0,char)
        return
    if ffx.FFX_ObjectGetAttr(char,'tangled',0)==0:
        return
    tangledAgl=Object_GetAttr(char,'agility')-3
    ffx.FFX_ObjectSetAttr(char,'baseAgility',Object_GetAttr(char,'agility'))
    Object_SetAttr(char,'energy',0)
    Object_SetAttr(char,'agility',tangledAgl)
    if ffx.FFX_ObjectGetAttr(char, 'stasisTangle') == 1:
        ffx.RegTimer('maketangleFlyer', 0.2, 0, char, source)
        ffx.FFX_ObjectSetAttr(char, 'tangle_flier', 1)
        return
    else:
        ffx.RegTimer('makeTangled',0.2,0,char,source)

def maketangleFlyer(event):
    char = event.object
    source = event.string
    if Object_IsAlive(char)==0:
        ffx.FFX_ObjectSetAttr(char,'tangled',0)
        ffx.RegTimer('unTangle',1,0,char)
        return
    flailing=mlogreader.MLOG_IsFlailing(char)
    if flailing:
        ffx.RegTimer('maketangleFlyer', 0.2, 0, char, source)
    else:
        ffx.RegTimer('makeTangled',0.1,0,char,source)

def makeTangled(event):
    char = event.object
    source = event.string
    if Object_IsAlive(char)==0:
        ffx.FFX_ObjectSetAttr(char,'tangled',0)
        ffx.RegTimer('unTangle',1,0,char)
        return
    ffx.RegTimer('tangleCheck',3,0,char,source)

def tangleBreakCheck(char,source):
    if ffx.FFX_ObjectGetAttr(char,'tangleNetMental')==1:
        targetStr=ffx.getMentalResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    elif ffx.FFX_ObjectGetAttr(char,'tangleNetMystic')==1:
        targetStr=ffx.getMysticalResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    elif ffx.FFX_ObjectGetAttr(char,'tangleNetEnergy')==1:
        targetStr=ffx.getEnergyResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    else:
        targetStr=Object_GetAttr(char,'strength')+1
    tangleStr=ffx.getByTemplate(source,FFX_TANGLE_CUSTOM,2)
    if ffx.FFX_ObjectGetAttr(char,'tangleNetPhysical',0)!=1:
        if targetStr==1:
            if tangleStr < 7:
                tangleStr=tangleStr+2
            else:
                tangleStr=tangleStr+1
        if targetStr > 1:
            tangleStr=(tangleStr*0.5)+1.5
        if targetStr < 1:
            tangleStr=tangleStr*1.5
        chance=tangleStr*targetStr
    else:
        if targetStr>tangleStr:
            targetStr=targetStr+1
            strDiff=targetStr-tangleStr
            chance=5-strDiff
        if targetStr==tangleStr:
            chance=6
        if tangleStr>targetStr:
            targetStr=targetStr-1
            strDiff=tangleStr-targetStr
            chance=5+strDiff
    #calculate the chance to break free
    breakFree=randint(1,10)
    if breakFree > chance:
        return 1
    else:
        return 0

def tangleDmg(source,char):
    #apply damage if hold is successful
    if ffx.FFX_ObjectGetAttr(char,'tangleNetMental',0)==1:
        targetStr=ffx.getMentalResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    elif ffx.FFX_ObjectGetAttr(char,'tangleNetMystic',0)==1:
        targetStr=ffx.getMysticalResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    elif ffx.FFX_ObjectGetAttr(char,'tangleNetEnergy',0)==1:
        targetStr=ffx.getEnergyResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    tangleDmg=ffx.getByTemplate(source,FFX_TANGLE_CUSTOM,3)
    if tangleDmg=='Yes':
            tangleDmg=ffx.getByTemplate(source,FFX_TANGLE_CUSTOM,2)
    else:
        tangleDmg=0
    if tangleDmg > 0:
        baseDmg=tangleDmg*2
        if ffx.FFX_ObjectGetAttr(char,'tangleNetPhysical',0)!=1:
            damage=baseDmg*targetStr
        else:
            if ffx.FFX_ObjectGetAttr(char,'tangleNetCold',0)==1:
                targetStr=ffx.getColdResistanceValue(char,passive=0,active=0,attribs=1,states=1,material=1)
            else:
                targetStr=ffx.getCrushResistanceValue(char,passive=0,active=0,attribs=1,states=1,material=1)
            damage=baseDmg*targetStr
        if damage < 1:
            damage=1
        if (ffx.FFX_ObjectGetAttr(char,'tangleNetMental')==1) | (ffx.FFX_ObjectGetAttr(char,'tangleNetMystic')==1):
            ffx.FFX_ApplyDamage(char,damage,mental=1)
        else:
            if damage > 0:
                ffx.FFX_ApplyDamage(char,damage,mental=0)

def tangleCheck(event):
    char=event.object
    source=event.string
    if Object_IsAlive(char)==0:
        ffx.FFX_ObjectSetAttr(char,'tangled',0)
        ffx.RegTimer('unTangle',1,0,char)
        return
    if ffx.FFX_ObjectGetAttr(char,'tangled',0)==0:
        return
    if Object_GetPrimaryState(char)!=PCSTATE_NORMAL:
        duration=ffx.FFX_ObjectGetAttr(char,'tangleNetDuration')-2
        ffx.FFX_ObjectSetAttr(char,'tangleNetDuration',duration)
        ffx.RegTimer('tangleCheck',2,0,char,source)
        return
    duration=ffx.FFX_ObjectGetAttr(char,'tangleNetDuration')-3
    if duration<=0:
        ffx.FFX_ObjectSetAttr(char,'tangled',0)
        ffx.RegTimer('unTangle',0.1,0,char)
        return
    if tangleBreakCheck(char,source):
        ffx.FFX_ObjectSetAttr(char,'tangled',0)
        ffx.FFX_ObjectSetAttr(char,'tangleBreak',1)
        ffx.RegTimer('unTangle',1,0,char)
        return
    ffx.FFX_ObjectSetAttr(char,'tangleNetDuration',duration)
    ffx.RegTimer('tangleCheck',3,0,char,source)
    tangleDmg(source,char)

def unTangle(event):
    char=event.object
    handle=ffx.FFX_ObjectGetAttr(char,'tangleNet_handle')
    Object_StopEffect(char, handle)
    ffx.FFX_ObjectSetAttr(char,'tangleNetMental',0)
    ffx.FFX_ObjectSetAttr(char,'tangleNetMystic',0)
    ffx.FFX_ObjectSetAttr(char,'tangleNetCold',0)
    ffx.FFX_ObjectSetAttr(char,'tangleNetEnergy',0)
    ffx.FFX_ObjectSetAttr(char,'tangleNetPhysical',0)
    ffx.FFX_ObjectSetAttr(char,'stasisTangle',0)

def tangleRecover(event):
    char=event.object
    if Object_IsAlive(char)==0:
        return
    flailing=mlogreader.MLOG_IsFlailing(char)
    getup=mlogreader.MLOG_IsGettingUp(char)
    if flailing:
        mlogreader.regGetupStop(char,'tangleRecover',0,0,0)
        return
    if getup:
        mlogreader.regGetupStop(char,'tangleRecover',0,0,0)
        return
    agility=ffx.FFX_ObjectGetAttr(char,'baseAgility')
    Object_SetAttr(char,'agility',agility)
    energy=ffx.FFX_ObjectGetAttr(char,'baseEnergy')
    Object_SetAttr(char,'energy',energy)
    if not m25ai.IsPerformingTactic(char):
        AI_Animate(char,'unlock')
        hasPortrait=ffx.FFX_HasPortrait(char)
        pcAIEnabled=m25ai.AIInWatch(char)
        if pcAIEnabled or not hasPortrait:
            m25ai.ClearAIStandardOnly(char)
            m25ai.AIEnable(char)
            m25ai.AIEnableCustom(char)
            m25ai.SetBrawler(char)
            m25event.SetTimer(1.0,'m25ai.AIRecoverBroken',char,user=m25ai.GetAITimeStamp(char))
    if ffx.FFX_ObjectGetAttr(char,'tangleBreak',0)==1:
        if ffx.FFX_ObjectGetAttr(char,'tangleNetMystic',0)==1:
            AI_Animate(char,'recover_from_stun')
        elif ffx.FFX_ObjectGetAttr(char,'tangleNetMental',0)==1:
            AI_Animate(char,'recover_from_stun')
        else:
            AI_Animate(char,'swing_pole')
        ffx.FFX_ObjectSetAttr(char,'tangleBreak',0)
    else:
        flying=mlogreader.MLOG_IsFlying(char)
        if flying:
            AI_Animate(char,'hover')
        else:
            AI_Animate(char,'melee_idle')
    handle=ffx.FFX_ObjectGetAttr(char,'tangle_handle')
    Object_StopEffect(char,handle)
    ffx.FFX_ObjectSetAttr(char,'tangleMental',0)
    ffx.FFX_ObjectSetAttr(char,'tangleMystic',0)
    ffx.FFX_ObjectSetAttr(char,'tangleCold',0)
    ffx.FFX_ObjectSetAttr(char,'tangleEnergy',0)
    ffx.FFX_ObjectSetAttr(char,'tanglePhysical',0)
    if ffx.FFX_ObjectGetAttr(char,'tangleUnlock',0)==0:
        ffx.FFX_ObjectSetAttr(char,'tangleUnlock',1)
        ffx.RegTimer('tangleRecover2a',1,0,char)

def tangleRecover2a(event):
    char=event.object
    if Object_IsAlive(char)==0:
        return
    pos=Get_ObjectPos(char)
    ffx.FFX_ObjectSetAttr(char,'lastY',pos[1])
    ffx.FFX_ObjectSetAttr(char,'lastX',pos[0])
    ffx.RegTimer('tangleRecover2b',5,0,char)

def tangleRecover2b(event):
    char=event.object
    if Object_IsAlive(char)==0:
        return
    flailing=mlogreader.MLOG_IsFlailing(char)
    getup=mlogreader.MLOG_IsGettingUp(char)
    pos=Get_ObjectPos(char)
    dist=(pos[0]-ffx.FFX_ObjectGetAttr(char,'lastX'),pos[1]-ffx.FFX_ObjectGetAttr(char,'lastY'),0)
    ffx.FFX_ObjectSetAttr(char,'lastY',pos[1])
    ffx.FFX_ObjectSetAttr(char,'lastX',pos[0])
    if ffx.FFX_ObjectGetAttr(char,'tangled',0)==1:
        return
    if flailing:
        mlogreader.regGetupStop(char,'tangleRecover2b',0,0,0)
        return
    if getup:
        mlogreader.regGetupStop(char,'tangleRecover2b',0,0,0)
        return
    if (dist[0]*dist[0]+dist[1]*dist[1]) > 10:
        ffx.FFX_ObjectSetAttr(char,'tangledUnlock',0)
        return
    if not m25ai.IsPerformingTactic(char):
        AI_Animate(char,'unlock')
        hasPortrait=ffx.FFX_HasPortrait(char)
        pcAIEnabled=m25ai.AIInWatch(char)
        if pcAIEnabled or not hasPortrait:
            m25ai.ClearAIStandardOnly(char)
            m25ai.AIEnable(char)
            m25ai.AIEnableCustom(char)
            m25ai.SetBrawler(char)
            m25event.SetTimer(1.0, 'm25ai.AIRecoverBroken', char, user=m25ai.GetAITimeStamp(char))
    ffx.RegTimer('tangleRecover2b',5,0,char)


#################### ranged grapple state swap ########################################################

def stuntorangedgrapple(event):
    rangedgrappleP(event,PCSTATE_STUNNED,1)
def hypnosistorangedgrapple(event):
    rangedgrappleP(event,PCSTATE_HYPNOTISED,ffx.COST_HYPNO)
def ragetorangedgrapple(event):
    rangedgrappleP(event,PCSTATE_ENRAGED,ffx.COST_RAGE)
def exiletorangedgrapple(event):
    rangedgrappleP(event,PCSTATE_EXILE,ffx.COST_EXILE)
def blanktorangedgrapple(event):
    rangedgrappleP(event,PCSTATE_BLANK,ffx.COST_BLANK)
def panictorangedgrapple(event):
    rangedgrappleP(event,PCSTATE_PANICKED,ffx.COST_PANIC)
def frozentorangedgrapple(event):
    rangedgrappleP(event,PCSTATE_FROZEN,ffx.COST_FROZEN)
def stasistorangedgrapple(event):
    rangedgrappleP(event,PCSTATE_STATIC,ffx.COST_STASIS)

def hextorangedgrapple(event):
    rangedgrappleS(event,SCSTATE_HEXED,ffx.COST_HEX)
def blindtorangedgrapple(event):
    rangedgrappleS(event,SCSTATE_BLIND,ffx.COST_BLIND)
def powernulltorangedgrapple(event):
    rangedgrappleS(event,SCSTATE_POWER_NULLIFICATION,ffx.COST_NULL)
def weakentorangedgrapple(event):
    rangedgrappleS(event,SCSTATE_WEAKENED,ffx.COST_WEAKEN)
def speeddecreasetorangedgrapple(event):
    rangedgrappleS(event,SCSTATE_SPEED_DECREASED,ffx.COST_DECREASE)

def speedincreasetorangedgrapple(event):
    rangedgrappleS(event,SCSTATE_SPEED_INCREASED,ffx.COST_INCREASE)

def energisetorangedgrapple(event):
    char=event.object
    source=event.string
    if Object_GetSecondaryStates(char)&SCSTATE_ENERGIZED:
        Object_SetSecondaryState(char,SCSTATE_ENERGIZED,0,REMOVE_STATE)
        ffx.FFX_UpdateStates(char)
        rGrappledADcheck(char,source,ffx.COST_ENERGYSURGE)
    else:
        ffx.RegTimer('energizeSwapCancel',1,0,char,source)

def energizeSwapCancel(event):
    char=event.object
    source=event.string
    radius=80
    radius2=radius*radius
    for obj in Mission_GetDynamicObjects():
        if ((Object_GetClass(obj) & FFX_CHARACTER)!=0) & (obj!=source):
            d=ffx.distanceSq(obj,char)
            if d<radius2:
                if Object_GetSecondaryStates(obj)&SCSTATE_ENERGIZED:
                    Object_SetSecondaryState(obj,SCSTATE_ENERGIZED,0,REMOVE_STATE)
                if Object_GetSecondaryStates(obj)&SCSTATE_AREA_ENERGIZED:
                    Object_SetSecondaryState(obj,SCSTATE_AREA_ENERGIZED,0,REMOVE_STATE)

def energysurgetorangedgrapple(event):
    char=event.object
    source=event.string
    if Object_GetSecondaryStates(char)&SCSTATE_AREA_ENERGIZED:
        Object_SetSecondaryState(char,SCSTATE_AREA_ENERGIZED,0,REMOVE_STATE)
        ffx.FFX_UpdateStates(char)
        rGrappledADcheck(char,source,ffx.COST_ENERGYSURGE)
    else:
        ffx.RegTimer('energizeSwapCancel',1,0,char,source)

def densitytorangedgrapple(event):
    char=event.object
    source=event.string
    if ffx.densityaltered(char):
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        ffx.FFX_UpdateStates(char)
        ffx.FFX_ObjectSetAttr(source,'rangedGrappleEnergy',1)
        rGrappledADcheck(char,source,ffx.COST_DENSITY)

def rangedgrappleP(event,state,intensity):
    char=event.object
    source=event.string
    if state==PCSTATE_DIMENSION_SHIFT:
        ffx.FFX_ObjectSetAttr(char,'rangedGrappleMystic',1)
    if state==PCSTATE_STATIC:
        ffx.FFX_ObjectSetAttr(char,'rangedGrappleMystic',1)
    if state==PCSTATE_HYPNOTISED:
        ffx.FFX_ObjectSetAttr(char,'rangedGrappleMental',1)
    if state==PCSTATE_PANICKED:
        ffx.FFX_ObjectSetAttr(char,'rangedGrappleMental',1)
    if state==PCSTATE_BLANK:
        ffx.FFX_ObjectSetAttr(char,'rangedGrappleMental',1)
    if state==PCSTATE_ENRAGED:
        ffx.FFX_ObjectSetAttr(char,'rangedGrappleMental',1)
    if state==PCSTATE_FROZEN:
        ffx.FFX_ObjectSetAttr(char,'rangedGrappleCold',1)
    if Object_GetPrimaryState(char)==state:
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        rGrappledADcheck(char,source,intensity)

def rangedgrappleS(event,state,intensity):
    char=event.object
    source=event.string
    if state==SCSTATE_HEXED:
        ffx.FFX_ObjectSetAttr(char,'rangedGrappleMystic',1)
    if state==SCSTATE_BLIND:
        ffx.FFX_ObjectSetAttr(char,'rangedGrappleMystic',1)
    if state==SCSTATE_POWER_NULLIFICATION:
        ffx.FFX_ObjectSetAttr(char,'rangedGrappleMental',1)
    if state==SCSTATE_WEAKENED:
        ffx.FFX_ObjectSetAttr(char,'rangedGrappleMental',1)
    if Object_GetSecondaryStates(char)&state:
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        rGrappledADcheck(char,source,intensity)

def rGrappledADcheck(char, source, intensity):
    if ffx.FFX_ObjectGetAttr(char,'rangedgrappled',0)==1:
        return
    AI_Animate(source,'lock')
    mlogreader.regDodgeStart(source,'rGrappleCancel',0,0,0,char)
    ffx.FFX_ObjectSetAttr(source,'rangedgrappleIntensity',intensity)
    if (ffx.FFX_ObjectGetAttr(char,'rangedGrappleMental')==0) & (ffx.FFX_ObjectGetAttr(char,'rangedGrappleMystic')==0) & (ffx.FFX_ObjectGetAttr(char,'rangedGrappleEnergy')==0):
        ffx.FFX_ObjectSetAttr(char,'rangedGrapplePhysical',1)
        damage_type = m25ai.ai_damage_type['crushing']
        damage_mode = m25ai.ai_damage_mode['ranged']
        if ffx.FFX_ObjectGetAttr(char,'ffactivedefense')==1:
            useStr=ffx.getByTemplate(source,FFX_RANGEGRAPPLE_CUSTOM,2)
            adHP=ffx.FFX_ObjectGetAttr(char,'ffactivedefenseHP')
            grappleDmg=ffx.getByTemplate(source,FFX_RANGEGRAPPLE_CUSTOM,4)
            if grappleDmg=='Yes':
                if useStr=='Yes':
                    grappleDmg=Object_GetAttr(source,'strength')+1
                else:
                    grappleDmg=ffx.getByTemplate(source,FFX_RANGEGRAPPLE_CUSTOM,3)
            else:
                grappleDmg=0
            newHP=adHP-grappleDmg
            ffx.FFX_ObjectSetAttr(char,'ffactivedefenseHP',newHP)
            if ffx.FFX_ObjectGetAttr(char,'ffactivedefenseSelf',0)==0:
                FFX_crushTest1(char,source)
                return
            power=ffx.getByTemplate(char,FFX_FFACTIVEDEFENSE_CUSTOM,3)
            powdata = datfiles.Campaign_ReadPowers()[power]
            if powdata['PowerType'] == datfiles.PT_ACTIVE_DEFENCE:
                if ( powdata['DamageTypesBlocked'] & damage_type ) and \
                ( powdata['AttackModesBlocked'] & damage_mode ):
                    m25getset.GetObjectVar(char, 'defense ' + `damage_type` + '_' + `damage_mode`, 1,nosave=1)
                    AI_Animate(source,'unlock')
                    AI_Animate(source,'melee_idle')
                    return
        if ffx.FFX_HasPortrait(char):
            if not m25ai.AIInWatch(char):
                FFX_crushTest1(char,source)
                return
        if m25ai.HasActiveDefenceActive(char,damage_type,damage_mode):
            AI_Animate(source,'unlock')
            AI_Animate(source,'melee_idle')
            return
        if ffx.FFX_ObjectGetAttr(char,'phased_out',0)==1:
            AI_Animate(source,'unlock')
            AI_Animate(source,'melee_idle')
            return
    rangedGrappleStart(char, source)

def rGrappleCancel(event):
    source=event.object
    char=event.string
    if ffx.FFX_ObjectGetAttr(source,'rangedgrappler',0)==0:
        AI_Animate(source,'unlock')
        AI_Animate(source,'melee_idle')
    ffx.FFX_ObjectSetAttr(char,'rangedgrappled',0)
    ffx.FFX_ObjectSetAttr(source,'rangedgrappler',0)

def FFX_crushTest1(char,source):
    name=ffx.getDummyName()
    Object_SpawnAt('ffx_tiggot',Get_ObjectPos(source),name)
    Trigger_Power(name,char,'ffx_ranged_crush_test','',10)
    flying=mlogreader.MLOG_IsFlying(char)
    if flying:
        ffx.FFX_ObjectSetAttr(char, 'rangedGrappled_flier', 1)
    ffx.FFX_ObjectSetAttr(char,'crushTest',1)
    ffx.FFX_ObjectSetAttr(source,'crushTest',1)
    ffx.RegCharState(char,PCSTATE_STUNNED,'FFX_crushTest2',0,0,source)
    ffx.RegTimer('FFX_crushTest3',2,0,char,source)
    ffx.RegTimer('ffx.destroyTemp',3,0,name)

def FFX_crushTest2(event):
    char=event.object
    source=event.string
    if ffx.FFX_ObjectGetAttr(char,'crushTest',0)==1:
        if ffx.FFX_ObjectGetAttr(source,'crushTest',0)==1:
            ffx.FFX_ObjectSetAttr(source,'crushTest',0)
            grappleFX=ffx.getByTemplate(source,FFX_RANGEGRAPPLE_CUSTOM,1)
            handle = Object_PlayEffect(char, grappleFX,'',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'centre')
            ffx.FFX_ObjectSetAttr(char,'rangedGrapple_handle',handle)
            Object_SetPrimaryState(char,PCSTATE_STUNNED,0,REMOVE_STATE)
            if ffx.FFX_ObjectGetAttr(char,'rangedGrappled_flier',0)==1:
                AI_Animate(char,'hover')
                if rGrappleBreakCheck(char,source):
                    handle=ffx.FFX_ObjectGetAttr(char,'rangedGrapple_handle')
                    Object_StopEffect(char,handle)
                    if ffx.FFX_ObjectGetAttr(char,'rangedGrappleMystic',0)==1:
                        AI_Animate(char,'recover_from_stun')
                    elif ffx.FFX_ObjectGetAttr(char,'rangedGrappleMental',0)==1:
                        AI_Animate(char,'recover_from_stun')
                    else:
                        AI_Animate(char,'swing_pole')
                else:
                    ffx.FFX_ObjectSetAttr(char,'rangedgrappled',1)
                    ffx.FFX_ObjectSetAttr(source,'rangedgrappler',1)
                    AI_Animate(char,'pain')
                    ffx.RegTimer('rangedGrappleStartEvent',0.2,0,char,source)
            else:
                if rGrappleBreakCheck(char,source):
                    handle=ffx.FFX_ObjectGetAttr(char,'rangedGrapple_handle')
                    Object_StopEffect(char,handle)
                    if ffx.FFX_ObjectGetAttr(char,'rangedGrappleMystic',0)==1:
                        AI_Animate(char,'recover_from_stun')
                    elif ffx.FFX_ObjectGetAttr(char,'rangedGrappleMental',0)==1:
                        AI_Animate(char,'recover_from_stun')
                    else:
                        AI_Animate(char,'swing_pole')
                else:
                    ffx.FFX_ObjectSetAttr(char,'rangedgrappled',1)
                    ffx.FFX_ObjectSetAttr(source,'rangedgrappler',1)
                    AI_Animate(char,'pain')
                    ffx.RegTimer('rangedGrappleStartEvent',0.2,0,char,source)
    ffx.FFX_ObjectSetAttr(char,'crushTest',0)

def FFX_crushTest3(event):
    char=event.object
    source=event.string
    ffx.FFX_ObjectSetAttr(source,'crushTest',0)
    if ffx.FFX_ObjectGetAttr(char,'rGrappleBreak',0)==1:
        if ffx.FFX_ObjectGetAttr(char,'rangedGrappleMystic',0)==1:
            AI_Animate(char,'recover_from_stun')
        elif ffx.FFX_ObjectGetAttr(char,'rangedGrappleMental',0)==1:
            AI_Animate(char,'recover_from_stun')
        else:
            AI_Animate(char,'swing_pole')
        ffx.FFX_ObjectSetAttr(char,'rGrappleBreak',0)
    if ffx.FFX_ObjectGetAttr(char,'rangedgrappled',0)==1:
        flailing=mlogreader.MLOG_IsFlailing(char)
        if not flailing:
            AI_Animate(char,'pain')
    if ffx.FFX_ObjectGetAttr(source,'rangedgrappler',0)==0:
        AI_Animate(source,'unlock')
        AI_Animate(source,'melee_idle')

def rangedGrappleStartEvent(event):
    char=event.object
    source=event.string
    if Object_IsAlive(char)==0:
        return
    pos=Get_ObjectPos(source)
    pos2=Get_ObjectPos(char)
    ffx.FFX_ObjectSetAttr(source,'lastY',pos[1])
    ffx.FFX_ObjectSetAttr(source,'lastX',pos[0])
    ffx.FFX_ObjectSetAttr(char,'lastY',pos2[1])
    ffx.FFX_ObjectSetAttr(char,'lastX',pos2[0])
    ffx.FFX_ObjectSetAttr(source,'rgLastHealth',Object_GetAttr(source,'health'))
    ffx.FFX_ObjectSetAttr(source,'rGrapple_duration',9)
    hasPortrait=ffx.FFX_HasPortrait(char)
    pcAIEnabled=m25ai.AIInWatch(char)
    if pcAIEnabled or not hasPortrait:
        m25ai.AIDisable(char)
    ffx.RegTimer('makerangedGrapple',0.4,0,char,source)
    ffx.RegTimer('rGrappleLock',0.1,0,char,source)
    ffx.RegTimer('rangedgrappleMoveCheck',0.2,0,source,char)

def rangedGrappleStart(char, source):
    if Object_IsAlive(char)==0:
        return
    if ffx.FFX_ObjectGetAttr(char,'rangedgrappled',0)==1:
        return
    flying=mlogreader.MLOG_IsFlying(char)
    if flying:
        ffx.FFX_ObjectSetAttr(char, 'rangedGrappled_flier', 1)
    grappleFX=ffx.getByTemplate(source,FFX_RANGEGRAPPLE_CUSTOM,1)
    handle = Object_PlayEffect(char, grappleFX,'',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'centre')
    ffx.FFX_ObjectSetAttr(char,'rangedGrapple_handle',handle)
    if rGrappleBreakCheck(char,source):
        handle=ffx.FFX_ObjectGetAttr(char,'rangedGrapple_handle')
        Object_StopEffect(char,handle)
        ffx.FFX_ObjectSetAttr(char,'rGrappleBreak',1)
        ffx.RegTimer('rGrappleLock',0.3,0,char,source)
        return
    else:
        ffx.FFX_ObjectSetAttr(char,'rangedgrappled',1)
        ffx.FFX_ObjectSetAttr(source,'rangedgrappler',1)
        hasPortrait=ffx.FFX_HasPortrait(char)
        pcAIEnabled=m25ai.AIInWatch(char)
        if pcAIEnabled or not hasPortrait:
            m25ai.AIDisable(char)
    ffx.RegTimer('rangedGrappleStart2',0.5,0,char,source)

def rangedGrappleStart2(event):
    char=event.object
    source=event.string
    if Object_IsAlive(char)==0:
        ffx.FFX_ObjectSetAttr(char,'rangedgrappled',0)
        ffx.FFX_ObjectSetAttr(source,'rangedgrappler',0)
        return
    pos=Get_ObjectPos(source)
    pos2=Get_ObjectPos(char)
    ffx.FFX_ObjectSetAttr(source,'lastY',pos[1])
    ffx.FFX_ObjectSetAttr(source,'lastX',pos[0])
    ffx.FFX_ObjectSetAttr(char,'lastY',pos2[1])
    ffx.FFX_ObjectSetAttr(char,'lastX',pos2[0])
    ffx.FFX_ObjectSetAttr(source,'rgLastHealth',Object_GetAttr(source,'health'))
    ffx.FFX_ObjectSetAttr(source,'rGrapple_duration',9)
    AI_Animate(char,'pain')
    ffx.RegTimer('makerangedGrapple',0.4,0,char,source)
    ffx.RegTimer('rGrappleLock',0.1,0,char,source)
    ffx.RegTimer('rangedgrappleMoveCheck',0.2,0,source,char)

def rGrappleLock(event):
    char=event.object
    source=event.string
    flailing=mlogreader.MLOG_IsFlailing(char)
    flailingS=mlogreader.MLOG_IsFlailing(source)
    if flailing:
        ffx.FFX_ObjectSetAttr(char,'rangedgrappled',0)
        ffx.FFX_ObjectSetAttr(source,'rangedgrappler',0)
        mlogreader.regGetupStop(char,'rGrappleRecover',0,0,0)
        if flailingS:
            mlogreader.regGetupStop(source,'rGrappleRecover',0,0,0)
        else:
            ffx.RegTimer('rGrappleRecover',1,0,source)
        return
    if flailingS:
        ffx.FFX_ObjectSetAttr(char,'rangedgrappled',0)
        ffx.FFX_ObjectSetAttr(source,'rangedgrappler',0)
        mlogreader.regGetupStop(source,'rGrappleRecover',0,0,0)
        if flailing:
            mlogreader.regGetupStop(char,'rGrappleRecover',0,0,0)
        else:
            ffx.RegTimer('rGrappleRecover',1,0,char)
        return
    if ffx.FFX_ObjectGetAttr(char,'rangedgrappled',0)==0:
        if ffx.FFX_ObjectGetAttr(char,'rangedGrappled_flier',0)==1:
            ffx.FFX_ObjectSetAttr(char,'rangedGrappled_flier',0)
        if ffx.FFX_ObjectGetAttr(char,'rGrappleBreak',0)==0:
            Trigger_Force(char,0,0,1,Object_GetAttr(char,'mass')*100,TF_ABSOLUTE)
            if ffx.FFX_ObjectGetAttr(char,'acrobatic',0)!=1:
                mlogreader.regGetupStop(char,'rGrappleRecover',0,0,0)
            else:
                ffx.RegTimer('rGrappleRecover',1,0,char)
        else:
            ffx.RegTimer('rGrappleRecover',1,0,char)
        ffx.RegTimer('rGrappleRecover',1,0,source)
        return
    AI_Animate(char,'pain')
    ffx.RegTimer('rGrappleLock',0.2,0,char,source)

def makerangedGrapple(event):
    char=event.object
    source=event.string
    grappledAgl=Object_GetAttr(char,'agility')-3
    ffx.FFX_ObjectSetAttr(char,'baseAgility',Object_GetAttr(char,'agility'))
    ffx.FFX_ObjectSetAttr(source,'baseAgility',Object_GetAttr(source,'agility'))
    Object_SetAttr(char,'energy',0)
    Object_SetAttr(char,'agility',grappledAgl)
    Object_SetAttr(source,'agility',0)
    rGrappleDmg(source,char)
    ffx.RegTimer('rGrappleCheck',3,0,char,source)
    ffx.RegTimer('rGrappleEnergy',1,0,char,source)

def rangedgrappleMoveCheck(event):#checks grappler's and target's conditions (movement, damage, Primary State, KOed)
    source = event.object
    char = event.string
    if ffx.FFX_ObjectGetAttr(char,'rangedgrappled',0)==0:
        return
    lasthealth=ffx.FFX_ObjectGetAttr(source,'rgLastHealth')
    health=Object_GetAttr(source,'health')
    if health < lasthealth:
        ffx.FFX_ObjectSetAttr(char,'rangedgrappled',0)
        ffx.FFX_ObjectSetAttr(source,'rangedgrappler',0)
        return
    if (Object_GetPrimaryState(source)!=PCSTATE_NORMAL) | (Object_IsAlive(source)==0) | (ffx.FFX_ObjectGetAttr(source,'grappled',0)==1) | (ffx.FFX_ObjectGetAttr(source,'rangedgrappled',0)==1) | (ffx.FFX_ObjectGetAttr(source,'tangled',0)==1) | (ffx.FFX_ObjectGetAttr(source,'eTangled',0)==1) | (ffx.FFX_ObjectGetAttr(source,'thrownCharacter',0)==1):#if the grappler is koed, blanked, enraged, hexed, etc. cancel the grapple
        ffx.FFX_ObjectSetAttr(char,'rangedgrappled',0)
        ffx.FFX_ObjectSetAttr(source,'rangedgrappler',0)
        return
    if Object_GetPrimaryState(char)==ffx.PCSTATE_EXILE:
        ffx.FFX_ObjectSetAttr(char,'rangedgrappled',0)
        ffx.FFX_ObjectSetAttr(source,'rangedgrappler',0)
        return
    if (Object_IsAlive(char)==0):#if the target is koed, cancel the grapple
        ffx.FFX_ObjectSetAttr(char,'rangedgrappled',0)
        ffx.FFX_ObjectSetAttr(source,'rangedgrappler',0)
        return
    pos=Get_ObjectPos(source)
    pos2=Get_ObjectPos(char)
    dist=(pos[0]-ffx.FFX_ObjectGetAttr(source,'lastX'),pos[1]-ffx.FFX_ObjectGetAttr(source,'lastY'),0)
    dist2=(pos2[0]-ffx.FFX_ObjectGetAttr(char,'lastX'),pos2[1]-ffx.FFX_ObjectGetAttr(char,'lastY'),0)
    ffx.FFX_ObjectSetAttr(source,'lastY',pos[1])
    ffx.FFX_ObjectSetAttr(source,'lastX',pos[0])
    ffx.FFX_ObjectSetAttr(char,'lastY',pos2[1])
    ffx.FFX_ObjectSetAttr(char,'lastX',pos2[0])
    if (dist[0]*dist[0]+dist[1]*dist[1]) > 10:
        ffx.FFX_ObjectSetAttr(char,'rangedgrappled',0)
        ffx.FFX_ObjectSetAttr(source,'rangedgrappler',0)
        return
    elif (dist2[0]*dist2[0]+dist2[1]*dist2[1]) > 20:
        ffx.FFX_ObjectSetAttr(char,'rangedgrappled',0)
        ffx.FFX_ObjectSetAttr(source,'rangedgrappler',0)
        return
    ffx.FFX_ObjectSetAttr(source,'rgLastHealth',health)
    flailing=mlogreader.MLOG_IsFlailing(char)
    flailing2=mlogreader.MLOG_IsFlailing(source)
    if not flailing:
        AI_Animate(char,'lock')
    if not flailing2:
        AI_Animate(source,'lock')
    ffx.RegTimer('rangedgrappleMoveCheck',0.8,0,source,char)

def rGrappleBreakCheck(char,source):
    #calculate the target's resistance based on the kind of grapple(physical, mental, mystical, cold or energy)
    if ffx.FFX_ObjectGetAttr(char,'rangedGrappleMental',0)==1:
        targetStr=ffx.getMentalResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    elif ffx.FFX_ObjectGetAttr(char,'rangedGrappleMystic',0)==1:
        targetStr=ffx.getMysticalResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    elif ffx.FFX_ObjectGetAttr(char,'rangedGrappleEnergy',0)==1:
        targetStr=ffx.getEnergyResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    else:
        targetStr=Object_GetAttr(char,'strength')+1
        if ffx.FFX_ObjectGetAttr(char,'rangedGrappleCold',0)!=1:
            if ffx.hasAttribute(char,'wrestler'):
                targetStr=ffx.FFX_ObjectGetAttr(char,'wrestler')
    #calculate the grappler's hold strength (Strength Stat or Custom Value)
    useStr=ffx.getByTemplate(source,FFX_RANGEGRAPPLE_CUSTOM,2)
    if useStr=='Yes':
        holdStr=Object_GetAttr(source,'strength')+1
        if ffx.FFX_ObjectGetAttr(char,'rangedGrappleCold',0)!=1:
            if ffx.hasAttribute(source,'wrestler'):
                holdStr=ffx.FFX_ObjectGetAttr(source,'wrestler')
    else:
        holdStr=ffx.getByTemplate(source,FFX_RANGEGRAPPLE_CUSTOM,3)
    #calculate the difference in the grappler's and target's strength
    if ffx.FFX_ObjectGetAttr(char,'rangedGrapplePhysical',0)!=1:
        if targetStr==1:
            if holdStr < 7:
                holdStr=holdStr+2
            else:
                holdStr=holdStr+1
        if targetStr > 1:
            holdStr=(holdStr*0.5)+1.5
        if targetStr == 0.5:
            holdStr=holdStr*1.5
        if targetStr == 0.25:
            holdStr=holdStr*2.5
        chance=holdStr*targetStr
    else:
        if targetStr>holdStr:
            targetStr=targetStr+1
            strDiff=targetStr-holdStr
            chance=5-strDiff
        if targetStr==holdStr:
            chance=6
        if holdStr>targetStr:
            targetStr=targetStr-1
            strDiff=holdStr-targetStr
            chance=5+strDiff
    #calculate the chance to break free
    breakFree=randint(1,10)
    if breakFree > chance:
        return 1
    else:
        return 0

def rGrappleDmg(source,char):
    #apply damage if hold is successful
    if ffx.FFX_ObjectGetAttr(char,'rangedGrappleMental',0)==1:
        targetStr=ffx.getMentalResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    elif ffx.FFX_ObjectGetAttr(char,'rangedGrappleMystic',0)==1:
        targetStr=ffx.getMysticalResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    elif ffx.FFX_ObjectGetAttr(char,'rangedGrappleEnergy',0)==1:
        targetStr=ffx.getEnergyResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    useStr=ffx.getByTemplate(source,FFX_RANGEGRAPPLE_CUSTOM,2)
    grappleDmg=ffx.getByTemplate(source,FFX_RANGEGRAPPLE_CUSTOM,4)
    if grappleDmg=='Yes':
        if useStr=='Yes':
            grappleDmg=Object_GetAttr(source,'strength')+1
        else:
            grappleDmg=ffx.getByTemplate(source,FFX_RANGEGRAPPLE_CUSTOM,3)
    else:
        grappleDmg=0
    if grappleDmg > 0:
        baseDmg=grappleDmg*2
        if ffx.FFX_ObjectGetAttr(char,'rangedGrapplePhysical',0)!=1:
            damage=baseDmg*targetStr
        else:
            if ffx.FFX_ObjectGetAttr(char,'rangedGrappleCold',0)==1:
                targetStr=ffx.getColdResistanceValue(char,passive=0,active=0,attribs=1,states=1,material=1)
            else:
                targetStr=ffx.getCrushResistanceValue(char,passive=0,active=0,attribs=1,states=1,material=1)
            damage=baseDmg*targetStr
        if damage < 1:
            damage=1
        if (ffx.FFX_ObjectGetAttr(char,'rangedGrappleMental')==1) | (ffx.FFX_ObjectGetAttr(char,'rangedGrappleMystic')==1):
            ffx.FFX_ApplyDamage(char,damage,mental=1)
        else:
            if damage > 0:
                ffx.FFX_ApplyDamage(char,damage,mental=0)

def rGrappleEnergy(event):
    char=event.object
    source=event.string
    if ffx.FFX_ObjectGetAttr(char,'rangedgrappled',0)==0:
        return
    epCost=10
    if ffx.FFX_ObjectGetAttr(char,'rangedGrappleMental',0)==1:
        targetStr=ffx.getMentalResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    elif ffx.FFX_ObjectGetAttr(char,'rangedGrappleMystic',0)==1:
        targetStr=ffx.getMysticalResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    elif ffx.FFX_ObjectGetAttr(char,'rangedGrappleEnergy',0)==1:
        targetStr=ffx.getEnergyResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    else:
        targetStr=Object_GetAttr(char,'strength')+1
        if ffx.FFX_ObjectGetAttr(char,'rangedGrappleCold',0)!=1:
            if ffx.hasAttribute(char,'wrestler'):
                targetStr=ffx.FFX_ObjectGetAttr(char,'wrestler')
    useStr=ffx.getByTemplate(source,FFX_RANGEGRAPPLE_CUSTOM,2)
    if useStr=='Yes':
        holdStr=Object_GetAttr(source,'strength')+1
        if ffx.FFX_ObjectGetAttr(char,'rangedGrappleCold',0)!=1:
            if ffx.hasAttribute(source,'wrestler'):
                holdStr=ffx.FFX_ObjectGetAttr(source,'wrestler')
    else:
        holdStr=ffx.getByTemplate(source,FFX_RANGEGRAPPLE_CUSTOM,3)
    if ffx.FFX_ObjectGetAttr(char,'rangedGrapplePhysical',0)!=1:
        epCost=epCost/targetStr
    else:
        if targetStr>holdStr:
            targetStr=targetStr+1
            strDiff=targetStr-holdStr
            epCost=epCost*strDiff
        if holdStr>targetStr:
            targetStr=targetStr-1
            strDiff=holdStr-targetStr
            epCost=epCost/strDiff
    energy=Object_GetAttr(source,'energyPoints')
    newEnergy=Object_GetAttr(source,'energyPoints')-epCost
    Object_SetAttr(source,'energyPoints',newEnergy)
    if newEnergy <= 0:
        ffx.FFX_ObjectSetAttr(char,'rangedgrappled',0)
        ffx.FFX_ObjectSetAttr(source,'rangedgrappler',0)
        ffx.FFX_ObjectSetAttr(char,'rGrappleBreak',1)
        return
    ffx.RegTimer('rGrappleEnergy',1,0,char,source)

def rGrappleCheck(event):
    char=event.object
    source=event.string
    if ffx.FFX_ObjectGetAttr(char,'rangedgrappled',0)==0:
        return
    duration=ffx.FFX_ObjectGetAttr(source,'rGrapple_duration')-3
    if duration<=0:
        ffx.FFX_ObjectSetAttr(char,'rangedgrappled',0)
        ffx.FFX_ObjectSetAttr(source,'rangedgrappler',0)
        return
    if Object_GetPrimaryState(char)!=PCSTATE_NORMAL:
        ffx.FFX_ObjectSetAttr(source,'rGrapple_duration',duration)
        ffx.RegTimer('rGrappleCheck',3,0,char,source)
        return
    if rGrappleBreakCheck(char,source):
        ffx.FFX_ObjectSetAttr(char,'rangedgrappled',0)
        ffx.FFX_ObjectSetAttr(source,'rangedgrappler',0)
        ffx.FFX_ObjectSetAttr(char,'rGrappleBreak',1)
        return
    ffx.FFX_ObjectSetAttr(source,'rGrapple_duration',duration)
    rGrappleDmg(source,char)
    ffx.RegTimer('rGrappleCheck',3,0,char,source)

def rGrappleRecover(event):
    char=event.object
    if Object_IsAlive(char)==0:
        return
    flailing=mlogreader.MLOG_IsFlailing(char)
    if flailing:
        mlogreader.regGetupStop(char,'rGrappleRecover',0,0,0)
        return
    agility=ffx.FFX_ObjectGetAttr(char,'baseAgility')
    Object_SetAttr(char,'agility',agility)
    baseEnergy=ffx.FFX_ObjectGetAttr(char,'baseEnergy')
    energy=Object_GetAttr(char,'energy')
    if baseEnergy!=energy:
        Object_SetAttr(char,'energy',baseEnergy)
    if not m25ai.IsPerformingTactic(char):
        AI_Animate(char,'unlock')
        hasPortrait=ffx.FFX_HasPortrait(char)
        pcAIEnabled=m25ai.AIInWatch(char)
        if pcAIEnabled or not hasPortrait:
            m25ai.ClearAIStandardOnly(char)
            m25ai.AIEnable(char)
            m25ai.AIEnableCustom(char)
            m25ai.SetBrawler(char)
            m25event.SetTimer(1.0,'m25ai.AIRecoverBroken',char,user=m25ai.GetAITimeStamp(char))
    if ffx.FFX_ObjectGetAttr(char,'rGrappleBreak',0)==1:
        if ffx.FFX_ObjectGetAttr(char,'rangedGrappleMystic',0)==1:
            AI_Animate(char,'recover_from_stun')
        elif ffx.FFX_ObjectGetAttr(char,'rangedGrappleMental',0)==1:
            AI_Animate(char,'recover_from_stun')
        else:
            AI_Animate(char,'swing_pole')
        ffx.FFX_ObjectSetAttr(char,'rGrappleBreak',0)
    else:
        flying=mlogreader.MLOG_IsFlying(char)
        if flying:
            AI_Animate(char,'hover')
        else:
            AI_Animate(char,'melee_idle')
    handle=ffx.FFX_ObjectGetAttr(char,'rangedGrapple_handle')
    Object_StopEffect(char,handle)
    ffx.FFX_ObjectSetAttr(char,'rangedGrappleMental',0)
    ffx.FFX_ObjectSetAttr(char,'rangedGrappleMystic',0)
    ffx.FFX_ObjectSetAttr(char,'rangedGrappleCold',0)
    ffx.FFX_ObjectSetAttr(char,'rangedGrappleEnergy',0)
    ffx.FFX_ObjectSetAttr(char,'rangedGrapplePhysical',0)
    if ffx.FFX_ObjectGetAttr(char,'rGrappleUnlock',0)==0:
        ffx.FFX_ObjectSetAttr(char,'rGrappleUnlock',1)
        ffx.RegTimer('rGrappleRecover2a',1,0,char)

def rGrappleRecover2a(event):
    char=event.object
    if Object_IsAlive(char)==0:
        return
    pos=Get_ObjectPos(char)
    ffx.FFX_ObjectSetAttr(char,'lastY',pos[1])
    ffx.FFX_ObjectSetAttr(char,'lastX',pos[0])
    ffx.RegTimer('rGrappleRecover2b',5,0,char)

def rGrappleRecover2b(event):
    char=event.object
    if Object_IsAlive(char)==0:
        return
    flailing=mlogreader.MLOG_IsFlailing(char)
    getup=mlogreader.MLOG_IsGettingUp(char)
    pos=Get_ObjectPos(char)
    dist=(pos[0]-ffx.FFX_ObjectGetAttr(char,'lastX'),pos[1]-ffx.FFX_ObjectGetAttr(char,'lastY'),0)
    ffx.FFX_ObjectSetAttr(char,'lastY',pos[1])
    ffx.FFX_ObjectSetAttr(char,'lastX',pos[0])
    if ffx.FFX_ObjectGetAttr(char,'rangedgrappled',0)==1:
        return
    if ffx.FFX_ObjectGetAttr(char,'rangedgrappler',0)==1:
        return
    if flailing:
        mlogreader.regGetupStop(char,'rGrappleRecover2b',0,0,0)
        return
    if getup:
        mlogreader.regGetupStop(char,'rGrappleRecover2b',0,0,0)
        return
    if (dist[0]*dist[0]+dist[1]*dist[1]) > 10:
        ffx.FFX_ObjectSetAttr(char,'rGrappleUnlock',0)
        return
    if not m25ai.IsPerformingTactic(char):
        AI_Animate(char,'unlock')
        hasPortrait=ffx.FFX_HasPortrait(char)
        pcAIEnabled=m25ai.AIInWatch(char)
        if pcAIEnabled or not hasPortrait:
            m25ai.ClearAIStandardOnly(char)
            m25ai.AIEnable(char)
            m25ai.AIEnableCustom(char)
            m25ai.SetBrawler(char)
            m25event.SetTimer(1.0, 'm25ai.AIRecoverBroken', char, user=m25ai.GetAITimeStamp(char))
    ffx.RegTimer('rGrappleRecover2b',5,0,char)


#################### grapple state swap ########################################################
# Wrestling Hold State Swap that locks the target and attacker in place. Every two seconds the
# target gets a chance to break free or gets dealt damage equal to twice the attacker's strength
# -TaskmasterX
################################################################################################

def stuntograpple(event):
    grappleP(event,PCSTATE_STUNNED,1)
def hypnosistograpple(event):
    grappleP(event,PCSTATE_HYPNOTISED,ffx.COST_HYPNO)
def ragetograpple(event):
    grappleP(event,PCSTATE_ENRAGED,ffx.COST_RAGE)
def exiletograpple(event):
    grappleP(event,PCSTATE_EXILE,ffx.COST_EXILE)
def blanktograpple(event):
    grappleP(event,PCSTATE_BLANK,ffx.COST_BLANK)
def panictograpple(event):
    grappleP(event,PCSTATE_PANICKED,ffx.COST_PANIC)
def frozentograpple(event):
    grappleP(event,PCSTATE_FROZEN,ffx.COST_FROZEN)
def stasistograpple(event):
    grappleP(event,PCSTATE_STATIC,ffx.COST_STASIS)

def hextograpple(event):
    grappleS(event,SCSTATE_HEXED,ffx.COST_HEX)
def blindtograpple(event):
    grappleS(event,SCSTATE_BLIND,ffx.COST_BLIND)
def powernulltograpple(event):
    grappleS(event,SCSTATE_POWER_NULLIFICATION,ffx.COST_NULL)
def weakentograpple(event):
    grappleS(event,SCSTATE_WEAKENED,ffx.COST_WEAKEN)
def speeddecreasetograpple(event):
    grappleS(event,SCSTATE_SPEED_DECREASED,ffx.COST_DECREASE)

def speedincreasetograpple(event):
    grappleS(event,SCSTATE_SPEED_INCREASED,ffx.COST_INCREASE)

def energisetograpple(event):
    char=event.object
    source=event.string
    if Object_GetSecondaryStates(char)&SCSTATE_ENERGIZED:
        Object_SetSecondaryState(char,SCSTATE_ENERGIZED,0,REMOVE_STATE)
        ffx.FFX_UpdateStates(char)
        grappleStartCheck(char,source,ffx.COST_ENERGYSURGE)
        AI_Animate(source,'lock')

def energysurgetograpple(event):
    char=event.object
    source=event.string
    if Object_GetSecondaryStates(char)&SCSTATE_AREA_ENERGIZED:
        Object_SetSecondaryState(char,SCSTATE_AREA_ENERGIZED,0,REMOVE_STATE)
        ffx.FFX_UpdateStates(char)
        grappleStartCheck(char,source,ffx.COST_ENERGYSURGE)
        AI_Animate(source,'lock')

def densitytograpple(event):
    char=event.object
    source=event.string
    if ffx.densityaltered(char):
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        ffx.FFX_UpdateStates(char)
        ffx.FFX_ObjectSetAttr(char,'grappleEnergy',1)
        grappleStartCheck(char,source,ffx.COST_DENSITY)

def grappleS(event,state,intensity):
    char=event.object
    source=event.string
    if state==SCSTATE_HEXED:
        ffx.FFX_ObjectSetAttr(char,'grappleMystic',1)
    if state==SCSTATE_BLIND:
        ffx.FFX_ObjectSetAttr(char,'grappleMystic',1)
    if state==SCSTATE_POWER_NULLIFICATION:
        ffx.FFX_ObjectSetAttr(char,'grappleMental',1)
    if state==SCSTATE_WEAKENED:
        ffx.FFX_ObjectSetAttr(char,'grappleMental',1)
    if Object_GetSecondaryStates(char)&state:
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        grappleStartCheck(char,source,intensity)

def grappleP(event,state,intensity):
    char=event.object
    source=event.string
    if state==PCSTATE_DIMENSION_SHIFT:
        ffx.FFX_ObjectSetAttr(char,'grappleMystic',1)
    if state==PCSTATE_STATIC:
        ffx.FFX_ObjectSetAttr(char,'grappleMystic',1)
    if state==PCSTATE_HYPNOTISED:
        ffx.FFX_ObjectSetAttr(char,'grappleMental',1)
    if state==PCSTATE_PANICKED:
        ffx.FFX_ObjectSetAttr(char,'grappleMental',1)
    if state==PCSTATE_BLANK:
        ffx.FFX_ObjectSetAttr(char,'grappleMental',1)
    if state==PCSTATE_ENRAGED:
        ffx.FFX_ObjectSetAttr(char,'grappleMental',1)
    if state==PCSTATE_FROZEN:
        ffx.FFX_ObjectSetAttr(char,'grappleCold',1)
    if Object_GetPrimaryState(char)==state:
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        grappleStartCheck(char,source,intensity)

def grappleStartCheck(char,source,intensity):
    if ffx.FFX_ObjectGetAttr(char,'grappled',0)==1:
        return
    AI_Animate(source,'lock')
    mlogreader.regDodgeStart(source,'grappleCancel',0,0,0,char)
    ffx.FFX_ObjectSetAttr(source,'grappleIntensity',intensity)
    pos1 = Get_ObjectPos(char)
    pos2 = Get_ObjectPos(source)
    dist = cshelper.distance2D(pos1, pos2)
    subtype = m25ai.FindTacticType(char, 'subtype')
    if dist > 46:#check if the target moved too far away
        if (Object_GetClass(char)&js.OC_VEHICLE)!=1:
            if not ('vehicle' in subtype):
                AI_Animate(source,'unlock')
                AI_Animate(source,'melee_idle')
                return
    if (ffx.FFX_ObjectGetAttr(char,'grappleMental')==0) & (ffx.FFX_ObjectGetAttr(char,'grappleMystic')==0) & (ffx.FFX_ObjectGetAttr(char,'grappleEnergy')==0):
        ffx.FFX_ObjectSetAttr(char,'grapplePhysical',1)
        damage_type = m25ai.ai_damage_type['crushing']
        damage_mode = m25ai.ai_damage_mode['melee']
        if ffx.FFX_ObjectGetAttr(char,'ffactivedefense')==1:
            useStr=ffx.getByTemplate(source,FFX_RANGEGRAPPLE_CUSTOM,2)
            adHP=ffx.FFX_ObjectGetAttr(char,'ffactivedefenseHP')
            grappleDmg=ffx.getByTemplate(source,FFX_RANGEGRAPPLE_CUSTOM,4)
            if grappleDmg=='Yes':
                if useStr=='Yes':
                    grappleDmg=Object_GetAttr(source,'strength')+1
                else:
                    grappleDmg=ffx.getByTemplate(source,FFX_RANGEGRAPPLE_CUSTOM,3)
            else:
                grappleDmg=0
            newHP=adHP-grappleDmg
            ffx.FFX_ObjectSetAttr(char,'ffactivedefenseHP',newHP)
            if ffx.FFX_ObjectGetAttr(char,'ffactivedefenseSelf',0)==0:
                FFX_crushTest1a(char,source)
                return
            power=ffx.getByTemplate(char,FFX_FFACTIVEDEFENSE_CUSTOM,3)
            powdata = datfiles.Campaign_ReadPowers()[power]
            if powdata['PowerType'] == datfiles.PT_ACTIVE_DEFENCE:
                if ( powdata['DamageTypesBlocked'] & damage_type ) and \
                ( powdata['AttackModesBlocked'] & damage_mode ):
                    m25getset.GetObjectVar(char, 'defense ' + `damage_type` + '_' + `damage_mode`, 1,nosave=1)
                    AI_Animate(source,'unlock')
                    AI_Animate(source,'melee_idle')
                    return
        if ffx.FFX_HasPortrait(char):
            if not m25ai.AIInWatch(char):
                FFX_crushTest1a(char,source)
                return
        if m25ai.HasActiveDefenceActive(char,damage_type,damage_mode):
            AI_Animate(source,'unlock')
            AI_Animate(source,'melee_idle')
            return
        if ffx.FFX_ObjectGetAttr(char,'phased_out',0)==1:
            AI_Animate(source,'unlock')
            AI_Animate(source,'melee_idle')
            return
    makegrappled(char, source)

def FFX_crushTest1a(char,source):
    name=ffx.getDummyName()
    Object_SpawnAt('ffx_tiggot',Get_ObjectPos(source),name)
    Trigger_Power(name,char,'ffx_melee_crush_test','',10)
    ffx.FFX_ObjectSetAttr(char,'crushTestA',1)
    ffx.FFX_ObjectSetAttr(source,'crushTestA',1)
    ffx.RegTimer('ffx.destroyTemp',1,0,name)
    ffx.RegCharState(char,PCSTATE_STUNNED,'FFX_crushTest2a',0,0,source)
    ffx.RegTimer('FFX_crushTest3a',2,0,char,source)

def FFX_crushTest2a(event):
    char=event.object
    source=event.string
    if ffx.FFX_ObjectGetAttr(char,'crushTestA',0)==1:
        if ffx.FFX_ObjectGetAttr(source,'crushTestA',0)==1:
            ffx.FFX_ObjectSetAttr(source,'crushTestA',0)
            Object_SetPrimaryState(char,PCSTATE_STUNNED,0,REMOVE_STATE)
            makegrappled(char,source)
    ffx.FFX_ObjectSetAttr(char,'crushTestA',0)

def FFX_crushTest3a(event):
    char=event.object
    source=event.string
    ffx.FFX_ObjectSetAttr(source,'crushTestA',0)
    if ffx.FFX_ObjectGetAttr(char,'grappled',0)==0:
        AI_Animate(source,'unlock')
        AI_Animate(source,'melee_idle')
    else:
        AI_Animate(char,'pain')

def makegrappled(char,source):
    if ffx.FFX_ObjectGetAttr(char,'grappled',0)==1:
        return
    pos1 = Get_ObjectPos(char)
    pos2 = Get_ObjectPos(source)
    ffx.FFX_ObjectSetAttr(char,'grappled',1)
    ffx.FFX_ObjectSetAttr(source,'grappler',1)
    ffx.FFX_ObjectSetAttr(char,'lastY',pos1[1])
    ffx.FFX_ObjectSetAttr(char,'lastX',pos1[0])
    ffx.FFX_ObjectSetAttr(source,'lastY',pos2[1])
    ffx.FFX_ObjectSetAttr(source,'lastX',pos2[0])
    ffx.FFX_ObjectSetAttr(source,'gLastHealth',Object_GetAttr(source,'health'))
    grappleFX=ffx.getByTemplate(source,FFX_GRAPPLE_CUSTOM,1)
    if grappleFX!='':
        handle = Object_PlayEffect(char, grappleFX,'',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'centre')
        ffx.FFX_ObjectSetAttr(char,'grapple_handle',handle)
    ffx.FFX_ObjectSetAttr(source,'grapple_duration',12)
    AI_Animate(char,'pain')
    hasPortrait=ffx.FFX_HasPortrait(char)
    pcAIEnabled=m25ai.AIInWatch(char)
    if pcAIEnabled or not hasPortrait:
        m25ai.AIDisable(char)
    ffx.RegTimer('grappleStart',0.4,0,char,source)
    ffx.RegTimer('grappleLock',0.1,0,char,source)
    ffx.RegTimer('grappleMoveCheck',0.2,0,source,char)
    ffx.RegTimer('grappleEnergy',1,0,char,source)

def grappleCancel(event):
    source=event.object
    char=event.string
    if ffx.FFX_ObjectGetAttr(source,'grappler',0)==0:
        AI_Animate(source,'unlock')
        AI_Animate(source,'melee_idle')
    ffx.FFX_ObjectSetAttr(char,'grappled',0)
    ffx.FFX_ObjectSetAttr(source,'grappler',0)

def grappleLock(event):
    char=event.object
    source=event.string
    flailing=mlogreader.MLOG_IsFlailing(char)
    flailingS=mlogreader.MLOG_IsFlailing(source)
    if flailing:
        ffx.FFX_ObjectSetAttr(char,'grappled',0)
        ffx.FFX_ObjectSetAttr(source,'grappler',0)
        mlogreader.regGetupStop(char,'grappleRecover',0,0,0)
        if flailingS:
            mlogreader.regGetupStop(source,'grappleRecover',0,0,0)
        else:
            ffx.RegTimer('grappleRecover',1,0,source)
        return
    if flailingS:
        ffx.FFX_ObjectSetAttr(char,'grappled',0)
        ffx.FFX_ObjectSetAttr(source,'grappler',0)
        mlogreader.regGetupStop(source,'grappleRecover',0,0,0)
        if flailing:
            mlogreader.regGetupStop(char,'grappleRecover',0,0,0)
        else:
            ffx.RegTimer('grappleRecover',1,0,char)
        return
    if ffx.FFX_ObjectGetAttr(char,'grappled',0)==0:
        if ffx.FFX_ObjectGetAttr(char,'grappleBreak',0)==0:
            if Object_IsAlive(char)!=0:
                Trigger_Force(char,0,0,1,Object_GetAttr(char,'mass')*100,TF_ABSOLUTE)
            if ffx.FFX_ObjectGetAttr(char,'acrobatic',0)!=1:
                mlogreader.regGetupStop(char,'grappleRecover',0,0,0)
            else:
                ffx.RegTimer('grappleRecover',1,0,char)
        else:
            ffx.RegTimer('grappleRecover',1,0,char)
        ffx.RegTimer('grappleRecover',1,0,source)
        return
    if ffx.FFX_ObjectGetAttr(char,'grappled',0)==1:
        AI_Animate(char,'pain')
    ffx.RegTimer('grappleLock',0.3,0,char,source)

def grappleStart(event):
    char=event.object
    source=event.string
    if ffx.FFX_ObjectGetAttr(char,'grappled',0)==0:
        return
    if grappleBreakCheck(char,source):
        ffx.FFX_ObjectSetAttr(char,'grappled',0)
        ffx.FFX_ObjectSetAttr(source,'grappler',0)
        ffx.FFX_ObjectSetAttr(char,'grappleBreak',1)
        handle=ffx.FFX_ObjectGetAttr(char,'grapple_handle')
        Object_StopEffect(char,handle)
        return
    if Object_GetPrimaryState(char)==ffx.PCSTATE_EXILE:
        ffx.FFX_ObjectSetAttr(char,'grappled',0)
        ffx.FFX_ObjectSetAttr(source,'grappler',0)
        return
    grappledAgl=Object_GetAttr(char,'agility')-3
    ffx.FFX_ObjectSetAttr(char,'baseAgility',Object_GetAttr(char,'agility'))
    ffx.FFX_ObjectSetAttr(source,'baseAgility',Object_GetAttr(source,'agility'))
    Object_SetAttr(char,'energy',0)
    Object_SetAttr(source,'agility',grappledAgl)
    Object_SetAttr(char,'agility',0)
    grappleDmg(source,char)
    ffx.RegTimer('grappleCheck',3,0,char,source)

def grappleMoveCheck(event):#checks grappler's and target's conditions (movement, damage, Primary State, KOed)
    source = event.object
    char = event.string
    if ffx.FFX_ObjectGetAttr(char,'grappled',0)==0:
        return
    lasthealth=ffx.FFX_ObjectGetAttr(source,'gLastHealth')
    health=Object_GetAttr(source,'health')
    if health < lasthealth:
        ffx.FFX_ObjectSetAttr(char,'grappled',0)
        ffx.FFX_ObjectSetAttr(source,'grappler',0)
        return
    if (Object_GetPrimaryState(source)!=PCSTATE_NORMAL) | (Object_IsAlive(source)==0) | (ffx.FFX_ObjectGetAttr(source,'grappled',0)==1) | (ffx.FFX_ObjectGetAttr(source,'rangedgrappled',0)==1) | (ffx.FFX_ObjectGetAttr(source,'tangled',0)==1) | (ffx.FFX_ObjectGetAttr(source,'eTangled',0)==1) | (ffx.FFX_ObjectGetAttr(source,'thrownCharacter',0)==1):#if the grappler is koed, blanked, enraged, hexed, etc. cancel the grapple
        ffx.FFX_ObjectSetAttr(char,'grappled',0)
        ffx.FFX_ObjectSetAttr(source,'grappler',0)
        return
    if Object_GetPrimaryState(char)==ffx.PCSTATE_EXILE:
        ffx.FFX_ObjectSetAttr(char,'grappled',0)
        ffx.FFX_ObjectSetAttr(source,'grappler',0)
        return
    if (Object_IsAlive(char)==0):#if the target is koed, cancel the grapple
        ffx.FFX_ObjectSetAttr(char,'grappled',0)
        ffx.FFX_ObjectSetAttr(source,'grappler',0)
        return
    pos=Get_ObjectPos(source)
    pos2=Get_ObjectPos(char)
    dist=(pos[0]-ffx.FFX_ObjectGetAttr(source,'lastX'),pos[1]-ffx.FFX_ObjectGetAttr(source,'lastY'),0)
    dist2=(pos2[0]-ffx.FFX_ObjectGetAttr(char,'lastX'),pos2[1]-ffx.FFX_ObjectGetAttr(char,'lastY'),0)
    ffx.FFX_ObjectSetAttr(source,'lastY',pos[1])
    ffx.FFX_ObjectSetAttr(source,'lastX',pos[0])
    ffx.FFX_ObjectSetAttr(char,'lastY',pos2[1])
    ffx.FFX_ObjectSetAttr(char,'lastX',pos2[0])
    if (dist[0]*dist[0]+dist[1]*dist[1]) > 10:
        ffx.FFX_ObjectSetAttr(char,'grappled',0)
        ffx.FFX_ObjectSetAttr(source,'grappler',0)
        return
    elif (dist2[0]*dist2[0]+dist2[1]*dist2[1]) > 20:
        ffx.FFX_ObjectSetAttr(char,'grappled',0)
        ffx.FFX_ObjectSetAttr(source,'grappler',0)
        return
    ffx.FFX_ObjectSetAttr(source,'gLastHealth',health)
    flailing=mlogreader.MLOG_IsFlailing(char)
    myflailing=mlogreader.MLOG_IsFlailing(source)
    if not flailing:
        AI_Animate(char,'lock')
    if not myflailing:
        AI_Animate(source,'lock')
    ffx.RegTimer('grappleMoveCheck',0.7,0,source,char)

def grappleEnergy(event):
    char=event.object
    source=event.string
    if ffx.FFX_ObjectGetAttr(char,'grappled',0)==0:
        return
    epCost=10
    if ffx.FFX_ObjectGetAttr(char,'grappleMental',0)==1:
        targetStr=ffx.getMentalResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    elif ffx.FFX_ObjectGetAttr(char,'grappleMystic',0)==1:
        targetStr=ffx.getMysticalResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    elif ffx.FFX_ObjectGetAttr(char,'grappleEnergy',0)==1:
        targetStr=ffx.getEnergyResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    else:
        targetStr=Object_GetAttr(char,'strength')+1
        if ffx.FFX_ObjectGetAttr(char,'grappleCold',0)!=1:
            if ffx.hasAttribute(char,'wrestler'):
                targetStr=ffx.FFX_ObjectGetAttr(char,'wrestler')
    useStr=ffx.getByTemplate(source,FFX_GRAPPLE_CUSTOM,2)
    if useStr=='Yes':
        holdStr=Object_GetAttr(source,'strength')+1
        if ffx.FFX_ObjectGetAttr(char,'grappleCold',0)!=1:
            if ffx.hasAttribute(source,'wrestler'):
                holdStr=ffx.FFX_ObjectGetAttr(source,'wrestler')
    else:
        holdStr=ffx.getByTemplate(source,FFX_GRAPPLE_CUSTOM,3)
    if ffx.FFX_ObjectGetAttr(char,'grapplePhysical',0)!=1:
        epCost=epCost/targetStr
    else:
        if targetStr>holdStr:
            targetStr=targetStr+1
            strDiff=targetStr-holdStr
            epCost=epCost*strDiff
        if holdStr>targetStr:
            targetStr=targetStr-1
            strDiff=holdStr-targetStr
            epCost=epCost/strDiff
    energy=Object_GetAttr(source,'energyPoints')
    newEnergy=Object_GetAttr(source,'energyPoints')-epCost
    Object_SetAttr(source,'energyPoints',newEnergy)
    if newEnergy <= 0:
        ffx.FFX_ObjectSetAttr(char,'grappled',0)
        ffx.FFX_ObjectSetAttr(source,'grappler',0)
        ffx.FFX_ObjectSetAttr(char,'grappleBreak',1)
        return
    ffx.RegTimer('grappleEnergy',1,0,char,source)

def grappleBreakCheck(char,source):
    #calculate the target's resistance based on the kind of grapple(physical, mental, mystical, cold or energy)
    if ffx.FFX_ObjectGetAttr(char,'grappleMental',0)==1:
        targetStr=ffx.getMentalResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    elif ffx.FFX_ObjectGetAttr(char,'grappleMystic',0)==1:
        targetStr=ffx.getMysticalResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    elif ffx.FFX_ObjectGetAttr(char,'grappleEnergy',0)==1:
        targetStr=ffx.getEnergyResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    else:
        targetStr=Object_GetAttr(char,'strength')+1
        if ffx.FFX_ObjectGetAttr(char,'grappleCold',0)!=1:
            if ffx.hasAttribute(char,'wrestler'):
                targetStr=ffx.FFX_ObjectGetAttr(char,'wrestler')
    #calculate the grappler's hold strength (Strength Stat or Custom Value)
    useStr=ffx.getByTemplate(source,FFX_GRAPPLE_CUSTOM,2)
    if useStr=='Yes':
        holdStr=Object_GetAttr(source,'strength')+1
        if ffx.FFX_ObjectGetAttr(char,'grappleCold',0)!=1:
            if ffx.hasAttribute(source,'wrestler'):
                holdStr=ffx.FFX_ObjectGetAttr(source,'wrestler')
    else:
        holdStr=ffx.getByTemplate(source,FFX_GRAPPLE_CUSTOM,3)
    #calculate the difference in the grappler's and target's strength
    if ffx.FFX_ObjectGetAttr(char,'grapplePhysical',0)!=1:
        if targetStr==1:
            if holdStr < 7:
                holdStr=holdStr+2
            else:
                holdStr=holdStr+1
        if targetStr > 1:
            holdStr=(holdStr*0.5)+1.5
        if targetStr == 0.5:
            holdStr=holdStr*1.5
        if targetStr == 0.25:
            holdStr=holdStr*2.5
        chance=holdStr*targetStr
    else:
        if targetStr>holdStr:
            targetStr=targetStr+1
            strDiff=targetStr-holdStr
            chance=5-strDiff
        if targetStr==holdStr:
            chance=6
        if holdStr>targetStr:
            targetStr=targetStr-1
            strDiff=holdStr-targetStr
            chance=5+strDiff
    #calculate the chance to break free
    breakFree=randint(1,10)
    if breakFree > chance:
        return 1
    else:
        return 0

def grappleDmg(source,char):
    #apply damage if hold is successful
    if ffx.FFX_ObjectGetAttr(char,'grappleMental',0)==1:
        targetStr=ffx.getMentalResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    elif ffx.FFX_ObjectGetAttr(char,'grappleMystic',0)==1:
        targetStr=ffx.getMysticalResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    elif ffx.FFX_ObjectGetAttr(char,'grappleEnergy',0)==1:
        targetStr=ffx.getEnergyResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    useStr=ffx.getByTemplate(source,FFX_GRAPPLE_CUSTOM,2)
    grappleDmg=ffx.getByTemplate(source,FFX_GRAPPLE_CUSTOM,4)
    if grappleDmg=='Yes':
        if useStr=='Yes':
            grappleDmg=Object_GetAttr(source,'strength')+1
        else:
            grappleDmg=ffx.getByTemplate(source,FFX_GRAPPLE_CUSTOM,3)
    else:
        grappleDmg=0
    if grappleDmg > 0:
        baseDmg=grappleDmg*2
        if ffx.FFX_ObjectGetAttr(char,'grapplePhysical',0)!=1:
            damage=baseDmg*targetStr
        else:
            if ffx.FFX_ObjectGetAttr(char,'grappleCold',0)==1:
                targetStr=ffx.getColdResistanceValue(char,passive=0,active=0,attribs=1,states=1,material=1)
            else:
                targetStr=ffx.getCrushResistanceValue(char,passive=0,active=0,attribs=1,states=1,material=1)
            damage=baseDmg*targetStr
        if damage < 1:
            damage=1
        if (ffx.FFX_ObjectGetAttr(char,'grappleMental')==1) | (ffx.FFX_ObjectGetAttr(char,'grappleMystic')==1):
            ffx.FFX_ApplyDamage(char,damage,mental=1)
        else:
            if damage > 0:
                ffx.FFX_ApplyDamage(char,damage,mental=0)

def grappleCheck(event):
    char=event.object
    source=event.string
    if ffx.FFX_ObjectGetAttr(char,'grappled',0)==0:
        return
    duration=ffx.FFX_ObjectGetAttr(source,'grapple_duration')-3
    if duration<=0:
        ffx.FFX_ObjectSetAttr(char,'grappled',0)
        ffx.FFX_ObjectSetAttr(source,'grappler',0)
        return
    if Object_GetPrimaryState(char)!=PCSTATE_NORMAL:
        ffx.FFX_ObjectSetAttr(source,'grapple_duration',duration)
        ffx.RegTimer('grappleCheck',3,0,char,source)
        return
    if grappleBreakCheck(char,source):
        ffx.FFX_ObjectSetAttr(char,'grappled',0)
        ffx.FFX_ObjectSetAttr(source,'grappler',0)
        ffx.FFX_ObjectSetAttr(char,'grappleBreak',1)
        return
    ffx.FFX_ObjectSetAttr(source,'grapple_duration',duration)
    grappleDmg(source,char)
    ffx.RegTimer('grappleCheck',3,0,char,source)

def grappleRecover(event):
    char=event.object
    if Object_IsAlive(char)==0:
        return
    flailing=mlogreader.MLOG_IsFlailing(char)
    if flailing:
        mlogreader.regGetupStop(char,'grappleRecover',0,0,0)
        return
    agility=ffx.FFX_ObjectGetAttr(char,'baseAgility')
    Object_SetAttr(char,'agility',agility)
    baseEnergy=ffx.FFX_ObjectGetAttr(char,'baseEnergy')
    energy=Object_GetAttr(char,'energy')
    if baseEnergy!=energy:
        Object_SetAttr(char,'energy',baseEnergy)
    AI_Animate(char,'unlock')
    hasPortrait=ffx.FFX_HasPortrait(char)
    pcAIEnabled=m25ai.AIInWatch(char)
    if pcAIEnabled or not hasPortrait:
        m25ai.ClearAIStandardOnly(char)
        m25ai.AIEnable(char)
        m25ai.AIEnableCustom(char)
        m25ai.SetBrawler(char)
        m25event.SetTimer(1.0, 'm25ai.AIRecoverBroken', char, user=m25ai.GetAITimeStamp(char))
    if ffx.FFX_ObjectGetAttr(char,'grappleBreak',0)==1:
        if ffx.FFX_ObjectGetAttr(char,'grappleMystic',0)==1:
            AI_Animate(char,'recover_from_stun')
        elif ffx.FFX_ObjectGetAttr(char,'grappleMental',0)==1:
            AI_Animate(char,'recover_from_stun')
        else:
            AI_Animate(char,'swing_pole')
        ffx.FFX_ObjectSetAttr(char,'grappleBreak',0)
    else:
        AI_Animate(char,'melee_idle')
    handle=ffx.FFX_ObjectGetAttr(char,'grapple_handle')
    Object_StopEffect(char,handle)
    ffx.FFX_ObjectSetAttr(char,'grappleMental',0)
    ffx.FFX_ObjectSetAttr(char,'grappleMystic',0)
    ffx.FFX_ObjectSetAttr(char,'grappleCold',0)
    ffx.FFX_ObjectSetAttr(char,'grappleEnergy',0)
    ffx.FFX_ObjectSetAttr(char,'grapplePhysical',0)
    ffx.RegTimer('grappleRecover2a',1,0,char)

def grappleRecover2a(event):
    char=event.object
    if Object_IsAlive(char)==0:
        return
    pos=Get_ObjectPos(char)
    ffx.FFX_ObjectSetAttr(char,'lastY',pos[1])
    ffx.FFX_ObjectSetAttr(char,'lastX',pos[0])
    ffx.RegTimer('grappleRecover2b',5,0,char)

def grappleRecover2b(event):
    char=event.object
    if Object_IsAlive(char)==0:
        return
    flailing=mlogreader.MLOG_IsFlailing(char)
    getup=mlogreader.MLOG_IsGettingUp(char)
    pos=Get_ObjectPos(char)
    dist=(pos[0]-ffx.FFX_ObjectGetAttr(char,'lastX'),pos[1]-ffx.FFX_ObjectGetAttr(char,'lastY'),0)
    ffx.FFX_ObjectSetAttr(char,'lastY',pos[1])
    ffx.FFX_ObjectSetAttr(char,'lastX',pos[0])
    if ffx.FFX_ObjectGetAttr(char,'grappled',0)==1:
        return
    if ffx.FFX_ObjectGetAttr(char,'grappler',0)==1:
        return
    if flailing:
        mlogreader.regGetupStop(char,'grappleRecover2b',0,0,0)
        return
    if getup:
        mlogreader.regGetupStop(char,'grappleRecover2b',0,0,0)
        return
    if (dist[0]*dist[0]+dist[1]*dist[1]) > 10:
        return
    if not m25ai.IsPerformingTactic(char):
        AI_Animate(char,'unlock')
        hasPortrait=ffx.FFX_HasPortrait(char)
        pcAIEnabled=m25ai.AIInWatch(char)
        if pcAIEnabled or not hasPortrait:
            m25ai.ClearAIStandardOnly(char)
            m25ai.AIEnable(char)
            m25ai.AIEnableCustom(char)
            m25ai.SetBrawler(char)
            m25event.SetTimer(1.0, 'm25ai.AIRecoverBroken', char, user=m25ai.GetAITimeStamp(char))
    ffx.RegTimer('grappleRecover2b',5,0,char)


############################### Throw2 ###########################################

def stuntothrow2(event):
    throw2P(event,PCSTATE_STUNNED,1)
def hypnosistothrow2(event):
    throw2P(event,PCSTATE_HYPNOTISED,ffx.COST_HYPNO)
def ragetothrow2(event):
    throw2P(event,PCSTATE_ENRAGED,ffx.COST_RAGE)
def exiletothrow2(event):
    throw2P(event,PCSTATE_EXILE,ffx.COST_EXILE)
def blanktothrow2(event):
    throw2P(event,PCSTATE_BLANK,ffx.COST_BLANK)
def panictothrow2(event):
    throw2P(event,PCSTATE_PANICKED,ffx.COST_PANIC)
def frozentothrow2(event):
    throw2P(event,PCSTATE_FROZEN,ffx.COST_FROZEN)
def stasistothrow2(event):
    throw2P(event,PCSTATE_STATIC,ffx.COST_STASIS)

def hextothrow2(event):
    throw2S(event,SCSTATE_HEXED,ffx.COST_HEX)
def blindtothrow2(event):
    throw2S(event,SCSTATE_BLIND,ffx.COST_BLIND)
def powernulltothrow2(event):
    throw2S(event,SCSTATE_POWER_NULLIFICATION,ffx.COST_NULL)
def weakentothrow2(event):
    throw2S(event,SCSTATE_WEAKENED,ffx.COST_WEAKEN)
def speeddecreasetothrow2(event):
    throw2S(event,SCSTATE_SPEED_DECREASED,ffx.COST_DECREASE)

def speedincreasetothrow2(event):
    throw2S(event,SCSTATE_SPEED_INCREASED,ffx.COST_INCREASE)

def energisetothrow2(event):
    char=event.object
    source=event.string
    if ffx.FFX_ObjectGetAttr(source,'throwCharacter',0)==1:#prevents it from running twice
        return
    direction=Vector_Sub(Get_ObjectPos(source),Get_ObjectPos(char))
    d=1+sqrt(direction[0]*direction[0]+direction[1]*direction[1])
    meshSize=ffx.getByTemplate(source,FFX_THROW2_CUSTOM,1)
    subtype = m25ai.FindTacticType(char, 'subtype')
    #if the target moved to far away and the thrower is not a giant then cancel the throw
    if d > 50:
        if (Object_GetClass(char)&js.OC_VEHICLE)==0:
            if not ('vehicle' in subtype):
                if meshSize < 2:
                    Object_SetSecondaryState(char,SCSTATE_ENERGIZED,0,REMOVE_STATE)
                    return
    if ffx.FFX_ObjectGetAttr(char,'phased',0)==1:
        Object_SetSecondaryState(char,SCSTATE_ENERGIZED,0,REMOVE_STATE)
        return
    if Object_GetSecondaryStates(char)&SCSTATE_ENERGIZED:
        Object_SetSecondaryState(char,SCSTATE_ENERGIZED,0,REMOVE_STATE)
        ffx.FFX_ObjectSetAttr(source,'throwCharacter',0)
        if meshSize > 3.5:
            objMass=Object_GetAttr(char,'mass')
            direction=Vector_Sub(Get_ObjectPos(char),Get_ObjectPos(source))
            d=1+sqrt(direction[0]*direction[0]+direction[1]*direction[1])
            dx=direction[0]/d
            dy=direction[1]/d
            magnitude=objMass*300
            lift_time=ffx.getByTemplate(source,FFX_THROW2_CUSTOM,2)
            if lift_time > 0.3:
                ffx.RegTimer('throw2TargetLock',0.2,0,char)
            if meshSize > 10:
                magnitude=objMass*750
            Trigger_Force(char,dx,dy,1,magnitude,TF_ABSOLUTE)
        else:
            ffx.RegTimer('throw2TargetLock',0.1,0,char)
        ffx.FFX_UpdateStates(char)
        throwCharacterADCheck(char,source)

def energysurgetothrow2(event):
    char=event.object
    source=event.string
    if ffx.FFX_ObjectGetAttr(source,'throwCharacter',0)==1:#prevents it from running twice
        return
    direction=Vector_Sub(Get_ObjectPos(source),Get_ObjectPos(char))
    d=1+sqrt(direction[0]*direction[0]+direction[1]*direction[1])
    meshSize=ffx.getByTemplate(source,FFX_THROW2_CUSTOM,1)
    subtype = m25ai.FindTacticType(char, 'subtype')
    #if the target moved to far away and the thrower is not a giant then cancel the throw
    if d > 50:
        if (Object_GetClass(char)&js.OC_VEHICLE)==0:
            if not ('vehicle' in subtype):
                if meshSize < 2:
                    Object_SetSecondaryState(char,SCSTATE_AREA_ENERGIZED,0,REMOVE_STATE)
                    return
    if ffx.FFX_ObjectGetAttr(char,'phased',0)==1:
        Object_SetSecondaryState(char,SCSTATE_AREA_ENERGIZED,0,REMOVE_STATE)
        return
    if Object_GetSecondaryStates(char)&SCSTATE_AREA_ENERGIZED:
        Object_SetSecondaryState(char,SCSTATE_AREA_ENERGIZED,0,REMOVE_STATE)
        ffx.FFX_ObjectSetAttr(source,'throwCharacter',0)
        if meshSize > 3.5:
            objMass=Object_GetAttr(char,'mass')
            direction=Vector_Sub(Get_ObjectPos(char),Get_ObjectPos(source))
            d=1+sqrt(direction[0]*direction[0]+direction[1]*direction[1])
            dx=direction[0]/d
            dy=direction[1]/d
            magnitude=objMass*300
            lift_time=ffx.getByTemplate(source,FFX_THROW2_CUSTOM,2)
            if lift_time > 0.3:
                ffx.RegTimer('throw2TargetLock',0.2,0,char)
            if meshSize > 10:
                magnitude=objMass*750
            Trigger_Force(char,dx,dy,1,magnitude,TF_ABSOLUTE)
        else:
            ffx.RegTimer('throw2TargetLock',0.1,0,char)
        ffx.FFX_UpdateStates(char)
        throwCharacterADCheck(char,source)

def densitytothrow2(event):
    char=event.object
    source=event.string
    if ffx.FFX_ObjectGetAttr(source,'throwCharacter',0)==1:#prevents it from running twice
        return
    direction=Vector_Sub(Get_ObjectPos(source),Get_ObjectPos(char))
    d=1+sqrt(direction[0]*direction[0]+direction[1]*direction[1])
    meshSize=ffx.getByTemplate(source,FFX_THROW2_CUSTOM,1)
    subtype = m25ai.FindTacticType(char, 'subtype')
    #if the target moved to far away and the thrower is not a giant then cancel the throw
    if d > 50:
        if (Object_GetClass(char)&js.OC_VEHICLE)==0:
            if not ('vehicle' in subtype):
                if meshSize < 2:
                    return
    if ffx.densityaltered(char):
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        ffx.FFX_ObjectSetAttr(source,'throwCharacter',0)
        if meshSize > 3.5:
            objMass=Object_GetAttr(char,'mass')
            direction=Vector_Sub(Get_ObjectPos(char),Get_ObjectPos(source))
            d=1+sqrt(direction[0]*direction[0]+direction[1]*direction[1])
            dx=direction[0]/d
            dy=direction[1]/d
            magnitude=objMass*300
            lift_time=ffx.getByTemplate(source,FFX_THROW2_CUSTOM,2)
            if lift_time > 0.3:
                ffx.RegTimer('throw2TargetLock',0.2,0,char)
            if meshSize > 10:
                magnitude=objMass*750
            Trigger_Force(char,dx,dy,1,magnitude,TF_ABSOLUTE)
        else:
            ffx.RegTimer('throw2TargetLock',0.1,0,char)
        ffx.FFX_UpdateStates(char)
        throwCharacterADCheck(char,source)

def throw2S(event,state,intensity):
    char=event.object
    source=event.string
    if ffx.FFX_ObjectGetAttr(source,'throwCharacter',0)==1:#prevents it from running twice
        return
    direction=Vector_Sub(Get_ObjectPos(source),Get_ObjectPos(char))
    d=1+sqrt(direction[0]*direction[0]+direction[1]*direction[1])
    meshSize=ffx.getByTemplate(source,FFX_THROW2_CUSTOM,1)
    subtype = m25ai.FindTacticType(char, 'subtype')
    #if the target moved to far away and the thrower is not a giant then cancel the throw
    if d > 50:
        if (Object_GetClass(char)&js.OC_VEHICLE)==0:
            if not ('vehicle' in subtype):
                if meshSize < 2:
                    return
    if Object_GetSecondaryStates(char)&state:
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        ffx.FFX_ObjectSetAttr(source,'throwCharacter',0)
        if meshSize > 3.5:
            objMass=Object_GetAttr(char,'mass')
            direction=Vector_Sub(Get_ObjectPos(char),Get_ObjectPos(source))
            d=1+sqrt(direction[0]*direction[0]+direction[1]*direction[1])
            dx=direction[0]/d
            dy=direction[1]/d
            magnitude=objMass*300
            lift_time=ffx.getByTemplate(source,FFX_THROW2_CUSTOM,2)
            if lift_time > 0.3:
                ffx.RegTimer('throw2TargetLock',0.2,0,char)
            if meshSize > 10:
                magnitude=objMass*750
            Trigger_Force(char,dx,dy,1,magnitude,TF_ABSOLUTE)
        else:
            ffx.RegTimer('throw2TargetLock',0.1,0,char)
        ffx.FFX_UpdateStates(char)
        throwCharacterADCheck(char,source)

def throw2P(event,state,intensity):
    char=event.object
    source=event.string
    if ffx.FFX_ObjectGetAttr(source,'throwCharacter',0)==1:#prevents it from running twice
        return
    direction=Vector_Sub(Get_ObjectPos(source),Get_ObjectPos(char))
    d=1+sqrt(direction[0]*direction[0]+direction[1]*direction[1])
    meshSize=ffx.getByTemplate(source,FFX_THROW2_CUSTOM,1)
    subtype = m25ai.FindTacticType(char, 'subtype')
    #if the target moved to far away and the thrower is not a giant then cancel the throw
    if d > 50:
        if (Object_GetClass(char)&js.OC_VEHICLE)==0:
            if not ('vehicle' in subtype):
                if meshSize < 2:
                    return
    if Object_GetPrimaryState(char)==state:
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        ffx.FFX_ObjectSetAttr(source,'throwCharacter',0)
        if state==PCSTATE_STATIC:
            ffx.FFX_ObjectSetAttr(char,'throw2CharStatis',1)
        else:
            if meshSize > 3.5:
                objMass=Object_GetAttr(char,'mass')
                direction=Vector_Sub(Get_ObjectPos(char),Get_ObjectPos(source))
                d=1+sqrt(direction[0]*direction[0]+direction[1]*direction[1])
                dx=direction[0]/d
                dy=direction[1]/d
                magnitude=objMass*300
                lift_time=ffx.getByTemplate(source,FFX_THROW2_CUSTOM,2)
                if lift_time > 0.3:
                    ffx.RegTimer('throw2TargetLock',0.2,0,char)
                if meshSize > 10:
                    magnitude=objMass*750
                Trigger_Force(char,dx,dy,1,magnitude,TF_ABSOLUTE)
            else:
                ffx.RegTimer('throw2TargetLock',0.1,0,char)
        ffx.FFX_UpdateStates(char)
        throwCharacterADCheck(char,source)

def throwCharacterADCheck(char,source):
    damage_type = m25ai.ai_damage_type['crushing']
    damage_mode = m25ai.ai_damage_mode['melee']
    if ffx.FFX_ObjectGetAttr(char,'ffactivedefense')==1:
        if ffx.FFX_ObjectGetAttr(char,'ffactivedefenseSelf',0)==0:
            FFX_crushTestThrow(char,source)
            return
        power=ffx.getByTemplate(char,FFX_FFACTIVEDEFENSE_CUSTOM,3)
        powdata = datfiles.Campaign_ReadPowers()[power]
        if powdata['PowerType'] == datfiles.PT_ACTIVE_DEFENCE:
            if ( powdata['DamageTypesBlocked'] & damage_type ) and \
            ( powdata['AttackModesBlocked'] & damage_mode ):
                m25getset.GetObjectVar(char, 'defense ' + `damage_type` + '_' + `damage_mode`, 1,nosave=1)
                AI_Animate(source,'unlock')
                AI_Animate(source,'melee_idle')
                return
    if ffx.FFX_HasPortrait(char):
        if not m25ai.AIInWatch(char):
            FFX_crushTestThrow(char,source)
            return
    if m25ai.HasActiveDefenceActive(char,damage_type,damage_mode):
        AI_Animate(source,'unlock')
        AI_Animate(source,'melee_idle')
        return
    ffx.RegTimer('throw2TriggerFlail',0.1,0,char,source)
    throwCharacter(char,source)

def FFX_crushTestThrow(char,source):
    name=ffx.getDummyName()
    Object_SpawnAt('ffx_tiggot',Get_ObjectPos(source),name)
    Trigger_Power(name,char,'ffx_melee_crush_test','',10)
    ffx.FFX_ObjectSetAttr(char,'crushTestThrow',1)
    ffx.FFX_ObjectSetAttr(source,'crushTestThrow',1)
    ffx.RegTimer('ffx.destroyTemp',1,0,name)
    ffx.RegCharState(char,PCSTATE_STUNNED,'FFX_crushTestThrow2',0,0,source)
    ffx.RegTimer('FFX_crushTestThrow3',2,0,char,source)
    AI_Animate(source,'lock')

def FFX_crushTestThrow2(event):
    char=event.object
    source=event.string
    if ffx.FFX_ObjectGetAttr(char,'crushTestThrow',0)==1:
        if ffx.FFX_ObjectGetAttr(source,'crushTestThrow',0)==1:
            AI_Animate(source,'lock')
            ffx.FFX_ObjectSetAttr(source,'crushTestThrow',0)
            Object_SetPrimaryState(char,PCSTATE_STUNNED,0,REMOVE_STATE)
            meshSize=ffx.getByTemplate(source,FFX_THROW2_CUSTOM,1)
            ffx.FFX_ObjectSetAttr(source,'throw2Start',1)
            if meshSize > 3.5:
                objMass=Object_GetAttr(char,'mass')
                direction=Vector_Sub(Get_ObjectPos(char),Get_ObjectPos(source))
                d=1+sqrt(direction[0]*direction[0]+direction[1]*direction[1])
                dx=direction[0]/d
                dy=direction[1]/d
                magnitude=objMass*300
                if meshSize > 10:
                    magnitude=objMass*750
                Trigger_Force(char,dx,dy,1,magnitude,TF_ABSOLUTE)
            else:
                Trigger_Force(char,0,0,0.5,Object_GetAttr(char,'mass')*100,TF_ABSOLUTE)
            lift_time=ffx.getByTemplate(source,FFX_THROW2_CUSTOM,2)
            if lift_time > 0.3:
                ffx.RegTimer('throw2TargetLock',0.2,0,char)
            throwCharacter(char,source)
    ffx.FFX_ObjectSetAttr(char,'crushTestThrow',0)

def FFX_crushTestThrow3(event):
    char=event.object
    source=event.string
    ffx.FFX_ObjectSetAttr(source,'crushTestThrow',0)
    if ffx.FFX_ObjectGetAttr(source,'throwCharacter',0)==0:
        AI_Animate(source,'unlock')
        AI_Animate(source,'melee_idle')

def throwCharacter(char,source):
    subtype = m25ai.FindTacticType(char, 'subtype')
    direction=Vector_Sub(Get_ObjectPos(source),Get_ObjectPos(char))
    d=1+sqrt(direction[0]*direction[0]+direction[1]*direction[1])
    if d > 50:
        if (Object_GetClass(char)&js.OC_VEHICLE)!=1:
            if not ('vehicle' in subtype):
                return
    objMass=Object_GetAttr(char,'mass')
    if ffx.FFX_ObjectGetAttr(char, 'FFQRootedStill', 0)!=0:
        objMass=Object_GetAttr(char,'mass')+5500
    liftStr=Object_GetAttr(source,'strength')+1
    if ffx.hasAttribute(source, 'heavylifter') or ffx.hasAttribute(source, 'heavy lifter'):
        liftStr=Object_GetAttr(source,'strength')+4
    weight = {1: 10, 2: 50, 3: 100, 4: 250, 5: 500, 6: 800, 7: 1000, 8: 1500, 9: 2000, 10: 4000, 11: 6000, 12: 8000, 13: 10000}
    if objMass > weight[liftStr]:
        Mission_StatusText('target is to heavy to throw!')
        ffx.FFX_ObjectSetAttr(char,'throw2Heavy',1)
        AI_Animate(source,'lock')
        ffx.RegTimer('finishThrow2b',1,0,source)
        return
    pos=Get_ObjectPos(source)
    ffx.FFX_ObjectSetAttr(source,'lastY',pos[1])
    ffx.FFX_ObjectSetAttr(source,'lastX',pos[0])
    ffx.FFX_ObjectSetAttr(source,'throw2Start',0)
    ffx.FFX_ObjectSetAttr(source,'throwCharacter',1)
    ffx.FFX_ObjectSetAttr(source,'throw2LastHealth',Object_GetAttr(source,'health'))
    anim=ffx.getByTemplate(source,FFX_THROW2_CUSTOM,4)
    if anim=='':
        pickup_time=m25generateai.GetAnimationTime(source,'pick_up_object')-0.2#time to wait before using throw_object animation
        AI_Animate(source,'pick_up_object')
    else:
        pickup_time=m25generateai.GetAnimationTime(source,anim)-0.2#time to wait before using throw_object animation
        AI_Animate(source,anim)
    ffx.RegTimer('animateThrow2',pickup_time,0,source)
    lift_time=ffx.getByTemplate(source,FFX_THROW2_CUSTOM,2)#time to wait before lifting target into the air
    mlogreader.regDodgeStart(source,'throw2Cancel',0,0,0,char)
    ffx.RegTimer('throw2Pickup',lift_time,0,char,source)
    ffx.RegTimer('throw2MoveCheck',0.5,0,source,char)

def throw2TriggerFlail(event):
    char=event.object
    source=event.string
    if ffx.FFX_ObjectGetAttr(source,'throwCharacter',0)==0:#if target was too heavy, cancel
        return
    if ffx.FFX_ObjectGetAttr(source,'throw2Start',0)==1:#if throw is already started, cancel
        return
    if ffx.FFX_ObjectGetAttr(char,'throw2CharStatis',0)==1:#if char was under stasis and had it removed
        return
    meshSize=ffx.getByTemplate(source,FFX_THROW2_CUSTOM,1)
    ffx.FFX_ObjectSetAttr(source,'throw2Start',1)
    h=1
    dx=0
    dy=0
    magnitude=Object_GetAttr(char,'mass')*100
    if meshSize > 3.5:
        objMass=Object_GetAttr(char,'mass')
        direction=Vector_Sub(Get_ObjectPos(char),Get_ObjectPos(source))
        d=1+sqrt(direction[0]*direction[0]+direction[1]*direction[1])
        dx=direction[0]/d
        dy=direction[1]/d
        magnitude=objMass*300
        if meshSize > 10:
            magnitude=objMass*750
        Trigger_Force(char,dx,dy,h,magnitude,TF_ABSOLUTE)
        lift_time=ffx.getByTemplate(source,FFX_THROW2_CUSTOM,2)
        if lift_time > 0.3:
            ffx.RegTimer('throw2TargetLock',0.1,0,char)
        return
    subtype = m25ai.FindTacticType(char, 'subtype')
    if ((Object_GetClass(char)&js.OC_VEHICLE)!=0) | ('vehicle' in subtype):
        h=1.3
        magnitude=Object_GetAttr(char,'mass')*130
    Trigger_Force(char,0,0,h,magnitude,TF_ABSOLUTE)
    lift_time=ffx.getByTemplate(source,FFX_THROW2_CUSTOM,2)
    if lift_time > 0.3:
        ffx.RegTimer('throw2TargetLock',0.2,0,char)

def throw2TargetLock(event):
    char=event.object
    if ffx.FFX_ObjectGetAttr(char,'throw2Heavy',0)!=0:#if target was too heavy, cancel
        ffx.FFX_ObjectSetAttr(char,'throw2Heavy',0)
        return
    hasPortrait=ffx.FFX_HasPortrait(char)
    pcAIEnabled=m25ai.AIInWatch(char)
    if pcAIEnabled or not hasPortrait:
        m25ai.AIDisable(char)
    AI_Animate(char,'lock')

def throw2Cancel(event):
    source=event.object
    char=event.string
    ffx.FFX_ObjectSetAttr(source,'throwCharacter',0)
    if ffx.FFX_ObjectGetAttr(char,'thrownCharacter',0)==1:
        Trigger_Force(char,0,0,1,Object_GetAttr(char,'mass')*100,TF_ABSOLUTE)

def animateThrow2(event):
    source=event.object
    if ffx.FFX_ObjectGetAttr(source,'throwCharacter',0)==1:
        ffx.FFX_ObjectSetAttr(source,'throw2Start',0)
        AI_Animate(source,'throw_object')

def throw2MoveCheck(event):#checks if the thrower is moved by the player and if the thrower is not in a normal state
    source = event.object
    char = event.string
    if ffx.FFX_ObjectGetAttr(source,'throwCharacter',0)==0:
        return
    lasthealth=ffx.FFX_ObjectGetAttr(source,'throw2LastHealth')
    health=Object_GetAttr(source,'health')
    if health < lasthealth:
        ffx.FFX_ObjectSetAttr(source,'throwCharacter',0)
        Trigger_Force(char,0,0,1,Object_GetAttr(char,'mass')*100,TF_ABSOLUTE)
        return
    if (Object_GetPrimaryState(source)!=PCSTATE_NORMAL) | (Object_IsAlive(source)==0):#if the thrower is koed or is blanked, enraged, etc. cancel the throw
        ffx.FFX_ObjectSetAttr(source,'throwCharacter',0)
        Trigger_Force(char,0,0,1,Object_GetAttr(char,'mass')*100,TF_ABSOLUTE)
        return
    pos=Get_ObjectPos(source)
    dist=(pos[0]-ffx.FFX_ObjectGetAttr(source,'lastX'),pos[1]-ffx.FFX_ObjectGetAttr(source,'lastY'),0)
    ffx.FFX_ObjectSetAttr(source,'lastY',pos[1])
    ffx.FFX_ObjectSetAttr(source,'lastX',pos[0])
    flailing=mlogreader.MLOG_IsFlailing(char)
    myflailing=mlogreader.MLOG_IsFlailing(source)
    if flailing:
        mlogreader.regGetupStop(char, 'finishThrow2a', 0, 0, 0, source)
    if myflailing:
        mlogreader.regGetupStop(source, 'finishThrow2a', 0, 0, 0, char)
    if (dist[0]*dist[0]+dist[1]*dist[1]) > 10:
        ffx.FFX_ObjectSetAttr(source,'throwCharacter',0)
        Trigger_Force(char,0,0,1,Object_GetAttr(char,'mass')*100,TF_ABSOLUTE)
        return
    else:
        ffx.FFX_ObjectSetAttr(source,'throw2LastHealth',health)
        ffx.RegTimer('throw2MoveCheck',0.2,0,source,char)

def throw2Pickup(event):
    char=event.object
    source=event.string
    if ffx.FFX_ObjectGetAttr(source,'throwCharacter',0)==0:
        ffx.RegTimer('throw2Recover',1,0,char)
        return
    ffx.FFX_ObjectSetAttr(char,'thrownCharacter',1)
    direction=Vector_Sub(Get_ObjectPos(source),Get_ObjectPos(char))
    d=1+sqrt(direction[0]*direction[0]+direction[1]*direction[1])
    dx=direction[0]/d
    dy=direction[1]/d
    objMass=Object_GetAttr(char,'mass')
    h=1.5

    # adjust for weight
    if objMass < 121:
        magnitude=objMass*150
    if objMass > 121:
        if objMass < 176:
            magnitude=objMass*155
    if objMass > 175:
        magnitude=objMass*160

    # adjust for distance
    if d<40:
        h=2
        if objMass < 121:
            magnitude=objMass*160

        if objMass > 121:
            if objMass < 176:
                magnitude=objMass*165

        if objMass > 175:
            magnitude=objMass*170
    if d<30:
        h=3
        if objMass < 121:
            magnitude=objMass*162
        if objMass > 121:
            if objMass < 176:
                magnitude=objMass*167
        if objMass > 175:
            magnitude=objMass*175
    if d<20:
        h=4
        if objMass < 121:
            magnitude=objMass*165
        if objMass > 121:
            if objMass < 176:
                magnitude=objMass*170
        if objMass > 175:
            magnitude=objMass*180

    # adjust for thrower mesh size
    meshSize=ffx.getByTemplate(source,FFX_THROW2_CUSTOM,1)
    magnitude=magnitude*meshSize
    h=h*meshSize
    locktime=0.35
    ffx.FFX_ObjectSetAttr(char,'throw2Lgdy',dy)
    ffx.FFX_ObjectSetAttr(char,'throw2Lgdx',dx)
    if meshSize > 2:
        time=0.4
        if meshSize > 10:
            locktime=1
            time=1.1
        ffx.RegTimer('throwCharacter1',locktime,0,char,source)#wait this long until locking the target over the thrower
        ffx.RegTimer('throwCharacter1a',time,0,char,source)
        Trigger_Force(char,0,0,h,magnitude,TF_ABSOLUTE)
        return

    # adjust for target mesh size
    subtype = m25ai.FindTacticType(char, 'subtype')
    if ((Object_GetClass(char)&js.OC_VEHICLE)!=0) | ('vehicle' in subtype):
        locktime=0.5
        magnitude=magnitude*1.25
        ffx.RegTimer('throwCharacter1',locktime,0,char,source)#wait this long until locking the target over the thrower
        ffx.RegTimer('throwCharacter1a',0.7,0,char,source)
        Trigger_Force(char,0,0,h,magnitude,TF_ABSOLUTE)
        return

    ffx.RegTimer('throwCharacter1',locktime,0,char,source)#wait this long until locking the target over the thrower
    Trigger_Force(char,dx,dy,h,magnitude,TF_ABSOLUTE)

def throwCharacter1(event):
    char=event.object
    source=event.string
    if ffx.FFX_ObjectGetAttr(source,'throwCharacter',0)==0:
        ffx.RegTimer('throw2Recover',1,0,char)
        return
    AI_Animate(char,'lock')
    throw_time=ffx.getByTemplate(source,FFX_THROW2_CUSTOM,3)#time to wait until target is thrown forward
    ffx.RegTimer('throwCharacter2',throw_time,0,char,source)

def throwCharacter1a(event):
    char=event.object
    source=event.string
    if ffx.FFX_ObjectGetAttr(source,'throwCharacter',0)==0:
        ffx.RegTimer('throw2Recover',1,0,char)
        return
    dy=ffx.FFX_ObjectGetAttr(char,'throw2Lgdy')
    dx=ffx.FFX_ObjectGetAttr(char,'throw2Lgdx')
    objMass=Object_GetAttr(char,'mass')
    magnitude=objMass*180
    time = 0.2
    meshSize=ffx.getByTemplate(source,FFX_THROW2_CUSTOM,1)
    if meshSize > 6:
        magnitude=objMass*200
        time = 0.3
    Trigger_Force(char,dx,dy,1,magnitude,TF_ABSOLUTE)
    ffx.RegTimer('throwCharacter1b',time,0,char,source)

def throwCharacter1b(event):
    char=event.object
    source=event.string
    if ffx.FFX_ObjectGetAttr(source,'throwCharacter',0)==0:
        ffx.RegTimer('throw2Recover',1,0,char)
        return
    AI_Animate(char,'lock')

def throwCharacter2(event):
    char=event.object
    source=event.string
    if ffx.FFX_ObjectGetAttr(source,'throwCharacter',0)==0:
        ffx.RegTimer('throw2Recover',1,0,char)
        return
    direction=Vector_Sub(Get_ObjectPos(char),Get_ObjectPos(source))
    throwStr=Object_GetAttr(source,'strength')+1
    if ffx.hasAttribute(source, 'heavylifter') or ffx.hasAttribute(source, 'heavy lifter'):
        throwStr=Object_GetAttr(source,'strength')+4
    if throwStr < 3:
        intensity=1.25
    else:
        intensity=throwStr/2
    h=1
    subtype = m25ai.FindTacticType(char, 'subtype')
    if ((Object_GetClass(char)&js.OC_VEHICLE)!=0) | ('vehicle' in subtype):
        h=2
    magnitude=7500*intensity
    Trigger_Force(char,direction[0],direction[1],h,magnitude,TF_ABSOLUTE)
    ffx.FFX_ObjectSetAttr(char,'thrownCharacter',0)
    ffx.RegTimer('finishThrow2',0.4,0,char,source)
    ffx.FFX_ObjectSetAttr(source,'throwCharacter',0)
    if ffx.FFX_ObjectGetAttr(char,'acrobatic',0)!=1:
        mlogreader.regGetupStop(char, 'finishThrow2a', 0, 0, 0, source)
    else:
        ffx.RegTimer('finishThrow2a',2,0,char,source)

def finishThrow2(event):
    char=event.object
    source=event.string
    turnTo(source,char)

def finishThrow2a(event):
    char=event.object
    source=event.string
    ffx.FFX_ObjectSetAttr(char,'thrownCharacter',0)
    hasPortrait=ffx.FFX_HasPortrait(char)
    pcAIEnabled=m25ai.AIInWatch(char)
    if pcAIEnabled or not hasPortrait:
        m25ai.ClearAIStandardOnly(char)
        m25ai.AIEnable(char)
        m25ai.AIEnableCustom(char)
        m25ai.SetBrawler(char)
        m25event.SetTimer(1.0, 'm25ai.AIRecoverBroken', char, user=m25ai.GetAITimeStamp(char))
    ffx.RegTimer('finishThrow2b',0.2,0,char)

def finishThrow2b(event):
    char=event.object
    AI_Animate(char,'unlock')
    AI_Animate(char,'melee_idle')
    ffx.RegTimer('throw2Recover',1,0,char)

def throw2Recover(event):
    char=event.object
    if Object_IsAlive(char)==0:
        return
    flailing=mlogreader.MLOG_IsFlailing(char)
    if flailing:
        mlogreader.regGetupStop(char,'throw2Recover',0,0,0)
        return
    AI_Animate(char,'unlock')
    hasPortrait=ffx.FFX_HasPortrait(char)
    pcAIEnabled=m25ai.AIInWatch(char)
    if pcAIEnabled or not hasPortrait:
        m25ai.ClearAIStandardOnly(char)
        m25ai.AIEnable(char)
        m25ai.AIEnableCustom(char)
        m25ai.SetBrawler(char)
        m25event.SetTimer(1.0, 'm25ai.AIRecoverBroken', char, user=m25ai.GetAITimeStamp(char))
    AI_Animate(char,'melee_idle')
    ffx.RegTimer('throw2Recover2a',1,0,char)

def throw2Recover2a(event):
    char=event.object
    if Object_IsAlive(char)==0:
        return
    pos=Get_ObjectPos(char)
    ffx.FFX_ObjectSetAttr(char,'lastY',pos[1])
    ffx.FFX_ObjectSetAttr(char,'lastX',pos[0])
    ffx.RegTimer('throw2Recover2b',5,0,char)

def throw2Recover2b(event):
    char=event.object
    if Object_IsAlive(char)==0:
        return
    flailing=mlogreader.MLOG_IsFlailing(char)
    getup=mlogreader.MLOG_IsGettingUp(char)
    pos=Get_ObjectPos(char)
    dist=(pos[0]-ffx.FFX_ObjectGetAttr(char,'lastX'),pos[1]-ffx.FFX_ObjectGetAttr(char,'lastY'),0)
    ffx.FFX_ObjectSetAttr(char,'lastY',pos[1])
    ffx.FFX_ObjectSetAttr(char,'lastX',pos[0])
    if ffx.FFX_ObjectGetAttr(char,'thrownCharacter',0)==1:
        return
    if ffx.FFX_ObjectGetAttr(char,'throwCharacter',0)==1:
        return
    if flailing:
        mlogreader.regGetupStop(char,'throw2Recover2b',0,0,0)
        return
    if getup:
        mlogreader.regGetupStop(char,'throw2Recover2b',0,0,0)
        return
    if (dist[0]*dist[0]+dist[1]*dist[1]) > 20:
        return
    if not m25ai.IsPerformingTactic(char):    
        AI_Animate(char,'unlock')
        hasPortrait=ffx.FFX_HasPortrait(char)
        pcAIEnabled=m25ai.AIInWatch(char)
        if pcAIEnabled or not hasPortrait:
            m25ai.ClearAIStandardOnly(char)
            m25ai.AIEnable(char)
            m25ai.AIEnableCustom(char)
            m25ai.SetBrawler(char)
            m25event.SetTimer(1.0, 'm25ai.AIRecoverBroken', char, user=m25ai.GetAITimeStamp(char))
    ffx.RegTimer('throw2Recover2b',5,0,char)


#################### ranged grapple custom damage state swap ########################################################

def stuntorangedgrappleCD(event):
    rangedgrappleP(event,PCSTATE_STUNNED,1)
def hypnosistorangedgrappleCD(event):
    rangedgrappleCDP(event,PCSTATE_HYPNOTISED,ffx.COST_HYPNO)
def ragetorangedgrappleCD(event):
    rangedgrappleCDP(event,PCSTATE_ENRAGED,ffx.COST_RAGE)
def exiletorangedgrappleCD(event):
    rangedgrappleCDP(event,PCSTATE_EXILE,ffx.COST_EXILE)
def blanktorangedgrappleCD(event):
    rangedgrappleCDP(event,PCSTATE_BLANK,ffx.COST_BLANK)
def panictorangedgrappleCD(event):
    rangedgrappleCDP(event,PCSTATE_PANICKED,ffx.COST_PANIC)
def frozentorangedgrappleCD(event):
    rangedgrappleCDP(event,PCSTATE_FROZEN,ffx.COST_FROZEN)
def stasistorangedgrappleCD(event):
    rangedgrappleCDP(event,PCSTATE_STATIC,ffx.COST_STASIS)

def hextorangedgrappleCD(event):
    rangedgrappleCDS(event,SCSTATE_HEXED,ffx.COST_HEX)
def blindtorangedgrappleCD(event):
    rangedgrappleCDS(event,SCSTATE_BLIND,ffx.COST_BLIND)
def powernulltorangedgrappleCD(event):
    rangedgrappleCDS(event,SCSTATE_POWER_NULLIFICATION,ffx.COST_NULL)
def weakentorangedgrappleCD(event):
    rangedgrappleCDS(event,SCSTATE_WEAKENED,ffx.COST_WEAKEN)
def speeddecreasetorangedgrappleCD(event):
    rangedgrappleCDS(event,SCSTATE_SPEED_DECREASED,ffx.COST_DECREASE)

def speedincreasetorangedgrappleCD(event):
    rangedgrappleCDS(event,SCSTATE_SPEED_INCREASED,ffx.COST_INCREASE)

def energisetorangedgrappleCD(event):
    char=event.object
    source=event.string
    if ffx.FFX_GotState(char,SCSTATE_ENERGIZED):
        Object_SetSecondaryState(char,SCSTATE_ENERGIZED,0,REMOVE_STATE)
        ffx.FFX_UpdateStates(char)
        rGrappledCDADcheck(char,source,ffx.COST_ENERGYSURGE)
    else:
        ffx.RegTimer('energizeSwapCancel',1,0,char,source)

def energysurgetorangedgrappleCD(event):
    char=event.object
    source=event.string
    if ffx.FFX_GotState(char,SCSTATE_AREA_ENERGIZED):
        Object_SetSecondaryState(char,SCSTATE_AREA_ENERGIZED,0,REMOVE_STATE)
        ffx.FFX_UpdateStates(char)
        rGrappledCDADcheck(char,source,ffx.COST_ENERGYSURGE)
    else:
        ffx.RegTimer('energizeSwapCancel',1,0,char,source)

def densitytorangedgrappleCD(event):
    char=event.object
    source=event.string
    if ffx.densityaltered(char):
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        ffx.FFX_UpdateStates(char)
        ffx.FFX_ObjectSetAttr(source,'rangedGrappleEnergyCD',1)
        rGrappledCDADcheck(char,source,ffx.COST_DENSITY)

def rangedgrappleCDP(event,state,intensity):
    char=event.object
    source=event.string
    if state==PCSTATE_DIMENSION_SHIFT:
        ffx.FFX_ObjectSetAttr(char,'rangedGrappleMysticCD',1)
    if state==PCSTATE_STATIC:
        ffx.FFX_ObjectSetAttr(char,'rangedGrappleMysticCD',1)
    if state==PCSTATE_HYPNOTISED:
        ffx.FFX_ObjectSetAttr(char,'rangedGrappleMentalCD',1)
    if state==PCSTATE_PANICKED:
        ffx.FFX_ObjectSetAttr(char,'rangedGrappleMentalCD',1)
    if state==PCSTATE_BLANK:
        ffx.FFX_ObjectSetAttr(char,'rangedGrappleMentalCD',1)
    if state==PCSTATE_ENRAGED:
        ffx.FFX_ObjectSetAttr(char,'rangedGrappleMentalCD',1)
    if state==PCSTATE_FROZEN:
        ffx.FFX_ObjectSetAttr(char,'rangedGrappleColdCD',1)
    if Object_GetPrimaryState(char)==state:
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        rGrappledCDADcheck(char,source,intensity)

def rangedgrappleCDS(event,state,intensity):
    char=event.object
    source=event.string
    if state==SCSTATE_HEXED:
        ffx.FFX_ObjectSetAttr(char,'rangedGrappleMysticCD',1)
    if state==SCSTATE_BLIND:
        ffx.FFX_ObjectSetAttr(char,'rangedGrappleMysticCD',1)
    if state==SCSTATE_POWER_NULLIFICATION:
        ffx.FFX_ObjectSetAttr(char,'rangedGrappleMentalCD',1)
    if state==SCSTATE_WEAKENED:
        ffx.FFX_ObjectSetAttr(char,'rangedGrappleMentalCD',1)
    if Object_GetSecondaryStates(char)&state:
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        rGrappledCDADcheck(char,source,intensity)

def rGrappledCDADcheck(char, source, intensity):
    if ffx.FFX_ObjectGetAttr(char,'rangedgrappledCD',0)==1:
        return
    AI_Animate(source,'lock')
    mlogreader.regDodgeStart(source,'rGrappleCDCancel',0,0,0,char)
    ffx.FFX_ObjectSetAttr(source,'rangedgrappleCDIntensity',intensity)
    if (ffx.FFX_ObjectGetAttr(char,'rangedGrappleMentalCD')==0) & (ffx.FFX_ObjectGetAttr(char,'rangedGrappleMysticCD')==0) & (ffx.FFX_ObjectGetAttr(char,'rangedGrappleEnergyCD')==0):
        ffx.FFX_ObjectSetAttr(char,'rangedGrapplePhysicalCD',1)
        damage_type = m25ai.ai_damage_type['crushing']
        damage_mode = m25ai.ai_damage_mode['ranged']
        if ffx.FFX_ObjectGetAttr(char,'ffactivedefense')==1:
            useStr=ffx.getByTemplate(source,FFX_RANGEGRAPPLECD_CUSTOM,2)
            if ffx.FFX_ObjectGetAttr(char,'ffactivedefenseSelf',0)==0:
                FFX_crushTestCD1(char,source)
                return
            power=ffx.getByTemplate(char,FFX_FFACTIVEDEFENSE_CUSTOM,3)
            powdata = datfiles.Campaign_ReadPowers()[power]
            if powdata['PowerType'] == datfiles.PT_ACTIVE_DEFENCE:
                if ( powdata['DamageTypesBlocked'] & damage_type ) and \
                ( powdata['AttackModesBlocked'] & damage_mode ):
                    m25getset.GetObjectVar(char, 'defense ' + `damage_type` + '_' + `damage_mode`, 1,nosave=1)
                    AI_Animate(source,'unlock')
                    AI_Animate(source,'melee_idle')
                    return
        if ffx.FFX_HasPortrait(char):
            if not m25ai.AIInWatch(char):
                FFX_crushTestCD1(char,source)
                return
        if m25ai.HasActiveDefenceActive(char,damage_type,damage_mode):
            AI_Animate(source,'unlock')
            AI_Animate(source,'melee_idle')
            return
        if ffx.FFX_ObjectGetAttr(char,'phased_out',0)==1:
            AI_Animate(source,'unlock')
            AI_Animate(source,'melee_idle')
            return
    rangedGrappleCDStart(char, source)

def rGrappleCDCancel(event):
    source=event.object
    char=event.string
    if ffx.FFX_ObjectGetAttr(source,'rangedgrapplerCD',0)==0:
        AI_Animate(source,'unlock')
        AI_Animate(source,'melee_idle')
    ffx.FFX_ObjectSetAttr(char,'rangedgrappledCD',0)
    ffx.FFX_ObjectSetAttr(source,'rangedgrapplerCD',0)

def FFX_crushTestCD1(char,source):
    name=ffx.getDummyName()
    Object_SpawnAt('ffx_tiggot',Get_ObjectPos(source),name)
    Trigger_Power(name,char,'ffx_ranged_crush_test','',10)
    flying=mlogreader.MLOG_IsFlying(char)
    if flying:
        ffx.FFX_ObjectSetAttr(char, 'rangedGrappledCD_flier', 1)
    ffx.FFX_ObjectSetAttr(char,'crushTestCD',1)
    ffx.FFX_ObjectSetAttr(source,'crushTestCD',1)
    ffx.RegCharState(char,PCSTATE_STUNNED,'FFX_crushTestCD2',0,0,source)
    ffx.RegTimer('FFX_crushTestCD3',2,0,char,source)
    ffx.RegTimer('ffx.destroyTemp',3,0,name)

def FFX_crushTestCD2(event):
    char=event.object
    source=event.string
    if ffx.FFX_ObjectGetAttr(char,'crushTestCD',0)==1:
        if ffx.FFX_ObjectGetAttr(source,'crushTestCD',0)==1:
            ffx.FFX_ObjectSetAttr(source,'crushTestCD',0)
            grappleFX=ffx.getByTemplate(source,FFX_RANGEGRAPPLECD_CUSTOM,1)
            handle = Object_PlayEffect(char, grappleFX,'',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'centre')
            ffx.FFX_ObjectSetAttr(char,'rangedGrappleCD_handle',handle)
            Object_SetPrimaryState(char,PCSTATE_STUNNED,0,REMOVE_STATE)
            if ffx.FFX_ObjectGetAttr(char,'rangedGrappledCD_flier',0)==1:
                AI_Animate(char,'hover')
                if rGrappleCDBreakCheck(char,source):
                    handle=ffx.FFX_ObjectGetAttr(char,'rangedGrappleCD_handle')
                    Object_StopEffect(char,handle)
                    if ffx.FFX_ObjectGetAttr(char,'rangedGrappleMysticCD',0)==1:
                        AI_Animate(char,'recover_from_stun')
                    elif ffx.FFX_ObjectGetAttr(char,'rangedGrappleMentalCD',0)==1:
                        AI_Animate(char,'recover_from_stun')
                    else:
                        AI_Animate(char,'swing_pole')
                else:
                    ffx.FFX_ObjectSetAttr(char,'rangedgrappledCD',1)
                    ffx.FFX_ObjectSetAttr(source,'rangedgrapplerCD',1)
                    AI_Animate(char,'pain')
                    ffx.RegTimer('rangedGrappleCDStartEvent',0.2,0,char,source)
            else:
                if rGrappleCDBreakCheck(char,source):
                    handle=ffx.FFX_ObjectGetAttr(char,'rangedGrappleCD_handle')
                    Object_StopEffect(char,handle)
                    if ffx.FFX_ObjectGetAttr(char,'rangedGrappleMysticCD',0)==1:
                        AI_Animate(char,'recover_from_stun')
                    elif ffx.FFX_ObjectGetAttr(char,'rangedGrappleMentalCD',0)==1:
                        AI_Animate(char,'recover_from_stun')
                    else:
                        AI_Animate(char,'swing_pole')
                else:
                    ffx.FFX_ObjectSetAttr(char,'rangedgrappledCD',1)
                    ffx.FFX_ObjectSetAttr(source,'rangedgrapplerCD',1)
                    AI_Animate(char,'pain')
                    ffx.RegTimer('rangedGrappleCDStartEvent',0.2,0,char,source)
    ffx.FFX_ObjectSetAttr(char,'crushTestCD',0)

def FFX_crushTestCD3(event):
    char=event.object
    source=event.string
    ffx.FFX_ObjectSetAttr(source,'crushTestCD',0)
    if ffx.FFX_ObjectGetAttr(char,'rGrappleCDBreak',0)==1:
        if ffx.FFX_ObjectGetAttr(char,'rangedGrappleMysticCD',0)==1:
            AI_Animate(char,'recover_from_stun')
        elif ffx.FFX_ObjectGetAttr(char,'rangedGrappleMentalCD',0)==1:
            AI_Animate(char,'recover_from_stun')
        else:
            AI_Animate(char,'swing_pole')
        ffx.FFX_ObjectSetAttr(char,'rGrappleCDBreak',0)
    if ffx.FFX_ObjectGetAttr(char,'rangedgrappledCD',0)==1:
        flailing=mlogreader.MLOG_IsFlailing(char)
        if not flailing:
            AI_Animate(char,'pain')
    if ffx.FFX_ObjectGetAttr(source,'rangedgrapplerCD',0)==0:
        AI_Animate(source,'unlock')
        AI_Animate(source,'melee_idle')

def rangedGrappleCDStartEvent(event):
    char=event.object
    source=event.string
    if Object_IsAlive(char)==0:
        return
    pos=Get_ObjectPos(source)
    pos2=Get_ObjectPos(char)
    if Object_GetPrimaryState(char)==ffx.PCSTATE_EXILE:
        ffx.FFX_ObjectSetAttr(char,'rangedgrappledCD',0)
        ffx.FFX_ObjectSetAttr(source,'rangedgrapplerCD',0)
        return
    ffx.FFX_ObjectSetAttr(source,'lastY',pos[1])
    ffx.FFX_ObjectSetAttr(source,'lastX',pos[0])
    ffx.FFX_ObjectSetAttr(char,'lastY',pos2[1])
    ffx.FFX_ObjectSetAttr(char,'lastX',pos2[0])
    ffx.FFX_ObjectSetAttr(source,'rgLastHealth',Object_GetAttr(source,'health'))
    ffx.FFX_ObjectSetAttr(source,'rGrappleCD_duration',9)
    hasPortrait=ffx.FFX_HasPortrait(char)
    pcAIEnabled=m25ai.AIInWatch(char)
    if pcAIEnabled or not hasPortrait:
        m25ai.AIDisable(char)
    ffx.RegTimer('makerangedGrappleCD',0.4,0,char,source)
    ffx.RegTimer('rGrappleCDLock',0.1,0,char,source)
    ffx.RegTimer('rangedgrappleCDMoveCheck',0.2,0,source,char)

def rangedGrappleCDStart(char, source):
    if Object_IsAlive(char)==0:
        return
    if ffx.FFX_ObjectGetAttr(char,'rangedgrappledCD',0)==1:
        return
    flying=mlogreader.MLOG_IsFlying(char)
    if flying:
        ffx.FFX_ObjectSetAttr(char, 'rangedGrappledCD_flier', 1)
    grappleFX=ffx.getByTemplate(source,FFX_RANGEGRAPPLECD_CUSTOM,1)
    handle = Object_PlayEffect(char, grappleFX,'',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'centre')
    ffx.FFX_ObjectSetAttr(char,'rangedGrappleCD_handle',handle)
    if rGrappleCDBreakCheck(char,source):
        handle=ffx.FFX_ObjectGetAttr(char,'rangedGrappleCD_handle')
        Object_StopEffect(char,handle)
        ffx.FFX_ObjectSetAttr(char,'rGrappleCDBreak',1)
        ffx.RegTimer('rGrappleCDLock',0.3,0,char,source)
        return
    else:
        ffx.FFX_ObjectSetAttr(char,'rangedgrappledCD',1)
        ffx.FFX_ObjectSetAttr(source,'rangedgrapplerCD',1)
        hasPortrait=ffx.FFX_HasPortrait(char)
        pcAIEnabled=m25ai.AIInWatch(char)
        if pcAIEnabled or not hasPortrait:
            m25ai.AIDisable(char)
    ffx.RegTimer('rangedGrappleCDStart2',0.5,0,char,source)

def rangedGrappleCDStart2(event):
    char=event.object
    source=event.string
    if Object_IsAlive(char)==0:
        ffx.FFX_ObjectSetAttr(char,'rangedgrappledCD',0)
        ffx.FFX_ObjectSetAttr(source,'rangedgrapplerCD',0)
        return
    pos=Get_ObjectPos(source)
    pos2=Get_ObjectPos(char)
    if Object_GetPrimaryState(char)==ffx.PCSTATE_EXILE:
        ffx.FFX_ObjectSetAttr(char,'rangedgrappledCD',0)
        ffx.FFX_ObjectSetAttr(source,'rangedgrapplerCD',0)
        return
    ffx.FFX_ObjectSetAttr(source,'lastY',pos[1])
    ffx.FFX_ObjectSetAttr(source,'lastX',pos[0])
    ffx.FFX_ObjectSetAttr(char,'lastY',pos2[1])
    ffx.FFX_ObjectSetAttr(char,'lastX',pos2[0])
    ffx.FFX_ObjectSetAttr(source,'rgLastHealth',Object_GetAttr(source,'health'))
    ffx.FFX_ObjectSetAttr(source,'rGrappleCD_duration',9)
    AI_Animate(char,'pain')
    ffx.RegTimer('makerangedGrappleCD',0.4,0,char,source)
    ffx.RegTimer('rGrappleCDLock',0.1,0,char,source)
    ffx.RegTimer('rangedgrappleCDMoveCheck',0.2,0,source,char)

def rGrappleCDLock(event):
    char=event.object
    source=event.string
    flailing=mlogreader.MLOG_IsFlailing(char)
    flailingS=mlogreader.MLOG_IsFlailing(source)
    if flailing:
        ffx.FFX_ObjectSetAttr(char,'rangedgrappledCD',0)
        ffx.FFX_ObjectSetAttr(source,'rangedgrapplerCD',0)
        mlogreader.regGetupStop(char,'rGrappleCDRecover',0,0,0)
        if flailingS:
            mlogreader.regGetupStop(source,'rGrappleCDRecover',0,0,0)
        else:
            ffx.RegTimer('rGrappleCDRecover',1,0,source)
        return
    if flailingS:
        ffx.FFX_ObjectSetAttr(char,'rangedgrappledCD',0)
        ffx.FFX_ObjectSetAttr(source,'rangedgrapplerCD',0)
        mlogreader.regGetupStop(source,'rGrappleCDRecover',0,0,0)
        if flailing:
            mlogreader.regGetupStop(char,'rGrappleCDRecover',0,0,0)
        else:
            ffx.RegTimer('rGrappleCDRecover',1,0,char)
        return
    if ffx.FFX_ObjectGetAttr(char,'rangedgrappledCD',0)==0:
        if ffx.FFX_ObjectGetAttr(char,'rangedGrappledCD_flier',0)==1:
            ffx.FFX_ObjectSetAttr(char,'rangedGrappledCD_flier',0)
        if ffx.FFX_ObjectGetAttr(char,'rGrappleCDBreak',0)==0:
            if Object_IsAlive(char)==0:
                handle=ffx.FFX_ObjectGetAttr(char,'rangedGrappleCD_handle')
                Object_StopEffect(char,handle)
                return
            handle=ffx.FFX_ObjectGetAttr(char,'rangedGrappleCD_handle')
            Object_StopEffect(char,handle)
            Trigger_Force(char,0,0,1,Object_GetAttr(char,'mass')*100,TF_ABSOLUTE)
            if ffx.FFX_ObjectGetAttr(char,'acrobatic',0)!=1:
                mlogreader.regGetupStop(char,'rGrappleCDRecover',0,0,0)
            else:
                ffx.RegTimer('rGrappleCDRecover',1,0,char)
        else:
            ffx.RegTimer('rGrappleCDRecover',1,0,char)
        ffx.RegTimer('rGrappleCDRecover',1,0,source)
        return
    AI_Animate(char,'pain')
    ffx.RegTimer('rGrappleCDLock',0.2,0,char,source)

def makerangedGrappleCD(event):
    char=event.object
    source=event.string
    if ffx.FFX_ObjectGetAttr(char,'rangedgrappledCD',0)==0:
        return
    grappledAgl=Object_GetAttr(char,'agility')-3
    ffx.FFX_ObjectSetAttr(char,'baseAgility',Object_GetAttr(char,'agility'))
    ffx.FFX_ObjectSetAttr(source,'baseAgility',Object_GetAttr(source,'agility'))
    Object_SetAttr(char,'energy',0)
    Object_SetAttr(char,'agility',grappledAgl)
    Object_SetAttr(source,'agility',0)
    rGrappleCDDmg(source,char)
    ffx.RegTimer('rGrappleCDCheck',3,0,char,source)
    ffx.RegTimer('rGrappleCDEnergy',1,0,char,source)

def rangedgrappleCDMoveCheck(event):#checks grappler's and target's conditions (movement, damage, Primary State, KOed)
    source = event.object
    char = event.string
    if ffx.FFX_ObjectGetAttr(char,'rangedgrappledCD',0)==0:
        return
    lasthealth=ffx.FFX_ObjectGetAttr(source,'rgLastHealth')
    health=Object_GetAttr(source,'health')
    if health < lasthealth:
        ffx.FFX_ObjectSetAttr(char,'rangedgrappledCD',0)
        ffx.FFX_ObjectSetAttr(source,'rangedgrapplerCD',0)
        return
    if (Object_GetPrimaryState(source)!=PCSTATE_NORMAL) | (Object_IsAlive(source)==0) | (ffx.FFX_ObjectGetAttr(source,'grappled',0)==1) | (ffx.FFX_ObjectGetAttr(source,'rangedgrappled',0)==1) | (ffx.FFX_ObjectGetAttr(source,'tangled',0)==1) | (ffx.FFX_ObjectGetAttr(source,'eTangled',0)==1) | (ffx.FFX_ObjectGetAttr(source,'thrownCharacter',0)==1):#if the grappler is koed, blanked, enraged, hexed, etc. cancel the grapple
        ffx.FFX_ObjectSetAttr(char,'rangedgrappledCD',0)
        ffx.FFX_ObjectSetAttr(source,'rangedgrapplerCD',0)
        return
    if Object_GetPrimaryState(char)==ffx.PCSTATE_EXILE:
        ffx.FFX_ObjectSetAttr(char,'rangedgrappledCD',0)
        ffx.FFX_ObjectSetAttr(source,'rangedgrapplerCD',0)
        return
    if (Object_IsAlive(char)==0):#if the target is koed, cancel the grapple
        ffx.FFX_ObjectSetAttr(char,'rangedgrappledCD',0)
        ffx.FFX_ObjectSetAttr(source,'rangedgrapplerCD',0)
        return
    pos=Get_ObjectPos(source)
    pos2=Get_ObjectPos(char)
    dist=(pos[0]-ffx.FFX_ObjectGetAttr(source,'lastX'),pos[1]-ffx.FFX_ObjectGetAttr(source,'lastY'),0)
    dist2=(pos2[0]-ffx.FFX_ObjectGetAttr(char,'lastX'),pos2[1]-ffx.FFX_ObjectGetAttr(char,'lastY'),0)
    ffx.FFX_ObjectSetAttr(source,'lastY',pos[1])
    ffx.FFX_ObjectSetAttr(source,'lastX',pos[0])
    ffx.FFX_ObjectSetAttr(char,'lastY',pos2[1])
    ffx.FFX_ObjectSetAttr(char,'lastX',pos2[0])
    if (dist[0]*dist[0]+dist[1]*dist[1]) > 20:
        ffx.FFX_ObjectSetAttr(char,'rangedgrappledCD',0)
        ffx.FFX_ObjectSetAttr(source,'rangedgrapplerCD',0)
        return
    elif (dist2[0]*dist2[0]+dist2[1]*dist2[1]) > 20:
        ffx.FFX_ObjectSetAttr(char,'rangedgrappledCD',0)
        ffx.FFX_ObjectSetAttr(source,'rangedgrapplerCD',0)
        return
    ffx.FFX_ObjectSetAttr(source,'rgLastHealth',health)
    flailing=mlogreader.MLOG_IsFlailing(char)
    flailing2=mlogreader.MLOG_IsFlailing(source)
    if not flailing:
        AI_Animate(char,'lock')
    if not flailing2:
        AI_Animate(source,'lock')
    ffx.RegTimer('rangedgrappleCDMoveCheck',0.8,0,source,char)

def rGrappleCDBreakCheck(char,source):
    #calculate the target's resistance based on the kind of grapple(physical, mental, mystical, cold or energy)
    if ffx.FFX_ObjectGetAttr(char,'rangedGrappleMentalCD',0)==1:
        targetStr=ffx.getMentalResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    elif ffx.FFX_ObjectGetAttr(char,'rangedGrappleMysticCD',0)==1:
        targetStr=ffx.getMysticalResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    elif ffx.FFX_ObjectGetAttr(char,'rangedGrappleEnergyCD',0)==1:
        targetStr=ffx.getEnergyResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    else:
        targetStr=Object_GetAttr(char,'strength')+1
        if ffx.FFX_ObjectGetAttr(char,'rangedGrappleColdCD',0)!=1:
            if ffx.hasAttribute(char,'wrestler'):
                targetStr=ffx.FFX_ObjectGetAttr(char,'wrestler')
    #calculate the grappler's hold strength (Strength Stat or Custom Value)
    useStr=ffx.getByTemplate(source,FFX_RANGEGRAPPLECD_CUSTOM,2)
    if useStr=='Yes':
        holdStr=Object_GetAttr(source,'strength')+1
        if ffx.FFX_ObjectGetAttr(char,'rangedGrappleColdCD',0)!=1:
            if ffx.hasAttribute(source,'wrestler'):
                holdStr=ffx.FFX_ObjectGetAttr(source,'wrestler')
    else:
        holdStr=ffx.getByTemplate(source,FFX_RANGEGRAPPLECD_CUSTOM,3)
    #calculate the difference in the grappler's and target's strength
    if ffx.FFX_ObjectGetAttr(char,'rangedGrapplePhysicalCD',0)!=1:
        if targetStr==1:
            if holdStr < 7:
                holdStr=holdStr+2
            else:
                holdStr=holdStr+1
        if targetStr > 1:
            holdStr=(holdStr*0.5)+1.5
        if targetStr == 0.5:
            holdStr=holdStr*1.5
        if targetStr == 0.25:
            holdStr=holdStr*2.5
        chance=holdStr*targetStr
    else:
        if targetStr>holdStr:
            targetStr=targetStr+1
            strDiff=targetStr-holdStr
            chance=5-strDiff
        if targetStr==holdStr:
            chance=6
        if holdStr>targetStr:
            targetStr=targetStr-1
            strDiff=holdStr-targetStr
            chance=5+strDiff
    #calculate the chance to break free
    breakFree=randint(1,10)
    if breakFree > chance:
        return 1
    else:
        return 0

def rGrappleCDDmg(source,char):
    #apply damage if hold is successful
    if ffx.FFX_ObjectGetAttr(char,'rangedGrappleMentalCD',0)==1:
        targetStr=ffx.getMentalResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    elif ffx.FFX_ObjectGetAttr(char,'rangedGrappleMysticCD',0)==1:
        targetStr=ffx.getMysticalResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    else:
        targetStr=1
    name=ffx.getDummyName()
    power=ffx.getByTemplate(source,FFX_RANGEGRAPPLECD_CUSTOM,4)
    Object_SpawnAt('ffx_tiggot',Get_ObjectPos(source),name)
    Trigger_Power(name,char,power,'',targetStr)
    ffx.RegTimer('ffx.destroyTemp',5,0,name)

def rGrappleCDEnergy(event):
    char=event.object
    source=event.string
    if ffx.FFX_ObjectGetAttr(char,'rangedgrappledCD',0)==0:
        return
    epCost=10
    if ffx.FFX_ObjectGetAttr(char,'rangedGrappleMentalCD',0)==1:
        targetStr=ffx.getMentalResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    elif ffx.FFX_ObjectGetAttr(char,'rangedGrappleMysticCD',0)==1:
        targetStr=ffx.getMysticalResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    elif ffx.FFX_ObjectGetAttr(char,'rangedGrappleEnergyCD',0)==1:
        targetStr=ffx.getEnergyResistanceValue(char, passive=0, active=0, attribs=1, states=1, material=1)
    else:
        targetStr=Object_GetAttr(char,'strength')+1
        if ffx.FFX_ObjectGetAttr(char,'rangedGrappleColdCD',0)!=1:
            if ffx.hasAttribute(char,'wrestler'):
                targetStr=ffx.FFX_ObjectGetAttr(char,'wrestler')
    useStr=ffx.getByTemplate(source,FFX_RANGEGRAPPLECD_CUSTOM,2)
    if useStr=='Yes':
        holdStr=Object_GetAttr(source,'strength')+1
        if ffx.FFX_ObjectGetAttr(char,'rangedGrappleColdCD',0)!=1:
            if ffx.hasAttribute(source,'wrestler'):
                holdStr=ffx.FFX_ObjectGetAttr(source,'wrestler')
    else:
        holdStr=ffx.getByTemplate(source,FFX_RANGEGRAPPLECD_CUSTOM,3)
    if ffx.FFX_ObjectGetAttr(char,'rangedGrapplePhysicalCD',0)!=1:
        epCost=epCost/targetStr
    else:
        if targetStr>holdStr:
            targetStr=targetStr+1
            strDiff=targetStr-holdStr
            epCost=epCost*strDiff
        if holdStr>targetStr:
            targetStr=targetStr-1
            strDiff=holdStr-targetStr
            epCost=epCost/strDiff
    energy=Object_GetAttr(source,'energyPoints')
    newEnergy=Object_GetAttr(source,'energyPoints')-epCost
    Object_SetAttr(source,'energyPoints',newEnergy)
    if newEnergy <= 0:
        ffx.FFX_ObjectSetAttr(char,'rangedgrappledCD',0)
        ffx.FFX_ObjectSetAttr(source,'rangedgrapplerCD',0)
        ffx.FFX_ObjectSetAttr(char,'rGrappleCDBreak',1)
        return
    ffx.RegTimer('rGrappleCDEnergy',1,0,char,source)

def rGrappleCDCheck(event):
    char=event.object
    source=event.string
    if ffx.FFX_ObjectGetAttr(char,'rangedgrappledCD',0)==0:
        return
    duration=ffx.FFX_ObjectGetAttr(source,'rGrappleCD_duration')-3
    if duration<=0:
        ffx.FFX_ObjectSetAttr(char,'rangedgrappledCD',0)
        ffx.FFX_ObjectSetAttr(source,'rangedgrapplerCD',0)
        return
    if Object_GetPrimaryState(char)!=PCSTATE_NORMAL:
        ffx.RegTimer('rGrappleCDCheck',3,0,char,source)
        return
    if rGrappleCDBreakCheck(char,source):
        ffx.FFX_ObjectSetAttr(char,'rangedgrappledCD',0)
        ffx.FFX_ObjectSetAttr(source,'rangedgrapplerCD',0)
        ffx.FFX_ObjectSetAttr(char,'rGrappleCDBreak',1)
        return
    ffx.FFX_ObjectSetAttr(source,'rGrappleCD_duration',duration)
    rGrappleCDDmg(source,char)
    ffx.RegTimer('rGrappleCDCheck',3,0,char,source)

def rGrappleCDRecover(event):
    char=event.object
    if Object_IsAlive(char)==0:
        return
    flailing=mlogreader.MLOG_IsFlailing(char)
    if flailing:
        mlogreader.regGetupStop(char,'rGrappleCDRecover',0,0,0)
        return
    agility=ffx.FFX_ObjectGetAttr(char,'baseAgility')
    Object_SetAttr(char,'agility',agility)
    baseEnergy=ffx.FFX_ObjectGetAttr(char,'baseEnergy')
    energy=Object_GetAttr(char,'energy')
    if baseEnergy!=energy:
        Object_SetAttr(char,'energy',baseEnergy)
    if not m25ai.IsPerformingTactic(char):
        AI_Animate(char,'unlock')
        hasPortrait=ffx.FFX_HasPortrait(char)
        pcAIEnabled=m25ai.AIInWatch(char)
        if pcAIEnabled or not hasPortrait:
            m25ai.ClearAIStandardOnly(char)
            m25ai.AIEnable(char)
            m25ai.AIEnableCustom(char)
            m25ai.SetBrawler(char)
            m25event.SetTimer(1.0,'m25ai.AIRecoverBroken',char,user=m25ai.GetAITimeStamp(char))
    if ffx.FFX_ObjectGetAttr(char,'rGrappleCDBreak',0)==1:
        if ffx.FFX_ObjectGetAttr(char,'rangedGrappleMysticCD',0)==1:
            AI_Animate(char,'recover_from_stun')
        elif ffx.FFX_ObjectGetAttr(char,'rangedGrappleMentalCD',0)==1:
            AI_Animate(char,'recover_from_stun')
        else:
            AI_Animate(char,'swing_pole')
        ffx.FFX_ObjectSetAttr(char,'rGrappleCDBreak',0)
    else:
        flying=mlogreader.MLOG_IsFlying(char)
        if flying:
            AI_Animate(char,'hover')
        else:
            AI_Animate(char,'melee_idle')
    handle=ffx.FFX_ObjectGetAttr(char,'rangedGrappleCD_handle')
    Object_StopEffect(char,handle)
    ffx.FFX_ObjectSetAttr(char,'rangedGrappleMentalCD',0)
    ffx.FFX_ObjectSetAttr(char,'rangedGrappleMysticCD',0)
    ffx.FFX_ObjectSetAttr(char,'rangedGrappleColdCD',0)
    ffx.FFX_ObjectSetAttr(char,'rangedGrappleEnergyCD',0)
    ffx.FFX_ObjectSetAttr(char,'rangedGrapplePhysicalCD',0)
    if ffx.FFX_ObjectGetAttr(char,'rGrappleCDUnlock',0)==0:
        ffx.FFX_ObjectSetAttr(char,'rGrappleCDUnlock',1)
        ffx.RegTimer('rGrappleCDRecover2a',1,0,char)

def rGrappleCDRecover2a(event):
    char=event.object
    if Object_IsAlive(char)==0:
        return
    pos=Get_ObjectPos(char)
    ffx.FFX_ObjectSetAttr(char,'lastY',pos[1])
    ffx.FFX_ObjectSetAttr(char,'lastX',pos[0])
    ffx.RegTimer('rGrappleCDRecover2b',5,0,char)

def rGrappleCDRecover2b(event):
    char=event.object
    if Object_IsAlive(char)==0:
        return
    flailing=mlogreader.MLOG_IsFlailing(char)
    getup=mlogreader.MLOG_IsGettingUp(char)
    pos=Get_ObjectPos(char)
    dist=(pos[0]-ffx.FFX_ObjectGetAttr(char,'lastX'),pos[1]-ffx.FFX_ObjectGetAttr(char,'lastY'),0)
    ffx.FFX_ObjectSetAttr(char,'lastY',pos[1])
    ffx.FFX_ObjectSetAttr(char,'lastX',pos[0])
    if ffx.FFX_ObjectGetAttr(char,'rangedgrappledCD',0)==1:
        return
    if ffx.FFX_ObjectGetAttr(char,'rangedgrapplerCD',0)==1:
        return
    if flailing:
        mlogreader.regGetupStop(char,'rGrappleCDRecover2b',0,0,0)
        return
    if getup:
        mlogreader.regGetupStop(char,'rGrappleCDRecover2b',0,0,0)
        return
    if (dist[0]*dist[0]+dist[1]*dist[1]) > 10:
        ffx.FFX_ObjectSetAttr(char,'rGrappleCDUnlock',0)
        return
    if not m25ai.IsPerformingTactic(char):
        AI_Animate(char,'unlock')
        hasPortrait=ffx.FFX_HasPortrait(char)
        pcAIEnabled=m25ai.AIInWatch(char)
        if pcAIEnabled or not hasPortrait:
            m25ai.ClearAIStandardOnly(char)
            m25ai.AIEnable(char)
            m25ai.AIEnableCustom(char)
            m25ai.SetBrawler(char)
            m25event.SetTimer(1.0, 'm25ai.AIRecoverBroken', char, user=m25ai.GetAITimeStamp(char))
    ffx.RegTimer('rGrappleCDRecover2b',5,0,char)


##### Moved from ffx.py to make more room in that module for FFX 3.3 #####

MP_DENSITYINCREASE=13
MP_VLIFEDRAIN=14

#################### vampiric life drain swap ################################################
# This is almost exactly like the exisiting life drain swap but this adds a command to control
# the mind of the targets that have been affected by the life drain.
# -TaskmasterX
##############################################################################################

def stuntovlifedrain(event):
    vlifedrainP(event,PCSTATE_STUNNED,1)
def hypnosistovlifedrain(event):
    vlifedrainP(event,PCSTATE_HYPNOTISED,ffx.COST_HYPNO)
def ragetovlifedrain(event):
    vlifedrainP(event,PCSTATE_ENRAGED,ffx.COST_RAGE)
def exiletovlifedrain(event):
    vlifedrainP(event,PCSTATE_EXILE,ffx.COST_EXILE)
def blanktovlifedrain(event):
    vlifedrainP(event,PCSTATE_BLANK,ffx.COST_BLANK)
def panictovlifedrain(event):
    vlifedrainP(event,PCSTATE_PANICKED,ffx.COST_PANIC)
def frozentovlifedrain(event):
    vlifedrainP(event,PCSTATE_FROZEN,ffx.COST_FROZEN)
def stasistovlifedrain(event):
    vlifedrainP(event,PCSTATE_STATIC,ffx.COST_STASIS)

def hextovlifedrain(event):
    vlifedrainS(event,SCSTATE_HEXED,ffx.COST_HEX)
def blindtovlifedrain(event):
    vlifedrainS(event,SCSTATE_BLIND,ffx.COST_BLIND)
def powernulltovlifedrain(event):
    vlifedrainS(event,SCSTATE_POWER_NULLIFICATION,ffx.COST_NULL)
def weakentovlifedrain(event):
    vlifedrainS(event,SCSTATE_WEAKENED,ffx.COST_WEAKEN)
def speeddecreasetovlifedrain(event):
    vlifedrainS(event,SCSTATE_SPEED_DECREASED,ffx.COST_DECREASE)

def densitytovlifedrain(event):
    char=event.object
    source=event.string
    if ffx.densityaltered(char):
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        ffx.FFX_UpdateStates(char)
        makevlifedrained(char,source,ffx.COST_DENSITY)

def vlifedrainP(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetPrimaryState(char)==state:
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        ffx.FFX_UpdateStates(char)
        makevlifedrained(char,source,intensity)

def vlifedrainS(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetSecondaryStates(char)&state:
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        ffx.FFX_UpdateStates(char)
        makevlifedrained(char,source,intensity)

def makevlifedrained(char,source,intensity):
    ffx.MPSendMessage(MP_VLIFEDRAIN,Object_GetAttr(char,'ffxMPID'),Object_GetAttr(source,'ffxMPID'),intensity)
    if ffx.FFX_ObjectGetAttr(char,'vlifedrainHandle',-1)==-1:
        handle=Object_PlayEffect(char,'effect_ffx_lifedrain','',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'centre')
        ffx.FFX_ObjectSetAttr(char,'vlifedrainHandle',handle)
        ffx.RegTimer('onVLifeDrain',1,0,char,source)
    if ffx.FFX_ObjectGetAttr(char,'vMindControlOn')!=1:
        Mission_CustomAction('MIND_CONTROL',source,char,'mental_control',30,0)
        ffx.FFX_ObjectSetAttr(char,'vMindControlOn',1)
    ffx.FFX_ObjectSetAttr(char,'vlifedrain',(1+intensity)*2)

def onVLifeDrain(event):
    char=event.object
    source=event.string
    drain=ffx.FFX_ObjectGetAttr(char,'vlifedrain')
    drain=drain-1
    if Object_IsAlive(char)==0:
        drain=0
    if drain<=0:
        Object_StopEffect(char,ffx.FFX_ObjectGetAttr(char,'vlifedrainHandle'))
        ffx.FFX_ObjectSetAttr(char,'vlifedrainHandle',-1)
    else:
        ffx.RegTimer('onVLifeDrain',2,0,char,source)
        ffx.FFX_ObjectSetAttr(char,'vlifedrain',drain)
    intensity=ffx.FFX_Rand(1,3)+drain/2
    Trigger_Damage(char,intensity)
    Trigger_Damage(source,-intensity)

def mental_control(target,char):
    Trigger_Power(char,target,'ffx_mental_control','')


########################### POSSESSION WITH POWERS ##############################################
# Works like Body Snatch, except the target acquires attributes and powers during the possession
#################################################################################################

# Note: available only as a swap for possession.

def possessiontopossessionwithpowers(event):
    possessPowersS(event, SCSTATE_POSSESSED, 1.0)

def possessPowersS(event, state, intensity):
    char = event.object
    source = event.string
    if Object_GetSecondaryStates(char) & state:
        makepossessPowers(char, source, intensity)

def makepossessPowers(target, user, intensity=1):
    ffx.teleportToPos(user, Get_ObjectPos(target))
    ffx.RegTimer('OnPossessPowers', 0.3, 0, user, target)
    ffx.FFX_ObjectSetAttr(target,'possessPowers',1)

def OnPossessPowers(event):
    char = event.object
    target = event.string
    if ffx.FFX_ObjectGetAttr(target,'possessPowers')==1:
        ffx.FFX_ObjectSetAttr(target,'possessPowers',0)
        return
    ffx.setInvisibleState(char, duration = 60)
    oldTeam=m25ai.GetTeam(target)
    ffx.FFX_ObjectSetAttr(target,'targetOldTeam',oldTeam)
    ffx.FFX_ObjectSetAttr(char,'PPattrib1',0)
    ffx.FFX_ObjectSetAttr(char,'PPattrib2',0)
    attrib1=ffx.getByTemplate(char,FFX_POSSESSION_WITH_POWERS_CUSTOM,1)
    attrib2=ffx.getByTemplate(char,FFX_POSSESSION_WITH_POWERS_CUSTOM,2)
    cmd1=ffx.getByTemplate(char,FFX_POSSESSION_WITH_POWERS_CUSTOM,3)
    cmd2=ffx.getByTemplate(char,FFX_POSSESSION_WITH_POWERS_CUSTOM,5)
    cmd3=ffx.getByTemplate(char,FFX_POSSESSION_WITH_POWERS_CUSTOM,7)
    pwr1=ffx.getByTemplate(char,FFX_POSSESSION_WITH_POWERS_CUSTOM,4)
    pwr2=ffx.getByTemplate(char,FFX_POSSESSION_WITH_POWERS_CUSTOM,6)
    pwr3=ffx.getByTemplate(char,FFX_POSSESSION_WITH_POWERS_CUSTOM,8)
    if not ffx.hasAttribute(char,attrib1):
        ffx.addFFXAttrib(char,attrib1)
        ffx.FFX_ObjectSetAttr(char,'PPattrib1',1)
    if not ffx.hasAttribute(char,attrib2):
        ffx.addFFXAttrib(char,attrib2)
        ffx.FFX_ObjectSetAttr(char,'PPattrib2',1)
    for obj in Mission_GetObjects():
        if ((Object_GetClass(obj) & js.OC_TERRAIN)==0):
            Mission_CustomAction(cmd1,char,obj,ppPower1,30,0)
            Mission_CustomAction(cmd2,char,obj,ppPower2,30,0)
            Mission_CustomAction(cmd3,char,obj,ppPower3,30,0)
#            m25ai.AddGoal_DynamicAbility(char, temp_attribute='', tactic='TRanged(pwr1)')
#            m25ai.AddGoal_DynamicAbility(char, temp_attribute='', tactic='TRanged(pwr2)')
#            m25ai.AddGoal_DynamicAbility(char, temp_attribute='', tactic='TRanged(pwr3)')
    ffx.regSecondaryState2(target, SCSTATE_POSSESSED, 'OnPossessPowersEnd', user = 0, string = char, persistent = 0)
    m25ai.SetTeam(target,m25ai.GetTeam(char))
    m25ai.ClearAIStandardOnly(target)
    m25ai.AIEnableWatch(target)
    m25ai.AIEnable(target)
    m25ai.AIEnableCustom(target)
    m25ai.SetBrawler(target)
    m25event.SetTimer(1.0, 'AIRecoverBroken', target, user=m25ai.GetAITimeStamp(target))

def ppPower1(target,char):
    pwr1=ffx.getByTemplate(char,FFX_POSSESSION_WITH_POWERS_CUSTOM,4)
    Trigger_Power(char,target,pwr1,'')

def ppPower2(target,char):
    pwr2=ffx.getByTemplate(char,FFX_POSSESSION_WITH_POWERS_CUSTOM,6)
    Trigger_Power(char,target,pwr2,'')

def ppPower3(target,char):
    pwr3=ffx.getByTemplate(char,FFX_POSSESSION_WITH_POWERS_CUSTOM,8)
    Trigger_Power(char,target,pwr2,'')

def OnPossessPowersEnd(event):
    target = event.object
    char = event.string
    team = ffx.FFX_ObjectGetAttr(target,'targetOldTeam')
    pos = Get_ObjectPos(target)
    ffx.teleportToPos(char, pos)
    ffx.fallOver(target)
    ffx.setInvisibleState(char, duration = 0)
    Trigger_Move(char, 'move', (pos[0] + 20, pos[1], pos[2]), '', 1, 1)
    attrib1=ffx.getByTemplate(char,FFX_POSSESSION_WITH_POWERS_CUSTOM,1)
    attrib2=ffx.getByTemplate(char,FFX_POSSESSION_WITH_POWERS_CUSTOM,2)
    cmd1=ffx.getByTemplate(char,FFX_POSSESSION_WITH_POWERS_CUSTOM,3)
    cmd2=ffx.getByTemplate(char,FFX_POSSESSION_WITH_POWERS_CUSTOM,5)
    cmd3=ffx.getByTemplate(char,FFX_POSSESSION_WITH_POWERS_CUSTOM,7)
    if ffx.FFX_ObjectGetAttr(char,'PPattrib1')==1:
        ffx.removeFFXAttrib(char, attrib1)
    if ffx.FFX_ObjectGetAttr(char,'PPattrib2')==1:
        ffx.removeFFXAttrib(char, attrib2)
    for obj in Mission_GetObjects():
        if ((Object_GetClass(obj) & js.OC_TERRAIN)==0):
            Mission_RemoveCustomAction(cmd1,char,obj)
            Mission_RemoveCustomAction(cmd2,char,obj)
            Mission_RemoveCustomAction(cmd3,char,obj)
    m25ai.SetTeam(target,team)
    m25ai.AIRestart(target,100000)


############################# INCREASE DENISTY SWAP ######################################
### Adds 15 points of Invulnerable at the expense of -2 to Agility. Also sets mass to 500.
### -TaskmasterX

def stuntodensityincrease(event):
    densityincreaseP(event,PCSTATE_STUNNED,ffx.COST_STUN)
def hypnosistodensityincrease(event):
    densityincreaseP(event,PCSTATE_HYPNOTISED,ffx.COST_HYPNO)
def ragetodensityincrease(event):
    densityincreaseP(event,PCSTATE_ENRAGED,ffx.COST_RAGE)
def exiletodensityincrease(event):
    densityincreaseP(event,PCSTATE_EXILE,ffx.COST_EXILE)
def blanktodensityincrease(event):
    densityincreaseP(event,PCSTATE_BLANK,ffx.COST_BLANK)
def panictodensityincrease(event):
    densityincreaseP(event,PCSTATE_PANICKED,ffx.COST_PANIC)
def frozentodensityincrease(event):
    densityincreaseP(event,PCSTATE_FROZEN,ffx.COST_FROZEN)
def stasistodensityincrease(event):
    densityincreaseP(event,PCSTATE_STATIC,ffx.COST_STASIS)

def hextodensityincrease(event):
    densityincreaseS(event,SCSTATE_HEXED,ffx.COST_HEX)
def blindtodensityincrease(event):
    densityincreaseS(event,SCSTATE_BLIND,ffx.COST_BLIND)
def powernulltodensityincrease(event):
    densityincreaseS(event,SCSTATE_POWER_NULLIFICATION,ffx.COST_NULL)
def weakentodensityincrease(event):
    densityincreaseS(event,SCSTATE_WEAKENED,ffx.COST_WEAKEN)
def speeddecreasetodensityincrease(event):
    densityincreaseS(event,SCSTATE_SPEED_DECREASED,ffx.COST_DECREASE)

def densitytodensityincrease(event):
    char=event.object
    source=event.string
    if ffx.densityaltered(char):
        Object_SetGenericState(char,OBJSTATE_DENSITY_CHANGE,0,REMOVE_STATE)
        ffx.FFX_UpdateStates(char)
        makedensityincrease(char,source,ffx.COST_DENSITY)

def densityincreaseP(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetPrimaryState(char)==state:
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        ffx.FFX_UpdateStates(char)
        makedensityincrease(char,source,intensity)

def densityincreaseS(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetSecondaryStates(char)&state:
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        ffx.FFX_UpdateStates(char)
        makedensityincrease(char,source,intensity)

def makedensityincrease(char,source,intensity):
    ffx.MPSendMessage(MP_DENSITYINCREASE,Object_GetAttr(char,'ffxMPID'),intensity)
    duration=15*intensity
    handle=Object_PlayEffect(char,'effect_ffxabsorbstrength','',FX_LOOP|FX_TRACK_OBJECT_FULL,0,'centre')
    ffx.RegTimer('densityFX',1,handle,char)
    ffx.FFX_ObjectSetAttr(char,'densityFXOn',1)
    agl=Object_GetAttr(char,'agility')
    newAgl=agl-2
    Object_SetAttr(char,'agility',newAgl)
    Object_SetAttr(char,'mass',500)
    invPoints=ffx.FFX_ObjectGetAttr(char,'invPoints')
    if invPoints==0:
        ffx.FFX_ObjectSetAttr(char,'ivlastdam',Object_GetAttr(char,'health'))
        if not ffx.FFX_ObjectGetAttr(char,'DamageManagement',0):
            ffx.RegDamage(char,'DamageManagement')
            ffx.FFX_ObjectSetAttr(char,'DamageManagement',1)
        ffx.FFX_ObjectSetAttr(char,'invPoints',invPoints+15)
        ffx.FFX_ObjectSetAttr(char,'baseInvPoints',0)
    else:
        ffx.FFX_ObjectSetAttr(char,'invPoints',invPoints+15)
    ffx.RegTimer('makeNormalDensity',duration,0,char)

def densityFX(event):
    char=event.object
    if ffx.FFX_ObjectGetAttr(char,'densityFXOn',0)==0:
        Object_StopEffect(char,int(event.user))
    else:
        ffx.RegTimer('densityFX',1,event.user,char)

def makeNormalDensity(event):
    char=event.object
    ffx.FFX_ObjectSetAttr(char,'densityFXOn',0)
    agl=Object_GetAttr(char,'agility')
    newAgl=agl+2
    Object_SetAttr(char,'agility',newAgl)
    baseMass=ffx.FFX_ObjectGetAttr(char,'baseMass')
    Object_SetAttr(char,'mass',baseMass)
    bip=ffx.FFX_ObjectGetAttr(char,'baseInvPoints')
    invPoints=ffx.FFX_ObjectGetAttr(char,'invPoints')
    if bip==0:
        ffx.FFX_ObjectSetAttr(char,'DamageManagement',0)
        ffx.FFX_ObjectSetAttr(char,'invPoints',0)
    else:
        ffx.FFX_ObjectSetAttr(char,'invPoints',invPoints-15)


######################## Hypnosis Swap ##############################################

def empathytohypnosis(event):
    char=event.object
    Trigger_Explosion(char,'ffx_blankarea')
    ffx.RegTimer('llhypnosisCheck',1,ffx.stateintensity[int(event.user)],char,event.string)

def displacetohypnosis(event):
    char=event.object
    Trigger_Explosion(char,'ffx_blankarea')
    ffx.RegTimer('llhypnosisCheck',1,ffx.stateintensity[int(event.user)],char,event.string)

def cloaktohypnosis(event):
    char=event.object
    source=event.string
    Trigger_Explosion(char,'ffx_blankarea')
    ffx.RegTimer('llhypnosisCheck',1,ffx.stateintensity[int(event.user)],char,event.string)

def hypnosistohypnosis(event):
    char=event.object
    source=event.string
    intensity=3.333
    if Object_GetClass(char) & OC_CONTROLLABLE:
        return
    if Object_GetClass(source) & OC_CONTROLLABLE:
        return
    mentalResist=ffx.getMentalResistanceValue(char, passive=0, active=0, attribs=1, states=0, material=1)
    x=randint(1,100)
    mentals = {0.25: 10, 0.5: 30, 1: 60, 2: 75, 4:90}
    if x < mentals[mentalResist]:
        makehypnosis(char, source, intensity)

def limeyluretohypnosis(event):
    focus=getLure()
    if focus=='':
        return
    Trigger_Explosion(focus,'ffx_blankarea')
    ffx.RegTimer('llhypnosisCheck',1,stateintensity[int(event.user)],focus,event.string)
    ffx.RegTimer('destroyTemp',1.1,0,focus)

def llhypnosisCheck(event):
    char=event.object
    hero=event.string
    if event.string=='none':
        hero=event.object
    for obj in Mission_GetDynamicObjects():
        team=m25ai.GetTeam(obj)
        myTeam=m25ai.GetTeam(hero)
        if obj==hero:#for when the one hypnotizing gets hypnotized by the limeylure!
            Object_SetPrimaryState(obj,PCSTATE_BLANK,0,REMOVE_STATE)
        hasPortrait=ffx.FFX_HasPortrait(obj)
        pcAIEnabled=m25ai.AIInWatch(obj)
        if (myTeam==team) & (Mission_GetAttr('ffxSkirmish')==1):
            Object_SetPrimaryState(obj,PCSTATE_BLANK,0,REMOVE_STATE)
        if hasPortrait & (myTeam==team) & (Mission_GetAttr('ffxSkirmish')==0):
            Object_SetPrimaryState(obj,PCSTATE_BLANK,0,REMOVE_STATE)
        if (obj!=char) & (obj!=hero) & (team!=myTeam):
            if Object_GetClass(obj)&FFX_CHARACTER:
                if ffx.distanceSq(obj,char)<40000:
                    if Object_GetPrimaryState(obj)==PCSTATE_BLANK:
                        Object_SetPrimaryState(obj,PCSTATE_BLANK,0,REMOVE_STATE)
                        intensity=ffx.COST_BLANK
                        makehypnosis(obj, hero, intensity)

def makehypnosis(target, user, intensity):
    duration=intensity*10
    if ffx.FFX_ObjectGetAttr(target,'hypnosistohypnosis',0)==1:
        if ffx.FFX_ObjectGetAttr(user,'hypnosistohypnosis',0)==1:
            return
    team=m25ai.GetTeam(target)
    newTeam=m25ai.GetTeam(user)
    oldTeam=ffx.FFX_ObjectGetAttr(target,'targetOldTeam')
    if ffx.FFX_ObjectGetAttr(target,'hypnosistohypnosisStart',0)==0:
        ffx.FFX_ObjectSetAttr(target,'hypnosistohypnosisStart',1)
        ffx.FFX_ObjectSetAttr(target,'targetOriginalTeam',team)
    orgTeam=ffx.FFX_ObjectGetAttr(target,'targetOriginalTeam')
    if orgTeam==newTeam:
        ffx.FFX_ObjectSetAttr(target,'targetOldTeam',orgTeam)
        Object_SetPrimaryState(target,PCSTATE_HYPNOTISED,0,REMOVE_STATE)
        return
    ffx.FFX_ObjectSetAttr(target,'hypnosistohypnosis',1)
    ffx.FFX_ObjectSetAttr(user,'hypnosistohypnosis',1)
    Object_SetPrimaryState(target,PCSTATE_HYPNOTISED,duration,0)
    ffx.RegCharState(target,PCSTATE_NORMAL,'OnHypnosisEnd',0,0,user)
    ffx.RegDeath(user,'OnHypnosisEnd')
    ffx.FFX_ObjectSetAttr(target,'targetOldTeam',team)
    m25ai.SetTeam(target,newTeam)
    m25ai.ClearAIStandardOnly(target)
    m25ai.AIEnableWatch(target)
    m25ai.AIEnable(target)
    m25ai.AIEnableCustom(target)
    m25ai.SetBrawler(target)
    m25event.SetTimer(1.0, 'AIRecoverBroken', target, user=m25ai.GetAITimeStamp(target))

def OnHypnosisEnd(event):
    target = event.object
    char = event.string
    team = ffx.FFX_ObjectGetAttr(target,'targetOldTeam')
    if ffx.FFX_ObjectGetAttr(target,'hypnosistohypnosis',0)==0:
        return
    m25ai.SetTeam(target,team)
    newTeam=m25ai.GetTeam(target)
    m25ai.AIRestart(target,100000)
    ffx.FFX_ObjectSetAttr(target,'hypnosistohypnosis',0)
    if Object_IsAlive(char):
        ffx.FFX_ObjectSetAttr(char,'hypnosistohypnosis',0)


########## LimeyLure to Transmute Swap ##########
def limeyluretotransmute(event):
    focus=ffx.getLure()
    if focus=='':
        return
    Trigger_Explosion(focus,'ffx_hexarea')
    ffx.RegTimer('lltransmuteCheck',1,ffx.stateintensity[int(event.user)],focus,event.string)
    ffx.RegTimer('destroyTemp',1.1,0,focus)

def lltransmuteCheck(event):
    char=event.object
    hero=event.string
    for obj in Mission_GetDynamicObjects():
        team=m25ai.GetTeam(obj)
        myTeam=m25ai.GetTeam(hero)
        if obj==hero:
            Object_SetSecondaryState(obj,SCSTATE_HEXED,0,REMOVE_STATE)
        if team==myTeam:
            Object_SetSecondaryState(obj,SCSTATE_HEXED,0,REMOVE_STATE)
        if (obj!=char) & (obj!=hero) & (team!=myTeam):
            if Object_GetClass(obj)&FFX_CHARACTER:
                if ffx.distanceSq(obj,char)<40000:
                    if Object_GetSecondaryStates(obj)&SCSTATE_HEXED:
                        Object_SetSecondaryState(obj,SCSTATE_HEXED,0,REMOVE_STATE)
                        makelltransmuted(obj,char,event.user,hero)

def makelltransmuted(char,source,intensity,hero):
    ffx.RegTimer('OnTransmuteCB',0.1,0,char,source)
    ffx.MPSendMessage(ffx.MP_TRANSMUTE,Object_GetAttr(char,'ffxMPID'),intensity)
    obj='t%s'%(char)
    if Object_Exists(obj)==0:
        template=ffx.getTransmute(hero,char)
        if template=='':
            return
        if Object_GetClass(hero)&OC_CONTROLLABLE:
            if Object_GetPrimaryState(char)!=ffx.PCSTATE_EXILE:
                Object_SetPrimaryState(char,ffx.PCSTATE_EXILE,4*intensity,0)
        else:
            if Object_GetPrimaryState(char)!=ffx.PCSTATE_EXILE:
                Object_SetPrimaryState(char,ffx.PCSTATE_EXILE,16*intensity,0)
        ffx.FFX_Spawn(obj,template,char,1)
        Object_PlayEffect(obj,'effect_deja_clone','',0,0,'centre')
        if Object_GetClass(obj)&FFX_CHARACTER:
            ffx.initMinionAI(obj,m25ai.GetTeam(source),'',ffx.isEvil(source))
        ffx.setFFXState(char,ffx.FFX_STATE_TRANSMUTED)
        ffx.makecloak(char,100)
        flying=mlogreader.MLOG_IsFlying(char)
        if flying:
            Trigger_Force(obj,0,0,1,Object_GetAttr(obj,'mass')*100,TF_ABSOLUTE)
        ffx.RegTimer('Transmute2',0.15,0,obj,char)


####################### Sleep state swap #######################
def limeyluretosleep(event):
    focus=ffx.getLure()
    if focus=='':
        return
    Trigger_Explosion(focus,'ffx_hexarea')
    ffx.RegTimer('llsleepCheck',1,ffx.stateintensity[int(event.user)],focus,event.string)
    ffx.RegTimer('destroyTemp',1.1,0,focus)

def llsleepCheck(event):
    char=event.object
    hero=event.string
    for obj in Mission_GetDynamicObjects():
        if obj==hero:
            Object_SetSecondaryState(obj,SCSTATE_HEXED,0,REMOVE_STATE)
        if (obj!=char) & (obj!=hero):
            if Object_GetClass(obj)&FFX_CHARACTER:
                if ffx.distanceSq(obj,char)<40000:
                    if Object_GetSecondaryStates(obj)&SCSTATE_HEXED:
                        Object_SetSecondaryState(obj,SCSTATE_HEXED,0,REMOVE_STATE)
                        fallAsleep(obj, hero, duration=10)

def stuntosleep(event):
    sleepP(event,PCSTATE_STUNNED,ffx.COST_STUN)
def hypnosistosleep(event):
    sleepP(event,PCSTATE_HYPNOTISED,ffx.COST_HYPNO)
def ragetosleep(event):
    sleepP(event,PCSTATE_ENRAGED,ffx.COST_RAGE)
def exiletosleep(event):
    sleepP(event,PCSTATE_EXILE,ffx.COST_EXILE)
def blanktosleep(event):
    sleepP(event,PCSTATE_BLANK,ffx.COST_BLANK)
def panictosleep(event):
    sleepP(event,PCSTATE_PANICKED,ffx.COST_PANIC)
def stasistosleep(event):
    sleepP(event,PCSTATE_STATIC,ffx.COST_STASIS)

def hextosleep(event):
    sleepS(event,SCSTATE_HEXED,ffx.COST_HEX)
def blindtosleep(event):
    sleepS(event,SCSTATE_BLIND,ffx.COST_BLIND)
def powernulltosleep(event):
    sleepS(event,SCSTATE_POWER_NULLIFICATION,ffx.COST_NULL)
def weakentosleep(event):
    sleepS(event,SCSTATE_WEAKENED,ffx.COST_WEAKEN)
def speeddecreasetosleep(event):
    sleepS(event,SCSTATE_SPEED_DECREASED,ffx.COST_DECREASE)

def sleepP(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetPrimaryState(char)==state:
        Object_SetPrimaryState(char,state,0,REMOVE_STATE)
        fallAsleep(char, source, (intensity * 3) + 3)
    if state==PCSTATE_STATIC:
        ffx.FFX_ObjectSetAttr(char, 'stasisSleep', 1)

def sleepS(event,state,intensity):
    char=event.object
    source=event.string
    if Object_GetSecondaryStates(char)&state:
        Object_SetSecondaryState(char,state,0,REMOVE_STATE)
        fallAsleep(char, source, (intensity * 3) + 3)

def fallAsleep(char, source, duration):
    ffx.FFX_UpdateStates(char)
    if (ffx.getGender(char) == ffx.FFX_GENDER_ROBOT):
        return
    if Object_GetSecondaryStates(char)&SCSTATE_ZOMBIE:
        return
    if ffx.FFX_ObjectGetAttr(char, 'ffx_sleep') != 1:
        handle = Object_PlayEffect(char, 'effect_ffx_lifedrain', '', FX_LOOP|FX_TRACK_OBJECT_FULL, 0, 'centre')
        ffx.FFX_ObjectSetAttr(char, 'sleeping_handle', handle)
    if ffx.FFX_ObjectGetAttr(char, 'stasisSleep') == 1:
        ffx.FFX_ObjectSetAttr(char, 'sleep_duration', duration)
        ffx.RegTimer('makeasleepFlyer', 0.2, 0, char)
        ffx.FFX_ObjectSetAttr(char, 'sleep_flier', 1)
        return
    flying=mlogreader.MLOG_IsFlying(char)
    flailing=mlogreader.MLOG_IsFlailing(char)
    if (flying==1) | (flailing==1):
        Trigger_Force(char,0,0,1,Object_GetAttr(char,'mass')*100,TF_ABSOLUTE)
        ffx.FFX_ObjectSetAttr(char, 'sleep_duration', duration)
        ffx.RegTimer('makeasleepFlyer', 0.2, 0, char)
        ffx.FFX_ObjectSetAttr(char, 'sleep_flier', 1)
    else:
        makeasleep(char,duration)

def makeasleepFlyer(event):
    char = event.object
    duration = ffx.FFX_ObjectGetAttr(char, 'sleep_duration')-0.2
    ffx.FFX_ObjectSetAttr(char, 'sleep_duration', duration)
    falling=mlogreader.MLOG_IsFlailing(char)
    if falling:
        ffx.RegTimer('makeasleepFlyer', 0.2, 0, char)
    else:
        makeasleep(char,duration)

def makeasleep(char,duration):
    Trigger_Move(char,'lock')
    if ffx.FFX_ObjectGetAttr(char, 'sleep_flier') == 1:
        AI_Animate(char,'land_forward')
        ffx.FFX_ObjectSetAttr(char, 'sleep_flier', 0)
    else:
        AI_Animate(char,'fall')
    ff.RESULTBUBBLE_SCALE=0
    ffx.RegTimer('bubblesOn',0.1)
    ffx.RegTimer('removeFX',0.5,1,char)
    ffx.setPowerNullState(char, duration)
    ffx.FFX_ObjectSetAttr(char, 'ffx_sleep', 1)
    ffx.RegTimer('makewakeup', duration, 0, char)

def makewakeup(event):
    char = event.object
    makewakeup2(char)

def makewakeup2(char):
    if ffx.FFX_ObjectGetAttr(char, 'ffx_sleep') == 1: #make sure we don't wake them up twice
        ffx.setPowerNullState(char, 0)
        handle = ffx.FFX_ObjectGetAttr(char, 'sleeping_handle')
        Object_StopEffect(char, handle)
        Trigger_Move(char, 'unlock')
        AI_Animate(char,'get_up_forward')
        ffx.FFX_ObjectSetAttr(char, 'ffx_sleep', 0)


### Misc Functions

##### Increase Strength Functions #####
def increaseStrength(char,targets,array):
    power=len(targets)
    if power>0:
        ffx.playSynergyFX(char,array)
        ffx.playSynergyFXonTargets(char,targets,array)
    bonus=power*0.5
    str=Object_GetAttr(char,'templateStrength')+bonus
    Object_SetAttr(char,'strength',str)
    Object_SetAttr(char,'baseStrength',str)

def increaseStrengthAndInvulnerability(char,targets,array):
    power=len(targets)
    if power>0:
        ffx.playSynergyFX(char,array)
        ffx.playSynergyFXonTargets(char,targets,array)
    bonus=power*0.33
    str=Object_GetAttr(char,'templateStrength')+bonus
    Object_SetAttr(char,'strength',str)
    Object_SetAttr(char,'baseStrength',str)
    bip=ffx.FFX_ObjectGetAttr(char,'baseInvPoints')
    ffx.FFX_ObjectSetAttr(char,'invPoints',power+bip)

##### Adrenaline Surge #####
def adrenalineSurge(char,param,intensity):
    ### Strength Bonus ###
    bonus=0
    if ffx.FFX_ObjectGetAttr(char,'painResponse_AS')==1:
        ffx.FFX_ObjectSetAttr(char,'painResponse_AS',2)
        bonus=1
    else:
        if ffx.FFX_ObjectGetAttr(char,'painResponse_AS')==0:
            ffx.FFX_ObjectSetAttr(char,'painResponse_AS',1)
            bonus=1
            ffx.RegTimer('cancelAdrenalineSurgeCheck',6,0,char)
            ffx.RegCharState(char,PCSTATE_BLANK,'cancelAdrenalineSurge')
    if Object_GetPrimaryState(char)!=PCSTATE_ENRAGED:
        str=Object_GetAttr(char,'strength')+bonus
        Object_SetAttr(char,'strength',str)
        Object_SetAttr(char,'baseStrength',str)
    else:
        ffx.RegCharState(char,PCSTATE_NORMAL,'postEnragedStrReset')
    ### Energy Bonus ###
    ep=Object_GetAttr(char,'energyPoints')+intensity
    maxEP=Object_GetAttr(char,'maxEnergyPoints')
    excess=ep-maxEP
    if excess>0:
        ep=maxEP
    Object_SetAttr(char,'energyPoints',ep)
    ### Healing Bonus ###
    if ffx.FFX_ObjectGetAttr(char,'painResponse_heal')==1:
        return
    health=Object_GetAttr(char,'health')
    maxHealth=Object_GetAttr(char,'maxHealth')
    if health>=maxHealth:
        return
    healingfactor=Object_GetAttr(char,'energyPoints')
    if healingfactor < 34:
        timer=3
    if healingfactor > 33:
        if healingfactor < 66:
            timer=2
    if healingfactor > 65:
        timer=1
    ffx.RegTimer('healingrate',timer,0,char)
    ffx.FFX_ObjectSetAttr(char,'painResponse_heal',1)
    ffx.RegCharState(char,PCSTATE_STUNNED,'OnFFQPrimaryResist')
    ffx.RegCharState(char,PCSTATE_PANICKED,'OnFFQPrimaryResist')

def postEnragedStrReset(event):
    char=event.object
    bonus=ffx.FFX_ObjectGetAttr(char,'painResponse_AS')
    Object_SetAttr(char,'strength',Object_GetAttr(char,'templateStrength')+bonus)
    Object_SetAttr(char,'baseStrength',Object_GetAttr(char,'templateStrength')+bonus)

def cancelAdrenalineSurge(event):
    char=event.object
    Object_SetAttr(char,'strength',Object_GetAttr(char,'templateStrength'))
    Object_SetAttr(char,'baseStrength',Object_GetAttr(char,'templateStrength'))
    ffx.FFX_ObjectSetAttr(char,'painResponse_heal',2)
    ffx.FFX_ObjectSetAttr(char,'painResponse_AS',0)

def cancelAdrenalineSurgeDist(char):
    Object_SetAttr(char,'strength',Object_GetAttr(char,'templateStrength'))
    Object_SetAttr(char,'baseStrength',Object_GetAttr(char,'templateStrength'))
    ffx.FFX_ObjectSetAttr(char,'painResponse_heal',2)
    ffx.FFX_ObjectSetAttr(char,'painResponse_AS',0)

def cancelAdrenalineSurgeCheck(event):
    char=event.object
    target=m25ai.FindTarget(char,maxdist=m25distance.DISTANCE_VISIBLE,default=None)
    if target == None:
        cancelAdrenalineSurgeDist(char)
    else:
        ffx.RegTimer('cancelAdrenalineSurgeCheck',6,0,char)

PainResponseHealerRatio=2  # cost in EP for each health point healed   

def healingrate(event):
    char=event.object
    if not Object_Exists(char):
        return
    if not Object_IsAlive(char):
        return
    energy=Object_GetAttr(char,'energy')+1
    healing=energy/2
    if healing<1:
        healing=1
    health=Object_GetAttr(char,'health')
    maxHealth=Object_GetAttr(char,'maxHealth')
    if health>=maxHealth:
        ffx.FFX_ObjectSetAttr(char,'painResponse_heal',0)
        return
    if health + healing > maxHealth:
        healing = maxHealth - health
        if healing<1:
            healing=1
        health=maxHealth
    EP=Object_GetAttr(char,'energyPoints')
    Object_SetAttr(char,'health',health+healing)
    Object_SetAttr(char,'energyPoints',EP-healing*PainResponseHealerRatio)
    healingfactor=Object_GetAttr(char,'energyPoints')
    if healingfactor < 34:
        timer=3
    if healingfactor > 33:
        if healingfactor < 66:
            timer=2
    if healingfactor > 65:
        timer=1
    if ffx.FFX_ObjectGetAttr(char,'painResponse_heal')==2:
        timer=5
    ffx.RegTimer('healingrate',timer,0,char)

################## New Defense Mechanism Options ##################
#option for increasing invulnerablity for Pain Response (Defense Mechanism)
def resistanceThroughPain(char,param,intensity):
    bonus=1.0+intensity*0.65
    bip=ffx.FFX_ObjectGetAttr(char,'baseInvPoints')
    if bonus>bip:
        ffx.FFX_ObjectSetAttr(char,'invPoints',bip+intensity*0.75)
    ffx.RegTimer('decayInv',5,0,char)

#option for increasing strength AND invulnerablity for Pain Response (Defense Mechanism)
def strengthandResistanceThroughPain(char,param,intensity):
    bonus=1.0+intensity*0.1
    oldBonus=Object_GetAttr(char,'attackBonus')
    if bonus>oldBonus:
        ffx.FFX_SetStrength(char,intensity*0.2)
    if oldBonus==1:
        ffx.RegTimer('decayStrength',5,0,char)
    invbonus=1.0+intensity*0.65
    bip=ffx.FFX_ObjectGetAttr(char,'baseInvPoints')
    if invbonus>bip:
        ffx.FFX_ObjectSetAttr(char,'invPoints',bip+intensity*0.75)
    ffx.RegTimer('decayInv',5,0,char)

def decayInv(event):
    char=event.object
    bip=ffx.FFX_ObjectGetAttr(char,'baseInvPoints')
    invPoints=0.0+ffx.FFX_ObjectGetAttr(char,'invPoints')
    decay=invPoints-1
    if decay>bip:
        if decay<=1.0:
            decay=1.0
        else:
            ffx.RegTimer('decayInv',5,0,char)
        ffx.FFX_ObjectSetAttr(char,'invPoints',decay)


def zapStrengthAndtakeDamage(event):
    ffx.makeweakened(event.object,'',1)
    char=event.object
    Trigger_Damage(char,randint(5,10))


def blank25(event):
    char=event.object
    if randint(1,100)<25:
        Object_SetPrimaryState(char,PCSTATE_BLANK,20,0)


def isAlly(obj,char=''):
    if not (Object_Exists(obj) and Object_Exists(char)):
        return 0
    if obj==char:
        return 0
    if (Object_GetClass(obj)&FFX_CHARACTER)==0:
        return 0
    if m25ai.AreAllies(obj,char):
        return 1
    return 0


